SystemOrganization addCategory: #'MorphicExtras-Demo'!
SystemOrganization addCategory: #'MorphicExtras-AdditionalSupport'!
SystemOrganization addCategory: #'MorphicExtras-AdditionalMorphs'!
SystemOrganization addCategory: #'MorphicExtras-Widgets'!
SystemOrganization addCategory: #'MorphicExtras-Books'!
SystemOrganization addCategory: #'MorphicExtras-Postscript Filters'!
SystemOrganization addCategory: #'MorphicExtras-Support'!
SystemOrganization addCategory: #'MorphicExtras-Kernel'!
SystemOrganization addCategory: #'MorphicExtras-ST80'!
SystemOrganization addCategory: #'MorphicExtras-SoundInterface'!
SystemOrganization addCategory: #'MorphicExtras-Undo'!
SystemOrganization addCategory: #'MorphicExtras-Postscript Canvases'!
SystemOrganization addCategory: #'MorphicExtras-PartsBin'!
SystemOrganization addCategory: #'MorphicExtras-AdditionalWidgets'!
SystemOrganization addCategory: #'MorphicExtras-Flaps'!
SystemOrganization addCategory: #'MorphicExtras-Navigators'!
SystemOrganization addCategory: #'MorphicExtras-Palettes'!
SystemOrganization addCategory: #'MorphicExtras-Leds'!
SystemOrganization addCategory: #'MorphicExtras-SqueakPage'!
SystemOrganization addCategory: #'MorphicExtras-AdditionalWorlds'!
SystemOrganization addCategory: #'MorphicExtras-Text Support'!
SystemOrganization addCategory: #'MorphicExtras-Obsolete'!

!Rectangle methodsFor: '*MorphicExtras-*morphic-Postscript Canvases' stamp: 'mpw 8/9/1930 08:00'!
encodePostscriptOn:aStream 
	aStream write:self origin; print:' '; write:self extent; print:' '.! !

!String methodsFor: '*MorphicExtras-*morphic-Postscript Canvases' stamp: 'yo 11/3/2004 19:24'!
asPostscript

	| temp |
	temp := self asString copyReplaceAll: '(' with: '\('.
	temp := temp copyReplaceAll: ')' with: '\)'.
	temp := temp copyReplaceAll: '
' 
			with: ''.
	^ PostscriptEncoder mapMacStringToPS: temp! !

TransformationMorph subclass: #BOBTransformationMorph
	instanceVariableNames: 'worldBoundsToShow useRegularWarpBlt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-AdditionalSupport'!

!BOBTransformationMorph methodsFor: 'private' stamp: 'RAA 6/10/2000 14:22'!
adjustAfter: changeBlock 
	"Cause this morph to remain cetered where it was before, and
	choose appropriate smoothing, after a change of scale or rotation."
	| |

		"oldRefPos := self referencePosition."
	changeBlock value.
	self chooseSmoothing.
		"self penUpWhile: [self position: self position + (oldRefPos - self referencePosition)]."
	self layoutChanged.
	owner ifNotNil: [owner invalidRect: bounds]
! !

!BOBTransformationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 6/26/2000 19:24'!
changeWorldBoundsToShow: aRectangle

	aRectangle area = 0 ifTrue: [^self].
	worldBoundsToShow := aRectangle.
	owner myWorldChanged.! !

!BOBTransformationMorph methodsFor: 'drawing' stamp: 'RAA 6/4/2001 16:21'!
drawSubmorphsOn: aCanvas

	| t | 
	t := [
		self drawSubmorphsOnREAL: aCanvas
	] timeToRun.
"Q1 at: 3 put: t."
! !

!BOBTransformationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 6/4/2001 16:19'!
drawSubmorphsOnREAL: aCanvas 

	| newClip |

	(self innerBounds intersects: aCanvas clipRect) ifFalse: [^self].
	newClip := ((self innerBounds intersect: aCanvas clipRect) expandBy: 1) truncated.
	useRegularWarpBlt == true ifTrue: [
		transform scale asFloat = 1.0 ifFalse: [
			newClip := self innerBounds.		"avoids gribblies"
		].
		^aCanvas 
			transformBy: transform
			clippingTo: newClip
			during: [:myCanvas |
				submorphs reverseDo:[:m | myCanvas fullDrawMorph: m]
			]
			smoothing: smoothing
	].
	aCanvas 
		transform2By: transform		"#transformBy: for pure WarpBlt"
		clippingTo: newClip
		during: [:myCanvas |
			submorphs reverseDo:[:m | myCanvas fullDrawMorph: m]
		]
		smoothing: smoothing
! !

!BOBTransformationMorph methodsFor: 'geometry' stamp: 'RAA 6/27/2000 12:39'!
extent: aPoint

	| newExtent |

	newExtent := aPoint truncated.
	bounds extent = newExtent ifTrue: [^self].
	bounds := bounds topLeft extent: newExtent.
	self recomputeExtent.

! !

!BOBTransformationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 6/26/2000 19:23'!
extentFromParent: aPoint

	| newExtent |

	submorphs isEmpty ifTrue: [^self extent: aPoint].
	newExtent := aPoint truncated.
	bounds := bounds topLeft extent: newExtent.
	newExtent := self recomputeExtent.
	newExtent ifNil: [^self].
	bounds := bounds topLeft extent: newExtent.

! !

!BOBTransformationMorph methodsFor: 'layout' stamp: 'dgd 2/21/2003 23:02'!
layoutChanged
	"use the version from Morph"

	| myGuy |
	fullBounds := nil.
	owner ifNotNil: [owner layoutChanged].
	submorphs notEmpty 
		ifTrue: 
			[(myGuy := self firstSubmorph) isWorldMorph 
				ifFalse: 
					[worldBoundsToShow = myGuy bounds 
						ifFalse: [self changeWorldBoundsToShow: (worldBoundsToShow := myGuy bounds)]]

			"submorphs do: [:m | m ownerChanged]"	"<< I don't see any reason for this"]! !

!BOBTransformationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 6/27/2000 12:39'!
recomputeExtent

	| scalePt newScale theGreenThingie greenIBE myNewExtent |

	submorphs isEmpty ifTrue: [^self extent].
	worldBoundsToShow ifNil: [worldBoundsToShow := self firstSubmorph bounds].
	worldBoundsToShow area = 0 ifTrue: [^self extent].
	scalePt := owner innerBounds extent / worldBoundsToShow extent.
	newScale := scalePt x min: scalePt y.
	theGreenThingie := owner.
	greenIBE := theGreenThingie innerBounds extent.
	myNewExtent := (greenIBE min: worldBoundsToShow extent * newScale) truncated.
	self
		scale: newScale;
		offset: worldBoundsToShow origin * newScale.
	smoothing := (newScale < 1.0) ifTrue: [2] ifFalse: [1].
	^myNewExtent! !

!BOBTransformationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 8/28/2000 11:26'!
useRegularWarpBlt: aBoolean

	useRegularWarpBlt := aBoolean! !

TransformationMorph subclass: #TransformationB2Morph
	instanceVariableNames: 'worldBoundsToShow useRegularWarpBlt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!TransformationB2Morph commentStamp: '<historical>' prior: 0!
A transformation which:

- is content to let someone else decide my bounds (I do not try to minimally enclose my submorphs)
- can use bi-linear interpolation!

!TransformationB2Morph methodsFor: 'private' stamp: 'RAA 11/22/2000 08:12'!
adjustAfter: changeBlock 

	"same as super, but without reference position stuff"

	changeBlock value.
	self chooseSmoothing.
	self layoutChanged.
	owner ifNotNil: [owner invalidRect: bounds]
! !

!TransformationB2Morph methodsFor: 'geometry' stamp: 'RAA 11/21/2000 13:32'!
computeBounds

	"the transform bounds must remain under the control of the owner in this case"! !

!TransformationB2Morph methodsFor: 'drawing' stamp: 'RAA 12/17/2000 13:25'!
drawSubmorphsOn: aCanvas

	| r1 fullG r2 actualCanvas newClip where deferredMorphs case |
	(self innerBounds intersects: aCanvas clipRect) ifFalse: [^self].
	useRegularWarpBlt == true ifTrue: [
		^aCanvas 
			transformBy: transform
			clippingTo: ((self innerBounds intersect: aCanvas clipRect) expandBy: 1) rounded
			during: [:myCanvas |
				submorphs reverseDo:[:m | myCanvas fullDrawMorph: m]
			]
			smoothing: smoothing
	].
	r1 := self innerBounds intersect: aCanvas clipRect.
	r1 area = 0 ifTrue: [^self].
	fullG := (transform localBoundsToGlobal: self firstSubmorph fullBounds) rounded.
	r2 := r1 intersect: fullG.
	r2 area = 0 ifTrue: [^self].
	newClip := (r2 expandBy: 1) rounded intersect: self innerBounds rounded.
	deferredMorphs := #().
	aCanvas 
		transform2By: transform		"#transformBy: for pure WarpBlt"
		clippingTo: newClip
		during: [:myCanvas |
			self scale > 1.0 ifTrue: [
				actualCanvas := MultiResolutionCanvas new initializeFrom: myCanvas.
				actualCanvas deferredMorphs: (deferredMorphs := OrderedCollection new).
			] ifFalse: [
				actualCanvas := myCanvas.
			].
			submorphs reverseDo:[:m | actualCanvas fullDrawMorph: m].
		]
		smoothing: smoothing.

	deferredMorphs do: [ :each |
		where := each bounds: each fullBounds in: self.
		case := 2.
		case = 1 ifTrue: [where := where origin rounded extent: where extent rounded].
		case = 2 ifTrue: [where := where rounded].
		each drawHighResolutionOn: aCanvas in: where.
	].

! !

!TransformationB2Morph methodsFor: 'geometry' stamp: 'RAA 11/20/2000 18:17'!
extent: aPoint

	| newExtent |

	newExtent := aPoint truncated.
	bounds extent = newExtent ifTrue: [^self].
	bounds := bounds topLeft extent: newExtent.
	"self recomputeExtent."

! !

!TransformationB2Morph methodsFor: 'as yet unclassified' stamp: 'RAA 11/21/2000 12:44'!
useRegularWarpBlt: aBoolean

	useRegularWarpBlt := aBoolean! !

SketchMorph subclass: #BookPageThumbnailMorph
	instanceVariableNames: 'page pageNumber bookMorph flipOnClick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Books'!

!BookPageThumbnailMorph commentStamp: '<historical>' prior: 0!
A small picture representing a page of a BookMorph here or somewhere else.  When clicked, make that book turn to the page and do a visual effect and a noise.

page			either the morph of the page, or a url
pageNumber
bookMorph		either the book, or a url
flipOnClick!

!BookPageThumbnailMorph methodsFor: 'menus' stamp: 'dgd 8/30/2003 20:57'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addLine.
	aCustomMenu add: 'make a flex morph' translated selector: #makeFlexMorphFor: argument: aHandMorph.
	flipOnClick
		ifTrue: [aCustomMenu add: 'disable bookmark action' translated action: #toggleBookmark]
		ifFalse: [aCustomMenu add: 'enable bookmark action' translated action: #toggleBookmark].
	(bookMorph isKindOf: BookMorph)
		ifTrue:
			[aCustomMenu add: 'set page sound' translated action: #setPageSound:.
			aCustomMenu add: 'set page visual' translated action: #setPageVisual:]
! !

!BookPageThumbnailMorph methodsFor: 'as yet unclassified' stamp: 'RAA 6/28/2000 11:12'!
bookMorph

	^bookMorph! !

!BookPageThumbnailMorph methodsFor: 'as yet unclassified' stamp: 'tk 2/24/1999 00:01'!
computeThumbnail
	| f scale |
	self objectsInMemory.
	f := page imageForm.
	scale := (self height / f height).  "keep height invariant"
"(Sensor shiftPressed) ifTrue: [scale := scale * 1.4]."
	self form: (f magnify: f boundingBox by: scale@scale smoothing: 2).

! !

!BookPageThumbnailMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:24'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color lightGray! !

!BookPageThumbnailMorph methodsFor: 'as yet unclassified' stamp: 'tk 2/24/1999 13:24'!
doPageFlip
	"Flip to this page"

	self objectsInMemory.
	bookMorph ifNil: [^ self].
	bookMorph goToPageMorph: page
			transitionSpec: (self valueOfProperty: #transitionSpec).
	(owner isKindOf: PasteUpMorph) ifTrue:
		[owner cursor: (owner submorphs indexOf: self ifAbsent: [1])]! !

!BookPageThumbnailMorph methodsFor: 'event handling' stamp: 'di 1/4/1999 12:19'!
handlesMouseDown: event

	^ event shiftPressed or: [flipOnClick and: [event controlKeyPressed not]]! !

!BookPageThumbnailMorph methodsFor: 'as yet unclassified' stamp: 'di 1/4/1999 12:52'!
inBook: book
	bookMorph := book! !

!BookPageThumbnailMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:53'!
initialize
	"initialize the state of the receiver"
	| f |
	super initialize.
	""
	flipOnClick := false.
	
	f := Form extent: 60 @ 80 depth: Display depth.
	f fill: f boundingBox fillColor: color.
	self form: f! !

!BookPageThumbnailMorph methodsFor: 'as yet unclassified' stamp: 'ar 10/6/2000 16:36'!
makeFlexMorphFor: aHand

	aHand grabMorph: (FlexMorph new originalMorph: page)! !

!BookPageThumbnailMorph methodsFor: 'event handling' stamp: 'tk 7/25/2001 18:09'!
mouseDown: event
	"turn the book to that page"

	"May need to lie to it so mouseUp won't go to menu that may come up during fetch of a page in doPageFlip.  (Is this really true? --tk)"

	self doPageFlip.
! !

!BookPageThumbnailMorph methodsFor: 'fileIn/Out' stamp: 'ar 4/10/2005 18:45'!
objectForDataStream: refStrm
	"I am about to be written on an object file.  It would be bad to write a whole BookMorph out.  Store a string that is the url of the book or page in my inst var."

	| clone bookUrl bb stem ind |
	(bookMorph isString) & (page isString) ifTrue: [
		^ super objectForDataStream: refStrm].
	(bookMorph isNil) & (page isString) ifTrue: [
		^ super objectForDataStream: refStrm].
	(bookMorph isNil) & (page url notNil) ifTrue: [
		^ super objectForDataStream: refStrm].
	(bookMorph isNil) & (page url isNil) ifTrue: [
		self error: 'page should already have a url' translated.
		"find page's book, and remember it"
		"bookMorph := "].
	
	clone := self clone.
	(bookUrl := bookMorph url)
		ifNil: [bookUrl := self valueOfProperty: #futureUrl].
	bookUrl 
		ifNil: [	bb := RectangleMorph new.	"write out a dummy"
			bb bounds: bounds.
			refStrm replace: self with: bb.
			^ bb]
		ifNotNil: [clone instVarNamed: 'bookMorph' put: bookUrl].

	page url ifNil: [
			"Need to assign a url to a page that will be written later.
			It might have bookmarks too.  Don't want to recurse deeply.  
			Have that page write out a dummy morph to save its url on the server."
		stem := SqueakPage stemUrl: bookUrl.
		ind := bookMorph pages identityIndexOf: page.
		page reserveUrl: stem,(ind printString),'.sp'].
	clone instVarNamed: 'page' put: page url.
	refStrm replace: self with: clone.
	^ clone! !

!BookPageThumbnailMorph methodsFor: 'fileIn/Out' stamp: 'ar 4/10/2005 18:45'!
objectsInMemory
	"See if page or bookMorph need to be brought in from a server."
	| bookUrl bk wld try |
	bookMorph ifNil: ["fetch the page"
		page isString ifFalse: [^ self].	"a morph"
		try := (SqueakPageCache atURL: page) fetchContents.
		try ifNotNil: [page := try].
		^ self].
	bookMorph isString ifTrue: [
		bookUrl := bookMorph.
		(wld := self world) ifNil: [wld := Smalltalk currentWorld].
		bk := BookMorph isInWorld: wld withUrl: bookUrl.
		bk == #conflict ifTrue: [
			^ self inform: 'This book is already open in some other project' translated].
		bk == #out ifTrue: [
			(bk := BookMorph new fromURL: bookUrl) ifNil: [^ self]].
		bookMorph := bk].
	page isString ifTrue: [
		page := (bookMorph pages detect: [:pg | pg url = page] 
					ifNone: [bookMorph pages first])].
! !

!BookPageThumbnailMorph methodsFor: 'as yet unclassified' stamp: 'jm 11/17/97 17:30'!
page

	^ page
! !

!BookPageThumbnailMorph methodsFor: 'as yet unclassified' stamp: 'di 1/4/1999 13:39'!
page: aMorph

	page := aMorph.
	self computeThumbnail.
	self setNameTo: aMorph externalName.
	page fullReleaseCachedState.
! !

!BookPageThumbnailMorph methodsFor: 'as yet unclassified' stamp: 'di 1/4/1999 12:48'!
pageMorph: pageMorph inBook: book
	page := pageMorph.
	bookMorph := book! !

!BookPageThumbnailMorph methodsFor: 'as yet unclassified' stamp: 'di 12/20/1998 17:29'!
setPageSound: event

	^ bookMorph menuPageSoundFor: self event: event! !

!BookPageThumbnailMorph methodsFor: 'as yet unclassified' stamp: 'di 12/20/1998 17:29'!
setPageVisual: event

	^ bookMorph menuPageVisualFor: self event: event! !

!BookPageThumbnailMorph methodsFor: 'as yet unclassified' stamp: 'di 8/8/1998 14:06'!
smaller
	self form: (self form copy: (0@0 extent: self form extent//2)).
! !

!BookPageThumbnailMorph methodsFor: 'as yet unclassified' stamp: 'di 12/23/1998 15:53'!
toggleBookmark
	"Enable or disable sensitivity as a bookmark
		enabled means that a normal click will cause a pageFlip
		disabled means this morph can be picked up normally by the hand."

	flipOnClick := flipOnClick not! !

!BookPageThumbnailMorph methodsFor: 'copying' stamp: 'tk 1/6/1999 19:35'!
veryDeepFixupWith: deepCopier
	"If target and arguments fields were weakly copied, fix them here.  If they were in the tree being copied, fix them up, otherwise point to the originals!!!!"

super veryDeepFixupWith: deepCopier.
page := deepCopier references at: page ifAbsent: [page].
bookMorph := deepCopier references at: bookMorph ifAbsent: [bookMorph].
! !

!BookPageThumbnailMorph methodsFor: 'copying' stamp: 'tk 1/7/1999 14:35'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

super veryDeepInner: deepCopier.
"page := page.		Weakly copied"
pageNumber := pageNumber veryDeepCopyWith: deepCopier.
"bookMorph := bookMorph.		All weakly copied"
flipOnClick := flipOnClick veryDeepCopyWith: deepCopier. ! !

SketchMorph subclass: #FatBitsPaint
	instanceVariableNames: 'formToEdit magnification brush brushSize brushColor lastMouse currentTools currentSelectionMorph selectionAnchor backgroundColor'
	classVariableNames: 'FormClipboard'
	poolDictionaries: ''
	category: 'MorphicExtras-AdditionalWidgets'!

!FatBitsPaint commentStamp: '<historical>' prior: 0!
Extensions to FatBitsPaint

With the goal of making FatBitsPaint a fairly nifty Form fixer-upper in the Squeak/morphic environment, I have started this set of extensions. It will probably be updated as the mood strikes, so keep an eye out for new versions.

First, some basic operating instructions:

Get a Form and send it the message #morphEdit. To get started, you can try:

        (Form fromUser) morphEdit

And there is the form in all its glory. Control click on the form to get theFatBitsPaint menu and choose the "keep this menu up" item. This will be your main tool/command palette. With it you can:
 Change the magnification
 Change the brush size (in original scale pixels)
 Change the brush color (via a ColorPickerMorph)

Now to some of the enhancements:

(25 September 1999 2:38:25 pm )

 ColorPickerMorphs now have a label below that indicates their use (you might have more than one open)
 A quirk that could get the brush size out of alignment with the pixel size is fixed.
 A background has been added so that you can see the full extent of the Form and so that you can observe the effect of translucent pixels in the form.
 A menu item has been added to change the background color so that you can simulate the real environment the form will be displayed in.
 The magnification and brush size menus now highlight their current value.
 An inspect option has been added to the menu so that you can do arbitrary things to the form.
 A file out option has been added to write the form to a file.

(25 September 1999 10:02:13 pm ) 

 New menu item: Tools allows you to choose between (for now) Paint Brush (all there was before) and Selections. Selections allows you to select rectangular regions of the form where the next menu takes over.
 New menu item: Selections gives you choices:
         edit separately - opens a new editor on the selected rectangle. Useful for cropping.
         copy - copies the selection rectangle to a clipboard. Can be pasted to this or another FatBitsPaint.
         cut - does a copy and clears the selection to transparent.
         paste - paints the contents of the clipboard over the current selection. Only the starting point of the selection matters - the extent is controlled by the clipboard.

!

!FatBitsPaint methodsFor: 'menu' stamp: 'RAA 5/14/2000 12:42'!
accept
	| f |
	f := self unmagnifiedForm.
	f boundingBox = formToEdit boundingBox
		ifFalse: [^ self error: 'implementation error; form dimensions should match'].
	f displayOn: formToEdit.  "modify formToEdit in place"! !

!FatBitsPaint methodsFor: 'menu' stamp: 'dgd 10/8/2003 18:59'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

        super addCustomMenuItems: aCustomMenu hand: aHandMorph.
        aCustomMenu 
                add: 'background color' translated action: #setBackgroundColor:;
                add: 'pen color' translated action: #setPenColor:;
                add: 'pen size' translated action: #setPenSize:;
                add: 'fill' translated action: #fill;
                add: 'magnification' translated action: #setMagnification:;
                add: 'accept' translated action: #accept;
                add: 'revert' translated action: #revert;
                add: 'inspect' translated action: #inspectForm;
                add: 'file out' translated action: #fileOut;
                add: 'selection...' translated action: #selectionMenu:;
                add: 'tools...' translated action: #toolMenu:! !

!FatBitsPaint methodsFor: 'menu' stamp: 'RAA 9/25/1999 22:27'!
backgroundColor: aColor

        backgroundColor := aColor.
        self changed! !

!FatBitsPaint methodsFor: 'menu' stamp: 'jm 11/4/97 07:15'!
brushColor: aColor

	brushColor := aColor.
	brush color: aColor.
! !

!FatBitsPaint methodsFor: 'geometry testing' stamp: 'RAA 9/25/1999 21:14'!
containsPoint: aPoint

        ^ self bounds containsPoint: aPoint     "even if we are transparent"
! !

!FatBitsPaint methodsFor: 'menu' stamp: 'RAA 9/25/1999 21:50'!
copySelection

        | relativeBounds scaledBounds |
        currentSelectionMorph ifNil: [^ nil].
        relativeBounds := currentSelectionMorph bounds translateBy: self position negated.
        scaledBounds := relativeBounds scaleBy: 1 / magnification.
        FormClipboard := (self unmagnifiedForm copy: scaledBounds).
        ^ relativeBounds! !

!FatBitsPaint methodsFor: 'menu' stamp: 'RAA 9/25/1999 16:15'!
cutSelection

        | relativeBounds |
        relativeBounds := self copySelection ifNil: [^ nil].
        originalForm fill: relativeBounds rule: Form over fillColor: Color transparent.
        self revealPenStrokes! !

!FatBitsPaint methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:27'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color veryVeryLightGray! !

!FatBitsPaint methodsFor: 'drawing' stamp: 'ar 2/12/2000 18:40'!
drawOn: aCanvas
	| f |
	f := self rotatedForm.
	backgroundColor ifNotNil: [aCanvas fillRectangle: bounds fillStyle: backgroundColor].
	aCanvas translucentImage: f at: bounds origin.! !

!FatBitsPaint methodsFor: 'initialization' stamp: 'RAA 9/25/1999 15:54'!
editForm: aForm

        formToEdit := aForm.
        brushSize := magnification := 64 // (aForm height min: aForm width) max: 4.
        self revert! !

!FatBitsPaint methodsFor: 'menu' stamp: 'RAA 9/25/1999 16:19'!
editSelection

        (self selectionAsForm ifNil: [^ nil]) morphEdit! !

!FatBitsPaint methodsFor: 'menu' stamp: 'nb 6/17/2003 12:25'!
fileOut

        | fileName result |

        result := StandardFileMenu newFile ifNil: [^Beeper beep].
        fileName := result directory fullNameFor: result name.
        Cursor normal showWhile:
                [self unmagnifiedForm writeOnFileNamed: fileName]! !

!FatBitsPaint methodsFor: 'menu' stamp: 'bf 1/5/2000 18:48'!
fill

	| fillPt |
	Cursor blank show.
	Cursor crossHair showWhile:
		[fillPt := Sensor waitButton - self position].
	originalForm shapeFill: brushColor interiorPoint: fillPt.
	self changed.
! !

!FatBitsPaint methodsFor: 'event handling' stamp: 'jm 11/4/97 07:15'!
handlesMouseDown: evt

	^ true
! !

!FatBitsPaint methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:54'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self setCurrentToolTo: self toolsForPaintBrush.
	formToEdit := Form extent: 50 @ 40 depth: 8.
	formToEdit fill: formToEdit boundingBox fillColor: Color veryVeryLightGray.
	brushSize := magnification := 4.
	
	brushColor := Color red.
	backgroundColor := Color white.
	self revert! !

!FatBitsPaint methodsFor: 'menu' stamp: 'RAA 9/25/1999 15:49'!
inspectForm

        self unmagnifiedForm inspect! !

!FatBitsPaint methodsFor: 'menu' stamp: 'RAA 9/25/1999 15:49'!
magnification: aNumber

        | oldPenSize oldForm |
        oldPenSize := brushSize / magnification.
        oldForm := self unmagnifiedForm.
        magnification := aNumber asInteger max: 1.
        self form: (oldForm magnify: oldForm boundingBox by: magnification).
        brush := Pen newOnForm: originalForm.
        self penSize: oldPenSize.
        brush color: brushColor! !

!FatBitsPaint methodsFor: 'event handling' stamp: 'RAA 9/25/1999 15:24'!
mouseDown: evt

        ^ self
                perform: (currentTools at: #mouseDown: ifAbsent: [^nil])
                with: evt! !

!FatBitsPaint methodsFor: 'events' stamp: 'sw 3/30/2002 16:47'!
mouseDownDefault: evt
	lastMouse := nil.
	formToEdit depth = 1 ifTrue:
		[self brushColor: (originalForm colorAt: (self pointGriddedFromEvent: evt)) negated]! !

!FatBitsPaint methodsFor: 'events' stamp: 'sw 3/30/2002 16:47'!
mouseDownSelection: evt

        lastMouse := nil.
        currentSelectionMorph ifNotNil: [currentSelectionMorph delete. currentSelectionMorph := nil].
        selectionAnchor := self pointGriddedFromEvent: evt! !

!FatBitsPaint methodsFor: 'event handling' stamp: 'RAA 9/25/1999 15:24'!
mouseMove: evt

        ^ self
                perform: (currentTools at: #mouseMove: ifAbsent: [^nil])
                with: evt! !

!FatBitsPaint methodsFor: 'events' stamp: 'sw 3/30/2002 16:47'!
mouseMovePaintBrushMode: evt

        | p p2 |
        p := self pointGriddedFromEvent: evt.
        lastMouse = p ifTrue: [^ self].
        lastMouse ifNil: [lastMouse := p].  "first point in a stroke"
        "draw etch-a-sketch style-first horizontal, then vertical"
        p2 := p x@lastMouse y.
        brush drawFrom: lastMouse to: p2.
        brush drawFrom: p2 to: p.
                        
        self revealPenStrokes.
        lastMouse := p! !

!FatBitsPaint methodsFor: 'menu' stamp: 'sw 3/30/2002 16:48'!
mouseMoveSelectionMode: evt

        | p |
        p := self pointGriddedFromEvent: evt.
        lastMouse = p ifTrue: [^ self].

        currentSelectionMorph ifNil:
                [currentSelectionMorph := MarqueeMorph new 
                        color: Color transparent;
                        borderWidth: 2;
                        lock.
                self addMorphFront: currentSelectionMorph.
                currentSelectionMorph startStepping].
        currentSelectionMorph 
                bounds: ((Rectangle encompassing: {p. selectionAnchor}) translateBy: self position).

        lastMouse := p! !

!FatBitsPaint methodsFor: 'initialization' stamp: 'RAA 9/25/1999 22:26'!
openWith: aForm

        self editForm: aForm; openInWorld! !

!FatBitsPaint methodsFor: 'menu' stamp: 'RAA 9/25/1999 21:50'!
pasteSelection

        | relativeBounds tempForm |
        currentSelectionMorph ifNil: [^ nil].
        FormClipboard ifNil: [^nil].
        relativeBounds := currentSelectionMorph bounds translateBy: self position negated.
        tempForm := (FormClipboard magnify: FormClipboard boundingBox by: magnification).
        self form
                copy: (relativeBounds origin extent: tempForm boundingBox extent)
                from: 0@0
                in: tempForm
                rule: Form over. 
        self revealPenStrokes! !

!FatBitsPaint methodsFor: 'menu' stamp: 'jm 12/1/97 12:09'!
penSize: aNumber

	brushSize := (aNumber * magnification) asInteger.
	brush squareNib: brushSize.
! !

!FatBitsPaint methodsFor: 'events' stamp: 'sw 3/30/2002 16:47'!
pointGriddedFromEvent: evt

	| relativePt |
	relativePt := evt cursorPoint - self position.
	^ (relativePt x truncateTo: magnification)@(relativePt y truncateTo: magnification)
! !

!FatBitsPaint methodsFor: 'menu' stamp: 'RAA 9/28/1999 13:03'!
revert
"since WarpBits may mangle an 8-bit ColorForm, make it 32 first"
        self form: ((formToEdit asFormOfDepth: 32) 
                magnify: formToEdit boundingBox 
                by: magnification 
                smoothing: 1).
        brush := Pen newOnForm: originalForm.
        brush squareNib: brushSize.
        brush color: brushColor! !

!FatBitsPaint methodsFor: 'menu' stamp: 'RAA 9/25/1999 16:18'!
selectionAsForm

        | relativeBounds scaledBounds |
        currentSelectionMorph ifNil: [^nil].
        relativeBounds := currentSelectionMorph bounds translateBy: self position negated.
        scaledBounds := relativeBounds scaleBy: 1 / magnification.
        ^ self unmagnifiedForm copy: scaledBounds! !

!FatBitsPaint methodsFor: 'menu' stamp: 'nk 4/18/2004 19:04'!
selectionMenu: evt

        | menu |
 
        (menu := MenuMorph new)
                addTitle: 'Edit';
                addStayUpItem.

        {
                {'edit separately'. #editSelection}.
                {'copy'. #copySelection}.
                {'cut'. #cutSelection}.
                {'paste'. #pasteSelection}
        } do: [:each |
                menu add: each first
                        target: self
                        selector: each second
                        argumentList: #()].
        menu toggleStayUp: evt.
        menu popUpEvent: evt in: self world! !

!FatBitsPaint methodsFor: 'menu' stamp: 'ar 10/5/2000 18:51'!
setBackgroundColor: evt

	self
		changeColorTarget: self 
		selector: #backgroundColor: 
		originalColor: backgroundColor
		hand: evt hand! !

!FatBitsPaint methodsFor: 'initialization' stamp: 'RAA 9/25/1999 21:44'!
setCurrentToolTo: aDictionary

        currentTools := aDictionary.
        currentSelectionMorph ifNotNil: [currentSelectionMorph delete. currentSelectionMorph := nil]! !

!FatBitsPaint methodsFor: 'menu' stamp: 'RAA 6/12/2000 08:58'!
setMagnification: evt
	| menu |
	menu := MenuMorph new.
	((1 to: 8), #(16 24 32)) do: [:w |
		menu add: w printString
			target: self
			selector: #magnification:
			argumentList: (Array with: w).
		magnification = w ifTrue: [menu lastSubmorph color: Color red]].
	menu popUpEvent: evt in: self world! !

!FatBitsPaint methodsFor: 'menu' stamp: 'ar 10/5/2000 18:51'!
setPenColor: evt

	self changeColorTarget: self selector: #brushColor: originalColor: brushColor hand: evt hand.! !

!FatBitsPaint methodsFor: 'menu' stamp: 'RAA 6/12/2000 08:58'!
setPenSize: evt
	| menu sizes |
 
	menu := MenuMorph new.
	sizes := (1 to: 5), (6 to: 12 by: 2), (15 to: 40 by: 5).
	sizes do: [:w |
		menu add: w printString
			target: self
			selector: #penSize:
			argumentList: (Array with: w).
		(brushSize // magnification) = w ifTrue: [menu lastSubmorph color: Color red]].
	menu popUpEvent: evt in: self world! !

!FatBitsPaint methodsFor: 'events' stamp: 'nk 4/18/2004 19:04'!
toolMenu: evt
	| menu |
	menu := MenuMorph new.
	menu
		addTitle: 'Tools';
		addStayUpItem.
	{
		{'paint brush'. self toolsForPaintBrush}.
		{'selections'. self toolsForSelection}
	} do: [:each |
		menu add: each first
			target: self
			selector: #setCurrentToolTo:
			argumentList: {each second}].
	menu toggleStayUp: evt.
	menu popUpEvent: evt in: self world! !

!FatBitsPaint methodsFor: 'initialization' stamp: 'RAA 9/25/1999 15:25'!
toolsForPaintBrush

        ^Dictionary new
                at: #mouseMove: put: #mouseMovePaintBrushMode:;
                at: #mouseDown: put: #mouseDownDefault:;
                yourself! !

!FatBitsPaint methodsFor: 'initialization' stamp: 'RAA 9/25/1999 15:27'!
toolsForSelection

        ^ Dictionary new
                at: #mouseMove: put: #mouseMoveSelectionMode:;
                at: #mouseDown: put: #mouseDownSelection:;
                yourself! !

!FatBitsPaint methodsFor: 'menu' stamp: 'RAA 9/25/1999 15:48'!
unmagnifiedForm

        ^ self form shrink: self form boundingBox by: magnification! !

SketchMorph subclass: #FlexMorph
	instanceVariableNames: 'originalMorph borderWidth borderColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-AdditionalMorphs'!

!FlexMorph methodsFor: 'menus' stamp: 'dgd 8/30/2003 21:44'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	"super addCustomMenuItems: aCustomMenu hand: aHandMorph."
	aCustomMenu addLine.
	aCustomMenu add: 'update from original' translated action: #updateFromOriginal.
	aCustomMenu addList: {
						{'border color...' translated. #changeBorderColor:}.
						{'border width...' translated. #changeBorderWidth:}.
						}.
	aCustomMenu addLine.
! !

!FlexMorph methodsFor: 'accessing' stamp: 'di 1/11/1999 21:43'!
borderColor: aColor
	borderColor := aColor.
	self updateFromOriginal! !

!FlexMorph methodsFor: 'accessing' stamp: 'di 1/11/1999 21:43'!
borderWidth: width
	borderWidth := width asPoint.
	self updateFromOriginal! !

!FlexMorph methodsFor: 'as yet unclassified' stamp: 'ar 10/5/2000 18:52'!
changeBorderColor: evt
	| aHand |
	aHand := evt ifNotNil: [evt hand] ifNil: [self primaryHand].
	self changeColorTarget: self selector: #borderColor: originalColor: self borderColor hand: aHand.! !

!FlexMorph methodsFor: 'as yet unclassified' stamp: 'di 8/30/2000 21:39'!
changeBorderWidth: evt
	| handle origin aHand |
	aHand := evt ifNil: [self primaryHand] ifNotNil: [evt hand].
	origin := aHand position.
	handle := HandleMorph new forEachPointDo:
		[:newPoint | handle removeAllMorphs.
		handle addMorph:
			(LineMorph from: origin to: newPoint color: Color black width: 1).
		self borderWidth: (newPoint - origin) r asInteger // 5].
	aHand attachMorph: handle.
	handle startStepping! !

!FlexMorph methodsFor: 'drawing' stamp: 'di 1/11/1999 20:54'!
drawOn: aCanvas

	originalForm := nil.  "Aggressively uncache the originalForm"
	^ super drawOn: aCanvas! !

!FlexMorph methodsFor: 'geometry' stamp: 'di 1/11/1999 20:35'!
extent: newExtent

	self loadOriginalForm.  "make sure it's not nil"
	^ super extent: newExtent! !

!FlexMorph methodsFor: 'accessing' stamp: 'di 1/11/1999 20:35'!
form

	self loadOriginalForm.  "make sure it's not nil"
	^ super form! !

!FlexMorph methodsFor: 'drawing' stamp: 'di 1/11/1999 20:35'!
generateRotatedForm

	self loadOriginalForm.  "make sure it's not nil"
	^ super generateRotatedForm! !

!FlexMorph methodsFor: 'initialization' stamp: 'di 1/11/1999 21:37'!
initialize
	super initialize.
	borderWidth := 2@2.
	borderColor := Color black.! !

!FlexMorph methodsFor: 'layout' stamp: 'di 1/11/1999 20:35'!
layoutChanged

	self loadOriginalForm.  "make sure it's not nil"
	^ super layoutChanged! !

!FlexMorph methodsFor: 'as yet unclassified' stamp: 'di 1/11/1999 20:34'!
loadOriginalForm

	originalForm ifNil: [self updateFromOriginal].
! !

!FlexMorph methodsFor: 'as yet unclassified' stamp: 'tk 2/25/1999 10:36'!
originalMorph

	^ originalMorph! !

!FlexMorph methodsFor: 'as yet unclassified' stamp: 'di 1/11/1999 20:19'!
originalMorph: aMorph

	originalMorph := aMorph.
	scalePoint := 0.25@0.25.
	self updateFromOriginal.! !

!FlexMorph methodsFor: 'caching' stamp: 'di 1/11/1999 19:44'!
releaseCachedState
	"Clear cache of rotated, scaled Form."

	originalForm := Form extent: 10@10.  "So super hibernate won't have to work hard
												but won't crash either."
	super releaseCachedState.
	rotatedForm := nil.
	originalForm := nil.! !

!FlexMorph methodsFor: 'as yet unclassified' stamp: 'di 1/11/1999 21:46'!
updateFromOriginal

	| intermediateForm |
	intermediateForm := originalMorph imageForm offset: 0@0.
	intermediateForm border: intermediateForm boundingBox
		widthRectangle: (borderWidth corner: borderWidth+1)
		rule: Form over fillColor: borderColor.
	self form: intermediateForm.
	originalMorph fullReleaseCachedState! !

SketchMorph subclass: #MorphThumbnail
	instanceVariableNames: 'morphRepresented'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Books'!

!MorphThumbnail commentStamp: '<historical>' prior: 0!
A morph whose appearance is a thumbnail of some other morph.!

!MorphThumbnail methodsFor: 'menus' stamp: 'dgd 8/30/2003 21:53'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'reveal original morph' translated action: #revealOriginal.
	aCustomMenu add: 'grab original morph' translated action: #grabOriginal.
! !

!MorphThumbnail methodsFor: 'as yet unclassified' stamp: 'sw 11/13/1998 09:53'!
computeThumbnail
	"Assumption on entry:
       The receiver's width represents the maximum width allowable.
       The receiver's height represents the exact height desired."

	| f scaleX scaleY |
	f := morphRepresented imageForm.
	morphRepresented fullReleaseCachedState.
	scaleY := self height / f height.  "keep height invariant"
	scaleX := ((morphRepresented width * scaleY) <= self width)
		ifTrue:
			[scaleY]  "the usual case; same scale factor, to preserve aspect ratio"
		ifFalse:
			[self width / f width].
	self form: (f magnify: f boundingBox by: (scaleX @ scaleY) smoothing: 2).
	self extent: originalForm extent! !

!MorphThumbnail methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:28'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color lightGray! !

!MorphThumbnail methodsFor: 'as yet unclassified' stamp: 'sw 7/6/1998 22:08'!
grabOriginal
	self primaryHand attachMorph: morphRepresented! !

!MorphThumbnail methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:51'!
initialize
	"initialize the state of the receiver"
	| f |
	super initialize.
	""

	f := Form extent: 60 @ 80 depth: Display depth.
	f fill: f boundingBox fillColor: color.
	self form: f! !

!MorphThumbnail methodsFor: 'naming' stamp: 'bf 3/31/1999 12:24'!
innocuousName
	^ morphRepresented isNil
		ifTrue: [super innocuousName]
		ifFalse: [morphRepresented innocuousName]! !

!MorphThumbnail methodsFor: 'parts bin' stamp: 'dgd 2/16/2003 21:37'!
isPartsDonor
	"answer whether the receiver is PartsDonor"
	^ self partRepresented isPartsDonor! !

!MorphThumbnail methodsFor: 'parts bin' stamp: 'dgd 2/16/2003 21:40'!
isPartsDonor: aBoolean
	"change the receiver's isPartDonor property"
	self partRepresented isPartsDonor: aBoolean! !

!MorphThumbnail methodsFor: 'thumbnail' stamp: 'jm 11/17/97 17:30'!
morphRepresented

	^ morphRepresented
! !

!MorphThumbnail methodsFor: 'as yet unclassified' stamp: 'ar 10/7/2000 15:38'!
morphRepresented: aMorph

	morphRepresented := aMorph.
	self computeThumbnail.
! !

!MorphThumbnail methodsFor: 'parts bin' stamp: 'ar 10/6/2000 22:46'!
partRepresented
	^self morphRepresented! !

!MorphThumbnail methodsFor: 'thumbnail' stamp: 'bf 3/31/1999 07:54'!
representativeNoTallerThan: maxHeight norWiderThan: maxWidth thumbnailHeight: thumbnailHeight

	"Return a morph representing the receiver but which is no taller than aHeight.  If the receiver is already small enough, just return it, else return a MorphThumbnail companioned to the receiver, enforcing the maxWidth"

	(self height <= maxHeight and: [self width <= maxWidth]) ifTrue: [^ self].

	^ MorphThumbnail new
		extent: maxWidth @ (thumbnailHeight min: self height);
		morphRepresented: morphRepresented! !

!MorphThumbnail methodsFor: 'as yet unclassified' stamp: 'md 10/22/2003 15:24'!
revealOriginal
	((owner isKindOf: PasteUpMorph) and: [owner alwaysShowThumbnail]) 
		ifTrue: [^Beeper beep].
	morphRepresented owner isNil 
		ifTrue: [^owner replaceSubmorph: self by: morphRepresented].
	Beeper beep! !

!MorphThumbnail methodsFor: 'as yet unclassified' stamp: 'sw 8/10/1998 07:05'!
smaller
	self form: (self form copy: (0@0 extent: self form extent // 2))! !

!MorphThumbnail methodsFor: 'copying' stamp: 'tk 1/8/1999 09:39'!
veryDeepFixupWith: deepCopier
	"If target and arguments fields were weakly copied, fix them here.  If they were in the tree being copied, fix them up, otherwise point to the originals!!!!"

super veryDeepFixupWith: deepCopier.
morphRepresented := deepCopier references at: morphRepresented 
		ifAbsent: [morphRepresented].! !

!MorphThumbnail methodsFor: 'copying' stamp: 'tk 1/8/1999 09:39'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

super veryDeepInner: deepCopier.
morphRepresented := morphRepresented.		"Weakly copied"! !

SketchMorph subclass: #MultiuserTinyPaint
	instanceVariableNames: 'drawState'
	classVariableNames: 'LastMouseIndex PenColorIndex PenIndex PenSizeIndex'
	poolDictionaries: ''
	category: 'MorphicExtras-AdditionalWidgets'!

!MultiuserTinyPaint commentStamp: '<historical>' prior: 0!
A very simple paint program that handles multiple users (hands).
Each user has their own brush size and color.
!

!MultiuserTinyPaint classSide methodsFor: 'class initialization' stamp: 'jm 11/4/97 07:15'!
initialize
	"MultiuserTinyPaint initialize"

	"indices into the state array for a given hand"
	PenIndex := 1.
	PenSizeIndex := 2.
	PenColorIndex := 3.
	LastMouseIndex := 4.
! !

!MultiuserTinyPaint methodsFor: 'menu' stamp: 'dgd 8/30/2003 21:55'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'clear' translated action: #clear.
	aCustomMenu add: 'pen color' translated action: #setPenColor:.
	aCustomMenu add: 'pen size' translated action: #setPenSize:.
"	aCustomMenu add: 'fill' translated action: #fill:."
! !

!MultiuserTinyPaint methodsFor: 'menu' stamp: 'jm 11/4/97 07:15'!
brushColor: aColor hand: hand

	| state |
	(drawState includesKey: hand) ifFalse: [self createDrawStateFor: hand].
	state := drawState at: hand.
	(state at: PenIndex) color: aColor.
	state at: PenColorIndex put: aColor.
! !

!MultiuserTinyPaint methodsFor: 'menu' stamp: 'jm 11/4/97 07:15'!
clear

	| newPen |
	self form: ((Form extent: 400@300 depth: 8) fillColor: color).
	drawState do: [:state |
		newPen := Pen newOnForm: originalForm.
		newPen roundNib: (state at: PenSizeIndex).
		newPen color: (state at: PenColorIndex).
		state at: PenIndex put: newPen].
! !

!MultiuserTinyPaint methodsFor: 'private' stamp: 'jm 11/4/97 07:15'!
createDrawStateFor: aHand

	| pen state |
	pen := Pen newOnForm: originalForm.
	state := Array new: 4.
	state at: PenIndex put: pen.
	state at: PenSizeIndex put: 3.
	state at: PenColorIndex put: Color red.
	state at: LastMouseIndex put: nil.
	drawState at: aHand put: state.
! !

!MultiuserTinyPaint methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:29'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color veryVeryLightGray! !

!MultiuserTinyPaint methodsFor: 'menu' stamp: 'bf 1/5/2000 19:12'!
fill: evt

	| state fillPt |
	(drawState includesKey: evt hand) ifFalse: [self createDrawStateFor: evt hand].
	state := drawState at: evt hand.

	Cursor blank show.
	Cursor crossHair showWhile:
		[fillPt := Sensor waitButton - self position].
	originalForm shapeFill: (state at: PenColorIndex) interiorPoint: fillPt.
	self changed.
! !

!MultiuserTinyPaint methodsFor: 'event handling' stamp: 'jm 11/4/97 07:15'!
handlesMouseDown: evt

	^ true
! !

!MultiuserTinyPaint methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:52'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	
	drawState := IdentityDictionary new.
	self clear! !

!MultiuserTinyPaint methodsFor: 'event handling' stamp: 'jm 11/4/97 07:15'!
mouseDown: evt

	| state |
	(drawState includesKey: evt hand) ifFalse: [self createDrawStateFor: evt hand].
	state := drawState at: evt hand.
	state at: LastMouseIndex put: evt cursorPoint.
! !

!MultiuserTinyPaint methodsFor: 'event handling' stamp: 'jm 11/4/97 07:15'!
mouseMove: evt

	| state lastP p pen |
	state := drawState at: evt hand ifAbsent: [^ self].
	lastP := state at: LastMouseIndex.
	p := evt cursorPoint.
	p = lastP ifTrue: [^ self].

	pen := state at: PenIndex.
	pen drawFrom: lastP - bounds origin to: p - bounds origin.
	self invalidRect: (
		((lastP min: p) - pen sourceForm extent) corner:
		((lastP max: p) + pen sourceForm extent)).
	state at: LastMouseIndex put: p.
! !

!MultiuserTinyPaint methodsFor: 'menu' stamp: 'jm 9/26/97 14:47'!
penSize: anInteger hand: hand

	| state |
	(drawState includesKey: hand) ifFalse: [self createDrawStateFor: hand].
	state := drawState at: hand.
	state at: PenSizeIndex put: anInteger.
	(state at: PenIndex) roundNib: anInteger.
! !

!MultiuserTinyPaint methodsFor: 'menu' stamp: 'ar 10/5/2000 18:52'!
setPenColor: evt
	| state |
	(drawState includesKey: evt hand) ifFalse: [self createDrawStateFor: evt hand].
	state := drawState at: evt hand.
	self changeColorTarget: self selector: #brushColor:hand: originalColor: (state at: PenColorIndex) hand: evt hand! !

!MultiuserTinyPaint methodsFor: 'menu' stamp: 'RAA 6/12/2000 09:07'!
setPenSize: evt

	| menu sizes |
	menu := MenuMorph new.
	sizes := (0 to: 5), (6 to: 12 by: 2), (15 to: 40 by: 5).
	sizes do: [:w |
		menu add: w printString
			target: self
			selector: #penSize:hand:
			argumentList: (Array with: w with: evt hand)].

	menu popUpEvent: evt in: self world! !

!SketchMorph methodsFor: '*MorphicExtras-testing' stamp: 'RAA 12/4/2000 10:56'!
canDrawAtHigherResolution
	
	| pt |
	pt := self scalePoint.
	^pt x < 1.0 or: [pt y < 1.0]! !

!SketchMorph methodsFor: '*MorphicExtras-*morphic-Postscript Canvases' stamp: 'RAA 9/22/2000 15:14'!
drawPostscriptOn: aCanvas

	| top f2 c2 tfx clrs |

	tfx := self transformFrom: self world.
	tfx angle = 0.0 ifFalse: [^super drawPostscriptOn: aCanvas].	"can't do rotated yet"
	clrs := self rotatedForm colorsUsed.
	(clrs includes: Color transparent) 
		ifFalse: [^super drawPostscriptOn: aCanvas].		"no need for this, then"

"Smalltalk at: #Q put: OrderedCollection new"
"Q add: {self. tfx. clrs}."
"(self hasProperty: #BOB) ifTrue: [self halt]."

	top := aCanvas topLevelMorph.
	f2 := Form extent: self extent depth: self rotatedForm depth.
	c2 := f2 getCanvas.
	c2 fillColor: Color white.
	c2 translateBy: bounds origin negated clippingTo: f2 boundingBox during: [ :c |
		top fullDrawOn: c
	].
	aCanvas paintImage: f2 at: bounds origin

! !

SketchMorph subclass: #Thumbnail
	instanceVariableNames: 'maximumWidth minimumHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-PartsBin'!

!Thumbnail commentStamp: '<historical>' prior: 0!
A morph that serves as a thumbnail of a given form.!

!Thumbnail methodsFor: 'initialization' stamp: 'sw 6/13/2001 17:49'!
initialize
	"Initialize the receiver"

	super initialize.
	self setStandardDefaultMetrics! !

!Thumbnail methodsFor: 'thumnail creation' stamp: 'nk 9/1/2004 18:10'!
makeThumbnailFromForm: aForm
	"Make a thumbnail from the form provided, obeying my min and max width and height preferences"

	|  scaleX scaleY margin opaque |
	scaleY := minimumHeight / aForm height.  "keep height invariant"
	scaleX := ((aForm width * scaleY) <= maximumWidth)
		ifTrue: [scaleY]  "the usual case; same scale factor, to preserve aspect ratio"
		ifFalse: [scaleY := maximumWidth / aForm width].

	"self form: (aForm magnify: aForm boundingBox by: (scaleX @ scaleY) smoothing: 2)."
	"Note: A problem with magnify:by: fails to reproduce borders properly.
		The following code does a better job..."
	margin := 1.0 / (scaleX@scaleY) // 2 max: 0@0.  "Extra margin around border"
	opaque := (Form extent: aForm extent + margin depth: 32) "fillWhite".
	aForm fixAlpha displayOn: opaque at: aForm offset negated rule: Form blendAlpha.  "Opaque form shrinks better"
	opaque fixAlpha.
	self form: (opaque magnify: opaque boundingBox by: (scaleX @ scaleY) smoothing: 2).

	self extent: originalForm extent! !

!Thumbnail methodsFor: 'initialization' stamp: 'sw 6/13/2001 18:17'!
maxWidth: maxWidth minHeight: minHeight
	"Set the min and max heights and widths as indicated"

	maximumWidth := maxWidth.
	minimumHeight := minHeight! !

!Thumbnail methodsFor: 'initialization' stamp: 'sw 6/13/2001 19:38'!
setStandardDefaultMetrics
	"Provide the current choices for min.max width/height for thumbnails"

	self maxWidth: 60 minHeight: 24! !

SketchMorph subclass: #TinyPaint
	instanceVariableNames: 'brush brushSize brushColor lastMouse'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!TinyPaint methodsFor: 'menu' stamp: 'dgd 8/30/2003 22:20'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'clear' translated action: #clear.
	aCustomMenu add: 'pen color' translated action: #setPenColor:.
	aCustomMenu add: 'pen size' translated action: #setPenSize.
	aCustomMenu add: 'fill' translated action: #fill.
! !

!TinyPaint methodsFor: 'menu' stamp: 'jm 11/4/97 07:15'!
brushColor: aColor

	brushColor := aColor.
	brush color: aColor.
! !

!TinyPaint methodsFor: 'menu' stamp: 'jm 5/6/1998 16:23'!
clear

	self form: ((Form extent: 125@100 depth: 8) fillColor: color).
	brush := Pen newOnForm: originalForm.
	brush roundNib: brushSize.
	brush color: brushColor.
! !

!TinyPaint methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:31'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color veryVeryLightGray! !

!TinyPaint methodsFor: 'menu' stamp: 'bf 1/5/2000 19:39'!
fill

	| fillPt |
	Cursor blank show.
	Cursor crossHair showWhile:
		[fillPt := Sensor waitButton - self position].
	originalForm shapeFill: brushColor interiorPoint: fillPt.
	self changed.
! !

!TinyPaint methodsFor: 'event handling' stamp: 'sw 5/11/1998 14:02'!
handlesMouseDown: evt

	^ self inPartsBin not
! !

!TinyPaint methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:53'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	
	brushColor := Color red.
	brushSize := 3.
	self clear! !

!TinyPaint methodsFor: 'event handling' stamp: 'jm 5/6/1998 16:28'!
mouseDown: evt

	lastMouse := evt cursorPoint.
	brush drawFrom: lastMouse - bounds origin to: lastMouse - bounds origin.
	self invalidRect:
		((lastMouse - brush sourceForm extent) corner:
		 (lastMouse + brush sourceForm extent)).
! !

!TinyPaint methodsFor: 'event handling' stamp: 'jm 11/4/97 07:15'!
mouseMove: evt

	| p |
	p := evt cursorPoint.
	p = lastMouse ifTrue: [^ self].
	brush drawFrom: lastMouse - bounds origin to: p - bounds origin.
	self invalidRect: (
		((lastMouse min: p) - brush sourceForm extent) corner:
		((lastMouse max: p) + brush sourceForm extent)).
	lastMouse := p.
! !

!TinyPaint methodsFor: 'menu' stamp: 'ar 10/5/2000 18:54'!
setPenColor: evt

	self changeColorTarget: self selector: #brushColor: originalColor: brushColor hand: evt hand.! !

!TinyPaint methodsFor: 'menu' stamp: 'jm 11/4/97 07:16'!
setPenSize

	| menu sizes nibSize |
	menu := CustomMenu new.
	sizes := (0 to: 5), (6 to: 12 by: 2), (15 to: 40 by: 5).
	sizes do: [:w | menu add: w printString action: w].
	nibSize := menu startUp.
	nibSize ifNotNil: [
		brushSize := nibSize.
		brush roundNib: nibSize].
! !

!MenuIcons class methodsFor: '*MorphicExtras-accessing - icons' stamp: 'dgd 9/25/2004 22:59'!
backIcon
	"Private - Generated method"
	^ Icons
			at: #'back'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self backIconContents readStream) ].! !

!MenuIcons class methodsFor: '*MorphicExtras-accessing - icons' stamp: 'dgd 9/25/2004 22:59'!
forwardIcon
	"Private - Generated method"
	^ Icons
			at: #'forward'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self forwardIconContents readStream) ].! !

!MenuIcons class methodsFor: '*MorphicExtras-accessing - icons' stamp: 'dgd 9/25/2004 22:59'!
helpIcon
	"Private - Generated method"
	^ Icons
			at: #'help'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self helpIconContents readStream) ].! !

!MenuIcons class methodsFor: '*MorphicExtras-accessing - icons' stamp: 'dgd 9/22/2004 19:35'!
openIcon
	"Private - Generated method"
	^ Icons
			at: #'open'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self openIconContents readStream) ].! !

ImageMorph subclass: #AnimatedImageMorph
	instanceVariableNames: 'images delays stepTime nextTime imageIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-AdditionalMorphs'!

!AnimatedImageMorph commentStamp: '<historical>' prior: 0!
I am an ImageMorph that can hold more than one image. Each image has its own delay time.!

!AnimatedImageMorph classSide methodsFor: 'fileIn/Out' stamp: 'nk 6/12/2004 13:11'!
fileReaderServicesForFile: fullName suffix: suffix

	^((AnimatedGIFReadWriter typicalFileExtensions asSet
		add: '*'; add: 'form'; yourself)
		includes: suffix)
		ifTrue: [ self services ]
		ifFalse: [#()]
! !

!AnimatedImageMorph classSide methodsFor: 'instance creation' stamp: 'nk 2/15/2004 15:23'!
fromGIFFileNamed: fileName
	| reader |
	reader := AnimatedGIFReadWriter formsFromFileNamed: fileName.
	^reader forms size = 1
		ifTrue: [ ImageMorph new image: reader forms first ]
		ifFalse: [ self new fromReader: reader ]! !

!AnimatedImageMorph classSide methodsFor: 'instance creation' stamp: 'nk 2/15/2004 15:27'!
fromStream: aStream
	| reader |
	reader := AnimatedGIFReadWriter formsFromStream: aStream.
	^reader forms size = 1
		ifTrue: [ ImageMorph new image: reader forms first ]
		ifFalse: [ self new fromReader: reader ]! !

!AnimatedImageMorph classSide methodsFor: 'class initialization' stamp: 'asm 12/11/2003 21:05'!
initialize
	"register the receiver in the global registries"
	self environment
		at: #FileList
		ifPresent: [:cl | cl registerFileReader: self]! !

!AnimatedImageMorph classSide methodsFor: 'instance creation' stamp: 'nk 2/15/2004 16:57'!
openGIFInWindow: aStream
	^(self fromStream: aStream binary) openInWorld! !

!AnimatedImageMorph classSide methodsFor: 'fileIn/Out' stamp: 'dgd 4/3/2006 13:36'!
serviceOpenGIFInWindow
	"Answer a service for opening a gif graphic in a window"
	^ (SimpleServiceEntry
		provider: self
		label: 'open the graphic as a morph'
		selector: #openGIFInWindow:
		description: 'open a GIF graphic file as a morph'
		buttonLabel: 'open')
		argumentGetter: [:fileList | fileList readOnlyStream]! !

!AnimatedImageMorph classSide methodsFor: 'fileIn/Out' stamp: 'dgd 4/3/2006 13:36'!
services
	^ Array
		with: self serviceOpenGIFInWindow
		"with: Form serviceImageImports"
		with: Form serviceImageAsBackground! !

!AnimatedImageMorph classSide methodsFor: 'class initialization' stamp: 'asm 12/11/2003 21:01'!
unload
	"Unload the receiver from global registries"
	self environment
		at: #FileList
		ifPresent: [:cl | cl unregisterFileReader: self]! !

!AnimatedImageMorph methodsFor: 'private' stamp: 'nk 2/15/2004 15:20'!
fromGIFFileNamed: fileName
	self fromReader: (AnimatedGIFReadWriter formsFromFileNamed: fileName)! !

!AnimatedImageMorph methodsFor: 'private' stamp: 'bf 2/25/2005 11:18'!
fromReader: reader
	images := reader forms.
	delays := reader delays.
	imageIndex := 0.
	self image: (Form extent: images first extent depth: 32).
	self step! !

!AnimatedImageMorph methodsFor: 'private' stamp: 'nk 2/15/2004 15:20'!
fromStream: aStream
	self fromReader: (AnimatedGIFReadWriter formsFromStream: aStream)! !

!AnimatedImageMorph methodsFor: 'private' stamp: 'mir 11/19/2003 13:42'!
images
	^images! !

!AnimatedImageMorph methodsFor: 'private' stamp: 'bf 2/25/2005 11:09'!
initialize
	nextTime := Time millisecondClockValue.
	imageIndex := 1.
	stepTime := 10.
	super initialize! !

!AnimatedImageMorph methodsFor: 'stepping and presenter' stamp: 'marcus.denker 9/14/2008 19:13'!
step
	| d |
	images isEmpty ifTrue: [^ self].
		
	nextTime > Time millisecondClockValue ifTrue: [^self].
	self changed.
	self image: (images at: (imageIndex := imageIndex \\ images size + 1)).
	self changed . 
	d := (delays at: imageIndex) ifNil: [0].
	nextTime := Time millisecondClockValue + d
! !

!AnimatedImageMorph methodsFor: 'stepping and presenter' stamp: 'mir 11/19/2003 13:40'!
stepTime
	^stepTime ifNil: [super stepTime]! !

!AnimatedImageMorph methodsFor: 'stepping and presenter' stamp: 'mir 11/19/2003 13:40'!
stepTime: anInteger
	stepTime := anInteger! !

!AnimatedImageMorph methodsFor: 'stepping and presenter' stamp: 'asm 12/15/2003 19:44'!
wantsSteps
	^(images size > 1)
! !

ImageMorph subclass: #GrabPatchMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!GrabPatchMorph commentStamp: 'sw 8/1/2004 13:27' prior: 0!
When an instance of GrabPatchMorph is dropped by the user, it signals a desire to do a screen-grab of a rectangular area.!

!GrabPatchMorph classSide methodsFor: 'instance creation' stamp: 'sw 7/5/2004 01:53'!
authoringPrototype
	"Answer a prototype for use in a parts bin"

	^ self new image: (ScriptingSystem formAtKey: 'GrabPatch'); markAsPartsDonor; setBalloonText: 'Use this to grab a rectangular patch from the screen'; yourself! !

!GrabPatchMorph classSide methodsFor: 'parts bin' stamp: 'sw 7/5/2004 01:51'!
descriptionForPartsBin
	"Answer a description of the receiver's instances for a parts bin"

	^ self partName:	'Grab Patch'
		categories:		#('Graphics')
		documentation:	'Use this to grab a rectangular patch from the screen'! !

!GrabPatchMorph methodsFor: 'initialization' stamp: 'sw 7/5/2004 01:51'!
initialize
	"Initialize the receiver.  Emblazon the GrabPatch icon on its face"

	super initialize.
	self image: (ScriptingSystem formAtKey: 'GrabPatch')! !

!GrabPatchMorph methodsFor: 'initialization' stamp: 'sw 7/5/2004 01:51'!
initializeToStandAlone
	"Initialize the receiver.  Emblazon the GrabPatch icon on its face"

	super initializeToStandAlone.
	self image: (ScriptingSystem formAtKey: 'GrabPatch')! !

!GrabPatchMorph methodsFor: 'dropping' stamp: 'sw 4/6/2004 15:52'!
justDroppedInto: aPasteUpMorph event: anEvent
	"This message is sent to a dropped morph after it has been dropped on--and been accepted by--a drop-sensitive morph"

	aPasteUpMorph isPartsBin ifFalse:
		[self delete.
		ActiveWorld displayWorldSafely; runStepMethods.  "But the HW cursor stays up still ???"
		^ aPasteUpMorph grabDrawingFromScreen: anEvent].
	^ super justDroppedInto: aPasteUpMorph event: anEvent! !

!GrabPatchMorph methodsFor: 'dropping' stamp: 'sw 4/6/2004 14:40'!
wantsToBeDroppedInto: aMorph
	"Only into PasteUps that are not part bins"

	^ aMorph isPlayfieldLike! !

!ImageMorph methodsFor: '*MorphicExtras-*morphic-Postscript Canvases' stamp: 'RAA 4/20/2001 12:11'!
drawPostscriptOn: aCanvas

	| top f2 c2 clrs |

	clrs := image colorsUsed.
	(clrs includes: Color transparent) 
		ifFalse: [^super drawPostscriptOn: aCanvas].		"no need for this, then"

	top := aCanvas topLevelMorph.
	f2 := Form extent: self extent depth: image depth.
	c2 := f2 getCanvas.
	c2 fillColor: Color white.
	c2 translateBy: bounds origin negated clippingTo: f2 boundingBox during: [ :c |
		top fullDrawOn: c
	].
	aCanvas paintImage: f2 at: bounds origin

! !

ImageMorph subclass: #ImageMorphWithSpotlight
	instanceVariableNames: 'spotImage spotShape spotBuffer spotOn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!ImageMorphWithSpotlight commentStamp: '<historical>' prior: 0!
This class implements an image that appears one way or another depending upon whether it lies within a spotlight shape that moves with the cursor.  As delivered, the shape is a simple circle, the spotlighted appearance is that of a ColorForm, and the non-highlighted apperarance is a derived gray-scale form.

The implementation will space-efficient if supplied with a ColorForm, because the gray-scale derived form will share the same bitmap.

In general, any two images can be used -- one could be blurred, the other sharp -- and the masking form can be any shape.

At some point this class should be merged somehow with ScreeningMorph.!

!ImageMorphWithSpotlight methodsFor: 'all' stamp: 'di 5/26/1999 07:51'!
backgroundImage: bkgndImage spotImage: anImage spotShape: formOfDepth1

	"See class comment."
	spotImage := anImage.
	spotShape := formOfDepth1.
	spotBuffer := Form extent: spotShape extent depth: spotImage depth.
	super image: bkgndImage.
	spotOn := false.! !

!ImageMorphWithSpotlight methodsFor: 'drawing' stamp: 'ar 2/12/2000 18:06'!
drawOn: aCanvas

	super drawOn: aCanvas.
	spotOn ifTrue:
		[aCanvas paintImage: spotBuffer at: spotBuffer offset].
! !

!ImageMorphWithSpotlight methodsFor: 'accessing' stamp: 'di 5/26/1999 08:05'!
image: anImage

	"The spotlight will reveal the original  form supplied
	while the background form will be derived grayscale."
	"See class comment."
	self backgroundImage: anImage asGrayScale
		spotImage: anImage
		spotShape: (Form dotOfSize: 100)
! !

!ImageMorphWithSpotlight methodsFor: 'all' stamp: 'di 5/24/1999 22:37'!
spotChanged

	self invalidRect:
		((spotBuffer offset extent: spotBuffer extent) "intersect: self bounds")! !

!ImageMorphWithSpotlight methodsFor: 'stepping and presenter' stamp: 'ar 5/28/2000 12:09'!
step
	| cp |
	((self bounds expandBy: spotBuffer extent // 2) containsPoint: (cp := self cursorPoint))
		ifTrue:
		[(cp - (spotBuffer extent // 2)) = spotBuffer offset ifTrue: [^ self].  "No change"
		"Cursor has moved where its spotShape is visible"
		spotOn := true.
		self spotChanged.
		spotBuffer offset: cp - (spotBuffer extent // 2).
		self spotChanged.
		(BitBlt current toForm: spotBuffer)
			"clear the buffer"
			fill: spotBuffer boundingBox fillColor: (Bitmap with: 0) rule: Form over;
			"Clip anything outside the base form"
			clipRect: (spotBuffer boundingBox
				intersect: (self bounds translateBy: spotBuffer offset negated));
			"Fill the spotBuffer with the spot image"
			copyForm: spotImage to: self position - spotBuffer offset rule: Form over;
			"Mask everything outside the spot shape to 0 (transparent)."
			copyForm: spotShape to: spotShape offset negated rule: Form and
				colorMap: (Bitmap with: 0 with: 16rFFFFFFFF)]
		ifFalse:
		[spotOn ifTrue: [self spotChanged. spotOn := false]]! !

!ImageMorphWithSpotlight methodsFor: 'testing' stamp: 'di 5/24/1999 21:43'!
stepTime

	^ 20! !

ImageMorph subclass: #LassoPatchMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!LassoPatchMorph commentStamp: 'sw 8/1/2004 13:27' prior: 0!
When dropped by the user, a cursor is presented, allowing the user to grab a rectangular patch from the screen.!

!LassoPatchMorph classSide methodsFor: 'instance creation' stamp: 'sw 7/5/2004 01:53'!
authoringPrototype
	"Answer a prototype  for use in a parts bin"

	^ self new image: (ScriptingSystem formAtKey: 'Lasso'); markAsPartsDonor; setBalloonText: 'Drop this on the desktop and you can then grab a patch from the screen with a lasso.'; yourself! !

!LassoPatchMorph classSide methodsFor: 'parts bin' stamp: 'sw 7/5/2004 01:46'!
descriptionForPartsBin
	"Answer a description of the receiver to be used in a parts bin"

	^ self partName:	'Lasso'
		categories:		#('Graphics')
		documentation:	'Drop this icon to grab a patch from the screen with a lasso.'! !

!LassoPatchMorph methodsFor: 'initialization' stamp: 'sw 7/5/2004 01:43'!
initialize
	"Initialize the receiver.  Sets its image to the lasso picture"

	super initialize.
	self image: (ScriptingSystem formAtKey: 'Lasso')! !

!LassoPatchMorph methodsFor: 'initialization' stamp: 'sw 7/5/2004 01:44'!
initializeToStandAlone
	"Initialize the receiver such that it can live on its own.  Sets its image to the lasso picture"

	super initializeToStandAlone.
	self image: (ScriptingSystem formAtKey: 'Lasso')! !

!LassoPatchMorph methodsFor: 'dropping' stamp: 'sw 4/6/2004 15:43'!
justDroppedInto: aPasteUpMorph event: anEvent
	"This message is sent to a dropped morph after it has been dropped on--and been accepted by--a drop-sensitive morph"

	aPasteUpMorph isPartsBin ifFalse:
		[self delete.
		ActiveWorld displayWorldSafely; runStepMethods.
		^ aPasteUpMorph grabLassoFromScreen: anEvent].
	^ super justDroppedInto: aPasteUpMorph event: anEvent! !

!LassoPatchMorph methodsFor: 'dropping' stamp: 'sw 4/6/2004 13:19'!
wantsToBeDroppedInto: aMorph
	"Only into PasteUps that are not part bins"

	^ aMorph isPlayfieldLike! !

ImageMorph subclass: #PaintBoxColorPicker
	instanceVariableNames: 'currentColor locOfCurrent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Support'!

!PaintBoxColorPicker commentStamp: 'JMM 9/13/2004 07:37' prior: 0!
A pop-up, 32-bit color palette used as part of a PaintBoxMorph.
!

!PaintBoxColorPicker methodsFor: 'initialization' stamp: 'RAA 8/15/2000 14:57'!
beStatic

	"an aid for Nebraska: make the color chart a static image to reduce traffic"
	image isStatic ifFalse: [
		image := image as: StaticForm
	].! !

!PaintBoxColorPicker methodsFor: 'accessing' stamp: 'jm 4/29/1998 20:07'!
currentColor

	^ currentColor
! !

!PaintBoxColorPicker methodsFor: 'accessing' stamp: 'jm 4/29/1998 20:18'!
currentColor: aColor
	"Force me to select the given color."

	currentColor := aColor.
	locOfCurrent := nil.  "remove the marker"
! !

!PaintBoxColorPicker methodsFor: 'drawing' stamp: 'jm 4/29/1998 20:00'!
drawOn: aCanvas
	"Image plus circles for currently selected color."

	| c |
	super drawOn: aCanvas.
	locOfCurrent ifNotNil: [
		c := self ringColor.
		aCanvas
			fillOval: (Rectangle center: locOfCurrent + self topLeft extent: 9@9)
			color: Color transparent
			borderWidth: 1
			borderColor: c].
! !

!PaintBoxColorPicker methodsFor: 'event handling' stamp: 'ar 10/5/2000 16:01'!
endColorSelection: evt
	"Update current color and report it to paint box."

	self selectColor: evt.
	"restore mouseLeave handling"
	self on: #mouseLeave send: #delete to: self.
! !

!PaintBoxColorPicker methodsFor: 'event handling' stamp: 'ar 10/25/2000 17:49'!
initMouseHandlers

	self on: #mouseDown send: #startColorSelection: to: self.
	self on: #mouseMove send: #selectColor: to: self.
	self on: #mouseUp send: #endColorSelection: to: self.
	self on: #mouseLeave send: #delete to: self.
! !

!PaintBoxColorPicker methodsFor: 'initialization' stamp: 'jm 4/29/1998 21:24'!
initialize

	super initialize.
	currentColor := Color black.
	locOfCurrent := nil.
	self initMouseHandlers.
! !

!PaintBoxColorPicker methodsFor: 'drawing' stamp: 'jm 4/29/1998 20:00'!
ringColor
	"Choose a color that contrasts with my current color. If that color isn't redish, return red. Otherwise, return green"

	currentColor isTransparent ifTrue: [^ Color red].
	currentColor red < 0.5 ifTrue: [^ Color red].
	currentColor red > (currentColor green + (currentColor blue * 0.5))
		ifTrue: [^ Color green]
		ifFalse: [^ Color red].
! !

!PaintBoxColorPicker methodsFor: 'event handling' stamp: 'JMM 9/13/2004 09:08'!
selectColor: evt 
	"Update the receiver from the given event. Constrain locOfCurrent's center to lie within the color selection area. If it is partially in the transparent area, snap it entirely into it vertically."

	| r |

	locOfCurrent := evt cursorPoint - self topLeft.
	r := Rectangle center: locOfCurrent extent: 9 @ 9.
	locOfCurrent := locOfCurrent 
				+ (r amountToTranslateWithin: (8 @ 11 corner: (self image width-6) @ (self image height-6))).
	locOfCurrent x > (self image width-(12+7))  ifTrue: [locOfCurrent := (self image width - 12) @ locOfCurrent y].	"snap into grayscale"
	currentColor := locOfCurrent y < 19
				ifTrue:  
					[locOfCurrent := locOfCurrent x @ 11.	"snap into transparent"
					Color transparent]
				ifFalse: [image colorAt: locOfCurrent].
	(owner isKindOf: PaintBoxMorph) 
		ifTrue: [owner takeColorEvt: evt from: self].
	self changed! !

!PaintBoxColorPicker methodsFor: 'event handling' stamp: 'jm 4/29/1998 21:21'!
startColorSelection: evt
	"Start color selection. Make me stay up as long as the mouse is down."

	self on: #mouseLeave send: nil to: nil.
	self selectColor: evt.
! !

ImageMorph subclass: #PaintBoxMorph
	instanceVariableNames: 'action tool currentCursor thumbnail currentColor currentBrush colorMemory colorPatch stampHolder rotationTabForm scaleTabForm colorMemoryThin brushes focusMorph weakDependents recentColors'
	classVariableNames: 'AllOffImage AllOnImage AllPressedImage ColorChart OriginalBounds Prototype RecentColors'
	poolDictionaries: ''
	category: 'MorphicExtras-Support'!

!PaintBoxMorph classSide methodsFor: 'as yet unclassified' stamp: 'tk 8/21/2000 12:52'!
fixUpPrototype
	"PaintBoxMorph fixUpPrototype"
self error: 'who uses this?'.
	Prototype eventHandler: nil! !

!PaintBoxMorph classSide methodsFor: 'class initialization' stamp: 'tk 8/21/2000 12:58'!
initialize
	"PaintBoxMorph initialize"

	Prototype eventHandler: nil.
	Prototype focusMorph: nil.
	Prototype stampHolder clear.  "clear stamps"
	Prototype delete.  "break link to world, if any"

	AllOnImage := AllOffImage := AllPressedImage := nil.
	OriginalBounds := nil.

! !

!PaintBoxMorph classSide methodsFor: 'as yet unclassified' stamp: 'ar 7/8/2006 20:33'!
initializeColorChart
	"PaintBoxMorph initializeColorChart"
	ColorChart := (ColorPickerMorph colorPaletteForDepth: 32 extent: (360+10)@(180+10))! !

!PaintBoxMorph classSide methodsFor: 'notification' stamp: 'ar 7/8/2006 20:33'!
localeChanged
	| caption |
	caption := ColorPickerMorph noColorCaption.
	caption displayOn: ColorChart at: ColorChart boundingBox topCenter - (caption width // 2 @ 0)! !

!PaintBoxMorph classSide methodsFor: 'instance creation' stamp: 'bf 10/11/2004 13:37'!
new

	| pb button dualUse formCanvas rect |
	pb := Prototype veryDeepCopy.
		"Assume that the PaintBox does not contain any scripted Players!!"
	pb stampHolder normalize.	"Get the stamps to show"
	"Get my own copies of the brushes so I can modify them"
	#(brush1: brush2: brush3: brush4: brush5: brush6:) do: [:sel |
		button := pb submorphNamed: sel.
		button offImage: button offImage deepCopy.
		dualUse := button onImage == button pressedImage.	"sometimes shared"
		button onImage: button onImage deepCopy.
		dualUse
			ifTrue: [button pressedImage: button onImage]
			ifFalse: [button pressedImage: button pressedImage deepCopy].
		"force color maps for later mapping"
		button offImage.
		button onImage.
		button pressedImage.
		formCanvas := button onImage getCanvas.
		formCanvas := formCanvas
			copyOrigin: 0@0
			clipRect: (rect := 0@0 extent: button onImage extent).
		(#(brush1: brush3:) includes: sel) ifTrue: [
			rect := rect origin corner: rect corner - (2@2)].
		(#brush2: == sel) ifTrue: [
			rect := rect origin corner: rect corner - (2@4)].
		formCanvas frameAndFillRectangle: rect fillColor: Color transparent
			borderWidth: 2 borderColor: (Color r: 0.599 g: 0.8 b: 1.0).
		].
	pb showColor.
	pb fixUpRecentColors.
	pb addLabels.
	^ pb! !

!PaintBoxMorph classSide methodsFor: 'as yet unclassified' stamp: 'tk 10/12/97 11:01'!
prototype
	"Later we will be a subclass of Model, and it will have a general version of this"
	^ Prototype! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'laza 3/24/2000 17:58'!
action
	^ action	! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'RAA 8/16/2000 13:35'!
actionCursor
	"Return the cursor to use with this painting action/tool. Offset of the form must be set."

	^self
		cursorFor: action
		oldCursor: currentCursor
		currentNib: self getNib
		color: currentColor
! !

!PaintBoxMorph methodsFor: 'other' stamp: 'dgd 8/30/2003 21:55'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	"super addCustomMenuItems: aCustomMenu hand: aHandMorph."
		"don't want the ones from ImageMorph"
	aCustomMenu add: 'grab stamp from screen' translated action: #grabFromScreen:.

! !

!PaintBoxMorph methodsFor: 'other' stamp: 'yo 1/13/2005 14:08'!
addGraphicLabels
	"translate button labels"

	| formTranslator ext pos newForm |
	formTranslator := NaturalLanguageFormTranslator localeID: (Locale current localeID).

	#('KEEP' 'UNDO' 'CLEAR' 'TOSS') do: [:label |
		(formTranslator translate: label, '-off') ifNil: [^ false].
		(formTranslator translate: label, '-pressed') ifNil: [^ false].
	].
	
	#('keep:' 'undo:' 'clear:' 'toss:') with: #('KEEP' 'UNDO' 'CLEAR' 'TOSS') do: [:extName :label |
		| button |
		button := submorphs detect: [:m | m externalName = extName] ifNone: [nil].
		button ifNotNil: [
			button removeAllMorphs.
			ext := button extent.
			pos := button position.
			(newForm := formTranslator translate: label, '-off') ifNotNil: [
				button offImage: newForm.

			].
			(newForm := formTranslator translate: label, '-pressed') ifNotNil: [
				button pressedImage: newForm.
			].
			button extent: ext.
			button position: pos.
		].
	].

	^ true.
! !

!PaintBoxMorph methodsFor: 'other' stamp: 'yo 1/13/2005 14:08'!
addLabels

	Preferences useFormsInPaintBox ifFalse: [
		self addTextualLabels.
	] ifTrue: [
		self addGraphicLabels ifFalse: [self addTextualLabels].
	].
! !

!PaintBoxMorph methodsFor: 'other' stamp: 'yo 1/13/2005 11:06'!
addTextualLabels
	"translate button labels"

	#('keep:' 'undo:' 'clear:' 'toss:') with: #('KEEP' 'UNDO' 'CLEAR' 'TOSS') do: [:extName :label |
		| button |
		button := submorphs detect: [:m | m externalName = extName] ifNone: [nil].
		button ifNotNil: [
			button removeAllMorphs.
			button addMorph: (TextMorph new 
				contentsWrapped: (Text string: label translated
					attributes: {
						TextAlignment centered. 
						TextEmphasis bold.
						TextFontReference toFont:
							(Preferences standardPaintBoxButtonFont)});
				bounds: (button bounds translateBy: 0@3);
				lock)]]! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'RAA 8/15/2000 16:47'!
addWeakDependent: anObject

	weakDependents ifNil: [^weakDependents := WeakArray with: anObject].
	weakDependents := weakDependents,{anObject} reject: [ :each | each isNil].! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'RAA 8/15/2000 14:59'!
beStatic

	colorMemory ifNotNil: [colorMemory beStatic].! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'dgd 2/22/2003 19:03'!
brush: brushButton action: aSelector nib: aMask evt: evt 
	"Set the current tool and action for the paintBox.  "

	currentBrush 
		ifNotNil: [currentBrush == brushButton ifFalse: [currentBrush state: #off]].
	currentBrush := brushButton.	"A ThreePhaseButtonMorph"

	"currentBrush state: #on.	already done"
	"aSelector is like brush3:.  Don't save it.  Can always say (currentBrush arguments at: 2)
	aMask is the brush shape.  Don't save it.  Can always say (currentBrush arguments at: 3)"
	self notifyWeakDependentsWith: { 
				#currentNib.
				evt.
				currentBrush arguments third}.
	self brushable ifFalse: [self setAction: #paint: evt: evt]	"User now thinking of painting"! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'tk 10/19/97 11:12'!
brushable
	"Return true if the current tool uses a brush."
	^ (#("non-brushable" eyedropper: fill: pickup: stamp:) indexOf: action) = 0! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'RAA 8/16/2000 01:34'!
clear: clearButton with: clearSelector evt: evt

	| ss |
	(ss := self focusMorph) 
		ifNotNil: [ss clearPainting: self]
		ifNil: [self notCurrentlyPainting].
	clearButton state: #off.! !

!PaintBoxMorph methodsFor: 'other' stamp: 'tk 10/31/97 13:38'!
colorMemory

	^ colorMemory! !

!PaintBoxMorph methodsFor: 'other' stamp: 'di 10/14/97 10:15'!
colorMemory: aMorph

	colorMemory := aMorph! !

!PaintBoxMorph methodsFor: 'other' stamp: 'tk 10/31/97 13:35'!
colorPatch
	^ colorPatch! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'tk 7/15/97 13:35'!
colorable
	"Return true if the current tool uses a color."
	^ (#("These use no color" erase: eyedropper: "fill: does" pickup: stamp:) indexOf: action) = 0! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'sw 5/23/2001 13:53'!
createButtons
	"Create buttons one at a time and let the user place them over the background.  Later can move them again by turning on AuthorModeOwner in ThreePhaseButtonMorph.
	self createButtons.	"

	| rect button nib |
	#(erase: eyedropper: fill: paint: rect: ellipse: polygon: line: star: pickup: "pickup: pickup: pickup:" stamp: "stamp: stamp: stamp:" undo: keep: toss: prevStamp: nextStamp:) do: [:sel |
		(self submorphNamed: sel) ifNil:
			[self inform: 'Rectangle for ',sel.
			rect := Rectangle fromUser.
			button := ThreePhaseButtonMorph new.
			button onImage: nil; bounds: rect.
			self addMorph: button.
			button actionSelector: #tool:action:cursor:evt:; arguments: (Array with: button with: sel with: nil).
			button actWhen: #buttonUp; target: self]].
	#(brush1: brush2: brush3: brush4: brush5: brush6: ) doWithIndex: [:sel :ind |
		(self submorphNamed: sel) ifNil:
			[self inform: 'Rectangle for ',sel.
			rect := Rectangle fromUser.
			button := ThreePhaseButtonMorph new.
			button onImage: nil; bounds: rect.
			self addMorph: button.
			nib := Form dotOfSize: (#(1 2 3 6 11 26) at: ind).
			button actionSelector: #brush:action:nib:evt:; 
					arguments: (Array with: button with: sel with: nib).
			button actWhen: #buttonUp; target: self]].
	"stamp:  Stamps are held in a ScrollingToolHolder.  Pickups and stamps and brushes are id-ed by the button == with item from a list."


! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'RAA 8/17/2000 17:06'!
currentColor: aColor evt: evt
	"Accept a color from the outside.  (my colorMemoryMorph must call takeColorEvt: evt from: colorPicker instead)"

	currentColor := aColor.
	colorMemory currentColor: aColor.
	self notifyWeakDependentsWith: {#currentColor. evt. currentColor}.
	self showColor.
	self colorable ifFalse: [self setAction: #paint: evt: evt].	"User now thinking of painting"! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'RAA 8/16/2000 13:37'!
cursorFor: anAction oldCursor: oldCursor currentNib: aNibForm color: aColor 
	"Return the cursor to use with this painting action/tool. Offset of the 
	form must be set."

	| ff width co larger c box |

	anAction == #paint:
		ifTrue: ["Make a cursor from the brush and the color"
			width := aNibForm width.
			c := self ringColorFor: aColor.
			co := oldCursor offset - (width // 4 @ 34 - (width // 6)) min: 0 @ 0.
			larger := width negated + 10 @ 0 extent: oldCursor extent + (width @ width).
			ff := oldCursor copy: larger.
			ff colors at: 1 put: Color transparent.
			ff colors at: 2 put: Color transparent.
			ff offset: co - (width @ width // 2).
			ff getCanvas
				fillOval: (Rectangle center: ff offset negated extent: width @ width)
				color: Color transparent
				borderWidth: 1
				borderColor: c.
			^ ff].
	anAction == #erase:
		ifTrue: ["Make a cursor from the cursor and the color"
			width := aNibForm width.
			co := oldCursor offset + (width // 2 @ 4) min: 0 @ 0.
			larger := 0 @ 0 extent: oldCursor extent + (width @ width).
			ff := oldCursor copy: larger.
			ff offset: co - (width @ width // 2).
			ff
				fill: (box := co negated extent: width @ width)
				fillColor: (Color r: 0.5 g: 0.5 b: 1.0).
			ff
				fill: (box insetBy: 1 @ 1)
				fillColor: Color transparent.
			^ ff].
	^ oldCursor! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'dgd 2/22/2003 19:03'!
deleteCurrentStamp: evt 
	"The trash is telling us to delete the currently selected stamp"

	(tool arguments second) == #stamp: 
		ifTrue: 
			[stampHolder remove: tool.
			self setAction: #paint: evt: evt]	"no use stamping with a blank stamp"! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'JMM 9/13/2004 09:47'!
eyedropper: aButton action: aSelector cursor: aCursor evt: evt 
	"Take total control and pick up a color!!!!"

	| pt feedbackColor delay |
	delay := Delay forMilliseconds: 10.
	aButton state: #on.
	tool ifNotNil: [tool state: #off].
	currentCursor := aCursor.
	evt hand showTemporaryCursor: currentCursor
		hotSpotOffset: 6 negated @ 4 negated.
	"<<<< the form was changed a bit??"
	feedbackColor := Display colorAt: Sensor cursorPoint.
	colorMemory align: colorMemory bounds topRight
		with: colorMemoryThin bounds topRight.
	self addMorphFront: colorMemory.

	"Full color picker"
	[Sensor anyButtonPressed] whileFalse: 
			[pt := Sensor cursorPoint.
			"deal with the fact that 32 bit displays may have garbage in the 
			alpha bits"
			feedbackColor := Display depth = 32 
						ifTrue: 
							[Color colorFromPixelValue: ((Display pixelValueAt: pt) bitOr: 4278190080)
								depth: 32]
						ifFalse: [Display colorAt: pt].
			"the hand needs to be drawn"
			evt hand position: pt.
			currentColor ~= feedbackColor ifTrue: [
				currentColor := feedbackColor.
				self showColor ].
			self world displayWorldSafely.
			delay wait].

	"Now wait for the button to be released."
	[Sensor anyButtonPressed] whileTrue:
		[ pt := Sensor cursorPoint.
		"the hand needs to be drawn"
		evt hand position: pt.
		self world displayWorldSafely.
		delay wait].

	evt hand showTemporaryCursor: nil hotSpotOffset: 0 @ 0.
	self currentColor: feedbackColor evt: evt.
	colorMemory delete.
	tool ifNotNil: 
			[tool state: #on.
			currentCursor := tool arguments third].
	aButton state: #off
! !

!PaintBoxMorph methodsFor: 'recent colors' stamp: 'ar 7/8/2006 20:33'!
fixUpColorPicker
	| chart picker |
	chart := ColorChart ifNil:[Cursor wait showWhile:[ColorChart := (ColorPickerMorph colorPaletteForDepth: 16 extent: 120@89)]].
	chart getCanvas frameRectangle: chart boundingBox color: Color black.
	picker := Form extent: (chart extent + (14@12)) depth: 16.
	picker fillWhite.
	"top"
	picker copy: (0@0 extent: picker width@6)
			from: (colorMemory image width - picker width)@0 
			in: colorMemory image rule: Form over.
	"bottom"
	picker copy: (0@ (picker height-6) extent: picker width@6) 
			from: (colorMemory image width - picker width)@(colorMemory image height - 7)
			in: colorMemory image rule: Form over.
	"left"
	picker copy: (0@6 corner: 8@(picker height - 6))
			from: (colorMemory image boundingBox topLeft + (0@6)) 
			in: colorMemory image rule: Form over.
	"right"
	picker copy: (picker width-6@6 corner: picker width@(picker height - 6))
			from: (colorMemory image boundingBox topRight - (6@-6)) 
			in: colorMemory image rule: Form over.
	chart displayOn: picker at: 8@6.
	picker getCanvas frameRectangle: picker boundingBox color: Color black.
	colorMemory image: picker.
! !

!PaintBoxMorph methodsFor: 'recent colors' stamp: 'dgd 2/21/2003 23:17'!
fixUpRecentColors
	| inner outer border box form newImage canvas morph |
	self fixUpColorPicker.
	recentColors := WriteStream on: Array new.
	form := image.
	newImage := Form extent: form extent + (0 @ 41) depth: form depth.
	form displayOn: newImage.
	newImage 
		copy: (0 @ (form height - 10) 
				extent: form width @ (newImage height - form height + 10))
		from: 0 @ (form height - (newImage height - form height + 10))
		in: form
		rule: Form over.
	canvas := newImage getCanvas.
	canvas 
		line: 12 @ (form height - 10)
		to: 92 @ (form height - 10)
		width: 1
		color: Color black.
	canvas := canvas copyOffset: 12 @ (form height - 9).
	inner := Color 
				r: 0.677
				g: 0.71
				b: 0.968.
	outer := inner darker darker.
	border := Color 
				r: 0.194
				g: 0.258
				b: 0.194.
	0 to: 1
		do: 
			[:y | 
			0 to: 3
				do: 
					[:x | 
					box := (x * 20) @ (y * 20) extent: 20 @ 20.
					morph := BorderedMorph new 
								bounds: ((box insetBy: 1) translateBy: canvas origin + bounds origin).
					morph
						borderWidth: 1;
						borderColor: border.
					morph color: Color white.
					morph 
						on: #mouseDown
						send: #mouseDownRecent:with:
						to: self.
					morph 
						on: #mouseMove
						send: #mouseStillDownRecent:with:
						to: self.
					morph 
						on: #mouseUp
						send: #mouseUpRecent:with:
						to: self.
					self addMorphFront: morph.
					recentColors nextPut: morph.
					canvas fillRectangle: box color: Color white.
					canvas frameRectangle: (box insetBy: 1) color: border.
					canvas frameRectangle: box color: inner.
					box := box insetBy: 1.
					canvas 
						line: box topRight
						to: box bottomRight
						width: 1
						color: outer.
					canvas 
						line: box bottomLeft
						to: box bottomRight
						width: 1
						color: outer]].
	recentColors := recentColors contents.
	(RecentColors isNil or: [RecentColors size ~= recentColors size]) 
		ifTrue: [RecentColors := recentColors collect: [:each | each color]]
		ifFalse: 
			[RecentColors 
				keysAndValuesDo: [:idx :aColor | (recentColors at: idx) color: aColor]].
	self image: newImage.
	self toggleStamps.
	self toggleStamps! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'dgd 2/22/2003 19:39'!
fixupButtons
	| changes answer newSelector |
	changes := Dictionary new.
	changes
		at: #brush:action:nib: put: #brush:action:nib:evt:;
		at: #tool:action:cursor: put: #tool:action:cursor:evt:;
		at: #pickup:action:cursor: put: #pickup:action:cursor:evt:;
		at: #keep:with: put: #keep:with:evt:;
		at: #undo:with: put: #undo:with:evt:;
		at: #scrollStamps:action: put: #scrollStamps:action:evt:;
		at: #toss:with: put: #toss:with:evt:;
		at: #eyedropper:action:cursor: put: #eyedropper:action:cursor:evt:;
		at: #clear:with: put: #clear:with:evt:.
	answer := WriteStream on: String new.
	self allMorphsDo: 
			[:each | 
			(each isKindOf: ThreePhaseButtonMorph) 
				ifTrue: 
					[answer nextPutAll: each actionSelector.
					(changes includesKey: each actionSelector) 
						ifTrue: 
							[each actionSelector: (newSelector := changes at: each actionSelector).
							answer nextPutAll: ' <-- ' , newSelector].
					answer cr]].
	^answer contents
	"StringHolder new
		contents: answer contents;
		openLabel: 'button fixups'"! !

!PaintBoxMorph methodsFor: 'other' stamp: 'ar 3/23/2000 14:18'!
focusMorph
	"Note: For backward compatibility we search the world for a SketchEditorMorph if the current focus morph is nil"
	^focusMorph ifNil:[focusMorph := self world findA: SketchEditorMorph]! !

!PaintBoxMorph methodsFor: 'other' stamp: 'ar 3/23/2000 14:20'!
focusMorph: newFocus
	"Set the new focus morph"
	focusMorph ifNotNil:[focusMorph paletteDetached: self]. "In case the morph is interested"
	focusMorph := newFocus.
	focusMorph ifNotNil:[focusMorph paletteAttached: self]. "In case the morph is interested"! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'tk 7/1/97 12:52'!
getColor
	^ currentColor! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'dgd 2/22/2003 19:03'!
getNib
	^currentBrush arguments third! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'tk 7/1/97 13:02'!
getSpecial
	^ action		"a selector like #paint:"! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'dgd 2/21/2003 23:17'!
grabFromScreen: evt 
	"Allow the user to grab a picture from the screen OUTSIDE THE PAINTING AREA and install it in a blank stamp.  To get a stamp in the painting area, click on the stamp tool in a blank stamp."

	"scroll to blank stamp"

	| stampButton form |
	stampButton := stampHolder stampButtons first.
	[(stampHolder stampFormFor: stampButton) isNil] 
		whileFalse: [stampHolder scroll: 1].
	form := Form fromUser.
	tool state: #off.
	tool := stampHolder otherButtonFor: stampButton.
	stampHolder stampForm: form for: tool.	"install it"
	stampButton state: #on.
	stampButton doButtonAction: evt.
	evt hand showTemporaryCursor: (focusMorph getCursorFor: evt)! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'sw 8/29/2000 15:31'!
indicateColorUnderMouse
	"Track the mouse with the special eyedropper cursor, and accept whatever color is under the mouse as the currently-chosen color; reflect that choice in the feedback box, and return that color."

	| pt feedbackColor |
	pt := Sensor cursorPoint.
	"deal with the fact that 32 bit displays may have garbage in the alpha bits"
	feedbackColor := Display depth = 32
		ifTrue: [ Color colorFromPixelValue: ((Display pixelValueAt: pt) bitOr: 16rFF000000) depth: 32] 		ifFalse: [Display colorAt: pt].

	self activeHand position: pt.
	self world displayWorldSafely.
	Display fill: colorPatch bounds fillColor: feedbackColor.
	^ feedbackColor	! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'dgd 2/22/2003 19:03'!
init3
	"Just a record of how we loaded in the latest paintbox button images"

	| bb rect lay pic16Bit aa blt on thin |
	self loadoffImage: 'etoy_default.gif'.
	self allMorphsDo: 
			[:button | 
			(button isKindOf: ThreePhaseButtonMorph) 
				ifTrue: [button offImage: nil]
				ifFalse: [button position: button position + (100 @ 0)]].
	(bb := self submorphNamed: #keep:) position: bb position + (100 @ 0).
	(bb := self submorphNamed: #toss:) position: bb position + (100 @ 0).
	(bb := self submorphNamed: #undo:) position: bb position + (100 @ 0).
	"Transparent is (Color r: 1.0 g: 0 b: 1.0)"
	self moveButtons.
	self loadOnImage: 'etoy_in.gif'.
	AllOnImage := nil.
	'save space'.
	self loadPressedImage: 'etoy_in.gif'.
	AllPressedImage := nil.
	'save space'.
	self loadCursors.

	"position the stamp buttons"
	stampHolder stampButtons owner last delete.
	stampHolder pickupButtons last delete.
	stampHolder stampButtons: (stampHolder stampButtons copyFrom: 1 to: 3).
	stampHolder pickupButtons: (stampHolder pickupButtons copyFrom: 1 to: 3).
	"| rect |"
	stampHolder pickupButtons do: 
			[:button | 
			"PopUpMenu notify: 'Rectangle for ',sel."

			rect := Rectangle fromUser.
			button bounds: rect	"image is nil"].
	"| rect lay |"
	stampHolder clear.
	stampHolder stampButtons do: 
			[:button | 
			button
				offImage: nil;
				pressedImage: nil.
			lay := button owner.
			"PopUpMenu notify: 'Rectangle for ',sel."
			rect := Rectangle fromUser.
			button image: (Form fromDisplay: (rect insetBy: 2)).
			lay borderWidth: 2.
			lay bounds: rect	"image is nil"].
	"| pic16Bit blt aa on |"
	pic16Bit := GIFReadWriter formFromFileNamed: 'etoy_in.gif'.	"really 8"
	aa := Form extent: OriginalBounds extent depth: 8.
	blt := BitBlt current toForm: aa.
	blt
		sourceForm: pic16Bit;
		combinationRule: Form over;
		sourceRect: OriginalBounds;
		destOrigin: 0 @ 0;
		copyBits.
	"Collect all the images for the buttons in the on state"
	stampHolder pickupButtons do: 
			[:button | 
			on := ColorForm extent: button extent depth: 8.
			on colors: pic16Bit colors.
			on 
				copy: (0 @ 0 extent: button extent)
				from: button topLeft - self topLeft
				in: aa
				rule: Form over.
			button
				image: on;
				pressedImage: on;
				offImage: nil].
	self invalidRect: bounds.
	((self submorphNamed: #erase:) arguments third) offset: 12 @ 35.
	((self submorphNamed: #eyedropper:) arguments third) offset: 0 @ 0.
	((self submorphNamed: #fill:) arguments third) offset: 10 @ 44.
	((self submorphNamed: #paint:) arguments third) offset: 3 @ 3.	"unused"
	((self submorphNamed: #rect:) arguments third) offset: 6 @ 17.
	((self submorphNamed: #ellipse:) arguments third) offset: 5 @ 4.
	((self submorphNamed: #polygon:) arguments third) offset: 5 @ 4.
	((self submorphNamed: #line:) arguments third) offset: 5 @ 17.
	((self submorphNamed: #star:) arguments third) offset: 2 @ 5.
	thumbnail delete.
	thumbnail := nil.
	(submorphs select: [:e | e class == RectangleMorph]) first 
		bounds: Rectangle fromUser.
	((submorphs select: [:e | e class == RectangleMorph]) first)
		borderWidth: 1;
		borderColor: Color black.
	"| thin |"
	submorphs do: [:ss | ss class == ImageMorph ifTrue: [thin := ss	"first"]].
	colorMemoryThin := thin! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'tk 8/22/2000 11:56'!
init4
	"Just a record of how Ted loaded in the paintbox button images, Feb 98"
| bb im pp newImage pic24Bit picNewBit blt |

"self loadoffImage: 'roundedPalette3.bmp'."
pic24Bit := GIFReadWriter formFromServerFile: 'updates/137roundedPalette3.bmp'.
picNewBit := Form extent: pic24Bit extent depth: 16.
pic24Bit displayOn: picNewBit.
OriginalBounds := picNewBit boundingBox.
AllOffImage := Form extent: OriginalBounds extent depth: 16.
blt := BitBlt current toForm: AllOffImage.
blt sourceForm: picNewBit; combinationRule: Form over;
		sourceRect: OriginalBounds; destOrigin: 0@0; copyBits.

AllOffImage mapColor: Color transparent to: Color black.
self image: AllOffImage.
self invalidRect: bounds.

self submorphsDo: [:button | button position: button position + (10@10)].
(im := submorphs at: 28) class == ImageMorph ifTrue: [
	im position: im position + (2@0)].	"color picker"
"exercise it once"

(bb := self submorphNamed: #keep:) position: bb position + (0@25).
(bb := self submorphNamed: #toss:) position: bb position + (0@25).
(bb := self submorphNamed: #undo:) position: bb position + (0@-25).
(bb := self submorphNamed: #clear:) position: bb position + (0@-25).
(bb := self submorphNamed: #undo:) position: bb position + (0@-69).
(bb := self submorphNamed: #clear:) position: bb position + (0@-69).
self submorphsDo: [:button | 
	button class == AlignmentMorph ifTrue: [
		button position: button position + (0@25)].
	(button printString includesSubString: 'stamp:') ifTrue: [
		button position: button position + (0@25)]].
(bb := self submorphNamed: #prevStamp:) position: bb position + (0@25).
(bb := self submorphNamed: #nextStamp:) position: bb position + (0@25).

bb := self submorphNamed: #keep:.
newImage := bb pressedImage copy: (0@4 corner: (bb pressedImage boundingBox extent)).
bb onImage: newImage.  bb pressedImage: newImage.  bb extent: newImage extent.
bb position: bb position + (4@1).

pp := (bb := self submorphNamed: #toss:) pressedImage.
newImage := pp copy: (0@4 corner: (bb pressedImage extent - (3@0))).
bb onImage: newImage.  bb pressedImage: newImage.  
bb extent: newImage extent.
bb position: bb position + (3@1).

pp := (bb := self submorphNamed: #undo:) pressedImage.
newImage := pp copy: (0@0 corner: (bb pressedImage extent - (3@5))).
bb onImage: newImage.  bb pressedImage: newImage.  
bb extent: newImage extent.
bb position: bb position + (3@-1).

pp := (bb := self submorphNamed: #clear:) pressedImage.
newImage := pp copy: (0@0 corner: (bb pressedImage extent - (0@5))).
bb onImage: newImage.  bb pressedImage: newImage.  
bb extent: newImage extent.
bb position: bb position + (3@-1).

pic24Bit := GIFReadWriter formFromServerFile: 'updates/137pencil.bmp'.
picNewBit := Form extent: pic24Bit extent depth: 16.
pic24Bit displayOn: picNewBit.
newImage := picNewBit as8BitColorForm.
newImage transparentColor: (Color r: 0 g: 0 b: 0).
(bb := self submorphNamed: #erase:) pressedImage: newImage; onImage: newImage;
	extent: newImage extent.

bb position: bb position + (-11@-1).
! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'tk 7/28/2000 23:26'!
initialize
	super initialize.
	colorMemory ifNotNil: [colorMemory on: #mouseDown send: #takeColorEvt:from: to: self].! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'RAA 8/16/2000 01:48'!
keep: keepButton with: keepSelector evt: evt
	"Showing of the corrent palette (viewer or noPalette) is done by the block submitted to the SketchMorphEditor, see (EToyHand makeNewDrawing) and (SketchMorph editDrawingInWorld:forBackground:)."
	| ss |
	owner ifNil: [^ self].
	keepButton ifNotNil: [keepButton state: #off].
	(ss := self focusMorph) 
		ifNotNil: [ss savePainting: self evt: evt]
		ifNil:
		[keepSelector == #silent ifTrue: [^ self].
		self notCurrentlyPainting].! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'jm 6/18/1999 18:58'!
loadColorChooser
	"Load Forms for ColorMemoryMorph."

	| doc closedForm openForm |
	doc := Utilities objectStrmFromUpdates: 'colorPalClosed.obj'.
	closedForm := doc fileInObjectAndCode mapColor: Color transparent to: Color black.
	doc := Utilities objectStrmFromUpdates: 'colorPalOpen.obj'.
	openForm := doc fileInObjectAndCode mapColor: Color transparent to: Color black.

	colorMemoryThin image: closedForm.
	colorMemoryThin position: self position + (0@140).

	colorMemory delete.	"delete old one"
	colorMemory := PaintBoxColorPicker new image: openForm.
! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'sw 5/23/2001 13:54'!
loadCursors
	"Display the form containing the cursors.  Transparent is (Color r: 1.0 g: 0 b: 1.0).  Grab the forms one at a time, and they are stored away.
	self loadCursors.	"

	| button transp cursor map |
	transp := Color r: 1.0 g: 0 b: 1.0.
	map := Color indexedColors copy.	"just in case"
	1 to: 256 do: [:ind | (map at: ind) = transp ifTrue: 
				[map at: ind put: Color transparent]].

	#(erase: eyedropper: fill: paint: rect: ellipse: polygon: line: star: ) do: [:sel |
		self inform: 'Rectangle for ',sel.
		cursor := ColorForm fromUser.
		cursor colors: map.	"share it"
		button := self submorphNamed: sel.
		button arguments at: 3 put: cursor].
! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'yo 1/13/2005 12:20'!
loadJapanesePaintBoxBitmaps
"
	PaintBoxMorph new loadJapanesePaintBoxBitmaps.
"

	| formTranslator form bb |
	self position: 0@0.
	formTranslator := NaturalLanguageFormTranslator localeID: (LocaleID isoString: 'ja').
	form := Form fromFileNamed: 'offPaletteJapanese(children).form'.

	#('keep:' 'undo:' 'clear:' 'toss:') with: #('KEEP' 'UNDO' 'CLEAR' 'TOSS') do: [:extName :label |
		bb := (self submorphs detect: [:e | e externalName = extName]) bounds.
		formTranslator name: label, '-off' form: (form copy: bb)
	].


	form := Form fromFileNamed: 'pressedPaletteJapanese(children).form'.
	#('keep:' 'undo:' 'clear:' 'toss:') with: #('KEEP' 'UNDO' 'CLEAR' 'TOSS') do: [:extName :label |
		bb := (self submorphs detect: [:e | e externalName = extName]) bounds.
		formTranslator name: label, '-pressed' form: (form copy: bb)
	].
! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'yo 11/4/2002 21:20'!
loadOffForm: pic16Bit 
	"Prototype loadOffForm: (Smalltalk imageImports at: #offPaletteJapanese)"

	| blt |
	OriginalBounds := pic16Bit boundingBox.
	AllOffImage := Form extent: OriginalBounds extent depth: 16.
	blt := BitBlt current toForm: AllOffImage.
	blt sourceForm: pic16Bit;
		 combinationRule: Form over;
		 sourceRect: OriginalBounds;
		 destOrigin: 0 @ 0;
		 copyBits.
	AllOffImage mapColor: Color blue to: Color transparent.
	self image: AllOffImage.
	AllOffImage := nil.
	self invalidRect: bounds
! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'ar 5/28/2000 12:10'!
loadOnImage: fileName
	"Read in and convert the image for the paintBox with the buttons
on.  A .bmp 24-bit image.  For each button, cut that chunk out and save it."
	"	self loadOnImage: 'NoSh:=on.bmp'.
		AllOnImage := nil.	'save space'.	"

	| pic16Bit blt aa on type |
	type := 'gif'.  "   gif or bmp  "
type = 'gif' ifTrue: [
	pic16Bit "really 8" := GIFReadWriter formFromFileNamed: fileName.
	pic16Bit display.
	aa := AllOnImage := Form extent: OriginalBounds extent depth: 8.
	blt := BitBlt current toForm: aa.
	blt sourceForm: pic16Bit; combinationRule: Form over;
		sourceRect: OriginalBounds; destOrigin: 0@0; copyBits.
	].
type = 'bmp' ifTrue: [
	pic16Bit := (Form fromBMPFileNamed: fileName) asFormOfDepth: 16.
	pic16Bit display.
	aa := AllOnImage := Form extent: OriginalBounds extent depth: 16.
	blt := BitBlt current toForm: aa.
	blt sourceForm: pic16Bit; combinationRule: Form over;
		sourceRect: OriginalBounds; destOrigin: 0@0; copyBits.
	aa mapColor: Color transparent to: Color black.
	].
	"Collect all the images for the buttons in the on state"
	self allMorphsDo: [:button |
		(button isKindOf: ThreePhaseButtonMorph) ifTrue: [
			type = 'gif' ifTrue: [on := ColorForm extent: button extent depth: 8.
					 on colors: pic16Bit colors]
				ifFalse: [on := Form extent: button extent depth: 16].
			on copy: (0@0 extent: button extent)
				from: (button topLeft - self topLeft) in: aa rule: Form over.
			button onImage: on]].
	self invalidRect: bounds.

	! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'yo 11/4/2002 21:20'!
loadPressedForm: pic16Bit 
	"Prototype loadPressedForm: (Smalltalk imageImports at: #pressedPaletteJapanese)"

	| blt on |
	AllPressedImage := AllPressedImage := Form extent: OriginalBounds extent depth: 16.
	blt := BitBlt current toForm: AllPressedImage.
	blt sourceForm: pic16Bit;
		 combinationRule: Form over;
		 sourceRect: OriginalBounds;
		 destOrigin: 0 @ 0;
		 copyBits.
	AllPressedImage mapColor: Color black to: Color transparent.
	self
		allMorphsDo: [:button | (button isKindOf: ThreePhaseButtonMorph)
				ifTrue: [on := Form extent: button extent depth: 16.
					on
						copy: (0 @ 0 extent: button extent)
						from: button topLeft - self topLeft
						in: AllPressedImage
						rule: Form over.
					button pressedImage: on]].
	AllPressedImage := nil.
	self invalidRect: bounds
! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'ar 5/28/2000 12:10'!
loadPressedImage: fileName
	"Read in and convert the image for the paintBox with the buttons
on.  A .bmp 24-bit image.  For each button, cut that chunk out and save it."
	"	self loadPressedImage: 'NoSh:=on.bmp'.
		AllPressedImage := nil.	'save space'.	"

	| pic16Bit blt aa on type |
	type := 'gif'.  "   gif or bmp  "
type = 'gif' ifTrue: [
	pic16Bit "really 8" := GIFReadWriter formFromFileNamed: fileName.
	pic16Bit display.
	aa := AllPressedImage := Form extent: OriginalBounds extent depth: 8.
	blt := BitBlt current toForm: aa.
	blt sourceForm: pic16Bit; combinationRule: Form over;
		sourceRect: OriginalBounds; destOrigin: 0@0; copyBits.
	].
type = 'bmp' ifTrue: [
	pic16Bit := (Form fromBMPFileNamed: fileName) asFormOfDepth: 16.
	pic16Bit display.
	aa := AllPressedImage := Form extent: OriginalBounds extent depth: 16.
	blt := BitBlt current toForm: aa.
	blt sourceForm: pic16Bit; combinationRule: Form over;
		sourceRect: OriginalBounds; destOrigin: 0@0; copyBits.
	aa mapColor: Color transparent to: Color black.
	].
	"Collect all the images for the buttons in the on state"
	self allMorphsDo: [:button |
		(button isKindOf: ThreePhaseButtonMorph) ifTrue: [
			type = 'gif' ifTrue: [on := ColorForm extent: button extent depth: 8.
					 on colors: pic16Bit colors]
				ifFalse: [on := Form extent: button extent depth: 16].
			on copy: (0@0 extent: button extent)
				from: (button topLeft - self topLeft) in: aa rule: Form over.
			button pressedImage: on]].
	self invalidRect: bounds.

	! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'md 11/14/2003 16:52'!
loadoffImage: fileName
	"Read in and convert the background image for the paintBox.  All
buttons off.  A .bmp 24-bit image."
	"	Prototype loadoffImage: 'roundedPalette3.bmp'	"

	| pic16Bit blt type getBounds |
	type := 'bmp'.  " gif or bmp  "
	getBounds := 'fromPic'.	"fromUser = draw out rect of paintbox on image"
		"fromOB = just read in new bits, keep same size and place as last time."
		"fromPic = picture is just the PaintBox, use its bounds"
type = 'gif' ifTrue: [
	pic16Bit "really 8" := GIFReadWriter formFromFileNamed: fileName.
	getBounds = 'fromUser' ifTrue: ["Just first time, collect the bounds"
			pic16Bit display.
			OriginalBounds := Rectangle fromUser].
	getBounds = 'fromPic' ifTrue: [OriginalBounds := pic16Bit boundingBox].
	].
		"Use OriginalBounds as it was last time"
type = 'bmp' ifTrue: [
	pic16Bit := (Form fromBMPFileNamed: fileName) asFormOfDepth: 16.
	getBounds = 'fromUser' ifTrue: ["Just first time, collect the bounds"
			pic16Bit display.
			OriginalBounds := Rectangle fromUser].
		"Use OriginalBounds as it was last time"
	(getBounds = 'fromPic') ifTrue: [OriginalBounds := pic16Bit boundingBox].
	AllOffImage := Form extent: OriginalBounds extent depth: 16.
	].

type = 'gif' ifTrue: [
	AllOffImage := ColorForm extent: OriginalBounds extent depth: 8.
	AllOffImage colors: pic16Bit colors].

	blt := BitBlt current toForm: AllOffImage.
	blt sourceForm: pic16Bit; combinationRule: Form over;
		sourceRect: OriginalBounds; destOrigin: 0@0; copyBits.

type = 'bmp' ifTrue: [AllOffImage mapColor: Color transparent to: Color black].
	self image: AllOffImage.
	self invalidRect: bounds.

	! !

!PaintBoxMorph methodsFor: 'other' stamp: 'tk 8/22/2000 11:57'!
maxBounds
	| rr |
	"fullBounds if all flop-out parts of the paintBox were showing."

	rr := bounds merge: colorMemory bounds.
	rr := rr merge: (self submorphNamed: 'stamps') bounds.
	rr := rr origin corner: rr corner + (0@ (self submorphNamed: 'shapes') height 
				+ 10 "what is showing of (self submorphNamed: #toggleShapes) height").
	^ rr! !

!PaintBoxMorph methodsFor: 'recent colors' stamp: 'ar 9/23/2000 19:54'!
mouseDownRecent: evt with: aMorph
	aMorph borderColor: Color white.
! !

!PaintBoxMorph methodsFor: 'recent colors' stamp: 'ar 9/23/2000 20:01'!
mouseStillDownRecent: evt with: aMorph
	(aMorph containsPoint: evt cursorPoint)
		ifTrue:[aMorph borderColor: Color white]
		ifFalse:[aMorph borderColor: (Color r: 0.194 g: 0.258 b: 0.194)]
! !

!PaintBoxMorph methodsFor: 'user interface' stamp: 'tk 7/2/97 08:10'!
mouseUpBalk: evt
	"A button I own got a mouseDown, but the user moved out before letting up.  Prevent this for the current tool.  Some tool must stay selected."

	tool state: #on.	"keep current one, even if user balked on it"
	currentBrush ifNotNil: [currentBrush state: #on].! !

!PaintBoxMorph methodsFor: 'recent colors' stamp: 'ar 9/23/2000 19:59'!
mouseUpRecent: evt with: aMorph
	aMorph borderColor: (Color r: 0.194 g: 0.258 b: 0.194).
	(aMorph containsPoint: evt cursorPoint) ifTrue:[
		self takeColor: aMorph color event: evt.
	].! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'sw 5/23/2001 13:54'!
moveButtons
	"Move buttons one at a time and let the user place them over the background.  Later can move them again by turning on AuthorModeOwner in ThreePhaseButtonMorph.
	self createButtons.	"

	| rect button |
	#(erase: eyedropper: fill: paint: rect: ellipse: polygon: line: star: "pickup: pickup: pickup: pickup:" "stamp: stamp: stamp: stamp:" undo: keep: toss: prevStamp: nextStamp:) do: [:sel |
			self inform: 'Rectangle for ',sel.
			rect := Rectangle fromUser.
			button := self submorphNamed: sel.
			button bounds: rect.	"image is nil"].
	#(brush1: brush2: brush3: brush4: brush5: brush6: ) doWithIndex: [:sel :ind |
			self inform: 'Rectangle for ',sel.
			rect := Rectangle fromUser.
			button := self submorphNamed: sel.
			button bounds: rect.	"image is nil"].
	"stamp:  Stamps are held in a ScrollingToolHolder.  Pickups and stamps and brushes are id-ed by the button == with item from a list."

	"
	"
! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'tk 8/22/97 15:57'!
noVeneer
	"For a palette with a background (off) image, clear that image.
But first, for each button, cut that chunk out and save it in the offImage
part."
	"	self noVeneer.
		AllOffImage := nil.	'save space.  irreversible'.	"

	| aa on |
	AllOffImage ifNil: [AllOffImage := image].
	aa := AllOffImage.
	"Collect all the images for the buttons in the on state"
	self allMorphsDo: [:button |
		(button isKindOf: ThreePhaseButtonMorph) ifTrue: [
			on := Form extent: button extent depth: 16.
			on copy: (0@0 extent: button extent)
				from: (button topLeft - self topLeft) in:
aa rule: Form over.
			button offImage: on]].
	self image: (Form extent: AllOffImage extent depth: 1).
	self invalidRect: bounds.


	! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'sw 5/3/1998 18:22'!
notCurrentlyPainting
	self inform: 'You are not currently painting'! !

!PaintBoxMorph methodsFor: 'initialization' stamp: 'RAA 8/16/2000 11:12'!
notifyWeakDependentsWith: arguments

	weakDependents ifNil: [^self].
	weakDependents do: [ :each |
		each ifNotNil: [
			each paintBoxChanged: arguments.
			each paintBoxChanged: {#changed. arguments second. true}.
		].
	].! !

!PaintBoxMorph methodsFor: 'other' stamp: 'tk 8/22/2000 23:48'!
offsetFromMaxBounds
	"location of normal PaintBox within maxBounds."

	^ self left - colorMemory left @ 0! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'dgd 2/22/2003 19:04'!
pickup: actionButton action: aSelector cursor: aCursor evt: evt 
	"Special version for pickup: and stamp:, because of these tests"

	| ss picker old map stamper |
	self 
		tool: actionButton
		action: aSelector
		cursor: aCursor
		evt: evt.
	aSelector == #stamp: 
		ifTrue: 
			[(stampHolder pickupButtons includes: actionButton) 
				ifTrue: 
					[stamper := stampHolder otherButtonFor: actionButton.
					^self 
						pickup: stamper
						action: #stamp:
						cursor: (stamper arguments third)
						evt: evt].
			(stampHolder stampFormFor: actionButton) ifNil: 
					["If not stamp there, go to pickup mode"

					picker := stampHolder otherButtonFor: actionButton.
					picker state: #on.
					^self 
						pickup: picker
						action: #pickup:
						cursor: (picker arguments third)
						evt: evt]
				ifNotNil: 
					[old := stampHolder stampFormFor: actionButton.
					currentCursor := ColorForm extent: old extent depth: 8.
					old displayOn: currentCursor.
					map := Color indexedColors copy.
					map at: 1 put: Color transparent.
					currentCursor colors: map.
					currentCursor offset: currentCursor extent // -2.
					"Emphisize the stamp button"
					actionButton owner borderColor: (Color 
								r: 0.65
								g: 0.599
								b: 0.8)	"layoutMorph"	"color: (Color r: 1.0 g: 0.645 b: 0.419);"]].
	aSelector == #pickup: 
		ifTrue: 
			[ss := self focusMorph.
			ss ifNotNil: [currentCursor := aCursor]
				ifNil: 
					[self notCurrentlyPainting.
					self setAction: #paint: evt: evt]]! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'tk 7/2/97 22:13'!
pickupForm: stampForm
	"Install the new picture in this stamp"

	| stampButton |
	stampHolder stampForm: stampForm for: tool.
	stampButton := action == #pickup: 
		ifTrue: [stampHolder otherButtonFor: tool]
		ifFalse: [tool].	"was a nil stampForm"
	stampButton state: #on.
	stampButton doButtonAction.! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'RAA 8/17/2000 14:59'!
pickupForm: stampForm evt: evt
	"Install the new picture in this stamp"

	| stampButton |
	stampHolder stampForm: stampForm for: tool.
	stampButton := action == #pickup: 
		ifTrue: [stampHolder otherButtonFor: tool]
		ifFalse: [tool].	"was a nil stampForm"
	stampButton state: #on.
	stampButton doButtonAction: evt.! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'RAA 8/16/2000 13:40'!
plainCursor
	"Return the cursor to use with this painting action/tool. Offset of the form must be set."

	^currentCursor
! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'ar 10/10/2000 16:38'!
plainCursor: aCursor event: anEvent
	"Set the cursor to use with this painting action/tool. Offset of the form must be set."

	currentCursor := aCursor.
	anEvent hand showTemporaryCursor: aCursor.
	self notifyWeakDependentsWith: {#currentCursor. anEvent. currentCursor}.! !

!PaintBoxMorph methodsFor: 'recent colors' stamp: 'dgd 2/21/2003 23:17'!
recentColor: aColor 
	"Remember the color as one of our recent colors"

	(recentColors anySatisfy: [:any | any color = aColor]) ifTrue: [^self].	"already remembered"
	recentColors size to: 2
		by: -1
		do: 
			[:i | 
			(recentColors at: i) color: (recentColors at: i - 1) color.
			RecentColors at: i put: (RecentColors at: i - 1)].
	(recentColors first) color: aColor.
	RecentColors at: 1 put: aColor! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'RAA 8/16/2000 13:30'!
ringColor
	"Choose a color that contrasts with my current color. If that color isn't redish, return red. Otherwise, return green"

	^self ringColorFor: currentColor
! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'RAA 8/16/2000 13:29'!
ringColorFor: aColor
	"Choose a color that contrasts with my current color. If that color isn't redish, return red. Otherwise, return green"

	aColor isTransparent ifTrue: [^ Color red].
	aColor red < 0.5 ifTrue: [^ Color red].
	aColor red > (aColor green + (aColor blue * 0.5))
		ifTrue: [^ Color green]
		ifFalse: [^ Color red].
! !

!PaintBoxMorph methodsFor: 'other' stamp: 'tk 7/17/97 16:26'!
rotationTabForm
	^ rotationTabForm! !

!PaintBoxMorph methodsFor: 'other' stamp: 'tk 7/17/97 16:26'!
scaleTabForm
	^ scaleTabForm! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'RAA 8/16/2000 01:44'!
scrollStamps: actionButton action: aSelector evt: evt
	"Move the stamps over"

	aSelector == #prevStamp:
		ifTrue: [stampHolder scroll: -1]
		ifFalse: [stampHolder scroll: 1].
	actionButton state: #off.
	action == #stamp: ifTrue: ["reselect the stamp and compute the cursor"
		self stampForm 
			ifNil: [self setAction: #paint: evt: evt]
			ifNotNil: [tool doButtonAction: evt]].
		! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'tk 8/22/2000 11:57'!
setAction: aSelector evt: evt
	"Find this button and turn it on.  Does not work for stamps or pickups"

	| button |
	button := self submorphNamed: aSelector.
 
	button ifNotNil: [
		button state: #on.
		button doButtonAction: evt].	"select it!!"! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'dgd 2/22/2003 19:04'!
showColor
	"Display the current color in all brushes, both on and off."

	| offIndex onIndex center |
	currentColor ifNil: [^self].
	"colorPatch color: currentColor.	May delete later"
	(brushes isNil or: [brushes first owner ~~ self]) 
		ifTrue: 
			[brushes := OrderedCollection new.
			#(#brush1: #brush2: #brush3: #brush4: #brush5: #brush6:) 
				do: [:sel | brushes addLast: (self submorphNamed: sel)]].
	center := (brushes sixth) offImage extent // 2.
	offIndex := (brushes sixth) offImage pixelValueAt: center.
	onIndex := (brushes sixth) onImage pixelValueAt: center.
	brushes do: 
			[:bb | 
			bb offImage colors at: offIndex + 1 put: currentColor.
			bb offImage clearColormapCache.
			bb onImage colors at: onIndex + 1 put: currentColor.
			bb onImage clearColormapCache.
			bb invalidRect: bb bounds].
	self invalidRect: (brushes first topLeft rect: brushes last bottomRight)! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'ar 12/19/2000 19:16'!
showColorPalette: evt

	| w box |
	self comeToFront.
	colorMemory align: colorMemory bounds topRight 
			with: colorMemoryThin bounds topRight.
	"make sure color memory fits or else align with left"
	w := self world.
	box := self bounds: colorMemory fullBounds in: w.
	box left < 0 ifTrue:[
		colorMemory align: colorMemory bounds topLeft
			with: colorMemoryThin bounds topLeft].
	self addMorphFront: colorMemory.! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'tk 8/22/2000 11:58'!
stampCursorBeCursorFor: anAction
	"User just chose a stamp.  Take that stamp picture and make it be the cursor for the tool named."
	"self stampCursorBeCursorFor: #star:.
	currentCursor offset: -9@-3.			Has side effect on the saved cursor."

	(self submorphNamed: anAction) arguments at: 3 put: currentCursor.
		"Already converted to 8 bits and in the right form"! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'di 5/6/1998 21:08'!
stampDeEmphasize
	"Turn off an emphasized stamp.  Was turned on in pickup:action:cursor:"

	tool owner class == AlignmentMorph ifTrue: [
		tool "actionButton" owner "layoutMorph" color: Color transparent; 
					borderColor: Color transparent].! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'tk 7/2/97 14:02'!
stampForm
	"Return the selected stamp"

	^ stampHolder stampFormFor: tool.
! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'tk 7/17/97 11:47'!
stampHolder

	^ stampHolder! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'tk 7/17/97 11:48'!
stampHolder: newOne

	stampHolder := newOne! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'ar 9/23/2000 20:00'!
takeColor: aColor event: evt
	"Accept the given color programmatically"
	currentColor := aColor.
	self notifyWeakDependentsWith: {#currentColor. evt. currentColor}.
	self showColor.
	self colorable ifFalse: [self setAction: #paint: evt: evt].	"User now thinking of painting"! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'ar 9/23/2000 20:39'!
takeColorEvt: evt from: colorPicker
	"Accept a new color from the colorMemory.  Programs use currentColor: instead.  Do not do this before the picker has a chance to set its own color!!"
	^self takeColor: colorPicker currentColor event: evt! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'tk 8/21/2000 16:06'!
toggleShapes
	| tab sh stamps |
	"The sub panel that has the shape tools on it.  Rect, line..."
	stamps := self submorphNamed: 'stamps'.
	tab := self submorphNamed: 'shapeTab'.
	(sh := self submorphNamed: 'shapes') visible
		ifTrue: [sh hide.  tab top: stamps bottom-1]
		ifFalse: [sh comeToFront.  sh top: stamps bottom-9.  
				sh show.  tab top: sh bottom - tab height + 10].
	self layoutChanged.
! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'tk 8/21/2000 15:57'!
toggleStamps
	| tab otherTab st shapes |
	"The sub panel that has the stamps in it.  For saving and moving parts of an image."
	shapes := self submorphNamed: 'shapes'.
	otherTab := self submorphNamed: 'shapeTab'.
	tab := self submorphNamed: 'stampTab'.
	(st := self submorphNamed: 'stamps') visible
		ifTrue: [st hide.  st bottom: self bottom.  tab top: self bottom-1.
				shapes top: self bottom-9.
				otherTab top: (shapes visible ifTrue: [shapes bottom - otherTab height + 10] 
									ifFalse: [self bottom-1])]
		ifFalse: [st top: self bottom-10.  st show.  tab top: st bottom-0.
				shapes top: st bottom-9.
				otherTab top: (shapes visible ifTrue: [shapes bottom - otherTab height + 10] 
									ifFalse: [st bottom-0])].
	self layoutChanged.! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'tk 7/1/97 12:09'!
tool
	^ tool! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'RAA 8/16/2000 12:38'!
tool: actionButton action: aSelector cursor: aCursor evt: evt
	"Set the current tool and action for the paintBox.  "

	tool ifNotNil: [
		tool == actionButton ifFalse: [
			tool state: #off.
			action == #stamp: ifTrue: [self stampDeEmphasize]]].
	tool := actionButton.		"A ThreePhaseButtonMorph"
	"tool state: #on.	already done"
	action := aSelector.		"paint:"
	currentCursor := aCursor.
	self notifyWeakDependentsWith: {#action. evt. action}.
	self notifyWeakDependentsWith: {#currentCursor. evt. currentCursor}.
! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'RAA 8/16/2000 01:45'!
toss: cancelButton with: cancelSelector evt: evt
	"Reject the painting.  Showing noPalette is done by the block submitted to the SketchEditorMorph"

	| focus |
	owner ifNil: ["it happens"  ^ self].
	(focus := self focusMorph) 
		ifNotNil: [focus cancelPainting: self evt: evt]
		ifNil:
			[self delete].
	cancelButton state: #off.
! !

!PaintBoxMorph methodsFor: 'actions' stamp: 'RAA 8/16/2000 11:15'!
undo: undoButton with: undoSelector evt: evt
	| ss |
	(ss := self focusMorph) 
		ifNotNil: [ss undoPainting: self evt: evt]
		ifNil: [self notCurrentlyPainting].
	undoButton state: #off.! !

!PaintBoxMorph methodsFor: 'copying' stamp: 'di 10/14/97 10:13'!
updateReferencesUsing: aDictionary
	"Fix up stampHolder which is a ScrollingToolHolder, which is not a Morph"

	super updateReferencesUsing: aDictionary.
	stampHolder updateReferencesUsing: aDictionary.
	colorMemory updateReferencesUsing: aDictionary.! !

ImageMorph subclass: #PaintInvokingMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!PaintInvokingMorph commentStamp: '<historical>' prior: 0!
When this is dropped inside some appropriate place, then painting is invoked for that place.!

!PaintInvokingMorph classSide methodsFor: 'scripting' stamp: 'sw 5/6/2000 02:28'!
authoringPrototype
	^ self new image: (ScriptingSystem formAtKey: 'Painting'); markAsPartsDonor; setBalloonText: 'drop this into any playfield or book page to make a new painting there'; yourself! !

!PaintInvokingMorph classSide methodsFor: 'parts bin' stamp: 'nk 8/23/2004 18:11'!
descriptionForPartsBin
	^ self partName:	'Paint'
		categories:		#('Basic' 'Graphics')
		documentation:	'Drop this icon to start painting a new object.'! !

!PaintInvokingMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/10/2003 13:16'!
initialize

	self registerInFlapsRegistry.! !

!PaintInvokingMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 10:09'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(PaintInvokingMorph	new	'Paint'	'Drop this into an area to start making a fresh painting there')
						forFlapNamed: 'PlugIn Supplies'.
						cl registerQuad: #(PaintInvokingMorph	new	'Paint'	'Drop this into an area to start making a fresh painting there')
						forFlapNamed: 'Widgets'.
						cl registerQuad: #(PaintInvokingMorph	new	'Paint'	'Drop this into an area to start making a fresh painting there')
						forFlapNamed: 'Scripting']! !

!PaintInvokingMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 12:38'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

!PaintInvokingMorph methodsFor: 'initialization' stamp: 'sw 7/16/1998 00:02'!
initialize
	super initialize.
	self image: (ScriptingSystem formAtKey: 'Painting')! !

!PaintInvokingMorph methodsFor: 'parts bin' stamp: 'sw 8/12/2001 17:19'!
initializeToStandAlone
	super initializeToStandAlone.
	self image: (ScriptingSystem formAtKey: 'Painting')! !

!PaintInvokingMorph methodsFor: 'dropping/grabbing' stamp: 'dgd 4/3/2006 14:19'!
justDroppedInto: aPasteUpMorph event: anEvent
	"This message is sent to a dropped morph after it has been dropped on--and been accepted by--a drop-sensitive morph"
	aPasteUpMorph isPartsBin ifFalse:[
		self removeHalo.
		self delete.
		^aPasteUpMorph makeNewDrawing: anEvent].
	^super justDroppedInto: aPasteUpMorph event: anEvent! !

!PaintInvokingMorph methodsFor: 'dropping/grabbing' stamp: 'ar 3/3/2001 20:40'!
wantsToBeDroppedInto: aMorph
	"Only into PasteUps that are not part bins"
	^aMorph isPlayfieldLike! !

ImageMorph subclass: #SoundMorph
	instanceVariableNames: 'sound'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SoundInterface'!

!SoundMorph commentStamp: '<historical>' prior: 0!
Note: as of December 2000, this does not work. SoundMorph>>buildImage requires the sound to implement #volumeEnvelopeScaledTo: and as yet, no one does.!

!SoundMorph methodsFor: 'as yet unclassified' stamp: 'jm 11/14/97 11:21'!
buildImage
	| scale env h imageColor |
	owner ifNil: [scale := 128@128]  "Default is 128 pix/second, 128 pix fullscale"
		ifNotNil: [scale := owner soundScale].
	env := sound volumeEnvelopeScaledTo: scale.
	self image: (ColorForm extent: env size @ env max).
	1 to: image width do:
		[:x | h := env at: x.
		image fillBlack: ((x-1)@(image height-h//2) extent: 1@h)].
	imageColor := #(black red orange green blue) atPin:
						(sound pitch / 110.0) rounded highBit.
	image colors: (Array with: Color transparent with: (Color perform: imageColor)).
! !

!SoundMorph methodsFor: 'initialization' stamp: 'jm 12/17/97 22:43'!
initialize

	super initialize.
	self sound: (FMSound pitch: 880.0 dur: 0.2 loudness: 0.8).
! !

!SoundMorph methodsFor: 'dropping/grabbing' stamp: 'ar 10/5/2000 20:05'!
justDroppedInto: aMorph event: anEvent
	| relPosition |
	relPosition := self position - aMorph innerBounds topLeft.
	relPosition := (relPosition x roundTo: 8) @ relPosition y.
	self position: aMorph innerBounds topLeft + relPosition.
	sound copy play.
	^super justDroppedInto: aMorph event: anEvent! !

!SoundMorph methodsFor: 'as yet unclassified' stamp: 'jm 11/14/97 11:08'!
reset
	sound reset! !

!SoundMorph methodsFor: 'as yet unclassified' stamp: 'jm 11/14/97 11:08'!
sound
	^ sound! !

!SoundMorph methodsFor: 'as yet unclassified' stamp: 'jm 11/14/97 11:08'!
sound: aSound
	sound := aSound copy.
	sound reset.
	self buildImage! !

Model subclass: #PreferencesPanel
	instanceVariableNames: 'searchString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Palettes'!

!PreferencesPanel commentStamp: '<historical>' prior: 0!
I represent the model of a Preferences window.!

!PreferencesPanel classSide methodsFor: 'cleanup' stamp: 'alain.plantec 6/10/2008 18:50'!
deleteAllPreferencesPanels
	"Called manually to clobber all existing preferences panels"
	"PreferencesPanel deleteAllPreferencesPanels"

	| aWindow |
	self allInstancesDo:
		[:aPanel |
			(aWindow := aPanel containingWindow) isMorph
				ifTrue:
					[aWindow delete]].
	UpdatingThreePhaseButtonMorph allInstancesDo: "clobber old stand-alone prefs buttons"
		[:m | (m actionSelector == #togglePreference:) ifTrue:
			[(m owner isAlignmentMorph) ifTrue:
				[m owner delete]]]! !

!PreferencesPanel classSide methodsFor: 'window color' stamp: 'sw 2/26/2002 14:41'!
windowColorSpecification
	"Answer a WindowColorSpec object that declares my preference"

	^ WindowColorSpec classSymbol: self name wording: 'Preferences Panel' brightColor: #(0.645 1.0 1.0)	pastelColor: #(0.886 1.0 1.0) helpMessage: 'A tool for expressing personal preferences for numerous options.'! !

!PreferencesPanel methodsFor: 'find' stamp: 'nk 4/28/2004 10:18'!
addHelpItemsTo: panelPage
	"Add the items appropriate the the ? page of the receiver"

	| aButton aTextMorph aMorph firstTextMorph |
	panelPage hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	firstTextMorph :=  TextMorph new contents: 'Search Preferences for:'.
	firstTextMorph beAllFont: ((TextStyle default fontOfSize: 13) emphasized: 1).
	panelPage addMorphBack: firstTextMorph lock.
	panelPage addTransparentSpacerOfSize: 0@10.

	aMorph := RectangleMorph new clipSubmorphs: true; beTransparent; borderWidth: 2; borderColor: Color black; extent: 250 @ 36.
	aMorph vResizing: #rigid; hResizing: #rigid.
	aTextMorph :=  PluggableTextMorph new
				on: self
				text: #searchString
				accept: #setSearchStringTo:
				readSelection: nil
				menu: nil.
"	aTextMorph hResizing: #rigid."
	aTextMorph borderWidth: 0.
	aTextMorph font: ((TextStyle default fontOfSize: 21) emphasized: 1); setTextColor: Color red.
	aMorph addMorphBack: aTextMorph.
	aTextMorph acceptOnCR: true.
	aTextMorph position: (aTextMorph position + (6@5)).
	aMorph clipLayoutCells: true.
	aTextMorph extent: 240 @ 25.
	panelPage addMorphBack: aMorph.
	aTextMorph setBalloonText: 'Type what you want to search for here, then hit the "Search" button, or else hit RETURN or ENTER'.
	aTextMorph setTextMorphToSelectAllOnMouseEnter.
	aTextMorph hideScrollBarsIndefinitely.
	panelPage addTransparentSpacerOfSize: 0@10.

	aButton := SimpleButtonMorph new target: self; color: Color transparent; actionSelector: #initiateSearch:; arguments: {aTextMorph}; label: 'Search'.
	panelPage addMorphBack: aButton.
	aButton setBalloonText: 'Type what you want to search for in the box above, then click here (or hit RETURN or ENTER) to start the search; results will appear in the "search results" category.'.

	panelPage addTransparentSpacerOfSize: 0@30.
	panelPage addMorphBack: (SimpleButtonMorph new color: Color transparent; label: 'Restore all Default Preference Settings'; target: Preferences; actionSelector: #chooseInitialSettings; setBalloonText: 'Click here to reset all the preferences to their standard default values.'; yourself).

	panelPage addTransparentSpacerOfSize: 0@14.
	panelPage addMorphBack: (SimpleButtonMorph new color: Color transparent; label: 
'Save Current Settings as my Personal Preferences'; 
		target: Preferences; actionSelector: #savePersonalPreferences; setBalloonText: 'Click here to save the current constellation of Preferences settings as your personal defaults; you can get them all reinstalled with a single gesture by clicking the "Restore my Personal Preferences".'; yourself).

	panelPage addTransparentSpacerOfSize: 0@14.
	panelPage addMorphBack: (SimpleButtonMorph new color: Color transparent; label: 'Restore my Personal Preferences'; target: Preferences; actionSelector: #restorePersonalPreferences; setBalloonText: 'Click here to reset all the preferences to their values in your Personal Preferences.'; yourself).

	panelPage addTransparentSpacerOfSize: 0@30.
	panelPage addMorphBack: (SimpleButtonMorph new color: Color transparent; label: 
'Save Current Settings to Disk'; 
		target: Preferences; actionSelector: #storePreferencesToDisk; setBalloonText: 'Click here to save the current constellation of Preferences settings to a file; you can get them all reinstalled with a single gesture by clicking "Restore Settings From Disk".'; yourself).

	panelPage addTransparentSpacerOfSize: 0@14.
	panelPage addMorphBack: (SimpleButtonMorph new color: Color transparent; label: 'Restore Settings from Disk'; target: Preferences; actionSelector: #restorePreferencesFromDisk; setBalloonText: 'Click here to load all the preferences from their saved values on disk.'; yourself).

	panelPage addTransparentSpacerOfSize: 0@30.

	panelPage addMorphBack: (SimpleButtonMorph new color: Color transparent; label: 'Inspect Parameters'; target: Preferences; actionSelector: #inspectParameters; setBalloonText: 'Click here to view all the values stored in the system Parameters dictionary'; yourself).

	panelPage addTransparentSpacerOfSize: 0@10.
	panelPage addMorphBack: (Preferences themeChoiceButtonOfColor: Color transparent font: TextStyle defaultFont).
	panelPage addTransparentSpacerOfSize: 0@10.
	panelPage addMorphBack: (SimpleButtonMorph new color: Color transparent; label: 'Help!!'; target: Preferences; actionSelector: #giveHelpWithPreferences; setBalloonText: 'Click here to get some hints on use of this Preferences Panel'; yourself).
	panelPage wrapCentering: #center.
! !

!PreferencesPanel methodsFor: 'initialization' stamp: 'sw 2/6/2001 02:13'!
addModelItemsToWindowMenu: aMenu
	"aMenu is being constructed to be presented to the user in response to the user's pressing on the menu widget in the title bar of a morphic SystemWindow.  Here, the model is given the opportunity to add any model-specific items to the menu, whose default target is the SystemWindow itself."

	true ifTrue: [^ self].  

	"The below are provisionally disenfranchised, because their function is now directly available in the ? category"
	aMenu addLine.
	aMenu add: 'find preference... (f)' target: self action: #findPreference:.
	aMenu add: 'inspect parameters' target: Preferences action: #inspectParameters! !

!PreferencesPanel methodsFor: 'initialization' stamp: 'FBS 2/24/2004 14:26'!
adjustProjectLocalEmphasisFor: aSymbol
	"Somewhere, the preference represented by aSymbol got changed from being one that is truly global to one that varies by project, or vice-versa.  Get my panel right -- this involves changing the emphasis on the item"

	| aWindow toFixUp allMorphs emphasis |
	(aWindow := self containingWindow) ifNil: [^ self].
	emphasis := (Preferences preferenceAt: aSymbol ifAbsent: [^ self]) localToProject
		ifTrue:	[TextEmphasis bold emphasisCode "bold for local-to-project"]
		ifFalse:	[TextEmphasis normal emphasisCode "normal for global"].
	allMorphs := IdentitySet new.
	aWindow allMorphsAndBookPagesInto: allMorphs.
	toFixUp := allMorphs select:
		[:m | (m isKindOf: StringMorph) and: [m contents = aSymbol]].
	toFixUp do:
		[:aStringMorph | aStringMorph emphasis: emphasis]

	! !

!PreferencesPanel methodsFor: 'find' stamp: 'marcus.denker 8/24/2008 21:43'!
findCategoryFromPreference: prefSymbol
	"Find all categories in which the preference occurs"

	| aMenu| 
	aMenu := MenuMorph new defaultTarget: self.
	(Preferences categoriesContainingPreference: prefSymbol) do:
		[:aCategory | aMenu add: aCategory target: self selector: #switchToCategoryNamed:event: argumentList: {aCategory. MorphicEvent basicNew}].
	aMenu popUpInWorld! !

!PreferencesPanel methodsFor: 'find' stamp: 'rbb 3/1/2005 11:07'!
findPreference: evt
	"Allow the user to submit a selector fragment; search for that among preference names; put up a list of qualifying preferences; if the user selects one of those, redirect the preferences panel to reveal the chosen preference"

	self findPreferencesMatching: (UIManager default request: 'Search for preferences containing:' initialAnswer: 'color')! !

!PreferencesPanel methodsFor: 'initialization' stamp: 'md 2/24/2006 16:04'!
findPreferencesMatching: incomingTextOrString
	"find all preferences matching incomingTextOrString"

	| result aList aPalette controlPage  |
	result := incomingTextOrString asString asLowercase.
	result := result asLowercase withBlanksTrimmed.
	result isEmptyOrNil ifTrue: [^ self].

	aList := Preferences allPreferenceObjects select:
		[:aPreference | 
			(aPreference name includesSubstring: result caseSensitive: false) or:
				[aPreference helpString includesSubstring: result caseSensitive: false]].
	aPalette := (self containingWindow ifNil: [^ self]) findDeeplyA: TabbedPalette.
	aPalette ifNil: [^ self].
	aPalette selectTabNamed:  'search results'.
	aPalette currentPage ifNil: [^ self].  "bkwd compat"
	controlPage := aPalette currentPage.
	controlPage removeAllMorphs.
	controlPage addMorph: (StringMorph contents: ('Preferences matching "', self searchString, '"') font: Preferences standardButtonFont).
	controlPage color: Color transparent.
	aList := aList asSortedCollection:
		[:a :b | a name < b name].
	aList do:
		[:aPreference | | button |
			button := aPreference representativeButtonWithColor:  Color transparent inPanel: self.
			button ifNotNil: [controlPage addMorphBack: button]].
	aPalette world startSteppingSubmorphsOf: aPalette! !

!PreferencesPanel methodsFor: 'find' stamp: 'sw 2/6/2001 02:01'!
findPreferencesMatchingSearchString
	"find all preferences matching incomingTextOrString"

	self findPreferencesMatching: self searchString! !

!PreferencesPanel methodsFor: 'find' stamp: 'sw 7/27/2001 16:39'!
initiateSearch: morphHoldingSearchString
	"Carry out the action of the Search button in the Preferences panel"

	searchString := morphHoldingSearchString text.
	self setSearchStringTo: self searchString.
	
	self findPreferencesMatchingSearchString! !

!PreferencesPanel methodsFor: 'find' stamp: 'sw 2/6/2001 02:06'!
keyStroke: anEvent
	"Handle a keystroke event in the panel; we map f (for find) into a switch to the ? category"

	(anEvent keyCharacter == $f) ifTrue:
		[^ self switchToCategoryNamed: #? event: nil]! !

!PreferencesPanel methodsFor: 'find' stamp: 'sw 7/27/2001 23:11'!
searchString
	"Answer the current searchString, initializing it if need be"

	 | win aMorph |
searchString isEmptyOrNil ifTrue: 
		[searchString := 'Type here, hit Search'.
		(win := self containingWindow) ifNotNil:
			[aMorph := win findDeepSubmorphThat:
					[:m | m isKindOf: PluggableTextMorph]
				ifAbsent: [^ searchString].
			aMorph setText: searchString.
			aMorph setTextMorphToSelectAllOnMouseEnter.
			aMorph selectAll]].
	^ searchString! !

!PreferencesPanel methodsFor: 'find' stamp: 'sw 2/6/2001 01:45'!
setSearchStringTo: aText
	"The user submitted aText as the search string; now search for it"

	searchString := aText asString.
	self findPreferencesMatching: searchString.
	^ true! !

!PreferencesPanel methodsFor: 'category switch' stamp: 'sw 2/18/2001 04:02'!
switchToCategoryNamed: aName event: anEvent
	"Switch the panel so that it looks at the category of the given name"

	| aPalette |
	aPalette := self containingWindow findDeeplyA: TabbedPalette.
	aPalette ifNil: [^ self].
	aPalette selectTabNamed: aName! !

PolygonMorph subclass: #BlobMorph
	instanceVariableNames: 'random velocity sneaky'
	classVariableNames: 'AllBlobs'
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!BlobMorph commentStamp: '<historical>' prior: 0!
The Blob was written by David N Smith.  It started out as a simple test of the CurveMorph and ended up as an oozing, pulsating, repulsive mess which will wander across your screen until killed.  Each instance has its own rate of oozing, so some are faster than others.  It's not good for anything.

Try:
	BlobMorph new openInWorld

15 Jan 2000 by Bob Arning, a change so that the blob tries to be a color like the color under itself.
16 Jan 2000 by David N Smith, added blob merging: if two blobs meet then one eats the other.
18 Jan 2000
 by Sean McGrath, smother color changes.
06 Feb 2000 by Stefan Matthias Aust, refactoring and support for duplication, dragging and translucent colors.!

!BlobMorph classSide methodsFor: 'instance remembering' stamp: 'sma 2/6/2000 18:36'!
delete: anInstance
	AllBlobs ifNotNil: [AllBlobs remove: anInstance ifAbsent: []]! !

!BlobMorph classSide methodsFor: 'parts bin' stamp: 'sw 8/2/2001 01:20'!
descriptionForPartsBin
	^ self partName:	'Blob'
		categories:		#('Demo')
		documentation:	'A patch of primordial slime'! !

!BlobMorph classSide methodsFor: 'instance creation' stamp: 'dns 1/16/2000 15:11'!
new

	^ self remember: super new
		! !

!BlobMorph classSide methodsFor: 'instance remembering' stamp: 'sma 2/6/2000 18:35'!
remember: anInstance
	AllBlobs isNil ifTrue: [AllBlobs := IdentitySet new].
	^ AllBlobs add: anInstance! !

!BlobMorph methodsFor: 'stepping' stamp: 'tk 7/4/2000 12:02'!
adjustColors
	"Bob Arning <arning@charm.net>"
	"Color mixing - Sean McGrath <sean@email.ces.ucsf.edu>"
	| nearbyColors center r degrees |
	center := bounds center.
	nearbyColors := vertices collect:
		[:each |
		degrees := (each - center) degrees.
		r := (each - center) r.
		Display colorAt: (Point r: r + 6 degrees: degrees) + center].
		self color: ((self color alphaMixed: 0.95 with: (Color
			r: (nearbyColors collect: [:each | each red]) average
			g: (nearbyColors collect: [:each | each green]) average
			b: (nearbyColors collect: [:each | each blue]) average))
				alpha: self color alpha).
        sneaky ifFalse: [self color: color negated]! !

!BlobMorph methodsFor: 'stepping' stamp: 'sma 3/24/2000 11:40'!
bounceOffWalls
	" Change sign of velocity when we hit a wall of the container "
	| ob sb |

	" If owned by a handmorph we're being dragged or something;
	  don't bounce since the boundaries are different than our real parent "
	owner isHandMorph ifTrue: [ ^ self ].

	" If we're entirely within the parents bounds, we don't bounce "
	ob := owner bounds.
	sb := self bounds.
	(ob containsRect: sb) ifTrue: [ ^ self ].

	" We're partly outside the parents bounds; better bounce or we disappear!! "
	sb top < ob top ifTrue: [ velocity := velocity x @ velocity y abs ].
	sb left < ob left ifTrue: [ velocity := velocity x abs @ velocity y ].
	sb bottom > ob bottom ifTrue: [ velocity := velocity x @ velocity y abs negated ].
	sb right > ob right ifTrue: [ velocity := velocity x abs negated @ velocity y ].
! !

!BlobMorph methodsFor: 'geometry testing' stamp: 'sma 2/12/2000 13:10'!
containsPoint: aPoint
	(self color alpha = 1.0 or: [Sensor blueButtonPressed])
		ifTrue: [^ super containsPoint: aPoint].
	^ false! !

!BlobMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:24'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ random next < 0.25
		ifTrue: [Color random]
		ifFalse: [Color random alpha: random next * 0.4 + 0.4]! !

!BlobMorph methodsFor: 'submorphs-add/remove' stamp: 'sma 2/6/2000 17:41'!
delete
	self class delete: self.
	super delete! !

!BlobMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:42'!
initialize
	"initialize the state of the receiver"
	random := Random new.
	sneaky := random next < 0.75.
	super initialize.
""
	self beSmoothCurve; initializeBlobShape; setVelocity! !

!BlobMorph methodsFor: 'initialization' stamp: 'sma 2/6/2000 18:22'!
initializeBlobShape

	self
		vertices: {59@40. 74@54. 79@74. 77@93. 57@97. 37@97. 22@83. 15@67. 22@50. 33@35. 47@33}
		color: self color
		borderWidth: 1
		borderColor: Color black! !

!BlobMorph methodsFor: 'debug and other' stamp: 'sma 2/12/2000 13:08'!
installModelIn: aWorld
	"Overwritten to not add handles to the receiver."! !

!BlobMorph methodsFor: 'stepping' stamp: 'dns 1/16/2000 16:29'!
limitRange: verts
	" limit radius to range 20-120; limit interpoint angle to surrounding angles with max of twice of average separation. "
	| cent new prevn nextn prevDeg nextDeg thisDeg dincr |

	cent := self bounds center.
	new := Array new: verts size.
	dincr := 360 // verts size.
	verts doWithIndex: [ :pt :n |

		"Find prev/next points, allowing for wrapping around "
		prevn := n-1 < 1 ifTrue: [new size] ifFalse: [n-1].
		nextn := n+1 > new size ifTrue: [1] ifFalse: [n+1].

		"Get prev/this/next point's angles "
		prevDeg := ((verts at: prevn)-cent) degrees.
		thisDeg := ((verts at: n)-cent) degrees.
		nextDeg := ((verts at: nextn)-cent) degrees.

		"Adjust if this is where angles wrap from 0 to 360"
		(thisDeg - prevDeg) abs > 180 ifTrue: [ prevDeg := prevDeg - 360 ].
		(thisDeg - nextDeg) abs > 180 ifTrue: [ nextDeg := nextDeg + 360 ].

		"Put adjusted point into new collection"
		new at: n put: cent +
			(self selfPolarPointRadius: ((((pt - cent) r) min: 80) max: 20)
				degrees: (((thisDeg min: nextDeg-5) max: prevDeg+5) min: dincr*2+prevDeg)) ].
	^ new
! !

!BlobMorph methodsFor: 'initialization' stamp: 'sma 2/6/2000 18:28'!
maximumVelocity
	^ 6.0! !

!BlobMorph methodsFor: 'stepping' stamp: 'ccn 8/28/2001 20:51'!
mergeBlobs
	"See if we need to merge by checking our bounds against all other Blob
	bounds, then all our vertices against any Blob with overlapping bounds.
	If we find a need to merge, then someone else does all the work."

	(AllBlobs isNil or: [AllBlobs size < 2]) 
		ifTrue: [^ self].
	AllBlobs
		do:
			[:aBlob |
			aBlob owner == self owner ifTrue:
				[(self bounds intersects: aBlob bounds) ifTrue:
					[vertices do:
						[:aPoint |
						(aBlob containsPoint: aPoint) ifTrue:
							[^ self mergeSelfWithBlob: aBlob atPoint: aPoint]]]]]
		without: self! !

!BlobMorph methodsFor: 'stepping' stamp: 'dns 1/17/2000 13:34'!
mergeSelfWithBlob: aBlob atPoint: aPoint
	" It has already been determined that we merge with aBlob; we do all the work here. "
	| v v2 c |

	c := self bounds center.

	" Merge the vertices by throwing them all together in one pot "
	v := vertices, aBlob vertices.

	" Sort the vertices by degrees to keep them in order "
	v := (v asSortedCollection: [ :a :b | (a-c) degrees < (b-c) degrees ]) asArray.

	" Now, pick half of the vertices so the count stays the same "
	v2 := Array new: v size // 2.
	1 to: v2 size do: [ :n |
		v2 at: n put: (v at: n+n) ].
	v := v2.

	" Average each contiguous pair to help minimize jaggies "
	2 to: v size do: [ :n |
		v at: n put: ((v at: n) + (v at: n-1)) / 2.0 ].

	" Remember the new vertices, set a new velocity, then delete the merged blob "
	vertices := v.
	self setVelocity.
	aBlob delete
! !

!BlobMorph methodsFor: 'stepping' stamp: 'dns 1/17/2000 13:36'!
oozeAFewPointsOf: verts
	" change some points at random to cause oozing across screen "
	| n v |

	(verts size sqrt max: 2) floor timesRepeat: [
		n := (verts size * random next) floor + 1.
		v := verts at: n.
		v := (v x + (random next * 2.0 - 1.0))  @ 
			(v y + (random next * 2.0 - 1.0)).
		verts at: n put: v + velocity ].

! !

!BlobMorph methodsFor: 'stepping' stamp: 'dns 1/14/2000 17:47'!
selfPolarPointRadius: rho degrees: theta
	" Same as Point>>#r:degrees: in Point class except that x and y are not truncated to integers "
	| radians x y |

	radians := theta asFloat degreesToRadians.
	x := rho asFloat * radians cos.
	y := rho asFloat * radians sin.
	^ Point x: x y: y! !

!BlobMorph methodsFor: 'geometry' stamp: 'tk 7/14/2001 11:06'!
setConstrainedPosition: aPoint hangOut: partiallyOutside
	"Deal with dragging the blob over another blob which results in spontaneous deletations."

	self owner ifNil: [^ self].
	super setConstrainedPosition: aPoint hangOut: false.
		"note that we keep them from overlapping"! !

!BlobMorph methodsFor: 'initialization' stamp: 'sma 2/6/2000 18:28'!
setVelocity

	velocity :=
		((random next - 0.5) * self maximumVelocity) @ 
		((random next - 0.5) * self maximumVelocity)! !

!BlobMorph methodsFor: 'stepping and presenter' stamp: 'sma 2/12/2000 13:09'!
step
	| verts |
	self comeToFront.
	self mergeBlobs.
	verts := vertices copy.

	" change two points at random to cause oozing across screen "
	self oozeAFewPointsOf: verts.

	" limit radius and interpoint angle "
	verts := self limitRange: verts.

	" Set new vertices; bounce off a wall if necessary "
	self setVertices: verts.
	self bounceOffWalls.
	self adjustColors
! !

!BlobMorph methodsFor: 'testing' stamp: 'sma 2/6/2000 18:41'!
stepTime
	"Answer the desired time between steps in milliseconds."

	^ 125! !

!BlobMorph methodsFor: 'copying' stamp: 'sma 2/6/2000 18:07'!
veryDeepCopy
	^ self class remember: super veryDeepCopy! !

PolygonMorph subclass: #EnvelopeLineMorph
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SoundInterface'!

!EnvelopeLineMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:27'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color transparent! !

!EnvelopeLineMorph methodsFor: 'editing' stamp: 'ar 3/17/2001 14:38'!
dragVertex: ix event: evt fromHandle: handle
	| p |
	super dragVertex: ix event: evt fromHandle: handle.
	p := owner acceptGraphPoint: evt cursorPoint at: ix.
	self verticesAt: ix put: p.
! !

!EnvelopeLineMorph methodsFor: 'editing' stamp: 'ar 3/17/2001 14:31'!
dropVertex: ix event: evt fromHandle: handle
	| oldVerts |
	oldVerts := vertices.
	super dropVertex: ix event: evt fromHandle: handle.
	vertices = oldVerts ifFalse: [owner deletePoint: ix "deleted a vertex"]! !

!EnvelopeLineMorph methodsFor: 'editing' stamp: 'ar 3/17/2001 14:39'!
newVertex: ix event: evt fromHandle: handle
	"Install a new vertex if there is room."
	(owner insertPointAfter: ix) ifFalse: [^ self "not enough room"].
	super newVertex: ix event: evt fromHandle: handle.
	self verticesAt: ix+1 put: (owner acceptGraphPoint: evt cursorPoint at: ix+1).
! !

!EnvelopeLineMorph methodsFor: 'as yet unclassified' stamp: 'dgd 2/14/2003 20:17'!
vertices: verts borderWidth: bw borderColor: bc 
	super initialize.
	vertices := verts.
	
	borderWidth := bw.
	borderColor := bc.
	closed := false.
	arrows := #none.
	self computeBounds! !

!PolygonMorph class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/11/2003 10:03'!
initialize

	self registerInFlapsRegistry.	! !

!PolygonMorph class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/11/2003 10:10'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(PolygonMorph	authoringPrototype		'Polygon'	'A straight-sided figure with any number of sides')
						forFlapNamed: 'PlugIn Supplies'.
						cl registerQuad: #(PolygonMorph	authoringPrototype		'Polygon'	'A straight-sided figure with any number of sides')
						forFlapNamed: 'Supplies'.]! !

!PolygonMorph class methodsFor: '*MorphicExtras-instance creation' stamp: 'nk 8/23/2004 18:12'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'Arrow'
		categoryList: #('Basic' 'Graphics')
		documentation: 'A line with an arrowhead.  Shift-click to get handles and move the ends.'
		globalReceiverSymbol: #PolygonMorph
		nativitySelector: #arrowPrototype}
! !

!PolygonMorph class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/11/2003 12:38'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

!PolygonMorph methodsFor: '*MorphicExtras-*morphic-Postscript Canvases' stamp: 'ar 11/26/2001 23:15'!
drawPostscriptOn: aCanvas 
	"Display the receiver, a spline curve, approximated by straight 
	line segments."
	| array |
	vertices size < 1
		ifTrue: [self error: 'a polygon must have at least one point'].
	array := self drawArrowsOn: aCanvas.
	closed
		ifTrue: [aCanvas
				drawPolygon: self getVertices
				color: self color
				borderWidth: self borderWidth
				borderColor: self borderColor]
		ifFalse: [self drawClippedBorderOn: aCanvas usingEnds: array].
! !

!PolygonMorph methodsFor: '*MorphicExtras-geometry eToy' stamp: 'nk 9/4/2004 11:57'!
scale: scaleFactor 
	| flex center ratio |
	ratio := self scaleFactor / scaleFactor.
	self borderWidth: ((self borderWidth / ratio) rounded max: 0).
	center := self referencePosition.
	flex := (MorphicTransform offset: center negated)
				withScale: ratio.
	self
		setVertices: (vertices
				collect: [:v | (flex transform: v)
						- flex offset]).
	super scale: scaleFactor.! !

PolygonMorph subclass: #StarMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!StarMorph commentStamp: 'wiz 9/6/2005 12:30' prior: 0!
I am a very flexible star..

Grab me from the supplies flap or from the graphic objects.
Add my handles and you can move and resize me.
The up and down arrows increase or reduce the number of my sides.
The right and left arrows cycle thru different amounts of  pointiness.


Use the arrows right and left of my center or get stars with a specific amount of pointyness.  The left side goes from fat to thin and then cycles around again. The right goes from thin to fat. Hold down the shift key if you wish to stop the cycling at the extremes.

Use the arrows up and down to change the number of sides if you would like a different number of points.

To add or remove just one side hold the shift key down as you use the arrows or use the menu items for that purpose.


If you add or remove just one point I will have an odd number of sides.  When that happens I can only look like a regular polygon. The right and left arrows will have no effect.  Add or remove just one more side and you can shift drag the outer handle or use the arrows to restore my pointiness. 

That was too complicated. It is gone. You can get regular polygon shapes by adjusting my pointiness. For example the extreme of a five pointed star is a dodecahedron (10 sided regular polygon) and one step less extreme is a pentagon (5 sided regular polygon).


At some time you will probably shift drag the outer handle thru the center handle.
While I looked round as you shrunk me, I will look very much like an asterisk as you pull me away.  What happens is that inside bend shrunk on the way down because it can never be larger than the outer point (or it wouldn't be the innerbend would it).
But on the way out it is perfectly happy to remain small. So I look like an asterisk.

To fatten me up  (if you haven't already figured this out by fooling around)  hold the shift down an move the outer handle towards the center (but not quite all the way) then let the shift up and move the outer handle away.  A couple of cycles like this and I'll be looking fat and jolly again. Or you can now just use the right arrow to make me fatter.

This is also the reason I don't let the inside bend get larger than the outer point.
If I did the same process that fattened me when I was an asterisk would also grow an asterisk so large squeak would complain about not having enough memory.

Historical note:

The former star had two bugs that are fixed here.
The outer handle now no longer jumps from one point to another.
The other bug prevented some higher order stars from looking right. 
Which is why the former star didn't allow you to change the number of points. !

!StarMorph classSide methodsFor: 'parts bin' stamp: 'sw 8/2/2001 16:22'!
descriptionForPartsBin
	^ self partName:	'Star'
		categories:		#('Graphics')
		documentation:	'A symmetrical polygon in the shape of a star'! !

!StarMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 11:37'!
initialize

	self registerInFlapsRegistry.	! !

!StarMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 11:39'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(StarMorph		authoringPrototype	'Star'	'A star')
						forFlapNamed: 'PlugIn Supplies'.
						cl registerQuad: #(StarMorph	authoringPrototype	'Star'	'A star')
						forFlapNamed: 'Supplies'.]! !

!StarMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 12:41'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

!StarMorph methodsFor: 'menu' stamp: 'wiz 9/5/2005 23:08'!
addChangeSidesMenuItems: aCustomMenu hand: aHandMorph 
	"Menu items to change number of sides."
	aCustomMenu addLine.
	aCustomMenu add: 'more sides' translated action: #moreVertices.
	aCustomMenu add: 'fewer sides' translated action: #lessVertices.
"	Regular polygons can be simulated with the one of the skip stars 
	and it would confuse users to have stars be limited to Regular polygons.
	So we've removed those menu items - wiz"
"	aCustomMenu add: 'one more side' translated action: #oneMoreVertex.
	aCustomMenu add: 'one fewer side' translated action: #oneLessVertex"! !

!StarMorph methodsFor: 'menu' stamp: 'wiz 1/11/2005 14:55'!
addCustomMenuItems: aCustomMenu hand: aHandMorph 
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
self addChangeSidesMenuItems: aCustomMenu hand: aHandMorph.
self addTwinkleMenuItems: aCustomMenu hand: aHandMorph.
	! !

!StarMorph methodsFor: 'editing' stamp: 'wiz 12/15/2004 00:59'!
addHandles
	self addStarHandles! !

!StarMorph methodsFor: 'editing' stamp: 'wiz 1/15/2005 00:20'!
addStarHandles
	"Outer handle must not be blocked so it comes first. 
	The editing routine expects to find the center handle second.
	The side and shape changing handles follow these."
	| center |
	self removeHandles.
	"Check for old stars and correct order of vertices."
	self insureCompatability .
	handles := OrderedCollection new.
	center := vertices average rounded.
	self withCenterOuterHandles; withUpDownLeftRightHandlesAround: 6 center: center.
	self placeHandles.
	self changed.
	! !

!StarMorph methodsFor: 'menu' stamp: 'wiz 1/11/2005 20:38'!
addTwinkleMenuItems: aCustomMenu hand: aHandMorph 
	"Menu items to change the sharpness of the star."
	aCustomMenu addLine.
	aCustomMenu add: 'twinkle fatter' translated action: #nextTwinkle.
	aCustomMenu add: 'twinkle thinner' translated action: #prevTwinkle.
"	aCustomMenu add: 'fatter star' translated action: #nextFatter.
	aCustomMenu add: 'thinner star' translated action: #prevThinner"
	
	


! !

!StarMorph methodsFor: 'editing' stamp: 'wiz 9/5/2005 23:12'!
changeVertices: label event: evt fromHandle: handle 
	| |
	label == #more
		ifTrue: [evt shiftPressed
				ifTrue: [self moreVertices "not oneMoreVertex"]
				ifFalse: [self moreVertices]].
	label == #less
		ifTrue: [evt shiftPressed
				ifTrue: [self lessVertices "not oneLessVertex"]
				ifFalse: [self lessVertices]].
	label == #next
		ifTrue: [evt shiftPressed
				ifTrue: [self makeVertices: vertices size starRatio: self nextSkip]
				ifFalse: [self makeVertices: vertices size starRatio: self nextTwinkleSkip]].
	label == #prev
		ifTrue: [evt shiftPressed
				ifTrue: [self makeVertices: vertices size starRatio: self prevSkip]
				ifFalse: [self makeVertices: vertices size starRatio: self prevTwinkleSkip]].
	self computeBounds! !

!StarMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:35'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color black! !

!StarMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:40'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!StarMorph methodsFor: 'initialization' stamp: 'wiz 1/11/2005 14:33'!
defaultCenter
	"answer the default center for the receiver"
	^ 0 asPoint! !

!StarMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:31'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color lightBlue! !

!StarMorph methodsFor: 'initialization' stamp: 'wiz 1/11/2005 14:33'!
defaultFirstVertex
	"answer the default first outer point for the receiver.
	This with the center determines the angle and size of the outer radius."
	^ 10 asPoint! !

!StarMorph methodsFor: 'initialization' stamp: 'wiz 1/11/2005 14:28'!
defaultSides
	"answer the default number of sides for the receiver"
	^ 10! !

!StarMorph methodsFor: 'initialization' stamp: 'wiz 1/11/2005 14:29'!
defaultStarRatio
	"answer the default ratio of outer radius to inner radius for the receiver"
	^ 5.0 / 12.0! !

!StarMorph methodsFor: 'editing' stamp: 'wiz 1/20/2005 19:07'!
dragVertex: label event: evt fromHandle: handle 
	| center r1 rN rNext a1 rTotal |
	label == #outside
		ifTrue: [center := handles second center.
			r1 := center dist: vertices first.
			"Rounding and what happens as the outer handle
			approached the center, 
			requires we guard the inner radius 
			from becoming larger than the outer radius."
			rN := r1
						min: (center dist: vertices last).
			rNext := 1
						max: (center dist: evt cursorPoint).
			a1 := 270.0
						+ (center bearingToPoint: evt cursorPoint).
			rTotal := vertices size even
						ifTrue: [evt shiftPressed
								ifTrue: [rNext + rNext min: rNext + rN]
								ifFalse: [r1 + rN * rNext / r1]]
						ifFalse: [rNext + rNext].
			rNext := rTotal - rNext.
			vertices := ((a1 to: a1 + 359.999 by: 360.0 / vertices size)
						collect: [:angle | center
								+ (Point r: (rNext := rTotal - rNext) degrees: angle)]) .
			handle align: handle center with: evt cursorPoint].
	label == #center
		ifTrue: [evt shiftPressed
				ifTrue: [self updateFormFromUser]
				ifFalse: [self position: self position + (evt cursorPoint - handle center)]].
	self computeBounds! !

!StarMorph methodsFor: 'initialization' stamp: 'wiz 1/11/2005 14:36'!
initialize
	"initialize the state of the receiver"
	super initialize.
	self
		makeVertices: self defaultSides
		starRatio: self defaultStarRatio
		withCenter: self defaultCenter
		withPoint: self defaultFirstVertex.
	self computeBounds! !

!StarMorph methodsFor: 'parts bin' stamp: 'sw 7/2/2001 11:07'!
initializeToStandAlone
	^ self initialize removeHandles! !

!StarMorph methodsFor: 'initialization' stamp: 'wiz 1/9/2005 20:15'!
insureCompatability
"The old stars had the point on the second not the first vertex. So we need to check for this special case."
 | c v1 v2 |
c := vertices average rounded.
 v1 := vertices first .
 v2 := vertices second .
(c dist: v1) + 0.001 < (c dist: v2) ifTrue: [vertices := vertices allButFirst copyWith: v1]

! !

!StarMorph methodsFor: 'menus' stamp: 'wiz 12/12/2004 16:43'!
lessVertices
"Reduce the number of points by one until we are  a diamond. If odd reduce the number of sides by two until we become a triangle. See class comment."
	| nVerts |
	( nVerts := 2 negated + vertices size) < 3 ifFalse: [
	self
		makeVertices: nVerts]! !

!StarMorph methodsFor: 'initialization' stamp: 'wiz 12/30/2004 02:57'!
makeVertices: nSides 
	"Assuming vertices has at least one point, make a new star 
	or regular polygon (for odd sided polygons).
	The center of the polygon and the first vertex remain in
	place. The inner distances for stars remain the same also if
	possible."
	| center r1 rN rNext a1 rTotal |
	center := vertices average rounded.
	r1 := center dist: vertices first.
	rN := center dist: vertices last.
	rNext := 1 max: r1.
	a1 := 270.0
				+ (center bearingToPoint: vertices first).
	rTotal := nSides even
				ifTrue: [rNext + rNext min: rNext + rN]
				ifFalse: [rNext + rNext].
	rNext := rTotal - rNext.
	self changed .
	vertices := (a1 to: a1 + 359.999 by: 360.0 / nSides)
				collect: [:angle | center
						+ (Point r: (rNext := rTotal - rNext) degrees: angle)].
	self computeBounds.
	self changed! !

!StarMorph methodsFor: 'initialization' stamp: 'wiz 1/4/2005 19:31'!
makeVertices: nSides starRatio: fraction
	"Assuming vertices has at least one point, make a new star 
	or regular polygon (for odd sided polygons).
	The center of the polygon and the first vertex remain in
	place. The inner distances for stars remain the same also if
	possible."
	| center r1 rN rNext a1 rTotal |
	center := vertices average rounded.
	r1 := center dist: vertices first.
	rNext := 1 max: r1.
	rN := (1.0 min: fraction) * rNext.
	a1 := 270.0
				+ (center bearingToPoint: vertices first).
	rTotal := nSides even
				ifTrue: [rNext + rNext min: rNext + rN]
				ifFalse: [rNext + rNext].
	rNext := rTotal - rNext.
	self changed .
	vertices := (a1 to: a1 + 359.999 by: 360.0 / nSides)
				collect: [:angle | center
						+ (Point r: (rNext := rTotal - rNext) degrees: angle)].
	self computeBounds.
	self changed! !

!StarMorph methodsFor: 'initialization' stamp: 'wiz 1/11/2005 21:36'!
makeVertices: nSides starRatio: fraction withCenter: center withPoint: aPoint 
	"Make a new star or regular polygon (for odd sided polygons).
	This makes star vertices from scratch without any feedback from existing vertices."
	| r1 rN rNext a1 rTotal |
	r1 := center dist: aPoint.
	rNext := 1 max: r1.
	rN := (1.0 min: fraction)
				* rNext.
	a1 := 270.0
				+ (center bearingToPoint: aPoint).
	rTotal := nSides even
				ifTrue: [rNext + rNext min: rNext + rN]
				ifFalse: [rNext + rNext].
	rNext := rTotal - rNext.
	self changed.
	vertices := (a1 to: a1 + 359.999 by: 360.0 / nSides)
				collect: [:angle | center
						+ (Point r: (rNext := rTotal - rNext) degrees: angle)].
	self computeBounds.
	self changed! !

!StarMorph methodsFor: 'menus' stamp: 'wiz 12/11/2004 16:45'!
moreVertices
	self makeVertices: 2+ vertices size! !

!StarMorph methodsFor: 'geometry' stamp: 'wiz 1/19/2005 22:34'!
nextSkip
	"Set starRatio to next skip wrapping if needed."
	| skips n c r1 rN |
	c := vertices average rounded.
	r1 := (c dist: vertices first) truncated asFloat.
	rN := c dist: vertices last.
	skips := self skipRatios.
	n := skips * r1
				findFirst: [:r | r > (rN + 1.0)].
	"n = 0
		ifTrue: [n := skips size]."
	^ skips atWrap: n! !

!StarMorph methodsFor: 'menus' stamp: 'wiz 1/11/2005 20:37'!
nextTwinkle
	self makeVertices: vertices size starRatio: self nextTwinkleSkip .
	self computeBounds.! !

!StarMorph methodsFor: 'geometry' stamp: 'wiz 1/19/2005 22:42'!
nextTwinkleSkip
	"Set starRatio to next skip wrapping if needed."
	| skips n c r1 rN |
	c := vertices average rounded.
	r1 := (c dist: vertices first) truncated asFloat.
	rN := c dist: vertices last.
	skips := self skipRatios.
	n := skips * r1
				findFirst: [:r | r > (rN + 1.0)].
	n = 0
		ifTrue: [ n := 1].
	^ skips atWrap: n! !

!StarMorph methodsFor: 'menu' stamp: 'wiz 12/11/2004 16:45'!
oneLessVertex
	self
		makeVertices: (3 max: 1 negated + vertices size)! !

!StarMorph methodsFor: 'menu' stamp: 'wiz 12/11/2004 16:46'!
oneMoreVertex
	self makeVertices: 1 + vertices size! !

!StarMorph methodsFor: 'editing' stamp: 'wiz 1/15/2005 00:19'!
placeHandles
	"Add the handles to my submorphs."
	handles reverseDo: [:each | self addMorphFront: each ] .
	
	! !

!StarMorph methodsFor: 'geometry' stamp: 'wiz 1/19/2005 22:41'!
prevSkip
	"Set starRatio to next skip wrapping if necessary"
	| skips n c r1 rN |
	c := vertices average rounded.
	r1 := c dist: vertices first.
	rN := (c dist: vertices last) truncated asFloat.
	skips := self skipRatios.
	n := skips * r1
				findLast: [:r | r + 1.0 < rN].
	n = 0
		ifTrue: [n := 1].
	^ skips at: n! !

!StarMorph methodsFor: 'menus' stamp: 'wiz 1/11/2005 20:37'!
prevTwinkle
	self makeVertices: vertices size starRatio: self prevTwinkleSkip .
	self computeBounds.! !

!StarMorph methodsFor: 'geometry' stamp: 'wiz 1/19/2005 22:19'!
prevTwinkleSkip
	"Set starRatio to next skip wrapping if necessary"
	| skips n c r1 rN |
	c := vertices average rounded.
	r1 := c dist: vertices first.
	rN := (c dist: vertices last) truncated asFloat.
	skips := self skipRatios.
	n := skips * r1
				findLast: [:r | r + 1.0 < rN].
	"n = 0
	ifTrue: [^ oldR]."
	^ skips atWrap: n! !

!StarMorph methodsFor: 'access' stamp: 'wiz 1/11/2005 03:58'!
skipRatios
"Return an array of  ratios  of the inner radius to the outer radius.
Ratios are in ascending order from 0.0 to 1.0."
"Assume we have at least one vertex.
All ways return a number <= 1.0"

| n  alpha  |
"Odd vertices sizes can not be stars only regular polygons"
n:= vertices size . n odd ifTrue: [ ^ #(  1.0) ] .

alpha := Float pi / (n//2)  asFloat .

^ ((((    Float halfPi -alpha  to: alpha /2.0  by: alpha  negated ) 
	collect:  [:angle |( (angle) sin )/
					(angle + alpha ) sin ]
	) copyWith: 0.0) copyWithFirst: 1.0) reversed .! !

!StarMorph methodsFor: 'access' stamp: 'wiz 1/4/2005 20:14'!
starRatio
"Return the ratio of the inner radius to the outer radius."
"Assume we have at least one vertex.
All ways return a number <= 1.0"
| r c |
c := vertices average rounded .
r := (c dist: vertices last) / (c dist:  vertices first)  .
^ r > 1.0  ifTrue: [  r reciprocal ] ifFalse: [r ] .! !

!StarMorph methodsFor: 'accessing' stamp: 'wiz 1/4/2005 19:47'!
starRatio: r
"Set the star s.t. the ratio of the inner radius to the outer radius is r.
If r is > 1 use the reciprocal to keep the outer radius first."
"Assume we have at least one vertex.
set
All ways return a number <= 1.0"
self makeVertices: vertices size starRatio:( r > 1.0  ifTrue: [  r reciprocal ] ifFalse: [r ] ).! !

!StarMorph methodsFor: 'menus' stamp: 'wiz 1/15/2005 02:26'!
updateFormFromUser
"Does nothing here. Overridden in subclasses e.g. Kaleidoscope."
^ self.! !

!StarMorph methodsFor: 'editing' stamp: 'di 9/26/97 11:11'!
updateHandles! !

!StarMorph methodsFor: 'editing' stamp: 'wiz 1/11/2005 19:39'!
withCenterOuterHandles
	"Add to our handles the center positioning and outer resizing
	handles. Outer handle must not be blocked so it comes first. 
	The editing routine expects to find the center handle second.
	The side and shape changing handles follow these."
	| center v1 hExtent holder |
	center := vertices average rounded.
	hExtent := 8 @ 8.
	v1 := vertices first.
	holder := {(EllipseMorph
				newBounds: (Rectangle center: v1 extent: hExtent)
				color: Color yellow)
				setBalloonText: 'Move me to adjust size. Shift move to adjust pointiness'. (EllipseMorph
				newBounds: (Rectangle center: center extent: hExtent)
				color: Color yellow)
				setBalloonText: 'Move me to adjust position'}.
	holder
		with: {#outside. #center}
		do: [:handle :which | handle
				on: #mouseDown
				send: #dragVertex:event:fromHandle:
				to: self
				withValue: which;
				
				on: #mouseMove
				send: #dragVertex:event:fromHandle:
				to: self
				withValue: which].
	handles addAll: holder! !

!StarMorph methodsFor: 'editing' stamp: 'wiz 1/11/2005 19:47'!
withUpDownLeftRightHandlesAround: radius center: center
	"Add to our handles the side and shape changing handles."
	| tri  above holder  triAbove triBelow triRight triLeft |
	above := 0 @ radius negated.
	
	tri := Array
				with: 0 @ -5
				with: 4 @ 3
				with: -4 @ 3.
	triAbove := tri + (center + above).
	triBelow := triAbove
				collect: [:pt | pt rotateBy: #pi centerAt: center].
	triRight := triAbove
				collect: [:pt | pt rotateBy: #right centerAt: center].
	triLeft := triAbove
				collect: [:pt | pt rotateBy: #left centerAt: center].
				
	holder := { (PolygonMorph
				vertices: triAbove
				color: Color green
				borderWidth: 1
				borderColor: Color black)
				 setBalloonText: 'More points.'. 
				
				(PolygonMorph
				vertices: triBelow
				color: Color magenta
				borderWidth: 1
				borderColor: Color black)
				 setBalloonText: 'Fewer points.'. 
				
				(PolygonMorph
				vertices: triRight
				color: Color green
				borderWidth: 1
				borderColor: Color black)
				 setBalloonText: 'Twinkle fatter.'. 
				
				(PolygonMorph
				vertices: triLeft
				color: Color magenta
				borderWidth: 1
				borderColor: Color black)
				 setBalloonText: 'Twinkle thinner.'}.
	
	holder
		with: {#more. #less. #next. #prev}
		do: [:handle :which | handle
				on: #mouseDown
				send: #changeVertices:event:fromHandle:
				to: self
				withValue: which;
				
				on: #mouseMove
				send: #changeVertices:event:fromHandle:
				to: self
				withValue: which].
	^ handles addAll: holder! !

!FileDirectory methodsFor: '*MorphicExtras-file name utilities' stamp: 'fbs 2/2/2005 13:22'!
url
	"Convert my path into a file:// type url String."
	
	^self asUrl asString.! !

!MIMEDocument methodsFor: '*MorphicExtras-accessing' stamp: 'sma 4/28/2000 14:48'!
url
	"Answer the URL the receiver was downloaded from.  It may legitimately be nil."

	^ url! !

!WorldState methodsFor: '*MorphicExtras-hands' stamp: 'ar 1/22/2001 14:26'!
activeHand: aHandMorph
	"still needed until event loop with old code goes away"
	ActiveHand := aHandMorph.! !

!WorldState methodsFor: '*MorphicExtras-update cycle' stamp: 'RAA 6/6/2000 17:30'!
displayWorldAsTwoTone: aWorld submorphs: submorphs color: color
	"Display the world in living black-and-white. (This is typically done to save space.)"

	| f |
	f := ColorForm extent: aWorld viewBox extent depth: 1.
	f colors: (Array with: color dominantColor with: Color black).
	self canvas: f getCanvas.

	"force the entire canvas to be redrawn"
	aWorld fullRepaintNeeded.
	self drawWorld: aWorld submorphs: submorphs invalidAreasOn: canvas.  "redraw on offscreen canvas"
	canvas showAt: aWorld viewBox origin.  "copy redrawn areas to Display"
	Display forceDisplayUpdate.
	self canvas: nil.  "forget my canvas to save space"
! !

!WorldState methodsFor: '*MorphicExtras-initialization' stamp: 'ar 10/22/2000 16:04'!
stepListSummary
	^ String streamContents:
		[:aStream |
			aStream nextPutAll: stepList size printString, ' items in steplist:'.
			stepList do:
				[:anElement | aStream nextPutAll: anElement receiver printString]]

"Transcript cr show: self currentWorld stepListSummary"! !

UpdatingStringMorph subclass: #UpdatingBooleanStringMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!UpdatingBooleanStringMorph commentStamp: '<historical>' prior: 0!
A customized updating-string-morph used for displaying and editing boolean values; mouse-down on one of these is inerpreted as a request to toggle.!

!UpdatingBooleanStringMorph methodsFor: 'event handling' stamp: 'sw 10/1/1998 16:59'!
handlesMouseDown: evt
	^ true! !

!UpdatingBooleanStringMorph methodsFor: 'target access' stamp: 'dgd 2/22/2003 18:59'!
informTarget
	"Determine a value by evaluating my readout, and send that value to my target"

	| newValue |
	(target notNil and: [putSelector notNil]) 
		ifTrue: 
			[newValue := self valueFromContents.
			newValue ifNotNil: 
					[target 
						perform: putSelector
						with: getSelector
						with: newValue.
					target isMorph ifTrue: [target changed]].
			self growable 
				ifTrue: 
					[self
						readFromTarget;
						fitContents.
					owner updateLiteralLabel]]! !

!UpdatingBooleanStringMorph methodsFor: 'event handling' stamp: 'sw 6/16/1999 13:30'!
mouseDown: evt
	self color: Color red! !

!UpdatingBooleanStringMorph methodsFor: 'event handling' stamp: 'nb 6/17/2003 12:25'!
mouseUp: evt
	(bounds containsPoint: evt cursorPoint)
		ifTrue:
			[self contentsClipped: (target perform: getSelector) not asString.
			self informTarget]
		ifFalse:
			[Beeper beep].
	self color: Color black! !

!UpdatingStringMorph methodsFor: '*MorphicExtras-accessing' stamp: 'sw 9/13/2002 17:57'!
floatPrecision: aPrecision
	"Set the receiver's number of decimal places to correspond with the given precision.  The preferred protocol here is #decimalPlaces:, which conforms to the UI for this, but #floatPrecision: is retained for backward compatibility."

	self decimalPlaces: (Utilities decimalPlacesForFloatPrecision: aPrecision)! !

UpdatingStringMorph subclass: #UpdatingStringMorphWithArgument
	instanceVariableNames: 'argumentTarget argumentGetSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!UpdatingStringMorphWithArgument methodsFor: 'as yet unclassified' stamp: 'sw 10/25/1998 00:20'!
argumentTarget: t argumentGetSelector: s
	argumentTarget := t.
	argumentGetSelector := s! !

!UpdatingStringMorphWithArgument methodsFor: 'target access' stamp: 'sw 10/25/1998 00:57'!
readFromTarget
	| v |
	argumentTarget ifNil: [^ super readFromTarget].
	v := target perform: getSelector with: (argumentTarget perform: argumentGetSelector).
	^ self acceptValueFromTarget: v! !

!UpdatingStringMorphWithArgument methodsFor: 'copying' stamp: 'tk 1/7/1999 15:40'!
veryDeepFixupWith: deepCopier
	"If target and arguments fields were weakly copied, fix them here.  If they were in the tree being copied, fix them up, otherwise point to the originals!!!!"

super veryDeepFixupWith: deepCopier.
argumentTarget := deepCopier references at: argumentTarget 
			ifAbsent: [argumentTarget].
! !

!UpdatingStringMorphWithArgument methodsFor: 'copying' stamp: 'tk 1/7/1999 15:39'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

super veryDeepInner: deepCopier.
"argumentTarget := argumentTarget.		Weakly copied"
argumentGetSelector := argumentGetSelector veryDeepCopyWith: deepCopier.! !

PluggableTextMorphWithModel subclass: #ScrollableField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!ScrollableField classSide methodsFor: 'scripting' stamp: 'dgd 10/14/2004 18:08'!
additionsToViewerCategories
	^ TextMorph additionsToViewerCategories! !

!ScrollableField classSide methodsFor: 'parts bin' stamp: 'sw 4/2/2002 12:21'!
descriptionForPartsBin
	^ self partName:	'Scrolling Text'
		categories:		#('Text' )
		documentation:	'A scrollable, editable body of text'! !

!ScrollableField classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 10:59'!
initialize

	self registerInFlapsRegistry.	! !

!ScrollableField classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 11:01'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(ScrollableField			newStandAlone		'Scrolling Text'		'Holds any amount of text; has a scroll bar')
						forFlapNamed: 'Stack Tools'.]! !

!ScrollableField classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 12:40'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 19:08'!
adjustTextAnchor: aMorph 
	textMorph
		ifNotNil: [textMorph adjustTextAnchor: aMorph]! !

!ScrollableField methodsFor: 'editing' stamp: 'dgd 10/14/2004 19:21'!
anchorMorph: aMorph at: aPoint type: anchorType 
	textMorph anchorMorph: aMorph at: aPoint type: anchorType ! !

!ScrollableField methodsFor: 'updating' stamp: 'dgd 10/14/2004 19:18'!
changed
	super changed.
	textMorph changed.! !

!ScrollableField methodsFor: 'editing' stamp: 'dgd 10/14/2004 18:57'!
chooseEmphasisOrAlignment
	textMorph chooseEmphasisOrAlignment! !

!ScrollableField methodsFor: 'editing' stamp: 'dgd 10/14/2004 18:59'!
chooseFont
	textMorph chooseFont! !

!ScrollableField methodsFor: 'editing' stamp: 'dgd 10/14/2004 18:58'!
chooseStyle
	textMorph chooseStyle! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 19:05'!
contents
	^ textMorph contents! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 18:27'!
cursor
	"Answer the receiver's logical cursor position"
	^ textMorph cursor! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 18:31'!
cursorWrapped: aNumber 
"Set the cursor as indicated"
	textMorph cursorWrapped: aNumber! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 19:00'!
editor
	^ textMorph editor! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 18:13'!
elementCount
	"Answer how many sub-objects are within me"
	^ textMorph elementCount! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 18:14'!
getAllButFirstCharacter
	"Obtain all but the first character from the receiver; if that  
	would be empty, return a black dot"
	^ textMorph getAllButFirstCharacter ! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 18:31'!
getCharacters
"obtain a string value from the receiver"
	^ textMorph getCharacters! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 18:14'!
getFirstCharacter
	"obtain the first character from the receiver if it is empty, 
	return a black dot"
	^ textMorph getFirstCharacter! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 18:14'!
getLastCharacter
	"obtain the last character from the receiver if it is empty,  
	return a black dot"
	^ textMorph getLastCharacter ! !

!ScrollableField methodsFor: 'menu' stamp: 'dgd 10/1/2004 11:44'!
getMenu: shiftKeyState 
	^ (shiftKeyState not
			or: [Preferences noviceMode])
		ifTrue: [ParagraphEditor yellowButtonMenu]
		ifFalse: [ParagraphEditor shiftedYellowButtonMenu]! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 18:27'!
getNumericValue
	"Obtain a numeric value from the receiver; if no digits, return  
	zero"
	^ textMorph getNumericValue ! !

!ScrollableField methodsFor: 'parts bin' stamp: 'dgd 4/3/2006 13:28'!
initializeToStandAlone
	super initializeToStandAlone.
	self  color: (Color r: 0.972 g: 0.972 b: 0.662).
	self retractable: false; scrollBarOnLeft: false.

	self wantsFrameAdornments: false.! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 18:28'!
insertCharacters: aString 
	"Insert the characters from the given source at my current  
	cursor position"
	textMorph insertCharacters: aString ! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 18:28'!
insertContentsOf: aPlayer 
	"Insert the characters from the given player at my current  
	cursor position"
	textMorph insertContentsOf: aPlayer ! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 19:03'!
isAutoFit
	^ textMorph isAutoFit! !

!ScrollableField methodsFor: 'classification' stamp: 'dgd 10/14/2004 18:56'!
isTextMorph
	^ true! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 19:03'!
isWrapped
	^ textMorph isWrapped! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 19:04'!
margins
	^ textMorph margins! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 18:25'!
paragraph
	^ textMorph paragraph! !

!ScrollableField methodsFor: 'private' stamp: 'dgd 10/14/2004 19:19'!
releaseParagraph
	textMorph releaseParagraph ! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 18:30'!
setCharacters: chars 
	"obtain a string value from the receiver"
	textMorph setCharacters: chars ! !

!ScrollableField methodsFor: 'containment' stamp: 'dgd 10/14/2004 19:19'!
setContainer: newContainer 
	self changed.
	textMorph setContainer: newContainer.
self releaseParagraph! !

!ScrollableField methodsFor: 'contents' stamp: 'sw 4/7/2002 18:48'!
setMyText: someText
	"Set my text, as indicated"

	| toUse |
	toUse := someText ifNil: [''].
	myContents := toUse.
	self setText: toUse.
	^ true! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 18:28'!
setNumericValue: aValue 
	"Set the contents of the receiver to be a string obtained from  
	aValue"
	textMorph setNumericValue: aValue ! !

!ScrollableField methodsFor: 'private' stamp: 'dgd 10/14/2004 19:05'!
text: aText textStyle: aTextStyle 
	textMorph text: aText textStyle: aTextStyle ! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 19:05'!
textStyle
	^ textMorph textStyle! !

!ScrollableField methodsFor: 'accessing' stamp: 'dgd 10/14/2004 18:28'!
updateFromParagraph
	"A change has taken place in my paragraph, as a result of  
	editing and I must be updated. If a line break causes  
	recomposition of the current paragraph, or it the selection has 
	entered a different paragraph, then the current editor will be  
	released, and must be reinstalled with the resulting new  
	paragraph, while retaining any editor state, such as selection,  
	undo state, and current typing emphasis."
	textMorph updateFromParagraph ! !

!ScrollableField methodsFor: 'menu' stamp: 'dgd 10/1/2004 11:57'!
wantsYellowButtonMenu
	"Answer true if the receiver wants a yellow button menu"
	^ true! !

FormCanvas subclass: #MultiResolutionCanvas
	instanceVariableNames: 'deferredMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Support'!

!MultiResolutionCanvas methodsFor: 'as yet unclassified' stamp: 'RAA 12/4/2000 12:00'!
deferredMorphs

	^deferredMorphs! !

!MultiResolutionCanvas methodsFor: 'as yet unclassified' stamp: 'RAA 12/4/2000 11:58'!
deferredMorphs: aCollection

	deferredMorphs := aCollection! !

!MultiResolutionCanvas methodsFor: 'drawing-general' stamp: 'RAA 12/4/2000 12:00'!
fullDraw: aMorph

	aMorph canDrawAtHigherResolution ifTrue: [
		deferredMorphs ifNil: [deferredMorphs := OrderedCollection new].
		deferredMorphs add: aMorph.
	] ifFalse: [
		super fullDraw: aMorph
	].! !

!MultiResolutionCanvas methodsFor: 'as yet unclassified' stamp: 'RAA 12/17/2000 13:25'!
initializeFrom: aFormCanvas

	origin := aFormCanvas origin.
	clipRect := aFormCanvas privateClipRect.
	form := aFormCanvas form.
	port := aFormCanvas privatePort.
	shadowColor := aFormCanvas shadowColor.
! !

!ProjectViewMorph methodsFor: '*MorphicExtras-events' stamp: 'fc 12/23/2004 19:33'!
enterAsActiveSubproject
	"Enter my project."

	self setProperty: #wasOpenedAsSubproject toValue: true.
	project class == DiskProxy 
		ifTrue: 
			["When target is not in yet"

			[self enterWhenNotPresent	"will bring it in"] on: ProjectEntryNotification
				do: [:ex | ^ex projectToEnter enterAsActiveSubprojectWithin: self world].
			project class == DiskProxy ifTrue: [self error: 'Could not find view']].
	(owner isSystemWindow) ifTrue: [project setViewSize: self extent].
	self showMouseState: 3.
	project enterAsActiveSubprojectWithin: self world! !

!ProjectViewMorph methodsFor: '*MorphicExtras-*morphic-Postscript Canvases' stamp: 'RAA 4/19/2001 11:25'!
fullDrawPostscriptOn: aCanvas

	| f |
	"handle the fact that we have the squished text within"

	f := self imageForm.
	f offset: 0@0.
	aCanvas paintImage: f at: bounds origin.
! !

!ProjectViewMorph methodsFor: '*MorphicExtras-event handling' stamp: 'ar 10/25/2000 17:37'!
handlesMouseStillDown: evt
	^true! !

!ProjectViewMorph methodsFor: '*MorphicExtras-event handling' stamp: 'fc 12/23/2004 16:24'!
mouseStillDown: evt

	(self containsPoint: evt cursorPoint) ifFalse: [
		self showMouseState: 3.
		^self
	].
	self showMouseState: 2.
	
	
					! !

!UpdatingMenuItemMorph methodsFor: '*MorphicExtras-e-toy support' stamp: 'ar 3/17/2001 20:18'!
adaptToWorld: aWorld
	super adaptToWorld: aWorld.
	wordingProvider := wordingProvider adaptedToWorld: aWorld.! !

EllipseMorph subclass: #AtomMorph
	instanceVariableNames: 'velocity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!AtomMorph commentStamp: 'tbn 11/25/2004 09:06' prior: 0!
AtomMorph represents an atom used in the simulation of
an ideal gas. It's container is typically a BouncingAtomsMorph.

Try:

	BouncingAtomsMorph  new openInWorld

to open the gas simulation or:

	AtomMorph example

to open an instance in the current world!

!AtomMorph classSide methodsFor: 'examples' stamp: 'tbn 11/25/2004 09:03'!
example
	"
	AtomMorph example
	"
	|a|
	a := AtomMorph new openInWorld. 
	a color: Color random.
 	[1000 timesRepeat:  [a bounceIn: World bounds.  (Delay forMilliseconds: 50) wait]. 
	 a delete] fork.! !

!AtomMorph classSide methodsFor: 'new-morph participation' stamp: 'di 6/22/97 09:07'!
includeInNewMorphMenu
	"Not to be instantiated from the menu"
	^ false! !

!AtomMorph methodsFor: 'private' stamp: 'jm 8/10/1998 17:40'!
bounceIn: aRect
	"Move this atom one step along its velocity vector and make it bounce if it goes outside the given rectangle. Return true if it is bounced."

	| p vx vy px py bounced |
	p := self position.
	vx := velocity x.		vy := velocity y.
	px := p x + vx.		py := p y + vy.
	bounced := false.
	px > aRect right ifTrue: [
		px := aRect right - (px - aRect right).
		vx := velocity x negated.
		bounced := true].
	py > aRect bottom ifTrue: [
		py :=  aRect bottom - (py - aRect bottom).
		vy := velocity y negated.
		bounced := true].
	px < aRect left ifTrue: [
		px := aRect left - (px - aRect left).
		vx := velocity x negated.
		bounced := true].
	py < aRect top ifTrue: [
		py :=  aRect top - (py - aRect top).
		vy := velocity y negated.
		bounced := true].
	self position: px @ py.
	bounced ifTrue: [self velocity: vx @ vy].
	^ bounced
! !

!AtomMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:13'!
defaultBorderWidth
"answer the default border width for the receiver"
	^ 0! !

!AtomMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:13'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color blue! !

!AtomMorph methodsFor: 'drawing' stamp: ''!
drawOn: aCanvas
	"Note: Set 'drawAsRect' to true to make the atoms draw faster. When testing the speed of other aspects of Morphic, such as its damage handling efficiency for large numbers of atoms, it is useful to make drawing faster."

	| drawAsRect |
	drawAsRect := false.  "rectangles are faster to draw"
	drawAsRect
		ifTrue: [aCanvas fillRectangle: self bounds color: color]
		ifFalse: [super drawOn: aCanvas].! !

!AtomMorph methodsFor: 'accessing' stamp: ''!
infected

	^ color = Color red! !

!AtomMorph methodsFor: 'accessing' stamp: ''!
infected: aBoolean

	aBoolean
		ifTrue: [self color: Color red]
		ifFalse: [self color: Color blue].! !

!AtomMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:13'!
initialize
	"Make a new atom with a random position and velocity."
	super initialize.
""
	self extent: 8 @ 7.
	
	self
		randomPositionIn: (0 @ 0 corner: 300 @ 300)
		maxVelocity: 10! !

!AtomMorph methodsFor: 'initialization' stamp: 'RAA 12/15/2000 07:32'!
randomPositionIn: aRectangle maxVelocity: maxVelocity
	"Give this atom a random position and velocity."

	| origin extent |
	origin := aRectangle origin.
	extent := (aRectangle extent - self bounds extent) rounded.
	self position:
		(origin x + extent x atRandom) @
		(origin y + extent y atRandom).
	velocity :=
		(maxVelocity - (2 * maxVelocity) atRandom) @
		(maxVelocity - (2 * maxVelocity) atRandom).
! !

!AtomMorph methodsFor: 'accessing' stamp: ''!
velocity

	^ velocity! !

!AtomMorph methodsFor: 'accessing' stamp: ''!
velocity: newVelocity

	velocity := newVelocity.! !

!EllipseMorph class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/10/2003 13:03'!
initialize

	self registerInFlapsRegistry.	! !

!EllipseMorph class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/10/2003 13:05'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(EllipseMorph	authoringPrototype		'Ellipse'			'An ellipse or circle')
						forFlapNamed: 'Supplies'.
						cl registerQuad: #(EllipseMorph	authoringPrototype		'Ellipse'			'An ellipse or circle')
						forFlapNamed: 'PlugIn Supplies'.]! !

!EllipseMorph class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/11/2003 12:33'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

EllipseMorph subclass: #Flasher
	instanceVariableNames: 'onColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!Flasher commentStamp: '<historical>' prior: 0!
A simple example - a circle that flashes.

The "onColor" instance variable indicates the color to use when "on",  A darker color is used to represent "off".

The #step method, called every 500ms. by default, alternatively makes the flasher show its "on" and its "off" color.!

!Flasher classSide methodsFor: 'parts bin' stamp: 'sw 4/17/2002 11:37'!
descriptionForPartsBin
	"Answer a description of the receiver for use in a parts bin"

	^ self partName:	'Flasher'
		categories:		#('Demo')
		documentation:	'A circle that flashes'! !

!Flasher methodsFor: 'parts bin' stamp: 'sd 4/21/2002 09:36'!
initializeToStandAlone
	"Initialize the flasher."

	super initializeToStandAlone.
	self color: Color red.
	self onColor: Color red. 
	self borderWidth: 2.
	self extent: 25@25! !

!Flasher methodsFor: 'operations' stamp: 'sw 5/28/2002 18:44'!
onColor
	"Answer my onColor"

	^ onColor ifNil: [onColor := Color red]! !

!Flasher methodsFor: 'operations' stamp: 'sd 4/21/2002 09:55'!
onColor: aColor
	"Change my on color to be aColor"

	onColor := aColor.
	self color: aColor! !

!Flasher methodsFor: 'stepping and presenter' stamp: 'sw 5/28/2002 18:45'!
step
	"Perform my standard periodic action"

	super step.
	self color = self onColor
		ifTrue: [self color: (onColor alphaMixed: 0.5 with: Color black)]
		ifFalse: [self color: onColor]! !

!Flasher methodsFor: 'testing' stamp: 'sw 4/17/2002 12:05'!
stepTime
	"Answer the desired time between steps, in milliseconds."

	^ 500! !

EllipseMorph subclass: #MovingEyeMorph
	instanceVariableNames: 'inner iris'
	classVariableNames: 'IrisSize'
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!MovingEyeMorph classSide methodsFor: 'parts bin' stamp: 'sw 8/2/2001 12:51'!
descriptionForPartsBin
	^ self partName:	'MovingEye'
		categories:		#('Demo')
		documentation:	'An eye which follows the cursor'! !

!MovingEyeMorph classSide methodsFor: 'class initialization' stamp: 'yo 2/15/2001 16:04'!
initialize
"
	MovingEyeMorph initialize
"
	IrisSize := (0.42@0.50).! !

!MovingEyeMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:42'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color black! !

!MovingEyeMorph methodsFor: 'geometry' stamp: 'yo 2/15/2001 15:59'!
extent: aPoint

	super extent: aPoint.
	inner extent: (self extent * ((1.0@1.0)-IrisSize)) asIntegerPoint.
	iris extent: (self extent * IrisSize) asIntegerPoint.
	inner position: (self center - (inner extent // 2)) asIntegerPoint.
! !

!MovingEyeMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:42'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	inner := EllipseMorph new.
	inner color: self color.
	inner extent: (self extent * (1.0 @ 1.0 - IrisSize)) asIntegerPoint.
	inner borderColor: self color.
	inner borderWidth: 0.
""
	iris := EllipseMorph new.
	iris color: Color white.
	iris extent: (self extent * IrisSize) asIntegerPoint.
""
	self addMorphCentered: inner.
	inner addMorphCentered: iris.
""
	self extent: 26 @ 33! !

!MovingEyeMorph methodsFor: 'as yet unclassified' stamp: 'yo 2/15/2001 15:24'!
irisPos: cp

	| a b theta x y |
	theta := (cp - self center) theta.
	a := inner width // 2.
	b := inner height // 2.
	x := a * (theta cos).
	y := b * (theta sin).
	iris position: ((x@y) asIntegerPoint) + self center - (iris extent // 2).! !

!MovingEyeMorph methodsFor: 'stepping and presenter' stamp: 'di 2/18/2001 00:10'!
step
	| cp |
	cp := self globalPointToLocal: World primaryHand position.
	(inner containsPoint: cp)
		ifTrue: [iris position: (cp - (iris extent // 2))]
		ifFalse: [self irisPos: cp].
	self changed "cover up gribblies if embedded in Flash"! !

!MovingEyeMorph methodsFor: 'testing' stamp: 'yo 2/15/2001 15:38'!
stepTime

	^ 100.! !

EllipseMorph subclass: #TickIndicatorMorph
	instanceVariableNames: 'stepTime corners index range isTicking lastTick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!TickIndicatorMorph methodsFor: 'accessing' stamp: 'ar 2/11/2001 19:48'!
color: aColor
	super color: aColor.
	self borderColor: aColor darker.! !

!TickIndicatorMorph methodsFor: 'initialization' stamp: 'gm 3/10/2003 22:10'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ self defaultColor darker
! !

!TickIndicatorMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:59'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color
		r: 0.767
		g: 0.767
		b: 1.0! !

!TickIndicatorMorph methodsFor: 'drawing' stamp: 'ar 2/12/2001 17:50'!
drawOn: aCanvas
	| r center cc deg |
	super drawOn: aCanvas.
	corners ifNil:[
		r := (bounds topCenter - bounds center) r - 2.
		corners := Array new: 32.
		1 to: corners size do:[:i|
			deg := 360.0 / corners size * (i-1).
			corners at: i put: (Point r: r degrees: deg-90) asIntegerPoint]].
	index := index \\ corners size.
	cc := color darker.
	center := bounds center.
	1 to: corners size by: 4 do:[:i|
		aCanvas fillRectangle: (center + (corners at: i)-2  extent: 4@4) color: cc.
	].
	cc := cc darker.
	aCanvas line: center to: center + (corners at: index + 1) width: 2 color: cc.! !

!TickIndicatorMorph methodsFor: 'geometry' stamp: 'ar 2/11/2001 20:12'!
extent: aPoint
	super extent: ((aPoint x max: aPoint y)  asInteger bitClear: 3) asPoint.
	corners := nil.! !

!TickIndicatorMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:59'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""

	self extent: 20 @ 20.
	index := 0! !

!TickIndicatorMorph methodsFor: 'accessing' stamp: 'ar 2/11/2001 20:31'!
isTicking
	^isTicking ifNil:[false].! !

!TickIndicatorMorph methodsFor: 'accessing' stamp: 'ar 2/11/2001 20:32'!
isTicking: aBool
	isTicking := aBool.! !

!TickIndicatorMorph methodsFor: 'private' stamp: 'ar 2/11/2001 19:22'!
privateMoveBy: delta
	corners := nil.
	super privateMoveBy: delta! !

!TickIndicatorMorph methodsFor: 'stepping and presenter' stamp: 'md 8/20/2005 19:03'!
stepAt: nowTick 
	| delta |
	self isTicking 
		ifTrue: 
			[(lastTick isNil or: [nowTick < lastTick]) ifTrue: [lastTick := nowTick].
			delta := (nowTick - lastTick) // self stepTime.
			delta > 0 
				ifTrue: 
					[index := index + delta.
					lastTick := nowTick.
					self changed]]! !

!TickIndicatorMorph methodsFor: 'testing' stamp: 'ar 2/12/2001 17:53'!
stepTime
	^(stepTime ifNil:[125]) max: 50! !

!TickIndicatorMorph methodsFor: 'accessing' stamp: 'ar 2/12/2001 17:40'!
stepTime: aNumber
	stepTime := aNumber max: 1.! !

!TickIndicatorMorph methodsFor: 'testing' stamp: 'ar 2/11/2001 19:14'!
wantsSteps
	^true! !

EllipseMorph subclass: #WatchMorph
	instanceVariableNames: 'fontName cColor handsColor romanNumerals antialias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!WatchMorph commentStamp: '<historical>' prior: 0!
This class is a representation of a watch.
The labels' font is changeble. Labels' font size increase or decrease when resizing me.

WatchMorph new openInWorld
(WatchMorph fontName: 'ComicPlain' bgColor: Color transparent centerColor: Color transparent) openInWorld		" transparent "
(WatchMorph fontName: 'ComicBold' bgColor: Color white centerColor: Color black) openInWorld

Structure:
	fontName		String -- the labels' font name
	cColor			Color -- center color
	handsColor		Color
	romanNumerals	Boolean
	antialias		Boolean!

!WatchMorph classSide methodsFor: 'parts bin' stamp: 'sw 8/2/2001 12:53'!
descriptionForPartsBin
	^ self partName:	'Watch'
		categories:		#('Useful')
		documentation:	'An analog clock face'! !

!WatchMorph classSide methodsFor: 'as yet unclassified' stamp: 'di 5/16/2000 21:43'!
fontName: aString bgColor: aColor centerColor: otherColor
	^ self new
		fontName: aString;
		color: aColor;
		centerColor: otherColor! !

!WatchMorph methodsFor: 'menus' stamp: 'dgd 8/30/2003 22:24'!
addCustomMenuItems: aMenu hand: aHandMorph
	"Add morph-specific items to the given menu which was invoked by the given hand."

	super addCustomMenuItems: aMenu hand: aHandMorph.
	aMenu addLine.
	aMenu addUpdating: #romanNumeralString action: #toggleRoman.
	aMenu addUpdating: #antiAliasString action: #toggleAntialias.
	aMenu addLine.
	aMenu add: 'change font...' translated action: #changeFont.
	aMenu balloonTextForLastItem: 'Allows you to change the font used to display the numbers.' translated.
	aMenu add: 'change hands color...' translated action: #changeHandsColor.
	aMenu balloonTextForLastItem: 'Allows you to specify a new color for the hands of the watch.  Note that actual *watch* color can be changed simply by using the halo''s recoloring handle.' translated.
	aMenu add: 'change center color...' translated action: #changeCenterColor.
	aMenu balloonTextForLastItem: 'Allows you to specify a new color to be used during PM hours for the center portion of the watch; during AM hours, a lighter shade of the same color will be used.' translated.! !

!WatchMorph methodsFor: 'menus' stamp: 'dgd 8/30/2003 22:25'!
antiAliasString
	^ (antialias
		ifTrue: ['<on>']
		ifFalse: ['<off>'])
		, 'anti-aliasing' translated! !

!WatchMorph methodsFor: 'accessing' stamp: 'bf 5/18/2000 11:06'!
antialias: aBoolean
	antialias := aBoolean! !

!WatchMorph methodsFor: 'accessing' stamp: 'sw 7/4/2002 00:19'!
centerColor: aColor
	"Set the center color as indicated; map nil into transparent"

	cColor := aColor ifNil: [Color transparent]! !

!WatchMorph methodsFor: 'menus' stamp: 'sw 9/6/2000 18:46'!
changeCenterColor
	"Let the user change the color of the center of the watch"

	ColorPickerMorph new
		choseModalityFromPreference;
		sourceHand: self activeHand;
		target: self;
		selector: #centerColor:;
		originalColor: self color;
		putUpFor: self near: self fullBounds! !

!WatchMorph methodsFor: 'menus' stamp: 'di 5/16/2000 21:48'!
changeFont

	self fontName: ((SelectionMenu labelList: StrikeFont familyNames
							selections: StrikeFont familyNames) startUp
					ifNil: [^ self])! !

!WatchMorph methodsFor: 'menus' stamp: 'sw 9/6/2000 18:46'!
changeHandsColor
	"Let the user change the color of the hands of the watch."

	ColorPickerMorph new
		choseModalityFromPreference;
		sourceHand: self activeHand;
		target: self;
		selector: #handsColor:;
		originalColor: self color;
		putUpFor: self near: self fullBounds! !

!WatchMorph methodsFor: 'labels' stamp: 'tlk 5/21/2006 14:53'!
createLabels
	| numeral font h r |
	self removeAllMorphs.
	font := StrikeFont familyName: fontName size: (h := self height min: self width)//8.
	r := 1.0 - (1.4 * font height / h).
	1 to: 12 do:
		[:hour |
		numeral := romanNumerals
			ifTrue: [hour printStringRoman]
			ifFalse: [hour asString].
		self addMorphBack: ((StringMorph contents: numeral font: font emphasis: 1)
			center: (self radius: r hourAngle: hour)) lock]! !

!WatchMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:01'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color green! !

!WatchMorph methodsFor: 'drawing' stamp: 'sw 7/4/2002 00:22'!
drawOn: aCanvas
	"Draw the watch on the given canvas"

	| pHour pMin pSec time centerColor |
	time := Time now.
	pHour := self radius: 0.6 hourAngle: time hours + (time minutes/60.0).
	pMin := self radius: 0.72 hourAngle: (time minutes / 5.0).
	pSec := self radius: 0.8 hourAngle: (time seconds / 5.0).
	centerColor := cColor
		ifNil:
			[Color transparent]
		ifNotNil:
			[time hours < 12
				ifTrue: [cColor muchLighter]
				ifFalse: [cColor]].

	antialias ifTrue:
		[aCanvas asBalloonCanvas
			aaLevel: 4;
			drawOval: (bounds insetBy: borderWidth // 2 + 1) color: self fillStyle
				borderWidth: borderWidth borderColor: borderColor;
			drawOval: (bounds insetBy: self extent*0.35) color: centerColor
				borderWidth: 0 borderColor: Color black;
			drawPolygon: {self center. pHour}
				color: Color transparent borderWidth: 3 borderColor: handsColor;
			drawPolygon: {self center. pMin}
				color: Color transparent borderWidth: 2 borderColor: handsColor;
			drawPolygon: {self center. pSec}
				color: Color transparent borderWidth: 1 borderColor: handsColor]
		ifFalse:
			[super drawOn: aCanvas.
			aCanvas
				fillOval: (bounds insetBy: self extent*0.35) color: centerColor;
				line: self center to: pHour width: 3 color: handsColor;
				line: self center to: pMin width: 2 color: handsColor;
				line: self center to: pSec width: 1 color: handsColor]
! !

!WatchMorph methodsFor: 'geometry' stamp: 'di 5/16/2000 21:18'!
extent: newExtent

	super extent: newExtent.
	self createLabels! !

!WatchMorph methodsFor: 'accessing' stamp: 'di 5/16/2000 21:45'!
fontName: aString

	fontName := aString.
	self createLabels! !

!WatchMorph methodsFor: 'accessing' stamp: 'rjf 5/11/2000 00:03'!
handsColor: aColor

	handsColor := aColor! !

!WatchMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:01'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""

	self handsColor: Color red.
	self centerColor: Color gray.
	romanNumerals := false.
	antialias := false.
	fontName := 'NewYork'.
	self extent: 130 @ 130.
	self start! !

!WatchMorph methodsFor: 'private' stamp: 'di 5/16/2000 22:22'!
radius: unitRadius hourAngle: hourAngle
	"unitRadius goes from 0.0 at the center to 1.0 on the circumference.
	hourAngle runs from 0.0 clockwise around to 12.0 with wrapping."

	^ self center + (self extent * (Point r: 0.5 * unitRadius
									degrees: hourAngle * 30.0 - 90.0)).! !

!WatchMorph methodsFor: 'menus' stamp: 'dgd 8/30/2003 22:24'!
romanNumeralString
	"Answer a string governing the roman-numerals checkbox"
	^ (romanNumerals
		ifTrue: ['<on>']
		ifFalse: ['<off>'])
		, 'roman numerals' translated! !

!WatchMorph methodsFor: 'stepping and presenter' stamp: 'rlf 3/17/2000 12:59'!
step
	self changed.! !

!WatchMorph methodsFor: 'menus' stamp: 'bf 5/17/2000 18:46'!
toggleAntialias
	antialias := antialias not! !

!WatchMorph methodsFor: 'menus' stamp: 'di 5/16/2000 21:19'!
toggleRoman

	romanNumerals := romanNumerals not.
	self createLabels! !

Slider subclass: #SimpleSliderMorph
	instanceVariableNames: 'target arguments minVal maxVal truncate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!SimpleSliderMorph class methodsFor: 'scripting' stamp: 'sw 3/10/2000 13:45'!
authoringPrototype
	| aSlider nominalColor |
	"self currentHand attachMorph: SimpleSliderMorph authoringPrototype"

	aSlider := super authoringPrototype beSticky.
	aSlider extent: 14@120.
	nominalColor := Color r: 0.4 g: 0.86 b: 0.7.
	aSlider color: nominalColor.
	aSlider sliderColor: nominalColor muchLighter.
	aSlider descending: true.
	aSlider setScaledValue: 0.3.
	^ aSlider! !

!SimpleSliderMorph class methodsFor: 'printing' stamp: 'sw 3/8/2000 12:56'!
defaultNameStemForInstances
	"Answer a basis for names of default instances of the receiver"
	^ 'Slider'! !

!SimpleSliderMorph class methodsFor: 'parts bin' stamp: 'sw 8/12/2001 17:53'!
descriptionForPartsBin
	^ self partName:	'Slider'
		categories:		#('Scripting')
		documentation:	'A scriptable control that allows you to choose a numeric value by dragging a knob.'! !

!SimpleSliderMorph class methodsFor: 'class initialization' stamp: 'asm 4/11/2003 11:04'!
initialize

	self registerInFlapsRegistry.	! !

!SimpleSliderMorph class methodsFor: 'class initialization' stamp: 'asm 4/11/2003 11:29'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(SimpleSliderMorph		authoringPrototype		'Slider'			'A slider for showing and setting numeric values.')
						forFlapNamed: 'PlugIn Supplies'.
						cl registerQuad: #(SimpleSliderMorph		authoringPrototype		'Slider'			'A slider for showing and setting numeric values.')
						forFlapNamed: 'Supplies'.
						cl registerQuad: #(SimpleSliderMorph		authoringPrototype		'Slider'			'A slider for showing and setting numeric values.')
						forFlapNamed: 'Scripting']! !

!SimpleSliderMorph class methodsFor: 'class initialization' stamp: 'asm 4/11/2003 12:40'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

!SimpleSliderMorph methodsFor: 'accessing' stamp: 'jm 1/29/98 14:17'!
actionSelector

	^ setValueSelector
! !

!SimpleSliderMorph methodsFor: 'accessing' stamp: 'jm 1/29/98 14:17'!
actionSelector: aSymbolOrString

	(nil = aSymbolOrString or:
	 ['nil' = aSymbolOrString or:
	 [aSymbolOrString isEmpty]])
		ifTrue: [^ setValueSelector := nil].

	setValueSelector := aSymbolOrString asSymbol.
! !

!SimpleSliderMorph methodsFor: 'menu' stamp: 'wiz 1/2/2006 10:02'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"To all the other Custom menu items add slider and targeting items."
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	self addSliderMenuItems: aCustomMenu hand: aHandMorph .
	self addTargetingMenuItems: aCustomMenu hand: aHandMorph .! !

!SimpleSliderMorph methodsFor: 'menu' stamp: 'wiz 1/2/2006 09:37'!
addSliderMenuItems: aCustomMenu hand: aHandMorph 
	"Add items to set slider parameters"
	aCustomMenu addLine.
	""
	aCustomMenu add: 'set action selector' translated action: #setActionSelector.
	aCustomMenu add: 'change arguments' translated action: #setArguments.
	""
	aCustomMenu add: 'set minimum value' translated action: #setMinVal.
	aCustomMenu add: 'set maximum value' translated action: #setMaxVal.
	""
	aCustomMenu addUpdating: #descendingString action: #toggleDescending.
	aCustomMenu addUpdating: #truncateString action: #toggleTruncate.
	! !

!SimpleSliderMorph methodsFor: 'menu' stamp: 'wiz 1/2/2006 09:29'!
addTargetingMenuItems: aCustomMenu hand: aHandMorph 
	"Add targeting menu items"
	aCustomMenu addLine.

	aCustomMenu add: 'set target' translated action: #targetWith:.
	aCustomMenu add: 'sight target' translated action: #sightTargets:.
	target
		ifNotNil: [aCustomMenu add: 'clear target' translated action: #clearTarget]! !

!SimpleSliderMorph methodsFor: 'private' stamp: 'jm 1/30/98 13:17'!
adjustToValue: aNumber
	"Adjust the position of this slider to correspond to the given value in the range minVal..maxVal."
	"Details: Internal values are normalized to the range 0..1."

	self value:
		(aNumber - minVal) asFloat / (maxVal - minVal).
! !

!SimpleSliderMorph methodsFor: 'accessing' stamp: 'jm 1/29/98 16:17'!
arguments

	^ arguments
! !

!SimpleSliderMorph methodsFor: 'accessing' stamp: 'jm 1/29/98 16:16'!
arguments: aCollection

	arguments := aCollection asArray copy.
! !

!SimpleSliderMorph methodsFor: 'menu' stamp: 'jm 1/29/98 14:08'!
clearTarget

	target := nil.
! !

!SimpleSliderMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 22:13'!
descendingString
	^ (self descending
		ifTrue: ['switch to ascending']
		ifFalse: ['switch to descending']) translated! !

!SimpleSliderMorph methodsFor: 'private' stamp: 'sw 3/12/2000 11:48'!
getScaledValue
	| aValue |
	aValue := (value * (maxVal - minVal)) + minVal.
	^ truncate ifTrue: [aValue truncated] ifFalse: [aValue]! !

!SimpleSliderMorph methodsFor: 'initialization' stamp: 'jm 1/29/98 16:16'!
initialize

	super initialize.
	target := nil.
	arguments := EmptyArray.
	minVal := 0.0.
	maxVal := 1.0.
	truncate := false.
! !

!SimpleSliderMorph methodsFor: 'parts bin' stamp: 'sw 6/29/2001 12:24'!
initializeToStandAlone
	| nominalColor |

	self initialize.
	self beSticky.
	self extent: 14@120.
	nominalColor := Color r: 0.452 g: 0.645 b: 0.935.
	self color: nominalColor.
	self borderColor: Color veryDarkGray.
	self sliderColor: nominalColor muchLighter.
	self descending: true.
	self setScaledValue: 0.3! !

!SimpleSliderMorph methodsFor: 'e-toy support' stamp: 'yo 2/10/2005 20:38'!
isLikelyRecipientForMouseOverHalos

	self player ifNil: [^ false].
	self player getHeading = 0.0 ifTrue: [^ false].
	^ true.
! !

!SimpleSliderMorph methodsFor: 'accessing' stamp: 'jm 1/30/98 12:41'!
maxVal

	^ maxVal
! !

!SimpleSliderMorph methodsFor: 'accessing' stamp: 'jm 1/30/98 12:41'!
maxVal: aNumber

	maxVal := aNumber.
! !

!SimpleSliderMorph methodsFor: 'accessing' stamp: 'jm 1/30/98 12:40'!
minVal

	^ minVal
! !

!SimpleSliderMorph methodsFor: 'accessing' stamp: 'jm 1/30/98 12:41'!
minVal: aNumber

	minVal := aNumber.
! !

!SimpleSliderMorph methodsFor: 'menu' stamp: 'yo 3/14/2005 13:06'!
setActionSelector
	| oldSel newSel |
	oldSel := setValueSelector isNil ifTrue: [''] ifFalse: [setValueSelector].
	newSel := FillInTheBlank 
				request: 'Please type the selector to be sent to
the target when this slider is changed' translated
				initialAnswer: oldSel.
	newSel isEmpty ifFalse: [self actionSelector: newSel]! !

!SimpleSliderMorph methodsFor: 'menu' stamp: 'yo 3/14/2005 13:09'!
setArguments

	| s newArgs newArgsArray |
	s := WriteStream on: ''.
	arguments do: [:arg | arg printOn: s. s nextPutAll: '. '].
	newArgs := FillInTheBlank
		request:
'Please type the arguments to be sent to the target
when this button is pressed separated by periods' translated
		initialAnswer: s contents.
	newArgs isEmpty ifFalse: [
		newArgsArray := Compiler evaluate: '{', newArgs, '}' for: self logged: false.
		self arguments: newArgsArray].
! !

!SimpleSliderMorph methodsFor: 'menu' stamp: 'jm 1/29/98 14:05'!
setLabel

	| newLabel |
	newLabel := FillInTheBlank
		request:
'Please a new label for this button'
		initialAnswer: self label.
	newLabel isEmpty ifFalse: [self label: newLabel].
! !

!SimpleSliderMorph methodsFor: 'menu' stamp: 'jm 1/29/98 14:41'!
setMaxVal

	| newMaxVal |
	newMaxVal := FillInTheBlank
		request: 'Maximum value?'
		initialAnswer: maxVal printString.
	newMaxVal isEmpty ifFalse: [
		maxVal := newMaxVal asNumber.
		minVal := minVal min: maxVal].
! !

!SimpleSliderMorph methodsFor: 'private' stamp: 'sw 3/6/2000 17:19'!
setMaxVal: newMaxVal
	maxVal := newMaxVal asNumber.
	minVal := maxVal min: minVal
! !

!SimpleSliderMorph methodsFor: 'menu' stamp: 'jm 1/29/98 14:42'!
setMinVal

	| newMinVal |
	newMinVal := FillInTheBlank
		request: 'Minimum value?'
		initialAnswer: minVal printString.
	newMinVal isEmpty ifFalse: [
		minVal := newMinVal asNumber.
		maxVal := maxVal max: minVal].
! !

!SimpleSliderMorph methodsFor: 'menu' stamp: 'sw 3/6/2000 17:13'!
setMinVal: newMinVal
	minVal := newMinVal asNumber.
	maxVal := maxVal max: minVal
! !

!SimpleSliderMorph methodsFor: 'private' stamp: 'sw 3/8/2000 16:22'!
setScaledValue: aNumber
	| denom |
	(denom := maxVal - minVal) > 0
		ifTrue:
			[self setValue: (aNumber - minVal) / denom]
		ifFalse:
			[self setValue: maxVal]
	"If minVal = maxVal, that value is the only one this (rather unuseful!!) slider can bear"! !

!SimpleSliderMorph methodsFor: 'menu' stamp: 'dgd 2/22/2003 18:55'!
setTarget: evt 
	| rootMorphs |
	rootMorphs := self world rootMorphsAt: evt hand targetOffset.
	target := rootMorphs size > 1
				ifTrue: [rootMorphs second]! !

!SimpleSliderMorph methodsFor: 'model access' stamp: 'dgd 2/22/2003 18:58'!
setValue: newValue 
	"Update the target with this sliders new value."

	| scaledValue |
	self value: newValue.
	scaledValue := newValue * (maxVal - minVal) + minVal.
	truncate ifTrue: [scaledValue := scaledValue truncated].
	(target notNil and: [setValueSelector notNil]) 
		ifTrue: 
			[Cursor normal showWhile: 
					[target perform: setValueSelector
						withArguments: (arguments copyWith: scaledValue)]]! !

!SimpleSliderMorph methodsFor: 'accessing' stamp: 'jm 1/29/98 14:09'!
target

	^ target
! !

!SimpleSliderMorph methodsFor: 'accessing' stamp: 'jm 1/29/98 14:09'!
target: anObject

	target := anObject
! !

!SimpleSliderMorph methodsFor: 'menu' stamp: 'sw 3/12/2000 11:40'!
toggleDescending

	descending := self descending not
! !

!SimpleSliderMorph methodsFor: 'menu' stamp: 'jm 1/29/98 14:46'!
toggleTruncate

	truncate := truncate not.
! !

!SimpleSliderMorph methodsFor: 'private' stamp: 'sw 3/12/2000 11:54'!
truncate
	^ truncate == true! !

!SimpleSliderMorph methodsFor: 'private' stamp: 'sw 3/12/2000 11:53'!
truncate: aBoolean
	truncate := aBoolean! !

!SimpleSliderMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 22:13'!
truncateString
	^ (truncate
		ifTrue: ['turn off truncation']
		ifFalse: ['turn on truncation'])  translated! !

!SimpleSliderMorph methodsFor: 'copying' stamp: 'jm 1/29/98 16:18'!
updateReferencesUsing: aDictionary
	"Copy and update references in the arguments array during copying."

	super updateReferencesUsing: aDictionary.
	arguments := arguments collect:
		[:old | aDictionary at: old ifAbsent: [old]].
! !

!SimpleSliderMorph methodsFor: 'copying' stamp: 'tk 1/6/1999 19:24'!
veryDeepFixupWith: deepCopier
	"If target and arguments fields were weakly copied, fix them here.  If they were in the tree being copied, fix them up, otherwise point to the originals!!!!"

super veryDeepFixupWith: deepCopier.
target := deepCopier references at: target ifAbsent: [target].
arguments := arguments collect: [:each |
	deepCopier references at: each ifAbsent: [each]].
! !

!SimpleSliderMorph methodsFor: 'copying' stamp: 'tk 1/7/1999 14:35'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

super veryDeepInner: deepCopier.
"target := target.		Weakly copied"
"arguments := arguments.		All weakly copied"
minVal := minVal veryDeepCopyWith: deepCopier.		"will be fast if integer"
maxVal := maxVal veryDeepCopyWith: deepCopier.
truncate := truncate veryDeepCopyWith: deepCopier.
! !

!RemoteFileStream methodsFor: '*MorphicExtras-as yet unclassified' stamp: 'tk 1/25/1999 15:16'!
url
	^ remoteFile url! !

StringMorph subclass: #BorderedStringMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!BorderedStringMorph methodsFor: 'drawing' stamp: 'ar 12/31/2001 02:34'!
drawOn: aCanvas
	| nameForm |
	font := self fontToUse.
	nameForm := Form extent: bounds extent depth: 8.
	nameForm getCanvas drawString: contents at: 0@0 font: self fontToUse color: Color black.
	(bounds origin + 1) eightNeighbors do: [ :pt |
		aCanvas
			stencil: nameForm 
			at: pt
			color: self borderColor.
	].
	aCanvas
		stencil: nameForm 
		at: bounds origin + 1 
		color: color.


	
! !

!BorderedStringMorph methodsFor: 'initialization' stamp: 'ar 12/14/2001 20:02'!
initWithContents: aString font: aFont emphasis: emphasisCode
	super initWithContents: aString font: aFont emphasis: emphasisCode.
	self borderStyle: (SimpleBorder width: 1 color: Color white).! !

!BorderedStringMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 20:42'!
initialize
"initialize the state of the receiver"
	super initialize.
""
	self
		borderStyle: (SimpleBorder width: 1 color: Color white)! !

!BorderedStringMorph methodsFor: 'accessing' stamp: 'ar 12/12/2001 03:03'!
measureContents
	^super measureContents +2.! !

StringMorph subclass: #ClockMorph
	instanceVariableNames: 'showSeconds show24hr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!ClockMorph classSide methodsFor: 'scripting' stamp: 'sw 10/16/1998 15:36'!
authoringPrototype
	^ super authoringPrototype contents: Time now printString! !

!ClockMorph classSide methodsFor: 'parts bin' stamp: 'sw 8/2/2001 01:22'!
descriptionForPartsBin
	^ self partName:	'Clock'
		categories:		#('Useful')
		documentation:	'A digital clock'! !

!ClockMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/10/2003 13:00'!
initialize

	self registerInFlapsRegistry.	! !

!ClockMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/10/2003 13:02'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(ClockMorph	authoringPrototype		'Clock'			'A simple digital clock')
						forFlapNamed: 'Supplies'.
						cl registerQuad: #(ClockMorph	authoringPrototype		'Clock'			'A simple digital clock')
						forFlapNamed: 'PlugIn Supplies'.]! !

!ClockMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 12:33'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

!ClockMorph methodsFor: 'menu' stamp: 'fc 2/8/2004 11:57'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"Note minor loose end here -- if the menu is persistent, then the wording will be wrong half the time"
	| item |
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	item := showSeconds == true
		ifTrue:	['stop showing seconds']
		ifFalse: ['start showing seconds'].
	aCustomMenu add: item translated target: self action: #toggleShowingSeconds.
	item := show24hr == true
		ifTrue: ['display Am/Pm']
		ifFalse: ['display 24 hour'].
	aCustomMenu add: item translated target: self action: #toggleShowing24hr.	
		
! !

!ClockMorph methodsFor: 'initialization' stamp: 'fc 2/8/2004 11:33'!
initialize
"initialize the state of the receiver"
	super initialize.
""
	showSeconds := true.
	show24hr := false.
	self step! !

!ClockMorph methodsFor: 'parts bin' stamp: 'sw 7/12/2001 17:41'!
initializeToStandAlone
	super initializeToStandAlone.
	showSeconds := true.
	self step! !

!ClockMorph methodsFor: '24hr' stamp: 'fc 2/8/2004 11:38'!
show24hr: aBoolean
	show24hr := aBoolean! !

!ClockMorph methodsFor: 'seconds' stamp: 'sw 2/17/1999 14:39'!
showSeconds: aBoolean
	showSeconds := aBoolean! !

!ClockMorph methodsFor: 'stepping and presenter' stamp: 'fc 2/8/2004 11:40'!
step
	| time |
	super step.
	time := String streamContents:
		[:aStrm | Time now print24: (show24hr == true) showSeconds: (showSeconds == true) on: aStrm].

	self contents: time			! !

!ClockMorph methodsFor: 'testing' stamp: ''!
stepTime
	"Answer the desired time between steps in milliseconds."

	^ 1000! !

!ClockMorph methodsFor: '24hr' stamp: 'fc 2/8/2004 11:39'!
toggleShowing24hr
	show24hr := (show24hr == true) not
! !

!ClockMorph methodsFor: 'seconds' stamp: 'sw 2/17/1999 14:53'!
toggleShowingSeconds
	showSeconds := (showSeconds == true) not
! !

StringMorph subclass: #FrameRateMorph
	instanceVariableNames: 'lastDisplayTime framesSinceLastDisplay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!FrameRateMorph classSide methodsFor: 'scripting' stamp: 'sw 6/13/2001 00:57'!
authoringPrototype
	"Answer a morph representing a prototypical instance of the receiver"

	| aMorph |
	aMorph := self new.
	aMorph color: Color blue.
	aMorph step.
	^ aMorph! !

!FrameRateMorph classSide methodsFor: 'parts bin' stamp: 'sw 8/2/2001 12:49'!
descriptionForPartsBin
	^ self partName:	'FrameRate'
		categories:		#('Useful')
		documentation:	'A readout that allows you to monitor the frame rate of your system'! !

!FrameRateMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/10/2003 13:05'!
initialize

	self registerInFlapsRegistry.	! !

!FrameRateMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/10/2003 13:06'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(FrameRateMorph		authoringPrototype		'Frame Rate'		'An indicator of how fast your system is running')
						forFlapNamed: 'Widgets']! !

!FrameRateMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 12:36'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

!FrameRateMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 20:42'!
initialize
"initialize the state of the receiver"
	super initialize.
""
	lastDisplayTime := 0.
	framesSinceLastDisplay := 0! !

!FrameRateMorph methodsFor: 'parts bin' stamp: 'sw 7/19/2001 13:39'!
initializeToStandAlone
	"Initialize the receiver as a stand-alone entity"

	super initializeToStandAlone.
	self color: Color blue.
	self step! !

!FrameRateMorph methodsFor: 'stepping and presenter' stamp: 'sw 10/5/2000 06:52'!
step
	"Compute and display (every half second or so) the current framerate"

	| now mSecs mSecsPerFrame framesPerSec newContents |
	framesSinceLastDisplay := framesSinceLastDisplay + 1.
	now := Time millisecondClockValue.
	mSecs := now - lastDisplayTime.
	(mSecs > 500 or: [mSecs < 0 "clock wrap-around"]) ifTrue: 
		[mSecsPerFrame := mSecs // framesSinceLastDisplay.
		framesPerSec := (framesSinceLastDisplay * 1000) // mSecs.
		newContents := mSecsPerFrame printString, ' mSecs (', framesPerSec printString, ' frame', (framesPerSec == 1 ifTrue: [''] ifFalse: ['s']), '/sec)'.
		self contents: newContents.
		lastDisplayTime := now.
		framesSinceLastDisplay := 0]! !

!FrameRateMorph methodsFor: 'testing' stamp: 'jm 2/23/98 18:41'!
stepTime
	"Answer the desired time between steps in milliseconds."

	^ 0
! !

StringMorph subclass: #InfoStringMorph
	instanceVariableNames: 'stepTime block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!InfoStringMorph commentStamp: '<historical>' prior: 0!
A generalization of the clock morph

Try
	InfoStringMorph new openInWorld
or
	(InfoStringMorph on: [Smalltalk vmParameterAt: 9])
		stepTime: 50;
		openInWorld!

!InfoStringMorph classSide methodsFor: 'instance creation' stamp: 'sma 6/1/2000 14:07'!
on: aBlock
	^ self new block: aBlock! !

!InfoStringMorph methodsFor: 'accessing' stamp: 'sma 6/1/2000 14:06'!
block
	^ block! !

!InfoStringMorph methodsFor: 'accessing' stamp: 'sma 6/1/2000 14:05'!
block: aBlock
	block := aBlock! !

!InfoStringMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 20:42'!
initialize
"initialize the state of the receiver"
	super initialize.
""
	stepTime := 1000.
	block := [Time now]! !

!InfoStringMorph methodsFor: 'stepping and presenter' stamp: 'sma 6/1/2000 14:03'!
step
	self contents: block value asString! !

!InfoStringMorph methodsFor: 'testing' stamp: 'sma 6/1/2000 14:03'!
stepTime
	^ stepTime! !

!InfoStringMorph methodsFor: 'accessing' stamp: 'sma 6/1/2000 14:06'!
stepTime: anInteger
	stepTime := anInteger! !

!StringMorph methodsFor: '*MorphicExtras-printing' stamp: ''!
fullPrintOn: aStream

	aStream nextPutAll: '('.
	super fullPrintOn: aStream.
	aStream nextPutAll: ') contents: '; print: contents! !

!StringMorph methodsFor: '*MorphicExtras-accessing' stamp: 'sw 2/18/2003 02:55'!
getCharacters
	"obtain a string value from the receiver."

	^ self contents! !

!StringMorph methodsFor: '*MorphicExtras-accessing' stamp: 'sw 9/9/1999 18:09'!
handsWithMeForKeyboardFocus
	| foc |
	"Answer the hands that have me as their keyboard focus"

	hasFocus ifFalse: [^ #()].
	^ self currentWorld hands select:
		[:aHand | (foc := aHand keyboardFocus) notNil and: [foc owner == self]]! !

StringMorph subclass: #ZASMStepsMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!ZASMStepsMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/3/2000 11:24'!
getStepCount

	^[self contents asNumber] ifError: [ :a :b | 10]
	
! !

!ZASMStepsMorph methodsFor: 'event handling' stamp: 'RAA 12/3/2000 11:29'!
handlesMouseDown: evt

	^ true! !

!ZASMStepsMorph methodsFor: 'event handling' stamp: 'RAA 12/3/2000 11:28'!
mouseDown: evt
	"If the shift key is pressed, make this string the keyboard input focus."

	self launchMiniEditor: evt
! !

!ZASMStepsMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/3/2000 11:24'!
setStepCount: n

	self contents: n printString.

! !

!IconicButton methodsFor: '*MorphicExtras-initialization' stamp: 'nk 9/1/2004 17:14'!
initializeToShow: aMorph withLabel: aLabel andSend: aSelector to: aReceiver 	
	"Initialize the receiver to show the current appearance of aMorph on its face, giving it the label supplied and arranging for it, when the button goes down on it, to obtain a new morph by sending the specified selector to the specified receiver"

	| aThumbnail |
	aThumbnail := Thumbnail new.
	aThumbnail makeThumbnailFromForm: (aMorph imageFormDepth: 32).
	^ self initializeWithThumbnail: aThumbnail withLabel: aLabel andColor: self color andSend: aSelector to: aReceiver 	! !

HandMorph subclass: #HandMorphForReplay
	instanceVariableNames: 'recorder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-AdditionalSupport'!

!HandMorphForReplay commentStamp: '<historical>' prior: 0!
I am a hand for replaying events stored in an EventRecorderMorph.  When there are no more events, I delete myself.!

!HandMorphForReplay methodsFor: 'initialization' stamp: 'ar 10/25/2000 20:58'!
initialize
	super initialize.
	self showTemporaryCursor: Cursor normal.
! !

!HandMorphForReplay methodsFor: 'drawing' stamp: 'RAA 12/12/2000 14:45'!
needsToBeDrawn

	^true! !

!HandMorphForReplay methodsFor: 'event handling' stamp: 'di 3/4/1999 14:57'!
pauseEventRecorderIn: aWorld
	"Suspend my recorder prior to a project change, and return it.
	It will be resumed after starting the new project."

	^ recorder pauseIn: aWorld! !

!HandMorphForReplay methodsFor: 'event handling' stamp: 'dgd 2/22/2003 13:25'!
processEvents
	"Play back the next event"

	| evt hadMouse hadAny |
	hadMouse := hadAny := false.
	[(evt := recorder nextEventToPlay) isNil] whileFalse: 
			[evt type == #EOF 
				ifTrue: 
					[recorder pauseIn: self world.
					^self].
			evt type == #startSound 
				ifTrue: 
					[evt argument play.
					recorder synchronize.
					^self].
			evt isMouse ifTrue: [hadMouse := true].
			(evt isMouse or: [evt isKeyboard]) 
				ifTrue: 
					[self handleEvent: (evt setHand: self) resetHandlerFields.
					hadAny := true]].
	(mouseClickState notNil and: [hadMouse not]) 
		ifTrue: 
			["No mouse events during this cycle. Make sure click states time out accordingly"

			mouseClickState handleEvent: lastMouseEvent asMouseMove from: self].
	hadAny 
		ifFalse: 
			["No pending events. Make sure z-order is up to date"

			self mouseOverHandler processMouseOver: lastMouseEvent]! !

!HandMorphForReplay methodsFor: 'initialization' stamp: 'di 3/3/1999 14:54'!
recorder: anEventRecorder
	recorder := anEventRecorder! !

!HandMorphForReplay methodsFor: 'cursor' stamp: 'di 3/7/1999 00:00'!
showTemporaryCursor: cursorOrNil hotSpotOffset: hotSpotOffset
	"When I show my cursor, it appears double size,
	unless it is a form such as a paint brush."

	cursorOrNil
	ifNil: ["Setting cursor to nil cannot revert to hardware cursor -- just show normal."
			^ self showTemporaryCursor: Cursor normal hotSpotOffset: Cursor normal offset]
	ifNotNil:
		[(cursorOrNil isKindOf: Cursor)
			ifTrue: ["Show cursors magnified for visibility"
					^ super showTemporaryCursor:
									(CursorWithMask derivedFrom: (cursorOrNil magnifyBy: 2))
				 				hotSpotOffset: (cursorOrNil offset negated*2) + hotSpotOffset]
			ifFalse: [^ super showTemporaryCursor: cursorOrNil
				 				hotSpotOffset: hotSpotOffset]]! !

!HandMorphForReplay methodsFor: 'copying' stamp: 'LC 12/23/1998 13:26'!
veryDeepCopyWith: deepCopier
	^ self copy! !

!AlignmentMorph class methodsFor: '*MorphicExtras-parts bin' stamp: 'sw 11/16/2001 09:16'!
supplementaryPartsDescriptions
	"Extra items for parts bins"

	^ {DescriptionForPartsBin
		formalName: 'Column'
		categoryList: #('Presentation')
		documentation: 'An object that presents the things within it in a column'
		globalReceiverSymbol: #AlignmentMorph
		nativitySelector: #columnPrototype.
	DescriptionForPartsBin
		formalName: 'Row'
		categoryList: #('Presentation')
		documentation: 'An object that presents the things within it in a row'
		globalReceiverSymbol: #AlignmentMorph
		nativitySelector: #rowPrototype}! !

!AlignmentMorph methodsFor: '*MorphicExtras-initialization' stamp: 'dgd 2/14/2003 22:02'!
basicInitialize
	"Do basic generic initialization of the instance variables"
	super basicInitialize.
	""
	self layoutPolicy: TableLayout new;
	  listDirection: #leftToRight;
	  wrapCentering: #topLeft;
	  hResizing: #spaceFill;
	  vResizing: #spaceFill;
	  layoutInset: 2;
	  rubberBandCells: true! !

AlignmentMorph subclass: #AlignmentMorphBob1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-AdditionalSupport'!

!AlignmentMorphBob1 commentStamp: '<historical>' prior: 0!
A quick and easy to space things vertically in absolute or proportional amounts.!

!AlignmentMorphBob1 methodsFor: 'as yet unclassified' stamp: 'RAA 3/10/2001 13:54'!
acceptDroppingMorph: aMorph event: evt

	| handlerForDrops |

	handlerForDrops := self valueOfProperty: #handlerForDrops ifAbsent: [
		^super acceptDroppingMorph: aMorph event: evt
	].
	(handlerForDrops acceptDroppingMorph: aMorph event: evt in: self) ifFalse: [
		aMorph rejectDropMorphEvent: evt.		"send it back where it came from"
	].! !

!AlignmentMorphBob1 methodsFor: 'as yet unclassified' stamp: 'RAA 7/23/2000 16:42'!
addAColumn: aCollectionOfMorphs

	| col |
	col := self inAColumn: aCollectionOfMorphs.
	self addMorphBack: col.
	^col! !

!AlignmentMorphBob1 methodsFor: 'as yet unclassified' stamp: 'RAA 7/23/2000 16:42'!
addARow: aCollectionOfMorphs

	| row |
	row := self inARow: aCollectionOfMorphs.
	self addMorphBack: row.
	^row! !

!AlignmentMorphBob1 methodsFor: 'as yet unclassified' stamp: 'ar 11/9/2000 21:09'!
addARowCentered: aCollectionOfMorphs

	^(self addARow: aCollectionOfMorphs)
		hResizing: #shrinkWrap;
		wrapCentering: #center;
		cellPositioning: #leftCenter! !

!AlignmentMorphBob1 methodsFor: 'as yet unclassified' stamp: 'dgd 11/7/2004 19:52'!
addARowCentered: aCollectionOfMorphs cellInset: cellInsetInteger

	^(self addARow: aCollectionOfMorphs)
		hResizing: #shrinkWrap;
		wrapCentering: #center;
		cellPositioning: #leftCenter;
		cellInset: cellInsetInteger! !

!AlignmentMorphBob1 methodsFor: 'as yet unclassified' stamp: 'dgd 11/3/2004 19:28'!
fancyText: aString font: aFont color: aColor 
	| answer tm col |
	col := ColorTheme current dialog3DTitles
				ifTrue: [aColor]
				ifFalse: [aColor negated].
	tm := TextMorph new.
	tm beAllFont: aFont;
		 color: col;
		 contents: aString.
	answer := self inAColumn: {tm}.
	ColorTheme current dialog3DTitles
		ifTrue: [""
			tm addDropShadow.
			tm shadowPoint: 5 @ 5 + tm bounds center].
	tm lock.
	^ answer! !

!AlignmentMorphBob1 methodsFor: 'as yet unclassified' stamp: 'ar 12/30/2001 19:14'!
fullDrawOn: aCanvas

	| mask |
	(aCanvas isVisible: self fullBounds) ifFalse:[^self].
	super fullDrawOn: aCanvas.
	mask := self valueOfProperty: #disabledMaskColor ifAbsent: [^self].
	aCanvas fillRectangle: bounds color: mask.
! !

!AlignmentMorphBob1 methodsFor: 'as yet unclassified' stamp: 'ar 11/9/2000 21:10'!
inAColumn: aCollectionOfMorphs

	| col |
	col := AlignmentMorph newColumn
		color: Color transparent;
		vResizing: #shrinkWrap;
		layoutInset: 1;
		wrapCentering: #center;
		cellPositioning: #topCenter.
	aCollectionOfMorphs do: [ :each | col addMorphBack: each].
	^col! !

!AlignmentMorphBob1 methodsFor: 'as yet unclassified' stamp: 'dgd 11/2/2004 21:54'!
inARightColumn: aCollectionOfMorphs 
	| col |
	col := AlignmentMorph newColumn color: Color transparent;
				 vResizing: #shrinkWrap;
				 layoutInset: 1;
				 wrapCentering: #bottomRight;
				 cellPositioning: #topCenter.
	aCollectionOfMorphs
		do: [:each | col addMorphBack: each].
	^ col! !

!AlignmentMorphBob1 methodsFor: 'as yet unclassified' stamp: 'dgd 4/4/2006 16:16'!
inARow: aCollectionOfMorphs 
	| row |
	row := AlignmentMorph newRow color: Color transparent;
				 vResizing: #shrinkWrap;
				 layoutInset: 2;
				 wrapCentering: #center;
				 cellPositioning: #leftCenter.
	aCollectionOfMorphs
		do: [:each | row addMorphBack: each].
	^ row! !

!AlignmentMorphBob1 methodsFor: 'initialization' stamp: 'dgd 4/4/2006 16:17'!
initialize
	super initialize.
	self listDirection: #topToBottom.
	self layoutInset: 0.
	self hResizing: #rigid. "... this is very unlikely..."
	self vResizing: #rigid! !

!AlignmentMorphBob1 methodsFor: 'as yet unclassified' stamp: 'RAA 3/14/2001 08:36'!
wantsDroppedMorph: aMorph event: evt

	| handlerForDrops |

	handlerForDrops := self valueOfProperty: #handlerForDrops ifAbsent: [
		^super wantsDroppedMorph: aMorph event: evt
	].
	^handlerForDrops wantsDroppedMorph: aMorph event: evt in: self! !

AlignmentMorphBob1 subclass: #ProjectNavigationMorph
	instanceVariableNames: 'mouseInside soundSlider'
	classVariableNames: 'LastManualPlacement'
	poolDictionaries: ''
	category: 'MorphicExtras-Navigators'!

!ProjectNavigationMorph classSide methodsFor: 'as yet unclassified' stamp: 'mir 8/22/2001 18:09'!
preferredNavigator

	"Preferences eToyFriendly ifTrue: [^KidNavigationMorph]."
	^ProjectNavigationMorph! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/9/2001 08:19'!
addButtons

	self orientedVertically ifTrue: [
		self addAColumn: (
			self makeTheButtons collect: [ :x | self inAColumn: {x}]
		)
	] ifFalse: [
		self addARow: (
			self makeTheButtons collect: [ :x | self inAColumn: {x}]
		)
	].
! !

!ProjectNavigationMorph methodsFor: 'menus' stamp: 'RAA 1/9/2001 08:15'!
addCustomMenuItems: aMenu hand: aHandMorph

	"Add further items to the menu as appropriate"

	super addCustomMenuItems: aMenu hand: aHandMorph.
	aMenu 
		addUpdating: #orientationString 
		action: #toggleOrientation.
! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/27/2000 17:54'!
amountToShowWhenSmall

	^7	"if no part of the buttons is visible, we chew up fewer cycles"! !

!ProjectNavigationMorph methodsFor: 'the buttons' stamp: 'yo 2/10/2005 15:37'!
buttonFind
	"Answer a button for finding/loading projects"

	^ self makeButton: 'FIND' balloonText: 'Click here to find a project.  Hold down this button to reveal additional options.' translated for: #findAProjectSimple
! !

!ProjectNavigationMorph methodsFor: 'the buttons' stamp: 'RAA 9/19/2000 13:42'!
buttonFlaps

	^self inFlapsSuppressedMode ifTrue: [
		self makeButton: 'Show tabs' balloonText: 'Show tabs' for: #toggleFlapsSuppressed
	] ifFalse: [
		self makeButton: 'Hide tabs' balloonText: 'Hide tabs' for: #toggleFlapsSuppressed
	].

! !

!ProjectNavigationMorph methodsFor: 'the buttons' stamp: 'alain.plantec 6/19/2008 11:16'!
buttonFullScreen
	^ self inFullScreenMode
		ifTrue: [self
				makeButton: 'Browser Reentry'
				balloonText: 'Re-enter the browser'
				for: #fullScreenOff]
		ifFalse: [self
				makeButton: 'Escape Browser'
				balloonText: 'Use the full screen'
				for: #fullScreenOn]! !

!ProjectNavigationMorph methodsFor: 'the buttons' stamp: 'dgd 4/3/2006 13:12'!
buttonLanguage
	"Answer a button for finding/loading projects"
	^ SimpleButtonDelayedMenuMorph new target: self;
		 borderColor: #raised;
		 color: self colorForButtons;
		 label: Project current naturalLanguage font: self fontForButtons;
		 setBalloonText: 'Click here to choose your language.' translated;
		 actionSelector: #chooseLanguage! !

!ProjectNavigationMorph methodsFor: 'the buttons' stamp: 'RAA 7/16/2001 14:06'!
buttonNewProject

	^self makeButton: 'NEW' balloonText: 'Start a new project' for: #newProject
! !

!ProjectNavigationMorph methodsFor: 'the buttons' stamp: 'RAA 9/19/2000 13:37'!
buttonNewer

	^self makeButton: 'Newer?' balloonText: 'Is there a newer version of this project ?' for: #getNewerVersionIfAvailable! !

!ProjectNavigationMorph methodsFor: 'the buttons' stamp: 'RAA 9/19/2000 14:04'!
buttonNext

	^self makeButton: 'NEXT >' balloonText: 'Next project' for: #nextProject! !

!ProjectNavigationMorph methodsFor: 'the buttons' stamp: 'RAA 11/8/2000 09:53'!
buttonPaint

	| pb oldArgs brush myButton m |

	myButton := self makeButton: '' balloonText: 'Make a painting' for: #doNewPainting.
	pb := PaintBoxMorph new submorphNamed: #paint:.
	pb ifNil: [
		(brush := Form extent: 16@16 depth: 16) fillColor: Color red
	] ifNotNil: [
		oldArgs := pb arguments.
		brush := oldArgs third.
		brush := brush copy: (2@0 extent: 42@38).
		brush := brush scaledToSize: brush extent // 2.
	].
	myButton addMorph: (m := brush asMorph lock).
	myButton extent: m extent + (myButton borderWidth + 6).
	m position: myButton center - (m extent // 2).

	^myButton

"brush := (ScriptingSystem formAtKey: 'Painting')."

! !

!ProjectNavigationMorph methodsFor: 'the buttons' stamp: 'RAA 9/19/2000 14:04'!
buttonPrev

	^self makeButton: '< PREV' balloonText: 'Previous project' for: #previousProject! !

!ProjectNavigationMorph methodsFor: 'the buttons' stamp: 'yo 2/10/2005 15:42'!
buttonPublish
	"Answer a button for publishing the project"

	^ self makeButton: 'PUBLISH IT!!' translated balloonText: 'Click here to save a project.  Hold down this button to reveal additional publishing options' translated for: #publishProject! !

!ProjectNavigationMorph methodsFor: 'the buttons' stamp: 'RAA 9/19/2000 14:03'!
buttonQuit

	^self makeButton: 'QUIT' balloonText: 'Quit Squeak altogether' for: #quitSqueak
! !

!ProjectNavigationMorph methodsFor: 'the buttons' stamp: 'sw 1/31/2006 03:54'!
buttonUndo
	"Build and return a fresh Undo button for me."

	^ self makeUpdatingButtonWithBalloonText:  'Undo or redo the last undoable action' actionSelector: #undoOrRedoLastCommand wordingSelector: #undoButtonWording

! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'marcus.denker 9/25/2008 23:16'!
checkForRebuild
	| lastScreenMode flapsSuppressed |

	lastScreenMode := ScreenController isFullScreen.
	flapsSuppressed := Project current flapsSuppressed.
	((self valueOfProperty: #currentNavigatorVersion) = self currentNavigatorVersion
			and: [lastScreenMode = self inFullScreenMode
			and: [flapsSuppressed = self inFlapsSuppressedMode
			and: [(self valueOfProperty: #includeSoundControlInNavigator) = 
						Preferences includeSoundControlInNavigator]]]) ifFalse: [
		self 
			setProperty: #includeSoundControlInNavigator 
			toValue: Preferences includeSoundControlInNavigator.
		self setProperty: #flapsSuppressedMode toValue: flapsSuppressed.
		self setProperty: #showingFullScreenMode toValue: lastScreenMode.
		self setProperty: #currentNavigatorVersion toValue: self currentNavigatorVersion.
		self removeAllMorphs.
		self addButtons.
	].
! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'mir 1/2/2004 13:54'!
chooseLanguage

	Project current chooseNaturalLanguage! !

!ProjectNavigationMorph methodsFor: 'accessing' stamp: 'RAA 7/5/2000 16:24'!
color: newColor

	| buttonColor |

	super color: newColor.
	buttonColor := color darker.
	self submorphsDo: [:m | m submorphsDo: [:n | n color: buttonColor]]! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/26/2000 18:51'!
colorForButtons

	^color darker! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'sw 1/31/2006 03:09'!
currentNavigatorVersion
	"Answer the current navigator version."

	^ 31		"since these guys get saved, we fix them up if they are older versions"! !

!ProjectNavigationMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:30'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color orange! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'marcus.denker 8/18/2008 21:25'!
doFindButtonMenuEvent: evt

	| menu selection |

	menu := CustomMenu new.
	menu 
		add: 'find a project' translated action: [self findAProjectSimple];
		add: 'find a project (more places)' translated action: [self findAProject];
		add: 'find any file' translated action: [self findAnything].

	selection := menu build startUpCenteredWithCaption: 'Find options' translated.
	selection ifNil: [^self].
	selection value.

! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'yo 2/17/2005 15:40'!
doNewPainting
	
	| w f |

	w := self world.
	w assureNotPaintingElse: [^ self].
	(f := self owner flapTab) ifNotNil: [f hideFlap].
	w makeNewDrawing: (self primaryHand lastEvent copy setPosition: w center)
! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'marcus.denker 8/18/2008 21:28'!
doPublishButtonMenuEvent: evt

	| menu selection |

	menu := CustomMenu new.
	menu 
		add: 'Publish' translated action: [self publishProject];
		add: 'Publish As...' translated action: [self publishProjectAs];
		add: 'Publish to Different Server' translated action: [self publishDifferent].
	selection := menu build startUpCenteredWithCaption: 'Publish options' translated.
	selection ifNil: [^self].
	selection value.

! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'RAA 2/17/2001 12:27'!
findAProject

	FileList2 
		morphicViewProjectLoader2InWorld: self world 
		reallyLoad: true
		dirFilterType: #initialDirectoryList! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'RAA 2/17/2001 12:27'!
findAProjectSimple

	FileList2 
		morphicViewProjectLoader2InWorld: self world 
		reallyLoad: true
		dirFilterType: #limitedSuperSwikiDirectoryList! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'RAA 7/24/2000 19:32'!
findAnything

	FileList2 morphicViewGeneralLoaderInWorld: self world! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/26/2000 18:52'!
fontForButtons

	^TextStyle defaultFont! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'alain.plantec 6/19/2008 11:17'!
fullScreenOff

	self setProperty: #showingFullScreenMode toValue: false.
	ScreenController fullScreenOff.
	self removeProperty: #currentNavigatorVersion.
	mouseInside := false.
! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'RAA 8/30/2000 15:32'!
fullScreenOn

	self setProperty: #showingFullScreenMode toValue: true.
	ScreenController new fullScreenOn.
	self removeProperty: #currentNavigatorVersion.
	mouseInside := false.
! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'nb 6/17/2003 12:25'!
getNewerVersionIfAvailable

	(self world ifNil: [^Beeper beep]) project loadFromServer: true.

! !

!ProjectNavigationMorph methodsFor: 'event handling' stamp: 'RAA 6/29/2000 11:11'!
handlesMouseOver: evt

	^true! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 7/16/2000 08:26'!
inFlapsSuppressedMode

	^(self valueOfProperty: #flapsSuppressedMode) == true! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 7/15/2000 00:03'!
inFullScreenMode

	^(self valueOfProperty: #showingFullScreenMode) == true! !

!ProjectNavigationMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:30'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self layoutInset: 6;
	  hResizing: #shrinkWrap;
	  vResizing: #shrinkWrap;
	  useRoundedCorners.
	mouseInside := false.
	self addButtons! !

!ProjectNavigationMorph methodsFor: 'dropping/grabbing' stamp: 'RAA 1/9/2001 07:47'!
justDroppedInto: aMorph event: anEvent

	self setProperty: #stickToTop toValue: nil.
	self positionVertically.
	LastManualPlacement := {self position. self valueOfProperty: #stickToTop}.
	super justDroppedInto: aMorph event: anEvent.
	self step! !

!ProjectNavigationMorph methodsFor: 'the buttons' stamp: 'bf 10/8/2004 12:47'!
languageIcon
	^ (ColorForm
	extent: 19@18
	depth: 4
	fromArray: #( 4294967295 4294967295 4293918720 4294967206 2183331839 4293918720 4294946286 3972145919 4293918720 4294631150 3430031919 4293918720 4289588973 3396477476 4293918720 4292799965 3399692836 4293918720 4208913868 724784466 804257792 4141735107 858993445 804257792 4140616899 1127429205 804257792 4174171340 3006481493 804257792 4174171340 3274982741 804257792 4170435788 3409204562 804257792 4280497100 1429493074 4293918720 4280431429 1429558562 4293918720 4294059093 1431654959 4293918720 4294919237 1431446271 4293918720 4294967074 572719103 4293918720 4294967295 4294967295 4293918720)
	offset: 0@0)
	colorsFromArray: #(#(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.376 0.376 0.784) #(0.357 0.357 0.733) #(0.231 0.231 0.474) #(0.494 0.494 0.964) #(0.498 0.498 0.933) #(0.376 0.376 0.706) #(0.419 0.419 0.78) #(0.415 0.415 0.776) #(0.595 0.595 0.972) #(0.638 0.638 0.968) #(0.654 0.654 0.96) #(0.686 0.686 0.96) #(0.71 0.71 0.964) #( )  )! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'yo 7/2/2004 20:01'!
makeButton: aString balloonText: anotherString for: aSymbol

	self flag: #yo.
	"In principle, this method shouldn't call #translated."

	^ SimpleButtonDelayedMenuMorph new target: self;
		 borderColor: #raised;
		 color: self colorForButtons;
		 label: aString translated font: self fontForButtons;
		 setBalloonText: anotherString translated;
		 actionSelector: aSymbol! !

!ProjectNavigationMorph methodsFor: 'buttons' stamp: 'al 7/22/2008 20:56'!
makeTheAdvancedButtons

	^{
		self buttonNewProject.
		self buttonShare.
		self buttonPrev.
		self buttonNext.
		self buttonPublish.
		self buttonNewer.
		self buttonFind.
		self buttonFullScreen.
		"self buttonFlaps."
		self buttonPaint.
	},
	(
		Preferences includeSoundControlInNavigator ifTrue: [{self buttonSound}] ifFalse: [#()]
	),
	{
		self buttonLanguage.
		self buttonUndo.
		self buttonQuit.
	}
! !

!ProjectNavigationMorph methodsFor: 'buttons' stamp: 'tak 3/15/2005 01:40'!
makeTheButtons
	^ Preferences showAdvancedNavigatorButtons
		ifTrue: [self makeTheAdvancedButtons]
		ifFalse: [self makeTheSimpleButtons]! !

!ProjectNavigationMorph methodsFor: 'buttons' stamp: 'ar 7/28/2005 10:51'!
makeTheSimpleButtons

	^{
		self buttonNewProject.

		self buttonPrev.
		self buttonNext.
		self buttonPublish.
		self buttonFind.
		self buttonFullScreen.

		self buttonPaint.
	},
	(
		Preferences includeSoundControlInNavigator ifTrue: [{self buttonSound}] ifFalse: [#()]
	),
	{
		self buttonLanguage.
		self buttonUndo.
		self buttonQuit.
	}
! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'sw 1/31/2006 02:32'!
makeUpdatingButtonWithBalloonText: balloonString actionSelector: actionSymbol wordingSelector: wordingSymbol
	"Answer a button  whose target is the receiver (i.e. a ProjectNavigationMorph), who gets its wording by sending the wordingSelector to me.  The given string"

	| aButton |
	aButton := UpdatingSimpleButtonMorph new.
	aButton
		target: self;
		borderColor: #raised;
		color: self colorForButtons;
		label: '-' font: self fontForButtons;
		setBalloonText: balloonString translated;
		actionSelector: actionSymbol;
		wordingSelector: wordingSymbol.
	aButton step.
	^ aButton
	
	! !

!ProjectNavigationMorph methodsFor: 'WiW support' stamp: 'RAA 10/3/2000 09:24'!
morphicLayerNumber

	"helpful for insuring some morphs always appear in front of or behind others.
	smaller numbers are in front"

	^mouseInside == true ifTrue: [26] ifFalse: [25]

		"Navigators are behind menus and balloons, but in front of most other stuff"! !

!ProjectNavigationMorph methodsFor: 'event handling' stamp: 'RAA 6/30/2000 13:57'!
mouseEnter: evt

	(self worldBounds containsPoint: evt cursorPoint) ifFalse: [^self].
	mouseInside := true.
	self positionVertically.
	! !

!ProjectNavigationMorph methodsFor: 'event handling' stamp: 'RAA 9/1/2000 07:51'!
mouseLeave: evt

	self world ifNil: [^self].		"can happen after delete from control menu"
	(self worldBounds containsPoint: evt cursorPoint) ifFalse: [^self].
	mouseInside := false.
	self positionVertically.
! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'RAA 10/6/2000 13:55'!
newProject

	Project newMorphicOn: nil
! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'nb 6/17/2003 12:25'!
nextProject

	Project advanceToNextProject.
	Beeper beep.! !

!ProjectNavigationMorph methodsFor: 'initialization' stamp: 'RAA 9/15/2000 21:43'!
openInWorld: aWorld

	LastManualPlacement ifNotNil: [
		self position: LastManualPlacement first.
		self setProperty: #stickToTop toValue: LastManualPlacement second.
	].
	super openInWorld: aWorld.! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'dgd 8/30/2003 21:59'!
orientationString
	^ (self orientedVertically
		ifTrue: ['<yes>']
		ifFalse: ['<no>'])
		, 'vertical orientation' translated! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/9/2001 08:18'!
orientedVertically

	^self valueOfProperty: #orientedVertically ifAbsent: [false]
! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/9/2001 08:26'!
positionVertically

	| wb stickToTop |

	owner == self world ifFalse: [^self].
	wb := self worldBounds.
	stickToTop := self valueOfProperty: #stickToTop.
	stickToTop ifNil: [
		stickToTop := (self top - wb top) abs < (self bottom - wb bottom) abs.
		self setProperty: #stickToTop toValue: stickToTop.
	].
	mouseInside == true ifTrue: [
		stickToTop ifTrue: [
			self top: wb top
		] ifFalse: [
			self bottom: wb bottom
		].
	] ifFalse: [
		stickToTop ifTrue: [
			self bottom: wb top + self amountToShowWhenSmall
		] ifFalse: [
			self top: wb bottom - self amountToShowWhenSmall
		].
	].

! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'dao 10/1/2004 13:14'!
previousProject

	Project returnToPreviousProject.
	Project current exit.	"go to parent if no previous"
	Beeper beep.! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'RAA 5/16/2001 17:44'!
publishDifferent

	self 
		publishStyle: #initialDirectoryList 
		forgetURL: true
		withRename: false
! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'yo 2/17/2005 14:55'!
publishProject

	self world paintBoxOrNil ifNotNil: [
		(self confirm: 'You seem to be painting a sketch.
Do you continue and publish the project with the paint tool?' translated) ifFalse: [^ self].
	].
	self 
		publishStyle: #limitedSuperSwikiPublishDirectoryList 
		forgetURL: false
		withRename: false! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'mir 6/25/2001 16:53'!
publishProjectAs

	self 
		publishStyle: #limitedSuperSwikiPublishDirectoryList 
		forgetURL: false
		withRename: true! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'mir 11/15/2004 10:25'!
publishStyle: aSymbol forgetURL: aBoolean withRename: renameBoolean

	| w saveOwner primaryServer rename |

	w := self world ifNil: [^Beeper beep].
	w setProperty: #SuperSwikiPublishOptions toValue: aSymbol.

	primaryServer := w project primaryServerIfNil: [nil].
	rename := ((primaryServer notNil
		and: [primaryServer acceptsUploads]) not)
		or: [renameBoolean].
	w setProperty: #SuperSwikiRename toValue: rename.

	saveOwner := owner.
	self delete.
	[w project 
		storeOnServerShowProgressOn: self 
		forgetURL: aBoolean | rename]
		ensure: [saveOwner addMorphFront: self]! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'sw 3/3/2004 14:19'!
quitSqueak
	"Obtain a confirmation from the user, and if the answer is true, quite Squeak summarily"

	(self confirm: 'Are you sure you want to Quit Squeak?' translated) ifFalse: [^ self].
	
	SmalltalkImage current snapshot: false andQuit: true
! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 2/6/2001 14:16'!
retractIfAppropriate

	mouseInside := false.
	self positionVertically.
! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 2/17/2001 12:44'!
showMenuFor: aSymbol event: evt

	(aSymbol == #publishProject or: [aSymbol == #publishProjectSimple]) ifTrue: [
		self doPublishButtonMenuEvent: evt.
		^true		"we did show the menu"
	].
	(aSymbol == #findAProject or: [aSymbol == #findAProjectSimple]) ifTrue: [
		self doFindButtonMenuEvent: evt.
		^true		"we did show the menu"
	].
	^false
! !

!ProjectNavigationMorph methodsFor: 'stepping and presenter' stamp: 'RAA 8/23/2001 18:11'!
step
	| wb |

	owner ifNil: [^ self].
	(self ownerThatIsA: HandMorph) ifNotNil: [^self].
	self checkForRebuild.
	owner == self world ifTrue: [
		owner addMorphInLayer: self.
		wb := self worldBounds.
		self left < wb left ifTrue: [self left: wb left].
		self right > wb right ifTrue: [self right: wb right].
		self positionVertically.
	].! !

!ProjectNavigationMorph methodsFor: 'testing' stamp: 'RAA 5/18/2000 11:43'!
stepTime

	^1000! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'dao 10/1/2004 13:45'!
toggleFlapsSuppressed

	Project current toggleFlapsSuppressed! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/9/2001 08:18'!
toggleOrientation

	self setProperty: #orientedVertically toValue: self orientedVertically not.
	self setProperty: #currentNavigatorVersion toValue: self currentNavigatorVersion - 1.

! !

!ProjectNavigationMorph methodsFor: 'stepping and presenter' stamp: 'sw 1/31/2006 04:06'!
undoButtonWording
	"Answer the wording for the Undo button."

	| wdng |
	wdng := ActiveWorld commandHistory undoOrRedoMenuWording.
	(wdng endsWith: ' (z)') ifTrue:
		[wdng := wdng copyFrom: 1to: wdng size - 4].
	^ wdng! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'RAA 2/19/2001 09:52'!
undoLastCommand
	
	self world commandHistory undoLastCommand! !

!ProjectNavigationMorph methodsFor: 'the actions' stamp: 'sw 1/31/2006 03:55'!
undoOrRedoLastCommand
	"Undo or redo the last command, as approrpiate."

	ActiveWorld commandHistory undoOrRedoCommand! !

!ProjectNavigationMorph methodsFor: 'testing' stamp: 'RAA 5/18/2000 11:43'!
wantsSteps

	^true! !

AlignmentMorphBob1 subclass: #ThreadNavigationMorph
	instanceVariableNames: 'listOfPages currentIndex loadedProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Navigators'!

ThreadNavigationMorph subclass: #InternalThreadNavigationMorph
	instanceVariableNames: 'threadName preferredIndex'
	classVariableNames: 'CachedThumbnails KnownThreads'
	poolDictionaries: ''
	category: 'MorphicExtras-Navigators'!

!InternalThreadNavigationMorph classSide methodsFor: 'thumbnails' stamp: 'RAA 5/10/2001 17:06'!
cacheThumbnailFor: aProject

	| form |

	CachedThumbnails ifNil: [CachedThumbnails := Dictionary new].
	CachedThumbnails
		at: aProject name
		put: (form := self sorterFormForProject: aProject sized: nil).
	^form
	! !

!InternalThreadNavigationMorph classSide methodsFor: 'known threads' stamp: 'tetha 4/18/2005 01:38'!
clearKnownThreads

	KnownThreads := nil! !

!InternalThreadNavigationMorph classSide methodsFor: 'thumbnails' stamp: 'RAA 5/10/2001 17:09'!
clearThumbnailCache

	CachedThumbnails := nil! !

!InternalThreadNavigationMorph classSide methodsFor: 'parts bin' stamp: 'sw 8/19/2001 21:15'!
descriptionForPartsBin
	^ self partName: 	'ThreadNavigator'
		categories:		#('Navigation')
		documentation:	'A tool that lets you navigate through a thread of projects.'! !

!InternalThreadNavigationMorph classSide methodsFor: 'thumbnails' stamp: 'RAA 5/10/2001 17:07'!
getThumbnailFor: aProject

	CachedThumbnails ifNil: [CachedThumbnails := Dictionary new].
	^CachedThumbnails
		at: aProject name
		ifAbsentPut: [self sorterFormForProject: aProject sized: nil]! !

!InternalThreadNavigationMorph classSide methodsFor: 'known threads' stamp: 'RAA 11/9/2000 17:12'!
know: listOfPages as: nameOfThread

	self knownThreads at: nameOfThread put: listOfPages.
! !

!InternalThreadNavigationMorph classSide methodsFor: 'known threads' stamp: 'RAA 11/9/2000 15:53'!
knownThreads

	^KnownThreads ifNil: [KnownThreads := Dictionary new].
! !

!InternalThreadNavigationMorph classSide methodsFor: 'known threads' stamp: 'RAA 2/24/2001 13:10'!
openThreadNamed: nameOfThread atIndex: anInteger

	| coll nav |

	coll := self knownThreads at: nameOfThread ifAbsent: [^self].
	nav := World 
		submorphThat: [ :each | (each isKindOf: self) and: [each threadName = nameOfThread]]
		ifNone: [
			nav := self basicNew.
			nav
				listOfPages: coll;
				threadName: nameOfThread index: anInteger;
				initialize;
				openInWorld;
				positionAppropriately.
			^self
		].
	nav
		listOfPages: coll;
		threadName: nameOfThread index: anInteger;
		removeAllMorphs;
		addButtons.

! !

!InternalThreadNavigationMorph classSide methodsFor: 'known threads' stamp: 'sw 3/18/2003 23:12'!
openThreadNamed: nameOfThread atIndex: anInteger beKeyboardHandler: aBoolean
	"Activate the thread of the given name, from the given index; set it up to be navigated via desktop keys if indicated"

	| coll nav |

	coll := self knownThreads at: nameOfThread ifAbsent: [^self].
	nav := World 
		submorphThat: [ :each | (each isKindOf: self) and: [each threadName = nameOfThread]]
		ifNone:
			[nav := self basicNew.
			nav
				listOfPages: coll;
				threadName: nameOfThread index: anInteger;
				initialize;
				openInWorld;
				positionAppropriately.
			aBoolean ifTrue: [ActiveWorld keyboardNavigationHandler: nav].
			^ self].
	nav
		listOfPages: coll;
		threadName: nameOfThread index: anInteger;
		removeAllMorphs;
		addButtons.
	aBoolean ifTrue: [ActiveWorld keyboardNavigationHandler: nav]

! !

!InternalThreadNavigationMorph classSide methodsFor: 'sorter' stamp: 'RAA 5/10/2001 17:04'!
sorterFormForProject: aProject sized: ignored

	^(ProjectViewMorph on: aProject) imageForm scaledToSize: 80@60.
! !

!InternalThreadNavigationMorph methodsFor: 'sorting' stamp: 'dgd 9/19/2003 15:27'!
acceptSortedContentsFrom: aHolder
	"Update my page list from the given page sorter."

	| nameOfThisProject cachedData proj |

	threadName isEmpty ifTrue: [threadName := 'I need a name' translated].
	threadName := FillInTheBlank 
		request: 'Name this thread.' translated 
		initialAnswer: threadName.
	threadName isEmptyOrNil ifTrue: [^self].
	listOfPages := OrderedCollection new.
	aHolder submorphs doWithIndex: [:m :i |
		(nameOfThisProject := m valueOfProperty: #nameOfThisProject) ifNotNil: [
			cachedData := {nameOfThisProject}.
			proj := Project named: nameOfThisProject.
			(proj isNil or: [proj thumbnail isNil]) ifFalse: [
				cachedData := cachedData, {proj thumbnail scaledToSize: self myThumbnailSize}.
			].
			listOfPages add: cachedData.
		].
	].
	self class know: listOfPages as: threadName.
	self removeAllMorphs; addButtons.
	self world ifNil: [
		self openInWorld; positionAppropriately.
	].
! !

!InternalThreadNavigationMorph methodsFor: 'initialization' stamp: 'dgd 11/29/2003 17:35'!
addButtons

	| marginPt i sz data images pageNumber f m b1 b2 dot arrowWidth arrowCenter vertices arrowHeight nameMorph sizeRatio controlsColor |

	sizeRatio := self sizeRatio.
	controlsColor := Color orange lighter.

	self changeNoLayout.
	self hResizing: #rigid.
	self vResizing: #rigid.
	marginPt := (4 @ 4 * sizeRatio) rounded..
	i := self currentIndex.
	sz := self myThumbnailSize.
	arrowWidth := (14 * sizeRatio) rounded.
	arrowHeight := (14 * sizeRatio) rounded.
	data := {
		{i - 1. 'Previous:'. #previousPage. #leftCenter. arrowWidth. 'Prev'}.
		{i + 1. 'Next:'. #nextPage. #rightCenter. arrowWidth negated. 'Next'}
	}.
	images := data collect: [ :tuple |
		pageNumber := tuple first.
		(pageNumber between: 1 and: listOfPages size) ifTrue: [
			f := self 
				makeThumbnailForPageNumber: pageNumber 
				scaledToSize: sz 
				default: tuple sixth.
			f := f deepCopy.		"we're going to mess it up"
			arrowCenter := f boundingBox perform: tuple fourth.
			vertices := {
				arrowCenter + (tuple fifth @ arrowHeight negated).
				arrowCenter + (tuple fifth @ arrowHeight).
				arrowCenter.
			}.
			f getCanvas
				drawPolygon: vertices 
				color: controlsColor
				borderWidth: 0 
				borderColor: Color transparent.
			m := ImageMorph new image: f.
			m setBalloonText: tuple second translated,' ',(listOfPages at: pageNumber) first.
			m addMouseUpActionWith: (
				MessageSend receiver: self selector: tuple third
			).
		] ifFalse: [
			f := (Form extent: sz depth: 16) fillColor: Color lightGray.
			m := ImageMorph new image: f.
		].
		m
	].
	b1 := images first.
	b2 := images second.
	dot := EllipseMorph new extent: (18@18 * sizeRatio) rounded; color: controlsColor; borderWidth: 0.

	self addMorph: (b1 position: self position + marginPt).
	self addMorph: (b2 position: b1 topRight + (marginPt x @ 0)).

	self extent: (b1 bottomRight max: b2 bottomRight) - self position + marginPt.
	self addMorph: dot.
	dot align: dot center with: b1 bounds rightCenter + ((marginPt x @ 0) // 2).
	dot setBalloonText: threadName,'
more commands'.
	dot on: #mouseDown send: #moreCommands to: self.
	self fullBounds.
	self addMorph: (nameMorph := SquishedNameMorph new).
	nameMorph
		target: self getSelector: #threadName setSelector: nil;
		color: Color transparent;
		width: self width;
		height: (15 * sizeRatio) rounded;
		align: nameMorph bottomLeft with: self bottomLeft.

! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'RAA 11/10/2000 11:41'!
buttonForMenu

	^self makeButton: '?' balloonText: 'More commands' for: #moreCommands.
! !

!InternalThreadNavigationMorph methodsFor: 'private' stamp: 'dao 10/1/2004 13:36'!
currentIndex

	| currentName |

	currentName := Project current name.
	listOfPages withIndexDo: [ :each :index |
		(each first = currentName and: [preferredIndex = index]) ifTrue: [^currentIndex := index]
	].
	listOfPages withIndexDo: [ :each :index |
		each first = currentName ifTrue: [^currentIndex := index]
	].
	
	currentIndex isNil
		ifTrue: [^ 1].

	^ currentIndex min: listOfPages size
! !

!InternalThreadNavigationMorph methodsFor: 'initialization' stamp: 'dgd 10/26/2003 19:06'!
defaultColor
	"answer the default color/fill style for the receiver"
	^(Color r: 0.27 g: 0.634 b: 0.365) alpha: 0.5! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'RAA 11/9/2000 15:31'!
deleteCurrentPage

	"no-op here"! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'sw 3/3/2004 16:58'!
destroyThread
	"Manually destroy the thread"

	(self confirm: ('Destroy thread <{1}> ?' translated format:{threadName})) ifFalse: [^ self].
	self class knownThreads removeKey: threadName ifAbsent: [].
	self setProperty: #moribund toValue: true.  "In case pointed to in some other project"
	ActiveWorld keyboardNavigationHandler == self ifTrue:
		[self stopKeyboardNavigation]. 
	self delete! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'RAA 2/4/2001 11:41'!
editThisThread

	| sorter |

	sorter := ProjectSorterMorph new.
	sorter navigator: self listOfPages: listOfPages.
	self currentWorld addMorphFront: sorter.
	sorter align: sorter center with: self currentWorld center.
	self delete.

! !

!InternalThreadNavigationMorph methodsFor: 'initialization' stamp: 'dgd 9/19/2003 15:30'!
ensureSuitableDefaults

	listOfPages ifNil: [
		listOfPages := Project allMorphicProjects collect: [ :each | {each name}].
		threadName := 'all (default)' translated.
		self class know: listOfPages as: threadName.
	].
	currentIndex ifNil: [currentIndex := 0].
! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'RAA 11/10/2000 11:51'!
getRecentThread

	self switchToThread: (
		ProjectHistory currentHistory mostRecentThread ifNil: [^self]
	)

! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'dao 10/1/2004 13:36'!
insertNewProjectActionFor: newProj

	| me |

	me := Project current name.
	listOfPages withIndexDo: [ :each :index |
		each first = me ifTrue: [
			listOfPages add: {newProj name} afterIndex: index.
			^self switchToThread: threadName.
		].
	].
	listOfPages add: {newProj name} afterIndex: listOfPages size.
	^self switchToThread: threadName
		
! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'RAA 11/10/2000 12:10'!
jumpToIndex: anInteger

	currentIndex := anInteger.
	self loadPageWithProgress.! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'dao 10/1/2004 13:36'!
jumpWithinThread

	| aMenu me weHaveOthers myIndex |

	me := Project current name.
	aMenu := MenuMorph new defaultTarget: self.
	weHaveOthers := false.
	myIndex := self currentIndex.
	listOfPages withIndexDo: [ :each :index |
		index = myIndex ifTrue: [
			aMenu add: 'you are here' translated action: #yourself.
			aMenu lastSubmorph color: Color red.
		] ifFalse: [
			weHaveOthers := true.
			aMenu add: ('jump to <{1}>' translated format:{each first}) selector: #jumpToIndex: argument: index.
			myIndex = (index - 1) ifTrue: [
				aMenu lastSubmorph color: Color blue
			].
			myIndex = (index + 1) ifTrue: [
				aMenu lastSubmorph color: Color orange
			].
		].
	].
	weHaveOthers ifFalse: [^self inform: 'This is the only project in this thread' translated].
	aMenu popUpEvent: self world primaryHand lastEvent in: self world! !

!InternalThreadNavigationMorph methodsFor: 'private' stamp: 'RAA 11/11/2000 19:11'!
listOfPages: aCollection

	listOfPages := aCollection.
	currentIndex := nil.
	self currentIndex
! !

!InternalThreadNavigationMorph methodsFor: 'private' stamp: 'dao 10/1/2004 13:31'!
loadPageWithProgress
	"Load the desired page, showing a progress indicator as we go"
	
	| projectInfo projectName beSpaceHandler |
	projectInfo := listOfPages at: currentIndex.
	projectName := projectInfo first.
	loadedProject := Project named: projectName.
	self class know: listOfPages as: threadName.
	beSpaceHandler := (ActiveWorld keyboardNavigationHandler == self).
	WorldState addDeferredUIMessage:
		[InternalThreadNavigationMorph openThreadNamed: threadName atIndex: currentIndex beKeyboardHandler: beSpaceHandler] fixTemps.

	loadedProject ifNil: [
		ComplexProgressIndicator new 
			targetMorph: self;
			historyCategory: 'project loading' translated;
			withProgressDo: [
				[
					loadedProject := Project current 
							fromMyServerLoad: projectName
				] 
					on: ProjectViewOpenNotification
					do: [ :ex | ex resume: false]		
						"we probably don't want a project view morph in this case"
			].
	].
	loadedProject ifNil: [
		^self inform: 'I cannot find that project' translated
	].
	self delete.

	loadedProject enter.
! !

!InternalThreadNavigationMorph methodsFor: 'sorting' stamp: 'RAA 2/4/2001 09:38'!
makeThumbnailForPageNumber: pageNumber scaledToSize: sz default: aString

	| cachedData proj tn label |
	cachedData := listOfPages at: pageNumber.
	proj := Project named: cachedData first.
	(proj isNil or: [proj thumbnail isNil]) ifTrue: [
		cachedData size >= 2 ifTrue: [^cachedData second].
		tn := Form extent: sz depth: 8.
		tn fillColor: Color veryLightGray.
		label := (StringMorph contents: aString) imageForm.
		label displayOn: tn at: tn center - (label extent // 2) rule: Form paint.
		^tn
	].
	tn := proj thumbnail  scaledToSize: sz.
	cachedData size < 2 ifTrue: [
		cachedData := cachedData,#(0).
		listOfPages at: pageNumber put: cachedData.
	].
	cachedData at: 2 put: tn.
	^tn
! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'marcus.denker 8/18/2008 21:27'!
moreCommands
	"Put up a menu of options"

	| allThreads aMenu others target |
	allThreads := self class knownThreads.
	aMenu := MenuMorph new defaultTarget: self.
	aMenu addTitle: 'navigation' translated.

	Preferences noviceMode ifFalse:[
		self flag: #deferred.  "Probably don't want that stay-up item, not least because the navigation-keystroke stuff is not dynamically handled"
		aMenu addStayUpItem
	].
	
	others := (allThreads keys reject: [ :each | each = threadName]) asSortedCollection.
	others do: [ :each |
		aMenu add: ('switch to <{1}>' translated format:{each}) selector: #switchToThread: argument: each
	].

	aMenu addList: {
		{'switch to recent projects' translated.  #getRecentThread}.
		#-.
		{'create a new thread' translated.  #threadOfNoProjects}.
		{'edit this thread' translated.  #editThisThread}.
		{'create thread of all projects' translated.  #threadOfAllProjects}.
		#-.
		{'First project in thread' translated.  #firstPage}.
		{'Last project in thread' translated.  #lastPage}
	}.

	(target := self currentIndex + 2) > listOfPages size ifFalse: [
		aMenu 
			add: ('skip over next project ({1})' translated format:{(listOfPages at: target - 1) first})
			action: #skipOverNext
	].

	aMenu addList: {
		{'jump within this thread' translated.  #jumpWithinThread}.
		#-.
		{'simply close this navigator' translated.  #delete}.
		{'destroy this thread' translated. #destroyThread}.
		#-
	}.

	(ActiveWorld keyboardNavigationHandler == self) ifFalse:[
		aMenu add: 'start keyboard navigation with this thread' translated action: #startKeyboardNavigation
	]
	ifTrue: [
		aMenu add: 'stop keyboard navigation with this thread' translated action: #stopKeyboardNavigation
	].

	aMenu popUpInWorld.
! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'dgd 11/29/2003 17:36'!
myThumbnailSize
	^ (52 @ 39 * self sizeRatio) rounded! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'RAA 6/1/2001 13:37'!
positionAppropriately

	| others otherRects overlaps |

	(self ownerThatIsA: HandMorph) ifNotNil: [^self].
	others := self world submorphs select: [ :each | each ~~ self and: [each isKindOf: self class]].
	otherRects := others collect: [ :each | each bounds].
	self align: self fullBounds bottomRight with: self world bottomRight.
	self setProperty: #previousWorldBounds toValue: self world bounds.

	[
		overlaps := false.
		otherRects do: [ :r |
			(r intersects: bounds) ifTrue: [overlaps := true. self bottom: r top].
		].
		self top < self world top ifTrue: [
			self bottom: self world bottom.
			self right: self left - 1.
		].
		overlaps
	] whileTrue.! !

!InternalThreadNavigationMorph methodsFor: 'menu' stamp: 'RAA 11/9/2000 17:49'!
showMenuFor: actionSelector event: evt

	self perform: actionSelector
! !

!InternalThreadNavigationMorph methodsFor: 'accessing' stamp: 'dgd 11/29/2003 17:35'!
sizeRatio
	"answer the size ratio for the receiver"
	
	^ Preferences standardMenuFont height / 12! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'nb 6/17/2003 12:25'!
skipOverNext
	
	| target |

	(target := self currentIndex + 2) > listOfPages size ifTrue: [^Beeper beep].
	currentIndex := target.
	self loadPageWithProgress.
! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'sw 3/18/2003 23:12'!
startKeyboardNavigation
	"Tell the active world to starting navigating via desktop keyboard navigation via me"

	ActiveWorld keyboardNavigationHandler: self! !

!InternalThreadNavigationMorph methodsFor: 'stepping' stamp: 'RAA 6/1/2001 13:36'!
step

	super step.
	(self valueOfProperty: #previousWorldBounds) = self world bounds ifFalse: [
		self positionAppropriately.
	].
	self class knownThreads
		at: threadName
		ifPresent: [ :known |
			known == listOfPages ifFalse: [
				listOfPages := known.
				self removeAllMorphs.
				self addButtons.
			].
		].
! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'sw 3/18/2003 23:09'!
stopKeyboardNavigation
	"Cease navigating via the receiver in response to desktop keystrokes"

	ActiveWorld removeProperty: #keyboardNavigationHandler! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'RAA 11/9/2000 17:46'!
switchToThread: newName

	threadName := newName.
	listOfPages := self class knownThreads at: threadName.
	self removeAllMorphs.
	self addButtons.
	self currentIndex.
! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'RAA 11/9/2000 17:10'!
threadName

	^threadName! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'RAA 2/24/2001 13:15'!
threadName: aString index: anInteger

	threadName := aString.
	preferredIndex := anInteger.
	self currentIndex.! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'RAA 2/24/2001 13:15'!
threadOfAllProjects

	| nameList nav |

	nameList := Project allMorphicProjects collect: [ :each | {each name}].
	nav := self class basicNew.
	nav
		listOfPages: nameList;
		threadName: '' index: nil;
		initialize.
	nav editThisThread.
! !

!InternalThreadNavigationMorph methodsFor: 'navigation' stamp: 'dao 10/1/2004 13:36'!
threadOfNoProjects

	| nameList nav |

	nameList := { {Project current name} }.
	nav := self class basicNew.
	nav
		listOfPages: nameList;
		threadName: '' index: nil;
		initialize.
	nav editThisThread.
! !

!InternalThreadNavigationMorph methodsFor: 'piano rolls' stamp: 'md 10/22/2003 15:25'!
triggerActionFromPianoRoll
	| proj |
	WorldState addDeferredUIMessage: 
			[self currentIndex >= listOfPages size 
				ifTrue: [Beeper beep]
				ifFalse: 
					[currentIndex := self currentIndex + 1.
					proj := Project named: ((listOfPages at: currentIndex) first).
					proj world setProperty: #letTheMusicPlay toValue: true.
					proj enter]]! !

!ThreadNavigationMorph classSide methodsFor: 'as yet unclassified' stamp: 'RAA 6/28/2000 08:20'!
example1
"
ThreadNavigationMorph example1
"
	self new
		listOfPages: #(
			('ftp://209.143.91.36/Drive A Car')
			('ftp://209.143.91.36/Teachers & NewTech' 1)
			('ftp://209.143.91.36/Teachers & NewTech' 2)
			('ftp://209.143.91.36/Lander')
		);
		openInWorld! !

!ThreadNavigationMorph methodsFor: 'initialization' stamp: 'RAA 11/9/2000 16:29'!
addButtons

	self addARow: {
		self inAColumn: {self buttonFirst}.
		self inAColumn: {self buttonPrevious}.
		self inAColumn: {self buttonForward}.
		self inAColumn: {self buttonLast}.
		self inAColumn: {self buttonExit}.
	}.
! !

!ThreadNavigationMorph methodsFor: 'buttons' stamp: 'RAA 11/9/2000 16:28'!
buttonExit

	^self makeButton: 'Exit' balloonText: 'Exit the sequence' for: #exitTheSequence.


! !

!ThreadNavigationMorph methodsFor: 'buttons' stamp: 'RAA 11/9/2000 16:26'!
buttonFirst

	^self makeButton: 'First' balloonText: 'First page in sequence' for: #firstPage
! !

!ThreadNavigationMorph methodsFor: 'buttons' stamp: 'RAA 11/9/2000 16:27'!
buttonForward

	^self makeButton: 'Forward >' balloonText: 'Next page in sequence' for: #nextPage

! !

!ThreadNavigationMorph methodsFor: 'buttons' stamp: 'RAA 11/9/2000 16:27'!
buttonLast

	^self makeButton: 'Last' balloonText: 'Last page in sequence' for: #lastPage

! !

!ThreadNavigationMorph methodsFor: 'buttons' stamp: 'RAA 11/9/2000 16:27'!
buttonPrevious

	^self makeButton: '< Back' balloonText: 'Previous page in sequence' for: #previousPage
! !

!ThreadNavigationMorph methodsFor: 'initialization' stamp: 'RAA 11/9/2000 16:31'!
colorForButtons

	^color darker! !

!ThreadNavigationMorph methodsFor: 'private' stamp: 'RAA 11/9/2000 16:52'!
currentIndex

	^currentIndex! !

!ThreadNavigationMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:31'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color red lighter! !

!ThreadNavigationMorph methodsFor: 'navigation' stamp: 'RAA 6/28/2000 08:29'!
deleteCurrentPage

	| outerWrapper |

	loadedProject ifNil: [^self].
	outerWrapper := loadedProject world ownerThatIsA: EmbeddedWorldBorderMorph.
	outerWrapper ifNil: [^self].
	outerWrapper delete.
	loadedProject := nil.

! !

!ThreadNavigationMorph methodsFor: 'navigation' stamp: 'RAA 11/10/2000 11:37'!
ensureSuitableDefaults

	listOfPages ifNil: [listOfPages := OrderedCollection new].
	currentIndex ifNil: [currentIndex := 0].

! !

!ThreadNavigationMorph methodsFor: 'navigation' stamp: 'RAA 6/28/2000 08:32'!
exitTheSequence

	self deleteCurrentPage.
	self delete.! !

!ThreadNavigationMorph methodsFor: 'navigation' stamp: 'nb 6/17/2003 12:25'!
firstPage

	listOfPages isEmpty ifTrue: [^Beeper beep].
	currentIndex := 1.
	self loadPageWithProgress.! !

!ThreadNavigationMorph methodsFor: 'initialization' stamp: 'RAA 11/9/2000 16:31'!
fontForButtons

	^TextStyle defaultFont! !

!ThreadNavigationMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:28'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self layoutInset: 6;
	  hResizing: #shrinkWrap;
	  vResizing: #shrinkWrap;
	  useRoundedCorners;
	  ensureSuitableDefaults;
	  addButtons! !

!ThreadNavigationMorph methodsFor: 'navigation' stamp: 'nb 6/17/2003 12:25'!
lastPage

	listOfPages isEmpty ifTrue: [^Beeper beep].
	currentIndex := listOfPages size.
	self loadPageWithProgress.! !

!ThreadNavigationMorph methodsFor: 'private' stamp: 'RAA 6/27/2000 18:49'!
listOfPages: aCollection

	listOfPages := aCollection! !

!ThreadNavigationMorph methodsFor: 'private' stamp: 'dgd 2/22/2003 13:24'!
loadPage
	| theProject projectInfo url gotoPage theBook |
	projectInfo := listOfPages at: currentIndex.
	url := projectInfo first.
	gotoPage := projectInfo at: 2 ifAbsent: [nil].
	[Project fromUrl: url] on: ProjectEntryNotification
		do: 
			[:ex | 
			self deleteCurrentPage.
			theProject := ex projectToEnter enterAsActiveSubprojectWithin: self world.
			theProject world showExpandedView.
			loadedProject := theProject.
			gotoPage ifNotNil: 
					[theBook := loadedProject world findA: BookMorph.
					theBook ifNotNil: [theBook goToPage: gotoPage]].
			^loadedProject]! !

!ThreadNavigationMorph methodsFor: 'private' stamp: 'RAA 6/28/2000 08:26'!
loadPageWithProgress

	ComplexProgressIndicator new 
		targetMorph: self;
		historyCategory: 'project loading';
		withProgressDo: [self loadPage]
! !

!ThreadNavigationMorph methodsFor: 'initialization' stamp: 'dgd 9/19/2003 15:23'!
makeButton: aString balloonText: anotherString for: aSymbol 
	^ SimpleButtonDelayedMenuMorph new target: self;
		 borderColor: #raised;
		 color: self colorForButtons;
		 label: aString translated font: self fontForButtons;
		 setBalloonText: anotherString translated;
		 actionSelector: aSymbol! !

!ThreadNavigationMorph methodsFor: 'private' stamp: 'RAA 6/27/2000 18:09'!
morphicLayerNumber

	"helpful for insuring some morphs always appear in front of or behind others.
	smaller numbers are in front"

	^15		"Navigators are behind menus and balloons, but in front of most other stuff"! !

!ThreadNavigationMorph methodsFor: 'navigation' stamp: 'nk 7/30/2004 21:47'!
navigateFromKeystroke: aChar 
	"A character was typed in an effort to do interproject navigation along the receiver's thread"

	| ascii |
	ascii := aChar asciiValue.
	(#(29 31 32) includes: ascii) ifTrue: [^self nextPage].	"right arrow, down arrow, space"
	(#(8 28 30) includes: ascii) ifTrue: [^self previousPage].	"left arrow, up arrow, backspace"
	(#(1) includes: ascii) ifTrue: [^self firstPage].
	(#(4) includes: ascii) ifTrue: [^self lastPage].
	Beeper beep! !

!ThreadNavigationMorph methodsFor: 'navigation' stamp: 'nb 6/17/2003 12:25'!
nextPage

	self currentIndex >= listOfPages size ifTrue: [^Beeper beep].
	currentIndex := self currentIndex + 1.
	self loadPageWithProgress.! !

!ThreadNavigationMorph methodsFor: 'navigation' stamp: 'nb 6/17/2003 12:25'!
previousPage

	self currentIndex <= 1 ifTrue: [^Beeper beep].
	currentIndex := self currentIndex - 1.
	self loadPageWithProgress.! !

!ThreadNavigationMorph methodsFor: 'menu' stamp: 'RAA 11/9/2000 17:50'!
showMenuFor: actionSelector event: evt

	"no-op here"! !

!ThreadNavigationMorph methodsFor: 'stepping' stamp: 'RAA 11/9/2000 16:33'!
step

	| delta |

	owner == self world ifFalse: [^ self].
	owner addMorphInLayer: self.
	delta := self bounds amountToTranslateWithin: self worldBounds.
	delta = (0 @ 0) ifFalse: [self position: self position + delta].
! !

!ThreadNavigationMorph methodsFor: 'stepping' stamp: 'RAA 6/28/2000 08:22'!
stepTime

	^250! !

!ThreadNavigationMorph methodsFor: 'stepping' stamp: 'RAA 6/27/2000 17:59'!
wantsSteps

	^true! !

AlignmentMorph subclass: #BookPageSorterMorph
	instanceVariableNames: 'book pageHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Books'!

!BookPageSorterMorph methodsFor: 'as yet unclassified' stamp: 'jm 6/17/1998 21:27'!
acceptSort

	book acceptSortedContentsFrom: pageHolder.
	self delete.
! !

!BookPageSorterMorph methodsFor: 'as yet unclassified' stamp: 'dgd 10/26/2003 13:21'!
addControls

	| bb r aButton str |
	r := AlignmentMorph newRow color: Color transparent; borderWidth: 0; layoutInset: 0.
	r wrapCentering: #center; cellPositioning: #topCenter; 
			hResizing: #shrinkWrap; vResizing: #shrinkWrap; extent: 5@5.
	bb := SimpleButtonMorph new target: self; borderColor: Color black.
	r addMorphBack: (self wrapperFor: (bb label: 'Okay' translated;	actionSelector: #acceptSort)).
	bb := SimpleButtonMorph new target: self; borderColor: Color black.
	r addMorphBack: (self wrapperFor: (bb label: 'Cancel' translated;	actionSelector: #delete)).

	r addTransparentSpacerOfSize: 8 @ 0.
	r addMorphBack: (self wrapperFor: (aButton := UpdatingThreePhaseButtonMorph checkBox)).
	aButton
		target: self;
		actionSelector: #togglePartsBinStatus;
		arguments: #();
		getSelector: #getPartsBinStatus.
	str := StringMorph contents: 'Parts bin' translated.
	r addMorphBack: (self wrapperFor: str lock).

	self addMorphFront: r.
! !

!BookPageSorterMorph methodsFor: 'as yet unclassified' stamp: 'ar 11/8/2000 22:49'!
book: aBookMorph morphsToSort: morphList

	| innerBounds |
	book := aBookMorph.
	pageHolder removeAllMorphs.
	pageHolder addAllMorphs: morphList.
	pageHolder extent: pageHolder width@pageHolder fullBounds height.
	innerBounds := Rectangle merging: (morphList collect: [:m | m bounds]).
	pageHolder extent: innerBounds extent + pageHolder borderWidth + 6.! !

!BookPageSorterMorph methodsFor: 'as yet unclassified' stamp: 'dgd 2/17/2003 19:56'!
changeExtent: aPoint 
	self extent: aPoint.
	pageHolder extent: self extent - self borderWidth! !

!BookPageSorterMorph methodsFor: 'as yet unclassified' stamp: 'ar 11/9/2000 21:11'!
columnWith: aMorph

	^AlignmentMorph newColumn
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		wrapCentering: #center;
		cellPositioning: #topCenter;
		layoutInset: 1;
		addMorph: aMorph
! !

!BookPageSorterMorph methodsFor: 'initialization' stamp: 'dgd 2/17/2003 19:55'!
defaultBorderWidth
"answer the default border width for the receiver"
	^ 2! !

!BookPageSorterMorph methodsFor: 'initialization' stamp: 'dgd 2/17/2003 19:55'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color lightGray! !

!BookPageSorterMorph methodsFor: 'as yet unclassified' stamp: 'RAA 6/28/2000 11:57'!
getPartsBinStatus

	^pageHolder isPartsBin! !

!BookPageSorterMorph methodsFor: 'initialization' stamp: 'dgd 2/17/2003 19:56'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self extent: Display extent - 100;
		 listDirection: #topToBottom;
		 wrapCentering: #topLeft;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 layoutInset: 3.
	pageHolder := PasteUpMorph new behaveLikeHolder extent: self extent -self borderWidth.
	pageHolder hResizing: #shrinkWrap.
	"pageHolder cursor: 0."
	"causes a walkback as of 5/25/2000"
	self addControls.
	self addMorphBack: pageHolder! !

!BookPageSorterMorph methodsFor: 'as yet unclassified' stamp: 'jm 11/17/97 16:46'!
pageHolder

	^ pageHolder
! !

!BookPageSorterMorph methodsFor: 'as yet unclassified' stamp: 'ar 11/9/2000 21:11'!
rowWith: aMorph

	^AlignmentMorph newColumn
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		wrapCentering: #center;
		cellPositioning: #topCenter;
		layoutInset: 1;
		addMorph: aMorph
! !

!BookPageSorterMorph methodsFor: 'as yet unclassified' stamp: 'RAA 6/28/2000 11:58'!
togglePartsBinStatus

	pageHolder isPartsBin: pageHolder isPartsBin not! !

!BookPageSorterMorph methodsFor: 'copying' stamp: 'tk 1/7/1999 14:36'!
veryDeepFixupWith: deepCopier
	"If fields were weakly copied, fix them here.  If they were in the tree being copied, fix them up, otherwise point to the originals."

super veryDeepFixupWith: deepCopier.
book := deepCopier references at: book ifAbsent: [book].
! !

!BookPageSorterMorph methodsFor: 'copying' stamp: 'tk 1/7/1999 14:36'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

super veryDeepInner: deepCopier.
"book := book.		Weakly copied"
pageHolder := pageHolder veryDeepCopyWith: deepCopier.! !

!BookPageSorterMorph methodsFor: 'dropping/grabbing' stamp: 'ar 9/18/2000 18:34'!
wantsToBeDroppedInto: aMorph
	"Return true if it's okay to drop the receiver into aMorph"
	^aMorph isWorldMorph "only into worlds"! !

!BookPageSorterMorph methodsFor: 'as yet unclassified' stamp: 'RAA 6/28/2000 12:10'!
wrapperFor: aMorph

	^self columnWith: (self rowWith: aMorph)
! !

BookPageSorterMorph subclass: #ProjectSorterMorph
	instanceVariableNames: 'sizeOfEachMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Navigators'!

!ProjectSorterMorph methodsFor: 'as yet unclassified' stamp: 'RAA 2/24/2001 22:19'!
clickFromSorterEvent: evt morph: aMorph

	| where what |
	(aMorph bounds containsPoint: evt cursorPoint) ifFalse: [^self].
	evt isMouseUp ifFalse: [
		evt shiftPressed ifFalse: [^evt hand grabMorph: aMorph].
		^self
	].

	evt shiftPressed ifTrue: [
		where := aMorph owner submorphs indexOf: aMorph ifAbsent: [nil].
		what := book threadName.
		WorldState addDeferredUIMessage: [
			InternalThreadNavigationMorph openThreadNamed: what atIndex: where
		] fixTemps.
		(Project named: (aMorph valueOfProperty: #nameOfThisProject)) enter.
	].
! !

!ProjectSorterMorph methodsFor: 'initialization' stamp: 'dgd 2/17/2003 19:54'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 0 ! !

!ProjectSorterMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:30'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color
		r: 0.365
		g: 0.634
		b: 0.729! !

!ProjectSorterMorph methodsFor: 'initialization' stamp: 'dgd 2/17/2003 19:54'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self useRoundedCorners.
	pageHolder useRoundedCorners; borderWidth: 0;
		color: (self
				gridFormOrigin: 0 @ 0
				grid: 16 @ 16
				background: Color white
				line: Color blue muchLighter)! !

!ProjectSorterMorph methodsFor: 'as yet unclassified' stamp: 'RAA 2/4/2001 15:40'!
morphsForMyContentsFrom: listOfPages sizedTo: sz

	| morphsForPageSorter |

	'Assembling thumbnail images...'
		displayProgressAt: self cursorPoint
		from: 0 to: listOfPages size
		during: [:bar |
			morphsForPageSorter := listOfPages withIndexCollect: [ :each :index | 
				bar value: index.
				self sorterMorphForProjectNamed: each first
			].
		].
	^morphsForPageSorter
! !

!ProjectSorterMorph methodsFor: 'as yet unclassified' stamp: 'md 11/14/2003 17:09'!
navigator: aThreadNavigator listOfPages: listOfPages

	| morphsForPageSorter pixelsAvailable pixelsNeeded scale |

	"a bit of fudging to try to outguess the layout mechanism and get best possible scale"
	pixelsAvailable := Display extent - 130.
	pixelsAvailable := pixelsAvailable x * pixelsAvailable y.
	pixelsNeeded := 100@75.
	pixelsNeeded := pixelsNeeded x * pixelsNeeded y  * listOfPages size.
	scale := (pixelsAvailable / pixelsNeeded min: 1) sqrt.
	sizeOfEachMorph := (100@75 * scale) rounded.

	morphsForPageSorter := self morphsForMyContentsFrom: listOfPages sizedTo: sizeOfEachMorph.
	morphsForPageSorter := morphsForPageSorter reject: [ :each | each isNil].
	self changeExtent: Display extent.

	self
		book: aThreadNavigator 
		morphsToSort: morphsForPageSorter.
	pageHolder 
		cursor: aThreadNavigator currentIndex;
		fullBounds;
		hResizing: #rigid.

! !

!ProjectSorterMorph methodsFor: 'as yet unclassified' stamp: 'RAA 5/10/2001 17:07'!
sorterMorphForProjectNamed: projName

	| pvm proj |

	(proj := Project named: projName) ifNil: [^nil].
	pvm := (InternalThreadNavigationMorph getThumbnailFor: proj) asMorph.
	pvm setProperty: #nameOfThisProject toValue: projName.
	pvm setBalloonText: projName.
	pvm on: #mouseDown send: #clickFromSorterEvent:morph: to: self.
	pvm on: #mouseUp send: #clickFromSorterEvent:morph: to: self.
	^pvm

! !

BookPageSorterMorph subclass: #TabSorterMorph
	instanceVariableNames: 'originalTabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Palettes'!

!TabSorterMorph commentStamp: '<historical>' prior: 0!
A sorter for the tabs of a TabbedPalette!

!TabSorterMorph methodsFor: 'as yet unclassified' stamp: 'dgd 2/21/2003 22:56'!
acceptSort
	"Reconstitute the palette based on what is found in the sorter"

	| rejects toAdd oldOwner tabsToUse appearanceMorph oldTop aMenu |
	tabsToUse := OrderedCollection new.
	rejects := OrderedCollection new.
	pageHolder submorphs doWithIndex: 
			[:m :i | 
			toAdd := nil.
			(m isKindOf: BookMorph) ifTrue: [toAdd := SorterTokenMorph forMorph: m].
			(m isKindOf: SorterTokenMorph) 
				ifTrue: 
					[toAdd := m morphRepresented.
					(toAdd referent isKindOf: MenuMorph) 
						ifTrue: 
							[(aMenu := toAdd referent) setProperty: #paletteMenu toValue: true.
							(aMenu submorphs size > 1 and: 
									[(aMenu submorphs second isKindOf: MenuItemMorph) 
										and: [aMenu submorphs second contents = 'dismiss this menu']]) 
								ifTrue: 
									[aMenu submorphs first delete.	"delete title"
									aMenu submorphs first delete.	"delete stay-up item"
									(aMenu submorphs first isKindOf: MenuLineMorph) 
										ifTrue: [aMenu submorphs first delete]]].
					toAdd removeAllMorphs.
					toAdd addMorph: (appearanceMorph := m submorphs first).
					appearanceMorph position: toAdd position.
					appearanceMorph lock.
					toAdd fitContents].
			toAdd ifNil: [rejects add: m] ifNotNil: [tabsToUse add: toAdd]].
	tabsToUse isEmpty 
		ifTrue: [^self inform: 'Sorry, must have at least one tab'].
	book newTabs: tabsToUse.
	book tabsMorph color: pageHolder color.
	oldTop := self topRendererOrSelf.	"in case some maniac has flexed the sorter"
	oldOwner := oldTop owner.
	oldTop delete.
	oldOwner addMorphFront: book! !

!TabSorterMorph methodsFor: 'as yet unclassified' stamp: 'tk 2/19/2001 18:28'!
addControls

	| b r |
	b := SimpleButtonMorph new target: self; borderColor: Color black.
	r := AlignmentMorph newRow.
	r color: b color; borderWidth: 0; layoutInset: 0.
	r hResizing: #shrinkWrap; vResizing: #shrinkWrap; extent: 5@5.
	r wrapCentering: #topLeft.
	r addMorphBack: (b label: 'Okay';	actionSelector: #acceptSort).
	b := SimpleButtonMorph new target: self; borderColor: Color black.
	r addMorphBack: (b label: 'Cancel';	actionSelector: #cancelSort).
	self addMorphFront: r.
! !

!TabSorterMorph methodsFor: 'as yet unclassified' stamp: 'sw 7/3/1998 16:06'!
cancelSort
	| oldOwner |
	oldOwner := owner.
	self delete.
	oldOwner addMorphFront: book! !

!TabSorterMorph methodsFor: 'initialization' stamp: 'tk 10/30/2001 18:41'!
initialize
	super initialize.
	self removeAllMorphs.

	self extent: 300@100.
	pageHolder := PasteUpMorph new.
	pageHolder vResizeToFit: true; autoLineLayout: true.
	pageHolder extent: self extent - borderWidth.
	pageHolder padding: 8.
	pageHolder cursor: 0.
	self addControls.
	self addMorphBack: pageHolder! !

!TabSorterMorph methodsFor: 'as yet unclassified' stamp: 'sw 3/2/1999 16:47'!
sortTabsFor: aTabbedPalette
	| actualTabs |
	actualTabs := aTabbedPalette tabMorphs.
	self book: aTabbedPalette morphsToSort:
		(actualTabs collect: [:aTab | aTab sorterToken]).
	pageHolder color: aTabbedPalette tabsMorph color.
 
	self position: aTabbedPalette position.
	pageHolder extent: self extent.
	self setNameTo: 'Tab Sorter for ', aTabbedPalette externalName.
	aTabbedPalette owner addMorphFront: self! !

AlignmentMorph subclass: #BooklikeMorph
	instanceVariableNames: 'pageSize newPagePrototype'
	classVariableNames: 'PageFlipSoundOn'
	poolDictionaries: ''
	category: 'MorphicExtras-Books'!

!BooklikeMorph commentStamp: '<historical>' prior: 0!
A common superclass for BookMorph and WebBookMorph!

BooklikeMorph subclass: #BookMorph
	instanceVariableNames: 'pages currentPage'
	classVariableNames: 'MethodHolders VersionNames VersionTimes'
	poolDictionaries: ''
	category: 'MorphicExtras-Books'!

!BookMorph commentStamp: '<historical>' prior: 0!
A collection of pages, each of which is a place to put morphs.  Allows one or another page to show; orchestrates the page transitions; offers control panel for navigating among pages and for adding and deleting pages.

To write a book out to the disk or to a file server, decide what folder it goes in.  Construct a url to a typical page:
	file://myDisk/folder/myBook1.sp
or
	ftp://aServer/folder/myBook1.sp

Choose "send all pages to server" from the book's menu (press the <> part of the controls).  Choose "use page numbers".  Paste in the url.

To load an existing book, find its ".bo" file in the file list browser.  Choose "load as book".

To load an existing book from its url, execute:
(URLMorph grabURL: 'ftp://aServer/folder/myBook1.sp') book: true.

Multiple people may modify a book.  If other people may have changed a book you have on your screen, choose "reload all from server".

Add or modify a page, and choose "send this page to server".

The polite thing to do is to reload before changing a book.  Then write one or all pages soon after making your changes.  If you store a stale book, it will wipe out changes that other people made in the mean time.

Pages may be linked to each other.  To create a named link to a new page, type the name of the page in a text area in a page.  Select it and do Cmd-6.  Choose 'link to'.  A new page of that name will be added at the back of the book.  Clicking on the blue text flips to that page.  
	To create a link to an existing page, first name the page.  Go to that page and Cmd-click on it.  The name of the page is below the page.  Click in it and backspace and type.  Return to the page you are linking from.  Type the name. Cmd-6, 'link to'.  

Text search:  Search for a set of fragments.  allStrings collects text of fields.  Turn to page with all fragments on it and highlight the first one.  Save the container and offset in properties: #searchContainer, #searchOffset, #searchKey.  Search again from there.  Clear those at each page turn, or change of search key.  

[rules about book indexes and pages:  Index and pages must live in the same directory. They have the same file prefix, followed by .bo for the index or 4.sp for a page (or x4.sp).  When a book is moved to a new directory, the load routine gets the new urls for all pages and saves those in the index.  Book stores index url in property #url.  
    Allow mulitple indexes (books) on the same shared set of pages.  If book has a url in same directory as pages, allow them to have different prefixes.
	save all pages first time, save one page first time, fromRemoteStream: (first time)
	save all pages normal , save one page normal, reload
	where I check if same dir]
URLMorph holds url of both page and book.!

!BookMorph classSide methodsFor: 'scripting' stamp: 'sw 3/6/1999 01:21'!
authoringPrototype
	"Answer an instance of the receiver suitable for placing in a parts bin for authors"
	
	| book |
	book := self new markAsPartsDonor.
	book removeEverything; pageSize: 360@228; color: (Color gray: 0.9).
	book borderWidth: 1; borderColor: Color black.
	book beSticky.
	book showPageControls; insertPage.
	^ book! !

!BookMorph classSide methodsFor: 'parts bin' stamp: 'sw 8/2/2001 01:20'!
descriptionForPartsBin
	^ self partName:	'Book'
		categories:		#('Presentation')
		documentation:	'Multi-page structures'! !

!BookMorph classSide methodsFor: 'fileIn/Out' stamp: 'sd 2/6/2002 21:28'!
fileReaderServicesForFile: fullName suffix: suffix

	^(suffix = 'bo') | (suffix = '*') 
		ifTrue: [ Array with: self serviceLoadAsBook]
		ifFalse: [#()]
! !

!BookMorph classSide methodsFor: 'url' stamp: 'sma 4/30/2000 10:36'!
grabURL: aURLString
	"Create a BookMorph for this url and put it in the hand."

	| book |
	book := self new fromURL: aURLString.
	"If this book is already in, we will steal the pages out of it!!!!!!!!"
	book goToPage: 1.	"install it"
	HandMorph attach: book! !

!BookMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 10:31'!
initialize

	FileList registerFileReader: self.

	self registerInFlapsRegistry.	! !

!BookMorph classSide methodsFor: 'url' stamp: 'tk 3/28/2000 13:30'!
isInWorld: aWorld withUrl: aUrl
	| urls bks short |
	"If a book with this url is in the that (current) world, return it.  Say if it is out or in another world."

	urls := OrderedCollection new.
	bks := OrderedCollection new.
	aWorld allMorphsDo: [:aBook | (aBook isKindOf: BookMorph) ifTrue: [
			bks add: aBook.
			 (urls add: (aBook valueOfProperty: #url)) = aUrl ifTrue: [
				aBook world == aWorld 
					ifTrue: [^ aBook]]]]. 	"shortcut"
		
	self withAllSubclassesDo: [:cls |
		cls allInstancesDo: [:aBook | 
			 (aBook valueOfProperty: #url) = aUrl ifTrue: [
				aBook world == aWorld 
					ifTrue: [^ aBook]
					ifFalse: [
						self inform: 'Book may be open in some other project'.
						^ aBook]]]].

	"if same book name, use it"
	short := (aUrl findTokens: '/') last.
	urls withIndexDo: [:kk :ind | (kk findTokens: '/') last = short ifTrue: [
			^ bks at: ind]].
	^ #out! !

!BookMorph classSide methodsFor: 'scripting' stamp: 'sw 6/13/2001 17:14'!
nextPageButton
	"Answer a button that will take the user to the next page of its enclosing book"

	| aButton |
	aButton := SimpleButtonMorph new.
	aButton target: aButton; actionSelector: #nextOwnerPage; label: '->'; color: Color yellow.
	aButton setNameTo: 'next'.
	^ aButton! !

!BookMorph classSide methodsFor: 'fileIn/Out' stamp: 'alain.plantec 6/19/2008 09:57'!
openFromFile: fullName
	"Reconstitute a Morph from the selected file, presumed to be represent
	a Morph saved via the SmartRefStream mechanism, and open it in an
	appropriate Morphic world"

	| book aFileStream |
	aFileStream := FileStream oldFileNamed: fullName.
	book := BookMorph new.
	book setProperty: #url toValue: aFileStream url.
	book fromRemoteStream: aFileStream.
	aFileStream close.

	ActiveWorld addMorphsAndModel: book.
	book goToPage: 1! !

!BookMorph classSide methodsFor: 'scripting' stamp: 'sw 6/13/2001 17:13'!
previousPageButton
	"Answer a button that will take the user to the previous page of its enclosing book"

	| aButton |
	aButton := SimpleButtonMorph new.
	aButton target: aButton; actionSelector: #previousOwnerPage; color: Color yellow; label: '<-'.
	aButton setNameTo: 'previous'.
	^ aButton! !

!BookMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 10:37'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(BookMorph		nextPageButton			'NextPage'		'A button that takes you to the next page')
						forFlapNamed: 'PlugIn Supplies'.
						cl registerQuad: #(BookMorph	previousPageButton 		'PreviousPage'	'A button that takes you to the previous page')
						forFlapNamed: 'PlugIn Supplies'.
						cl registerQuad: #(BookMorph	authoringPrototype		'Book'			'A multi-paged structure')
						forFlapNamed: 'PlugIn Supplies'.
						cl registerQuad: #(BookMorph		nextPageButton			'NextPage'		'A button that takes you to the next page')
						forFlapNamed: 'Supplies'.
						cl registerQuad: #(BookMorph	previousPageButton 		'PreviousPage'	'A button that takes you to the previous page')
						forFlapNamed: 'Supplies'.
						cl registerQuad: #(BookMorph	authoringPrototype		'Book'			'A multi-paged structure')
						forFlapNamed: 'Supplies']! !

!BookMorph classSide methodsFor: 'fileIn/Out' stamp: 'sd 2/1/2002 21:33'!
serviceLoadAsBook

	^ SimpleServiceEntry 
			provider: self 
			label: 'load as book'
			selector: #openFromFile:
			description: 'open as bookmorph'! !

!BookMorph classSide methodsFor: 'fileIn/Out' stamp: 'sd 2/1/2002 21:33'!
services

	^ Array with: self serviceLoadAsBook! !

!BookMorph classSide methodsFor: 'initialize-release' stamp: 'asm 4/11/2003 12:31'!
unload
	"Unload the receiver from global registries"

	self environment
		at: #FileList
		ifPresent: [:cl | cl unregisterFileReader: self].
	self environment
		at: #Flaps
		ifPresent: [:cl | cl unregisterQuadsWithReceiver: self]! !

!BookMorph methodsFor: 'submorphs-add/remove' stamp: 'tk 12/15/1998 14:32'!
abandon
	"Like delete, but we really intend not to use this morph again.  Make the page cache release the page object."

	| pg |
	self delete.
	pages do: [:aPage |
		(pg := aPage sqkPage) ifNotNil: [
			pg contentsMorph == aPage ifTrue: [
					pg contentsMorph: nil]]].! !

!BookMorph methodsFor: 'layout' stamp: 'sw 10/18/97 18:03'!
acceptDroppingMorph: aMorph event: evt
	"Allow the user to add submorphs just by dropping them on this morph."

	(currentPage allMorphs includes: aMorph)
		ifFalse: [currentPage addMorph: aMorph]! !

!BookMorph methodsFor: 'sorting' stamp: 'ar 4/10/2005 18:42'!
acceptSortedContentsFrom: aHolder 
	"Update my page list from the given page sorter."

	| goodPages rejects toAdd sqPage |
	goodPages := OrderedCollection new.
	rejects := OrderedCollection new.
	aHolder submorphs doWithIndex: 
			[:m :i | 
			toAdd := nil.
			(m isKindOf: PasteUpMorph) ifTrue: [toAdd := m].
			(m isKindOf: BookPageThumbnailMorph) 
				ifTrue: 
					[toAdd := m page.
					m bookMorph == self 
						ifFalse: 
							["borrowed from another book. preserve the original"

							toAdd := toAdd veryDeepCopy.

							"since we came from elsewhere, cached strings are wrong"
							self removeProperty: #allTextUrls.
							self removeProperty: #allText]].
			toAdd isString 
				ifTrue: 
					["a url"

					toAdd := pages detect: [:aPage | aPage url = toAdd] ifNone: [toAdd]].
			toAdd isString 
				ifTrue: 
					[sqPage := SqueakPageCache atURL: toAdd.
					toAdd := sqPage contentsMorph 
								ifNil: [sqPage copyForSaving	"a MorphObjectOut"]
								ifNotNil: [sqPage contentsMorph]].
			toAdd ifNil: [rejects add: m] ifNotNil: [goodPages add: toAdd]].
	self newPages: goodPages.
	goodPages isEmpty ifTrue: [self insertPage].
	rejects notEmpty 
		ifTrue: 
			[self 
				inform: rejects size printString , ' objects vanished in this process.']! !

!BookMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 21:13'!
addBookMenuItemsTo: aMenu hand: aHandMorph
	| controlsShowing subMenu |
	subMenu := MenuMorph new defaultTarget: self.
	subMenu add: 'previous page' translated action: #previousPage.
	subMenu add: 'next page' translated action: #nextPage.
	subMenu add: 'goto page' translated action: #goToPage.
	subMenu add: 'insert a page' translated action: #insertPage.
	subMenu add: 'delete this page' translated action: #deletePage.

	controlsShowing := self hasSubmorphWithProperty: #pageControl.
	controlsShowing
		ifTrue:
			[subMenu add: 'hide page controls' translated action: #hidePageControls.
			subMenu add: 'fewer page controls' translated action: #fewerPageControls]
		ifFalse:
			[subMenu add: 'show page controls' translated action: #showPageControls].
	self isInFullScreenMode ifTrue: [
		subMenu add: 'exit full screen' translated action: #exitFullScreen.
	] ifFalse: [
		subMenu add: 'show full screen' translated action: #goFullScreen.
	].
	subMenu addLine.
	subMenu add: 'sound effect for all pages' translated action: #menuPageSoundForAll:.
	subMenu add: 'sound effect this page only' translated action: #menuPageSoundForThisPage:.
	subMenu add: 'visual effect for all pages' translated action: #menuPageVisualForAll:.
	subMenu add: 'visual effect this page only' translated action: #menuPageVisualForThisPage:.

	subMenu addLine.
	subMenu add: 'sort pages' translated action: #sortPages:.
	subMenu add: 'uncache page sorter' translated action: #uncachePageSorter.
	(self hasProperty: #dontWrapAtEnd)
		ifTrue: [subMenu add: 'wrap after last page' translated selector: #setWrapPages: argument: true]
		ifFalse: [subMenu add: 'stop at last page' translated selector: #setWrapPages: argument: false].

	subMenu addLine.
	subMenu add: 'search for text' translated action: #textSearch.
	(aHandMorph pasteBuffer class isKindOf: PasteUpMorph class) ifTrue:
		[subMenu add: 'paste book page' translated	action: #pasteBookPage].

	subMenu add: 'send all pages to server' translated action: #savePagesOnURL.
	subMenu add: 'send this page to server' translated action: #saveOneOnURL.
	subMenu add: 'reload all from server' translated action: #reload.
	subMenu add: 'copy page url to clipboard' translated action: #copyUrl.
	subMenu add: 'keep in one file' translated action: #keepTogether.
	subMenu add: 'save as new-page prototype' translated action: #setNewPagePrototype.
	newPagePrototype ifNotNil:
		[subMenu add: 'clear new-page prototype' translated action: #clearNewPagePrototype].

	aMenu add: 'book...' translated subMenu: subMenu
! !

!BookMorph methodsFor: 'other' stamp: 'sw 6/6/2003 13:55'!
adjustCurrentPageForFullScreen
	"Adjust current page to conform to whether or not I am in full-screen mode.  Also, enforce uniform page size constraint if appropriate"

	self isInFullScreenMode
		ifTrue:
			[(currentPage hasProperty: #sizeWhenNotFullScreen) ifFalse:
				[currentPage setProperty: #sizeWhenNotFullScreen toValue: currentPage extent].
			currentPage extent: Display extent]
		ifFalse:
			[(currentPage hasProperty: #sizeWhenNotFullScreen) ifTrue:
				[currentPage extent: (currentPage valueOfProperty: #sizeWhenNotFullScreen).
				currentPage removeProperty: #sizeWhenNotFullScreen].
			self uniformPageSize ifNotNilDo:
				[:anExtent | currentPage extent: anExtent]].
	(self valueOfProperty: #floatingPageControls) ifNotNilDo:
		[:pc | pc isInWorld ifFalse: [pc openInWorld]]! !

!BookMorph methodsFor: 'submorphs-accessing' stamp: 'tk 12/17/1998 11:19'!
allNonSubmorphMorphs
	"Return a collection containing all morphs in this morph which are not currently in the submorph containment hierarchy.  Especially the non-showing pages in BookMorphs.    (As needed, make a variant of this that brings in all pages that are not in memory.)"

	| coll |
	coll := OrderedCollection new.
	pages do: [:pg |
		pg isInMemory ifTrue: [
			pg == currentPage ifFalse: [coll add: pg]]].
	^ coll! !

!BookMorph methodsFor: 'dropping/grabbing' stamp: ''!
allowSubmorphExtraction

	^ false! !

!BookMorph methodsFor: 'Postscript Canvases' stamp: ''!
asPostscript
	^self asPostscriptPrintJob.
! !

!BookMorph methodsFor: 'menu' stamp: 'dgd 10/26/2003 13:03'!
bookmarkForThisPage
	"If this book exists on a server, make the reference via a URL"
	| bb url um |
	(url := self url) ifNil: [
		bb := SimpleButtonMorph new target: self.
		bb actionSelector: #goToPageMorph:fromBookmark:.
		bb label: 'Bookmark' translated.
		bb arguments: (Array with: currentPage with: bb).
		self primaryHand attachMorph: bb.
		^ bb].
	currentPage url ifNil: [currentPage saveOnURLbasic].
	um := URLMorph newForURL: currentPage url.
	um setURL: currentPage url page: currentPage sqkPage.
	(SqueakPage stemUrl: url) = (SqueakPage stemUrl: currentPage url) 
		ifTrue: [um book: true]
		ifFalse: [um book: url].  	"remember which book"
	um isBookmark: true; label: 'Bookmark' translated.
	um borderWidth: 1; borderColor: #raised.
	um color: (Color r: 0.4 g: 0.8 b: 0.6).
	self primaryHand attachMorph: um.
	^ um! !

!BookMorph methodsFor: 'navigation' stamp: 'ar 11/9/2000 20:37'!
buildFloatingPageControls

	| pageControls |
	pageControls := self makePageControlsFrom: self fullControlSpecs.
	pageControls borderWidth: 0; layoutInset: 4.
	pageControls  setProperty: #pageControl toValue: true.
	pageControls setNameTo: 'Page Controls'.
	pageControls color: Color yellow.
	^FloatingBookControlsMorph new addMorph: pageControls.
! !

!BookMorph methodsFor: 'menu' stamp: 'dgd 10/26/2003 13:04'!
buildThreadOfProjects

	| thisPVM projectNames threadName |

	projectNames := pages collect: [ :each |
		(thisPVM := each findA: ProjectViewMorph) ifNil: [
			nil
		] ifNotNil: [
			{thisPVM project name}.
		].
	].
	projectNames := projectNames reject: [ :each | each isNil].
	threadName := FillInTheBlank 
		request: 'Please name this thread.' translated 
		initialAnswer: (
			self valueOfProperty: #nameOfThreadOfProjects ifAbsent: ['Projects on Parade' translated]
		).
	threadName isEmptyOrNil ifTrue: [^self].
	InternalThreadNavigationMorph 
		know: projectNames as: threadName;
		openThreadNamed: threadName atIndex: nil.
! !

!BookMorph methodsFor: 'accessing' stamp: 'tk 12/12/2001 15:36'!
cardsOrPages
	"The turnable and printable entities"

	^ pages! !

!BookMorph methodsFor: 'menu' stamp: 'dgd 10/26/2003 13:05'!
copyUrl
	"Copy this page's url to the clipboard"
	| str |
	str := currentPage url ifNil: [str := 'Page does not have a url.  Send page to server first.' translated].
	Clipboard clipboardText: str asText.
! !

!BookMorph methodsFor: 'accessing' stamp: 'sw 10/16/1998 22:39'!
currentPage
	(submorphs includes: currentPage) ifFalse: [currentPage := nil].
	^ currentPage! !

!BookMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:24'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color white! !

!BookMorph methodsFor: 'insert and delete' stamp: 'sw 10/13/2000 12:59'!
defaultNameStemForNewPages
	"Answer a stem onto which to build default names for fresh pages"

	^ 'page'
! !

!BookMorph methodsFor: 'halos and balloon help' stamp: 'ar 9/14/2000 16:46'!
defersHaloOnClickTo: aSubMorph
	"If a cmd-click on aSubMorph would make it a preferred recipient of the halo, answer true"
	^ currentPage notNil and:
		[aSubMorph hasOwner: currentPage]
	! !

!BookMorph methodsFor: 'insert and delete' stamp: 'dgd 9/21/2003 17:45'!
deletePage

	| message |
	message := 
'Are you certain that you
want to delete this page and
everything that is on it? ' translated.
	(self confirm: message) ifTrue: 
			[self deletePageBasic].
	! !

!BookMorph methodsFor: 'insert and delete' stamp: 'di 9/7/1999 21:57'!
deletePageBasic
	| thisPage |
	thisPage := self pageNumberOf: currentPage.
	pages remove: currentPage.
	currentPage delete.
	currentPage := nil.
	pages isEmpty ifTrue: [^ self insertPage].
	self goToPage: (thisPage min: pages size)
! !

!BookMorph methodsFor: 'other' stamp: 'RAA 8/23/2000 12:43'!
exitFullScreen

	| floater |

	self isInFullScreenMode ifFalse: [^self].
	self setProperty: #fullScreenMode toValue: false.
	floater := self valueOfProperty: #floatingPageControls ifAbsent: [nil].
	floater ifNotNil: [
		floater delete.
		self removeProperty: #floatingPageControls.
	].
	self position: 0@0.
	self adjustCurrentPageForFullScreen.
! !

!BookMorph methodsFor: 'menu' stamp: 'md 9/27/2005 22:57'!
findText: wants
	"Turn to the next page that has all of the strings mentioned on it.  Highlight where it is found.  allText and allTextUrls have been set.  Case insensitive search.
	Resuming a search.  If container's text is still in the list and secondary keys are still in the page, (1) search rest of that container.  (2) search rest of containers on that page (3) pages till end of book, (4) from page 1 to this page again."

	"Later sort wants so longest key is first"
	| allText good thisWord here fromHereOn startToHere oldContainer oldIndex otherKeys strings |
	allText := self valueOfProperty: #allText ifAbsent: [#()].
	here := pages identityIndexOf: currentPage ifAbsent: [1].
	fromHereOn := here+1 to: pages size.
	startToHere := 1 to: here.		"repeat this page"
	(self valueOfProperty: #searchKey ifAbsent: [#()]) = wants ifTrue: [
		"does page have all the other keys?  No highlight if found!!"
		otherKeys := wants allButFirst.
		strings := allText at: here.
		good := true.
		otherKeys do: [:searchString | "each key"
			good ifTrue: [thisWord := false.
				strings do: [:longString |
					(longString findString: searchString startingAt: 1 
						caseSensitive: false) > 0 ifTrue: [
							thisWord := true]].
				good := thisWord]].
		good ifTrue: ["all are on this page.  Look in rest for string again."
			oldContainer := self valueOfProperty: #searchContainer.
			oldIndex := self valueOfProperty: #searchOffset.
			(self findText: (OrderedCollection with: wants first) inStrings: strings	
				startAt: oldIndex+1 container: oldContainer 
				pageNum: here) ifTrue: [
					self setProperty: #searchKey toValue: wants.
					^ true]]]
		ifFalse: [fromHereOn := here to: pages size].	"do search this page"
	"other pages"
	allText ifNotEmpty: [
		fromHereOn do: [:pageNum |
			(self findText: wants inStrings: (allText at: pageNum) startAt: 1 container: nil 
					pageNum: pageNum) 
					ifTrue: [^ true]].
		startToHere do: [:pageNum |
			(self findText: wants inStrings: (allText at: pageNum) startAt: 1 container: nil 
					pageNum: pageNum) 
						ifTrue: [^ true]]].
	"if fail"
	self setProperty: #searchContainer toValue: nil.
	self setProperty: #searchOffset toValue: nil.
	self setProperty: #searchKey toValue: nil.
	^ false! !

!BookMorph methodsFor: 'menu' stamp: 'gm 2/22/2003 13:17'!
findText: keys inStrings: rawStrings startAt: startIndex container: oldContainer pageNum: pageNum 
	"Call once to search a page of the book.  Return true if found and highlight the text.  oldContainer should be NIL.  
	(oldContainer is only non-nil when (1) doing a 'search again' and (2) the page is in memory and (3) keys has just one element.  oldContainer is a TextMorph.)"

	| good thisWord index insideOf place container start wasIn strings old |
	good := true.
	start := startIndex.
	strings := oldContainer ifNil: 
					["normal case"

					rawStrings]
				ifNotNil: 
					[(pages at: pageNum) isInMemory 
						ifFalse: [rawStrings]
						ifTrue: [(pages at: pageNum) allStringsAfter: oldContainer]].
	keys do: 
			[:searchString | 
			"each key"

			good 
				ifTrue: 
					[thisWord := false.
					strings do: 
							[:longString | 
							(index := longString 
										findString: searchString
										startingAt: start
										caseSensitive: false) > 0 
								ifTrue: 
									[thisWord not & (searchString == keys first) 
										ifTrue: 
											[insideOf := longString.
											place := index].
									thisWord := true].
							start := 1].	"only first key on first container"
					good := thisWord]].
	good 
		ifTrue: 
			["all are on this page"

			wasIn := (pages at: pageNum) isInMemory.
			self goToPage: pageNum.
			wasIn 
				ifFalse: 
					["search again, on the real current text.  Know page is in."

					^self 
						findText: keys
						inStrings: ((pages at: pageNum) allStringsAfter: nil)
						startAt: startIndex
						container: oldContainer
						pageNum: pageNum	"recompute"]].
	(old := self valueOfProperty: #searchContainer) ifNotNil: 
			[(old respondsTo: #editor) 
				ifTrue: 
					[old editor selectFrom: 1 to: 0.	"trying to remove the previous selection!!"
					old changed]].
	good 
		ifTrue: 
			["have the exact string object"

			(container := oldContainer) ifNil: 
					[container := self 
								highlightText: keys first
								at: place
								in: insideOf]
				ifNotNil: 
					[container userString == insideOf 
						ifFalse: 
							[container := self 
										highlightText: keys first
										at: place
										in: insideOf]
						ifTrue: 
							[(container isTextMorph) 
								ifTrue: 
									[container editor selectFrom: place to: keys first size - 1 + place.
									container changed]]].
			self setProperty: #searchContainer toValue: container.
			self setProperty: #searchOffset toValue: place.
			self setProperty: #searchKey toValue: keys.	"override later"
			ActiveHand newKeyboardFocus: container.
			^true].
	^false! !

!BookMorph methodsFor: 'menu' stamp: 'tk 2/26/1999 22:39'!
forgetURLs
	"About to save these objects in a new place.  Forget where stored now.  Must bring in all pages we don't have."

| pg |
pages do: [:aPage |
	aPage yourself.	"bring it into memory"
	(pg := aPage valueOfProperty: #SqueakPage) ifNotNil: [
		SqueakPageCache removeURL: pg url.
		pg contentsMorph setProperty: #SqueakPage toValue: nil]].
self setProperty: #url toValue: nil.! !

!BookMorph methodsFor: 'initialization' stamp: 'dgd 2/21/2003 23:10'!
fromRemoteStream: strm 
	"Make a book from an index and a bunch of pages on a server.  NOT showing any page!!  Index and pages must live in the same directory.  If the book has moved, save the current correct urls for each of the pages.  Self must already have a url stored in property #url."

	| remote dict bookUrl oldStem stem oldUrl endPart |
	remote := strm fileInObjectAndCode.
	bookUrl := (SqueakPage new)
				url: (self valueOfProperty: #url);
				url.
	"expand a relative url"
	oldStem := SqueakPage stemUrl: (remote second) url.
	oldStem := oldStem copyUpToLast: $/.
	stem := SqueakPage stemUrl: bookUrl.
	stem := stem copyUpToLast: $/.
	oldStem = stem 
		ifFalse: 
			["Book is in new directory, fix page urls"

			2 to: remote size
				do: 
					[:ii | 
					oldUrl := (remote at: ii) url.
					endPart := oldUrl copyFrom: oldStem size + 1 to: oldUrl size.
					(remote at: ii) url: stem , endPart]].
	self initialize.
	pages := OrderedCollection new.
	2 to: remote size do: [:ii | pages add: (remote at: ii)].
	currentPage
		fullReleaseCachedState;
		delete.	"the blank one"
	currentPage := remote second.
	dict := remote first.
	self setProperty: #modTime toValue: (dict at: #modTime).
	dict at: #allText
		ifPresent: [:val | self setProperty: #allText toValue: val].
	dict at: #allTextUrls
		ifPresent: [:val | self setProperty: #allTextUrls toValue: val].
	#(#color #borderWidth #borderColor #pageSize) 
		with: #(#color: #borderWidth: #borderColor: #pageSize:)
		do: [:key :sel | dict at: key ifPresent: [:val | self perform: sel with: val]].
	^self! !

!BookMorph methodsFor: 'initialization' stamp: 'ar 4/10/2005 18:42'!
fromURL: url
	"Make a book from an index and a bunch of pages on a server.  NOT showing any page!!"

	| strm |
	Cursor wait showWhile: [
		strm := (ServerFile new fullPath: url) asStream].
	strm isString ifTrue: [self inform: 'Sorry, ',strm. ^ nil].
	self setProperty: #url toValue: url.
	self fromRemoteStream: strm.
	^ self! !

!BookMorph methodsFor: 'Postscript Canvases' stamp: 'mpw 9/13/1999 20:22'!
fullDrawPostscriptOn:aCanvas
	^aCanvas fullDrawBookMorph:self.
! !

!BookMorph methodsFor: 'menu' stamp: 'tk 1/26/1999 09:26'!
getAllText
	"Collect the text for each page.  Just point at strings so don't have to recopy them.  Parallel array of urls for ID of pages.
	allText = Array (pages size) of arrays (fields in it) of strings of text.
	allTextUrls = Array (pages size) of urls or page numbers.
	For any page that is out, text data came from .bo file on server.  
	Is rewritten when one or all pages are stored."

	| oldUrls oldStringLists allText allTextUrls aUrl which |
	oldUrls := self valueOfProperty: #allTextUrls ifAbsent: [#()].
	oldStringLists := self valueOfProperty: #allText ifAbsent: [#()].
	allText := pages collect: [:pg | OrderedCollection new].
	allTextUrls := Array new: pages size.
	pages doWithIndex: [:aPage :ind | aUrl := aPage url.  aPage isInMemory 
		ifTrue: [(allText at: ind) addAll: (aPage allStringsAfter: nil).
			aUrl ifNil: [aUrl := ind].
			allTextUrls at: ind put: aUrl]
		ifFalse: ["Order of pages on server may be different.  (later keep up to date?)"
			which := oldUrls indexOf: aUrl.
			allTextUrls at: ind put: aUrl.
			which = 0 ifFalse: [allText at: ind put: (oldStringLists at: which)]]].
	self setProperty: #allText toValue: allText.
	self setProperty: #allTextUrls toValue: allTextUrls.
	^ allText! !

!BookMorph methodsFor: 'menu' stamp: 'dgd 10/26/2003 13:06'!
getStemUrl
	"Try to find the old place where this book was stored. Confirm with the 
	user. Else ask for new place."
	| initial pg url knownURL |

	knownURL := false.
	initial := ''.
	(pg := currentPage valueOfProperty: #SqueakPage)
		ifNotNil: [pg contentsMorph == currentPage
				ifTrue: [initial := pg url.
					knownURL := true]].
	"If this page has a url"
	pages
		doWithIndex: [:aPage :ind | initial isEmpty
				ifTrue: [aPage isInMemory
						ifTrue: [(pg := aPage valueOfProperty: #SqueakPage)
								ifNotNil: [initial := pg url]]]].
	"any page with a url"
	initial isEmpty
		ifTrue: [initial := ServerDirectory defaultStemUrl , '1.sp'].
	"A new legal place"
	url := knownURL
		ifTrue: [initial]
		ifFalse: [FillInTheBlank request: 'url of the place to store a typical page in this book.
Must begin with file:// or ftp://' translated initialAnswer: initial].
	^ SqueakPage stemUrl: url! !

!BookMorph methodsFor: 'other' stamp: 'RAA 8/23/2000 12:42'!
goFullScreen

	| floater |

	self isInFullScreenMode ifTrue: [^self].
	self setProperty: #fullScreenMode toValue: true.
	self position: (currentPage topLeft - self topLeft) negated.
	self adjustCurrentPageForFullScreen.
	floater := self buildFloatingPageControls.
	self setProperty: #floatingPageControls toValue: floater.
	floater openInWorld.
! !

!BookMorph methodsFor: 'menu' stamp: 'dgd 10/26/2003 12:59'!
goToPage
	| pageNum |
	pageNum := FillInTheBlank request: 'Page?' translated initialAnswer: '0'.
	pageNum isEmptyOrNil ifTrue: [^true].
	self goToPage: pageNum asNumber.
! !

!BookMorph methodsFor: 'navigation' stamp: 'di 12/20/1998 10:18'!
goToPage: pageNumber

	^ self goToPage: pageNumber transitionSpec: nil! !

!BookMorph methodsFor: 'navigation' stamp: 'di 1/14/1999 12:07'!
goToPage: pageNumber transitionSpec: transitionSpec

	| pageMorph |
	pages isEmpty ifTrue: [^ self].
	pageMorph := (self hasProperty: #dontWrapAtEnd)
		ifTrue: [pages atPin: pageNumber]
		ifFalse: [pages atWrap: pageNumber].
	^ self goToPageMorph: pageMorph transitionSpec: transitionSpec! !

!BookMorph methodsFor: 'navigation' stamp: 'sw 11/8/2002 13:31'!
goToPage: pageNumber transitionSpec: transitionSpec runTransitionScripts: aBoolean
	"Go the the given page number; use the transitionSpec supplied, and if the boolean parameter is true, run opening and closing scripts as appropriate"

	| pageMorph |
	pages isEmpty ifTrue: [^ self].
	pageMorph := (self hasProperty: #dontWrapAtEnd)
		ifTrue: [pages atPin: pageNumber]
		ifFalse: [pages atWrap: pageNumber].
	^ self goToPageMorph: pageMorph transitionSpec: transitionSpec runTransitionScripts: aBoolean! !

!BookMorph methodsFor: 'navigation' stamp: 'sw 11/8/2002 21:30'!
goToPageMorph: aMorph
	"Set the given morph as the current page; run closing and opening scripts as appropriate"

	self goToPageMorph: aMorph runTransitionScripts: true! !

!BookMorph methodsFor: 'navigation' stamp: 'di 1/4/1999 12:37'!
goToPageMorph: aMorph fromBookmark: aBookmark
	"This protocol enables sensitivity to a transitionSpec on the bookmark"
	
	self goToPageMorph: aMorph
		transitionSpec: (aBookmark valueOfProperty: #transitionSpec).
! !

!BookMorph methodsFor: 'navigation' stamp: 'stephane.ducasse 10/8/2008 17:56'!
goToPageMorph: aMorph runTransitionScripts: aBoolean
	"Set the given morph as the current page.  If the boolean parameter is true, then opening and closing scripts will be run"

	self goToPage: (pages identityIndexOf: aMorph ifAbsent: [^ self "abort"]) transitionSpec: nil runTransitionScripts: aBoolean
! !

!BookMorph methodsFor: 'navigation' stamp: 'stephane.ducasse 10/8/2008 17:53'!
goToPageMorph: newPage transitionSpec: transitionSpec 
	| pageIndex aWorld oldPageIndex ascending tSpec readIn |
	pages isEmpty ifTrue: [^self].
	self setProperty: #searchContainer toValue: nil.	"forget previous search"
	self setProperty: #searchOffset toValue: nil.
	self setProperty: #searchKey toValue: nil.
	pageIndex := pages identityIndexOf: newPage ifAbsent: [^self	"abort"].
	readIn := newPage isInMemory not.
	oldPageIndex := pages identityIndexOf: currentPage ifAbsent: [nil].
	ascending := (oldPageIndex isNil or: [newPage == currentPage]) 
				ifTrue: [nil]
				ifFalse: [oldPageIndex < pageIndex].
	tSpec := transitionSpec ifNil: 
					["If transition not specified by requestor..."

					newPage valueOfProperty: #transitionSpec
						ifAbsent: 
							[" ... then consult new page"

							self transitionSpecFor: self	" ... otherwise this is the default"]].
	self flag: #arNote.	"Probably unnecessary"
	(aWorld := self world) ifNotNil: [self primaryHand releaseKeyboardFocus].
	currentPage ifNotNil: [currentPage updateCachedThumbnail].
	self currentPage notNil 
		ifTrue: 
			[(((pages at: pageIndex) owner isKindOf: TransitionMorph) 
				and: [(pages at: pageIndex) isInWorld]) 
					ifTrue: [^self	"In the process of a prior pageTurn"].
			ascending ifNotNil: 
					["Show appropriate page transition and start new page when done"

					currentPage stopStepping.
					(pages at: pageIndex) position: currentPage position.
					^(TransitionMorph 
						effect: tSpec second
						direction: tSpec third
						inverse: (ascending or: [transitionSpec notNil]) not) 
							showTransitionFrom: currentPage
							to: (pages at: pageIndex)
							in: self
							whenStart: [self playPageFlipSound: tSpec first]
							whenDone: 
								[currentPage
									delete;
									fullReleaseCachedState.
								self insertPageMorphInCorrectSpot: (pages at: pageIndex).
								self adjustCurrentPageForFullScreen.
								self snapToEdgeIfAppropriate.
								aWorld ifNotNil: [self world startSteppingSubmorphsOf: currentPage].
								(aWorld := self world) ifNotNil: 
										["WHY??"

										aWorld displayWorld].
								readIn 
									ifTrue: 
										[currentPage updateThumbnailUrlInBook: self url.
										currentPage sqkPage computeThumbnail	"just store it"]]].

			"No transition, but at least decommission current page"
			currentPage
				delete;
				fullReleaseCachedState].
	self insertPageMorphInCorrectSpot: (pages at: pageIndex).
	self adjustCurrentPageForFullScreen.
	self snapToEdgeIfAppropriate.
	aWorld ifNotNil: [self world startSteppingSubmorphsOf: currentPage].
	(aWorld := self world) ifNotNil: 
			["WHY??"

			aWorld displayWorld].
	readIn 
		ifTrue: 
			[currentPage updateThumbnailUrl.
			currentPage sqkPage computeThumbnail	"just store it"]! !

!BookMorph methodsFor: 'navigation' stamp: 'stephane.ducasse 10/8/2008 18:03'!
goToPageMorph: newPage transitionSpec: transitionSpec runTransitionScripts: aBoolean 
	"Install the given page as the new current page; use the given transition spec, and if the boolean parameter is true, run closing and opening scripts on the outgoing and incoming players"

	| pageIndex aWorld oldPageIndex ascending tSpec readIn |
	pages isEmpty ifTrue: [^self].
	self setProperty: #searchContainer toValue: nil.	"forget previous search"
	self setProperty: #searchOffset toValue: nil.
	self setProperty: #searchKey toValue: nil.
	pageIndex := pages identityIndexOf: newPage ifAbsent: [^self	"abort"].
	readIn := newPage isInMemory not.
	oldPageIndex := pages identityIndexOf: currentPage ifAbsent: [nil].
	ascending := (oldPageIndex isNil or: [newPage == currentPage]) 
				ifTrue: [nil]
				ifFalse: [oldPageIndex < pageIndex].
	tSpec := transitionSpec ifNil: 
					["If transition not specified by requestor..."

					newPage valueOfProperty: #transitionSpec
						ifAbsent: 
							[" ... then consult new page"

							self transitionSpecFor: self	" ... otherwise this is the default"]].
	self flag: #arNote.	"Probably unnecessary"
	(aWorld := self world) ifNotNil: [self primaryHand releaseKeyboardFocus].
	currentPage ifNotNil: [currentPage updateCachedThumbnail].
	self currentPage notNil 
		ifTrue: 
			[(((pages at: pageIndex) owner isKindOf: TransitionMorph) 
				and: [(pages at: pageIndex) isInWorld]) 
					ifTrue: [^self	"In the process of a prior pageTurn"].
			ascending ifNotNil: 
					["Show appropriate page transition and start new page when done"

					currentPage stopStepping.
					(pages at: pageIndex) position: currentPage position.
					^(TransitionMorph 
						effect: tSpec second
						direction: tSpec third
						inverse: (ascending or: [transitionSpec notNil]) not) 
							showTransitionFrom: currentPage
							to: (pages at: pageIndex)
							in: self
							whenStart: [self playPageFlipSound: tSpec first]
							whenDone: 
								[currentPage
									delete;
									fullReleaseCachedState.
								self insertPageMorphInCorrectSpot: (pages at: pageIndex).
								self adjustCurrentPageForFullScreen.
								self snapToEdgeIfAppropriate.
								aWorld ifNotNil: [self world startSteppingSubmorphsOf: currentPage].
								.
								(aWorld := self world) ifNotNil: 
										["WHY??"

										aWorld displayWorld].
								readIn 
									ifTrue: 
										[currentPage updateThumbnailUrlInBook: self url.
										currentPage sqkPage computeThumbnail	"just store it"]]].

			"No transition, but at least decommission current page"
			currentPage
				delete;
				fullReleaseCachedState].
	self insertPageMorphInCorrectSpot: (pages at: pageIndex).
	self adjustCurrentPageForFullScreen.
	self snapToEdgeIfAppropriate.
	aWorld ifNotNil: [self world startSteppingSubmorphsOf: currentPage].
	(aWorld := self world) ifNotNil: 
			["WHY??"

			aWorld displayWorld].
	readIn 
		ifTrue: 
			[currentPage updateThumbnailUrl.
			currentPage sqkPage computeThumbnail	"just store it"]! !

!BookMorph methodsFor: 'navigation' stamp: 'dgd 2/21/2003 23:10'!
goToPageUrl: aUrl 
	| pp short |
	pp := pages detect: [:pg | pg url = aUrl] ifNone: [nil].
	pp ifNil: 
			[short := (aUrl findTokens: '/') last.
			pp := pages detect: 
							[:pg | 
							pg url ifNil: [false] ifNotNil: [(pg url findTokens: '/') last = short]	"it moved"]
						ifNone: [pages first]].
	self goToPageMorph: pp! !

!BookMorph methodsFor: 'navigation' stamp: 'sw 10/26/1998 15:41'!
goto: aPlayer
	self goToPageMorph: aPlayer costume! !

!BookMorph methodsFor: 'menu' stamp: 'gm 2/22/2003 13:17'!
highlightText: stringToHilite at: index in: insideOf 
	"Find the container with this text and highlight it.  May not be able to do it for stringMorphs."

	"Find the container with that text"

	| container |
	self 
		allMorphsDo: [:sub | insideOf == sub userString ifTrue: [container := sub]].
	container ifNil: 
			[self 
				allMorphsDo: [:sub | insideOf = sub userString ifTrue: [container := sub]]].	"any match"
	container ifNil: [^nil].

	"Order it highlighted"
	(container isTextMorph) 
		ifTrue: 
			[container editor selectFrom: index to: stringToHilite size - 1 + index].
	container changed.
	^container! !

!BookMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:09'!
initialize
"initialize the state of the receiver"
	super initialize.
""
	self setInitialState.
	pages := OrderedCollection new.
	self showPageControls.
	self class
		turnOffSoundWhile: [self insertPage]! !

!BookMorph methodsFor: 'parts bin' stamp: 'sw 8/2/2001 16:52'!
initializeToStandAlone
	self initialize.
	self removeEverything; pageSize: 360@228; color: (Color gray: 0.9).
	self borderWidth: 1; borderColor: Color black.
	self beSticky.
	self showPageControls; insertPage.
	^ self! !

!BookMorph methodsFor: 'insert and delete' stamp: 'sw 10/12/97 21:48'!
insertPage: aPage pageSize: aPageSize
	^ self insertPage: aPage pageSize: aPageSize atIndex: (pages size + 1)! !

!BookMorph methodsFor: 'insert and delete' stamp: 'dgd 2/21/2003 23:10'!
insertPage: aPage pageSize: aPageSize atIndex: anIndex 
	| sz predecessor |
	sz := aPageSize 
				ifNil: [currentPage isNil ifTrue: [pageSize] ifFalse: [currentPage extent]]
				ifNotNil: [aPageSize].
	aPage extent: sz.
	(pages isEmpty | anIndex isNil or: [anIndex > pages size]) 
		ifTrue: [pages add: aPage]
		ifFalse: 
			[anIndex <= 1 
				ifTrue: [pages addFirst: aPage]
				ifFalse: 
					[predecessor := anIndex isNil 
								ifTrue: [currentPage]
								ifFalse: [pages at: anIndex].
					self pages add: aPage after: predecessor]].
	self goToPageMorph: aPage! !

!BookMorph methodsFor: 'insert and delete' stamp: 'dgd 2/21/2003 23:11'!
insertPageColored: aColor 
	"Insert a new page for the receiver, using the given color as its background color"

	| sz newPage bw bc |
	bc := currentPage isNil 
				ifTrue: 
					[sz := pageSize.
					bw := 0.
					Color blue muchLighter]
				ifFalse: 
					[sz := currentPage extent.
					bw := currentPage borderWidth.
					currentPage borderColor].
	newPagePrototype ifNil: 
			[newPage := (PasteUpMorph new)
						extent: sz;
						color: aColor.
			newPage
				borderWidth: bw;
				borderColor: bc]
		ifNotNil: [Cursor wait showWhile: [newPage := newPagePrototype veryDeepCopy]].
	newPage setNameTo: self defaultNameStemForNewPages.
	newPage vResizeToFit: false.
	pages isEmpty 
		ifTrue: [pages add: (currentPage := newPage)]
		ifFalse: [pages add: newPage after: currentPage].
	self nextPage! !

!BookMorph methodsFor: 'insert and delete' stamp: 'ar 11/9/2000 21:10'!
insertPageLabel: labelString morphs: morphList

	| m c labelAllowance |
	self insertPage.
	labelString ifNotNil:
			[m := (TextMorph new extent: currentPage width@20; contents: labelString).
		m lock.
		m position: currentPage position + (((currentPage width - m width) // 2) @ 5).
		currentPage addMorph: m.
		labelAllowance := 40]
		ifNil:
			[labelAllowance := 0].

	"use a column to align the given morphs, then add them to the page"
	c := AlignmentMorph newColumn wrapCentering: #center; cellPositioning: #topCenter.
	c addAllMorphs: morphList.
	c position: currentPage position + (0 @ labelAllowance).
	currentPage addAllMorphs: morphList.
	^ currentPage
! !

!BookMorph methodsFor: 'navigation' stamp: 'stephane.ducasse 10/8/2008 17:51'!
insertPageMorphInCorrectSpot: aPageMorph

	self addMorphBack: (currentPage := aPageMorph).
! !

!BookMorph methodsFor: 'menu' stamp: 'dgd 4/3/2006 13:08'!
invokeBookMenu
	"Invoke the book's control panel menu."
	| aMenu |
	aMenu := MenuMorph new defaultTarget: self.
	aMenu addTitle: 'Book' translated.
	Preferences noviceMode
		ifFalse:[aMenu addStayUpItem].
	aMenu add: 'find...' translated action: #textSearch.
	aMenu add: 'go to page...' translated action: #goToPage.
	aMenu addLine.

	aMenu addList: {
		{'sort pages' translated.		#sortPages}.
		{'uncache page sorter' translated.	#uncachePageSorter}}.
	(self hasProperty: #dontWrapAtEnd)
		ifTrue: [aMenu add: 'wrap after last page' translated selector: #setWrapPages: argument: true]
		ifFalse: [aMenu add: 'stop at last page' translated selector: #setWrapPages: argument: false].
	aMenu addList: {
		{'make bookmark' translated.		#bookmarkForThisPage}.
		{'make thumbnail' translated.		#thumbnailForThisPage}}.
	aMenu addUpdating: #showingPageControlsString action: #toggleShowingOfPageControls.
	aMenu addUpdating: #showingFullScreenString action: #toggleFullScreen.

	aMenu addLine.
	aMenu add: 'sound effect for all pages' translated action: #menuPageSoundForAll:.
	aMenu add: 'sound effect this page only' translated action: #menuPageSoundForThisPage:.
	aMenu add: 'visual effect for all pages' translated action: #menuPageVisualForAll:.
	aMenu add: 'visual effect this page only' translated action: #menuPageVisualForThisPage:.

	aMenu addLine.
	(self primaryHand pasteBuffer class isKindOf: PasteUpMorph class) ifTrue:
		[aMenu add: 'paste book page' translated   action: #pasteBookPage].

	aMenu add: 'save as new-page prototype' translated action: #setNewPagePrototype.
	newPagePrototype ifNotNil: [
		aMenu add: 'clear new-page prototype' translated action: #clearNewPagePrototype].

	aMenu add: (self dragNDropEnabled ifTrue: ['close dragNdrop'] ifFalse: ['open dragNdrop']) translated
			action: #toggleDragNDrop.
	aMenu add: 'make all pages this size' translated action: #makeUniformPageSize.
	
	aMenu
		addUpdating: #keepingUniformPageSizeString
		target: self
		action: #toggleMaintainUniformPageSize.
	aMenu addLine.

	aMenu add: 'send all pages to server' translated action: #savePagesOnURL.
	aMenu add: 'send this page to server' translated action: #saveOneOnURL.
	aMenu add: 'reload all from server' translated action: #reload.
	aMenu add: 'copy page url to clipboard' translated action: #copyUrl.
	aMenu add: 'keep in one file' translated action: #keepTogether.

	aMenu addLine.
	aMenu add: 'load PPT images from slide #1' translated action: #loadImagesIntoBook.
	aMenu add: 'background color for all pages...' translated action: #setPageColor.
	aMenu add: 'make a thread of projects in this book' translated action: #buildThreadOfProjects.

	aMenu popUpEvent: self world activeHand lastEvent in: self world
! !

!BookMorph methodsFor: 'other' stamp: 'RAA 8/23/2000 11:58'!
isInFullScreenMode

	^self valueOfProperty: #fullScreenMode ifAbsent: [false]! !

!BookMorph methodsFor: 'menu' stamp: 'tk 12/2/1998 19:31'!
keepTogether
	"Mark this book so that each page will not go into a separate file.  Do this when pages share referenes to a common Player.  Don't want many copies of that Player when bring in.  Do not write pages of book out.  Write the PasteUpMorph that the entire book lives in."

	self setProperty: #keepTogether toValue: true.! !

!BookMorph methodsFor: 'uniform page size' stamp: 'sw 3/3/2004 18:39'!
keepingUniformPageSizeString
	"Answer a string characterizing whether I am currently maintaining uniform page size"

	^ (self maintainsUniformPageSize
		ifTrue: ['<yes>']
		ifFalse: ['<no>']), 'keep all pages the same size' translated! !

!BookMorph methodsFor: 'navigation' stamp: 'sw 8/4/97 12:05'!
lastPage
	self goToPage: pages size
! !

!BookMorph methodsFor: 'menu' stamp: 'nk 6/12/2004 09:23'!
loadImagesIntoBook
	"PowerPoint stores GIF presentations as individual slides named Slide1, Slide2, etc.
	Load these into the book.  mjg 9/99"

	| directory filenumber form newpage |
	directory := ((StandardFileMenu oldFileFrom: FileDirectory default) 
				ifNil: [^nil]) directory.
	directory isNil ifTrue: [^nil].

	"Start loading 'em up!!"
	filenumber := 1.
	[directory fileExists: 'Slide' , filenumber asString] whileTrue: 
			[Transcript
				show: 'Slide' , filenumber asString;
				cr.
			Smalltalk bytesLeft < 1000000 
				ifTrue: 
					["Make some room"

					(self valueOfProperty: #url) isNil 
						ifTrue: [self savePagesOnURL]
						ifFalse: [self saveAsNumberedURLs]].
			form := Form 
						fromFileNamed: (directory fullNameFor: 'Slide' , filenumber asString).
			newpage := PasteUpMorph new extent: form extent.
			newpage addMorph: (World drawingClass withForm: form).
			self pages addLast: newpage.
			filenumber := filenumber + 1].

	"After adding all, delete the first page."
	self goToPage: 1.
	self deletePageBasic.

	"Save the book"
	(self valueOfProperty: #url) isNil 
		ifTrue: [self savePagesOnURL]
		ifFalse: [self saveAsNumberedURLs]! !

!BookMorph methodsFor: 'uniform page size' stamp: 'sw 6/6/2003 13:56'!
maintainsUniformPageSize
	"Answer whether I am currently set up to maintain uniform page size"

	^ self uniformPageSize notNil! !

!BookMorph methodsFor: 'uniform page size' stamp: 'sw 6/6/2003 13:56'!
maintainsUniformPageSize: aBoolean
	"Set the property governing whether I maintain uniform page size"

	aBoolean
		ifFalse:
			[self removeProperty: #uniformPageSize]
		ifTrue:
			[self setProperty: #uniformPageSize toValue: currentPage extent]! !

!BookMorph methodsFor: 'menu' stamp: 'nb 6/17/2003 12:25'!
makeUniformPageSize
	"Make all pages be of the same size as the current page."
	currentPage ifNil: [^ Beeper beep].
	self resizePagesTo: currentPage extent.
	newPagePrototype ifNotNil:
		[newPagePrototype extent: currentPage extent]! !

!BookMorph methodsFor: 'menu' stamp: 'em 3/30/2005 14:35'!
menuPageSoundFor: target event: evt
	| tSpec menu |
	tSpec := self transitionSpecFor: target.
	menu := (MenuMorph entitled: 'Choose a sound
(it is now ' translated, tSpec first translated, ')') defaultTarget: target.
	SoundService default sampledSoundChoices do:
		[:soundName |
		menu add: soundName translated target: target
			selector: #setProperty:toValue:
			argumentList: (Array with: #transitionSpec
								with: (tSpec copy at: 1 put: soundName; yourself))].

	menu popUpEvent: evt in: self world! !

!BookMorph methodsFor: 'menu' stamp: 'di 12/20/1998 13:53'!
menuPageSoundForAll: evt

	^ self menuPageSoundFor: self event: evt! !

!BookMorph methodsFor: 'menu' stamp: 'di 12/20/1998 13:55'!
menuPageSoundForThisPage: evt

	currentPage ifNotNil:
		[^ self menuPageSoundFor: currentPage event: evt]! !

!BookMorph methodsFor: 'menu' stamp: 'dgd 10/26/2003 13:39'!
menuPageVisualFor: target event: evt
	| tSpec menu subMenu directionChoices |
	tSpec := self transitionSpecFor: target.
	menu := (MenuMorph entitled: ('Choose an effect
(it is now {1})' translated format:{tSpec second asString translated})) defaultTarget: target.
	TransitionMorph allEffects do:
		[:effect |
		directionChoices := TransitionMorph directionsForEffect: effect.
		directionChoices isEmpty
		ifTrue: [menu add: effect asString translated target: target
					selector: #setProperty:toValue:
					argumentList: (Array with: #transitionSpec
									with: (Array with: tSpec first with: effect with: #none))]
		ifFalse: [subMenu := MenuMorph new.
				directionChoices do:
					[:dir |
					subMenu add: dir asString translated target: target
						selector: #setProperty:toValue:
						argumentList: (Array with: #transitionSpec
									with: (Array with: tSpec first with: effect with: dir))].
				menu add: effect asString translated subMenu: subMenu]].

	menu popUpEvent: evt in: self world! !

!BookMorph methodsFor: 'menu' stamp: 'di 12/20/1998 17:16'!
menuPageVisualForAll: evt

	^ self menuPageVisualFor: self event: evt! !

!BookMorph methodsFor: 'menu' stamp: 'di 12/20/1998 13:55'!
menuPageVisualForThisPage: evt

	currentPage ifNotNil:
		[^ self menuPageVisualFor: currentPage event: evt]! !

!BookMorph methodsFor: 'sorting' stamp: 'sw 3/5/1999 17:38'!
morphsForPageSorter
	| i thumbnails |
	'Assembling thumbnail images...'
		displayProgressAt: self cursorPoint
		from: 0 to: pages size
		during:
			[:bar | i := 0.
			thumbnails := pages collect:
				[:p | bar value: (i:= i+1).
				pages size > 40 
					ifTrue: [p smallThumbnailForPageSorter inBook: self]
					ifFalse: [p thumbnailForPageSorter inBook: self]]].
	^ thumbnails! !

!BookMorph methodsFor: 'initialization' stamp: 'sw 6/24/1998 09:23'!
newPages: pageList
	"Replace all my pages with the given list of BookPageMorphs.  After this call, currentPage may be invalid."

	pages := pages species new.
	pages addAll: pageList! !

!BookMorph methodsFor: 'initialization' stamp: 'jm 11/17/97 17:26'!
newPages: pageList currentIndex: index
	"Replace all my pages with the given list of BookPageMorphs. Make the current page be the page with the given index."

	pages := pages species new.
	pages addAll: pageList.
	pages isEmpty ifTrue: [^ self insertPage].
	self goToPage: index.
! !

!BookMorph methodsFor: 'navigation' stamp: 'dgd 2/21/2003 23:11'!
nextPage
	currentPage isNil ifTrue: [^self goToPage: 1].
	self goToPage: (self pageNumberOf: currentPage) + 1! !

!BookMorph methodsFor: 'menu' stamp: 'sw 5/23/2000 02:14'!
pageControlsVisible
	^ self hasSubmorphWithProperty: #pageControl! !

!BookMorph methodsFor: 'navigation' stamp: 'tk 12/24/1998 07:19'!
pageNumber

	^ self pageNumberOf: currentPage! !

!BookMorph methodsFor: 'accessing' stamp: 'tk 12/24/1998 07:27'!
pageNumberOf: aMorph
	"Modified so that if the page IS in memory, other pages don't have to be brought in.  (This method may wrongly say a page is not here if pages has a tombstone (MorphObjectOut) and that tombstone would resolve to an object already in this image.  This is an unlikely case, and callers just have to tolerate it.)"

	^ pages identityIndexOf: aMorph ifAbsent: [0]
! !

!BookMorph methodsFor: 'accessing' stamp: ''!
pages

	^ pages
! !

!BookMorph methodsFor: 'printing' stamp: 'RAA 2/1/2001 17:41'!
pagesHandledAutomatically

	^true! !

!BookMorph methodsFor: 'menu' stamp: 'sw 5/14/1998 11:04'!
pasteBookPage
	| aPage |
	aPage := self primaryHand objectToPaste.

	self insertPage: aPage pageSize: aPage extent atIndex: ((pages indexOf: currentPage) - 1).
	"self goToPageMorph: aPage"! !

!BookMorph methodsFor: 'navigation' stamp: 'dgd 2/21/2003 23:11'!
previousPage
	currentPage isNil ifTrue: [^self goToPage: 1].
	self goToPage: (self pageNumberOf: currentPage) - 1! !

!BookMorph methodsFor: 'menus' stamp: 'yo 7/2/2004 13:05'!
printPSToFile
	"Ask the user for a filename and print this morph as postscript."

	| fileName rotateFlag |
	fileName := ('MyBook') translated asFileName.
	fileName := FillInTheBlank request: 'File name? (".ps" will be added to end)' translated 
			initialAnswer: fileName.
	fileName isEmpty ifTrue: [^ Beeper beep].
	(fileName endsWith: '.ps') ifFalse: [fileName := fileName,'.ps'].

	rotateFlag := ((PopUpMenu labels:
'portrait (tall)
landscape (wide)' translated) 
			startUpWithCaption: 'Choose orientation...' translated) = 2.

	(FileStream newFileNamed: fileName asFileName)
		nextPutAll: (DSCPostscriptCanvas morphAsPostscript: self rotated: rotateFlag); close.

! !

!BookMorph methodsFor: 'caching' stamp: 'tk 3/11/2002 12:05'!
releaseCachedState
	"Release the cached state of all my pages."

	super releaseCachedState.
	self removeProperty: #allText.	"the cache for text search"
	pages do: [:page | 
		page == currentPage ifFalse: [page fullReleaseCachedState]].
! !

!BookMorph methodsFor: 'menu' stamp: 'dgd 10/26/2003 13:14'!
reload
	"Fetch the pages of this book from the server again.  For all pages that have not been modified, keep current ones.  Use new pages.  For each, look up in cache, if time there is equal to time of new, and its in, use the current morph.
	Later do fancy things when a page has changed here, and also on the server."

	| url onServer onPgs sq which |
	(url := self valueOfProperty: #url) ifNil: ["for .bo index file"
	url := FillInTheBlank 
		request: 'url of the place where this book''s index is stored.
Must begin with file:// or ftp://' translated
		initialAnswer: (self getStemUrl, '.bo').
	url notEmpty ifTrue: [self setProperty: #url toValue: url]
				ifFalse: [^ self]].
	onServer := self class new fromURL: url.
	"Later: test book times?"
	onPgs := onServer pages collect: [:out |
		sq := SqueakPageCache pageCache at: out url ifAbsent: [nil].
		(sq notNil and: [sq contentsMorph isInMemory])
			ifTrue: [((out sqkPage lastChangeTime > sq lastChangeTime) or: 
					  [sq contentsMorph isNil]) 
						ifTrue: [SqueakPageCache atURL: out url put: out sqkPage.
							out]
						ifFalse: [sq contentsMorph]]
			ifFalse: [SqueakPageCache atURL: out url put: out sqkPage.
				out]].
	which := (onPgs findFirst: [:pg | pg url = currentPage url]) max: 1.
	self newPages: onPgs currentIndex: which.
		"later stay at current page"
	self setProperty: #modTime toValue: (onServer valueOfProperty: #modTime).
	self setProperty: #allText toValue: (onServer valueOfProperty: #allText).
	self setProperty: #allTextUrls toValue: (onServer valueOfProperty: #allTextUrls).
! !

!BookMorph methodsFor: 'initialization' stamp: 'sw 7/4/1998 16:45'!
removeEverything
	currentPage := nil.
	pages := OrderedCollection new.
	self removeAllMorphs! !

!BookMorph methodsFor: 'menu' stamp: 'dgd 2/21/2003 23:12'!
reserveUrls
	"Save a dummy version of the book first, assign all pages URLs, write dummy files to reserve the url, and write the index.  Good when I have pages with interpointing bookmarks."

	| stem |
	(stem := self getStemUrl) isEmpty ifTrue: [^self].
	pages doWithIndex: 
			[:pg :ind | 
			"does write the current page too"

			pg url ifNil: [pg reserveUrl: stem , ind printString , '.sp']]

	"self saveIndexOnURL."! !

!BookMorph methodsFor: 'menu' stamp: 'tk 2/25/1999 10:37'!
reserveUrlsIfNeeded
	"See if this book needs to pre-allocate urls.  Harmless if have urls already.  Actually writes dummy files to reserve names."

| baddies bad2 |
pages size > 25 ifTrue: [^ self reserveUrls].
baddies := BookPageThumbnailMorph withAllSubclasses.
bad2 := FlexMorph withAllSubclasses.
pages do: [:aPage |
	aPage allMorphsDo: [:mm | 
		(baddies includes: mm class) ifTrue: [^ self reserveUrls].
		(bad2 includes: mm class) ifTrue: [
			mm originalMorph class == aPage class ifTrue: [
				^ self reserveUrls]]]].
		
! !

!BookMorph methodsFor: 'other' stamp: 'sw 10/1/1998 13:40'!
resizePagesTo: anExtent
	pages do:
		[:aPage | aPage extent: anExtent]! !

!BookMorph methodsFor: 'menu' stamp: 'dgd 2/21/2003 23:12'!
saveAsNumberedURLs
	"Write out all pages in this book that are not showing, onto a server.  The local disk could be the server.  For any page that does not have a SqueakPage and a url already, name that page file by its page number.  Any pages that are already totally out will stay that way."

	| stem list firstTime |
	firstTime := (self valueOfProperty: #url) isNil.
	stem := self getStemUrl.	"user must approve"
	stem isEmpty ifTrue: [^self].
	firstTime ifTrue: [self setProperty: #futureUrl toValue: stem , '.bo'].
	self reserveUrlsIfNeeded.
	pages doWithIndex: 
			[:aPage :ind | 
			"does write the current page too"

			aPage isInMemory 
				ifTrue: 
					["not out now"

					aPage presenter ifNotNil: [aPage presenter flushPlayerListCache].
					aPage saveOnURL: stem , ind printString , '.sp']].
	list := pages collect: [:aPage | aPage sqkPage prePurge].
	"knows not to purge the current page"
	list := (list select: [:each | each notNil]) asArray.
	"do bulk become:"
	(list collect: [:each | each contentsMorph]) 
		elementsExchangeIdentityWith: (list 
				collect: [:spg | MorphObjectOut new xxxSetUrl: spg url page: spg]).
	self saveIndexOnURL.
	self presenter ifNotNil: [self presenter flushPlayerListCache].
	firstTime 
		ifTrue: 
			["Put a thumbnail into the hand"

			URLMorph grabForBook: self.
			self setProperty: #futureUrl toValue: nil	"clean up"]! !

!BookMorph methodsFor: 'menu' stamp: 'ar 4/10/2005 18:42'!
saveIndexOfOnly: aPage
	"Modify the index of this book on a server.  Read the index, modify the entry for just this page, and write back.  See saveIndexOnURL. (page file names must be unique even if they live in different directories.)"

	| mine sf remoteFile strm remote pageURL num pre index after dict allText allTextUrls fName |
	mine := self valueOfProperty: #url.
	mine ifNil: [^ self saveIndexOnURL].
	Cursor wait showWhile: [strm := (ServerFile new fullPath: mine)].
	strm ifNil: [^ self saveIndexOnURL].
	strm isString ifTrue: [^ self saveIndexOnURL].
	strm exists ifFalse: [^ self saveIndexOnURL].	"write whole thing if missing"
	strm := strm asStream.
	strm isString ifTrue: [^ self saveIndexOnURL].
	remote := strm fileInObjectAndCode.
	dict := remote first.
	allText := dict at: #allText ifAbsent: [nil].	"remote, not local"
	allTextUrls := dict at: #allTextUrls ifAbsent: [nil].
	allText size + 1 ~= remote size ifTrue: [self error: '.bo size mismatch.  Please tell Ted what you just did to this book.' translated].


	(pageURL := aPage url) ifNil: [self error: 'just had one!!' translated].
	fName := pageURL copyAfterLast: $/.
	2 to: remote size do: [:ii | 
		((remote at: ii) url findString: fName startingAt: 1 
						caseSensitive: false) > 0 ifTrue: [index := ii].	"fast"
		(remote at: ii) xxxReset].
	index ifNil: ["new page, what existing page does it follow?"
		num := self pageNumberOf: aPage.
		1 to: num-1 do: [:ii | (pages at: ii) url ifNotNil: [pre := (pages at: ii) url]].
		pre ifNil: [after := remote size+1]
			ifNotNil: ["look for it on disk, put me after"
				pre := pre copyAfterLast: $/.
				2 to: remote size do: [:ii | 
					((remote at: ii) url findString: pre startingAt: 1 
								caseSensitive: false) > 0 ifTrue: [after := ii+1]].
				after ifNil: [after := remote size+1]].
		remote := remote copyReplaceFrom: after to: after-1 with: #(1).
		allText ifNotNil: [
			dict at: #allText put: (allText copyReplaceFrom: after-1 to: after-2 with: #(())).
			dict at: #allTextUrls put: (allTextUrls copyReplaceFrom: after-1 to: after-2 with: #(()))].
		index := after].

	remote at: index put: (aPage sqkPage copyForSaving).

	(dict at: #modTime ifAbsent: [0]) < Time totalSeconds ifTrue:
		[dict at: #modTime put: Time totalSeconds].
	allText ifNotNil: [
		(dict at: #allText) at: index-1 put: (aPage allStringsAfter: nil).
		(dict at: #allTextUrls) at: index-1 put: pageURL].

	sf := ServerDirectory new fullPath: mine.
	Cursor wait showWhile: [
		remoteFile := sf fileNamed: mine.
		remoteFile fileOutClass: nil andObject: remote.
		"remoteFile close"].
! !

!BookMorph methodsFor: 'menu' stamp: 'dgd 2/21/2003 23:12'!
saveIndexOnURL
	"Make up an index to the pages of this book, with thumbnails, and store it on the server.  (aDictionary, aMorphObjectOut, aMorphObjectOut, aMorphObjectOut).  The last part corresponds exactly to what pages looks like when they are all out.  Each holds onto a SqueakPage, which holds a url and a thumbnail."

	| dict list mine sf remoteFile urlList |
	pages isEmpty ifTrue: [^self].
	dict := Dictionary new.
	dict at: #modTime put: Time totalSeconds.
	"self getAllText MUST have been called at start of this operation."
	dict at: #allText put: (self valueOfProperty: #allText).
	#(#color #borderWidth #borderColor #pageSize) 
		do: [:sel | dict at: sel put: (self perform: sel)].
	self reserveUrlsIfNeeded.	"should already be done"
	list := pages copy.	"paste dict on front below"
	"Fix up the entries, should already be done"
	list doWithIndex: 
			[:out :ind | 
			out isInMemory 
				ifTrue: 
					[(out valueOfProperty: #SqueakPage) ifNil: [out saveOnURLbasic].
					list at: ind put: out sqkPage copyForSaving]].
	urlList := list collect: [:ppg | ppg url].
	self setProperty: #allTextUrls toValue: urlList.
	dict at: #allTextUrls put: urlList.
	list := (Array with: dict) , list.
	mine := self valueOfProperty: #url.
	mine ifNil: 
			[mine := self getStemUrl , '.bo'.
			self setProperty: #url toValue: mine].
	sf := ServerDirectory new fullPath: mine.
	Cursor wait showWhile: 
			[remoteFile := sf fileNamed: mine.
			remoteFile dataIsValid.
			remoteFile fileOutClass: nil andObject: list
			"remoteFile close"]! !

!BookMorph methodsFor: 'menu' stamp: 'dgd 10/26/2003 13:18'!
saveOnUrlPage: pageMorph
	"Write out this single page in this book onto a server.  See savePagesOnURL.  (Don't compute the texts, only this page's is written.)"
	| stem ind response rand newPlace dir |
	(self valueOfProperty: #keepTogether) ifNotNil: [
		self inform: 'This book is marked ''keep in one file''. 
Several pages use a common Player.
Save the owner of the book instead.' translated.
		^ self].
	"Don't give the chance to put in a different place.  Assume named by number"
	((self valueOfProperty: #url) isNil and: [pages first url notNil]) ifTrue: [
		response := (PopUpMenu labels: 'Old book
New book sharing old pages' translated)
				startUpWithCaption: 'Modify the old book, or make a new
book sharing its pages?' translated.
		response = 2 ifTrue: [
			"Make up new url for .bo file and confirm with user."  "Mark as shared"
			[rand := String new: 4.
			1 to: rand size do: [:ii |
				rand at: ii put: ('bdfghklmnpqrstvwz' at: 17 atRandom)].
			(newPlace := self getStemUrl) isEmpty ifTrue: [^ self].
			newPlace := (newPlace copyUpToLast: $/), '/BK', rand, '.bo'.
			dir := ServerFile new fullPath: newPlace.
			(dir includesKey: dir fileName)] whileTrue.	"keep doing until a new file"
			self setProperty: #url toValue: newPlace].
		response = 0 ifTrue: [^ self]].

	stem := self getStemUrl.	"user must approve"
	stem isEmpty ifTrue: [^ self].
	ind := pages identityIndexOf: pageMorph ifAbsent: [self error: 'where is the page?' translated].
	pageMorph isInMemory ifTrue: ["not out now"
			pageMorph saveOnURL: stem,(ind printString),'.sp'].
	self saveIndexOfOnly: pageMorph.! !

!BookMorph methodsFor: 'menu' stamp: 'tk 1/12/1999 18:58'!
saveOneOnURL
	"Write out this single page onto a server.  See savePagesOnURL.  (Don't compute the texts, only this page's is written.)"

	^ self saveOnUrlPage: currentPage! !

!BookMorph methodsFor: 'menu' stamp: 'dgd 10/26/2003 13:20'!
savePagesOnURL
	"Write out all pages in this book onto a server.  For any page that does not have a SqueakPage and a url already, ask the user for one.  Give the option of naming all page files by page number.  Any pages that are not in memory will stay that way.  The local disk could be the server."

	| response list firstTime newPlace rand dir bookUrl |
	(self valueOfProperty: #keepTogether) ifNotNil: [
		self inform: 'This book is marked ''keep in one file''. 
Several pages use a common Player.
Save the owner of the book instead.' translated.
		^ self].
	self getAllText.	"stored with index later"
	response := (PopUpMenu labels: 'Use page numbers
Type in file names
Save in a new place (using page numbers)
Save in a new place (typing names)
Save new book sharing old pages' translated)
			startUpWithCaption: 'Each page will be a file on the server.  
Do you want to page numbers be the names of the files? 
or name each one yourself?' translated.
	response = 1 ifTrue: [self saveAsNumberedURLs. ^ self].
	response = 3 ifTrue: [self forgetURLs; saveAsNumberedURLs. ^ self].
	response = 4 ifTrue: [self forgetURLs].
	response = 5 ifTrue: [
		"Make up new url for .bo file and confirm with user."  "Mark as shared"
		[rand := String new: 4.
		1 to: rand size do: [:ii |
			rand at: ii put: ('bdfghklmnpqrstvwz' at: 17 atRandom)].
		(newPlace := self getStemUrl) isEmpty ifTrue: [^ self].
		newPlace := (newPlace copyUpToLast: $/), '/BK', rand, '.bo'.
		dir := ServerFile new fullPath: newPlace.
		(dir includesKey: dir fileName)] whileTrue.	"keep doing until a new file"

		self setProperty: #url toValue: newPlace.
		self saveAsNumberedURLs. 
		bookUrl := self valueOfProperty: #url.
		(SqueakPage stemUrl: bookUrl) = 
			(SqueakPage stemUrl: currentPage url) ifTrue: [
				bookUrl := true].		"not a shared book"
		(URLMorph grabURL: currentPage url) book: bookUrl.
		^ self].
	response = 0 ifTrue: [^ self].

"self reserveUrlsIfNeeded.	Need two passes here -- name on one, write on second"
pages do: [:aPage |	"does write the current page too"
	aPage isInMemory ifTrue: ["not out now"
		aPage presenter ifNotNil: [aPage presenter flushPlayerListCache].
		aPage saveOnURLbasic.
		]].	"ask user if no url"

list := pages collect: [:aPage |	 aPage sqkPage prePurge].
	"knows not to purge the current page"
list := (list select: [:each | each notNil]) asArray.
"do bulk become:"
(list collect: [:each | each contentsMorph])
	elementsExchangeIdentityWith:
		(list collect: [:spg | MorphObjectOut new xxxSetUrl: spg url page: spg]).

firstTime := (self valueOfProperty: #url) isNil.
self saveIndexOnURL.
self presenter ifNotNil: [self presenter flushPlayerListCache].
firstTime ifTrue: ["Put a thumbnail into the hand"
	URLMorph grabForBook: self.
	self setProperty: #futureUrl toValue: nil].	"clean up"
! !

!BookMorph methodsFor: 'accessing' stamp: 'mjg 9/28/1999 11:57'!
setAllPagesColor: aColor
	"Set the color of all the pages to a new color"

	self pages do: [:page | page color: aColor].! !

!BookMorph methodsFor: 'other' stamp: 'sw 6/6/2003 17:21'!
setExtentFromHalo: anExtent
	"The user has dragged the grow box such that the receiver's extent would be anExtent.  Do what's needed.  For a BookMorph, we assume any resizing attempt is a request that the book-page currently being viewed be resized accoringly; this will typically not affect unseen book pages, though there is a command that can be issued to harmonize all book-page sizes, and also an option to set that will maintain all pages at the same size no matter what."

	currentPage isInWorld
		ifFalse: "doubtful case mostly"
			[super setExtentFromHalo: anExtent]
		ifTrue:
			[currentPage width: anExtent x.
			currentPage height: (anExtent y - (self innerBounds height - currentPage height)).
			self maintainsUniformPageSize ifTrue:
				[self setProperty: #uniformPageSize toValue: currentPage extent]]! !

!BookMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:07'!
setInitialState
	self listDirection: #topToBottom;
	  wrapCentering: #topLeft;
	  hResizing: #shrinkWrap;
	  vResizing: #shrinkWrap;
	  layoutInset: 5.
	pageSize := 160 @ 300.
	self enableDragNDrop! !

!BookMorph methodsFor: 'menu' stamp: 'tk 8/13/1998 12:09'!
setNewPagePrototype
	"Record the current page as the prototype to be copied when inserting new pages."

	currentPage ifNotNil:
		[newPagePrototype := currentPage veryDeepCopy].
! !

!BookMorph methodsFor: 'menu' stamp: 'sw 9/6/2000 18:43'!
setPageColor
	"Get a color from the user, then set all the pages to that color"

	self currentPage ifNil: [^ self].
	ColorPickerMorph new
		choseModalityFromPreference;
		sourceHand: self activeHand;
		target: self;
		selector: #setAllPagesColor:;
		originalColor: self currentPage color;
		putUpFor: self near: self fullBoundsInWorld! !

!BookMorph methodsFor: 'navigation' stamp: 'di 1/14/1999 12:20'!
setWrapPages: doWrap
	doWrap
		ifTrue: [self removeProperty: #dontWrapAtEnd]
		ifFalse: [self setProperty: #dontWrapAtEnd toValue: true].
! !

!BookMorph methodsFor: 'navigation' stamp: 'sw 5/23/2000 13:11'!
showMoreControls
	self currentEvent shiftPressed
		ifTrue:
			[self hidePageControls]
		ifFalse:
			[self showPageControls: self fullControlSpecs]! !

!BookMorph methodsFor: 'menu commands' stamp: 'di 1/4/1999 13:52'!
sortPages

	currentPage ifNotNil: [currentPage updateCachedThumbnail].
	^ super sortPages! !

!BookMorph methodsFor: 'sorting' stamp: 'di 1/4/1999 12:12'!
sortPages: evt

	^ self sortPages! !

!BookMorph methodsFor: 'menu' stamp: 'dgd 10/26/2003 12:58'!
textSearch
	"search the text on all pages of this book"

	| wanted wants list str |
	list := self valueOfProperty: #searchKey ifAbsent: [#()].
	str := String streamContents: [:strm | 
			list do: [:each | strm nextPutAll: each; space]].
	wanted := FillInTheBlank request: 'words to search for.  Order is not important.
Beginnings of words are OK.' translated
		initialAnswer: str.
	wants := wanted findTokens: Character separators.
	wants isEmpty ifTrue: [^ self].
	self getAllText.		"save in allText, allTextUrls"
	^ self findText: wants	"goes to the page and highlights the text"! !

!BookMorph methodsFor: 'menu' stamp: 'di 1/4/1999 12:49'!
thumbnailForThisPage
	self primaryHand attachMorph:
		(currentPage thumbnailForPageSorter pageMorph: currentPage inBook: self)
! !

!BookMorph methodsFor: 'menu' stamp: 'RAA 8/23/2000 12:20'!
toggleFullScreen
	self isInFullScreenMode
		ifTrue:	[self exitFullScreen]
		ifFalse:	[self goFullScreen]! !

!BookMorph methodsFor: 'uniform page size' stamp: 'sw 6/6/2003 13:57'!
toggleMaintainUniformPageSize
	"Toggle whether or not the receiver should maintain uniform page size"

	self maintainsUniformPageSize: self maintainsUniformPageSize not! !

!BookMorph methodsFor: 'menu' stamp: 'sw 5/23/2000 02:18'!
toggleShowingOfPageControls
	self pageControlsVisible
		ifTrue:	[self hidePageControls]
		ifFalse:	[self showPageControls]! !

!BookMorph methodsFor: 'navigation' stamp: 'di 12/21/1998 11:15'!
transitionSpecFor: aMorph
	^ aMorph valueOfProperty: #transitionSpec  " check for special propety"
		ifAbsent: [Array with: 'camera'  " ... otherwise this is the default"
						with: #none
						with: #none]! !

!BookMorph methodsFor: 'menu' stamp: 'di 12/23/1998 14:55'!
uncachePageSorter
	pages do: [:aPage | aPage removeProperty: #cachedThumbnail].! !

!BookMorph methodsFor: 'uniform page size' stamp: 'sw 6/6/2003 13:57'!
uniformPageSize
	"Answer the uniform page size to maintain, or nil if the option is not set"

	^ self valueOfProperty: #uniformPageSize ifAbsent: [nil]! !

!BookMorph methodsFor: 'copying' stamp: 'jm 7/1/97 17:06'!
updateReferencesUsing: aDictionary

	super updateReferencesUsing: aDictionary.
	pages do: [:page |
		page allMorphsDo: [:m | m updateReferencesUsing: aDictionary]].
! !

!BookMorph methodsFor: 'accessing' stamp: 'tk 12/16/1998 12:05'!
userString
	"Do I have a text string to be searched on?"

	| list |
	self getAllText.
	list := OrderedCollection new.
	(self valueOfProperty: #allText ifAbsent: #()) do: [:aList |
		list addAll: aList].
	^ list! !

!BookMorph methodsFor: 'dropping/grabbing' stamp: 'di 9/30/1998 10:38'!
wantsDroppedMorph: aMorph event: evt
	(currentPage bounds containsPoint: (self pointFromWorld: evt cursorPoint)) ifFalse: [^ false].
	^ super wantsDroppedMorph: aMorph event: evt! !

BookMorph subclass: #TabbedPalette
	instanceVariableNames: 'tabsMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Palettes'!

!TabbedPalette commentStamp: '<historical>' prior: 0!
A structure of tabs and associated books.  Pressing a tab brings into focus the associated book.  Some tabs can have simple actions rather than books as their focus -- in this case, the palette is cleared and the action taken. !

!TabbedPalette classSide methodsFor: 'scripting' stamp: 'nk 6/12/2004 10:05'!
authoringPrototype
	| aTabbedPalette aBook aTab |
	aTabbedPalette := self new markAsPartsDonor.
	aTabbedPalette pageSize: 200 @ 300.
	aTabbedPalette tabsMorph highlightColor: Color red regularColor: Color blue.
	aTabbedPalette addMenuTab.

	aBook := BookMorph new setNameTo: 'one'; pageSize: aTabbedPalette pageSize.
	aBook color: Color blue muchLighter.
	aBook removeEverything; insertPage; showPageControls.
	aBook currentPage addMorphBack: (World drawingClass withForm: ScriptingSystem squeakyMouseForm).
	aTab := aTabbedPalette addTabForBook: aBook.

	aBook := BookMorph new setNameTo: 'two'; pageSize: aTabbedPalette pageSize.
	aBook color: Color red muchLighter.
	aBook removeEverything; insertPage; showPageControls.
	aBook currentPage addMorphBack: CurveMorph authoringPrototype.
	aTabbedPalette addTabForBook: aBook.

	aTabbedPalette selectTab: aTab.

	aTabbedPalette beSticky.
	aTabbedPalette tabsMorph hResizing: #spaceFill.
	^ aTabbedPalette! !

!TabbedPalette classSide methodsFor: 'printing' stamp: 'sw 6/3/1998 21:27'!
defaultNameStemForInstances
	^ 'tabbedPalette'! !

!TabbedPalette classSide methodsFor: 'parts bin' stamp: 'sw 8/12/2001 13:15'!
descriptionForPartsBin
	^ DescriptionForPartsBin
		formalName: 'TabbedPalette'
		categoryList: #('Presentation')
		documentation: 'A tabbed palette of books'
		globalReceiverSymbol: #TabbedPalette
		nativitySelector: #authoringPrototype! !

!TabbedPalette classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 11:40'!
initialize

	self registerInFlapsRegistry.	! !

!TabbedPalette classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 11:41'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(TabbedPalette	authoringPrototype	'TabbedPalette'	'A structure with tabs')
						forFlapNamed: 'Supplies'.]! !

!TabbedPalette classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 12:41'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

!TabbedPalette methodsFor: 'palette menu' stamp: 'nk 6/12/2004 10:05'!
addMenuTab
	"Add the menu tab.  This is ancient code, not much in the spirit of anything current"

	| aMenu aTab aGraphic sk |
	aMenu := MenuMorph new defaultTarget: self.
	aMenu stayUp: true.
	"aMenu add:  'clear' translated action: #showNoPalette."
	aMenu add:  'sort tabs' translated action: #sortTabs:.
	aMenu add:  'choose new colors for tabs' translated action: #recolorTabs.
	aMenu setProperty: #paletteMenu toValue: true.
	"aMenu add:  'make me the Standard palette' translated action: #becomeStandardPalette."
	aTab := self addTabForBook: aMenu  withBalloonText: 'a menu of palette-related controls' translated.
	aTab highlightColor: tabsMorph highlightColor; regularColor: tabsMorph regularColor.
	tabsMorph laySubpartsOutInOneRow; layoutChanged.

	aGraphic := ScriptingSystem formAtKey: 'TinyMenu'.
	aGraphic ifNotNil:
		[aTab removeAllMorphs.
		aTab addMorph: (sk := World drawingClass withForm: aGraphic).
		sk position: aTab position.
		sk lock.
		aTab fitContents].
	self layoutChanged! !

!TabbedPalette methodsFor: 'initialization' stamp: 'sw 1/11/2000 11:16'!
addTabFor: aReferent font: aFont
	| aTab |
	aTab := tabsMorph addTabFor: aReferent font: aFont.
	pages add: aReferent.
	currentPage ifNil: [currentPage := aReferent].
	^ aTab! !

!TabbedPalette methodsFor: 'initialization' stamp: 'sw 7/2/1998 17:52'!
addTabForBook: aBook
	| aTab |
	aTab := tabsMorph addTabForBook: aBook.
	pages add: aBook.
	currentPage ifNil: [currentPage := aBook].
	^ aTab! !

!TabbedPalette methodsFor: 'initialization' stamp: 'sw 10/29/1998 17:35'!
addTabForBook: aBook withBalloonText: text
	| aTab |
	aTab := tabsMorph addTabForBook: aBook.
	pages add: aBook.
	currentPage ifNil: [currentPage := aBook].
	text ifNotNil: [aTab setBalloonText: text].
	^ aTab! !

!TabbedPalette methodsFor: 'miscellaneous' stamp: 'sw 6/23/1998 12:31'!
currentPalette
	"A stylistic convenience to reduce confusion caused by the fact that a palette is a book of books"
	^ currentPage! !

!TabbedPalette methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:31'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color transparent! !

!TabbedPalette methodsFor: 'initialization' stamp: 'sw 7/3/1998 18:05'!
defaultPageSize
	^ 156 @ 232! !

!TabbedPalette methodsFor: 'halos and balloon help' stamp: 'ar 9/14/2000 16:45'!
defersHaloOnClickTo: aSubMorph
	"If a cmd-click on aSubMorph would make it a preferred recipient of the halo, answer true"

	^ currentPage notNil and:
		[(aSubMorph hasOwner: currentPage)
			and: [currentPage defersHaloOnClickTo: aSubMorph]]
	! !

!TabbedPalette methodsFor: 'scraps tab' stamp: 'sw 6/24/1998 18:36'!
hasScrapsTab
	pages detect: [:p | (p hasProperty: #scraps)] ifNone: [^ false].
	^ true! !

!TabbedPalette methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:08'!
initialize
	"Initialize the receiver, which was just created via a call to the  
	class's #basicNew"
	super initialize.
	""
	pageSize := self defaultPageSize.
	self removeEverything.
	
	tabsMorph := IndexTabs new.
	self addMorph: tabsMorph! !

!TabbedPalette methodsFor: 'initialization' stamp: 'sw 12/7/1998 17:26'!
newTabs: tabsList
	"Reconstitute the palette based on info in the tabs list"

	| itsBook color1 color2 color3 |
	pages := pages species new.
	tabsMorph ifNotNil:
		[color1 := tabsMorph  highlightColor.
		color2 := tabsMorph regularColor.
		color3 := tabsMorph color.
		tabsMorph delete].
	tabsMorph := IndexTabs new.
	self addMorphFront: tabsMorph.
	color1 ifNotNil:
		[tabsMorph highlightColor: color1 regularColor: color2; color: color3].
	currentPage ifNotNil:
		[currentPage delete.
		currentPage := nil].
	tabsList do:
		[:aTab |
			tabsMorph addTab: aTab.
			aTab unHighlight.
			(itsBook := aTab morphToInstall) ifNotNil:
					[pages add: itsBook.
					currentPage ifNil: [currentPage := itsBook]]].
	tabsMorph position: self position + self borderWidth! !

!TabbedPalette methodsFor: 'misc menu items' stamp: 'sw 7/4/1998 14:12'!
recolorTabs
	"Prompt the user for new on and off colors for tabs"

	| onColor offColor |
	self inform: 'Choose the ''on'' color'.
	onColor := Color fromUser.

	self inform: 
'Okay, now please choose
the ''off'' color'.
	offColor := Color fromUser.

	tabsMorph highlightColor: onColor regularColor: offColor.
	currentPage ifNotNil:
		[tabsMorph highlightTabFor: currentPage]! !

!TabbedPalette methodsFor: 'submorphs-add/remove' stamp: 'sw 4/7/1999 12:16'!
replaceSubmorph: oldMorph by: newMorph
	super replaceSubmorph: oldMorph by: newMorph.
	oldMorph == currentPage ifTrue:
		[currentPage := newMorph]! !

!TabbedPalette methodsFor: 'scraps tab' stamp: 'sw 6/24/1998 18:42'!
scrapsBook
	^ pages detect: [:p | p hasProperty: #scraps] ifNone: [nil]! !

!TabbedPalette methodsFor: 'user-interface' stamp: 'stephane.ducasse 10/8/2008 18:03'!
selectTab: aTab
	| currentPalette morphToInstall oldTab aSketchEditor |
	oldTab := tabsMorph highlightedTab.
	(oldTab notNil and: [(morphToInstall := oldTab morphToInstall) isKindOf: PaintBoxMorph])
		ifTrue:
			[(aSketchEditor := self world findA: SketchEditorMorph) ifNotNil:
				[aSketchEditor cancelOutOfPainting].
			morphToInstall delete].

	tabsMorph selectTab: aTab.
	morphToInstall := aTab morphToInstall.

	(morphToInstall isKindOf: PaintBoxMorph) "special case, maybe generalize this need?"
		ifFalse:
			[self goToPageMorph: morphToInstall]
		ifTrue:
			[self showNoPaletteAndHighlightTab: aTab.
			self world addMorphFront: morphToInstall.
			morphToInstall position: ((self left max: 90) "room for the pop-out-to-left panel"
				@ (tabsMorph bottom))].
	
	(currentPalette := self currentPalette) ifNotNil:
		[currentPalette layoutChanged.].
	self snapToEdgeIfAppropriate! !

!TabbedPalette methodsFor: 'user-interface' stamp: 'sw 1/19/2001 12:47'!
selectTabNamed: aName
	"If the receiver has a tab with the given name, select it"

	| aTab |
	aTab := self tabNamed: aName.
	aTab ifNotNil: [self selectTab: aTab]! !

!TabbedPalette methodsFor: 'user-interface' stamp: 'sw 7/5/1998 15:40'!
selectTabOfBook: aBook
	self tabMorphs do:
		[:aTab | aTab morphToInstall == aBook ifTrue: [^ self selectTab: aTab]]! !

!TabbedPalette methodsFor: 'other' stamp: 'sw 6/6/2003 17:38'!
setExtentFromHalo: anExtent
	"The user has dragged the grow box such that the receiver's extent would be anExtent.  Do what's needed.  For a BookMorph, we assume any resizing attempt is a request that the book-page currently being viewed be resized accoringly; this will typically not affect unseen book pages, though there is a command that can be issued to harmonize all book-page sizes, and also an option to set that will maintain all pages at the same size no matter what."

	currentPage isInWorld
		ifFalse: "doubtful case mostly"
			[super setExtentFromHalo: anExtent]
		ifTrue:
			[currentPage setExtentFromHalo: ((anExtent x @ (anExtent y - (self innerBounds height - currentPage height))) - (2 * (self borderWidth @ self borderWidth))).
			self maintainsUniformPageSize ifTrue:
				[self setProperty: #uniformPageSize toValue: currentPage extent]]! !

!TabbedPalette methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:07'!
setInitialState
	super setInitialState.
""
	self layoutInset: 0.
	pageSize := 156 @ 232! !

!TabbedPalette methodsFor: 'misc menu items' stamp: 'sw 12/27/1998 23:34'!
showNoPalette
	self showNoPaletteAndHighlightTab: nil! !

!TabbedPalette methodsFor: 'misc menu items' stamp: 'marcus.denker 8/18/2008 11:25'!
showNoPaletteAndHighlightTab: aTab

	| oldTab morphToInstall aSketchEditor |
	oldTab := tabsMorph highlightedTab.
	(oldTab notNil and: [(morphToInstall := oldTab morphToInstall) isKindOf: PaintBoxMorph])
		ifTrue:
			[(aSketchEditor := self world findA: SketchEditorMorph) ifNotNil:
				[aSketchEditor cancelOutOfPainting].
			morphToInstall delete].

	currentPage ifNotNil: [currentPage delete].
	currentPage := nil.
	submorphs size > 1 ifTrue: "spurious submorphs, yecch"
		[(submorphs copyFrom: 2 to: submorphs size) do: [:m | m delete]].
	tabsMorph highlightTab: aTab! !

!TabbedPalette methodsFor: 'scraps tab' stamp: 'sw 3/8/1999 14:56'!
showScrapsTab
	self selectTabOfBook: self scrapsBook! !

!TabbedPalette methodsFor: 'misc menu items' stamp: 'sw 7/3/1998 18:17'!
sortTabs: evt
	TabSorterMorph new sortTabsFor: self.  "it directly replaces me"
	self delete
! !

!TabbedPalette methodsFor: 'user-interface' stamp: 'sw 7/5/1998 15:38'!
tabMorphs
	^ tabsMorph tabMorphs! !

!TabbedPalette methodsFor: 'user-interface' stamp: 'sw 1/19/2001 03:23'!
tabNamed: aName
	"Answer the tab of the given name, or nil if none"

	^ self tabMorphs detect: [:m | ((m isKindOf: StringMorph) and: [m contents = aName])
		or: [(m isKindOf: ReferenceMorph) and: [(m firstSubmorph isKindOf: StringMorph) and:
				[m firstSubmorph contents = aName]]]] ifNone: [nil]! !

!TabbedPalette methodsFor: 'miscellaneous' stamp: 'jm 11/16/97 17:59'!
tabsMorph
	^ tabsMorph! !

!TabbedPalette methodsFor: 'navigation' stamp: 'sw 12/22/1998 16:37'!
transitionSpecFor: aMorph
	^ aMorph valueOfProperty: #transitionSpec  " check for special propety"
		ifAbsent: [Array with: 'silence'  " ... otherwise this is the default"
						with: #none
						with: #none]! !

!TabbedPalette methodsFor: 'dropping/grabbing' stamp: 'dgd 2/21/2003 23:00'!
wantsDroppedMorph: aMorph event: evt 
	(tabsMorph bounds containsPoint: (self pointFromWorld: evt cursorPoint)) 
		ifTrue: [^false	"unless it's a book, perhaps, someday"].
	^currentPage isNil or: [currentPage wantsDroppedMorph: aMorph event: evt]! !

!BooklikeMorph classSide methodsFor: 'class initialization' stamp: 'sw 7/4/1998 15:59'!
initialize
	"BooklikeMorph initialize"
	PageFlipSoundOn := true
! !

!BooklikeMorph classSide methodsFor: 'as yet unclassified' stamp: 'sw 7/4/1998 16:43'!
turnOffSoundWhile: aBlock
	"Turn off page flip sound during the given block."
	| old |
	old := PageFlipSoundOn.
	PageFlipSoundOn := false.
	aBlock value.
	PageFlipSoundOn := old! !

!BooklikeMorph methodsFor: 'misc' stamp: 'dgd 8/30/2003 21:13'!
addBookMenuItemsTo: aCustomMenu hand: aHandMorph
	(self hasSubmorphWithProperty: #pageControl)
		ifTrue: [aCustomMenu add: 'hide page controls' translated action: #hidePageControls]
		ifFalse: [aCustomMenu add: 'show page controls' translated action: #showPageControls]! !

!BooklikeMorph methodsFor: 'menus' stamp: 'sw 7/4/1998 17:36'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"This factoring allows subclasses to have different menu yet still use the super call for the rest of the metamenu."

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	self addBookMenuItemsTo: aCustomMenu hand: aHandMorph! !

!BooklikeMorph methodsFor: 'page controls' stamp: 'sw 6/6/2003 14:10'!
addPageControlMorph: aMorph
	"Add the morph provided as a page control, at the appropriate place"

	aMorph setProperty: #pageControl toValue: true.
	self addMorph: aMorph asElementNumber: self indexForPageControls! !

!BooklikeMorph methodsFor: 'menu commands' stamp: 'sw 7/4/1998 15:39'!
clearNewPagePrototype
	newPagePrototype := nil
! !

!BooklikeMorph methodsFor: 'page controls' stamp: 'sw 5/23/2000 13:07'!
fewerPageControls
	self currentEvent shiftPressed
		ifTrue:
			[self hidePageControls]
		ifFalse:
			[self showPageControls: self shortControlSpecs]! !

!BooklikeMorph methodsFor: 'menu commands' stamp: 'sw 7/4/1998 15:40'!
firstPage
	self goToPage: 1! !

!BooklikeMorph methodsFor: 'page controls' stamp: 'yo 1/14/2005 19:25'!
fullControlSpecs

	^ {
		#spacer.
		#variableSpacer.
		{'-'.		#deletePage.				'Delete this page' translated}.
		#spacer.
		{''.		#firstPage.				'First page' translated}.
		#spacer.
		{'<'. 		#previousPage.			'Previous page' translated}.
		#spacer.
		{''.		#invokeBookMenu. 		'Click here to get a menu of options for this book.' translated}.
		#spacer.
		{'>'.		#nextPage.				'Next page' translated}.
		#spacer.
		{ ''.		#lastPage.				'Final page' translated}.
		#spacer.
		{'+'.		#insertPage.				'Add a new page after this one' translated}.
		#variableSpacer.
		{''.		#fewerPageControls.	'Fewer controls' translated}
}
! !

!BooklikeMorph methodsFor: 'page controls' stamp: 'sw 7/4/1998 16:12'!
hidePageControls
	"Delete all submorphs answering to the property #pageControl"
	self deleteSubmorphsWithProperty: #pageControl! !

!BooklikeMorph methodsFor: 'page controls' stamp: 'sw 6/6/2003 17:00'!
indexForPageControls
	"Answer which submorph should hold the page controls"

	^ (submorphs size > 0 and: [submorphs first hasProperty: #header])
		ifTrue:	[2]
		ifFalse:	[1]! !

!BooklikeMorph methodsFor: 'menu commands' stamp: 'sw 7/4/1998 17:18'!
insertPage
	self insertPageColored: self color! !

!BooklikeMorph methodsFor: 'page controls' stamp: 'tk 2/19/2001 18:34'!
makePageControlsFrom: controlSpecs
	"From the controlSpecs, create a set of page control and return them -- this method does *not* add the controls to the receiver."

	| c col row b lastGuy |
	c := (color saturation > 0.1) ifTrue: [color slightlyLighter] ifFalse: [color slightlyDarker].
	col := AlignmentMorph newColumn.
	col color: c; borderWidth: 0; layoutInset: 0.
	col hResizing: #spaceFill; vResizing: #shrinkWrap; extent: 5@5.

	row := AlignmentMorph newRow.
	row color: c; borderWidth: 0; layoutInset: 0.
	row hResizing: #spaceFill; vResizing: #shrinkWrap; extent: 5@5.
	controlSpecs do: [:spec |
		spec == #spacer
			ifTrue:
				[row addTransparentSpacerOfSize: (10 @ 0)]
			ifFalse:
				[spec == #variableSpacer
					ifTrue:
						[row addMorphBack: AlignmentMorph newVariableTransparentSpacer]
					ifFalse:
						[b := SimpleButtonMorph new target: self; borderWidth: 1; 
								borderColor: Color veryLightGray; color: c.
						b label: spec first;
						actionSelector: spec second;
						borderWidth: 0;
	 					setBalloonText: spec third.
						row addMorphBack: b.
						(((lastGuy := spec last asLowercase) includesSubString: 'menu') or:
								[lastGuy includesSubString: 'designations'])
							ifTrue: [b actWhen: #buttonDown]]]].  "pop up menu on mouseDown"
		col addMorphBack: row.
	^ col! !

!BooklikeMorph methodsFor: 'misc' stamp: 'ar 10/10/2000 16:09'!
move
	(owner isWorldMorph and:[self isSticky not]) ifTrue: [self activeHand grabMorph: self]! !

!BooklikeMorph methodsFor: 'misc' stamp: 'sw 7/4/1998 15:36'!
pageSize
	^ pageSize
! !

!BooklikeMorph methodsFor: 'misc' stamp: 'sw 7/4/1998 16:51'!
pageSize: aPoint
	pageSize := aPoint! !

!BooklikeMorph methodsFor: 'page controls' stamp: 'stephane.ducasse 10/8/2008 17:57'!
playPageFlipSound: soundName
	
	PageFlipSoundOn  "mechanism to suppress sounds at init time"
			ifTrue: [self playSoundNamed: soundName].
! !

!BooklikeMorph methodsFor: 'page controls' stamp: 'sw 6/6/2003 22:44'!
setEventHandlerForPageControls: controls
	"Set the controls' event handler if appropriate.  Default is to let the tool be dragged by the controls"

	controls eventHandler: (EventHandler new on: #mouseDown send: #move to: self)! !

!BooklikeMorph methodsFor: 'page controls' stamp: 'dgd 9/19/2003 11:35'!
shortControlSpecs
^ {
		#spacer.
		#variableSpacer.
		{'<'. 		#previousPage.			'Previous page' translated}.
		#spacer.
		{''.		#invokeBookMenu. 		'Click here to get a menu of options for this book.' translated}.
		#spacer.
		{'>'.		#nextPage.				'Next page' translated}.
		#spacer.
		#variableSpacer.
		{''.		#showMoreControls.		'More controls' translated}
}
! !

!BooklikeMorph methodsFor: 'page controls' stamp: 'sw 3/2/1999 15:01'!
showPageControls
	self showPageControls: self shortControlSpecs! !

!BooklikeMorph methodsFor: 'page controls' stamp: 'sw 6/6/2003 13:58'!
showPageControls: controlSpecs  
	"Remove any existing page controls, and add fresh controls at the top of the receiver (or in position 2 if the receiver's first submorph is one with property #header).  Add a single column of controls."

	| pageControls column |
	self hidePageControls.
	column := AlignmentMorph newColumn beTransparent.
	pageControls := self makePageControlsFrom: controlSpecs.
	pageControls borderWidth: 0; layoutInset: 4.
	pageControls beSticky.
	pageControls setNameTo: 'Page Controls'.
	self setEventHandlerForPageControls: pageControls.
	column addMorphBack: pageControls.
	self addPageControlMorph: column! !

!BooklikeMorph methodsFor: 'misc' stamp: 'dgd 9/19/2003 11:04'!
showingFullScreenString
	^ (self isInFullScreenMode
		ifTrue: ['exit full screen']
		ifFalse: ['show full screen']) translated! !

!BooklikeMorph methodsFor: 'misc' stamp: 'dgd 9/19/2003 11:04'!
showingPageControlsString
	^ (self pageControlsVisible
		ifTrue: ['hide page controls']
		ifFalse: ['show page controls']) translated! !

!BooklikeMorph methodsFor: 'menu commands' stamp: 'tk 2/25/1999 11:04'!
sortPages
	| sorter |
	sorter := BookPageSorterMorph new
		book: self morphsToSort: self morphsForPageSorter.
	sorter pageHolder cursor: self pageNumber.
	"Align at bottom right of screen, but leave 20-pix margin."
	self bottom + sorter height < Display height ifTrue: "Place it below if it fits"
		[^ self world addMorphFront: (sorter align: sorter topLeft with: self bottomLeft)].
	self right + sorter width < Display width ifTrue: "Place it below if it fits"
		[^ self world addMorphFront: (sorter align: sorter bottomLeft with: self bottomRight)].
	"Otherwise, place it at lower right of screen"
	self world addMorphFront: (sorter position: Display extent - (20@20) - sorter extent).
! !

AlignmentMorph subclass: #EmbeddedWorldBorderMorph
	instanceVariableNames: 'heights minWidth minHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-AdditionalSupport'!

!EmbeddedWorldBorderMorph methodsFor: 'menus' stamp: 'RAA 7/13/2000 10:16'!
addCustomMenuItems: menu hand: aHandMorph

	super addCustomMenuItems: menu hand: aHandMorph.

	self worldIEnclose
		addScalingMenuItems: menu 
		hand: aHandMorph
! !

!EmbeddedWorldBorderMorph methodsFor: 'boxes' stamp: 'RAA 7/13/2000 10:04'!
appViewBoxArea

	^self genericBoxArea: 1
! !

!EmbeddedWorldBorderMorph methodsFor: 'boxes' stamp: 'RAA 7/13/2000 10:12'!
boxesAndColorsAndSelectors

	^{
		{self zoomBoxArea. Color blue. #toggleZoom}.
		{self appViewBoxArea. Color yellow. #goAppView}.
		{self factoryViewBoxArea. Color red. #goFactoryView}.
		{self fullViewBoxArea. Color cyan. #goFullView}.
		{self normalEntryBoxArea. Color white. #goNormalProjectEntry}.
	}! !

!EmbeddedWorldBorderMorph methodsFor: 'drawing' stamp: 'RAA 7/13/2000 10:08'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self boxesAndColorsAndSelectors do: [ :each |
		aCanvas fillRectangle: each first fillStyle: each second
	].

! !

!EmbeddedWorldBorderMorph methodsFor: 'geometry' stamp: 'RAA 6/26/2000 19:10'!
extent: aPoint

	bounds extent = aPoint ifFalse: [
		self changed.
		bounds := bounds topLeft extent: aPoint.
		self myWorldChanged.
	].
! !

!EmbeddedWorldBorderMorph methodsFor: 'boxes' stamp: 'RAA 7/13/2000 10:04'!
factoryViewBoxArea

	^self genericBoxArea: 2
! !

!EmbeddedWorldBorderMorph methodsFor: 'boxes' stamp: 'RAA 7/13/2000 10:04'!
fullViewBoxArea

	^self genericBoxArea: 3
! !

!EmbeddedWorldBorderMorph methodsFor: 'boxes' stamp: 'RAA 7/13/2000 10:03'!
genericBoxArea: countDownFromTop

	^self innerBounds right @ (self top + (countDownFromTop * 2 * borderWidth)) 
		extent: borderWidth @ borderWidth
! !

!EmbeddedWorldBorderMorph methodsFor: 'as yet unclassified' stamp: 'RAA 7/13/2000 10:16'!
goAppView

	self worldIEnclose showApplicationView

! !

!EmbeddedWorldBorderMorph methodsFor: 'as yet unclassified' stamp: 'RAA 7/13/2000 10:17'!
goFactoryView

	self worldIEnclose showFactoryView

! !

!EmbeddedWorldBorderMorph methodsFor: 'as yet unclassified' stamp: 'RAA 7/13/2000 10:18'!
goFullView

	self worldIEnclose showFullView

! !

!EmbeddedWorldBorderMorph methodsFor: 'as yet unclassified' stamp: 'RAA 7/13/2000 10:18'!
goNormalProjectEntry

	| w |
	w := self worldIEnclose.
	self delete.
	w project enter.

! !

!EmbeddedWorldBorderMorph methodsFor: 'event handling' stamp: 'RAA 7/13/2000 10:10'!
handlesMouseDown: evt

	self boxesAndColorsAndSelectors do: [ :each |
		(each first containsPoint: evt cursorPoint) ifTrue: [^true]
	].
	^false

! !

!EmbeddedWorldBorderMorph methodsFor: 'initialization' stamp: 'em 3/24/2005 15:07'!
initialize

	super initialize.
	self setBalloonText: 'This is the frame of an embedded project. Click on the colored boxes:
blue - expand or reduce
yellow - app view
red - factory view
cyan - full view
white - enter the project completely' translated! !

!EmbeddedWorldBorderMorph methodsFor: 'layout' stamp: 'RAA 6/26/2000 18:45'!
minHeight: anInteger

	minHeight := anInteger! !

!EmbeddedWorldBorderMorph methodsFor: 'layout' stamp: 'RAA 6/26/2000 18:46'!
minWidth: anInteger

	minWidth := anInteger! !

!EmbeddedWorldBorderMorph methodsFor: 'WiW support' stamp: 'RAA 6/27/2000 19:23'!
morphicLayerNumber

	"helpful for insuring some morphs always appear in front of or behind others.
	smaller numbers are in front"

	^20		"Embedded worlds come in front of other worlds' Project navigation morphs"! !

!EmbeddedWorldBorderMorph methodsFor: 'event handling' stamp: 'RAA 7/13/2000 10:13'!
mouseDown: evt

	self boxesAndColorsAndSelectors do: [ :each |
		(each first containsPoint: evt cursorPoint) ifTrue: [
			^self perform: each third
		].
	].


! !

!EmbeddedWorldBorderMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/2/2000 13:31'!
myTransformation

	^submorphs detect: [ :x | x isKindOf: TransformationMorph] ifNone: [nil]
! !

!EmbeddedWorldBorderMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/14/2000 10:48'!
myWorldChanged
	| trans |
	trans := self myTransformation.
	self changed.
	self layoutChanged.
	trans ifNotNil:[
		trans extentFromParent: self innerBounds extent.
		bounds := bounds topLeft extent: trans extent + (borderWidth * 2).
	].
	self changed.
! !

!EmbeddedWorldBorderMorph methodsFor: 'boxes' stamp: 'RAA 7/13/2000 10:04'!
normalEntryBoxArea

	^self genericBoxArea: 4
! !

!EmbeddedWorldBorderMorph methodsFor: 'as yet unclassified' stamp: 'RAA 7/13/2000 10:12'!
toggleZoom

	self bounds: (
		bounds area > (Display boundingBox area * 0.9) ifTrue: [
			Display extent // 4 extent: Display extent // 2.
		] ifFalse: [
			Display boundingBox
		]
	)

! !

!EmbeddedWorldBorderMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/2/2000 13:31'!
worldIEnclose

	^self myTransformation firstSubmorph	
					"quick hack since this is the only usage pattern at the moment"
! !

!EmbeddedWorldBorderMorph methodsFor: 'boxes' stamp: 'RAA 7/13/2000 10:03'!
zoomBoxArea

	^self genericBoxArea: 0
! !

AlignmentMorph subclass: #EventRecorderMorph
	instanceVariableNames: 'tape state time deltaTime recHand playHand lastEvent lastDelta tapeStream saved statusLight voiceRecorder startSoundEvent recordMeter caption journalFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-AdditionalSupport'!

!EventRecorderMorph commentStamp: '<historical>' prior: 0!
During recording, the EventRecorder subscribes to all events of the normal morphic hand, and saves them as they occur.

For replay, a second playback hand is created that reads events from the recorder and plays them back in the world.

The EventRecorder began with the work of Ted Kaehler and John Malone.  This was then signifcantly expanded by Leandro Caniglia and Valeria Murgia as a tutorial aid for the Morphic Wrapper project.

Since that time, I have...
Changed to a simple inboard array for the tape (event storage).
Provided the ability to condense linear mouse movement with interpolation at replay.
Made simple provisions for wrap-around of the millisecond clock.
Eliminated step methods in favor of using the processEvents cycle in the playback hand.
Provided a pause/resume mechanism that is capable of surviving project changes.
Added the ability to spawn a simple 'play me' button that can be saved as a morph.
Caused the playback hand to display its cursor double size for visibility.
Integrated a voice recorder with on-the-fly compression.
	This currently does NOT survive project changes, not is its data stored on the tape.
	Right now it can only be saved by saving the entire recorder as a morph.
	This will be fixed by adding a startSound event at each project change.
	We will also convert read/write file to use saveOnFile.
Added a journal file facility for recording sequences that end in a crash.
The above two features can be engaged via the ER's morph menu.
	- Dan Ingalls 3/6/99!

!EventRecorderMorph classSide methodsFor: 'parts bin' stamp: 'sw 11/21/2001 16:06'!
descriptionForPartsBin
	"Answer  a description for use in a parts bin"

	^ self partName: 'Event Recorder'
		categories: #(Presentation Tools)
		documentation: 'Lets you record and play back interactions'! !

!EventRecorderMorph classSide methodsFor: 'fileIn/Out' stamp: 'sd 2/6/2002 21:31'!
fileReaderServicesForFile: fullName suffix: suffix

	^(suffix = 'tape') | (suffix = '*') 
		ifTrue: [ self services]
		ifFalse: [#()]

! !

!EventRecorderMorph classSide methodsFor: 'instance creation' stamp: 'edc 5/29/2006 08:35'!
fromFileNamed: aFileName
	| file answer |
	file := FileStream readOnlyFileNamed: aFileName.
	answer := self readFrom: file setConverterForCode.
	file close.
	^ answer! !

!EventRecorderMorph classSide methodsFor: 'class initialization' stamp: 'hg 8/3/2000 17:25'!
initialize

	FileList registerFileReader: self! !

!EventRecorderMorph classSide methodsFor: 'instance creation' stamp: 'los 2/26/2004 11:46'!
openTapeFromFile: fullName
	"Open an eventRecorder tape for playback."
 
	(self new) readTape: fullName; openInWorld! !

!EventRecorderMorph classSide methodsFor: 'instance creation' stamp: 'LC 12/23/1998 11:14'!
readFrom: aStream
	^ self new readFrom: aStream! !

!EventRecorderMorph classSide methodsFor: 'fileIn/Out' stamp: 'sd 2/6/2002 21:31'!
services

	^{SimpleServiceEntry 
			provider: self 
			label: 'open for playback'
			selector: #openTapeFromFile:.}
! !

!EventRecorderMorph classSide methodsFor: 'initialize-release' stamp: 'SD 11/15/2001 22:21'!
unload

	FileList unregisterFileReader: self ! !

!EventRecorderMorph methodsFor: 'initialization' stamp: 'RAA 6/14/2001 16:52'!
addButtons
	| r b |

	caption ifNotNil: ["Special setup for play-only interface"
		(r := self makeARowForButtons)
			addMorphBack: (SimpleButtonMorph new target: self;
	 							label: caption; actionSelector: #play);
			addMorphBack: self makeASpacer;
			addMorphBack: self makeStatusLight;
			addMorphBack: self makeASpacer.
		^ self addMorphBack: r
	].

	(r := self makeARowForButtons)
		addMorphBack: (b := self buttonFor: {#record. nil. 'Begin recording'});
		addMorphBack: self makeASpacer;
		addMorphBack: (self buttonFor: {#stop. b width. 'Stop recording - you can also use the ESC key to stop it'});
		addMorphBack: self makeASpacer;
		addMorphBack: (self buttonFor: {#play. b width. 'Play current recording'}).
	self addMorphBack: r.

	(r := self makeARowForButtons)
		addMorphBack: (b := self buttonFor: {#writeTape. nil. 'Save current recording on disk'});
		addMorphBack: self makeASpacer;
		addMorphBack: (self buttonFor: {#readTape. b width. 'Get a new recording from disk'}).
	self addMorphBack: r.

	(r := self makeARowForButtons)
		addMorphBack: (b := self buttonFor: {#shrink. nil. 'Make recording shorter by removing unneeded events'});
		addMorphBack: self makeASpacer;
		addMorphBack: self makeStatusLight;
		addMorphBack: self makeASpacer;
		addMorphBack: (self buttonFor: {#button. b width. 'Make a simple button to play this recording'}).
	self addMorph: r.
	self setStatusLight: #ready.! !

!EventRecorderMorph methodsFor: 'initialization' stamp: 'dgd 8/30/2003 21:19'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'add voice controls' translated action: #addVoiceControls.
	aCustomMenu add: 'add journal file' translated action: #addJournalFile.
! !

!EventRecorderMorph methodsFor: 'initialization' stamp: 'ar 10/25/2000 21:42'!
addJournalFile
	"In case there is a chance of not regaining control to stop recording and save a file, the EventRecorder can write directly to file as it is recording.  This is useful for capturing a sequence that results in a nasty crash."

	journalFile ifNotNil: [journalFile close].
	journalFile := FileStream newFileNamed: 'EventRecorder.tape'.
	journalFile nextPutAll:'Event Tape v1 ASCII'; cr.! !

!EventRecorderMorph methodsFor: 'commands' stamp: 'yo 2/11/2005 09:59'!
button
	"Make a simple button interface for replay only"
	| butnCaption erm |
	butnCaption := FillInTheBlank request: 'Caption for this butn?' translated initialAnswer: 'play' translated.
	butnCaption isEmpty ifTrue: [^ self].
	erm := (EventRecorderMorph basicNew
				caption: butnCaption
				voiceRecorder: voiceRecorder copy
				tape: tape) initialize.
	self world primaryHand attachMorph: erm! !

!EventRecorderMorph methodsFor: 'accessing' stamp: 'LC 12/23/1998 12:48'!
button: label 
	^ self allMorphs
		detect: [:one | (one isKindOf: SimpleButtonMorph)
				and: [one label = label]]
		ifNone: []! !

!EventRecorderMorph methodsFor: 'initialization' stamp: 'yo 2/11/2005 09:56'!
buttonFor: data 

	| b |
	b := SimpleButtonMorph new 
		target: self;
		label: data first asString translated;
		actionSelector: data first.
	data second ifNotNil: [b width < data second ifTrue: [b width: data second]].
	data third ifNotNil: [b setBalloonText: data third translated].
	^b! !

!EventRecorderMorph methodsFor: 'initialization' stamp: 'di 2/17/1999 17:44'!
caption: butnCaption voiceRecorder: butnRecorder tape: butnTape
	caption := butnCaption.
	voiceRecorder := butnRecorder.
	tape := butnTape! !

!EventRecorderMorph methodsFor: 'fileIn/Out' stamp: 'dgd 2/21/2003 23:15'!
checkTape
	"See if this tape was already converted to the new format"

	tape ifNil: [^self].
	tape isEmpty ifTrue: [^self].
	(tape first isKindOf: Association) 
		ifTrue: [tape := self convertV0Tape: tape]! !

!EventRecorderMorph methodsFor: 'commands' stamp: 'dgd 2/22/2003 19:01'!
condense
	"Shorten the tape by deleting mouseMove events that can just as well be
	interpolated later at playback time."

	"e1, e2, and e3 are three consecutive events on the tape.
	t1, t2, and t3 are the associated time steps for each of them."

	| e1 e2 t1 t2 e3 t3 |
	tape := Array streamContents: 
					[:tStream | 
					e1 := e2 := e3 := nil.
					t1 := t2 := t3 := nil.
					1 to: tape size
						do: 
							[:i | 
							e1 := e2.
							t1 := t2.
							e2 := e3.
							t2 := t3.
							e3 := tape at: i.
							t3 := e3 timeStamp.
							((e1 notNil and: 
									[e2 type == #mouseMove 
										& (e1 type == #mouseMove or: [e3 type == #mouseMove])]) 
								and: 
									["Middle point within 3 pixels of mean of outer two"

									e2 position 
										onLineFrom: e1 position
										to: e3 position
										within: 2.5]) 
									ifTrue: 
										["Delete middle mouse move event.  Absorb its time into e3"

										e2 := e1.
										t2 := t1]
									ifFalse: [e1 ifNotNil: [tStream nextPut: (e1 copy setTimeStamp: t1)]]].
					e2 ifNotNil: [tStream nextPut: (e2 copy setTimeStamp: t2)].
					e3 ifNotNil: [tStream nextPut: (e3 copy setTimeStamp: t3)]]! !

!EventRecorderMorph methodsFor: 'fileIn/Out' stamp: 'ar 10/26/2000 01:04'!
convertV0Tape: anArray
	"Convert the tape into the new format"
	| lastKey evt |
	lastKey := 0.
	^anArray collect:[:assn| 
		evt := assn value.
		evt setTimeStamp: (lastKey := lastKey + assn key).
		evt]! !

!EventRecorderMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:34'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ #raised! !

!EventRecorderMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:37'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 2! !

!EventRecorderMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:27'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color red! !

!EventRecorderMorph methodsFor: 'events-processing' stamp: 'ar 10/25/2000 21:26'!
handleListenEvent: anEvent
	"Record the given event"
	(state == #record and:[anEvent hand == recHand]) 
		ifFalse:[^self].
	anEvent = lastEvent ifTrue: [^ self].
	(anEvent isKeyboard and:[anEvent keyValue = 27 "esc"])
		ifTrue: [^ self stop].
	time := anEvent timeStamp.
	tapeStream nextPut: (anEvent copy setHand: nil).
	journalFile ifNotNil:
		[journalFile store: anEvent; cr; flush].
	lastEvent := anEvent.! !

!EventRecorderMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 19:21'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	saved := true.
	self listDirection: #topToBottom;
		 wrapCentering: #center;
		 cellPositioning: #topCenter;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 layoutInset: 2;
		 minCellSize: 4;
		 addButtons! !

!EventRecorderMorph methodsFor: 'initialization' stamp: 'RAA 6/14/2001 16:19'!
makeARowForButtons

	^AlignmentMorph newRow
		vResizing: #shrinkWrap;
		wrapCentering: #center;
		cellPositioning: #leftCenter;
		minCellSize: 4;
		color: Color blue! !

!EventRecorderMorph methodsFor: 'initialization' stamp: 'RAA 6/14/2001 16:14'!
makeASpacer

	^AlignmentMorph newSpacer: Color transparent! !

!EventRecorderMorph methodsFor: 'initialization' stamp: 'RAA 6/14/2001 16:13'!
makeStatusLight

	^statusLight := EllipseMorph new 
		extent: 11 @ 11;
		color: Color green;
		borderWidth: 0! !

!EventRecorderMorph methodsFor: 'event handling' stamp: 'marcus.denker 8/24/2008 21:43'!
nextEventToPlay
	"Return the next event when it is time to be replayed.
	If it is not yet time, then return an interpolated mouseMove.
	Return nil if nothing has happened.
	Return an EOF event if there are no more events to be played."
	| nextEvent now nextTime lastP delta |
	(tapeStream isNil or:[tapeStream atEnd]) 
		ifTrue:[^MorphicUnknownEvent basicNew setType: #EOF argument: nil].
	now := Time millisecondClockValue.
	nextEvent := tapeStream next.
	"nextEvent isKeyboard ifTrue: [ nextEvent setPosition: self position ]."
	deltaTime ifNil:[deltaTime := now - nextEvent timeStamp].
	nextTime := nextEvent timeStamp + deltaTime.
	now < time ifTrue:["clock rollover"
		time := now.
		deltaTime := nil.
		^nil "continue it on next cycle"].
	time := now.
	(now >= nextTime) ifTrue:[
		nextEvent := nextEvent copy setTimeStamp: nextTime.
		nextEvent isMouse ifTrue:[lastEvent := nextEvent] ifFalse:[lastEvent := nil].
		^nextEvent].
	tapeStream skip: -1.
	"Not time for the next event yet, but interpolate the mouse.
	This allows tapes to be compressed when velocity is fairly constant."
	lastEvent ifNil: [^ nil].
	lastP := lastEvent position.
	delta := (nextEvent position - lastP) * (now - lastEvent timeStamp) // (nextTime - lastEvent timeStamp).
	delta = lastDelta ifTrue: [^ nil]. "No movement"
	lastDelta := delta.
	^MouseMoveEvent basicNew
		setType: #mouseMove 
		startPoint: lastEvent position endPoint: lastP + delta
		trail: #() buttons: lastEvent buttons hand: nil stamp: now.! !

!EventRecorderMorph methodsFor: 'pause/resume' stamp: 'RAA 6/14/2001 16:50'!
pauseIn: aWorld
	"Suspend playing or recording, either as part of a stop command,
	or as part of a project switch, after which it will be resumed."

	self setStatusLight: #ready.
	state = #play ifTrue:
		[state := #suspendedPlay.
		playHand delete.
		aWorld removeHand: playHand.
		playHand := nil].
	state = #record ifTrue:
		[state := #suspendedRecord.
		recHand removeEventListener: self.
		recHand := nil].

	voiceRecorder ifNotNil:
		[voiceRecorder pause.
		startSoundEvent ifNotNil:
			[startSoundEvent argument: voiceRecorder recordedSound.
			voiceRecorder clearRecordedSound.
			startSoundEvent := nil]].
! !

!EventRecorderMorph methodsFor: 'commands' stamp: 'RAA 6/14/2001 16:42'!
play

	self isInWorld ifFalse: [^ self].
	self stop.
	tape ifNil: [^ self].
	tapeStream := ReadStream on: tape.
	self resumePlayIn: self world.
	self setStatusLight: #nowPlaying.

! !

!EventRecorderMorph methodsFor: 'fileIn/Out' stamp: 'ar 10/25/2000 22:00'!
readFrom: aStream
	"Private"
	| cr header |
	cr := Character cr.
	header := aStream upTo: cr.
	(header = 'Event Tape v1 BINARY') ifTrue:[^aStream fileInObjectAndCode].
	(header = 'Event Tape v1 ASCII') ifTrue:[^self readFromV1: aStream].
	"V0 had no header so guess"
	aStream reset.
	header first isDigit ifFalse:[^self convertV0Tape: (aStream fileInObjectAndCode)].
	^self convertV0Tape: (self readFromV0: aStream).
! !

!EventRecorderMorph methodsFor: 'fileIn/Out' stamp: 'ar 10/26/2000 01:55'!
readFromV0: aStream
	| cr line lineStream t evt |
	cr := Character cr.
	^Array streamContents:[:tStream |
		[aStream atEnd] whileFalse:
			[line := aStream upTo: cr.
			line isEmpty "Some MW tapes have an empty record at the end"
				ifFalse: [lineStream := ReadStream on: line.
						t := Integer readFrom: lineStream.
						[lineStream peek isLetter] whileFalse: [lineStream next].
						evt := MorphicEvent readFromObsolete: lineStream.
						tStream nextPut: t -> evt]]].! !

!EventRecorderMorph methodsFor: 'fileIn/Out' stamp: 'ar 10/26/2000 01:55'!
readFromV1: aStream
	| cr |
	cr := Character cr.
	^Array streamContents:[:tStream |
		[aStream atEnd] whileFalse:[
			tStream nextPut: (MorphicEvent readFromString: (aStream upTo: cr))]]! !

!EventRecorderMorph methodsFor: 'fileIn/Out' stamp: 'md 7/15/2004 17:22'!
readTape
	^ self readTape: (FillInTheBlank
							request: 'Tape to read'
							initialAnswer: 'tapeName.tape').! !

!EventRecorderMorph methodsFor: 'fileIn/Out' stamp: 'ar 10/25/2000 22:00'!
readTape: fileName 
	| file |
	self writeCheck.
	(FileStream isAFileNamed: fileName) ifFalse: [^ nil].
	file := FileStream oldFileNamed: fileName.
	tape := self readFrom: file.
	file close.
	saved := true  "Still exists on file"! !

!EventRecorderMorph methodsFor: 'commands' stamp: 'RAA 6/14/2001 16:42'!
record

	self isInWorld ifFalse: [^ self].
	self stop.
	self writeCheck.
	self addJournalFile.
	tapeStream := WriteStream on: (Array new: 10000).
	self resumeRecordIn: self world.
	self setStatusLight: #nowRecording.
! !

!EventRecorderMorph methodsFor: 'pause/resume' stamp: 'di 4/20/1999 16:29'!
resumeIn: aWorld
	"Resume playing or recording after a project switch."

	state = #suspendedPlay ifTrue:
		[self resumePlayIn: aWorld].
	state = #suspendedRecord ifTrue:
		[self resumeRecordIn: aWorld].
! !

!EventRecorderMorph methodsFor: 'pause/resume' stamp: 'ar 10/25/2000 20:58'!
resumePlayIn: aWorld

	playHand := HandMorphForReplay new recorder: self.
	playHand position: tapeStream peek position.
	aWorld addHand: playHand.
	playHand newKeyboardFocus: aWorld.
	playHand userInitials: 'play' andPicture: nil.

	lastEvent := nil.
	lastDelta := 0@0.
	state := #play.

	self synchronize.
! !

!EventRecorderMorph methodsFor: 'pause/resume' stamp: 'marcus.denker 8/24/2008 21:43'!
resumeRecordIn: aWorld

	recHand := aWorld activeHand ifNil: [aWorld primaryHand].
	recHand newKeyboardFocus: aWorld.
	recHand addEventListener: self.

	lastEvent := nil.
	state := #record.

	voiceRecorder ifNotNil:
		[voiceRecorder clearRecordedSound.
		voiceRecorder resumeRecording.
		startSoundEvent := MorphicUnknownEvent basicNew setType: #startSound argument: nil hand: nil stamp: Time millisecondClockValue.
		tapeStream nextPut: startSoundEvent].

	self synchronize.
! !

!EventRecorderMorph methodsFor: 'commands' stamp: 'RAA 6/14/2001 16:43'!
setStatusLight: aSymbol

	aSymbol == #ready ifTrue: [
		statusLight color: Color green.
		tape ifNil: [
			statusLight setBalloonText: 'Ready to record'.
		] ifNotNil: [
			statusLight setBalloonText: 'Ready to record or play'.
		].
		^self
	].
	aSymbol == #nowRecording ifTrue: [
		statusLight 
			color: Color red;
			setBalloonText: 'Recording is active'.
		^self
	].
	aSymbol == #nowPlaying ifTrue: [
		statusLight 
			color: Color yellow;
			setBalloonText: 'Now playing'.
		^self
	].
! !

!EventRecorderMorph methodsFor: 'commands' stamp: 'dgd 9/21/2003 17:54'!
shrink
	"Shorten the tape by deleting mouseMove events that can just as well be
	interpolated later at playback time."

	| oldSize priorSize |
	self writeCheck.
	oldSize := priorSize := tape size.
	[self condense.  tape size < priorSize] whileTrue: [priorSize := tape size].
	self inform: ('{1} events reduced to {2}' translated format:{oldSize. tape size}).
	voiceRecorder ifNotNil: [voiceRecorder suppressSilence].
	saved := false.
! !

!EventRecorderMorph methodsFor: 'stepping and presenter' stamp: 'RAA 1/2/2001 15:45'!
step

	(state == #record and: [voiceRecorder notNil]) ifTrue: [
		recordMeter width: (voiceRecorder meterLevel + 1).
	].
! !

!EventRecorderMorph methodsFor: 'testing' stamp: 'RAA 1/2/2001 10:28'!
stepTime

	^500
! !

!EventRecorderMorph methodsFor: 'stepping and presenter' stamp: 'RAA 6/14/2001 16:43'!
stop

	state = #record ifTrue:
		[tape := tapeStream contents.
		saved := false].
	journalFile ifNotNil:
		[journalFile close].
	self pauseIn: self world.
	tapeStream := nil.
	state := nil.
	self setStatusLight: #ready.
	recordMeter ifNotNil: [recordMeter width: 1].

	self checkTape.! !

!EventRecorderMorph methodsFor: 'event handling' stamp: 'ar 10/25/2000 20:44'!
synchronize

	time := Time millisecondClockValue.
	deltaTime := nil.! !

!EventRecorderMorph methodsFor: 'testing' stamp: 'RAA 1/2/2001 10:25'!
wantsSteps

	^true
! !

!EventRecorderMorph methodsFor: 'fileIn/Out' stamp: 'di 2/15/1999 16:05'!
writeCheck
	(saved not and: [self confirm: 'The current tape has not been saved.
Would you like to do so now?']) ifTrue:
		[self writeTape].
! !

!EventRecorderMorph methodsFor: 'fileIn/Out' stamp: 'ar 10/25/2000 22:11'!
writeFileNamed: fileName
	| file noVoice delta |
	file := FileStream newFileNamed: fileName.
	noVoice := true.
	tape do:[:evt | evt type = #startSound ifTrue: [noVoice := false]].
	noVoice
		ifTrue: ["Simple format (reads fast) for no voice"
				file nextPutAll:'Event Tape v1 ASCII'; cr.
				delta := tape first timeStamp.
				tape do: [:evt | file store: (evt copy setTimeStamp: evt timeStamp-delta); cr].
				file close]
		ifFalse: ["Inclusion of voice events requires general object storage"
				file nextPutAll:'Event Tape v1 BINARY'; cr.
				file fileOutClass: nil andObject: tape].
	saved := true.
	^ file name! !

!EventRecorderMorph methodsFor: 'fileIn/Out' stamp: 'md 7/15/2004 17:23'!
writeTape
	| args b |
	args := (b := self button: 'writeTape') isNil 
				ifTrue: [#()]
				ifFalse: [b arguments].
	(args notEmpty and: [args first notEmpty]) 
		ifTrue: 
			[args first.
			self writeTape: args first]
		ifFalse: 
			[^self writeTape: (FillInTheBlank request: 'Tape to write'
								initialAnswer: 'tapeName.tape')].! !

!EventRecorderMorph methodsFor: 'fileIn/Out' stamp: 'ar 10/25/2000 22:11'!
writeTape: fileName 
	| b name |
	name := self writeFileNamed: fileName.
	(b := self button: 'writeTape') ifNotNil: [
		b actionSelector: #writeTape:.
		b arguments: (Array with: name)].
! !

AlignmentMorph subclass: #FloatingBookControlsMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Navigators'!

!FloatingBookControlsMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:38'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!FloatingBookControlsMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 19:16'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self layoutInset: 0;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap ! !

!FloatingBookControlsMorph methodsFor: 'WiW support' stamp: 'RAA 8/23/2000 12:47'!
morphicLayerNumber

	"helpful for insuring some morphs always appear in front of or behind others.
	smaller numbers are in front"

	^23		"page controls are behind menus and balloons, but in front of most other stuff"! !

!FloatingBookControlsMorph methodsFor: 'stepping and presenter' stamp: 'RAA 8/23/2000 12:48'!
step

	owner == self world ifFalse: [^ self].
	owner addMorphInLayer: self.
! !

!FloatingBookControlsMorph methodsFor: 'testing' stamp: 'RAA 8/23/2000 12:47'!
stepTime

	^1000! !

!FloatingBookControlsMorph methodsFor: 'testing' stamp: 'RAA 8/23/2000 12:47'!
wantsSteps

	^true! !

AlignmentMorph subclass: #GraphicalMenu
	instanceVariableNames: 'target selector argument currentIndex formChoices formDisplayMorph coexistWithOriginal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-AdditionalWidgets'!

GraphicalMenu subclass: #GraphicalDictionaryMenu
	instanceVariableNames: 'baseDictionary entryNames lastSearchString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-AdditionalWidgets'!

!GraphicalDictionaryMenu commentStamp: '<historical>' prior: 0!
A morph that allows you to view, rename, and remove elements from a dictionary whose keys are strings and whose values are forms.!

!GraphicalDictionaryMenu classSide methodsFor: 'example' stamp: 'sd 5/11/2003 20:53'!
example
	"GraphicalDictionaryMenu example"
	| aDict |
	aDict := Dictionary new.
	#('ColorTilesOff' 'ColorTilesOn' 'Controls') do:
		[:aString | aDict at: aString put: (ScriptingSystem formAtKey: aString)].
	self openOn: aDict withLabel: 'Testing One Two Three'! !

!GraphicalDictionaryMenu classSide methodsFor: 'example' stamp: 'sd 5/11/2003 20:56'!
example2
	"GraphicalDictionaryMenu example2"
	| aDict |
	aDict := Dictionary new.
	self openOn: aDict withLabel: 'Testing Zero'! !

!GraphicalDictionaryMenu classSide methodsFor: 'instance creation' stamp: 'nk 1/11/2004 15:50'!
openOn: aFormDictionary withLabel: aLabel
	"open a graphical dictionary in a window having the label aLabel. 
     aFormDictionary should be a dictionary containing as value a form."

	| inst aWindow |
	aFormDictionary size isZero ifTrue: [^ self inform: 'Empty!!'].	
	inst := self new initializeFor: nil fromDictionary: aFormDictionary.

	aWindow := (SystemWindow labelled: aLabel) model: inst.
	aWindow addMorph: inst frame: (0@0 extent: 1@1).
	aWindow extent: inst fullBounds extent + (3 @ aWindow labelHeight + 3);
		minimumExtent: inst minimumExtent + (3 @ aWindow labelHeight + 3).
	
     HandMorph attach: aWindow.

	^ inst! !

!GraphicalDictionaryMenu methodsFor: 'initialization' stamp: 'sw 12/24/1998 11:59'!
baseDictionary: aDictionary
	baseDictionary := aDictionary.
	entryNames := aDictionary keys asSortedArray.
	formChoices := entryNames collect: [:n | aDictionary at: n].
	currentIndex := 1! !

!GraphicalDictionaryMenu methodsFor: 'menu commands' stamp: 'sw 11/10/2003 13:14'!
browseIconReferences
	"Browse all calls on the symbol by which the currently-seen graphic is keyed"

	self systemNavigation browseAllCallsOn: self nameOfGraphic! !

!GraphicalDictionaryMenu methodsFor: 'menu commands' stamp: 'sw 11/10/2003 13:14'!
browseStringIconReferences
	"Browse string references to the selected entry's key"

	self systemNavigation browseMethodsWithString: self nameOfGraphic asString matchCase: true! !

!GraphicalDictionaryMenu methodsFor: 'menu commands' stamp: 'sw 10/25/2002 16:58'!
copyName
	"Copy the name of the current selection to the clipboard"

	Clipboard clipboardText: self nameOfGraphic asText! !

!GraphicalDictionaryMenu methodsFor: 'menu commands' stamp: 'sw 10/12/2004 05:04'!
findAgain
	"Look for the next occurrence of the search string"

	| toFind searchIndex |
	lastSearchString ifNil: [lastSearchString := 'controls'].
	searchIndex := currentIndex + 1.
	searchIndex > entryNames size ifTrue:
		[currentIndex := 0.
		self inform: 'not found' translated.
		^ self].
	toFind := '*', lastSearchString, '*'.
	[toFind match: (entryNames at: searchIndex) asString]
		whileFalse:
			[searchIndex := (searchIndex \\ entryNames size) + 1.
			searchIndex == currentIndex ifTrue:
				[^ (toFind match: (entryNames at: searchIndex) asString)
					ifFalse:
						[self inform: 'not found' translated]
					ifTrue:
						[self flash]]].

	currentIndex := searchIndex.
	self updateThumbnail! !

!GraphicalDictionaryMenu methodsFor: 'menu commands' stamp: 'sw 2/24/2003 15:57'!
findEntry
	"Prompt the user for a search string and find the next match for it"

	| toFind searchIndex |
	lastSearchString ifNil: [lastSearchString := 'controls'].
	toFind := FillInTheBlank request: 'Type name or fragment: ' initialAnswer: lastSearchString.
	toFind isEmptyOrNil ifTrue: [^ self].
	lastSearchString := toFind asLowercase.
	searchIndex := currentIndex + 1.
	toFind := '*', lastSearchString, '*'.
	[toFind match: (entryNames at: searchIndex) asString]
		whileFalse:
			[searchIndex := (searchIndex \\ entryNames size) + 1.
			searchIndex == currentIndex ifTrue: [^ self inform: 'not found']].

	currentIndex := searchIndex.
	self updateThumbnail! !

!GraphicalDictionaryMenu methodsFor: 'menu commands' stamp: 'nk 1/6/2004 12:36'!
handMeOne
	self currentHand attachMorph: (World drawingClass new form: (formChoices at: currentIndex))! !

!GraphicalDictionaryMenu methodsFor: 'initialization' stamp: 'nk 1/11/2004 16:22'!
initializeFor: aTarget fromDictionary: aDictionary 
	"Initialize me for a target and a dictionary."

	| anIndex aButton |
	self baseDictionary: aDictionary.
	target := aTarget.
	coexistWithOriginal := true.
	self extent: 210 @ 210.
	self clipSubmorphs: true.
	self layoutPolicy: ProportionalLayout new.
	aButton := (IconicButton new)
				borderWidth: 0;
				labelGraphic: (ScriptingSystem formAtKey: 'TinyMenu');
				color: Color transparent;
				actWhen: #buttonDown;
				actionSelector: #showMenu;
				target: self;
				setBalloonText: 'menu'.
	self addMorph: aButton
		fullFrame: (LayoutFrame fractions: (0.5 @ 0 extent: 0 @ 0)
				offsets: (-50 @ 6 extent: aButton extent)).
	aButton := (SimpleButtonMorph new)
				target: self;
				borderColor: Color black;
				label: 'Prev';
				actionSelector: #downArrowHit;
				actWhen: #whilePressed;
				setBalloonText: 'show previous picture';
				yourself.
	self addMorph: aButton
		fullFrame: (LayoutFrame fractions: (0.5 @ 0 extent: 0 @ 0)
				offsets: (-24 @ 4 extent: aButton extent)).
	aButton := (SimpleButtonMorph new)
				target: self;
				borderColor: Color black;
				label: 'Next';
				actionSelector: #upArrowHit;
				actWhen: #whilePressed;
				setBalloonText: 'show next pictutre'.
	self addMorph: aButton
		fullFrame: (LayoutFrame fractions: (0.5 @ 0 extent: 0 @ 0)
				offsets: (24 @ 4 extent: aButton extent)).
	self addMorph: ((UpdatingStringMorph new)
				contents: ' ';
				target: self;
				putSelector: #renameGraphicTo:;
				getSelector: #truncatedNameOfGraphic;
				useStringFormat;
				setBalloonText: 'The name of the current graphic';
				yourself)
		fullFrame: (LayoutFrame fractions: (0 @ 0 extent: 1 @ 0)
				offsets: (10 @ 40 corner: -10 @ 60)).
	self addMorph: ((Morph new)
				extent: 100 @ 4;
				color: Color black)
		fullFrame: (LayoutFrame fractions: (0 @ 0 extent: 1 @ 0)
				offsets: (0 @ 60 corner: 0 @ 64)).
	formDisplayMorph := (Thumbnail new)
				extent: 100 @ 100;
				useInterpolation: true;
				maxWidth: 3000 minHeight: 100;
				yourself.
	self addMorph: formDisplayMorph
		fullFrame: (LayoutFrame fractions: (0 @ 0 extent: 0@0)
				offsets: (8 @ 72 corner:  108 @ 172)).
	self minimumExtent: 116@180.
	target ifNotNil: 
			[(anIndex := formChoices indexOf: target form ifAbsent: []) 
				ifNotNil: [currentIndex := anIndex]].
	self updateThumbnail! !

!GraphicalDictionaryMenu methodsFor: 'private' stamp: 'sw 12/24/1998 11:25'!
nameOfGraphic
	^ entryNames at: currentIndex! !

!GraphicalDictionaryMenu methodsFor: 'menu commands' stamp: 'sw 12/24/1998 12:15'!
removeEntry
	baseDictionary removeKey: (entryNames at: currentIndex).
	self baseDictionary: baseDictionary.
	self updateThumbnail! !

!GraphicalDictionaryMenu methodsFor: 'menu commands' stamp: 'nb 6/17/2003 12:25'!
renameEntry
	| reply curr |
	reply := FillInTheBlank
		request: 'New key? '
		initialAnswer: (curr := entryNames at: currentIndex)
		centerAt: self center.
	(reply isEmptyOrNil or: [reply = curr]) ifTrue: [^ Beeper beep].
	(baseDictionary includesKey: reply) ifTrue:
		[^ self inform: 'sorry that conflicts with
the name of another
entry in this dictionary'].
	baseDictionary at: reply put: (baseDictionary at: curr).
	baseDictionary removeKey: curr.
	self baseDictionary: baseDictionary.
	self updateThumbnail! !

!GraphicalDictionaryMenu methodsFor: 'menu commands' stamp: 'nb 6/17/2003 12:25'!
renameGraphicTo: newName
	| curr |
	curr := entryNames at: currentIndex.
	(newName isEmptyOrNil or: [newName = curr]) ifTrue: [^ Beeper beep].
	(baseDictionary includesKey: newName) ifTrue:
		[^ self inform: 'sorry that conflicts with
the name of another
entry in this dictionary'].
	baseDictionary at: newName put: (baseDictionary at: curr).
	baseDictionary removeKey: curr.
	self baseDictionary: baseDictionary.
	currentIndex := entryNames indexOf: newName.
	self updateThumbnail! !

!GraphicalDictionaryMenu methodsFor: 'menu commands' stamp: 'nk 1/6/2004 12:37'!
repaintEntry
	"Let the user enter into painting mode to repaint the item and save it back."

	| aWorld bnds sketchEditor aPaintBox formToEdit |
	
	(aWorld := self world) assureNotPaintingElse: [^ self].

	aWorld prepareToPaint.
	aWorld displayWorld.
	formToEdit := formChoices at: currentIndex.
	bnds := (submorphs second boundsInWorld origin extent: formToEdit extent) intersect: aWorld bounds.
	bnds := (aWorld paintingBoundsAround: bnds center) merge: bnds.
	sketchEditor := SketchEditorMorph new.
	aWorld addMorphFront: sketchEditor.
	sketchEditor initializeFor: ((World drawingClass withForm: formToEdit) position: submorphs second positionInWorld)  inBounds: bnds pasteUpMorph: aWorld paintBoxPosition: bnds topRight.
	sketchEditor
		afterNewPicDo: [:aForm :aRect |
			formChoices at: currentIndex put: aForm.
			baseDictionary at: (entryNames at: currentIndex) put: aForm.
			self updateThumbnail.
			(aPaintBox := aWorld paintBoxOrNil) ifNotNil: [aPaintBox delete]] 
		ifNoBits:
			[(aPaintBox := aWorld paintBoxOrNil) ifNotNil: [aPaintBox delete]].
	
! !

!GraphicalDictionaryMenu methodsFor: 'menu commands' stamp: 'sw 2/24/2003 15:59'!
showMenu
	"Show the receiver's menu"

	| aMenu |
	aMenu := MenuMorph new defaultTarget: self.
	aMenu title: 'Graphics Library'.
	aMenu addStayUpItem.
	aMenu addList: #(
		('remove'			removeEntry			'Remove this entry from the dictionary')
		('rename'			renameEntry			'Rename this entry')
		('repaint'			repaintEntry			'Edit the actual graphic for this entry' )
		-
		('hand me one'		handMeOne				'Hand me a morph with this picture as its form')
		('browse symbol references'
							browseIconReferences	'Browse methods that refer to this icon''s name')
		('browse string references'
							browseStringIconReferences'
													'Browse methods that refer to string constants that contian this icon''s name)
		('copy name'		copyName				'Copy the name of this graphic to the clipboard')
		-
		('find...'			findEntry				'Find an entry by name')
		('find again'		findAgain				'Find the next match for the keyword previously searched for')).
	aMenu popUpInWorld
! !

!GraphicalDictionaryMenu methodsFor: 'menu commands' stamp: 'sw 5/28/2000 23:19'!
truncatedNameOfGraphic
	^ self nameOfGraphic truncateTo: 30! !

!GraphicalDictionaryMenu methodsFor: 'private' stamp: 'nk 1/11/2004 15:14'!
updateThumbnail
	super updateThumbnail.
	(self findA: UpdatingStringMorph)
		doneWithEdits;
		contents: (entryNames at: currentIndex)
! !

!GraphicalMenu methodsFor: 'as yet unclassified' stamp: 'ar 6/25/1999 11:54'!
argument
	^argument! !

!GraphicalMenu methodsFor: 'as yet unclassified' stamp: 'ar 6/25/1999 11:54'!
argument: anObject
	argument := anObject! !

!GraphicalMenu methodsFor: 'as yet unclassified' stamp: 'sw 12/4/1998 23:49'!
cancel
	coexistWithOriginal
		ifTrue:
			[self delete]
		ifFalse:
			[owner replaceSubmorph: self topRendererOrSelf by: target]! !

!GraphicalMenu methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:34'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color blue darker! !

!GraphicalMenu methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:38'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!GraphicalMenu methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:27'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color white! !

!GraphicalMenu methodsFor: 'as yet unclassified' stamp: 'sw 12/1/1998 17:56'!
downArrowHit
	currentIndex := currentIndex - 1.
	(currentIndex < 1) ifTrue:  [currentIndex := formChoices size].
	self updateThumbnail
	
! !

!GraphicalMenu methodsFor: 'initialization' stamp: 'ar 6/25/1999 11:53'!
initialize
	super initialize.
	selector := #newForm:.! !

!GraphicalMenu methodsFor: 'initialization' stamp: 'nk 1/11/2004 15:09'!
initializeFor: aTarget withForms: formList coexist: aBoolean 
	"World primaryHand attachMorph:
		(GraphicalMenu new initializeFor: nil  
		withForms: Form allInstances coexist: true)"
	| buttons bb anIndex buttonCage |
	target := aTarget.
	coexistWithOriginal := aBoolean.
	formChoices := formList.
	currentIndex := 1.
	self borderWidth: 1;
		 cellPositioning: #center;
		 color: Color white;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	buttons := AlignmentMorph newRow.
	buttons borderWidth: 0;
		 layoutInset: 0.
	buttons hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 extent: 5 @ 5.
	buttons wrapCentering: #topLeft.
	buttonCage := AlignmentMorph newColumn.
	buttonCage hResizing: #shrinkWrap;
		 vResizing: #spaceFill.
	buttonCage addTransparentSpacerOfSize: 0 @ 10.
	bb := SimpleButtonMorph new target: self;
				 borderColor: Color black.
	buttons addMorphBack: (bb label: 'Prev';
			 actionSelector: #downArrowHit;
			 actWhen: #whilePressed).
	buttons addTransparentSpacerOfSize: 9 @ 0.
	bb := SimpleButtonMorph new target: self;
				 borderColor: Color black.
	buttons addMorphBack: (bb label: 'Next';
			 actionSelector: #upArrowHit;
			 actWhen: #whilePressed).
	buttons addTransparentSpacerOfSize: 5 @ 0.
	buttons submorphs last color: Color white.
	buttonCage addMorphBack: buttons.
	buttonCage addTransparentSpacerOfSize: 0 @ 12.
	buttons := AlignmentMorph newRow.
	bb := SimpleButtonMorph new target: self;
				 borderColor: Color black.
	buttons addMorphBack: (bb label: 'OK';
			 actionSelector: #okay).
	buttons addTransparentSpacerOfSize: 5 @ 0.
	bb := SimpleButtonMorph new target: self;
				 borderColor: Color black.
	buttons addMorphBack: (bb label: 'Cancel';
			 actionSelector: #cancel).
	buttonCage addMorphBack: buttons.
	buttonCage addTransparentSpacerOfSize: 0 @ 10.
	self addMorphFront: buttonCage.
	formDisplayMorph := Thumbnail new extent: 100 @ 100;
				 maxWidth: 100 minHeight: 30;
				 yourself.
	self addMorphBack: (Morph new color: Color white;
			 layoutPolicy: TableLayout new;
			 layoutInset: 4 @ 4;
			 hResizing: #spaceFill;
			 vResizing: #spaceFill;
			 listCentering: #center;
			 addMorphBack: formDisplayMorph;
			 yourself).
	target
		ifNotNil: [(anIndex := formList
						indexOf: target form
						ifAbsent: [])
				ifNotNil: [currentIndex := anIndex]].
	self updateThumbnail! !

!GraphicalMenu methodsFor: 'as yet unclassified' stamp: 'ar 6/25/1999 11:54'!
okay
	| nArgs |
	target ifNotNil:[
		nArgs := selector numArgs.
		nArgs = 1 ifTrue:[target perform: selector with: (formChoices at: currentIndex)].
		nArgs = 2 ifTrue:[target perform: selector with: (formChoices at: currentIndex) with: argument]].
	coexistWithOriginal
		ifTrue:
			[self delete]
		ifFalse:
			[owner replaceSubmorph: self topRendererOrSelf by: target]! !

!GraphicalMenu methodsFor: 'as yet unclassified' stamp: 'ar 6/25/1999 11:54'!
selector
	^selector! !

!GraphicalMenu methodsFor: 'as yet unclassified' stamp: 'ar 6/25/1999 11:54'!
selector: aSymbol
	selector := aSymbol! !

!GraphicalMenu methodsFor: 'as yet unclassified' stamp: 'sw 12/1/1998 17:54'!
upArrowHit
	currentIndex := currentIndex + 1.
	(currentIndex > formChoices size) ifTrue: [currentIndex := 1].
	self updateThumbnail
	
! !

!GraphicalMenu methodsFor: 'event handling' stamp: 'nk 1/11/2004 14:44'!
updateThumbnail
	| f |
	f := formChoices at: currentIndex.
	formDisplayMorph 
		makeThumbnailFromForm: f.
! !

AlignmentMorph subclass: #MIDIControllerMorph
	instanceVariableNames: 'channel controller midiPort lastValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SoundInterface'!

!MIDIControllerMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 21:50'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'set channel' translated action: #setChannel:.
	aCustomMenu add: 'set controller' translated action: #setController:.
! !

!MIDIControllerMorph methodsFor: 'accessing' stamp: 'jm 9/28/1998 22:35'!
channel

	^ channel
! !

!MIDIControllerMorph methodsFor: 'accessing' stamp: 'jm 9/28/1998 22:40'!
channel: anInteger

	channel := anInteger.
	lastValue := nil.
	self updateLabel.
! !

!MIDIControllerMorph methodsFor: 'accessing' stamp: 'jm 9/28/1998 22:35'!
controller

	^ controller
! !

!MIDIControllerMorph methodsFor: 'accessing' stamp: 'jm 9/28/1998 22:40'!
controller: anInteger

	controller := anInteger.
	lastValue := nil.
	self updateLabel.
! !

!MIDIControllerMorph methodsFor: 'menu' stamp: 'jm 9/29/1998 09:06'!
controllerList
	"Answer a list of controller name, number pairs to be used in the menu."

	^ #((1 modulation)
		(2 'breath control')
		(7 volume)
		(10 pan)
		(11 expression)
		(92 'tremolo depth')
		(93 'chorus depth')
		(94 'celeste depth')
		(95 'phaser depth'))
! !

!MIDIControllerMorph methodsFor: 'menu' stamp: 'jm 9/29/1998 09:09'!
controllerName: controllerNumber
	"Answer a name for the given controller. If no name is available, use the form 'CC5' (CC is short for 'continuous controller')."

	self controllerList do: [:pair |
		pair first = controllerNumber ifTrue: [^ pair last]].
	^ 'CC', controllerNumber asString
! !

!MIDIControllerMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:37'!
defaultBorderWidth
"answer the default border width for the receiver"
	^ 1! !

!MIDIControllerMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:37'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color
		r: 0.484
		g: 0.613
		b: 0.0! !

!MIDIControllerMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:37'!
initialize
"initialize the state of the receiver"
	| slider |
	super initialize.
""
	self listDirection: #topToBottom.
	self wrapCentering: #center;
		 cellPositioning: #topCenter.
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.
	channel := 0.
	controller := 7.
	"channel volume"
	slider := SimpleSliderMorph new target: self;
				 actionSelector: #newSliderValue:;
				 minVal: 0;
				 maxVal: 127;
				 extent: 128 @ 10.
	self addMorphBack: slider.
	self
		addMorphBack: (StringMorph contents: 'Midi Controller').
	self updateLabel! !

!MIDIControllerMorph methodsFor: 'accessing' stamp: 'jm 9/28/1998 22:54'!
midiPort

	^ midiPort
! !

!MIDIControllerMorph methodsFor: 'accessing' stamp: 'jm 9/28/1998 22:55'!
midiPort: anInteger

	midiPort := anInteger.
! !

!MIDIControllerMorph methodsFor: 'other' stamp: 'jm 10/12/1998 16:02'!
newSliderValue: newValue
	"Send a control command out the MIDI port."

	| val |
	midiPort ifNil: [^ self].
	val := newValue asInteger.
	lastValue = val ifTrue: [^ self].
	lastValue := val.
	midiPort midiCmd: 16rB0 channel: channel byte: controller byte: val.
! !

!MIDIControllerMorph methodsFor: 'menu' stamp: 'RAA 6/12/2000 09:02'!
setChannel: evt
	| menu |
	menu := MenuMorph new.
	1 to: 16 do: [:chan |
		menu add: chan printString
			target: self
			selector: #channel:
			argumentList: (Array with: chan - 1)].

	menu popUpEvent: evt in: self world! !

!MIDIControllerMorph methodsFor: 'menu' stamp: 'RAA 6/12/2000 09:02'!
setController: evt
	| menu |
	menu := MenuMorph new.
	self controllerList do: [:pair |
		menu add: (pair last)
			target: self
			selector: #controller:
			argumentList: (Array with: pair first)].

	menu popUpEvent: evt in: self world! !

!MIDIControllerMorph methodsFor: 'other' stamp: 'jm 9/29/1998 09:10'!
updateLabel

	| label |
	(label := self findA: StringMorph) ifNil: [^ self].
	label contents: (self controllerName: controller), ', ch: ', (channel + 1) printString.
! !

AlignmentMorph subclass: #ObjectsTool
	instanceVariableNames: 'searchString modeSymbol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-PartsBin'!

!ObjectsTool commentStamp: '<historical>' prior: 0!
I am a Master Parts Bin that allows the user to drag out a new Morph from a voluminous iconic list.

Choose "objects" from the world menu, or type Alt-o (Cmd-o on the Mac).

To add a new kinds of Morphs:
In the class of the Morph, implement the message:

descriptionForPartsBin
	^ self partName:	'Rectangle'
		categories:		#('Graphics' ' Basic 1 ')
		documentation:	'A rectangular shape, with border and fill style'

The partName is the title that will show in the lower pane of the Object Tool.
When is categories mode, an object can be seen in more than one category.  The list above tells which ones.
Documentation is what will show in the balloon help for each object thumbnail.
The message #initializeToStandAlone creates the actual instance.

To make a second variant object prototype coming from the same class, implement #supplementaryPartsDescriptions.  In it, you get to specify the nativitySelector.  It is sent to the class to get the variant objects.  Often it is #authoringPrototype.  (A class may supply supplementaryPartsDescriptions without implementing descriptionForPartsBin.  This gives you better control.)

!

!ObjectsTool classSide methodsFor: 'parts bin' stamp: 'sw 8/11/2001 20:16'!
descriptionForPartsBin
	^ self partName:	'Objects'
		categories:		#('Useful')
		documentation:	'A place to obtain many kinds of objects'! !

!ObjectsTool classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 10:45'!
initialize

	self registerInFlapsRegistry.	! !

!ObjectsTool classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 10:47'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(ObjectsTool			newStandAlone				'Object Catalog'		'A tool that lets you browse the catalog of objects')
						forFlapNamed: 'PlugIn Supplies'.
						cl registerQuad: #(ObjectsTool		newStandAlone				'Object Catalog'		'A tool that lets you browse the catalog of objects')
						forFlapNamed: 'Widgets'.]! !

!ObjectsTool classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 12:37'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

!ObjectsTool methodsFor: 'menu' stamp: 'dgd 8/30/2003 16:22'!
addCustomMenuItems: aMenu hand: aHand
	"Add items to the given halo-menu, given a hand"

	super addCustomMenuItems: aMenu hand: aHand.
	aMenu addLine.
	aMenu add: 'alphabetic' translated target: self selector: #showAlphabeticTabs.
	aMenu add: 'find' translated target: self selector: #showSearchPane.
	aMenu add: 'categories' translated target: self selector: #showCategories.
	aMenu addLine.
	aMenu add: 'reset thumbnails' translated target: self selector: #resetThumbnails.! !

!ObjectsTool methodsFor: 'alphabetic' stamp: 'dgd 4/4/2006 16:43'!
alphabeticTabs
	"Answer a list of buttons which, when hit, will trigger the choice of a morphic category"

	| buttonList aButton tabLabels |

	self flag: #todo. "includes non-english characters"
	tabLabels := (($a to: $z) collect: [:ch | ch asString]) asOrderedCollection.

	buttonList := tabLabels collect:
		[:catName |
			aButton := SimpleButtonMorph new label: catName.
			aButton actWhen: #buttonDown.
			aButton target: self; actionSelector: #showAlphabeticCategory:fromButton:; arguments: {catName. aButton}].
	^ buttonList

"ObjectsTool new tabsForMorphicCategories"! !

!ObjectsTool methodsFor: 'submorph access' stamp: 'nk 9/3/2004 08:06'!
buttonPane
	"Answer the receiver's button pane, nil if none"

	^ self submorphNamed: 'ButtonPane' ifNone: [].! !

!ObjectsTool methodsFor: 'layout' stamp: 'nk 9/3/2004 12:35'!
extent: anExtent
	"The user has dragged the grow box such that the receiver's extent would be anExtent.  Do what's needed"
	self extent = anExtent ifTrue: [ ^self ].
	super extent: anExtent.
	self fixLayoutFrames.! !

!ObjectsTool methodsFor: 'layout' stamp: 'nk 9/3/2004 13:44'!
fixLayoutFrames
	"Adjust the boundary between the tabs or search pane and the parts bin, giving preference to the tabs."

	| oldY newY tp tpHeight |
	oldY := ((tp := self tabsPane
						ifNil: [self searchPane])
				ifNil: [^ self]) layoutFrame bottomOffset.
	tpHeight := tp hasSubmorphs
				ifTrue: [(tp submorphBounds outsetBy: tp layoutInset) height]
				ifFalse: [tp height].
	newY := (self buttonPane
				ifNil: [^ self]) height + tpHeight.
	oldY = newY
		ifTrue: [^ self].
	tp layoutFrame bottomOffset: newY.
	(self partsBin
		ifNil: [^ self]) layoutFrame topOffset: newY.
	submorphs
		do: [:m | m layoutChanged ]! !

!ObjectsTool methodsFor: 'thumbnail' stamp: 'dgd 9/22/2004 19:28'!
icon
	"Answer a form with an icon to represent the receiver"
	^ MenuIcons objectCatalogIcon! !

!ObjectsTool methodsFor: 'initialization' stamp: 'nk 9/3/2004 13:46'!
initializeForFlap
	"Initialize the receiver to operate in a flap at the top of the screen."

	"
	Flaps newObjectsFlap openInWorld
	"

	| buttonPane aBin aColor heights tabsPane |
	self basicInitialize.

	self layoutInset: 0;
		layoutPolicy: ProportionalLayout new;
		hResizing: #shrinkWrap;
		vResizing: #rigid;
		borderWidth: 2; borderColor: Color darkGray;
		extent: (self minimumWidth @ self minimumHeight).

	"mode buttons"
	buttonPane := self paneForTabs: self modeTabs.
	buttonPane
		vResizing: #shrinkWrap;
		setNameTo: 'ButtonPane';
		color: (aColor := buttonPane color) darker;
		layoutInset: 6;
		wrapDirection: nil;
		width: self width;
		layoutChanged; fullBounds.

	"Place holder for a tabs or text pane"
	tabsPane := Morph new
		setNameTo: 'TabPane';
		hResizing: #spaceFill;
		yourself.

	heights := { buttonPane height. 40 }.

	buttonPane vResizing: #spaceFill.
	self
		addMorph: buttonPane
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ heights first)).

	self
		addMorph: tabsPane
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ heights first corner: 0 @ (heights first + heights second))).

	aBin := (PartsBin newPartsBinWithOrientation: #leftToRight from: #())
		listDirection: #leftToRight;
		wrapDirection: #topToBottom;
		color: aColor lighter lighter;
		setNameTo: 'Parts';
		dropEnabled: false;
		vResizing: #spaceFill;
		yourself.

	self
		addMorph: aBin
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ (heights first + heights second) corner: 0 @ 0)).

	aBin color: (Color orange muchLighter);
		setNameTo: 'Objects' translated.

	self color: (Color orange muchLighter);
		setNameTo: 'Objects' translated.
! !

!ObjectsTool methodsFor: 'initialization' stamp: 'dgd 4/4/2006 16:47'!
initializeToStandAlone
	"Initialize the receiver so that it can live as a stand-alone morph"
	| buttonPane aBin aColor heights tabsPane |
	self basicInitialize.

	self layoutInset: 0;
		layoutPolicy: ProportionalLayout new;
		useRoundedCorners;
		hResizing: #rigid;
		vResizing: #rigid;
		extent: (self minimumWidth @ self minimumHeight).

	"mode buttons"
	buttonPane := self paneForTabs: self modeTabs.
	buttonPane color: ColorTheme current dialogColor.
	buttonPane
		vResizing: #shrinkWrap;
		setNameTo: 'ButtonPane';
		addMorphFront: self dismissButton;
		addMorphBack: self helpButton;
		color: (aColor := buttonPane color) darker;
		layoutInset: 5;
		wrapDirection: nil;
		width: self width;
		layoutChanged; fullBounds.

	"Place holder for a tabs or text pane"
	tabsPane := Morph new.
	tabsPane
		color: ColorTheme current dialogColor;
		setNameTo: 'TabPane';
		hResizing: #spaceFill.

	heights := { buttonPane height. 40 }.

	buttonPane vResizing: #spaceFill.
	self
		addMorph: buttonPane
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ heights first)).

	self
		addMorph: tabsPane
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ heights first corner: 0 @ (heights first + heights second))).

	aBin := (PartsBin newPartsBinWithOrientation: #leftToRight from: #())
		listDirection: #leftToRight;
		wrapDirection: #topToBottom;
		color: aColor lighter lighter;
		setNameTo: 'Parts';
		dropEnabled: false;
		vResizing: #spaceFill;
		yourself.

	self
		addMorph: aBin
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0 @ (heights first + heights second) corner: 0 @ 0)).

	self
		borderWidth: ColorTheme current dialogBorderWidth;
		borderColor: ColorTheme current dialogBorderColor;
		color: ColorTheme current dialogColor;
		setNameTo: 'Objects' translated;
		showCategories.
! !

!ObjectsTool methodsFor: 'tabs' stamp: 'nk 9/3/2004 13:47'!
initializeWithTabs: tabList
	"Initialize the receiver to have the given tabs"
	| oldPane newPane |
	oldPane := self tabsPane ifNil: [ self searchPane ].
	newPane := (self paneForTabs: tabList)
		setNameTo: 'TabPane';
		yourself.
	newPane layoutFrame: oldPane layoutFrame.
	self replaceSubmorph: oldPane by: newPane.
	newPane layoutChanged; fullBounds.
	self fixLayoutFrames.

! !

!ObjectsTool methodsFor: 'alphabetic' stamp: 'nk 9/3/2004 13:47'!
installQuads: quads fromButton: aButton
	"Install items in the bottom pane that correspond to the given set of quads, as triggered from the given button"

	| aPartsBin sortedQuads oldResizing |
	aPartsBin := self partsBin.
	oldResizing := aPartsBin vResizing.
	aPartsBin removeAllMorphs.
	sortedQuads := (PartsBin translatedQuads: quads)
							asSortedCollection: [:a :b | a third < b third].
	aPartsBin listDirection: #leftToRight quadList: sortedQuads.
	aButton ifNotNil: [self tabsPane highlightOnlySubmorph: aButton].
	aPartsBin vResizing: oldResizing.
	aPartsBin layoutChanged; fullBounds.
	self isFlap ifFalse: [ self minimizePartsBinSize ].! !

!ObjectsTool methodsFor: 'layout' stamp: 'nk 9/3/2004 13:47'!
minimizePartsBinSize
	self layoutChanged; fullBounds.
	self fixLayoutFrames.
	self setExtentFromHalo: (self minimumWidth @ self minimumHeight) ! !

!ObjectsTool methodsFor: 'layout' stamp: 'nk 9/3/2004 10:35'!
minimumBottom
	| iconsBottom partsBin |
	partsBin := self partsBin ifNil: [ ^self bottom ].
	iconsBottom := partsBin submorphs isEmpty
		ifTrue: [ partsBin top + 60 ]
		ifFalse: [ partsBin submorphBounds bottom + partsBin layoutInset ].

	^iconsBottom + self layoutInset + self borderWidth! !

!ObjectsTool methodsFor: 'layout' stamp: 'nk 9/3/2004 11:53'!
minimumHeight
	^(self minimumBottom - self top) max: 280! !

!ObjectsTool methodsFor: 'layout' stamp: 'nk 9/3/2004 12:06'!
minimumWidth
	"Answer a width that assures that the alphabet fits in two rows"

	^ 300! !

!ObjectsTool methodsFor: 'major modes' stamp: 'sw 8/12/2001 16:30'!
modeSymbol
	"Answer the modeSymbol"

	^ modeSymbol! !

!ObjectsTool methodsFor: 'major modes' stamp: 'nk 9/3/2004 13:32'!
modeSymbol: aSymbol
	"Set the receiver's modeSymbol as indicated"

	modeSymbol := aSymbol.
	self tweakAppearanceAfterModeShift.
! !

!ObjectsTool methodsFor: 'major modes' stamp: 'dgd 4/4/2006 16:47'!
modeTabs
	"Answer a list of buttons which, when hit, will trigger the choice of mode of the receiver"

	| buttonList aButton tupleList |
	tupleList :=  #(
		('alphabetic'		alphabetic	showAlphabeticTabs	'A separate tab for each letter of the alphabet')
		('find'				search			showSearchPane			'Provides a type-in pane allowing you to match')
		('categories'		categories	showCategories			'Grouped by category')

		"('standard'		standard		showStandardPane		'Standard Squeak tools supplies for building')"
	).
				
	buttonList := tupleList collect:
		[:tuple |
			aButton := SimpleButtonMorph new label: tuple first translated.
			aButton actWhen: #buttonUp.
			aButton setProperty: #modeSymbol toValue: tuple second.
			aButton target: self; actionSelector: tuple third.
			aButton setBalloonText: tuple fourth translated.
			aButton borderWidth: 0.
			aButton].
	^ buttonList

"ObjectsTool new modeTabs"! !

!ObjectsTool methodsFor: 'search' stamp: 'nk 9/3/2004 11:20'!
newSearchPane
	"Answer a type-in pane for searches"

	| aTextMorph |
	aTextMorph := TextMorph new
		setProperty: #defaultContents toValue: ('' asText allBold addAttribute: (TextFontChange font3));
		setTextStyle: (TextStyle fontArray: { Preferences standardEToysFont });
		setDefaultContentsIfNil;
		on: #keyStroke send: #searchPaneCharacter: to: self;
		setNameTo: 'SearchPane';
		setBalloonText: 'Type here and all entries that match will be shown.' translated;
		vResizing: #shrinkWrap;
		hResizing: #spaceFill;
		margins: 4@6;
		backgroundColor: Color white.
	^ aTextMorph! !

!ObjectsTool methodsFor: 'tabs' stamp: 'dgd 4/4/2006 16:44'!
paneForTabs: tabList 
	"Answer a pane bearing tabs for the given list"
	| aPane |
	tabList do: [:t |
			t color: Color transparent.
			t borderWidth: 1;
				borderColor: Color black].

	aPane := AlignmentMorph newRow
				color: ColorTheme current dialogColor;
				listDirection: #leftToRight;
				wrapDirection: #topToBottom;
				vResizing: #spaceFill;
				hResizing: #spaceFill;
				cellInset: 6;
				layoutInset: 4;
				listCentering: #center;
				listSpacing: #equal;
				addAllMorphs: tabList;
				yourself.

	aPane width: self layoutBounds width.

	^ aPane! !

!ObjectsTool methodsFor: 'submorph access' stamp: 'nk 9/3/2004 08:09'!
partsBin
	^self findDeeplyA: PartsBin.! !

!ObjectsTool methodsFor: 'layout' stamp: 'nk 9/3/2004 12:40'!
position: aPoint
	"The user has dragged the grow box such that the receiver's extent would be anExtent.  Do what's needed"
	self position = aPoint ifTrue: [ ^self ].
	super position: aPoint.
	self fixLayoutFrames.! !

!ObjectsTool methodsFor: 'tabs' stamp: 'dgd 8/30/2003 16:09'!
presentHelp
	"Sent when a Help button is hit; provide the user with some form of help for the tool at hand"

'The Objects tool allows you to browse through, and obtain copies of, many kinds of objects.  

You can obtain an Objects tool by choosing "Objects" from the world menu, or by the shortcut of typing alt-o (cmd-o) any time the cursor is over the desktop.

There are three ways to use Objects, corresponding to the three tabs seen at the top:

alphabetic - gives you separate tabs for a, b, c, etc.  Click any tab, and you will see the icons of all the objects whose names begin with that letter

search - gives you a type-in pane for a search string.  Type any letters there, and icons of all the objects whose names match what you have typed will appear in the bottom pane.

categories - provides tabs representing categories of related items.  Click on any tab to see the icons of all the objects in the category.

When the cursor lingers over the icon of any object, you will get balloon help for the item.

When you drag an icon from Objects, it will result in a new copy of it in your hand; the new object will be deposited wherever you next click.' translated

	openInWorkspaceWithTitle: 'About Objects' translated! !

!ObjectsTool methodsFor: 'menu' stamp: 'nk 9/7/2003 07:42'!
resetThumbnails
	"Reset the thumbnail cache"

	PartsBin clearThumbnailCache.
	modeSymbol == #categories ifTrue: [self showCategories] ifFalse: [self showAlphabeticTabs]! !

!ObjectsTool methodsFor: 'submorph access' stamp: 'nk 9/3/2004 10:40'!
searchPane
	"Answer the receiver's search pane, nil if none"

	^ self submorphNamed: 'SearchPane' ifNone: [].! !

!ObjectsTool methodsFor: 'search' stamp: 'sw 6/30/2001 14:26'!
searchPaneCharacter: evt
	"A character represented by the event handed in was typed in the search pane by the user"

	^ self showMorphsMatchingSearchString

"	| char |  *** The variant below only does a new search if RETURN or ENTER is hit ***
	char := evt keyCharacter.
	(char == Character enter or: [char == Character cr]) ifTrue:
		[self showMorphsMatchingSearchString]"! !

!ObjectsTool methodsFor: 'layout' stamp: 'nk 9/3/2004 12:44'!
setExtentFromHalo: anExtent
	"The user has dragged the grow box such that the receiver's extent would be anExtent.  Do what's needed"
	super setExtentFromHalo: ((anExtent x max: self minimumWidth) @ (anExtent y max: self minimumHeight)).
! !

!ObjectsTool methodsFor: 'search' stamp: 'nk 9/3/2004 10:39'!
setSearchStringFromSearchPane
	"Set the search string by obtaining its contents from the search pane, and doing a certain amount of munging"

	searchString := self searchPane text string asLowercase withBlanksTrimmed.
	searchString := searchString copyWithoutAll: {Character enter. Character cr}! !

!ObjectsTool methodsFor: 'submorph access' stamp: 'nk 9/3/2004 13:51'!
showAlphabeticCategory: aString fromButton: aButton 
	"Blast items beginning with a given letter into my lower pane"
	| eligibleClasses quads uc |
	self partsBin removeAllMorphs.
	uc := aString asUppercase asCharacter.
	Cursor wait
		showWhile: [eligibleClasses := Morph withAllSubclasses.
			quads := OrderedCollection new.
			eligibleClasses
				do: [:aClass | aClass theNonMetaClass
						addPartsDescriptorQuadsTo: quads
						if: [:info | info formalName translated asUppercase first = uc]].
			self installQuads: quads fromButton: aButton]! !

!ObjectsTool methodsFor: 'alphabetic' stamp: 'nk 9/3/2004 12:13'!
showAlphabeticTabs
	"Switch to the mode of showing alphabetic tabs"

	modeSymbol == #alphabetic ifTrue: [ ^self ].
	self partsBin removeAllMorphs.
	self initializeWithTabs: self alphabeticTabs.
	self modeSymbol: #alphabetic.
	self tabsPane submorphs first doButtonAction! !

!ObjectsTool methodsFor: 'categories' stamp: 'nk 9/3/2004 13:43'!
showCategories
	"Set the receiver up so that it shows tabs for each of the standard categories"

	modeSymbol == #categories ifTrue: [ ^self ].

	self partsBin removeAllMorphs.
	self initializeWithTabs: self tabsForCategories.
	self modeSymbol: #categories.
	self tabsPane submorphs first doButtonAction.
! !

!ObjectsTool methodsFor: 'categories' stamp: 'nk 9/3/2004 13:51'!
showCategory: aCategoryName fromButton: aButton 
	"Project items from the given category into my lower pane"
	| quads |
	self partsBin removeAllMorphs.
	Cursor wait
		showWhile: [quads := OrderedCollection new.
			Morph withAllSubclasses
				do: [:aClass | aClass theNonMetaClass
						addPartsDescriptorQuadsTo: quads
						if: [:aDescription | aDescription translatedCategories includes: aCategoryName]].
			quads := quads
						asSortedCollection: [:q1 :q2 | q1 third <= q2 third].
			self installQuads: quads fromButton: aButton]! !

!ObjectsTool methodsFor: 'search' stamp: 'nk 9/3/2004 13:51'!
showMorphsMatchingSearchString
	"Put items matching the search string into my lower pane"
	| quads |
	self setSearchStringFromSearchPane.
	self partsBin removeAllMorphs.
	Cursor wait
		showWhile: [quads := OrderedCollection new.
			Morph withAllSubclasses
				do: [:aClass | aClass
						addPartsDescriptorQuadsTo: quads
						if: [:info | info formalName translated includesSubstring: searchString caseSensitive: false]].
			self installQuads: quads fromButton: nil]! !

!ObjectsTool methodsFor: 'search' stamp: 'nk 9/3/2004 12:13'!
showSearchPane
	"Set the receiver up so that it shows the search pane"

	| tabsPane aPane frame |
	modeSymbol == #search ifTrue: [ ^self ].

	self partsBin removeAllMorphs.

	tabsPane := self tabsPane.
	aPane := self newSearchPane.
	aPane layoutChanged; fullBounds.

	aPane layoutFrame: (frame := tabsPane layoutFrame copy).
	frame bottomOffset: (frame topOffset + aPane height).
	self replaceSubmorph: tabsPane by: aPane.
	self partsBin layoutFrame topOffset: frame bottomOffset.

	self modeSymbol: #search.
	self showMorphsMatchingSearchString.
	ActiveHand newKeyboardFocus: aPane! !

!ObjectsTool methodsFor: 'categories' stamp: 'nk 8/23/2004 18:18'!
tabsForCategories
	"Answer a list of buttons which, when hit, will trigger the choice of a category"

	| buttonList aButton classes categoryList basic |
	classes := Morph withAllSubclasses.
	categoryList := Set new.
	classes do: [:aClass |
		(aClass class includesSelector: #descriptionForPartsBin) ifTrue:
			[categoryList addAll: aClass descriptionForPartsBin translatedCategories].
		(aClass class includesSelector: #supplementaryPartsDescriptions) ifTrue:
			[aClass supplementaryPartsDescriptions do:
				[:aDescription | categoryList addAll: aDescription translatedCategories]]].

	categoryList := OrderedCollection withAll: (categoryList asSortedArray).
	
	basic := categoryList remove: ' Basic' translated ifAbsent: [ ].
	basic ifNotNil: [ categoryList addFirst: basic ].

	basic := categoryList remove: 'Basic' translated ifAbsent: [ ].
	basic ifNotNil: [ categoryList addFirst: basic ].

	buttonList := categoryList collect:
		[:catName |
			aButton := SimpleButtonMorph new label: catName.
			aButton actWhen: #buttonDown.
			aButton target: self; actionSelector: #showCategory:fromButton:; arguments: {catName. aButton}].
	^ buttonList

"ObjectsTool new tabsForCategories"! !

!ObjectsTool methodsFor: 'submorph access' stamp: 'nk 9/3/2004 08:06'!
tabsPane
	"Answer the receiver's tabs pane, nil if none"

	^ self submorphNamed: 'TabPane' ifNone: [].! !

!ObjectsTool methodsFor: 'initialization' stamp: 'dgd 4/4/2006 16:45'!
tweakAppearanceAfterModeShift
	"After the receiver has been put into a given mode, make an initial selection of category, if appropriate, and highlight the mode button."

	self buttonPane submorphs do:
		[:aButton | 
			| aColor |
			"aButton borderWidth: 1."
			aColor := (aButton valueOfProperty: #modeSymbol) = modeSymbol
				ifTrue: [Color red]
				ifFalse: [Color black].

			aButton firstSubmorph color: aColor.
			aButton borderColor: aColor.
		].! !

AlignmentMorph subclass: #RecordingControlsMorph
	instanceVariableNames: 'recorder recordingStatusLight recordMeter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SoundInterface'!

!RecordingControlsMorph class methodsFor: 'parts bin' stamp: 'sw 8/2/2001 18:18'!
descriptionForPartsBin
	^ self partName:	'SoundRecorder'
		categories:		#('Multimedia')
		documentation:	'A device for making sound recordings.'! !

!RecordingControlsMorph class methodsFor: 'class initialization' stamp: 'asm 4/11/2003 10:54'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(RecordingControlsMorph	authoringPrototype	'Sound' 	'A device for making sound recordings.')
						forFlapNamed: 'PlugIn Supplies'.
						cl registerQuad: #(RecordingControlsMorph	authoringPrototype	'Sound' 	'A device for making sound recordings.')
						forFlapNamed: 'Widgets'.]! !

!RecordingControlsMorph methodsFor: 'initialization' stamp: 'dgd 9/19/2003 12:21'!
addButtonRows

	| r |
	r := AlignmentMorph newRow vResizing: #shrinkWrap.


	r addMorphBack: (self buttonName: 'Morph' translated action: #makeSoundMorph).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'Tile' translated action: #makeTile).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'Trim' translated action: #trim).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'Show' translated action: #show).
	self addMorphBack: r.

	r := AlignmentMorph newRow vResizing: #shrinkWrap.
	r addMorphBack: (self buttonName: 'Record' translated action: #record).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'Stop' translated action: #stop).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'Play' translated action: #playback).
	r addMorphBack: self makeStatusLight.
	self addMorphBack: r.
! !

!RecordingControlsMorph methodsFor: 'other' stamp: 'ar 11/9/2000 21:21'!
addRecordLevelSlider

	| levelSlider r |
	levelSlider := SimpleSliderMorph new
		color: color;
		extent: 100@2;
		target: recorder;
		actionSelector: #recordLevel:;
		adjustToValue: recorder recordLevel.
	r := AlignmentMorph newRow
		color: color;
		layoutInset: 0;
		wrapCentering: #center; cellPositioning: #leftCenter;
		hResizing: #shrinkWrap;
		vResizing: #rigid;
		height: 24.
	r addMorphBack: (StringMorph contents: '0 ').
	r addMorphBack: levelSlider.
	r addMorphBack: (StringMorph contents: ' 10').
	self addMorphBack: r.
! !

!RecordingControlsMorph methodsFor: 'other' stamp: 'jhm 10/15/97 14:30'!
buttonName: aString action: aSymbol

	^ SimpleButtonMorph new
		target: self;
		label: aString;
		actionSelector: aSymbol
! !

!RecordingControlsMorph methodsFor: 'button commands' stamp: 'jhm 10/15/97 15:28'!
done

	recorder stopRecording.
	self makeTile.
	self delete.
! !

!RecordingControlsMorph methodsFor: 'initialization' stamp: 'ar 11/9/2000 21:58'!
initialize

	| r |
	super initialize.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	borderWidth := 2.
	self listDirection: #topToBottom.
	recorder := SoundRecorder new.
	self addButtonRows.
	self addRecordLevelSlider.

	r := AlignmentMorph newRow vResizing: #shrinkWrap.
	r addMorphBack: self makeRecordMeter.
	self addMorphBack: r.
	self extent: 10@10.  "make minimum size"
! !

!RecordingControlsMorph methodsFor: 'other' stamp: 'jm 8/24/97 21:31'!
makeRecordMeter

	| outerBox |
	outerBox := Morph new extent: 102@18; color: Color gray.
	recordMeter := Morph new extent: 1@16; color: Color yellow.
	recordMeter position: outerBox topLeft + (1@1).
	outerBox addMorph: recordMeter.
	^ outerBox
! !

!RecordingControlsMorph methodsFor: 'button commands' stamp: 'sw 6/10/2003 12:59'!
makeSoundMorph

	| m |
	recorder verifyExistenceOfRecordedSound ifFalse: [^ self].

	recorder pause.
	m := SoundEventMorph new sound: recorder recordedSound.
	self world firstHand attachMorph: m.
! !

!RecordingControlsMorph methodsFor: 'other' stamp: 'jhm 10/15/97 15:06'!
makeStatusLight

	recordingStatusLight := Morph new extent: 18@18.
	recordingStatusLight color: Color transparent.
	^ recordingStatusLight
! !

!RecordingControlsMorph methodsFor: 'button commands' stamp: 'sw 3/3/2004 19:49'!
makeTile
	"Make a tile representing my sound.  Get a sound-name from the user by which the sound is to be known."

	| newStyleTile sndName tile |
	recorder verifyExistenceOfRecordedSound ifFalse: [^ self].
	recorder pause.
	newStyleTile := true.
	newStyleTile
		ifTrue:
			[sndName := FillInTheBlank
				request: 'Please name your new sound' translated
				initialAnswer: 'sound' translated.
			sndName isEmpty ifTrue: [^ self].

			sndName := SampledSound unusedSoundNameLike: sndName.
			SampledSound
				addLibrarySoundNamed: sndName
				samples: recorder condensedSamples
				samplingRate: recorder samplingRate.
			tile := SoundTile new literal: sndName]
		ifFalse:
			[tile := InterimSoundMorph new sound: 
				(SampledSound
					samples: recorder condensedSamples
					samplingRate: recorder samplingRate)].

	tile bounds: tile fullBounds.
	tile openInHand! !

!RecordingControlsMorph methodsFor: 'button commands' stamp: 'sw 6/10/2003 12:59'!
playback
	"The user hit the playback button"

	recorder verifyExistenceOfRecordedSound ifFalse: [^ self].
	recorder pause.
	recorder playback.
! !

!RecordingControlsMorph methodsFor: 'button commands' stamp: 'jhm 10/15/97 14:30'!
record

	recorder clearRecordedSound.
	recorder resumeRecording.
! !

!RecordingControlsMorph methodsFor: 'accessing' stamp: 'jm 9/13/97 17:20'!
recorder

	^ recorder
! !

!RecordingControlsMorph methodsFor: 'button commands' stamp: 'sw 6/10/2003 12:59'!
show
	"Show my samples in a WaveEditor."

	| ed w |
	recorder verifyExistenceOfRecordedSound ifFalse: [^ self].
	recorder pause.
	ed := WaveEditor new.
	ed data: recorder condensedSamples.
	ed samplingRate: recorder samplingRate.
	w := self world.
	w activeHand
		ifNil: [w addMorph: ed]
		ifNotNil: [w activeHand attachMorph: ed].

! !

!RecordingControlsMorph methodsFor: 'stepping and presenter' stamp: 'tk 6/24/1999 11:41'!
startStepping
	"Make the level meter active when dropped into the world. Do nothing if already recording. Note that this will cause other recorders to stop recording..."

	super startStepping.
	recorder isPaused ifTrue: [
		SoundRecorder allSubInstancesDo: [:r | r stopRecording].  "stop all other sound recorders"
		recorder pause].  "meter is updated while paused"
! !

!RecordingControlsMorph methodsFor: 'stepping and presenter' stamp: 'jm 10/17/97 15:00'!
step

	recorder isPaused
		ifTrue: [recordingStatusLight color: Color transparent]
		ifFalse: [recordingStatusLight color: Color red].
	recordMeter extent: (recorder meterLevel + 1) @ recordMeter height.
! !

!RecordingControlsMorph methodsFor: 'testing' stamp: 'jm 8/24/97 21:00'!
stepTime

	^ 50
! !

!RecordingControlsMorph methodsFor: 'stepping and presenter' stamp: 'jhm 10/15/97 14:30'!
stop

	recorder pause.
! !

!RecordingControlsMorph methodsFor: 'stepping and presenter' stamp: 'jm 10/17/97 15:13'!
stopStepping
	"Turn off recording."

	super stopStepping.
	recorder stopRecording.
! !

!RecordingControlsMorph methodsFor: 'button commands' stamp: 'sw 6/10/2003 12:59'!
trim
	"Show my samples in a GraphMorph."
	
	recorder verifyExistenceOfRecordedSound ifFalse: [^ self].
	recorder pause.
	recorder trim: 1400 normalizedVolume: 80.0.
! !

!RecordingControlsMorph methodsFor: 'copying' stamp: 'jm 10/17/97 15:17'!
updateReferencesUsing: aDictionary
	"Copy my recorder."

	super updateReferencesUsing: aDictionary.
	recorder := SoundRecorder new.
! !

AlignmentMorph subclass: #SoundDemoMorph
	instanceVariableNames: 'soundColumn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SoundInterface'!

!SoundDemoMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:40'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 2! !

!SoundDemoMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:31'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color lightGray! !

!SoundDemoMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:04'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self listDirection: #topToBottom;
		 wrapCentering: #center;
		 cellPositioning: #topCenter;
		 hResizing: #spaceFill;
		 vResizing: #spaceFill;
		 layoutInset: 3;
		 addMorph: self makeControls;
	initializeSoundColumn.
	self extent: 118 @ 150! !

!SoundDemoMorph methodsFor: 'initialization' stamp: 'jam 3/9/2003 17:52'!
initializeSoundColumn
"initialize the receiver's soundColumn"
	soundColumn := AlignmentMorph newColumn.
	soundColumn enableDragNDrop.
	self addMorphBack: soundColumn! !

!SoundDemoMorph methodsFor: 'as yet unclassified' stamp: 'tk 2/19/2001 17:49'!
makeControls

	| bb r cc |
	cc := Color black.
	r := AlignmentMorph newRow.
	r color: cc; borderWidth: 0; layoutInset: 0.
	r hResizing: #shrinkWrap; vResizing: #shrinkWrap; extent: 5@5.
	bb := SimpleButtonMorph new target: self; borderColor: cc.
	r addMorphBack: (bb label: 'V1';			actionSelector: #playV1).
	bb := SimpleButtonMorph new target: self; borderColor: cc.
	r addMorphBack: (bb label: 'V2';			actionSelector: #playV2).
	bb := SimpleButtonMorph new target: self; borderColor: cc.
	r addMorphBack: (bb label: 'V3';			actionSelector: #playV3).
	bb := SimpleButtonMorph new target: self; borderColor: cc.
	r addMorphBack: (bb label: 'All';			actionSelector: #playAll).
	bb := SimpleButtonMorph new target: self; borderColor: cc.
	r addMorphBack: (bb label: 'Stop';		actionSelector: #stopSound).
	^ r
! !

!SoundDemoMorph methodsFor: 'as yet unclassified' stamp: 'dgd 2/22/2003 13:34'!
playAll
	| snd |
	soundColumn submorphs isEmpty
		ifTrue: [^ self].
	self setTimbreFromTile: soundColumn submorphs first.
	snd := SampledSound bachFugueVoice1On: SampledSound new.
	soundColumn submorphs size >= 2
		ifTrue: [""self setTimbreFromTile: soundColumn submorphs second.
			snd := snd
						+ (AbstractSound bachFugueVoice2On: SampledSound new)].
	soundColumn submorphs size >= 3
		ifTrue: [""self setTimbreFromTile: soundColumn submorphs third.
			snd := snd
						+ (AbstractSound bachFugueVoice3On: SampledSound new)].
	snd play! !

!SoundDemoMorph methodsFor: 'as yet unclassified' stamp: 'dgd 2/22/2003 13:35'!
playV1
	soundColumn submorphs isEmpty
		ifTrue: [^ self].
	self
		setTimbreFromTile: (soundColumn submorphs first).
	(SampledSound bachFugueVoice1On: SampledSound new) play! !

!SoundDemoMorph methodsFor: 'as yet unclassified' stamp: 'dgd 2/22/2003 13:35'!
playV2
	soundColumn submorphs size < 2
		ifTrue: [^ self].
	self
		setTimbreFromTile: (soundColumn submorphs second).
	(SampledSound bachFugueVoice2On: SampledSound new) playSilentlyUntil: 4.8;
		 resumePlaying! !

!SoundDemoMorph methodsFor: 'as yet unclassified' stamp: 'dgd 2/22/2003 13:35'!
playV3
	soundColumn submorphs size < 3
		ifTrue: [^ self].
	self
		setTimbreFromTile: (soundColumn submorphs third).
	(AbstractSound bachFugueVoice3On: SampledSound new) playSilentlyUntil: 14.4;
		 resumePlaying! !

!SoundDemoMorph methodsFor: 'as yet unclassified' stamp: 'jm 11/14/97 11:09'!
setTimbreFromTile: aSoundTile

	SampledSound defaultSampleTable: aSoundTile sound samples.
	SampledSound nominalSamplePitch: 400.
! !

!SoundDemoMorph methodsFor: 'as yet unclassified' stamp: 'jm 11/14/97 11:09'!
stopSound

	SoundPlayer shutDown.
! !

AlignmentMorph subclass: #SpectrumAnalyzerMorph
	instanceVariableNames: 'soundInput statusLight levelMeter graphMorph sonogramMorph fft displayType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SoundInterface'!

!SpectrumAnalyzerMorph commentStamp: '<historical>' prior: 0!
I am a tool for analyzing sound data from a microphone, CD, or other input source in real time. I have several display modes:

	signal		snapshots of the raw signal data as it arrives
	spectrum	frequency spectrum of the signal data as it arrives
	sonogram	scrolling plot of the frequency spectrum over time,
			      where the vertical axis is frequency, the horizontal
				  axis is time, and amount of energy at a given
				  frequency is shown as a grayscale value with
				  larger values being darker

To use this tool, be sure that you have selected the proper sound source using you host OS facilities. Set the desired sampling rate and FFT size (try 22050 samples/sec and an FFT size of 512) then click on the 'start' button. Use the slider to adjust the level so that the yellow level indicator peaks somewhere between the middle and the right edge at the maximum signal level.

Note that if the level meter peaks hit the right edge, you will get 'clipping', which creates a bunch of spurious high frequency noise in the frequency spectrum. If the display is set to 'signal' mode, you can actually see the tops and bottoms of the waveform being cut off when clipping occurs.

Many machines may not be able to perform spectrum analysis in real time, especially at higher sampling rates and larger FFT sizes. In both 'signal' and 'spectrum' modes, this tool will skip data to try to keep up with real time. However, in 'sonogram' mode it always processes all the data, even if it falls behind. This allows you to get a complete sonogram without dropouts even on a slower machine. However, as the sonogram display falls behind there will be a larger and larger time lag between when a sound is input and when it appears on the display.

The smaller the FFT size, the less frequency resolution you get. The lower the sampling rate, the less total frequency range you get. For an FFT size of N and a sampling rate of R, each of the N/2 'bins' of the frequency spectrum has a frequency resolution of R / N. For example, at a sampleing rate of 22050 samples/second, the total frequency range is 0 to 11025 Hz and an FFT of size 256 would divide this range into 128 bins (the output of an FFT of size N has N/2 bins), each of which covers a frequency band about 86 Hz wide.

To increase time resolution, increase the sampling rate and decrease the FFT size.
!

!SpectrumAnalyzerMorph methodsFor: 'private' stamp: 'dgd 9/19/2003 13:30'!
addButtonRow

	| r |
	r := AlignmentMorph newRow vResizing: #shrinkWrap.
	r addMorphBack: (self buttonName: 'Menu' translated action: #invokeMenu).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'Start' translated action: #start).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'Stop' translated action: #stop).
	r addMorphBack: (Morph new extent: 12@1; color: Color transparent).
	r addMorphBack: self makeStatusLight.
	self addMorphBack: r.
! !

!SpectrumAnalyzerMorph methodsFor: 'private' stamp: 'ar 11/9/2000 21:23'!
addLevelSlider

	| levelSlider r |
	levelSlider := SimpleSliderMorph new
		color: color;
		extent: 100@2;
		target: soundInput;
		actionSelector: #recordLevel:;
		adjustToValue: soundInput recordLevel.
	r := AlignmentMorph newRow
		color: color;
		layoutInset: 0;
		wrapCentering: #center; cellPositioning: #leftCenter;
		hResizing: #shrinkWrap;
		vResizing: #rigid;
		height: 24.
	r addMorphBack: (StringMorph contents: '0 ').
	r addMorphBack: levelSlider.
	r addMorphBack: (StringMorph contents: ' 10').
	self addMorphBack: r.
! !

!SpectrumAnalyzerMorph methodsFor: 'private' stamp: 'jhm 10/15/97 14:30'!
buttonName: aString action: aSymbol

	^ SimpleButtonMorph new
		target: self;
		label: aString;
		actionSelector: aSymbol
! !

!SpectrumAnalyzerMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:52'!
defaultBorderWidth
"answer the default border width for the receiver"
	^ 2! !

!SpectrumAnalyzerMorph methodsFor: 'submorphs-add/remove' stamp: 'jm 9/6/1999 14:40'!
delete
	"Turn off recording when this morph is deleted."

	super delete.
	soundInput stopRecording.
! !

!SpectrumAnalyzerMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:52'!
initialize
"initialize the state of the receiver"
	super initialize.
""
	self listDirection: #topToBottom.
	soundInput := SoundInputStream new samplingRate: 22050.
	fft := FFT new: 512.
	displayType := 'sonogram'.
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.
	self addButtonRow.
	self addLevelSlider.
	self addMorphBack: self makeLevelMeter.
	self addMorphBack: (Morph new extent: 10 @ 10;
			 color: Color transparent).
	"spacer"
	self resetDisplay! !

!SpectrumAnalyzerMorph methodsFor: 'menu and buttons' stamp: 'dgd 9/19/2003 13:25'!
invokeMenu
	"Invoke the settings menu."

	| aMenu |
	aMenu := CustomMenu new.
	aMenu addList:	{
		{'set sampling rate' translated.		#setSamplingRate}.
		{'set FFT size' translated.			#setFFTSize}.
		{'set display type' translated.		#setDisplayType}}.
	aMenu invokeOn: self defaultSelection: nil.
! !

!SpectrumAnalyzerMorph methodsFor: 'private' stamp: 'jm 9/8/1999 13:27'!
makeLevelMeter

	| outerBox |
	outerBox := RectangleMorph new extent: 125@14; color: Color lightGray.
	levelMeter := Morph new extent: 2@10; color: Color yellow.
	levelMeter position: outerBox topLeft + (2@2).
	outerBox addMorph: levelMeter.
	^ outerBox
! !

!SpectrumAnalyzerMorph methodsFor: 'private' stamp: 'dgd 9/19/2003 13:31'!
makeStatusLight

	| s |
	statusLight := RectangleMorph new extent: 24@19.
	statusLight color: Color gray.
	s := StringMorph contents: 'On' translated.
	s position: statusLight center - (s extent // 2).
	statusLight addMorph: s.
	^ statusLight
! !

!SpectrumAnalyzerMorph methodsFor: 'private' stamp: 'gm 2/28/2003 00:11'!
processBuffer: buf 
	"Analyze one buffer of data."

	| data |
	data := displayType = 'signal' 
		ifTrue: [buf]
		ifFalse: [fft transformDataFrom: buf startingAt: 1].
	graphMorph ifNotNil: 
			[graphMorph
				data: data;
				changed].
	sonogramMorph ifNotNil: 
			[data := data collect: [:v | v sqrt].	"square root compresses dynamic range"
			data /= 400.0.
			sonogramMorph plotColumn: (data copyFrom: 1 to: data size // 1)]! !

!SpectrumAnalyzerMorph methodsFor: 'private' stamp: 'jm 9/8/1999 12:49'!
removeAllDisplays
	"Remove all currently showing displays."

	sonogramMorph ifNotNil: [sonogramMorph delete].
	graphMorph ifNotNil: [graphMorph delete].
	sonogramMorph := graphMorph := nil.
! !

!SpectrumAnalyzerMorph methodsFor: 'menu and buttons' stamp: 'jm 9/8/1999 12:52'!
resetDisplay
	"Recreate my display after changing some parameter such as FFT size."

	displayType = 'signal' ifTrue: [self showSignal].
	displayType = 'spectrum' ifTrue: [self showSpectrum].
	displayType = 'sonogram' ifTrue: [self showSonogram].
! !

!SpectrumAnalyzerMorph methodsFor: 'menu and buttons' stamp: 'dgd 9/19/2003 13:29'!
setDisplayType
	"Set the display type."

	| aMenu choice on |
	aMenu := CustomMenu new title: ('display type (currently {1})' translated format:{displayType}).
	aMenu addList:	{
		{'signal' translated.	'signal'}.
		{'spectrum' translated.	'spectrum'}.
		{'sonogram' translated.	'sonogram'}}.
	choice := aMenu startUp.
	choice ifNil: [^ self].

	on := soundInput isRecording.
	self stop.
	displayType := choice.
	self resetDisplay.
	on ifTrue: [self start].

! !

!SpectrumAnalyzerMorph methodsFor: 'menu and buttons' stamp: 'dgd 9/19/2003 13:27'!
setFFTSize
	"Set the size of the FFT used for frequency analysis."

	| aMenu sz on |
	aMenu := CustomMenu new title: ('FFT size (currently {1})' translated format:{fft n}).
	((7 to: 10) collect: [:n | 2 raisedTo: n]) do:[:r | aMenu add: r printString action: r].
	sz := aMenu startUp.
	sz ifNil: [^ self].
	on := soundInput isRecording.
	self stop.
	fft := FFT new: sz.
	self resetDisplay.
	on ifTrue: [self start].
! !

!SpectrumAnalyzerMorph methodsFor: 'menu and buttons' stamp: 'dgd 9/19/2003 13:26'!
setSamplingRate
	"Set the sampling rate to be used for incoming sound data."

	| aMenu rate on |
	aMenu := CustomMenu new title:
		('Sampling rate (currently {1})' translated format:{soundInput samplingRate}).
	#(11025 22050 44100) do:[:r | aMenu add: r printString action: r].
	rate := aMenu startUp.
	rate ifNil: [^ self].
	on := soundInput isRecording.
	self stop.
	soundInput samplingRate: rate.
	self resetDisplay.
	on ifTrue: [self start].

! !

!SpectrumAnalyzerMorph methodsFor: 'private' stamp: 'jm 9/8/1999 19:56'!
showSignal
	"Display the actual signal waveform."

	displayType := 'signal'.
	self removeAllDisplays.
	graphMorph := GraphMorph new.
	graphMorph extent: (400 + (2 * graphMorph borderWidth))@128.
	graphMorph data: (Array new: 100 withAll: 0).
	graphMorph color: (Color r: 0.8 g: 1.0 b: 1.0).
	self addMorphBack: graphMorph.
	self extent: 10@10.  "shrink to minimum size"
! !

!SpectrumAnalyzerMorph methodsFor: 'private' stamp: 'jm 9/8/1999 19:43'!
showSonogram
	"Display a sonogram showing the frequency spectrum versus time."

	| zeros h w |
	displayType := 'sonogram'.
	self removeAllDisplays.
	h := fft n // 2.
	h := h min: 512 max: 64.
	w := 400.
	sonogramMorph :=
		Sonogram new
			extent: w@h
			minVal: 0.0
			maxVal: 1.0
			scrollDelta: w.
	zeros := Array new: sonogramMorph height withAll: 0.
	sonogramMorph width timesRepeat: [sonogramMorph plotColumn: zeros].
	self addMorphBack: sonogramMorph.
	self extent: 10@10.  "shrink to minimum size"
! !

!SpectrumAnalyzerMorph methodsFor: 'private' stamp: 'jm 9/8/1999 15:10'!
showSpectrum
	"Display the frequency spectrum."

	displayType := 'spectrum'.
	self removeAllDisplays.
	graphMorph := GraphMorph new.
	graphMorph extent: ((fft n // 2) + (2 * graphMorph borderWidth))@128.
	graphMorph data: (Array new: fft n // 2 withAll: 0).
	self addMorphBack: graphMorph.
	self extent: 10@10.  "shrink to minimum size"
! !

!SpectrumAnalyzerMorph methodsFor: 'stepping and presenter' stamp: 'jm 9/8/1999 15:12'!
start
	"Start displaying sound data."

	displayType = 'signal'
		ifTrue: [soundInput bufferSize: graphMorph width - (2 * graphMorph borderWidth)]
		ifFalse: [soundInput bufferSize: fft n].
	soundInput startRecording.
! !

!SpectrumAnalyzerMorph methodsFor: 'stepping and presenter' stamp: 'jm 9/8/1999 19:05'!
step
	"Update the record light, level meter, and display."

	| w |
	"update the record light and level meter"
	soundInput isRecording
		ifTrue: [statusLight color: Color yellow]
		ifFalse: [statusLight color: Color gray].
	w := ((121 * soundInput meterLevel) // 100) max: 1.
	levelMeter width ~= w ifTrue: [levelMeter width: w].

	"update the display if any data is available"
	self updateDisplay.
! !

!SpectrumAnalyzerMorph methodsFor: 'testing' stamp: 'jm 9/7/1999 22:26'!
stepTime

	^ 0
! !

!SpectrumAnalyzerMorph methodsFor: 'stepping and presenter' stamp: 'jm 9/8/1999 15:12'!
stop
	"Stop displaying sound data."

	soundInput stopRecording.
! !

!SpectrumAnalyzerMorph methodsFor: 'stepping and presenter' stamp: 'jm 9/6/1999 12:12'!
stopStepping
	"Turn off recording."

	super stopStepping.
	soundInput stopRecording.
! !

!SpectrumAnalyzerMorph methodsFor: 'private' stamp: 'jm 9/8/1999 19:39'!
updateDisplay
	"Update the display if any data is available."

	| buf bufCount |
	soundInput bufferCount = 0 ifTrue: [^ self].

	graphMorph ifNotNil: [
		[soundInput bufferCount > 0] whileTrue: [
			"skip to the most recent buffer"
			buf := soundInput nextBufferOrNil].
		^ self processBuffer: buf].

	sonogramMorph ifNotNil: [
		"at small buffer sizes we have to update the sonogram in
		 batches or we may get behind; shoot for 8 updates/second"
		bufCount := (soundInput samplingRate / (8 * soundInput bufferSize)) truncated max: 1.
		[bufCount > 0 and: [soundInput bufferCount > 0]] whileTrue: [
			self processBuffer: (soundInput nextBufferOrNil)]].
! !

AlignmentMorph subclass: #WaveEditor
	instanceVariableNames: 'graph samplingRate perceivedFrequency loopEnd loopLength loopCycles possibleLoopStarts keyboard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SoundInterface'!

!WaveEditor commentStamp: '<historical>' prior: 0!
This tool was created to aid in the preparation of LoopedSampledSound objects. It includes support for finding good loop points with a little help from the user.  Namely, the user must identify a good ending point for the loop (typically just before the decay phase begins) and identify one cycle of the waveform. After that, the  "choose loop point" menu command can be invoked to search backwards to find and rank all possible loop starting points. Some experimentation is usually required to find a loop that "breaths" in a natural way.

This tool can also be used as a general viewer of numerical sequences of any kind, such as time-varying functions, FFT data, etc.!

!WaveEditor class methodsFor: 'parts bin' stamp: 'sw 8/2/2001 14:52'!
descriptionForPartsBin
	^ self partName:	'WaveEditor'
		categories:		#('Multimedia')
		documentation:	'A workbench for seing and editing wave forms'! !

!WaveEditor class methodsFor: 'instance creation' stamp: 'jm 9/6/1999 11:21'!
openOn: dataCollection
	"Open a new WaveEditor on the given sequencable collection of data."

	^ (self new data: dataCollection) openInWorld
! !

!WaveEditor methodsFor: 'initialization' stamp: 'dgd 9/19/2003 12:23'!
addControls

	| slider bb r m |
	r := AlignmentMorph newRow.
	bb := SimpleButtonMorph new target: self; borderColor: Color black.
	r color: bb color; borderWidth: 0; layoutInset: 0.
	r hResizing: #shrinkWrap; vResizing: #shrinkWrap; extent: 5@5.
	r wrapCentering: #topLeft.
	bb := SimpleButtonMorph new target: self; borderColor: Color black.
	r addMorphBack: (bb label: 'X';					actionSelector: #delete).
	bb := SimpleButtonMorph new target: self; borderColor: Color black.
	r addMorphBack: (bb label: '<>'; actWhen: #buttonDown;
															actionSelector: #invokeMenu).
	bb := SimpleButtonMorph new target: self; borderColor: Color black.
	r addMorphBack: (bb label: 'Play' translated;				actionSelector: #play).
	bb := SimpleButtonMorph new target: self; borderColor: Color black.
	r addMorphBack: (bb label: 'Play Before' translated;		actionSelector: #playBeforeCursor).
	bb := SimpleButtonMorph new target: self; borderColor: Color black.
	r addMorphBack: (bb label: 'Play After' translated;			actionSelector: #playAfterCursor).
	bb := SimpleButtonMorph new target: self; borderColor: Color black.
	r addMorphBack: (bb label: 'Play Loop' translated;			actionSelector: #playLoop).
	bb := SimpleButtonMorph new target: self; borderColor: Color black.
	r addMorphBack: (bb label: 'Test' translated;				actionSelector: #playTestNote).
	bb := SimpleButtonMorph new target: self; borderColor: Color black.
	r addMorphBack: (bb label: 'Save' translated;				actionSelector: #saveInstrument).
	bb := SimpleButtonMorph new target: self; borderColor: Color black.
	r addMorphBack: (bb label: 'Set Loop End' translated;		actionSelector: #setLoopEnd).
	bb := SimpleButtonMorph new target: self; borderColor: Color black.
	r addMorphBack: (bb label: 'One Cycle' translated;			actionSelector: #setOneCycle).
	bb := SimpleButtonMorph new target: self; borderColor: Color black.
	r addMorphBack: (bb label: 'Set Loop Start' translated;		actionSelector: #setLoopStart).
	self addMorphBack: r.

	r := AlignmentMorph newRow.
	r color: self color; borderWidth: 0; layoutInset: 0.
	r hResizing: #spaceFill; vResizing: #rigid; extent: 5@20; wrapCentering: #center; cellPositioning: #leftCenter.

	m := StringMorph new contents: 'Index: ' translated.
	r addMorphBack: m.
	m := UpdatingStringMorph new
		target: graph; getSelector: #cursor; putSelector: #cursor:;
		growable: false; width: 71; step.
	r addMorphBack: m.

	m := StringMorph new contents: 'Value: ' translated.
	r addMorphBack: m.
	m := UpdatingStringMorph new
		target: graph; getSelector: #valueAtCursor; putSelector: #valueAtCursor:;
		growable: false; width: 50; step.
	r addMorphBack: m.

	slider := SimpleSliderMorph new
		color: color;
		extent: 200@2;
		target: self;
		actionSelector: #scrollTime:.
	r addMorphBack: slider.

	m := Morph new color: r color; extent: 10@5.  "spacer"
	r addMorphBack: m.
	m := UpdatingStringMorph new
		target: graph; getSelector: #startIndex; putSelector: #startIndex:;
		width: 40; step.
	r addMorphBack: m.

	self addMorphBack: r.

! !

!WaveEditor methodsFor: 'initialization' stamp: 'dgd 9/19/2003 12:23'!
addLoopPointControls

	| r m |
	r := AlignmentMorph newRow.
	r color: self color; borderWidth: 0; layoutInset: 0.
	r hResizing: #spaceFill; vResizing: #rigid; extent: 5@20; wrapCentering: #center; cellPositioning: #leftCenter.

	m := StringMorph new contents: 'Loop end: ' translated.
	r addMorphBack: m.
	m := UpdatingStringMorph new
		target: self; getSelector: #loopEnd; putSelector: #loopEnd:;
		growable: false; width: 50; step.
	r addMorphBack: m.

	m := StringMorph new contents: 'Loop length: ' translated.
	r addMorphBack: m.
	m := UpdatingStringMorph new
		target: self; getSelector: #loopLength; putSelector: #loopLength:;
		floatPrecision: 0.001;
		growable: false; width: 50; step.
	r addMorphBack: m.

	m := StringMorph new contents: 'Loop cycles: ' translated.
	r addMorphBack: m.
	m := UpdatingStringMorph new
		target: self; getSelector: #loopCycles; putSelector: #loopCycles:;
		floatPrecision: 0.001;
		growable: false; width: 50; step.
	r addMorphBack: m.

	m := StringMorph new contents: 'Frequency: ' translated.
	r addMorphBack: m.
	m := UpdatingStringMorph new
		target: self; getSelector: #perceivedFrequency; putSelector: #perceivedFrequency:;
		floatPrecision: 0.001;
		growable: false; width: 50; step.
	r addMorphBack: m.

	self addMorphBack: r.
! !

!WaveEditor methodsFor: 'other' stamp: 'jm 7/30/1998 18:51'!
autoCorrolationBetween: index1 and: index2 length: length
	"Answer the cummulative error between the portions of my waveform starting at the given two indices and extending for the given length. The larger this error, the greater the difference between the two waveforms."

	| data error i1 e |
	data := graph data.
	error := 0.
	i1 := index1.
	index2 to: (index2 + length - 1) do: [:i2 |
		e := (data at: i1) - (data at: i2).
		e < 0 ifTrue: [e := 0 - e].
		error := error + e.
		i1 := i1 + 1].
	^ error
! !

!WaveEditor methodsFor: 'menu' stamp: 'dgd 10/8/2003 20:12'!
chooseLoopStart 

	| bestLoops menu secs choice start |
	possibleLoopStarts ifNil: [
		Utilities
			informUser: 'Finding possible loop points...' translated
			during: [possibleLoopStarts := self findPossibleLoopStartsFrom: graph cursor]].
	bestLoops := possibleLoopStarts copyFrom: 1 to: (100 min: possibleLoopStarts size).
	menu := CustomMenu new.
	bestLoops do: [:entry |
		secs := ((loopEnd - entry first) asFloat / self samplingRate) roundTo: 0.01.
		menu add: ('{1} cycles; {2} secs' translated format:{entry third. secs}) action: entry].
	choice := menu startUp.
	choice ifNil: [^ self].
	loopCycles := choice third.
	start := self fractionalLoopStartAt: choice first.
	self loopLength: (loopEnd asFloat - start) + 1.0.
! !

!WaveEditor methodsFor: 'accessing' stamp: 'jm 7/5/1998 12:43'!
data: newData

	graph data: newData.
! !

!WaveEditor methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:02'!
defaultBorderWidth
"answer the default border width for the receiver"
	^ 2! !

!WaveEditor methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:02'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color lightGray! !

!WaveEditor methodsFor: 'other' stamp: 'jm 7/28/1998 02:29'!
errorBetween: sampleArray1 and: sampleArray2
	"Answer the cummulative error between the two sample arrays, which are assumed to be the same size."

	| error e |
	error := 0.
	1 to: sampleArray1 size do: [:i |
		e := (sampleArray1 at: i) - (sampleArray2 at: i).
		e < 0 ifTrue: [e := 0 - e].
		error := error + e].
	^ error
! !

!WaveEditor methodsFor: 'other' stamp: 'dgd 2/22/2003 18:59'!
findPossibleLoopStartsFrom: index 
	"Assume loopEnd is one sample before a zero-crossing."

	| r postLoopCycleStart i postLoopCycleLength cycleLength cycleCount err oldI |
	r := OrderedCollection new.

	"Record the start and length of the first cycle after the loop endpoint."
	postLoopCycleStart := loopEnd + 1.	"Assumed to be a zero-crossing."
	i := self zeroCrossingAfter: postLoopCycleStart 
						+ (0.9 * samplingRate / perceivedFrequency) asInteger.
	postLoopCycleLength := i - loopEnd - 1.

	"Step backwards one cycle at a time, using zero-crossings to find the
	 beginning of each cycle, and record the auto-corrolation error between
	 each cycle and the cycle following the loop endpoint. Assume pitch may shift gradually."
	i := self zeroCrossingAfter: postLoopCycleStart 
						- (1.1 * postLoopCycleLength) asInteger.
	cycleLength := postLoopCycleStart - i.
	cycleCount := 1.
	[cycleLength > 0] whileTrue: 
			[err := self 
						autoCorrolationBetween: i
						and: postLoopCycleStart
						length: postLoopCycleLength.
			r add: (Array 
						with: i
						with: err
						with: cycleCount
						with: ((loopEnd - i) asFloat / self samplingRate roundTo: 0.01)).
			oldI := i.
			i := self zeroCrossingAfter: oldI - (1.1 * cycleLength) asInteger.
			cycleLength := oldI - i.	"will be zero when start of data is encountered"
			cycleCount := cycleCount + 1].
	r := r asSortedCollection: [:e1 :e2 | (e1 second) < (e2 second)].
	^r asArray! !

!WaveEditor methodsFor: 'other' stamp: 'jm 8/17/1998 11:27'!
fractionalLoopStartAt: index
	"Answer the fractional index starting point near the given integral index that results in the closest match with the cycle following the loop end."
	"Note: could do this more efficiently by sliding downhill on the error curve to find lowest error."

	| oneCycle w1 minErr w2 err bestIndex |
	oneCycle := (samplingRate / perceivedFrequency) rounded.
	w1 := self interpolatedWindowAt: loopEnd + 1 width: oneCycle.
	minErr := SmallInteger maxVal.
	((index - 2) max: 1) to: ((index + 2) min: graph data size) by: 0.01 do: [:i |
		w2 := self interpolatedWindowAt: i width: oneCycle.
		err := self errorBetween: w1 and: w2.
		err < minErr ifTrue: [
			bestIndex := i.
			minErr := err]].
	^ bestIndex
! !

!WaveEditor methodsFor: 'accessing' stamp: 'jm 7/3/2004 18:16'!
graph

	^ graph
! !

!WaveEditor methodsFor: 'initialization' stamp: 'nk 6/22/2004 16:22'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	samplingRate := SoundPlayer samplingRate.
	loopEnd := loopLength := 0.
	loopCycles := 1.
	perceivedFrequency := 0.
	"zero means unknown"
	self extent: 5 @ 5;
		 listDirection: #topToBottom;
		 wrapCentering: #topLeft;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 layoutInset: 3.
	graph := GraphMorph new extent: 450 @ 100.

	graph cursor: 0.
	graph cursorColorAtZeroCrossings: Color blue.
	self addControls.
	self addLoopPointControls.
	self addMorphBack: graph.
	self
		addMorphBack: (Morph
				newBounds: (0 @ 0 extent: 0 @ 3)
				color: Color transparent).
	self addMorphBack: (keyboard := PianoKeyboardMorph new).
	self sound: (SampledSound soundNamed: 'croak').
! !

!WaveEditor methodsFor: 'other' stamp: 'jm 7/31/1998 11:54'!
interpolatedWindowAt: index width: nSamples
	"Return an array of N samples starting at the given index in my data."

	| scale data baseIndex scaledFrac scaledOneMinusFrac prevSample nextSample v |
	scale := 10000.
	data := graph data.
	index isInteger
		ifTrue: [^ (index to: index + nSamples - 1) collect: [:i | data at: i]].
	baseIndex := index truncated.
	scaledFrac := ((index asFloat - baseIndex) * scale) truncated.
	scaledOneMinusFrac := scale - scaledFrac.
	prevSample := data at: baseIndex.
	^ (baseIndex + 1 to: baseIndex + nSamples) collect: [:i |
		nextSample := data at: i.
		v := ((nextSample * scaledFrac) + (prevSample * scaledOneMinusFrac)) // scale.
		prevSample := nextSample.
		v].
! !

!WaveEditor methodsFor: 'menu' stamp: 'dgd 9/19/2003 12:47'!
invokeMenu
	"Invoke a menu of additonal functions for this WaveEditor."

	| aMenu |
	aMenu := CustomMenu new.
	aMenu addList:	{
		{'play straight through' translated.	#play}.
		{'play before cursor' translated.	#playBeforeCursor}.
		{'play after cursor' translated.		#playAfterCursor}.
		{'play test note' translated.			#playTestNote}.
		{'play loop' translated.				#playLoop}.
		{'trim before cursor' translated.	#trimBeforeCursor}.
		{'trim after cursor' translated.		#trimAfterCursor}.
		{'choose loop start' translated.		#chooseLoopStart}.
		{'jump to loop start' translated.		#jumpToLoopStart}.
		{'jump to loop end' translated.		#jumpToLoopEnd}.
		{'make unlooped' translated.		#setUnlooped}.
		{'make unpitched' translated.		#setUnpitched}.
		{'show envelope' translated.		#showEnvelope}.
		{'show FFT' translated.				#showFFTAtCursor}}.
	aMenu invokeOn: self defaultSelection: nil.
! !

!WaveEditor methodsFor: 'menu' stamp: 'jm 8/3/1998 12:42'!
jumpToLoopEnd

	graph cursor: loopEnd; centerCursor.
! !

!WaveEditor methodsFor: 'menu' stamp: 'jm 8/17/1998 10:09'!
jumpToLoopStart

	graph cursor: (loopEnd - loopLength) truncated; centerCursor.
! !

!WaveEditor methodsFor: 'accessing' stamp: 'jm 7/7/1998 09:48'!
loopCycles

	^ loopCycles
! !

!WaveEditor methodsFor: 'accessing' stamp: 'jm 7/8/1998 20:21'!
loopCycles: aNumber

	loopCycles := aNumber.
	self loopLength: loopLength.  "updates frequency"
! !

!WaveEditor methodsFor: 'accessing' stamp: 'jm 6/30/1998 17:20'!
loopEnd

	^ loopEnd
! !

!WaveEditor methodsFor: 'accessing' stamp: 'jm 7/31/1998 14:01'!
loopEnd: aNumber

	loopEnd := (aNumber asInteger max: 1) min: graph data size.
	possibleLoopStarts := nil.
! !

!WaveEditor methodsFor: 'accessing' stamp: 'jm 7/7/1998 08:38'!
loopLength

	^ loopLength
! !

!WaveEditor methodsFor: 'accessing' stamp: 'jm 7/8/1998 21:03'!
loopLength: aNumber

	loopLength := aNumber.
	((loopCycles > 0) and: [loopLength > 0]) ifTrue: [
		perceivedFrequency := samplingRate asFloat * loopCycles / loopLength].

! !

!WaveEditor methodsFor: 'accessing' stamp: 'jm 8/17/1998 10:08'!
loopStart

	^ (loopEnd - loopLength) truncated + 1
! !

!WaveEditor methodsFor: 'accessing' stamp: 'jm 8/17/1998 20:46'!
loopStart: index

	| start len |
	start := self fractionalLoopStartAt: index.
	len := (loopEnd asFloat - start) + 1.0.
	loopCycles := (len / (samplingRate / perceivedFrequency)) rounded.
	self loopLength: len.
! !

!WaveEditor methodsFor: 'menu' stamp: 'nk 6/22/2004 18:34'!
makeLoopedSampledSound
	| data end snd basePitch |
	data := graph data.
	snd := (loopEnd = 0 or: [loopLength = 0]) 
				ifTrue: 
					["save as unlooped"

					basePitch := perceivedFrequency = 0 
						ifTrue: [100.0]
						ifFalse: [perceivedFrequency].
					LoopedSampledSound new 
						unloopedSamples: data
						pitch: basePitch
						samplingRate: samplingRate]
				ifFalse: 
					[end := (loopEnd min: data size) max: 1.
					basePitch := samplingRate * loopCycles / loopLength.
					LoopedSampledSound new 
						samples: data
						loopEnd: end
						loopLength: end
						pitch: basePitch
						samplingRate: samplingRate].
	snd addReleaseEnvelope.
	^snd! !

!WaveEditor methodsFor: 'other' stamp: 'gm 2/27/2003 23:31'!
normalize: sampleArray 
	"Return a copy of the given sample array scaled to use the maximum 16-bit sample range. Remove any D.C. offset."

	| max scale out |
	max := 0.
	sampleArray do: 
			[:s | 
			max := max max: s abs].
	scale := ((1 << 15) - 1) asFloat / max.
	out := sampleArray species new: sampleArray size.
	1 to: sampleArray size
		do: [:i | out at: i put: (scale * (sampleArray at: i)) truncated].
	^out! !

!WaveEditor methodsFor: 'accessing' stamp: 'jm 8/17/1998 20:31'!
perceivedFrequency

	^ perceivedFrequency

! !

!WaveEditor methodsFor: 'accessing' stamp: 'jm 8/17/1998 20:32'!
perceivedFrequency: aNumber

	perceivedFrequency := aNumber.
	(loopCycles > 0) ifTrue: [
		loopLength := samplingRate asFloat * loopCycles / perceivedFrequency].
! !

!WaveEditor methodsFor: 'menu' stamp: 'jm 7/9/1998 09:23'!
play

	graph data size < 2 ifTrue: [^ self].
	(SampledSound samples: graph data samplingRate: samplingRate) play.

! !

!WaveEditor methodsFor: 'menu' stamp: 'jm 6/30/1998 17:40'!
playAfterCursor

	self playFrom: graph cursor to: graph data size.
! !

!WaveEditor methodsFor: 'menu' stamp: 'jm 6/30/1998 17:39'!
playBeforeCursor

	self playFrom: 1 to: graph cursor.
! !

!WaveEditor methodsFor: 'menu' stamp: 'jm 6/30/1998 17:02'!
playFrom: start to: end

	| sz i1 i2 snd |
	sz := graph data size.
	i1 := ((start + 1) min: sz) max: 1.
	i2 := ((end + 1) min: sz) max: i1.
	(i1 + 2) >= i2 ifTrue: [^ self].
	snd := SampledSound
		samples: (graph data copyFrom: i1 to: i2)
		samplingRate: samplingRate.
	snd play.
! !

!WaveEditor methodsFor: 'menu' stamp: 'jm 8/17/1998 11:39'!
playLoop

	| sz i1 i2 snd len |
	sz := graph data size.
	i1 := ((loopEnd - loopLength) truncated min: sz) max: 1.
	i2 := (loopEnd min: sz) max: i1.
	len := (i2 - i1) + 1.
	len < 2 ifTrue: [^ self].

	snd := LoopedSampledSound new
		samples: (graph data copyFrom: i1 to: i2)
		loopEnd: len
		loopLength: loopLength
		pitch: 100.0
		samplingRate: samplingRate.

	"sustain for the longer of four loops or two seconds"
	snd setPitch: 100.0
		dur: (((4.0 * loopLength) / samplingRate) max: 2.0)
		loudness: 0.5.
	snd play.
! !

!WaveEditor methodsFor: 'menu' stamp: 'jm 8/17/1998 11:38'!
playTestNote

	| data end snd loopDur dur |
	(loopEnd = 0 or: [loopLength = 0]) ifTrue: [^ self].
	data := graph data.
	end := (loopEnd min: data size) max: 1.
	snd := LoopedSampledSound new
		samples: data loopEnd: end loopLength: loopLength
		pitch: 100.0 samplingRate: samplingRate.

	loopDur := (4.0 * loopLength / samplingRate) max: 2.0.  "longer of 4 loops or 2 seconds"
	dur := (data size / samplingRate) + loopDur.
	(snd
		addReleaseEnvelope;
		setPitch: 100.0 dur: dur loudness: 0.5) play.
! !

!WaveEditor methodsFor: 'accessing' stamp: 'jm 7/4/1998 10:44'!
samplingRate

	^ samplingRate

! !

!WaveEditor methodsFor: 'accessing' stamp: 'jm 7/4/1998 10:44'!
samplingRate: samplesPerSecond

	samplingRate := samplesPerSecond.
! !

!WaveEditor methodsFor: 'menu' stamp: 'rbb 3/1/2005 11:20'!
saveInstrument

	| name |
	name := UIManager default request: 'Instrument name?' translated.
	name isEmpty ifTrue: [^ self].
	AbstractSound soundNamed: name put: self makeLoopedSampledSound.
! !

!WaveEditor methodsFor: 'other' stamp: 'jm 6/30/1998 16:11'!
scrollTime: relativeValue

	graph startIndex: relativeValue * (graph data size - (graph width // 2)).
! !

!WaveEditor methodsFor: 'menu' stamp: 'jm 7/31/1998 11:06'!
setLoopEnd

	graph cursor: (self zeroCrossingAfter: graph cursor) - 1.
	self loopEnd: graph cursor.

! !

!WaveEditor methodsFor: 'menu' stamp: 'dgd 9/19/2003 12:48'!
setLoopStart
	"Assuming that the loop end and approximate frequency have been set, this method uses the current cursor position to determine the loop length and the number of cycles."

	| start len |
	start := graph cursor.
	((start >= loopEnd) or: [perceivedFrequency = 0]) ifTrue: [
		^ self inform:
'Please set the loop end and the approximate frequency
first, then position the cursor one or more cycles
before the loop end and try this again.' translated].
	len := (loopEnd - start) + 1.
	loopCycles := (len / (samplingRate / perceivedFrequency)) rounded.
	self loopLength: len.

! !

!WaveEditor methodsFor: 'menu' stamp: 'jm 8/1/1998 11:05'!
setOneCycle
	"Set the approximate frequency based on a single cycle specified by the user. To use this, first set the loop end, then place the cursor one full cycle before the loop end and invoke this method."

	| len |
	len := loopEnd - graph cursor.
	len > 0 ifTrue: [
		loopCycles := 1.
		self loopLength: len].
! !

!WaveEditor methodsFor: 'menu' stamp: 'jm 8/1/1998 11:05'!
setUnlooped
	"Make this sound play straight through without looping."

	loopLength := 0.
	loopCycles := 1.
! !

!WaveEditor methodsFor: 'menu' stamp: 'jm 8/1/1998 11:05'!
setUnpitched
	"Make this instrument be unpitched and unlooped. Suitable for percussive sounds that should not be pitch-shifted when played. By convention, such sounds are played at a pitch of 100.0 to obtain their original pitch."

	loopLength := 0.
	loopCycles := 0.
	perceivedFrequency := 100.0.
! !

!WaveEditor methodsFor: 'menu' stamp: 'di 7/16/1999 08:30'!
showEnvelope
	"Show an envelope wave constructed by collecting the maximum absolute value of the samples in fixed-size time windows of mSecsPerQuantum."

	| data mSecsPerQuantum samplesPerQuantum result endOfQuantum maxThisQuantum s nSamples |
	data := graph data.
	mSecsPerQuantum := 10.
	samplesPerQuantum := (mSecsPerQuantum / 1000.0) * self samplingRate.
	result := WriteStream on: (Array new: data size // samplesPerQuantum).
	endOfQuantum := samplesPerQuantum.
	maxThisQuantum := 0.
	nSamples := (data isKindOf: SoundBuffer)
		ifTrue: [data monoSampleCount]
		ifFalse: [data size].
	1 to: nSamples do: [:i |
		i asFloat > endOfQuantum ifTrue: [
			result nextPut: maxThisQuantum.
			maxThisQuantum := 0.
			endOfQuantum := endOfQuantum + samplesPerQuantum].
		s := data at: i.
		s < 0 ifTrue: [s := 0 - s].
		s > maxThisQuantum ifTrue: [maxThisQuantum := s]].
	WaveEditor openOn: result contents.
! !

!WaveEditor methodsFor: 'menu' stamp: 'dgd 9/19/2003 12:48'!
showFFTAtCursor

	| data start availableSamples nu n fft r |
	data := graph data.
	start := graph cursor max: 1.
	availableSamples := (data size - start) + 1.
	nu := 12.
	nu > (availableSamples highBit - 1) ifTrue:
		[^ self inform: 'Too few samples after the cursor to take an FFT.' translated].
	n := 2 raisedTo: nu.
	fft := FFT new nu: nu.
	fft realData: ((start to: start + n - 1) collect: [:i | data at: i]).
	fft transformForward: true.
	r := (1 to: n // 2) collect:
		[:i | ((fft realData at: i) squared + (fft imagData at: i) squared) sqrt].
	WaveEditor openOn: r.

! !

!WaveEditor methodsFor: 'accessing' stamp: 'nk 6/22/2004 16:17'!
sound: aSound
	| buffer |
	buffer := aSound samples mergeStereo.
	graph data: buffer.
	loopLength := loopEnd := buffer size.
	self samplingRate: aSound originalSamplingRate.
	loopCycles :=  buffer size / aSound originalSamplingRate * 400.
	perceivedFrequency := 400.
! !

!WaveEditor methodsFor: 'stepping and presenter' stamp: 'di 6/21/1999 17:59'!
step

	keyboard soundPrototype: self makeLoopedSampledSound! !

!WaveEditor methodsFor: 'other' stamp: 'jm 9/20/1998 09:13'!
stretch: sampleArray by: stretchFactor
	"Return an array consisting of the given samples \stretched in time by the given factor."

	| out end incr i frac index |
	out := OrderedCollection new: (stretchFactor * sampleArray size) asInteger + 1.
	end := (sampleArray size - 1) asFloat.
	incr := 1.0 / stretchFactor.
	i := 1.0.
	[i < end] whileTrue: [
		frac := i fractionPart.
		index := i truncated.
		i := i + incr.
		out addLast:
			(((1.0 - frac) * (sampleArray at: index)) + (frac * (sampleArray at: index + 1))) rounded].
	^ out asArray
! !

!WaveEditor methodsFor: 'menu' stamp: 'jm 6/30/1998 17:48'!
trimAfterCursor

	graph data: (graph data copyFrom: 1 to: graph cursor).
! !

!WaveEditor methodsFor: 'menu' stamp: 'jm 6/30/1998 17:52'!
trimBeforeCursor

	graph data: (graph data copyFrom: graph cursor to: graph data size).
	graph cursor: 1.

! !

!WaveEditor methodsFor: 'other' stamp: 'jm 8/10/1998 15:08'!
zeroCrossingAfter: index
	"Find the index of the next negative-to-non-negative transition at or after the current index. The result is the index, i, of a zero crossing such that the sample at i-1 is negative and the sample at i is zero or positive. Answer the index of the last sample if the end of the array is encountered before finding a zero crossing."

	| data end i |
	data := graph data.
	end := data size.
	index <= 1 ifTrue: [^ 1].
	i := index - 1.
	[(i <= end) and: [(data at: i) >= 0]] whileTrue: [i := i + 1].  "find next negative sample"
	i >= end ifTrue: [^ end].

	i := i + 1.
	[(i <= end) and: [(data at: i) < 0]] whileTrue: [i := i + 1].  "find next non-negative sample"
	^ i
! !

TextMorph subclass: #ClipboardMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!ClipboardMorph commentStamp: '<historical>' prior: 0!
A morph that always displays the current contents of the text clipboard.!

!ClipboardMorph classSide methodsFor: 'parts bin' stamp: 'sw 8/2/2001 01:21'!
descriptionForPartsBin
	^ self partName:	'Clipboard'
		categories:		#('Useful')
		documentation:	'This object will always show whatever is on the text clipboard'! !

!ClipboardMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:33'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color
		r: 1.0
		g: 0.355
		b: 0.452! !

!ClipboardMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:36'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 6! !

!ClipboardMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:24'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color blue! !

!ClipboardMorph methodsFor: 'parts bin' stamp: 'dgd 2/14/2003 22:09'!
initializeToStandAlone
	super initializeToStandAlone.
""
	self initialize.
	""
	self extent: 200 @ 100.
	self
		backgroundColor: (Color
				r: 0.484
				g: 1.0
				b: 0.484).
	self setBalloonText: 'This shows the current contents of the text clipboard'.
	self newContents: Clipboard clipboardText! !

!ClipboardMorph methodsFor: 'stepping and presenter' stamp: 'sw 6/27/2001 14:15'!
step
	self newContents: Clipboard clipboardText! !

!ClipboardMorph methodsFor: 'testing' stamp: 'sw 6/27/2001 14:18'!
stepTime
	"Answer the interval between steps -- in this case a leisurely 1 seconds"

	^ 1000! !

!ClipboardMorph methodsFor: 'testing' stamp: 'sw 6/27/2001 13:40'!
wantsSteps
	^ true! !

!TextMorph class methodsFor: '*MorphicExtras-parts bin' stamp: 'nk 9/2/2004 15:38'!
supplementaryPartsDescriptions
	^ {
	DescriptionForPartsBin
		formalName: 'Text (border)'
		categoryList: #('Text')
		documentation: 'A text field with border'
		globalReceiverSymbol: #TextMorph
		nativitySelector: #borderedPrototype.

"	DescriptionForPartsBin
		formalName: 'Text (fancy)'
		categoryList: #('Text')
		documentation: 'A text field with a rounded shadowed border, with a fancy font.'
		globalReceiverSymbol: #TextMorph
		nativitySelector: #fancyPrototype."

	DescriptionForPartsBin
		formalName: 'Text'
		categoryList: #('Basic' 'Text')
		documentation: 'A raw piece of text which you can edit into anything you want'
		globalReceiverSymbol: #TextMorph
		nativitySelector: #boldAuthoringPrototype.
}
! !

!TextMorph methodsFor: '*MorphicExtras-printing' stamp: ''!
fullPrintOn: aStream

	aStream nextPutAll: '('.
	super fullPrintOn: aStream.
	aStream nextPutAll: ') contents: '; print: text! !

!TextMorph methodsFor: '*MorphicExtras-accessing' stamp: 'sw 6/27/2001 13:45'!
getCharacters
	"obtain a string value from the receiver"

	^ self text string copy! !

!TextMorph methodsFor: '*MorphicExtras-copying' stamp: 'di 11/11/97 20:45'!
updateReferencesUsing: refDict
	| anchors range new |
	super updateReferencesUsing: refDict.
	"Update any anchors in the text of a newly copied morph"
	anchors := IdentityDictionary new.
	text runs withStartStopAndValueDo:
		[:start :stop :attributes |
		attributes do: [:att | (att isMemberOf: TextAnchor)
							ifTrue: [anchors at: att put: (start to: stop)]]].
	anchors isEmpty ifTrue: [^ self].
	anchors keysDo:
		[:old |  range := anchors at: old.
		text removeAttribute: old from: range first to: range last.
		new := TextAnchor new anchoredMorph:
					(refDict at: old anchoredMorph).
		text addAttribute: new from: range first to: range last].
	self layoutChanged "for good measure"! !

TextMorph subclass: #UpdatingTextMorph
	instanceVariableNames: 'target getSelector growable stepTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!UpdatingTextMorph commentStamp: 'asm 7/31/2003 21:27' prior: 0!
A TextMorph that constantly tries to show the current data from the target object.  When sent #step, it shows what the target objects has (target perform: getSelector).!

!UpdatingTextMorph classSide methodsFor: 'instance creation' stamp: 'dgd 3/8/2004 20:31'!
on: targetObject selector: aSymbol 
	"answer a new instance of the receiver on a given target and selector"
	^ self new getSelector: aSymbol;
		 target: targetObject! !

!UpdatingTextMorph methodsFor: 'target access' stamp: 'nk 8/30/2004 16:18'!
contentsFromTarget
	"private - answer the contents from the receiver's target"
	(target isNil
			or: [getSelector isNil])
		ifTrue: [^ self contents].
	""
	^ (target perform: getSelector) asString! !

!UpdatingTextMorph methodsFor: 'accessing' stamp: 'dgd 3/7/2004 20:16'!
getSelector
	"answer the receiver's getSelector"
	^ getSelector! !

!UpdatingTextMorph methodsFor: 'accessing' stamp: 'dgd 3/7/2004 20:16'!
getSelector: aSymbol 
	"change the receiver's getSelector"
	getSelector := aSymbol! !

!UpdatingTextMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2004 20:17'!
initialize
	"Initialie the receiver to have default values in its instance  
	variables"
	super initialize.""
	stepTime := 50! !

!UpdatingTextMorph methodsFor: 'stepping and presenter' stamp: 'dgd 3/8/2004 20:34'!
step
	"update my contents"
	| newContents |
	super step.
	""
	newContents := self contentsFromTarget.
	self visible: newContents isEmpty not.
	self contents: newContents! !

!UpdatingTextMorph methodsFor: 'stepping and presenter' stamp: 'dgd 3/7/2004 20:19'!
stepTime
	"answer the desired time between steps in milliseconds."
	^ stepTime
		ifNil: [50]! !

!UpdatingTextMorph methodsFor: 'stepping and presenter' stamp: 'dgd 3/7/2004 20:19'!
stepTime: mSecsPerStep 
	"change the receiver's stepTime"
	stepTime := mSecsPerStep rounded! !

!UpdatingTextMorph methodsFor: 'accessing' stamp: 'dgd 3/7/2004 20:17'!
target
	"answer the receiver's target"
	^ target! !

!UpdatingTextMorph methodsFor: 'accessing' stamp: 'dgd 3/7/2004 20:17'!
target: anObject 
	"change the receiver's target"
	target := anObject! !

!MorphicModel methodsFor: '*MorphicExtras-compilation' stamp: 'md 7/23/2006 15:26'!
compileInitMethods
	| s nodeDict varNames |
	nodeDict := IdentityDictionary new.
	s := WriteStream on: (String new: 2000).
	varNames := self class allInstVarNames.
	s nextPutAll: 'initMorph'.
	3 to: self class instSize do:
		[:i | (self instVarAt: i) isMorph ifTrue:
			[s cr; tab; nextPutAll: (varNames at: i) , ' := '.
			s nextPutAll: (self instVarAt: i) initString; nextPutAll: '.'.
			nodeDict at: (self instVarAt: i) put: (varNames at: i)]].
	submorphs do: 
		[:m | s cr; tab; nextPutAll: 'self addMorph: '.
		m printConstructorOn: s indent: 1 nodeDict: nodeDict.
		s nextPutAll: '.'].
	self class
		compile: s contents
		classified: 'initialization'
		notifying: nil.! !

MorphicModel subclass: #TwoWayScrollPane
	instanceVariableNames: 'getMenuSelector getMenuTitleSelector xScrollBar yScrollBar scroller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Obsolete'!

!TwoWayScrollPane commentStamp: '<historical>' prior: 0!
TwoWayScrollPane is now obsolete.  You should be able to use ScrollPane to do both vertical and horizontal scrolling.

As an example, see Morph>>inATwoWayScrollPane and change the first line to create a ScrollPane instead of a TwoWayScrollPane.  It will still work.

(EllipseMorph new extent: 200@150) inATwoWayScrollPane openInWorld

Note that user preferences for ScrollPane may be geared toward text scrolling, so that the horizontal scrollbar may be hidden when not needed, while the vertical scrollbar is always shown.  Use ScrollPane>>alwaysShowHScrollbar: or its variants to adjust this if you want the vertical & horizontal scrollbars to be shown consistently.
!

!TwoWayScrollPane classSide methodsFor: 'new-morph participation' stamp: 'di 2/21/98 11:02'!
includeInNewMorphMenu
	"OK to instantiate"
	^ true! !

!TwoWayScrollPane methodsFor: 'accessing' stamp: 'md 7/29/2005 19:47'!
colorForInsets
	"My submorphs use the surrounding color"

	owner color isColor ifTrue:[^ owner color].
	^ Color white! !

!TwoWayScrollPane methodsFor: 'geometry testing' stamp: 'RAA 10/6/1998 18:40'!
containsPoint: aPoint
	(super containsPoint: aPoint) ifTrue: [^ true].
	"Also include scrollbar when it is extended..."
	"used to handle retractable scrolbar"
	^ false! !

!TwoWayScrollPane methodsFor: 'initialization' stamp: 'jam 3/9/2003 17:52'!
createScrollBarNamed: aString 
"creates a scroll bar named as aString"
	| result |
	result := ScrollBar new model: self slotName: aString.
	result borderWidth: 2;
		 borderColor: #inset.
	^ result! !

!TwoWayScrollPane methodsFor: 'initialization' stamp: 'jam 3/9/2003 17:53'!
createScroller
"create a scroller"
	| result |
	result := TransformMorph new color: Color transparent.
	result offset: 0 @ 0.
	^ result! !

!TwoWayScrollPane methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:35'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ #inset! !

!TwoWayScrollPane methodsFor: 'layout' stamp: 'di 5/2/2001 10:01'!
doLayoutIn: layoutBounds
	"layout has changed. update scroll deltas or whatever else"

	(owner notNil and: [owner hasProperty: #autoFitContents])
		ifTrue: [self fitContents].
	super doLayoutIn: layoutBounds.! !

!TwoWayScrollPane methodsFor: 'geometry' stamp: 'nk 7/11/2004 20:08'!
extent: newExtent
	bounds extent = newExtent ifTrue: [^ self].
	super extent: (newExtent max: 36@32).
	self resizeScrollBar; resizeScroller; setScrollDeltas.
! !

!TwoWayScrollPane methodsFor: 'geometry' stamp: 'nk 4/12/2002 14:00'!
fitContents
	"Adjust my size to fit my contents reasonably snugly"

	self extent: scroller submorphBounds extent
				+ (yScrollBar width @ xScrollBar height)
				+ (borderWidth*2)
				 ! !

!TwoWayScrollPane methodsFor: 'menu' stamp: 'dgd 2/21/2003 22:33'!
getMenu: shiftKeyState 
	"Answer the menu for this text view, supplying an empty menu to be filled in. If the menu selector takes an extra argument, pass in the current state of the shift key."

	| menu aMenu aTitle |
	getMenuSelector isNil ifTrue: [^nil].
	menu := MenuMorph new defaultTarget: model.
	aTitle := getMenuTitleSelector 
				ifNotNil: [model perform: getMenuTitleSelector].
	getMenuSelector numArgs = 1 
		ifTrue: 
			[aMenu := model perform: getMenuSelector with: menu.
			aTitle ifNotNil: [aMenu addTitle: aTitle].
			^aMenu].
	getMenuSelector numArgs = 2 
		ifTrue: 
			[aMenu := model 
						perform: getMenuSelector
						with: menu
						with: shiftKeyState.
			aTitle ifNotNil: [aMenu addTitle: aTitle].
			^aMenu].
	^self error: 'The getMenuSelector must be a 1- or 2-keyword symbol'! !

!TwoWayScrollPane methodsFor: 'event handling' stamp: 'di 5/7/1998 09:52'!
handlesMouseDown: evt
	^ true! !

!TwoWayScrollPane methodsFor: 'event handling' stamp: 'di 7/3/1998 12:07'!
handlesMouseOver: evt
	^ true! !

!TwoWayScrollPane methodsFor: 'retractable scroll bar' stamp: 'RAA 6/9/2000 15:05'!
hideOrShowScrollBar

	^self		"we don't support retractable at the moment"! !

!TwoWayScrollPane methodsFor: 'retractable scroll bar' stamp: 'di 5/2/2001 08:23'!
hideOrShowScrollBar: scrollBar forRange: range

	(self hasProperty: #hideUnneededScrollbars) ifFalse: [^ self].
	(submorphs includes: scrollBar)
		ifTrue: [range <= 0 ifTrue: [scrollBar model: nil; delete]]
		ifFalse: [range > 0 ifTrue: [scrollBar model: self.  self resizeScrollBar; addMorph: scrollBar]]
! !

!TwoWayScrollPane methodsFor: 'initialization' stamp: 'dgd 2/14/2003 18:03'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self addMorph: (yScrollBar := self createScrollBarNamed: 'yScrollBar');
		 addMorph: (xScrollBar := self createScrollBarNamed: 'xScrollBar');
		 addMorph: (scroller := self createScroller).
	""
	self extent: 150 @ 120! !

!TwoWayScrollPane methodsFor: 'event handling' stamp: 'RAA 10/6/1998 19:45'!
keyStroke: evt
	"If pane is not full, pass the event to the last submorph,
	assuming it is the most appropriate recipient (!!)"

	scroller submorphs last keyStroke: evt! !

!TwoWayScrollPane methodsFor: 'menu' stamp: 'RAA 10/6/1998 18:41'!
leftOrRight  "Change scroll bar location"

	"used to handle left vs right scrollbar"! !

!TwoWayScrollPane methodsFor: 'geometry' stamp: 'RAA 8/13/1999 15:56'!
leftoverScrollRange
	"Return the entire scrolling range minus the currently viewed area."
	^ self totalScrollRange - (self innerBounds extent * 3 // 4) max: 0@0
! !

!TwoWayScrollPane methodsFor: 'menu' stamp: 'nk 4/19/2002 12:58'!
menuSelector: aSelector
	getMenuSelector := aSelector! !

!TwoWayScrollPane methodsFor: 'menu' stamp: 'sw 8/18/1998 12:38'!
menuTitleSelector: aSelector
	getMenuTitleSelector := aSelector! !

!TwoWayScrollPane methodsFor: 'event handling' stamp: 'RAA 10/6/1998 19:45'!
mouseDown: evt
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].
	"If pane is not full, pass the event to the last submorph,
	assuming it is the most appropriate recipient (!!)"
	scroller hasSubmorphs ifTrue:
		[scroller submorphs last mouseDown: (evt transformedBy: (scroller transformFrom: self))]! !

!TwoWayScrollPane methodsFor: 'event handling' stamp: 'RAA 10/6/1998 18:38'!
mouseEnter: event

	"used to handle retractable scrolbar"! !

!TwoWayScrollPane methodsFor: 'event handling' stamp: 'RAA 10/6/1998 18:38'!
mouseLeave: event

	"used to handle retractable scrolbar"! !

!TwoWayScrollPane methodsFor: 'event handling' stamp: 'RAA 10/6/1998 19:45'!
mouseMove: evt
	"If pane is not full, pass the event to the last submorph,
	assuming it is the most appropriate recipient (!!)"
	scroller hasSubmorphs ifTrue:
		[scroller submorphs last mouseMove: (evt transformedBy: (scroller transformFrom: self))]! !

!TwoWayScrollPane methodsFor: 'event handling' stamp: 'RAA 10/6/1998 19:45'!
mouseUp: evt
	"If pane is not full, pass the event to the last submorph,
	assuming it is the most appropriate recipient (!!)"
	scroller hasSubmorphs ifTrue:
		[scroller submorphs last mouseUp: (evt transformedBy: (scroller transformFrom: self))]! !

!TwoWayScrollPane methodsFor: 'events-processing' stamp: 'RAA 11/23/2000 10:16'!
rejectsEvent: anEvent

	scroller submorphs isEmpty ifTrue: [^true].	"something messed up here"
	scroller firstSubmorph isSyntaxMorph ifTrue: [^ super rejectsEvent: anEvent].
	^self visible not		"ignore locked status"! !

!TwoWayScrollPane methodsFor: 'geometry' stamp: 'RAA 10/6/1998 19:00'!
resizeScrollBar
	"used to handle left vs right scrollbar"
	yScrollBar bounds: (bounds topLeft extent: 16 @ (bounds height - 16)).
	xScrollBar bounds: ((bounds left + 16) @ (bounds bottom - 16)  extent: (bounds width - 16) @ 16).
! !

!TwoWayScrollPane methodsFor: 'geometry' stamp: 'di 1/29/2001 14:18'!
resizeScroller
	| inner |
	"used to handle left vs right scrollbar"
	inner := self innerBounds.
	scroller bounds: (inner topLeft + (yScrollBar width@0) corner: (inner bottomRight - (0@xScrollBar height)))! !

!TwoWayScrollPane methodsFor: 'menu' stamp: 'RAA 10/6/1998 18:38'!
retractableOrNot  "Change scroll bar operation"

	"used to handle retractable scrolbar"! !

!TwoWayScrollPane methodsFor: 'geometry' stamp: 'RAA 10/6/1998 18:40'!
scrollBarFills: aRectangle
	"Return true if a flop-out scrollbar fills the rectangle"
	"used to handle retractable scrolbar"
	^ false! !

!TwoWayScrollPane methodsFor: 'scroll bar events' stamp: 'di 6/26/1998 13:31'!
scrollBarMenuButtonPressed: event
	^ self yellowButtonActivity: event shiftPressed! !

!TwoWayScrollPane methodsFor: 'menu' stamp: 'RAA 10/6/1998 18:41'!
scrollBarOnLeft: aBoolean

	"used to handle left vs right scrollbar"! !

!TwoWayScrollPane methodsFor: 'geometry' stamp: 'RAA 8/24/1999 18:13'!
scrollBy: delta
	"Move the contents in the direction delta."
	"For now, delta is assumed to have a zero x-component. Used by scrollIntoView:"
	| r newOffset |

	newOffset := (scroller offset - delta max: 0@0) min: self leftoverScrollRange.
	scroller offset: newOffset.

	r := self leftoverScrollRange.
	r y = 0
		ifTrue: [yScrollBar value: 0.0]
		ifFalse: [yScrollBar value: newOffset y asFloat / r y].
	r x = 0
		ifTrue: [xScrollBar value: 0.0]
		ifFalse: [xScrollBar value: newOffset x asFloat / r x].
! !

!TwoWayScrollPane methodsFor: 'geometry' stamp: 'RAA 8/21/1999 10:17'!
scrollIntoView: desiredRectangle extra: anumber
	| shift |

	shift := desiredRectangle deltaToEnsureInOrCentered: (
		scroller offset extent: scroller bounds extent
	)  extra: anumber.
	shift = (0 @ 0) ifFalse: [self scrollBy: (0@0) - shift].
! !

!TwoWayScrollPane methodsFor: 'access' stamp: 'RAA 10/6/1998 19:45'!
scroller
	^ scroller! !

!TwoWayScrollPane methodsFor: 'geometry' stamp: 'di 5/2/2001 10:03'!
setScrollDeltas
	| range scrollDelta totalRange innerBounds |
	totalRange := self totalScrollRange ifNil: [^ self].
	range := self leftoverScrollRange.
	innerBounds := self innerBounds.
	scrollDelta := 10 @ 10.

	self hideOrShowScrollBar: xScrollBar
		forRange: totalRange x - (innerBounds width - yScrollBar width).
	range x <= 0
		ifTrue: [xScrollBar scrollDelta: 0.02 pageDelta: 0.2.
				xScrollBar interval: 1.0]
		ifFalse: [xScrollBar scrollDelta: (scrollDelta x / range x) asFloat
						pageDelta: (innerBounds width - scrollDelta x / range x) asFloat.
				xScrollBar interval: (innerBounds width - scrollDelta x / totalRange x) asFloat].

	self hideOrShowScrollBar: yScrollBar
		forRange: totalRange y - (innerBounds height - xScrollBar height).
	range y <= 0
		ifTrue: [yScrollBar scrollDelta: 0.02 pageDelta: 0.2.
				yScrollBar interval: 1.0]
		ifFalse: [yScrollBar scrollDelta: (scrollDelta y / range y) asFloat
						pageDelta: (innerBounds height - scrollDelta y / range y) asFloat.
				yScrollBar interval: (innerBounds height - scrollDelta y / totalRange y) asFloat]! !

!TwoWayScrollPane methodsFor: 'scroll bar events' stamp: 'di 6/26/1998 13:31'!
shiftedYellowButtonActivity
	^ self yellowButtonActivity: true! !

!TwoWayScrollPane methodsFor: 'geometry' stamp: 'nk 4/12/2002 14:06'!
totalScrollRange

	"Return the entire scrolling range."
	^ ((scroller localVisibleSubmorphBounds ifNil: [^nil]) encompass: 0@0) extent

! !

!TwoWayScrollPane methodsFor: 'scroll bar events' stamp: 'di 6/26/1998 13:32'!
unshiftedYellowButtonActivity
	^ self yellowButtonActivity: false! !

!TwoWayScrollPane methodsFor: 'access' stamp: 'di 6/7/97 10:42'!
wantsSlot
	"For now do it the old way, until we sort this out"
	^ true! !

!TwoWayScrollPane methodsFor: 'menu' stamp: 'dgd 9/18/2004 18:30'!
wantsYellowButtonMenu
	"Answer true if the receiver wants a yellow button menu"
	^ getMenuSelector notNil! !

!TwoWayScrollPane methodsFor: 'scroll bar events' stamp: 'RAA 10/6/1998 22:38'!
xScrollBarMenuButtonPressed: event
	^ self yellowButtonActivity: event shiftPressed! !

!TwoWayScrollPane methodsFor: 'scroll bar events' stamp: 'RAA 8/24/1999 16:01'!
xScrollBarValue: scrollValue 

	"although there appear to be no senders, see Slider>>setValue:"

	scroller hasSubmorphs ifFalse: [^ self].
	scroller offset: self leftoverScrollRange x * scrollValue @ scroller offset y! !

!TwoWayScrollPane methodsFor: 'retractable scroll bar' stamp: 'tk 8/21/2001 18:11'!
xScrollerHeight

	(submorphs includes: xScrollBar)  "Sorry the logic is reversed :( "
		ifFalse: [^ 0 @ 0]					"already included"
		ifTrue: [^ 0 @ xScrollBar height]	"leave space for it"
! !

!TwoWayScrollPane methodsFor: 'scroll bar events' stamp: 'RAA 10/6/1998 22:37'!
yScrollBarMenuButtonPressed: event
	^ self yellowButtonActivity: event shiftPressed! !

!TwoWayScrollPane methodsFor: 'scroll bar events' stamp: 'RAA 8/13/1999 15:55'!
yScrollBarValue: scrollValue

	"although there appear to be no senders, see Slider>>setValue:"

	scroller hasSubmorphs ifFalse: [^ self].
	scroller offset: scroller offset x @ (self leftoverScrollRange y * scrollValue)! !

!TwoWayScrollPane methodsFor: 'scroll bar events' stamp: 'RAA 6/12/2000 09:01'!
yellowButtonActivity: shiftKeyState
	| menu |
	(menu := self getMenu: shiftKeyState) ifNotNil:
		[menu setInvokingView: self.
		menu popUpEvent: self activeHand lastEvent in: self world]! !

!ThreePhaseButtonMorph methodsFor: '*MorphicExtras-e-toy support' stamp: 'ar 3/17/2001 20:18'!
adaptToWorld: aWorld
	super adaptToWorld: aWorld.
	self target: (target adaptedToWorld: aWorld).! !

!ThreePhaseButtonMorph methodsFor: '*MorphicExtras-accessing' stamp: 'tk 6/29/97 21:04'!
authorModeOwner: aMorph
	AuthorModeOwner := aMorph! !

!ThreePhaseButtonMorph methodsFor: '*MorphicExtras-accessing' stamp: 'tk 6/29/97 21:02'!
dragIfAuthoring: evt
	"Allow simple dragging if the class var is set to my owner."
	owner == AuthorModeOwner ifTrue: [
		self center: evt cursorPoint].
	^ owner == AuthorModeOwner! !

!ThreePhaseButtonMorph methodsFor: '*MorphicExtras-copying' stamp: 'jm 7/28/97 11:56'!
updateReferencesUsing: aDictionary
	"If the arguments array points at a morph we are copying, then update it to point to the new copy. This method also copies the arguments array itself, which is important!!"

	super updateReferencesUsing: aDictionary.
	arguments := arguments collect:
		[:old | aDictionary at: old ifAbsent: [old]].
! !

ThreePhaseButtonMorph subclass: #TrashCanMorph
	instanceVariableNames: ''
	classVariableNames: 'TrashPic TrashPicOn'
	poolDictionaries: ''
	category: 'MorphicExtras-AdditionalWidgets'!

!TrashCanMorph classSide methodsFor: 'miscellaneous' stamp: 'nk 8/23/2004 18:12'!
descriptionForPartsBin
	^ self partName:	'Trash'
		categories:		#('Useful' 'Basic')
		documentation:	'a tool for discarding objects'! !

!TrashCanMorph classSide methodsFor: 'class initialization' stamp: 'dgd 4/4/2006 14:49'!
initialize
	"initialize the receiver"

	self registerInFlapsRegistry.

	self initializePictures.
! !

!TrashCanMorph classSide methodsFor: 'class initialization' stamp: 'dgd 9/2/2004 13:25'!
initializePictures
	" 
	TrashCanMorph initializePictures. 
	"
	TrashPicOn := self initializeTrashPicOn.
	TrashPic := self initializeTrashPic! !

!TrashCanMorph classSide methodsFor: 'class initialization' stamp: 'dgd 9/2/2004 13:13'!
initializeTrashPic
	^(Form
	extent: 72@72
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35593500 438246684 773791004 1109335324 706682140 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 52370716 857677084 1914641692 2971606300 3995016476 4280229148 4280229148 4280229148 4280229148 3089046812 1159666972 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35593500 1059003676 2535398684 3944684828 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 3508477212 1595874588 102702364 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 924785948 2401180956 3844021532 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4282136620 4281149988 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 3844021532 2015304988 287251740 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 790568220 2266963228 3726581020 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4282333741 4287266903 4292200065 4294962328 4294699158 4291279224 4286937941 4282597168 4280229148 4280229148 4280229148 4280229148 4280229148 4095679772 2451512604 572464412 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 673127708 2132745500 3609140508 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4282333741 4287266903 4292200065 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4292331393 4286346064 4281084195 4280229148 4280229148 4280229148 4280229148 4229897500 2870943004 941563164 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 52370716 1495211292 3424591132 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4282333741 4287266903 4292200065 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294370451 4289240168 4283320374 4280229148 4280229148 4280229148 4280229148 4280229148 3307150620 1226775836 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 169811228 1813978396 3726581020 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4281544487 4287069525 4292134272 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962071 4294103679 4290947944 4288252760 4293316998 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4292068480 4286148685 4280952610 4280229148 4280229148 4280229148 4280229148 3407813916 1310661916 18816284 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 320806172 2115968284 3944684828 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4283912250 4289897581 4294633365 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294895763 4293379184 4291467593 4292713278 4293501761 4281935888 4282330129 4292581949 4289495097 4291473254 4294962327 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294238866 4288648034 4282005034 4280229148 4280229148 4280229148 4280229148 3491699996 1394547996 18816284 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 438246684 2434735388 4095679772 4280229148 4280229148 4280229148 4280229148 4280229148 4281149988 4286609233 4292594564 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294961814 4293774199 4291796299 4293041983 4293501761 4293501761 4293501761 4293501761 4279898631 4284104473 4293370432 4293370432 4293370432 4291596347 4291207769 4294830228 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294699158 4289503082 4282597168 4280229148 4280229148 4280229148 4280229148 3558808860 1478434076 35593500 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1646206236 4028570908 4280229148 4280229148 4280229148 4280229148 4280229148 4283189045 4289305960 4294436243 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294564997 4292191827 4292779071 4293501761 4293501761 4293501761 4293501761 4293501761 4293501761 4293173055 4278321409 4285813024 4293370432 4293370432 4293370432 4293370432 4293370432 4292319293 4290943568 4294500750 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294896535 4290358129 4283451958 4280229148 4280229148 4280229148 4280229148 3625917724 1562320156 52370716 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 203365660 3089046812 4280229148 4280229148 4280229148 4280229148 4280229148 4283189045 4290621556 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294896278 4293378926 4292123203 4293501761 4293501761 4293501761 4293501761 4293501761 4293501761 4293501761 4293501761 4290281523 4284498715 4278190080 4287521831 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4292910142 4290942281 4294105222 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4291213433 4284307006 4280229148 4280229148 4280229148 4280229148 3676249372 1646206236 69147932 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2803834140 4280229148 4280229148 4280229148 4280229148 4282333741 4290423922 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294829713 4292456284 4292647743 4293501761 4293501761 4293501761 4293501761 4293501761 4293501761 4293501761 4290741813 4285484319 4280161544 4278190080 4278190080 4278190080 4281081612 4288376107 4293239103 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293107519 4290678852 4293579136 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4292002431 4283715129 4280229148 4280229148 4280229148 4280229148 3743358236 1713315100 18816284 0 0 0 0 0 0 0 0 0 0 0 0 0 1243553052 4280229148 4280229148 4280229148 4280294940 4286871892 4294436243 4294962328 4294962328 4294962328 4294962328 4294962328 4294962327 4292785762 4293107520 4293501761 4293501761 4293501761 4293501761 4293501761 4293501761 4292516157 4286667300 4280621578 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4280358665 4287193126 4292910398 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293173311 4290481215 4292986745 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4289766508 4281741865 4280229148 4280229148 4280229148 4280229148 2199854364 0 0 0 0 0 0 0 0 0 0 0 0 0 1310661916 4280229148 4280229148 4280360476 4288776274 4293515148 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4293248629 4290414395 4293304640 4293501761 4293501761 4293501761 4290873142 4284367386 4278781443 4278321666 4278716424 4279111182 4279242768 4279242768 4279242768 4279242768 4279242768 4279242768 4279308561 4278979596 4278584838 4279438597 4285944609 4292319035 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293304640 4290942021 4294895507 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294304658 4287266903 4280623647 4280229148 4280229148 4280229148 1511988508 0 0 0 0 0 0 0 0 0 0 0 0 1025449244 4280229148 4280229148 4281740320 4293370432 4286735669 4285686849 4292594564 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4290619751 4287720239 4288376107 4282067473 4278190080 4278453252 4279505940 4280295456 4280361249 4280361249 4280427042 4280427042 4280427042 4280427042 4280427042 4280427042 4280427042 4280427042 4280427042 4280229663 4279242768 4278913028 4284761628 4291530296 4293370432 4293370432 4292779069 4289427761 4288904509 4291736169 4294962070 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294830742 4290687091 4282333742 4280229148 4280229148 4129234204 455023900 0 0 0 0 0 0 0 0 0 0 0 773725211 4280229148 4280229148 4281871648 4293370432 4293370432 4288442418 4281280544 4284568890 4291410554 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4291147381 4283978293 4280163612 4281479730 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281348144 4279966491 4278518786 4282987284 4284896044 4288910687 4294304402 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4291805053 4288516449 4290160751 4294370195 4290161008 4280229148 4280229148 4280229148 2082413852 0 0 0 0 0 0 0 0 0 0 0 1074596876 4280229148 4280229148 4281477407 4293370432 4293370432 4293370432 4292253244 4284960041 4280229148 4283254065 4290423922 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4292923271 4285228105 4281940279 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282071864 4285557065 4292791684 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4292857478 4287266647 4285556808 4290029422 4294764950 4294962328 4294962328 4291805309 4280229148 4280229148 4280229148 1847335449 0 0 0 0 0 0 0 0 0 0 0 1040581893 4280229148 4280229148 4280294684 4293305153 4293370432 4293370432 4293370432 4293370432 4291004729 4284631336 4280294940 4283122480 4290752628 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294764950 4289042791 4283715910 4283453520 4283782485 4283782485 4283782485 4283782485 4283782485 4283782485 4283782485 4283782485 4283782485 4283650899 4283847497 4289043049 4294830742 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294633365 4289963629 4284438591 4285622345 4291936639 4294962328 4294962328 4294962328 4294962328 4294962328 4290687092 4280229148 4280229148 4280229148 1896877839 167772160 0 0 0 0 0 0 0 0 0 0 788529152 4229831707 4280229148 4280229148 4292977735 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4291333434 4285091113 4280426269 4283385907 4291016054 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4293318026 4286610012 4284308569 4284900966 4284900966 4284900966 4284900966 4284900966 4284374619 4286412639 4292923529 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4292857478 4287069525 4282794033 4287464024 4293580940 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4289174118 4280229148 4280229148 4280229148 1527186950 1056964608 16777216 0 0 0 0 0 0 0 0 0 687865856 4045282331 4280229148 4280229148 4290219337 4293370689 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4291662139 4285485354 4280492061 4283648821 4291410298 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4290490234 4285821028 4285098086 4285755229 4290950523 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294699157 4290095214 4284109628 4283122996 4289437289 4294567572 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4285162309 4280229148 4280229148 4062059547 1275068416 1275068416 419430400 0 0 0 0 0 0 0 0 0 587202560 3843889946 4280229148 4280229148 4280229148 4282990123 4290943054 4293371203 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4291924796 4285945387 4280886559 4284043321 4291739260 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4293318026 4287464024 4282465583 4286148686 4291936639 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4292528515 4280558111 4280229148 4280229148 3592165913 1275068416 1275068416 352321536 0 0 0 0 0 0 0 0 0 503316480 3659274777 4280229148 4280229148 4280229148 4280229148 4280229148 4281543715 4289628488 4293240390 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4292713021 4287850801 4282463782 4286016071 4294238353 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294896535 4290950006 4284833346 4283780921 4289371497 4294304402 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4291476090 4281347365 4280229148 4280229148 4280229148 3105495063 1275068416 1275068416 150994944 0 0 0 0 0 0 0 0 0 402653184 2014318350 3676051994 4280229148 4280229148 4280229148 4280229148 4280627012 4280099376 4280426270 4288050752 4293043528 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4289953846 4286276665 4291080047 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4293909903 4288319072 4283451959 4286740563 4292528771 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4293909902 4289963374 4285885515 4281741865 4280229148 4280229148 4280229148 4280229148 4280229148 2249396497 1275068416 1207959552 0 0 0 0 0 0 0 0 0 0 301989888 1275068416 1291845632 3155826711 4280229148 4280229148 4280229148 4281352290 4280166989 4280167246 4280561742 4280098343 4286407480 4292649802 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4291924796 4292586841 4294565770 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4291805053 4286148686 4285293638 4289963629 4294633365 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294764950 4291607675 4287464281 4283386166 4280294940 4280558630 4281679176 4281151542 4280229148 4280229148 4280229148 4280229148 3877444378 1375928834 1275068416 1006632960 0 0 0 0 0 0 0 0 0 0 218103808 1275068416 1275068416 2685867284 4280229148 4280229148 4280229148 4281286239 4280166989 4280166989 4280166989 4280167246 4280364881 4280297276 4284567602 4292190283 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4292844863 4291666774 4293579395 4294962328 4294962328 4294962328 4292923271 4288845156 4289765996 4294238353 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4293186441 4289108583 4284964931 4281149988 4281152831 4282472305 4283658645 4284647089 4285109445 4285109703 4281482312 4280229148 4280229148 3424327961 2920814358 1661602057 1275068416 1275068416 788529152 0 0 0 0 0 0 0 0 0 0 117440512 1275068416 1275068416 2434077459 4280229148 4280229148 4280229148 4281220444 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166990 4280363589 4282661678 4291467850 4293304897 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293504076 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294764950 4291410554 4286937941 4282596911 4280427301 4281879135 4283395214 4284713140 4285240001 4285174722 4285174980 4285175238 4285109703 4284978631 4280427301 4280229148 3860667162 1275068416 1275068416 1275068416 1275068416 1275068416 570425344 0 0 0 0 0 0 0 0 0 0 0 285212672 922746880 2198999312 4280229148 4280229148 4280229148 4281088342 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280232521 4281675823 4290547784 4293370947 4293370432 4293370432 4293370432 4293370432 4293370432 4293502790 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4293975439 4289766508 4285424968 4281215781 4280229664 4281877848 4283461009 4284778934 4285107900 4285108414 4285174464 4285240002 4285174979 4285175237 4285175238 4285044167 4284319411 4280229148 4280229148 3172603927 1275068416 1275068416 1275068416 1275068416 1275068416 167772160 0 0 0 0 0 0 0 0 0 0 0 0 0 1745948687 4280229148 4280229148 4280229148 4280890702 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280232779 4281018928 4289496903 4293305926 4293370432 4293370432 4293370432 4293370432 4294962327 4294962328 4294962328 4294962328 4294962328 4294962328 4292923270 4288253535 4283846459 4280426525 4280229149 4281548879 4283262598 4284515245 4284844725 4284976056 4285042362 4285173949 4285174463 4285174465 4285240259 4285175237 4285175238 4285109703 4285109704 4283330711 4280229148 4280229148 2685867284 1275068416 1275068416 1275068416 1275068416 738197504 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1393429773 4280229148 4280229148 4280229148 4280758084 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280232779 4280427050 4288576322 4293174856 4293370432 4293370432 4294829969 4294962328 4294962328 4293975439 4288976998 4283518008 4280229148 4280229148 4281218368 4282932603 4284185249 4284580781 4284712625 4284844212 4284910519 4285042106 4285108156 4285173951 4285174464 4285240258 4285240516 4285174981 4285109702 4285109704 4285044168 4282341750 4280229148 4280229148 2333348370 1275068416 1090519040 452984832 318767104 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1024002056 4280229148 4280229148 4280229148 4280625722 4281285730 4281746538 4282272628 4282601850 4282535800 4282404471 4282272885 4281746282 4280758871 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280495950 4280295203 4287393598 4292912715 4294434184 4290358129 4284964931 4280623647 4280229148 4280756268 4282207587 4283525774 4284185252 4284317353 4284514989 4284646831 4284778418 4284910262 4285041848 4285042619 4285108414 4285174208 4284977859 4284846533 4284715461 4284584390 4284518599 4284387271 4284256199 4281418325 4280229148 4280229148 2014318350 1275068416 654311424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 687865856 4246608923 4280229148 4280229148 4280624683 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4282667644 4281614697 4280627541 4280166989 4280166989 4280232525 4280627283 4281022041 4281285462 4280229406 4280820768 4280229148 4280558374 4281482059 4282669173 4283592342 4283921822 4284119459 4284251559 4284448938 4284646574 4284712626 4284844469 4284844985 4284714175 4284452289 4284255685 4283993286 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4280823351 4280229148 4280229148 1678379273 1275068416 335544320 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 553648128 4028505115 4280229148 4280229148 4280360736 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4282272628 4280693078 4280495441 4280824662 4281219163 4281548384 4281943399 4281747555 4282076265 4282802308 4283329428 4283527065 4283790237 4283987874 4284251046 4284383145 4284580781 4284516278 4284320447 4283993028 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283795650 4280229406 4280229148 4263386139 1359086082 1275068416 134217728 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 452984832 3793558298 4280229148 4280229148 4280229148 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283128452 4282206834 4281285214 4281416798 4281745763 4282009191 4282538367 4282934412 4283197841 4283526806 4283789723 4283922080 4284119975 4284122035 4284057790 4283927494 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283201446 4280229148 4280229148 4028505115 1275068416 1241513984 16777216 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 335544320 3541834265 4280229148 4280229148 4280229148 4283194760 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283062660 4282404212 4282008679 4282206570 4282669438 4283132048 4283394965 4283658908 4283923885 4283991741 4283861958 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4282540935 4280229148 4280229148 3692829466 1275068416 1107296256 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 3306887448 4280229148 4280229148 4280229148 4283129481 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283062659 4282732919 4282404716 4283463075 4283794104 4283861957 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4281946477 4280229148 4280229148 3357219096 1275068416 956301312 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 117440512 3071875095 4280229148 4280229148 4280229148 4283063688 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4281153350 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4281550170 4280229148 4280229148 3021543191 1275068416 788529152 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 2836928021 4280229148 4280229148 4280229148 4282932357 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4280624684 4283597496 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4281153864 4280229148 4280229148 2685867284 1275068416 637534208 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2551649556 4280229148 4280229148 4280229148 4282800512 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4280756528 4283465394 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4280757557 4280229148 4280229148 2350125586 1275068416 486539264 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2232751123 4280229148 4280229148 4280229148 4282603130 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4280888373 4283465394 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4280361251 4280229148 4280229148 2014318350 1275068416 335544320 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1913852433 4280229148 4280229148 4280229148 4282405233 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4281350216 4283861958 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283663804 4280229148 4280229148 4280229148 1695156745 1275068416 167772160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1561399311 4280229148 4280229148 4280229148 4282141543 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4282536308 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283267498 4280229148 4280229148 4280229148 1359086082 1275068416 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1175325964 4280229148 4280229148 4280229148 4281812060 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194761 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4282871191 4280229148 4280229148 4028505115 1275068416 1157627904 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 788989446 4280229148 4280229148 4280229148 4281416526 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194504 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4282474885 4280229148 4280229148 3709606682 1275068416 989855744 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 536870912 4179500059 4280229148 4280229148 4281086270 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194503 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4282078579 4280229148 4280229148 3357219096 1275068416 838860800 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 419430400 3944553243 4280229148 4280229148 4280624941 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4281748580 4280229148 4280229148 3038320407 1275068416 687865856 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 301989888 3709606682 4280229148 4280229148 4280360994 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4281483862 4280229148 4280229148 2702644501 1275068416 536870912 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 201326592 3474659865 4280229148 4280229148 4280229148 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283861958 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4281153864 4280229148 4280229148 2366903058 1275068416 369098752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 100663296 3239713048 4280229148 4280229148 4280229148 4283194760 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283795906 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4280823866 4280229148 4280229148 2031095566 1275068416 218103808 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2987988758 4280229148 4280229148 4280229148 4283129224 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283333548 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4280559404 4280229148 4280229148 1695222281 1275068416 67108864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2702710293 4280229148 4280229148 4280229148 4283063687 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283128453 4282870677 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283861958 4280229406 4280229148 4280229148 1375928834 1191182336 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2400654612 4280229148 4280229148 4280229148 4282866049 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4282930813 4282606987 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283663547 4280229148 4280229148 4045282331 1275068416 1040187392 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2048201747 4280229148 4280229148 4280229148 4282536565 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4282667124 4282409091 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283333549 4280229148 4280229148 3709606682 1275068416 889192448 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1712525841 4280229148 4280229148 4280229148 4282140774 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4282403434 4282276732 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283069087 4280229148 4280229148 3390773528 1275068416 738197504 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1292898062 4280229148 4280229148 4280229148 4281679187 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4282140258 4282276731 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4282607244 4280229148 4280229148 3038320407 1275068416 570425344 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 688063235 4095613979 4280229148 4280229148 4280756528 4282800511 4283194247 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4281876825 4282276731 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4281550427 4280229148 4280229148 2719421717 1275068416 419430400 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 503316480 2736199189 4280229148 4280229148 4280229148 4280229148 4280822579 4282799998 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4281613392 4282276731 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283795907 4280427560 4280229148 4280229148 2383680274 1275068416 268435456 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 318767104 1291845632 2987988758 4280229148 4280229148 4280229148 4280229148 4280229148 4281547599 4283128710 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4281349959 4282276731 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4281946476 4280229148 4280229148 4280229148 1997475342 1275068416 117440512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 1040187392 1275068416 2232553745 4062059547 4280229148 4280229148 4280229148 4280229148 4280756271 4282865276 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4281086270 4282276731 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283795648 4281880425 4280229148 4280229148 4280229148 4162722843 1359086082 1241513984 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 150994944 1073741824 1275068416 1594361863 3491502617 4280229148 4280229148 4280229148 4280229148 4280295200 4282206309 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4280822580 4282276732 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283201446 4281946733 4280625712 4280229148 4280229148 4280229148 4280229148 3390773528 1275068416 1073741824 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 704643072 1258291200 1291845632 2635470100 4213054491 4280229148 4280229148 4280229148 4280229148 4281283909 4283128709 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4280558889 4282408833 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283267755 4281946733 4280757556 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4229831707 1846348812 1275068416 771751936 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 285212672 1073741824 1275068416 1846348812 3810335514 4280229148 4280229148 4280229148 4280229148 4280624683 4282931071 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4280295199 4282540935 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283795649 4282540937 4281087812 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4213054491 2400457490 1275068416 1275068416 402653184 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33554432 687865856 1258291200 1392706307 3055097879 4280229148 4280229148 4280229148 4280229148 4280295200 4282404205 4283194246 4283194246 4283194246 4283194246 4283194246 4282996607 4280229148 4282673038 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283267498 4281814375 4280427560 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4246608923 3273267480 1812728843 1275068416 1275068416 1006632960 16777216 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 268435456 1056964608 1275068416 2198999312 4045282331 4280229148 4280229148 4280229148 4280229148 4281745238 4283194247 4283194246 4283194246 4283194246 4282732917 4280229148 4282804884 4283927751 4283927751 4283927751 4283927751 4283861957 4282739090 4281153606 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4028505115 2836928021 1627981832 1275068416 1275068416 1275068416 1056964608 167772160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33554432 654311424 1258291200 1560807175 3407550744 4280229148 4280229148 4280229148 4280229148 4281020475 4283129225 4283194246 4283194246 4282469228 4280229148 4282937242 4283927751 4283927751 4283663805 4282276475 4280691506 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 3575388697 2316505617 1342308866 1275068416 1275068416 1275068416 1073741824 553648128 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 251658240 1040187392 1275068416 2484409363 4145945627 4280229148 4280229148 4280229148 4280427303 4282998664 4283194246 4282205794 4280229148 4283069344 4283399342 4281748581 4280361508 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4145945627 3038320407 1812728843 1275068416 1275068416 1275068416 1207959552 788529152 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 603979776 1241513984 1695222281 3608943129 4280229148 4280229148 4280229148 4280229148 4282538365 4281942619 4280559146 4281154120 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 3776781082 2517963795 1426326532 1275068416 1275068416 1275068416 973078528 486539264 50331648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 184549376 956301312 1308688641 2719421717 4213054491 4280229148 4280229148 4280229148 4280691506 4280426788 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4213054491 3256490264 2014318350 1275068416 1275068416 1275068416 1140850688 671088640 184549376 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 503316480 1191182336 1846348812 3793558298 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 3944553242 2736199189 1560807175 1275068416 1275068416 1241513984 855638016 369098752 16777216 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 117440512 855638016 1375928834 2954434326 4263386139 4280229148 4280229148 4280229148 4280229148 4263386139 3457882649 2215776528 1308688641 1275068416 1275068416 1040187392 553648128 100663296 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 385875968 1140850688 1863126284 2685867284 3306887448 3038320407 2316505617 1577584647 1275068416 1275068416 1191182336 738197504 251658240 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 67108864 738197504 1258291200 1275068416 1275068416 1275068416 1224736768 905969664 436207616 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!TrashCanMorph classSide methodsFor: 'class initialization' stamp: 'dgd 9/2/2004 13:15'!
initializeTrashPicOn
	^ Form
		extent: 72 @ 72
		depth: 32
		fromArray: #(0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35593500 438246684 773791004 1109335324 706682140 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 52370716 857677084 1914641692 2971606300 3995016476 4280229148 4280229148 4280229148 4280229148 3089046812 1159666972 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 35593500 1059003676 2535398684 3944684828 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 3508477212 1595874588 102702364 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 924785948 2401180956 3844021532 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4282136620 4281149988 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 3844021532 2015304988 287251740 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 790568220 2266963228 3726581020 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4282333741 4287266903 4292200065 4294962328 4294699158 4291279224 4286937941 4282597168 4280229148 4280229148 4280229148 4280229148 4280229148 4095679772 2451512604 572464412 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 673127708 2132745500 3609140508 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4282333741 4287266903 4292200065 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4292331393 4286346064 4281084195 4280229148 4280229148 4280229148 4280229148 4229897500 2870943004 941563164 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 52370716 1495211292 3424591132 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4282333741 4287266903 4292200065 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294370451 4289240168 4283320374 4280229148 4280229148 4280229148 4280229148 4280229148 3307150620 1226775836 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 169811228 1813978396 3726581020 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4281544487 4287069525 4292134272 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962071 4294103679 4290947944 4288252760 4293316998 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4292068480 4286148685 4280952610 4280229148 4280229148 4280229148 4280229148 3407813916 1310661916 18816284 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 320806172 2115968284 3944684828 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4283912250 4289897581 4294633365 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294895763 4293379184 4291467593 4292713278 4293501761 4281935888 4282330129 4292581949 4289495097 4291473254 4294962327 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294238866 4288648034 4282005034 4280229148 4280229148 4280229148 4280229148 3491699996 1394547996 18816284 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 438246684 2434735388 4095679772 4280229148 4280229148 4280229148 4280229148 4280229148 4281149988 4286609233 4292594564 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294961814 4293774199 4291796299 4293041983 4293501761 4293501761 4293501761 4293501761 4279898631 4284104473 4293370432 4293370432 4293370432 4291596347 4291207769 4294830228 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294699158 4289503082 4282597168 4280229148 4280229148 4280229148 4280229148 3558808860 1478434076 35593500 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1646206236 4028570908 4280229148 4280229148 4280229148 4280229148 4280229148 4283189045 4289305960 4294436243 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294564997 4292191827 4292779071 4293501761 4293501761 4293501761 4293501761 4293501761 4293501761 4293173055 4278321409 4285813024 4293370432 4293370432 4293370432 4293370432 4293370432 4292319293 4290943568 4294500750 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294896535 4290358129 4283451958 4280229148 4280229148 4280229148 4280229148 3625917724 1562320156 52370716 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 203365660 3089046812 4280229148 4280229148 4280229148 4280229148 4280229148 4283189045 4290621556 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294896278 4293378926 4292123203 4293501761 4293501761 4293501761 4293501761 4293501761 4293501761 4293501761 4293501761 4290281523 4284498715 4278190080 4287521831 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4292910142 4290942281 4294105222 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4291213433 4284307006 4280229148 4280229148 4280229148 4280229148 3676249372 1646206236 69147932 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2803834140 4280229148 4280229148 4280229148 4280229148 4282333741 4290423922 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294829713 4292456284 4292647743 4293501761 4293501761 4293501761 4293501761 4293501761 4293501761 4293501761 4290741813 4285484319 4280161544 4278190080 4278190080 4278190080 4281081612 4288376107 4293239103 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293107519 4290678852 4293579136 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4292002431 4283715129 4280229148 4280229148 4280229148 4280229148 3743358236 1713315100 18816284 0 0 0 0 0 0 0 0 0 0 0 0 0 1243553052 4280229148 4280229148 4280229148 4280294940 4286871892 4294436243 4294962328 4294962328 4294962328 4294962328 4294962328 4294962327 4292785762 4293107520 4293501761 4293501761 4293501761 4293501761 4293501761 4293501761 4292516157 4286667300 4280621578 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4280358665 4287193126 4292910398 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293173311 4290481215 4292986745 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4289766508 4281741865 4280229148 4280229148 4280229148 4280229148 2199854364 0 0 0 0 0 0 0 0 0 0 0 0 0 1310661916 4280229148 4280229148 4280360476 4288776274 4293515148 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4293248629 4290414395 4293304640 4293501761 4293501761 4293501761 4290873142 4284367386 4278781443 4278321666 4278716424 4279111182 4279242768 4279242768 4279242768 4279242768 4279242768 4279242768 4279308561 4278979596 4278584838 4279438597 4285944609 4292319035 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293304640 4290942021 4294895507 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294304658 4287266903 4280623647 4280229148 4280229148 4280229148 1511988508 0 0 0 0 0 0 0 0 0 0 0 0 1025449244 4280229148 4280229148 4281740320 4293370432 4286735669 4285686849 4292594564 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4290619751 4287720239 4288376107 4282067473 4278190080 4278453252 4279505940 4280295456 4280361249 4280361249 4280427042 4280427042 4280427042 4280427042 4280427042 4280427042 4280427042 4280427042 4280427042 4280229663 4279242768 4278913028 4284761628 4291530296 4293370432 4293370432 4292779069 4289427761 4288904509 4291736169 4294962070 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294830742 4290687091 4282333742 4280229148 4280229148 4129234204 455023900 0 0 0 0 0 0 0 0 0 0 0 773725211 4280229148 4280229148 4281871648 4293370432 4293370432 4288442418 4281280544 4284568890 4291410554 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4291147381 4283978293 4280163612 4281479730 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281348144 4279966491 4278518786 4286213469 4284702037 4288253794 4294304402 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4291805053 4288516449 4290160751 4294370195 4290161008 4280229148 4280229148 4280229148 2082413852 0 0 0 0 0 0 0 0 0 0 0 1074596876 4280229148 4280229148 4281477407 4293370432 4293370432 4293370432 4292253244 4284960041 4280229148 4283254065 4290423922 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4292923271 4285228105 4281940279 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4282664004 4283585107 4288256927 4293454315 4294967295 4291612632 4284442748 4292924050 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4292857478 4287266647 4285556808 4290029422 4294764950 4294962328 4294962328 4291805309 4280229148 4280229148 4280229148 1847335449 0 0 0 0 0 0 0 0 0 0 0 1040581893 4280229148 4280229148 4280294684 4293305153 4293370432 4293370432 4293370432 4293370432 4291004729 4284631336 4280294940 4283122480 4290752628 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294764950 4289042791 4283715910 4283453520 4283782485 4283782485 4283782485 4283782485 4283782485 4283782485 4283782485 4283782485 4283782485 4286217343 4290888647 4294638331 4294967295 4294967295 4294967295 4294967295 4290692045 4284508540 4293384340 4294962328 4294962328 4294633365 4289963629 4284438591 4285622345 4291936639 4294962328 4294962328 4294962328 4294962328 4294962328 4290687092 4280229148 4280229148 4280229148 1896877839 167772160 0 0 0 0 0 0 0 0 0 0 788529152 4229831707 4280229148 4280229148 4292977735 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4291333434 4285091113 4280426269 4283385907 4291016054 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4293318026 4286610012 4284308569 4284900966 4284900966 4284900966 4284900966 4284835430 4287533462 4293059558 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288126895 4288650374 4292857478 4287069525 4282794033 4287464024 4293580940 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4289174118 4280229148 4280229148 4280229148 1527186950 1056964608 16777216 0 0 0 0 0 0 0 0 0 687865856 4045282331 4280229148 4280229148 4290219337 4293370689 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4291662139 4285485354 4280492061 4283648821 4291410298 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4290490234 4285821028 4285098086 4285755229 4285625721 4286548124 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292336352 4283587440 4283122996 4289437289 4294567572 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4285162309 4280229148 4280229148 4062059547 1275068416 1275068416 419430400 0 0 0 0 0 0 0 0 0 587202560 3843889946 4280229148 4280229148 4280229148 4282990123 4290943054 4293371203 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4291924796 4285945387 4280886559 4284043321 4291739260 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4293384340 4284179578 4291218131 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901502 4284771975 4292792722 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4292528515 4280558111 4280229148 4280229148 3592165913 1275068416 1275068416 352321536 0 0 0 0 0 0 0 0 0 503316480 3659274777 4280229148 4280229148 4280229148 4280229148 4280229148 4281543715 4289628488 4293240390 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4292713021 4287850801 4282463782 4286016071 4294238353 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4290491531 4285166988 4294835709 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287863724 4290097034 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4291476090 4281347365 4280229148 4280229148 4280229148 3105495063 1275068416 1275068416 150994944 0 0 0 0 0 0 0 0 0 402653184 2014318350 3676051994 4280229148 4280229148 4280229148 4280229148 4280627012 4280099376 4280426270 4288050752 4293043528 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4289953846 4286276665 4291080047 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294830743 4285297533 4291283667 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290165703 4288058757 4294962328 4294962328 4294962328 4294962328 4294962328 4293909902 4289963374 4285885515 4281741865 4280229148 4280229148 4280229148 4280229148 4280229148 2249396497 1275068416 1207959552 0 0 0 0 0 0 0 0 0 0 301989888 1275068416 1291845632 3155826711 4280229148 4280229148 4280229148 4281352290 4280166989 4280167246 4280561742 4280098343 4286407480 4292649802 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4291924796 4292586841 4294565770 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4291805053 4285163869 4285890453 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292402145 4286020735 4294962328 4294764950 4291607675 4287464281 4283386166 4280294940 4280558630 4281679176 4281151542 4280229148 4280229148 4280229148 4280229148 3877444378 1375928834 1275068416 1006632960 0 0 0 0 0 0 0 0 0 0 218103808 1275068416 1275068416 2685867284 4280229148 4280229148 4280229148 4281286239 4280166989 4280166989 4280166989 4280167246 4280364881 4280297276 4284567602 4292190283 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4292844863 4291666774 4293579395 4294962328 4294962328 4294962328 4292923271 4288845156 4289765996 4293778320 4283916922 4292336352 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294507002 4283851128 4284899138 4281149988 4281152831 4282472305 4283658645 4284647089 4285109445 4285109703 4281482312 4280229148 4280229148 3424327961 2920814358 1661602057 1275068416 1275068416 788529152 0 0 0 0 0 0 0 0 0 0 117440512 1275068416 1275068416 2434077459 4280229148 4280229148 4280229148 4281220444 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166990 4280363589 4282661678 4291467850 4293304897 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293370432 4293504076 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4287006849 4290363081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4285495440 4283394699 4284713140 4285240001 4285174722 4285174980 4285175238 4285109703 4284978631 4280427301 4280229148 3860667162 1275068416 1275068416 1275068416 1275068416 1275068416 570425344 0 0 0 0 0 0 0 0 0 0 0 285212672 922746880 2198999312 4280229148 4280229148 4280229148 4281088342 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280232521 4281675823 4290547784 4293370947 4293370432 4293370432 4293370432 4293370432 4293370432 4293502790 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4294962328 4290228362 4289179067 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287468711 4284579752 4285174464 4285240002 4285174979 4285175237 4285175238 4285044167 4284319411 4280229148 4280229148 3172603927 1275068416 1275068416 1275068416 1275068416 1275068416 167772160 0 0 0 0 0 0 0 0 0 0 0 0 0 1745948687 4280229148 4280229148 4280229148 4280890702 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280232779 4281018928 4289496903 4293305926 4293370432 4293370432 4293370432 4293370432 4294962327 4294962328 4294962328 4294962328 4294962328 4294962328 4292923270 4286807910 4287995053 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4289244860 4284381599 4285174465 4285240259 4285175237 4285175238 4285109703 4285109704 4283330711 4280229148 4280229148 2685867284 1275068416 1275068416 1275068416 1275068416 738197504 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1393429773 4280229148 4280229148 4280229148 4280758084 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280232779 4280427050 4288576322 4293174856 4293370432 4293370432 4294829969 4294962328 4294962328 4293975439 4288976998 4283518008 4280229148 4280887856 4286811295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290955216 4284183189 4285240258 4285240516 4285174981 4285109702 4285109704 4285044168 4282341750 4280229148 4280229148 2333348370 1275068416 1090519040 452984832 318767104 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1024002056 4280229148 4280229148 4280229148 4280625722 4281285730 4281746538 4282272628 4282601850 4282535800 4282404471 4282272885 4281746282 4280758871 4280166989 4280166989 4280166989 4280166989 4280166989 4280166989 4280495950 4280295203 4287393598 4292912715 4294434184 4290358129 4284964931 4280623647 4280229148 4280756268 4282207587 4283459723 4285627282 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292730853 4283853451 4284846533 4284715461 4284584390 4284518599 4284387271 4284256199 4281418325 4280229148 4280229148 2014318350 1275068416 654311424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 687865856 4246608923 4280229148 4280229148 4280624683 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4282667644 4281614697 4280627541 4280166989 4280166989 4280232525 4280627283 4281022041 4281285462 4280229406 4280820768 4280229148 4280558374 4281482059 4282669173 4283592342 4283921822 4283987101 4284508804 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294441209 4283523713 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4280823351 4280229148 4280229148 1678379273 1275068416 335544320 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 553648128 4028505115 4280229148 4280229148 4280360736 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4282272628 4280693078 4280495441 4280824662 4281219163 4281548384 4281943399 4281747555 4282076265 4282802308 4283329428 4283527065 4283790237 4283987874 4284052894 4283522425 4294638587 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4284772232 4283861443 4283927751 4283927751 4283927751 4283927751 4283795650 4280229406 4280229148 4263386139 1359086082 1275068416 134217728 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 452984832 3793558298 4280229148 4280229148 4280229148 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283128452 4282206834 4281285214 4281416798 4281745763 4282009191 4282538367 4282934412 4283197841 4283526806 4283789723 4283922080 4284119975 4283988904 4283522425 4293454573 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291678681 4284574853 4283859895 4283927751 4283927751 4283927751 4283927751 4283201446 4280229148 4280229148 4028505115 1275068416 1241513984 16777216 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 335544320 3541834265 4280229148 4280229148 4280229148 4283194760 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283062660 4282404212 4282008679 4282206570 4282669438 4283132048 4283394965 4283658908 4283923885 4283991741 4283861958 4283794360 4283522425 4292138974 4294967295 4294967295 4294967295 4294967295 4294704124 4290757582 4285495696 4283522425 4283591569 4283860670 4283927751 4283927751 4283927751 4283927751 4282540935 4280229148 4280229148 3692829466 1275068416 1107296256 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 3306887448 4280229148 4280229148 4280229148 4283129481 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283062659 4282732919 4282404716 4283463075 4283794104 4283861957 4283927751 4283927751 4283927751 4283794360 4283522425 4289442238 4294967295 4294967295 4292665060 4288521395 4284574853 4283522682 4283658134 4283860154 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4281946477 4280229148 4280229148 3357219096 1275068416 956301312 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 117440512 3071875095 4280229148 4280229148 4280229148 4283063688 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4281153350 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283861184 4283522425 4284640646 4289310653 4285232525 4283522425 4283523198 4283658908 4283860926 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4281550170 4280229148 4280229148 3021543191 1275068416 788529152 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 2836928021 4280229148 4280229148 4280229148 4282932357 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4280624684 4283597496 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283589764 4283522425 4283522940 4283592084 4283793071 4283927493 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4281153864 4280229148 4280229148 2685867284 1275068416 637534208 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2551649556 4280229148 4280229148 4280229148 4282800512 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4280756528 4283465394 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283861443 4283860412 4283861956 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4280757557 4280229148 4280229148 2350125586 1275068416 486539264 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2232751123 4280229148 4280229148 4280229148 4282603130 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4280888373 4283465394 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4280361251 4280229148 4280229148 2014318350 1275068416 335544320 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1913852433 4280229148 4280229148 4280229148 4282405233 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4281350216 4283861958 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283663804 4280229148 4280229148 4280229148 1695156745 1275068416 167772160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1561399311 4280229148 4280229148 4280229148 4282141543 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4282536308 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283267498 4280229148 4280229148 4280229148 1359086082 1275068416 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1175325964 4280229148 4280229148 4280229148 4281812060 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194761 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4282871191 4280229148 4280229148 4028505115 1275068416 1157627904 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 788989446 4280229148 4280229148 4280229148 4281416526 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194504 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4282474885 4280229148 4280229148 3709606682 1275068416 989855744 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 536870912 4179500059 4280229148 4280229148 4281086270 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194503 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4282078579 4280229148 4280229148 3357219096 1275068416 838860800 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 419430400 3944553243 4280229148 4280229148 4280624941 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4281748580 4280229148 4280229148 3038320407 1275068416 687865856 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 301989888 3709606682 4280229148 4280229148 4280360994 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4281483862 4280229148 4280229148 2702644501 1275068416 536870912 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 201326592 3474659865 4280229148 4280229148 4280229148 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283861958 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4281153864 4280229148 4280229148 2366903058 1275068416 369098752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 100663296 3239713048 4280229148 4280229148 4280229148 4283194760 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283795906 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4280823866 4280229148 4280229148 2031095566 1275068416 218103808 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2987988758 4280229148 4280229148 4280229148 4283129224 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283333548 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4280559404 4280229148 4280229148 1695222281 1275068416 67108864 0 0 0 0 72441209 3075562873 2790350201 1330732409 72441209 0 0 0 0 0 0 0 0 0 0 0 0 2702710293 4280229148 4280229148 4280229148 4283063687 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283128453 4282870677 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283861958 4280229406 4280229148 4280229148 1375928834 1191182336 0 0 0 0 0 1716608377 4283522425 4283522425 4286811296 3949622412 2287033721 558980473 0 0 0 0 0 0 0 0 0 0 2400654612 4280229148 4280229148 4280229148 4282866049 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4282930813 4282606987 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283663547 4280229148 4280229148 4045282331 1275068416 1040187392 0 0 0 0 72441209 3729874297 4283522425 4287534760 4294901502 4294704123 4289902532 4250362750 3008454009 1230069113 22109561 0 0 0 0 0 0 0 2048201747 4280229148 4280229148 4280229148 4282536565 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4282667124 4282409091 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283333549 4280229148 4280229148 3709606682 1275068416 889192448 0 0 0 0 1666276729 4283522425 4284772232 4294177781 4294901502 4294901502 4294901502 4292796645 4284903561 4283522425 3696319865 424762745 0 0 0 0 0 0 1712525841 4280229148 4280229148 4280229148 4282140774 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4282403434 4282276732 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283069087 4280229148 4280229148 3390773528 1275068416 738197504 0 0 0 189881721 3864092025 4283522425 4291875803 4294901502 4294901502 4294901502 4294901502 4294901502 4293914867 4286153368 4283522425 960119383 0 0 0 0 0 0 1292898062 4280229148 4280229148 4280229148 4281679187 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4282140258 4282276731 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4282607244 4280229148 4280229148 3038320407 1275068416 570425344 0 0 0 2169593209 4283522425 4288455602 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4290823631 3998112117 1359020289 922746880 0 0 0 0 0 688063235 4095613979 4280229148 4280229148 4280756528 4282800511 4283194247 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4281876825 4282276731 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4281550427 4280229148 4280229148 2719421717 1275068416 419430400 0 0 475094393 4115750265 4284903561 4294506745 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4294901502 4287666346 2721793113 1342177280 889192448 0 0 0 0 0 503316480 2736199189 4280229148 4280229148 4280229148 4280229148 4280822579 4282799998 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4281613392 4282276731 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283795907 4280427560 4280229148 4280229148 2383680274 1275068416 268435456 0 0 2706464121 4283522425 4290165701 4294572537 4294769916 4294901502 4294901502 4294901502 4294901502 4294901502 4293914866 4116013178 1510739474 1342177280 436207616 0 0 0 0 0 318767104 1291845632 2987988758 4280229148 4280229148 4280229148 4280229148 4280229148 4281547599 4283128710 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4281349959 4282276731 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4281946476 4280229148 4280229148 4280229148 1997475342 1275068416 117440512 0 860970361 4266679416 4284969353 4293585642 4293914607 4294111986 4294309365 4294440951 4294638330 4294835709 4294901502 4288915896 2889828446 1342177280 1124073472 16777216 0 0 0 0 0 16777216 1040187392 1275068416 2232553745 4062059547 4280229148 4280229148 4280229148 4280229148 4280756271 4282865276 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4281086270 4282276731 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283795648 4281880425 4280229148 4280229148 4280229148 4162722843 1359086082 1241513984 0 0 3193003385 4283522425 4289573563 4293059298 4293256677 4293454056 4293585642 4293783021 4293980400 4294177779 4293717486 4200228222 1595020571 1342177280 452984832 0 0 0 0 0 0 0 150994944 1073741824 1275068416 1594361863 3491502617 4280229148 4280229148 4280229148 4280229148 4280295200 4282206309 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4280822580 4282276732 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283201446 4281946733 4280625712 4280229148 4280229148 4280229148 4280229148 3390773528 1275068416 1073741824 0 1246846329 4283522425 4284969352 4292138196 4292401368 4292532954 4292730333 4292927712 4293125091 4293322470 4293519849 4288784308 3057798242 1342177280 1107296256 0 0 0 0 0 0 0 0 0 50331648 704643072 1258291200 1291845632 2635470100 4213054491 4280229148 4280229148 4280229148 4280229148 4281283909 4283128709 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4280558889 4282408833 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283267755 4281946733 4280757556 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4229831707 1846348812 1275068416 890048276 34080776 2907724920 4283522425 4285824144 4290756802 4291677645 4291875024 4292072403 4292269782 4292467161 4292664540 4292006870 4233651070 1729764646 1342177280 436207616 0 0 0 0 0 0 0 0 0 0 0 285212672 1073741824 1275068416 1846348812 3810335514 4280229148 4280229148 4280229148 4280229148 4280624683 4282931071 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4283194246 4280295199 4282540935 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283795649 4282540937 4281087812 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4213054491 2400457490 1275068416 2167354950 3914292086 1982871110 1242698777 2620998230 4115618678 4283719803 4286810521 4290756801 4291414473 4291611852 4291809231 4291940817 4287073951 3040955234 1342177280 1090519040 0 0 0 0 0 0 0 0 0 0 0 0 0 33554432 687865856 1258291200 1392706307 3055097879 4280229148 4280229148 4280229148 4280229148 4280295200 4282404205 4283194246 4283194246 4283194246 4283194246 4283194246 4282996607 4280229148 4282673038 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283927751 4283267498 4281814375 4280427560 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4246608923 3273267480 1812728843 1426853394 3158921833 4289113274 4290428874 3880605811 2030569739 1526726656 1611863581 3192147558 4266679416 4284377473 4289112495 4290953922 4291085508 4290033338 4065418103 1544491286 1342177280 419430400 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 268435456 1056964608 1275068416 2198999312 4045282331 4280229148 4280229148 4280229148 4280229148 4281745238 4283194247 4283194246 4283194246 4283194246 4282732917 4280229148 4282804884 4283927751 4283927751 4283927751 4283927751 4283861957 4282739090 4281153606 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4028505115 2836928021 1627981832 1275068416 2049651008 3982781829 4292796645 4294835709 4289968581 3914489207 1797005353 1023739141 1023410176 1342177280 2015833403 3796653937 4283588217 4287796896 4290427578 4285626765 2553757779 1342177280 989855744 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33554432 654311424 1258291200 1560807175 3407550744 4280229148 4280229148 4280229148 4280229148 4281020475 4283129225 4283194246 4283194246 4282469228 4280229148 4282937242 4283927751 4283927751 4283663805 4282276475 4280691506 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 3575388697 2316505617 1342308866 1275068416 1544820510 3024178018 4268915858 4293783537 4293388781 4286022038 3410449002 1612126495 1244937036 1582390649 458317177 503382273 1090519040 1544491543 3712702064 4283588217 4286613141 3746256497 1375863556 1308622848 201326592 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 251658240 1040187392 1275068416 2484409363 4145945627 4280229148 4280229148 4280229148 4280427303 4282998664 4283194246 4282205794 4280229148 4283069344 4283399342 4281748581 4280361508 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4145945627 3038320407 1812728843 1275068416 1275068416 2083008060 3982650755 4283916925 4286087575 4294375416 4291415253 4284180353 4166015863 3695924848 4183779971 4286613917 4285693074 2318744653 1376258056 17303560 452984832 1460671257 3729479280 4283522425 2083074110 1342177280 704643072 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 603979776 1241513984 1695222281 3608943129 4280229148 4280229148 4280229148 4280229148 4282538365 4281942619 4280559146 4281154120 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 3776781082 2517963795 1426326532 1275068416 1275068416 1275068416 973078528 2285717084 4292467938 4287600553 4291810266 4292270559 4285955989 4288586932 4291218131 4293783281 4294967295 4294967295 4290954960 2789033562 1426589704 185075720 0 234881024 1494488862 2688172887 1342177280 1174405120 50331648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 184549376 956301312 1308688641 2719421717 4213054491 4280229148 4280229148 4280229148 4280691506 4280426788 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4213054491 3256490264 2014318350 1275068416 1275068416 1275068416 1140850688 671088640 184549376 0 2118405733 4252598936 4284443268 4292533474 4294967295 4294967295 4294967295 4293322988 4290823374 4288455346 4286087575 4283917182 3192147557 1426589704 403179528 0 0 218103808 1191182336 1308622848 285212672 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 503316480 1191182336 1846348812 3793558298 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 4280229148 3944553242 2736199189 1560807175 1275068416 1275068416 1241513984 855638016 369098752 16777216 0 0 0 336070664 974263063 3511441264 4294441209 4291415253 4286942625 4284443268 4233124984 3729479280 3124972900 2536980306 1948592436 1376389900 1057490952 336070664 0 0 0 117440512 369098752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 117440512 855638016 1375928834 2954434326 4263386139 4280229148 4280229148 4280229148 4280229148 4263386139 3457882649 2215776528 1308688641 1275068416 1275068416 1040187392 553648128 100663296 0 0 0 0 0 0 0 0 3882513291 4292138974 4283719803 2906605662 2049519163 1410207762 1040713736 755501064 470288392 201852936 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 385875968 1140850688 1863126284 2685867284 3306887448 3038320407 2316505617 1577584647 1275068416 1275068416 1191182336 738197504 251658240 0 0 0 0 0 0 0 0 0 0 38886777 3192476781 3930937715 2990623328 1158154248 168298504 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 67108864 738197504 1258291200 1275068416 1275068416 1275068416 1224736768 905969664 436207616 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 621283336 1023936520 1158154248 151521288 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
		offset: 0 @ 0! !

!TrashCanMorph classSide methodsFor: 'miscellaneous' stamp: 'sw 8/18/1999 19:55'!
moveToTrash: aMorph
	Preferences soundsEnabled ifTrue:
		[Preferences preserveTrash 
			ifFalse:
				[self playSoundNamed: 'scratch']
			ifTrue:
				[self playDeleteSound]].

	aMorph delete.
	aMorph == Utilities scrapsBook ifFalse:
		[Utilities addToTrash: aMorph]! !

!TrashCanMorph classSide methodsFor: 'as yet unclassified' stamp: 'gk 2/23/2004 20:51'!
playDeleteSound
	"TrashCanMorph playDeleteSound"

	SoundService default playSampledSound: self samplesForDelete rate: 22050! !

!TrashCanMorph classSide methodsFor: 'as yet unclassified' stamp: 'gk 2/23/2004 20:51'!
playMouseEnterSound
	"TrashCanMorph playMouseEnterSound"

	SoundService default playSampledSound: self samplesForMouseEnter rate: 22050! !

!TrashCanMorph classSide methodsFor: 'as yet unclassified' stamp: 'gk 2/23/2004 20:51'!
playMouseLeaveSound
	"TrashCanMorph playMouseLeaveSound"

	SoundService default playSampledSound: self samplesForMouseLeave rate: 22050! !

!TrashCanMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 12:08'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(TrashCanMorph	new	'Trash'		'A tool for discarding objects')
						forFlapNamed: 'PlugIn Supplies'.
						cl registerQuad: #(TrashCanMorph	new	'Trash'		'A tool for discarding objects')
						forFlapNamed: 'Widgets'.
						cl registerQuad: #(TrashCanMorph	new	'Trash'		'A tool for discarding objects')
						forFlapNamed: 'Scripting']! !

!TrashCanMorph classSide methodsFor: 'as yet unclassified' stamp: 'jm 5/16/1998 11:00'!
samplesForDelete

	^ #(0 11 5 18 42 35 28 54 42 59 52 44 16 18 33 6 -39 -30 -39 -37 -61 -61 -55 -83 -71 -42 -66 -45 -61 -40 -22 1 -3 33 61 69 44 59 59 64 44 81 62 79 91 62 45 55 1 -8 -10 -1 -16 -33 -20 -57 -54 -18 10 5 -1 -6 25 62 47 49 79 52 20 50 76 94 74 91 100 94 69 67 76 76 44 71 62 64 91 93 96 113 93 125 120 108 76 67 79 54 79 69 64 83 37 39 35 6 -13 -57 -62 -52 -79 -94 -100 -78 -105 -101 -59 -69 -64 -25 -55 -33 -57 -33 -39 -33 -16 -16 -16 -30 -25 -1 -27 -32 -39 -44 -1 -18 -23 -61 -55 -45 -67 -74 -47 -23 -22 -55 -50 -18 -47 -39 -22 -32 -28 -45 -28 -50 -69 -83 -83 -66 -93 -84 -74 -74 -84 -76 -94 -52 -69 -62 -35 -3 11 -16 28 5 -10 0 3 25 -1 20 32 25 44 59 18 11 -32 0 -11 -28 -55 -67 -62 -64 -57 -49 -76 -239 -980 -1731 -1565 -478 1153 2646 2919 1799 -1385 -5482 -8325 -8427 -4347 2556 9606 13864 12797 7894 731 -6395 -9218 -6222 1491 9207 12724 10783 3258 -6050 -12631 -14020 -9175 -454 8771 14419 13457 7050 -1679 -8875 -11346 -7670 960 10478 16383 15908 10112 2191 -5150 -8398 -6123 644 8334 12364 11062 5163 -2966 -9760 -12327 -9012 -1947 4977 8880 8495 4412 -1704 -6697 -7935 -5491 -186 5557 9289 9235 4955 -819 -4990 -5843 -3005 2128 7204 9606 7728 2439 -3872 -8469 -9930 -7226 -1385 4532 7567 6452 2154 -3136 -7248 -8045 -4493 1794 7582 10089 8636 3994 -1994 -6473 -7257 -3774 1894 6760 9011 7177 1979 -4364 -8760 -9067 -5465 332 5596 7764 5742 284 -5345 -8517 -7840 -3480 2838 8592 10639 7918 2485 -3435 -7177 -7341 -3630 2542 7333 8449 5514 15 -5645 -9192 -8368 -3540 3111 8083 9218 6558 941 -5119 -8500 -7748 -2905 3329 8259 9891 6975 1192 -4921 -8285 -7411 -3123 3090 7961 9206 5967 -130 -5728 -8793 -7886 -3061 3637 8965 9864 6471 683 -5121 -8324 -7547 -2720 3679 8050 8714 5236 -373 -6032 -9138 -7679 -2653 3679 8166 8982 5906 -111 -5825 -8561 -7094 -2091 3874 8412 9128 5533 -361 -5918 -8320 -6939 -2222 4016 8376 8831 4987 -943 -6130 -8678 -7102 -2117 4149 8322 8296 4768 -744 -5827 -8144 -6444 -1172 4732 8463 8412 4659 -1111 -6519 -8782 -6838 -1876 3818 7423 7601 3966 -1852 -6722 -8505 -6354 -1297 4366 8266 8217 4386 -1206 -5891 -7589 -5647 -595 5092 8402 7645 3372 -2274 -7031 -8958 -6814 -1560 4329 7654 7123 3477 -1869 -6393 -7899 -5367 88 5572 8632 8001 3994 -1711 -6441 -7793 -5287 -393 4497 7216 6430 2176 -3494 -7572 -8412 -5660 -476 4873 7782 6690 2393 -2805 -6588 -7323 -4649 614 5879 8327 6904 2609 -2773 -6848 -7927 -5150 117 5087 7272 5923 1730 -3616 -7575 -8117 -4951 332 5082 7314 6100 1716 -3587 -7162 -7338 -4064 1063 5860 7922 6178 1477 -3845 -7267 -7575 -4571 537 5260 7199 5292 826 -4115 -7486 -7689 -4446 938 5637 7201 5421 1063 -3815 -7109 -7141 -3667 1448 5660 6990 4983 519 -4622 -7833 -7543 -3996 1080 5323 6922 5028 385 -4480 -7416 -7070 -3789 1145 5533 6878 4693 40 -4734 -7506 -7268 -3827 1353 5650 6756 4347 -161 -4821 -7581 -7051 -3301 1993 5847 6707 4347 -198 -4888 -7582 -6814 -2926 2076 5860 6719 4339 -313 -5104 -7557 -6685 -2960 1915 5679 6573 3945 -814 -5333 -7572 -6588 -2787 2269 6052 6597 3789 -877 -5189 -7406 -6525 -2636 2447 5996 6307 3497 -1070 -5450 -7609 -6463 -2340 2658 5945 6230 3482 -1158 -5519 -7458 -5949 -1767 3039 6341 6612 3603 -1267 -5625 -7343 -5857 -1774 3033 6279 6346 3156 -1653 -5721 -7357 -5877 -1742 3158 6256 6039 2848 -1752 -5721 -7285 -5643 -1223 3635 6464 6159 2960 -1731 -5771 -7229 -5280 -936 3662 6266 5823 2488 -2386 -6329 -7457 -5362 -1044 3521 6339 5962 2564 -2183 -5850 -6875 -4841 -536 4120 6763 6062 2488 -2111 -5681 -6838 -4873 -605 3845 6190 5268 1777 -2759 -6413 -7419 -5162 -680 3692 5964 5234 1888 -2556 -5979 -6624 -4157 242 4497 6702 5860 2200 -2597 -6054 -6732 -4381 -111 4183 6330 5153 1346 -3170 -6430 -7031 -4688 -198 4213 6335 5180 1519 -2753 -5777 -6198 -3531 958 5024 6619 5234 1523 -3048 -6295 -6753 -4157 137 3986 5665 4412 788 -3545 -6449 -6469 -3735 539 4539 6246 4921 1172 -3100 -5918 -6010 -3352 905 4800 6313 4702 865 -3363 -6118 -6254 -3609 753 4529 5842 4178 466 -3628 -6305 -6174 -3231 1195 4854 6112 4497 715 -3550 -6183 -5972 -3043 1265 4843 6030 4203 264 -3915 -6352 -5945 -2961 1328 4907 6001 4025 50 -3949 -6240 -5808 -2731 1620 5085 5932 3872 5 -3961 -6174 -5640 -2408 1971 5204 5806 3587 -347 -4320 -6493 -5674 -2252 2103 5245 5818 3709 -300 -4249 -6215 -5309 -2066 2078 5077 5591 3262 -809 -4558 -6335 -5384 -2111 2062 5097 5460 3022 -951 -4570 -6283 -5192 -1733 2491 5348 5475 3024 -912 -4546 -6217 -5077 -1557 2597 5245 5301 2785 -1263 -4934 -6522 -5226 -1716 2385 5104 5206 2680 -1328 -4860 -6276 -4933 -1472 2549 5211 5238 2602 -1389 -4778 -6118 -4834 -1379 2664 5109 4880 2156 -1731 -5007 -6259 -4754 -1121 2883 5297 4973 2318 -1620 -4939 -6086 -4395 -697 3187 5426 5082 2242 -1738 -5026 -6037 -4332 -754 3012 5156 4665 1777 -2237 -5294 -6125 -4310 -676 3177 5313 4707 1704 -2171 -5167 -5962 -4134 -434 3307 5221 4456 1421 -2371 -5287 -5974 -3954 -188 3542 5297 4424 1389 -2456 -5362 -5854 -3667 161 3709 5435 4476 1255 -2671 -5472 -5828 -3589 215 3804 5409 4402 1138 -2724 -5324 -5599 -3384 378 3901 5396 4091 868 -2871 -5385 -5572 -3270 525 3884 5155 3828 575 -3119 -5518 -5503 -2994 826 4095 5277 3886 615 -3100 -5348 -5202 -2603 1202 4405 5579 4064 602 -3109 -5419 -5272 -2790 899 4067 5100 3521 122 -3477 -5592 -5270 -2585 1314 4537 5531 3905 485 -3089 -5226 -4956 -2347 1443 4476 5236 3463 11 -3604 -5711 -5257 -2473 1341 4363 5141 3385 -28 -3584 -5504 -4973 -2164 1586 4456 5218 3413 -64 -3496 -5321 -4707 -1969 1721 4571 5109 3195 -329 -3723 -5474 -4821 -1969 1776 4503 4921 2919 -522 -3845 -5506 -4654 -1676 2057 4687 5036 3068 -415 -3721 -5323 -4408 -1430 2169 4614 4882 2788 -695 -3915 -5313 -4337 -1396 2132 4519 4702 2544 -905 -3866 -5124 -3993 -988 2586 4865 4841 2573 -877 -3859 -5050 -3949 -902 2556 4668 4510 2223 -1141 -4108 -5170 -3808 -703 2720 4719 4553 2271 -1131 -3972 -4907 -3489 -390 2919 4890 4537 2088 -1385 -4154 -4934 -3447 -337 2949 4792 4325 1743 -1562 -4181 -4856 -3273 -33 3316 5041 4439 1923 -1424 -3959 -4570 -2910 317 3423 4907 4088 1355 -2054 -4624 -5056 -3187 140 3307 4809 4030 1323 -2069 -4432 -4695 -2724 597 3694 5114 4179 1360 -1966 -4229 -4478 -2602 675 3715 5019 3932 1027 -2281 -4537 -4753 -2714 656 3687 4919 3859 1085 -2127 -4312 -4403 -2332 965 3786 4910 3750 882 -2391 -4437 -4402 -2254 933 3703 4646 3397 396 -2761 -4724 -4539 -2305 980 3754 4756 3469 590 -2468 -4317 -4120 -1871 1389 4050 4788 3321 318 -2715 -4503 -4201 -1837 1438 4025 4685 3201 220 -2892 -4629 -4167 -1665 1653 4171 4763 3180 93 -2975 -4602 -4015 -1499 1777 4212 4668 2927 -195 -3214 -4712 -4027 -1443 1877 4278 4609 2759 -451 -3440 -4853 -4093 -1385 1983 4334 4570 2726 -405 -3326 -4680 -3794 -1068 2210 4410 4547 2595 -554 -3460 -4715 -3725 -987 2203 4300 4352 2317 -875 -3669 -4760 -3687 -941 2237 4312 4330 2291 -778 -3453 -4486 -3475 -775 2271 4218 4105 1969 -1070 -3682 -4656 -3518 -661 2424 4262 4018 1854 -1197 -3718 -4505 -3141 -252 2809 4564 4264 2067 -1039 -3611 -4369 -3028 -201 2761 4427 4040 1772 -1318 -3740 -4352 -2907 -52 2939 4553 4008 1657 -1414 -3784 -4364 -2858 71 3089 4629 4098 1794 -1219 -3535 -4025 -2500 373 3224 4571 3896 1487 -1553 -3828 -4269 -2661 281 3126 4547 3891 1552 -1413 -3640 -3989 -2363 529 3341 4719 4010 1545 -1452 -3640 -3988 -2305 653 3467 4729 3866 1292 -1740 -3849 -4091 -2325 671 3436 4602 3716 1219 -1733 -3760 -3867 -1994 1031 3708 4758 3730 1100 -1925 -3891 -3898 -1938 1044 3640 4625 3557 921 -2020 -3859 -3776 -1813 1116 3687 4617 3465 815 -2079 -3828 -3713 -1708 1263 3759 4544 3307 641 -2169 -3855 -3674 -1608 1362 3750 4410 3090 425 -2383 -4022 -3725 -1533 1491 3835 4488 3167 390 -2378 -3928 -3509 -1257 1728 4013 4573 3123 286 -2473 -3894 -3404 -1080 1884 4078 4466 2853 -5 -2678 -4035 -3440 -1097 1857 3996 4295 2678 -137 -2821 -4118 -3421 -983 1959 4054 4283 2648 -196 -2873 -4054 -3273 -751 2161 4159 4334 2556 -320 -2965 -4064 -3201 -743 2176 4144 4225 2424 -491 -2999 -4011 -3065 -524 2366 4218 4166 2266 -527 -3007 -3950 -2995 -441 2446 4186 4011 2055 -793 -3221 -4122 -3048 -497 2269 3910 3759 1847 -951 -3318 -4032 -2861 -261 2461 4044 3777 1764 -1048 -3282 -3888 -2595 8 2720 4200 3747 1609 -1195 -3413 -4006 -2727 -94 2586 4001 3501 1396 -1321 -3396 -3835 -2456 164 2756 3984 3385 1253 -1458 -3540 -3889 -2427 161 2654 3835 3194 978 -1743 -3638 -3838 -2295 322 2819 3964 3211 939 -1698 -3550 -3689 -2147 446 2883 3884 3016 726 -1901 -3667 -3765 -2123 530 2870 3745 2848 568 -2028 -3721 -3652 -1884 743 3014 3804 2827 478 -2144 -3779 -3686 -1910 685 2910 3669 2636 249 -2295 -3828 -3676 -1867 787 3011 3681 2564 169 -2269 -3684 -3424 -1508 1109 3282 3789 2575 134 -2334 -3779 -3482 -1543 1073 3099 3608 2339 -127 -2620 -3944 -3519 -1525 1092 3151 3535 2273 -193 -2580 -3787 -3318 -1296 1326 3309 3652 2234 -256 -2634 -3888 -3409 -1348 1282 3204 3491 2125 -346 -2666 -3811 -3204 -1114 1441 3253 3462 2008 -432 -2714 -3692 -3007 -861 1662 3399 3499 1940 -547 -2821 -3765 -2983 -854 1648 3346 3394 1743 -761 -2958 -3849 -3087 -822 1676 3304 3282 1636 -822 -2963 -3772 -2878 -644 1835 3375 3296 1599 -831 -2924 -3667 -2702 -446 1998 3489 3307 1604 -885 -2949 -3667 -2658 -408 1984 3421 3207 1407 -1005 -3028 -3592 -2493 -223 2183 3519 3168 1323 -1124 -3078 -3621 -2468 -157 2191 3465 3090 1216 -1211 -3123 -3584 -2390 -106 2201 3424 2983 1031 -1414 -3236 -3594 -2278 52 2393 3518 2982 1026 -1372 -3185 -3492 -2174 217 2481 3558 2990 999 -1399 -3104 -3323 -1944 391 2603 3528 2824 765 -1645 -3338 -3516 -2118 259 2439 3404 2700 654 -1716 -3375 -3479 -1952 439 2602 3455 2704 617 -1772 -3360 -3404 -1901 493 2585 3413 2571 442 -1901 -3413 -3358 -1742 676 2719 3458 2583 442 -1862 -3275 -3184 -1514 848 2836 3482 2495 313 -1981 -3404 -3224 -1543 771 2719 3268 2198 22 -2217 -3523 -3218 -1457 934 2870 3380 2242 59 -2137 -3336 -3000 -1255 1077 2880 3290 2110 -83 -2249 -3472 -3087 -1267 1111 2885 3257 2040 -176 -2349 -3455 -3004 -1129 1255 3036 3316 2039 -227 -2339 -3367 -2824 -929 1423 3077 3287 1959 -317 -2425 -3404 -2826 -843 1430 3068 3162 1762 -476 -2500 -3382 -2659 -727 1562 3083 3145 1742 -512 -2522 -3314 -2559 -602 1664 3136 3073 1555 -715 -2690 -3413 -2556 -503 1757 3190 3055 1450 -804 -2731 -3387 -2464 -390 1826 3150 2944 1301 -988 -2887 -3487 -2491 -402 1808 3073 2807 1145 -1095 -2921 -3406 -2352 -208 1950 3141 2802 1072 -1204 -2977 -3394 -2252 -139 2044 3163 2751 988 -1284 -2999 -3350 -2217 -88 2015 3102 2629 783 -1424 -3044 -3346 -2157 -30 2050 2988 2449 636 -1582 -3178 -3411 -2135 33 2055 3016 2424 588 -1604 -3153 -3331 -2032 105 2123 3004 2344 451 -1704 -3204 -3309 -1933 240 2208 3055 2334 446 -1723 -3175 -3231 -1818 359 2308 3090 2346 386 -1787 -3260 -3265 -1820 356 2266 2999 2193 254 -1933 -3348 -3302 -1774 369 2222 2917 2042 49 -2030 -3348 -3221 -1676 551 2424 2995 2054 59 -2069 -3306 -3095 -1494 698 2522 3017 1974 -76 -2184 -3380 -3114 -1440 812 2568 3072 2033 -28 -2128 -3285 -2956 -1228 978 2724 3102 2010 -72 -2132 -3243 -2871 -1197 1016 2712 3029 1879 -193 -2206 -3229 -2775 -1056 1151 2797 3009 1818 -259 -2251 -3228 -2729 -924 1199 2758 2960 1718 -366 -2324 -3206 -2607 -812 1346 2836 2951 1687 -417 -2296 -3068 -2403 -625 1489 2924 2973 1616 -495 -2352 -3067 -2391 -554 1545 2861 2807 1397 -666 -2452 -3170 -2430 -598 1455 2785 2736 1312 -666 -2441 -3082 -2300 -371 1625 2866 2787 1319 -715 -2419 -3014 -2215 -357 1630 2768 2593 1134 -895 -2544 -3051 -2178 -300 1721 2892 2634 1145 -873 -2515 -2951 -2057 -198 1786 2807 2505 988 -1041 -2620 -2987 -2040 -173 1787 2775 2424 878 -1146 -2653 -2960 -1923 -22 1884 2870 2447 839 -1131 -2622 -2897 -1799 150 2027 2955 2466 880 -1138 -2624 -2885 -1730 215 2008 2792 2244 532 -1406 -2788 -2907 -1703 271 2074 2865 2293 571 -1377 -2724 -2844 -1597 359 2159 2905 2247 524 -1426 -2756 -2770 -1526 385 2118 2799 2111 366 -1521 -2792 -2805 -1494 476 2227 2856 2176 419 -1497 -2702 -2664 -1365 576 2242 2846 2050 288 -1597 -2805 -2685 -1346 610 2278 2780 1937 101 -1784 -2922 -2737 -1321 656 2274 2778 1906 101 -1762 -2860 -2610 -1156 798 2368 2831 1903 113 -1745 -2832 -2569 -1114 817 2385 2771 1847 64 -1781 -2734 -2446 -980 972 2488 2827 1830 -37 -1804 -2773 -2381 -854 1075 2529 2805 1762 -115 -1871 -2814 -2424 -863 995 2388 2588 1572 -262 -1977 -2756 -2281 -768 1187 2551 2702 1616 -217 -1921 -2693 -2156 -525 1368 2688 2802 1681 -176 -1843 -2583 -2054 -486 1362 2622 2668 1482 -310 -1964 -2658 -2030 -407 1440 2632 2615 1414 -419 -1998 -2603 -1949 -308 1501 2646 2553 1251 -544 -2111 -2641 -1891 -203 1606 2693 2558 1221 -636 -2152 -2639 -1867 -169 1662 2737 2547 1212 -588 -2088 -2498 -1655 66 1843 2843 2575 1178 -659 -2118 -2500 -1614 84 1874 2810 2476 1056 -807 -2218 -2522 -1633 91 1833 2736 2359 912 -917 -2295 -2539 -1521 210 1962 2793 2374 877 -956 -2273 -2486 -1486 273 1960 2763 2318 846 -924 -2200 -2364 -1294 463 2123 2812 2301 746 -1033 -2281 -2395 -1277 478 2088 2770 2203 668 -1089 -2273 -2325 -1138 593 2156 2782 2140 586 -1177 -2335 -2295 -1131 673 2266 2788 2115 527 -1240 -2337 -2291 -1065 714 2232 2751 2049 415 -1301 -2344 -2203 -912 893 2398 2875 2103 441 -1287 -2285 -2145 -860 919 2373 2787 1955 291 -1384 -2390 -2218 -926 895 2315 2670 1786 118 -1521 -2456 -2156 -763 1043 2485 2775 1905 215 -1428 -2301 -1988 -605 1143 2486 2773 1811 106 -1504 -2330 -1949 -517 1224 2539 2766 1765 -1 -1609 -2354 -1901 -485 1265 2576 2702 1630 -103 -1664 -2429 -1998 -532 1202 2383 2439 1382 -313 -1859 -2522 -1972 -449 1268 2454 2522 1407 -266 -1801 -2391 -1793 -269 1458 2597 2563 1399 -335 -1806 -2393 -1781 -264 1457 2571 2525 1296 -424 -1881 -2419 -1738 -169 1570 2620 2485 1246 -483 -1893 -2373 -1645 -76 1594 2564 2400 1128 -595 -2039 -2476 -1670 -79 1582 2556 2366 1092 -661 -2010 -2352 -1514 42 1745 2668 2398 1085 -602 -1954 -2271 -1428 161 1794 2649 2296 1000 -680 -1991 -2286 -1416 208 1781 2580 2232 882 -783 -2025 -2223 -1270 357 1925 2659 2237 856 -861 -2084 -2254 -1331 264 1833 2527 2105 724 -924 -2098 -2169 -1211 463 2013 2658 2137 717 -951 -2037 -2125 -1067 580 2088 2704 2156 712 -922 -1998 -2030 -975 687 2101 2625 2033 553 -1068 -2105 -2113 -992 614 2054 2544 1925 393 -1209 -2193 -2120 -978 659 2095 2553 1852 371 -1175 -2167 -2055 -907 712 2117 2532 1833 351 -1221 -2191 -2064 -904 722 2089 2497 1755 251 -1306 -2191 -1996 -809 793 2079 2441 1687 159 -1350 -2232 -1959 -717 875 2159 2439 1591 74 -1423 -2210 -1928 -710 904 2117 2327 1511 0 -1455 -2184 -1832 -544 1070 2242 2419 1545 6 -1440 -2161 -1769 -468 1124 2271 2393 1463 -93 -1541 -2206 -1748 -459 1145 2278 2366 1367 -193 -1575 -2225 -1774 -398 1206 2305 2327 1348 -193 -1597 -2240 -1767 -379 1195 2225 2232 1192 -351 -1692 -2218 -1655 -300 1255 2262 2245 1173 -381 -1740 -2223 -1589 -193 1358 2339 2254 1162 -359 -1698 -2137 -1513 -130 1419 2361 2208 1099 -480 -1771 -2242 -1558 -110 1399 2259 2096 965 -566 -1838 -2200 -1501 -69 1440 2279 2064 956 -566 -1796 -2127 -1367 47 1509 2339 2071 854 -666 -1862 -2105 -1321 125 1599 2378 2079 834 -676 -1816 -2062 -1279 167 1625 2349 1998 792 -726 -1860 -2055 -1178 296 1692 2369 1979 714 -802 -1893 -2084 -1211 261 1664 2237 1779 464 -1005 -2033 -2147 -1245 259 1594 2166 1720 434 -1065 -2061 -2095 -1133 371 1750 2251 1742 417 -1055 -2010 -2003 -1033 476 1747 2210 1621 274 -1178 -2098 -2074 -1051 405 1660 2091 1502 145 -1277 -2162 -2062 -1043 446 1704 2091 1430 117 -1302 -2130 -2008 -924 534 1752 2081 1391 6 -1401 -2186 -2016 -924 551 1669 1938 1233 -144 -1443 -2208 -1949 -810 656 1764 2040 1273 -74 -1399 -2100 -1818 -690 741 1816 2006 1199 -137 -1418 -2110 -1808 -673 737 1740 1866 1055 -293 -1597 -2213 -1793 -644 736 1752 1869 1050 -301 -1584 -2159 -1776 -568 810 1796 1871 1005 -364 -1608 -2164 -1706 -534 843 1798 1833 919 -422 -1660 -2137 -1655 -454 917 1830 1784 866 -449 -1647 -2147 -1604 -424 965 1801 1743 821 -566 -1743 -2128 -1562 -305 1000 1820 1704 753 -619 -1781 -2127 -1565 -334 1000 1874 1733 710 -631 -1726 -2074 -1487 -225 1072 1849 1676 690 -670 -1771 -2072 -1409 -150 1134 1842 1630 622 -744 -1801 -2088 -1375 -118 1112 1793 1572 517 -861 -1860 -2061 -1360 -125 1153 1801 1499 435 -863 -1843 -2011 -1287 -15 1250 1871 1496 419 -888 -1866 -2020 -1263 25 1240 1801 1457 354 -941 -1864 -1971 -1153 123 1290 1808 1416 300 -992 -1882 -1974 -1136 101 1265 1735 1287 169 -1145 -2027 -2006 -1172 88 1243 1709 1223 74 -1185 -2022 -1994 -1090 201 1290 1665 1151 -5 -1270 -2037 -1964 -1029 254 1341 1723 1148 -30 -1243 -1998 -1893 -990 313 1404 1692 1116 -88 -1318 -2061 -1901 -966 335 1372 1657 1007 -184 -1409 -2127 -1972 -1012 273 1297 1553 922 -283 -1502 -2195 -1944 -924 359 1353 1581 934 -257 -1472 -2069 -1782 -743 544 1508 1721 1005 -239 -1430 -2013 -1728 -726 568 1513 1687 946 -274 -1453 -2000 -1706 -615 656 1560 1662 916 -303 -1462 -2018 -1660 -619 641 1506 1558 765 -459 -1584 -2078 -1667 -602 614 1463 1504 707 -507 -1609 -2050 -1591 -502 732 1547 1574 746 -434 -1467 -1896 -1414 -320 873 1638 1558 717 -546 -1572 -1920 -1423 -303 914 1626 1499 622 -576 -1601 -1947 -1440 -315 878 1564 1413 497 -700 -1630 -1901 -1340 -235 943 1635 1450 505 -673 -1626 -1838 -1268 -117 1063 1699 1487 566 -598 -1531 -1754 -1133 6 1155 1725 1477 520 -692 -1577 -1721 -1087 50 1187 1782 1497 541 -634 -1526 -1698 -1005 122 1201 1737 1426 424 -741 -1599 -1704 -1051 98 1219 1728 1363 347 -795 -1614 -1650 -910 278 1353 1830 1470 405 -761 -1553 -1575 -782 407 1414 1867 1394 356 -827 -1587 -1589 -810 320 1326 1735 1304 232 -916 -1650 -1601 -790 378 1401 1748 1262 196 -924 -1606 -1538 -720 463 1453 1774 1262 215 -880 -1591 -1465 -619 542 1487 1760 1224 169 -924 -1567 -1379 -486 658 1604 1874 1328 256 -834 -1433 -1297 -476 680 1601 1816 1236 149 -922 -1492 -1307 -434 705 1579 1733 1136 59 -1005 -1540 -1331 -395 756 1616 1789 1146 67 -944 -1440 -1162 -234 897 1698 1796 1162 54 -965 -1433 -1126 -196 909 1742 1826 1116 39 -951 -1385 -1117 -179 985 1740 1777 1100 -3 -973 -1397 -1065 -139 965 1709 1708 1009 -83 -1061 -1492 -1114 -176 914 1630 1640 902 -188 -1100 -1497 -1082 -135 948 1676 1636 887 -137 -1063 -1382 -966 10 1061 1728 1681 890 -196 -1095 -1360 -888 52 1082 1706 1594 775 -300 -1194 -1472 -994 -25 1014 1628 1484 690 -420 -1262 -1480 -1007 -10 1063 1653 1467 631 -413 -1268 -1460 -951 27 1033 1557 1336 508 -544 -1350 -1552 -999 1 1027 1506 1307 486 -568 -1367 -1492 -904 123 1082 1574 1307 437 -602 -1372 -1474 -880 135 1083 1518 1204 320 -717 -1489 -1574 -980 22 965 1401 1092 188 -858 -1536 -1564 -893 120 1029 1372 1038 173 -824 -1484 -1470 -809 225 1095 1435 1063 156 -851 -1492 -1482 -804 189 1075 1357 992 79 -941 -1541 -1513 -817 186 1038 1329 909 -1 -951 -1550 -1487 -776 242 1068 1319 907 -37 -970 -1562 -1433 -703 281 1111 1338 877 -22 -994 -1547 -1382 -646 359 1158 1375 877 -39 -917 -1424 -1279 -513 488 1246 1396 895 -42 -944 -1430 -1251 -444 493 1180 1296 748 -193 -1056 -1523 -1294 -507 471 1189 1294 754 -176 -1068 -1426 -1178 -354 617 1314 1423 832 -137 -1029 -1413 -1138 -379 566 1257 1306 693 -251 -1112 -1494 -1204 -366 595 1224 1217 608 -351 -1167 -1513 -1184 -340 595 1201 1206 551 -368 -1260 -1558 -1240 -403 519 1117 1089 435 -536 -1324 -1623 -1250 -366 575 1173 1122 468 -466 -1309 -1516 -1111 -244 680 1257 1162 486 -441 -1211 -1443 -1011 -161 763 1258 1160 463 -481 -1258 -1414 -955 -105 773 1243 1104 435 -491 -1216 -1382 -949 -118 800 1263 1089 332 -585 -1250 -1363 -926 -47 832 1262 1027 296 -598 -1258 -1368 -829 54 919 1299 1085 378 -515 -1153 -1219 -703 189 997 1391 1145 393 -517 -1141 -1201 -678 213 1036 1363 1104 303 -605 -1216 -1279 -683 193 983 1304 1011 249 -641 -1223 -1251 -646 245 1046 1299 1002 205 -671 -1216 -1173 -554 354 1136 1397 1043 225 -659 -1189 -1133 -498 368 1139 1391 1004 178 -646 -1160 -1056 -478 432 1160 1401 978 161 -653 -1138 -1089 -420 459 1139 1341 927 115 -695 -1170 -1038 -381 468 1148 1316 893 61 -744 -1201 -1061 -376 503 1173 1341 899 49 -731 -1155 -1000 -312 536 1168 1335 853 27 -754 -1167 -983 -279 575 1219 1297 797 -8 -790 -1145 -931 -234 617 1223 1245 737 -89 -863 -1195 -949 -218 617 1167 1202 693 -183 -895 -1216 -951 -220 629 1172 1199 664 -128 -836 -1134 -844 -108 731 1265 1229 659 -157 -860 -1119 -809 -91 734 1240 1178 595 -229 -975 -1194 -870 -111 678 1150 1136 537 -283 -943 -1165 -800 -71 766 1226 1106 520 -271 -924 -1129 -800 -49 785 1221 1072 476 -361 -980 -1162 -753 1 768 1204 1063 415 -364 -994 -1122 -678 83 868 1268 1109 498 -329 -938 -1039 -631 137 880 1234 1009 354 -422 -1041 -1109 -663 72 832 1182 994 335 -478 -1029 -1136 -649 152 885 1234 1004 320 -471 -999 -1044 -539 247 926 1272 1070 373 -381 -939 -987 -490 256 966 1294 1007 305 -461 -972 -963 -469 278 966 1228 927 218 -529 -1044 -1041 -517 264 924 1143 853 105 -632 -1104 -1048 -507 313 943 1143 788 98 -670 -1100 -1019 -429 339 968 1141 822 117 -603 -1002 -907 -334 454 1050 1195 795 96 -612 -1014 -934 -369 412 983 1073 680 -47 -759 -1153 -1021 -419 335 919 1053 697 -15 -724 -1067 -916 -332 420 966 1055 659 -67 -734 -1106 -917 -349 385 929 1034 600 -96 -734 -1029 -885 -217 513 1060 1082 676 -40 -698 -1005 -785 -193 580 1063 1097 670 -45 -707 -1005 -787 -178 512 1029 1016 505 -217 -829 -1094 -827 -196 517 949 944 480 -229 -836 -1041 -753 -135 602 1100 1068 615 -83 -695 -948 -644 27 710 1133 1073 549 -179 -793 -1005 -736 -71 617 1044 990 463 -266 -831 -1017 -680 -45 658 1063 978 430 -245 -815 -944 -624 42 707 1034 910 376 -327 -880 -1014 -653 -55 636 966 812 290 -393 -917 -1022 -612 61 698 1034 902 327 -386 -912 -1005 -598 44 673 1002 838 261 -464 -944 -1053 -661 27 676 949 739 130 -537 -1031 -1097 -687 -18 653 922 690 113 -547 -1036 -1033 -597 105 719 983 751 149 -536 -978 -983 -546 125 737 949 681 79 -573 -1005 -1002 -559 108 720 895 648 28 -653 -1050 -1011 -524 137 681 834 536 -93 -754 -1160 -1085 -624 79 603 758 463 -184 -829 -1189 -1080 -563 79 631 788 434 -178 -809 -1129 -965 -454 201 724 861 497 -139 -724 -1082 -980 -405 227 729 804 430 -206 -814 -1158 -992 -439 218 683 751 351 -264 -890 -1177 -988 -449 159 661 726 356 -295 -904 -1131 -936 -415 242 697 707 301 -307 -870 -1106 -926 -337 296 739 739 356 -300 -829 -1053 -814 -212 407 821 839 378 -268 -829 -1026 -814 -232 361 749 744 274 -366 -910 -1090 -814 -254 347 751 676 184 -402 -924 -1077 -785 -189 419 763 683 240 -354 -885 -1017 -707 -117 481 812 722 290 -296 -793 -919 -590 -15 576 897 805 322 -312 -809 -890 -598 -64 544 839 715 242 -385 -836 -895 -592 10 602 878 765 291 -315 -731 -815 -454 123 707 955 826 300 -291 -717 -775 -434 139 710 973 788 254 -347 -732 -765 -391 189 714 961 776 249 -330 -707 -709 -332 230 736 941 736 196 -398 -783 -805 -408 195 663 838 632 94 -490 -849 -815 -435 162 648 822 607 83 -481 -826 -768 -320 259 731 873 649 135 -429 -734 -664 -247 335 802 921 629 89 -463 -753 -681 -300 247 693 792 513 -27 -566 -838 -714 -315 271 697 798 493 -22 -564 -860 -707 -245 281 722 819 541 -13 -505 -734 -617 -195 390 814 858 539 11 -520 -739 -607 -149 449 815 848 497 -45 -510 -790 -605 -171 369 775 780 461 -103 -603 -809 -639 -189 329 693 687 354 -183 -671 -843 -654 -193 368 739 770 376 -149 -575 -761 -578 -93 452 839 804 403 -134 -568 -726 -508 -45 498 778 773 371 -161 -625 -766 -530 -57 485 824 731 378 -179 -598 -727 -532 -25 502 773 698 291 -212 -670 -790 -546 -83 420 712 608 218 -293 -703 -787 -524 -49 471 739 649 274 -249 -661 -739 -452 57 532 810 710 274 -234 -619 -698 -413 61 558 758 602 169 -351 -732 -798 -517 -28 435 653 493 52 -408 -810 -817 -490 20 525 719 532 89 -407 -780 -804 -474 1 463 656 466 40 -463 -785 -809 -459 22 452 642 493 13 -435 -754 -717 -366 113 541 714 471 33 -456 -773 -748 -429 61 495 625 420 -15 -502 -838 -751 -402 106 500 610 395 -37 -510 -787 -739 -342 157 549 646 427 -20 -463 -734 -670 -290 208 608 709 452 -20 -469 -724 -666 -273 218 622 648 390 -44 -495).
! !

!TrashCanMorph classSide methodsFor: 'as yet unclassified' stamp: 'jm 5/16/1998 11:01'!
samplesForMouseEnter

	^ #(-37 -24 -30 -30 -25 -23 -11 -8 -38 -40 -34 -21 -18 -27 -34 -20 2 11 8 10 5 7 10 14 34 28 34 54 59 47 54 25 27 43 33 48 23 40 59 63 47 46 27 47 43 41 46 50 64 57 46 57 44 48 12 17 24 28 18 23 27 -7 -17 2 4 1 -4 18 12 11 34 25 43 18 11 20 43 43 11 12 31 -5 -11 -43 -41 -17 -23 -28 -38 -33 -48 -64 -61 -53 -61 -54 -56 -73 -73 -48 -48 -63 -92 -102 -90 -92 -115 -93 -90 -109 -120 -112 -119 -141 -136 -128 -146 -143 -141 -129 -118 -139 -132 -120 -103 -100 -96 -79 -71 -83 -79 -77 -87 -73 -73 -43 -24 -5 -10 20 23 -5 -4 0 28 20 -11 20 4 -11 -23 20 27 7 8 -2 -7 -15 -27 4 0 -8 -34 -31 -38 -34 -50 -40 -64 -46 -59 -51 -82 -80 -82 -80 -89 -95 -122 -89 -97 -67 -64 -31 -21 -34 -56 -25 -35 -48 -63 -37 -54 -34 8 40 82 161 306 503 921 1638 2549 3458 4074 4290 3947 2988 1528 -293 -2417 -4592 -6693 -8734 -10727 -12641 -14255 -15466 -16249 -16383 -15965 -15159 -14019 -12574 -10934 -9124 -7214 -5191 -3092 -856 1418 3639 5667 7543 9156 10532 11608 12361 12795 12922 12755 12307 11574 10473 8964 7129 5084 2911 596 -1773 -4103 -6374 -8593 -10593 -12355 -13748 -14599 -14866 -14527 -13593 -12109 -10146 -7697 -4933 -2022 881 3689 6302 8638 10580 12067 13052 13602 13774 13543 13046 12276 11271 9965 8426 6677 4771 2731 607 -1469 -3420 -5217 -6790 -8196 -9401 -10377 -11001 -11242 -11095 -10600 -9729 -8581 -7114 -5423 -3563 -1566 488 2577 4556 6448 8234 9786 11143 12136 12756 13034 12936 12489 11744 10678 9320 7673 5775 3813 1813 -182 -2113 -3924 -5606 -7123 -8439 -9477 -10213 -10688 -10855 -10663 -10109 -9278 -8125 -6682 -5004 -3147 -1171 791 2762 4655 6386 7944 9222 10201 10800 11120 11163 10885 10313 9434 8363 7050 5604 4048 2395 711 -872 -2376 -3707 -4894 -5875 -6667 -7214 -7489 -7480 -7251 -6739 -6039 -5102 -3987 -2754 -1475 -207 1094 2392 3590 4686 5639 6469 7178 7758 8142 8273 8187 7883 7398 6803 6056 5188 4152 3075 1968 866 -184 -1197 -2143 -2964 -3615 -4163 -4572 -4907 -5100 -5141 -5018 -4723 -4288 -3725 -3031 -2198 -1246 -276 704 1661 2529 3377 4140 4835 5333 5721 5941 6098 6048 5846 5498 5047 4467 3816 3131 2444 1659 856 57 -636 -1301 -1946 -2549 -3099 -3548 -3871 -4057 -4143 -4153 -3999 -3753 -3380 -2893 -2338 -1742 -1098 -391 380 1111 1822 2543 3206 3784 4283 4638 4868 4955 4894 4713 4385 3938 3365 2679 1910 1089 272 -564 -1379 -2145 -2902 -3583 -4127 -4562 -4866 -5010 -4949 -4785 -4468 -4026 -3463 -2817 -2070 -1256 -398 462 1297 2147 2922 3613 4211 4732 5178 5449 5617 5608 5456 5168 4727 4120 3404 2561 1646 706 -218 -1212 -2160 -3018 -3688 -4293 -4726 -5015 -5195 -5231 -5096 -4788 -4321 -3754 -3057 -2240 -1363 -433 515 1446 2340 3118 3820 4401 4851 5133 5256 5195 5011 4696 4209 3627 2934 2168 1334 434 -475 -1357 -2211 -2981 -3669 -4285 -4771 -5116 -5322 -5382 -5315 -5067 -4701 -4169 -3518 -2775 -1937 -1036 -165 735 1626 2440 3115 3681 4154 4467 4625 4681 4589 4344 4008 3583 3008 2353 1615 777 -57 -872 -1713 -2486 -3206 -3843 -4391 -4840 -5116 -5273 -5277 -5128 -4831 -4418 -3868 -3252 -2533 -1744 -898 -67 780 1570 2300 2913 3463 3874 4159 4331 4353 4248 4028 3668 3184 2633 1949 1216 426 -341 -1109 -1852 -2512 -3102 -3597 -3983 -4224 -4349 -4339 -4183 -3910 -3520 -3065 -2510 -1885 -1242 -588 54 685 1249 1839 2352 2777 3106 3327 3466 3488 3417 3234 2948 2617 2185 1671 1117 564 -15 -608 -1174 -1700 -2196 -2650 -3039 -3296 -3481 -3587 -3568 -3460 -3273 -2983 -2614 -2156 -1658 -1154 -626 -89 421 921 1413 1865 2266 2602 2818 3004 3090 3036 2944 2824 2565 2214 1837 1422 954 469 -15 -490 -960 -1413 -1806 -2139 -2421 -2703 -2877 -2949 -2974 -2964 -2820 -2608 -2340 -1972 -1592 -1154 -680 -190 267 745 1183 1592 1947 2225 2473 2624 2696 2723 2692 2565 2408 2219 1916 1579 1200 797 368 -115 -549 -994 -1408 -1767 -2037 -2241 -2394 -2469 -2497 -2427 -2317 -2150 -1887 -1551 -1197 -778 -346 103 544 942 1390 1766 2077 2353 2535 2657 2697 2700 2615 2473 2257 1980 1677 1287 871 466 21 -377 -757 -1134 -1464 -1713 -1932 -2096 -2208 -2243 -2235 -2168 -2051 -1854 -1566 -1229 -888 -499 -100 319 719 1124 1481 1801 2084 2306 2434 2469 2476 2431 2287 2101 1825 1527 1194 836 483 123 -231 -593 -931 -1251 -1541 -1796 -1978 -2122 -2188 -2162 -2106 -1903 -1717 -1467 -1140 -814 -463 -115 254 617 950 1284 1550 1753 1880 1992 1988 1930 1829 1695 1475 1226 924 603 293 -27 -345 -640 -954 -1217 -1471 -1687 -1832 -1917 -1985 -1960 -1900 -1750 -1546 -1356 -1092 -771 -469 -135 200 555 895 1176 1429 1628 1786 1920 1968 1966 1924 1842 1704 1464 1200 922 600 285 -21 -348 -614 -840 -1073 -1266 -1397 -1501 -1595 -1635 -1638 -1585 -1464 -1311 -1151 -971 -735 -501 -267 -43 210 398 643 865 1050 1206 1333 1419 1418 1410 1383 1281 1147 996 803 621 437 226 23 -148 -309 -466 -611 -748 -849 -912 -964 -1016 -1039 -1032 -990 -868 -757 -621 -440 -256 -118 43 194 354 470 564 653 718 780 809 793 748 672 587 453 321 151 8 -142 -308 -499 -647 -819 -950 -1073 -1169 -1243 -1276 -1282 -1262 -1219 -1140 -1016 -921 -809 -624 -475 -335 -142 25 182 339 483 613 702 796 856 899 898 902 858 826 735 656 529 395 263 146 -14 -167 -346 -480 -633 -715 -806 -878 -955 -958 -978 -930 -891 -794 -705 -616 -477 -336 -243 -112 4 109 205 276 332 430 480 519 508 521 513 518 463 384 319 227 112 -8 -100 -202 -348 -505 -596 -725 -833 -906 -951 -940 -927 -883 -806 -692 -542 -365 -207 -60 80 249 400 483 584 626 650 657 634 585 493 443 351 238 158 63 -30 -123 -185 -279 -359 -400 -470 -529 -570 -561 -594 -601 -588 -570 -524 -477 -414 -328 -236 -141 -37 48 99 204 287 391 441 472 495 516 476 418 371 292 204 99 -10 -43 -118 -207 -253 -303 -341 -349 -359 -342 -338 -305 -264 -227 -164 -119 -46 38 99 138 174 227 234 215 231 262 234 227 237 273 218 198 192 192 135 119 90 44 -27 -40 -73 -99 -132 -149 -154 -128 -92 -46 -23 38 59 59 51 57 50 28 17 37 -10 2 -4 -40 -71 -96 -126 -142 -194 -227 -274 -300 -345 -362 -369 -357 -345 -335 -303 -256 -223 -191 -141 -116 -71 -80 -96 -74 -86 -120 -141 -181 -249 -315 -372 -388 -397 -430 -449 -460 -462 -417 -391 -357 -299 -253 -175 -119 -34 43 128 198 241 282 357 410 436 444 472 473 441 413 358 260 191 96 -12 -74 -164 -270 -346 -437 -513 -594 -652 -704 -728 -750 -735 -668 -626 -544 -456 -341 -244 -138 -34 89 195 293 381 459 476 549 597 600 620 601 572 532 475 417 351 233 135 63 -44 -142 -230 -295 -385 -405 -450 -472 -492 -463 -482 -477 -460 -440 -393 -339 -326 -257 -190 -126 -35 63 146 201 283 355 393 401 427 441 411 382 335 282 241 200 133 90 30 -8 -64 -116 -142 -175 -213 -223 -244 -274 -280 -272 -280 -264 -241 -262 -249 -228 -211 -156 -128 -64 -21 43 80 129 142 187 215 227 230 237 243 254 266 267 273 256 254 251 253 236 208 164 128 69 54 30 -18 -69 -86 -106 -143 -167 -188 -218 -246 -247 -233 -220 -169 -138 -95 -44 -23 18 69 116 188 236 298 380 440 503 516 538 544 516 485 475 427 374 310 292 220 109 57 5 -100 -184 -276 -362 -436 -480 -512 -539 -531 -524 -511 -452 -371 -302 -260 -169 -95 -46 59 156 208 262 336 397 421 436 441 427 427 414 368 332 298 237 197 145 93 46 0 -48 -89 -112 -138 -132 -118 -73 -23 0).
! !

!TrashCanMorph classSide methodsFor: 'as yet unclassified' stamp: 'jm 5/16/1998 10:58'!
samplesForMouseLeave

	^ #(230 254 256 242 234 246 206 211 179 175 133 111 106 91 46 53 35 54 17 40 67 98 79 114 127 167 162 133 130 119 91 82 98 90 75 87 45 19 -17 1 -16 -1 8 12 -1 53 71 85 109 117 106 159 138 154 133 161 122 138 85 72 67 51 46 20 6 3 -8 8 -8 -4 -1 22 38 53 43 85 71 103 88 87 45 51 43 59 16 -9 -17 1 -45 -20 -32 -8 -38 3 -20 20 43 53 43 37 24 54 30 58 59 32 20 33 17 8 -30 -56 -72 -111 -133 -127 -122 -111 -129 -111 -108 -112 -108 -111 -135 -100 -130 -111 -158 -125 -121 -104 -96 -111 -135 -106 -111 -104 -133 -111 -143 -137 -140 -130 -109 -103 -119 -62 -59 -67 -62 -33 -41 -12 -43 -46 -43 -38 -71 -87 -100 -80 -125 -124 -145 -132 -145 -111 -148 -106 -95 -79 -51 -14 -17 8 22 85 93 111 116 127 138 133 96 67 53 72 45 -22 -30 -20 -33 16 27 121 177 335 500 756 1023 1362 1738 2131 2465 2769 2932 3032 2951 2609 1980 1102 -43 -1326 -2769 -4181 -5598 -6852 -7906 -8630 -9014 -8982 -8390 -7257 -5645 -3637 -1415 1029 3476 5953 8267 10196 11595 12386 12531 12089 10938 9187 6826 4120 1124 -1933 -4946 -7699 -10138 -12005 -13244 -13719 -13418 -12384 -10706 -8485 -5808 -2796 421 3640 6629 9344 11524 13121 14054 14261 13735 12528 10643 8209 5307 2125 -1265 -4592 -7693 -10426 -12683 -14290 -15200 -15273 -14514 -12881 -10583 -7628 -4171 -448 3303 6911 10154 12921 14914 16133 16383 15750 14259 12040 9164 5772 2083 -1721 -5395 -8751 -11629 -13799 -15261 -15758 -15399 -14104 -11989 -9176 -5801 -2022 1844 5593 9006 11905 14064 15405 15842 15387 13957 11834 9005 5754 2215 -1402 -4888 -8044 -10744 -12739 -14054 -14519 -14216 -13070 -11186 -8680 -5729 -2501 789 4023 6924 9450 11320 12489 12920 12629 11614 9949 7764 5214 2411 -495 -3327 -5845 -8006 -9690 -10820 -11288 -11133 -10271 -8914 -6992 -4820 -2357 174 2643 4910 6853 8361 9360 9729 9537 8811 7573 5908 3939 1799 -448 -2695 -4641 -6343 -7628 -8525 -8926 -8785 -8177 -7118 -5640 -3861 -1943 43 2047 3813 5332 6502 7292 7601 7455 6837 5872 4578 3054 1305 -482 -2228 -3781 -5133 -6187 -6850 -7136 -7039 -6529 -5688 -4489 -3071 -1489 109 1726 3166 4447 5398 6034 6235 6151 5651 4847 3747 2483 997 -464 -1915 -3221 -4323 -5159 -5708 -5929 -5812 -5328 -4601 -3635 -2478 -1165 75 1324 2432 3366 4011 4423 4557 4439 3961 3326 2470 1494 422 -616 -1596 -2506 -3267 -3797 -4124 -4258 -4142 -3740 -3235 -2527 -1702 -832 43 919 1718 2391 2820 3151 3276 3206 2988 2569 1983 1321 587 -125 -837 -1516 -2112 -2554 -2854 -2951 -2883 -2669 -2285 -1771 -1186 -539 119 779 1363 1889 2223 2457 2528 2451 2177 1776 1271 681 88 -500 -1079 -1592 -2009 -2283 -2420 -2354 -2230 -1904 -1460 -942 -385 198 766 1263 1660 1967 2138 2185 2094 1889 1518 1102 577 56 -463 -971 -1423 -1799 -2070 -2222 -2244 -2112 -1910 -1554 -1166 -679 -162 353 797 1195 1505 1733 1844 1863 1696 1489 1144 731 267 -201 -706 -1157 -1525 -1834 -2036 -2089 -2033 -1893 -1644 -1281 -865 -367 85 572 968 1342 1591 1783 1812 1699 1481 1186 811 413 -66 -534 -965 -1333 -1699 -1920 -2046 -2022 -1964 -1721 -1410 -989 -505 -14 471 929 1337 1673 1863 1989 1993 1854 1634 1318 898 477 -50 -484 -940 -1320 -1657 -1852 -1978 -1928 -1778 -1531 -1199 -785 -316 174 634 1092 1470 1789 2022 2107 2081 1999 1715 1374 939 488 -27 -493 -953 -1326 -1644 -1880 -1997 -1960 -1875 -1639 -1345 -927 -511 -85 342 834 1202 1570 1801 1938 1989 1893 1721 1436 1068 663 216 -185 -632 -1040 -1384 -1625 -1783 -1857 -1836 -1659 -1466 -1131 -748 -359 46 476 852 1200 1445 1600 1678 1710 1544 1297 1003 676 246 -175 -621 -990 -1353 -1628 -1855 -1947 -1965 -1851 -1639 -1341 -973 -524 -106 376 776 1160 1492 1715 1815 1838 1738 1589 1279 979 559 106 -285 -731 -1128 -1450 -1731 -1922 -2001 -2005 -1863 -1636 -1316 -948 -545 -137 306 755 1126 1466 1717 1893 1955 1915 1760 1531 1190 844 384 -61 -511 -921 -1299 -1584 -1773 -1889 -1880 -1730 -1520 -1152 -716 -256 156 622 1057 1437 1709 1873 1925 1902 1718 1431 1103 706 272 -164 -563 -915 -1224 -1450 -1592 -1642 -1596 -1441 -1194 -879 -527 -133 274 705 1015 1294 1515 1610 1671 1592 1412 1195 876 556 214 -153 -495 -800 -1037 -1189 -1307 -1308 -1260 -1087 -879 -626 -335 8 321 651 900 1137 1299 1402 1387 1341 1165 950 689 388 50 -266 -572 -823 -1028 -1203 -1287 -1265 -1197 -1052 -847 -539 -253 72 411 708 976 1236 1404 1470 1433 1350 1181 965 679 366 71 -217 -547 -789 -971 -1039 -1082 -1008 -884 -726 -476 -185 104 403 697 939 1097 1232 1247 1257 1124 955 756 534 224 -38 -332 -537 -731 -889 -981 -992 -937 -839 -747 -547 -324 -111 116 343 547 724 847 924 910 902 777 676 482 301 85 -104 -272 -445 -597 -702 -779 -782 -800 -766 -653 -500 -390 -187 -59 114 259 417 508 603 643 676 626 572 463 366 200 54 -119 -237 -398 -501 -637 -698 -731 -722 -714 -624 -519 -369 -246 -82 54 248 372 492 540 592 589 526 426 358 211 56 -90 -206 -372 -476 -592 -640 -666 -661 -598 -487 -367 -211 -66 151 290 430 526 663 695 753 719 724 629 563 430 300 153 20 -85 -158 -251 -296 -309 -301 -269 -217 -153 -51 33 151 230 345 429 495 527 558 568 572 508 421 321 240 111 43 -114 -175 -232 -267 -288 -305 -300 -214 -180 -79 4 104 206 324 403 511 555 580 585 618 563 498 458 382 308 279 198 148 108 95 51 51 50 66 91 104 116 162 183 214 195 253 261 274 279 267 266 285 266 285 254 258 254 243 269 235 180 175 154 179 159 119 164 216 227 274 314 371 398 461 495 532 509 485 498 401 325 271 164 100 -27 -116 -166 -204 -230 -227 -222 -166 -106 -4 127 258 364 485 577 663 708 753 743 718 608 547 440 298 188 75 -71 -153 -204 -227 -246 -208 -198 -140 -85 43 137 254 343 438 524 593 610 631 605 572 511 456 338 250 154 62 -17 -33 -103 -77 -114 -69 -38 59 117 193 288 369 390 429 438 456 408 353 303 235 140 80 -29 -95 -164 -192 -208 -185 -166 -119 -58 95 198 288 371 488 519 563 598 582 547 482 387 277 112 4 -132 -179 -319 -376 -447 -416 -416 -382 -298 -169 -80 69 211 364 490 624 718 774 789 811 768 721 601 509 384 271 154 33 -95 -138 -216 -259 -253 -237 -198 -171 -109 -22 56 167 264 374 450 530 551 584 595 553 500 458 348 275 146 51 -62 -166 -201 -254 -295 -266 -253 -164 -137 -59 11 98 214 343 403 514 550 603 632 593 543 509 405 337 196 111 17 -61 -146 -188 -242 -229 -224 -201 -187 -129 -104 -37 77 112 166 237 275 311 292 292 290 235 162 111 43 4 -59 -72 -124 -140 -140 -117 -108 -61 -24 56 109 158 169 240 264 284 292 275 266 256 185 124 109 64 1 -41 -72 -87 -80 -77 -46 -35 -11 41 43 56 69 101 116 119 133 108 51 56 53 59 9 43 32 67 95 104 109 150 167 171 183 204 213 190 171 172 122 130 98 95 30 16 -20 -46 -88 -83 -74 -56 -19 33 85 119 201 272 279 319 342 364 369 376 335 325 282 213 158 108 8 -30 -116 -130 -169 -182 -164 -140 -137 -82 -54 32 116 175 225 284 317 379 369 377 342 314).
! !

!TrashCanMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 12:41'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

!TrashCanMorph methodsFor: 'layout' stamp: 'wiz 8/2/2005 22:46'!
acceptDroppingMorph: aMorph event: evt 
	Preferences soundsEnabled
		ifTrue: [Preferences preserveTrash
				ifTrue: [self class playDeleteSound]
				ifFalse: [self playSoundNamed: 'scratch']].
	evt hand visible: true.
	self state: #off.
	aMorph delete.
	aMorph == Utilities scrapsBook
		ifFalse: [Utilities addToTrash: aMorph removeHalo]! !

!TrashCanMorph methodsFor: 'event handling' stamp: 'ar 12/11/2000 12:14'!
doubleClick: evt
	| palette |
	palette := self standardPalette.
	((palette notNil and: [palette isInWorld]) and: [palette hasScrapsTab])
		ifTrue:
			[palette showScrapsTab]
		ifFalse:
			[self world openScrapsBook: evt].! !

!TrashCanMorph methodsFor: 'private' stamp: 'sw 8/22/1998 22:44'!
findActivePaintBox
	"If painting, return the active PaintBoxMorph. If not painting, or if the paint box cannot be found, return nil."

	| w m |
	w := self world.
	w ifNil: [^ nil].
	(w findA: SketchEditorMorph) ifNil: [^ nil].  "not painting"
	(m := w findA: PaintBoxMorph) ifNotNil: [^ m].
	^ nil
! !

!TrashCanMorph methodsFor: 'event handling' stamp: 'ar 10/6/2000 00:17'!
handlesMouseDown: evt

	^ self inPartsBin not! !

!TrashCanMorph methodsFor: 'event handling' stamp: 'di 7/3/1998 13:33'!
handlesMouseOver: evt

	^ self inPartsBin not
! !

!TrashCanMorph methodsFor: 'event handling' stamp: 'di 9/14/1998 07:51'!
handlesMouseOverDragging: evt

	^ self inPartsBin not
! !

!TrashCanMorph methodsFor: 'initialization' stamp: 'dgd 9/19/2003 10:51'!
initialize
	"Initialize the receiver's graphics, name, and balloon-help"

	super initialize.
	self image: TrashPicOn;
		offImage: TrashPic;
		pressedImage: TrashPicOn.
	self setNameTo: 'Trash' translated.
	self setBalloonText:
'To remove an object, drop it on any trash can. To view, and maybe retrieve, items that have been thrown away, double-click on any trash-can.  Things are retained in the trash-can if the "preserveTrash" preference is set, otherwise they are purged immediately' translated.
! !

!TrashCanMorph methodsFor: 'parts bin' stamp: 'sw 8/12/2001 18:09'!
initializeToStandAlone
	"Bypass ImageMorph's intervention"

	self initialize! !

!TrashCanMorph methodsFor: 'event handling' stamp: 'ar 12/11/2000 12:02'!
mouseDown: evt
	| paintBox |
	evt hand visible: true.
	"See if a stamp is being dropped into the trash. It is not held by the hand."
	(paintBox := self findActivePaintBox) ifNotNil: [
		paintBox getSpecial == #stamp: ifTrue: [
			paintBox deleteCurrentStamp: evt.  "throw away stamp..."
			self primaryHand showTemporaryCursor: nil.
			^ self]].	  "... and don't open trash"
	evt hand waitForClicksOrDrag: self event: evt.
! !

!TrashCanMorph methodsFor: 'event handling' stamp: 'wiz 8/2/2005 22:53'!
mouseEnter: event 
	"Present feedback for potential deletion."
	| hand firstSub |
	hand := event hand.
	((hand submorphCount > 0
				and: [(firstSub := hand submorphs first) ~~ self])
			and: [self wantsDroppedMorph: firstSub event: event])
		ifTrue: [Preferences soundsEnabled
				ifTrue: [self class playMouseEnterSound].
			"hand visible: false." "This leads to confusion. Let morph and hand appear til dropped."
			"self world abandonAllHalos."
			"hand halo: nil."
			self state: #pressed]
		ifFalse: [self showStampIn: hand]! !

!TrashCanMorph methodsFor: 'event handling' stamp: 'di 9/14/1998 08:08'!
mouseEnterDragging: evt
	"Test button state elsewhere if at all"
	^ self mouseEnter: evt! !

!TrashCanMorph methodsFor: 'event handling' stamp: 'ar 10/5/2000 16:18'!
mouseLeave: event
	"Present feedback for aborted deletion."
	| hand |
	hand := event hand.
	((hand submorphCount > 0) and:
	 [hand submorphs first ~~ self])
		ifTrue:
			[Preferences soundsEnabled ifTrue: [self class playMouseLeaveSound].
			hand visible: true.
			self state: #off]
		ifFalse:
			[self stopShowingStampIn: hand].
! !

!TrashCanMorph methodsFor: 'event handling' stamp: 'di 9/14/1998 08:08'!
mouseLeaveDragging: evt
	"Test button state elsewhere if at all"
	^ self mouseLeave: evt! !

!TrashCanMorph methodsFor: 'event handling' stamp: 'ar 12/11/2000 12:13'!
mouseMove: evt
	| hand firstSub |
	hand := evt hand.
	(((hand submorphCount > 0) and: [(firstSub := hand submorphs first) ~~ self]) and:
			[self wantsDroppedMorph: firstSub event: evt])
		ifTrue: 
			[super mouseMove: evt]
! !

!TrashCanMorph methodsFor: 'event handling' stamp: 'jm 5/22/1998 10:35'!
mouseUp: evt
	"Close the lid when you're through!!"

	self state: #off.
! !

!TrashCanMorph methodsFor: 'printing' stamp: 'sw 9/14/1998 12:02'!
printOn: aStream
	aStream nextPutAll: 'a TrashCanMorph'! !

!TrashCanMorph methodsFor: 'private' stamp: 'jm 5/22/1998 10:13'!
showStampIn: aHand
	"If painting and in stamp mode, show the stamp that is about to be thrown away."

	| paintBox curs |
	paintBox := self findActivePaintBox.
	paintBox ifNotNil: [
		"See if a stamp is being dropped into the trash. It is not actually held by the hand."
		paintBox getSpecial == #stamp: ifTrue: [
			curs := paintBox actionCursor.
			aHand showTemporaryCursor: curs hotSpotOffset: curs center]].
! !

!TrashCanMorph methodsFor: 'event handling' stamp: 'ar 12/11/2000 12:08'!
startDrag: evt
	evt hand grabMorph: self.! !

!TrashCanMorph methodsFor: 'private' stamp: 'jm 5/22/1998 10:16'!
stopShowingStampIn: aHand
	"Revert to the normal cursor."

	aHand showTemporaryCursor: nil.
! !

!TrashCanMorph methodsFor: 'dropping/grabbing' stamp: 'sw 8/15/2000 17:03'!
wantsDroppedMorph: aMorph event: evt

	^ ((aMorph ~~ self) and: [aMorph ~~ Utilities scrapsBook]) and:
		[aMorph willingToBeDiscarded]! !

Morph subclass: #BackgroundMorph
	instanceVariableNames: 'image offset delta running'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!BackgroundMorph commentStamp: '<historical>' prior: 0!
This morph incorporates tiling and regular motion with the intent of supporting, eg, panning of endless (toroidal) backgrounds.

The idea is that embedded morphs get displayed at a moving offset relative to my position.  Moreover this display is tiled according to the bounding box of the submorphs (subBounds), as much as necesary to fill the rest of my bounds.!

!BackgroundMorph classSide methodsFor: 'as yet unclassified' stamp: 'kfr 8/7/2004 16:10'!
test
	"BackgroundMorph test"
	^(BackgroundMorph new addMorph: (ImageMorph new image: Form fromUser))openInWorld.! !

!BackgroundMorph methodsFor: 'menus' stamp: 'dgd 8/30/2003 20:56'!
addCustomMenuItems: aCustomMenu hand: aHandMorph 
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	running
		ifTrue: [aCustomMenu add: 'stop' translated action: #stopRunning]
		ifFalse: [aCustomMenu add: 'start' translated action: #startRunning]! !

!BackgroundMorph methodsFor: 'accessing' stamp: 'fc 7/24/2004 12:23'!
delta
	^delta! !

!BackgroundMorph methodsFor: 'accessing' stamp: 'fc 7/24/2004 12:24'!
delta: aPoint

	delta := aPoint.! !

!BackgroundMorph methodsFor: 'drawing' stamp: 'ar 6/17/1999 01:06'!
drawOn: aCanvas
	"The tiling is solely determined by bounds, subBounds and offset.
	The extent of display is determined by bounds and the clipRect of the canvas."
	| start d subBnds |
	submorphs isEmpty ifTrue: [^ super drawOn: aCanvas].
	subBnds := self subBounds.
	running ifFalse:
		[super drawOn: aCanvas.
		^ aCanvas fillRectangle: subBnds color: Color lightBlue].
	start := subBnds topLeft + offset - bounds topLeft - (1@1) \\ subBnds extent - subBnds extent + (1@1).
	d := subBnds topLeft - bounds topLeft.
"Sensor redButtonPressed ifTrue: [self halt]."
	start x to: bounds width - 1 by: subBnds width do:
		[:x |
		start y to: bounds height - 1 by: subBnds height do:
			[:y | aCanvas translateBy: (x@y) - d clippingTo: bounds
				during:[:tileCanvas| self drawSubmorphsOn: tileCanvas]]].! !

!BackgroundMorph methodsFor: 'layout' stamp: ''!
fullBounds
	^ self bounds! !

!BackgroundMorph methodsFor: 'drawing' stamp: 'ar 12/30/2001 19:16'!
fullDrawOn: aCanvas
	(aCanvas isVisible: self fullBounds) ifFalse:[^self].
	running ifFalse: [
		^aCanvas clipBy: (bounds translateBy: aCanvas origin)
				during:[:clippedCanvas| super fullDrawOn: clippedCanvas]].
	(aCanvas isVisible: self bounds) ifTrue:[aCanvas drawMorph: self].
! !

!BackgroundMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:43'!
initialize
	"initialize the state of the receiver"
	super initialize.
""
	offset := 0 @ 0.
	delta := 1 @ 0.
	running := true! !

!BackgroundMorph methodsFor: 'layout' stamp: ''!
layoutChanged
	"Do nothing, since I clip my submorphs"! !

!BackgroundMorph methodsFor: 'accessing' stamp: 'fc 7/24/2004 13:50'!
offset
	^offset! !

!BackgroundMorph methodsFor: 'accessing' stamp: 'fc 7/24/2004 13:50'!
offset: aPoint
	offset := aPoint! !

!BackgroundMorph methodsFor: 'accessing' stamp: ''!
slideBy: inc
	submorphs isEmpty ifTrue: [^ self].
	offset := offset + inc \\ self subBounds extent.
	self changed! !

!BackgroundMorph methodsFor: 'accessing' stamp: ''!
startRunning
	running := true.
	self changed! !

!BackgroundMorph methodsFor: 'stepping and presenter' stamp: 'fc 7/24/2004 13:47'!
step
	
	running ifTrue: [self slideBy: delta]! !

!BackgroundMorph methodsFor: 'testing' stamp: ''!
stepTime
	"Answer the desired time between steps in milliseconds."

	^ 20! !

!BackgroundMorph methodsFor: 'accessing' stamp: ''!
stopRunning
	running := false.
	self changed! !

!BackgroundMorph methodsFor: 'accessing' stamp: 'aoy 2/17/2003 01:20'!
subBounds
	"calculate the submorph bounds"

	| subBounds |
	subBounds := nil.
	self submorphsDo: 
			[:m | 
			subBounds := subBounds isNil
						ifTrue: [m fullBounds]
						ifFalse: [subBounds merge: m fullBounds]].
	^subBounds! !

Morph subclass: #BouncingAtomsMorph
	instanceVariableNames: 'damageReported infectionHistory transmitInfection recentTemperatures temperature'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!BouncingAtomsMorph commentStamp: '<historical>' prior: 0!
This morph shows how an ideal gas simulation might work. When it gets step messages, it makes all its atom submorphs move along their velocity vectors, bouncing when they hit a wall. It also exercises the Morphic damage reporting and display architecture. Here are some things to try:

  1. Resize this morph as the atoms bounce around.
  2. In an inspector on this morph, evaluate "self addAtoms: 10."
  3. Try setting quickRedraw to false in invalidRect:. This gives the
     default damage reporting and incremental redraw. Try it for
     100 atoms.
  4. In the drawOn: method of AtomMorph, change drawAsRect to true.
  5. Create a HeaterCoolerMorph and embed it in the simulation. Extract
	it and use an inspector on it to evaluate "self velocityDelta: -5", then
     re-embed it. Note the effect on atoms passing over it.
!

!BouncingAtomsMorph classSide methodsFor: 'parts bin' stamp: 'sw 8/2/2001 01:21'!
descriptionForPartsBin
	^ self partName:	'BouncingAtoms'
		categories:		#('Demo')
		documentation:	'The original, intensively-optimized bouncing-atoms simulation by John Maloney'! !

!BouncingAtomsMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/10/2003 12:57'!
initialize

	self registerInFlapsRegistry.	! !

!BouncingAtomsMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/10/2003 12:58'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(BouncingAtomsMorph	new	'Bouncing Atoms'	'Atoms, mate')
						forFlapNamed: 'Widgets']! !

!BouncingAtomsMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 12:32'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

!BouncingAtomsMorph methodsFor: 'other' stamp: 'jm 6/28/1998 18:10'!
addAtoms: n
	"Add a bunch of new atoms."

	| a |
	n timesRepeat: [
		a := AtomMorph new.
		a randomPositionIn: bounds maxVelocity: 10.
		self addMorph: a].
	self stopStepping.
! !

!BouncingAtomsMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 21:15'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'startInfection' translated action: #startInfection.
	aCustomMenu add: 'set atom count' translated action: #setAtomCount.
	aCustomMenu add: 'show infection history' translated action: #showInfectionHistory:.
! !

!BouncingAtomsMorph methodsFor: 'submorphs-add/remove' stamp: ''!
addMorphFront: aMorph
	"Called by the 'embed' meta action. We want non-atoms to go to the back."
	"Note: A user would not be expected to write this method. However, a sufficiently advanced user (e.g, an e-toy author) might do something equivalent by overridding the drag-n-drop messages when they are implemented."

	(aMorph isMemberOf: AtomMorph)
		ifTrue: [super addMorphFront: aMorph]
		ifFalse: [super addMorphBack: aMorph].! !

!BouncingAtomsMorph methodsFor: 'drawing' stamp: 'di 1/4/1999 20:22'!
areasRemainingToFill: aRectangle
	color isTranslucent
		ifTrue: [^ Array with: aRectangle]
		ifFalse: [^ aRectangle areasOutside: self bounds]! !

!BouncingAtomsMorph methodsFor: 'other' stamp: 'aoy 2/15/2003 21:38'!
collisionPairs
	"Return a list of pairs of colliding atoms, which are assumed to be
circles of known radius. This version uses the morph's positions--i.e.
the top-left of their bounds rectangles--rather than their centers."

	| count sortedAtoms radius twoRadii radiiSquared collisions p1 continue j p2 distSquared m1 m2 |
	count := submorphs size.
	sortedAtoms := submorphs 
				asSortedCollection: [:mt1 :mt2 | mt1 position x < mt2 position x].
	radius := 8.
	twoRadii := 2 * radius.
	radiiSquared := radius squared * 2.
	collisions := OrderedCollection new.
	1 to: count - 1
		do: 
			[:i | 
			m1 := sortedAtoms at: i.
			p1 := m1 position.
			continue := (j := i + 1) <= count.
			[continue] whileTrue: 
					[m2 := sortedAtoms at: j.
					p2 := m2 position.
					continue := p2 x - p1 x <= twoRadii  
								ifTrue: 
									[distSquared := (p1 x - p2 x) squared + (p1 y - p2 y) squared.
									distSquared < radiiSquared 
										ifTrue: [collisions add: (Array with: m1 with: m2)].
									(j := j + 1) <= count]
								ifFalse: [false]]].
	^collisions! !

!BouncingAtomsMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:14'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color
		r: 0.8
		g: 1.0
		b: 0.8! !

!BouncingAtomsMorph methodsFor: 'drawing' stamp: ''!
drawOn: aCanvas
	"Clear the damageReported flag when redrawn."

	super drawOn: aCanvas.
	damageReported := false.! !

!BouncingAtomsMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:14'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	damageReported := false.
	self extent: 400 @ 250.

	infectionHistory := OrderedCollection new.
	transmitInfection := false.
	self addAtoms: 30! !

!BouncingAtomsMorph methodsFor: 'initialization' stamp: 'ar 8/13/2003 11:41'!
intoWorld: aWorld
	"Make sure report damage at least once"
	damageReported := false.
	super intoWorld: aWorld.! !

!BouncingAtomsMorph methodsFor: 'change reporting' stamp: 'ar 11/12/2000 18:42'!
invalidRect: damageRect from: aMorph
	"Try setting 'quickRedraw' to true. This invalidates the entire morph, whose bounds typically subsume all it's submorphs. (However, this code checks that assumption and passes through any damage reports for out-of-bounds submorphs. Note that atoms with super-high velocities do occaisionally shoot through the walls!!) An additional optimization is to only submit only damage report per display cycle by using the damageReported flag, which is reset to false when the morph is drawn."

	| quickRedraw |
	quickRedraw := true.  "false gives the original invalidRect: behavior"
	(quickRedraw and:
	 [(bounds origin <= damageRect topLeft) and:
	 [damageRect bottomRight <= bounds corner]]) ifTrue: [
		"can use quick redraw if damage is within my bounds"
		damageReported ifFalse: [super invalidRect: bounds from: self].  "just report once"
		damageReported := true.
	] ifFalse: [super invalidRect: damageRect from: aMorph].  "ordinary damage report"! !

!BouncingAtomsMorph methodsFor: 'menu' stamp: 'jm 6/28/1998 18:04'!
setAtomCount

	| countString count |
	countString := FillInTheBlank
		request: 'Number of atoms?'
		initialAnswer: self submorphCount printString.
	countString isEmpty ifTrue: [^ self].
	count := Integer readFrom: (ReadStream on: countString).
	self removeAllMorphs.
	self addAtoms: count.
! !

!BouncingAtomsMorph methodsFor: 'other' stamp: 'jm 6/28/1998 18:31'!
showInfectionHistory: evt
	"Place a graph of the infection history in the world."

	| graph |
	infectionHistory isEmpty ifTrue: [^ self].
	graph := GraphMorph new data: infectionHistory.
	graph extent: ((infectionHistory size + (2 * graph borderWidth) + 5)@(infectionHistory last max: 50)).
	evt hand attachMorph: graph.
! !

!BouncingAtomsMorph methodsFor: 'menu' stamp: ''!
startInfection

	self submorphsDo: [:m | m infected: false].
	self firstSubmorph infected: true.
	infectionHistory := OrderedCollection new: 500.
	transmitInfection := true.
	self startStepping.
! !

!BouncingAtomsMorph methodsFor: 'stepping and presenter' stamp: 'sw 7/15/1999 07:32'!
step
	"Bounce those atoms!!"

	| r bounces |
	super step.
	bounces := 0.
	r := bounds origin corner: (bounds corner - (8@8)).
	self submorphsDo: [ :m |
		(m isMemberOf: AtomMorph) ifTrue: [
			(m bounceIn: r) ifTrue: [bounces := bounces + 1]]].
	"compute a 'temperature' that is proportional to the number of bounces
	 divided by the circumference of the enclosing rectangle"
	self updateTemperature: (10000.0 * bounces) / (r width + r height).
	transmitInfection ifTrue: [self transmitInfection].
! !

!BouncingAtomsMorph methodsFor: 'testing' stamp: 'jm 6/28/1998 18:10'!
stepTime
	"As fast as possible."

	^ 0
! !

!BouncingAtomsMorph methodsFor: 'other' stamp: 'jm 6/28/1998 18:20'!
transmitInfection

	| infected count |
	self collisionPairs do: [:pair |
		infected := false.
		pair do: [:atom | atom infected ifTrue: [infected := true]].
		infected
			ifTrue: [pair do: [:atom | atom infected: true]]].

	count := 0.
	self submorphsDo: [:m | m infected ifTrue: [count := count + 1]].
	infectionHistory addLast: count.
	count = submorphs size ifTrue: [
		transmitInfection := false.
		self stopStepping].
! !

!BouncingAtomsMorph methodsFor: 'other' stamp: 'dgd 2/22/2003 13:36'!
updateTemperature: currentTemperature 
	"Record the current temperature, which is taken to be the number of atoms that have bounced in the last cycle. To avoid too much jitter in the reading, the last several readings are averaged."

	recentTemperatures isNil 
		ifTrue: 
			[recentTemperatures := OrderedCollection new.
			20 timesRepeat: [recentTemperatures add: 0]].
	recentTemperatures removeLast.
	recentTemperatures addFirst: currentTemperature.
	temperature := recentTemperatures sum asFloat / recentTemperatures size! !

Morph subclass: #CachingMorph
	instanceVariableNames: 'damageRecorder cacheCanvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Kernel'!

!CachingMorph commentStamp: '<historical>' prior: 0!
This morph can be used to cache the picture of a morph that takes a long time to draw. It should be used with judgement, however, since heavy use of caching can consume large amounts of memory.!

!CachingMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:24'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color veryLightGray! !

!CachingMorph methodsFor: 'drawing' stamp: ''!
drawOn: aCanvas

	submorphs isEmpty ifTrue: [^ super drawOn: aCanvas].
! !

!CachingMorph methodsFor: 'drawing' stamp: 'ar 12/30/2001 19:14'!
fullDrawOn: aCanvas
	(aCanvas isVisible: self fullBounds) ifFalse:[^self].
	self updateCacheCanvas: aCanvas.
	aCanvas cache: self fullBounds
			using: cacheCanvas form
			during:[:cachingCanvas| super fullDrawOn: cachingCanvas].
! !

!CachingMorph methodsFor: 'drawing' stamp: 'ar 5/28/2000 17:12'!
imageForm

	self updateCacheCanvas: Display getCanvas.
	^ cacheCanvas form offset: self fullBounds topLeft
! !

!CachingMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:48'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	damageRecorder := DamageRecorder new! !

!CachingMorph methodsFor: 'change reporting' stamp: 'ar 11/12/2000 18:43'!
invalidRect: damageRect from: aMorph
	"Record the given rectangle in the damage list."
	damageRecorder recordInvalidRect: (damageRect translateBy: self fullBounds origin negated).
	super invalidRect: damageRect from: aMorph! !

!CachingMorph methodsFor: 'caching' stamp: 'jm 11/13/97 16:31'!
releaseCachedState

	super releaseCachedState.
	cacheCanvas := nil.
! !

!CachingMorph methodsFor: 'as yet unclassified' stamp: 'dgd 2/21/2003 23:03'!
updateCacheCanvas: aCanvas 
	"Update the cached image of the morphs being held by this hand."

	| myBnds rectList |
	myBnds := self fullBounds.
	(cacheCanvas isNil or: [cacheCanvas extent ~= myBnds extent]) 
		ifTrue: 
			[cacheCanvas := (aCanvas allocateForm: myBnds extent) getCanvas.
			cacheCanvas translateBy: myBnds origin negated
				during: [:tempCanvas | super fullDrawOn: tempCanvas].
			^self].

	"incrementally update the cache canvas"
	rectList := damageRecorder 
				invalidRectsFullBounds: (0 @ 0 extent: myBnds extent).
	damageRecorder reset.
	rectList do: 
			[:r | 
			cacheCanvas 
				translateTo: myBnds origin negated
				clippingTo: r
				during: 
					[:c | 
					c fillColor: Color transparent.	"clear to transparent"
					super fullDrawOn: c]]! !

Morph subclass: #LedCharacterMorph
	instanceVariableNames: 'char highlighted'
	classVariableNames: 'BSegments CHSegmentOrigins CHSegments CVSegmentOrigins CVSegments DSegments TSegments'
	poolDictionaries: ''
	category: 'MorphicExtras-Leds'!

!LedCharacterMorph commentStamp: '<historical>' prior: 0!
char 36 is SPACE!

!LedCharacterMorph class methodsFor: 'new-morph participation' stamp: 'kfr 5/26/2000 19:03'!
includeInNewMorphMenu

	^false! !

!LedCharacterMorph class methodsFor: 'class initialization' stamp: 'kfr 6/3/2000 21:32'!
initialize

	CHSegmentOrigins := {0.2@0.1. 0.2@0.45. 0.2@0.8}.
	CVSegmentOrigins := {0.1@0.2. 0.1@0.55. 0.8@0.2. 0.8@0.55}.
	TSegments := { 0.25@0.25. 0.45@0.25. 0.55@0.25. 0.75@0.25. 0.25@0.6. 0.45@0.6. 0.55@0.6. 0.75@0.6. }.
	BSegments := { 0.45@0.4. 0.25@0.4. 0.75@0.4. 0.55@0.4. 0.45@0.76. 0.25@0.76. 0.75@0.76. 0.55@0.76. }.

	DSegments  := {
	{false. false. false. false. false. false. false. false. }."0"
	{false. false. false. false. false. false. false. false. }."1"
	{false. false. false. false. false. false. false. false. }."2"
	{false. false. false. false. false. false. false. false. }."3"
	{false. false. false. false. false. false. false. false. }."4"
	{false. false. false. false. false. false. false. false. }."5"
	{false. false. false. false. false. false. false. false. }."6"
	{false. false. false. false. false. false. false. false. }."7"
	{false. false. false. false. false. false. false. false. }."8"
	{false. false. false. false. false. false. false. false. }."9"
	{false. false. false. false. false. false. false. false. }."A"
	{false. false. false. false. false. false. false. false. }."B"
	{false. false. false. false. false. false. false. false. }."C"
	{false. false. false. false. false. false. false. false. }."D"
	{false. false. false. false. false. false. false. false. }."E"
	{false. false. false. false. false. false. false. false. }."F"
	{false. false. false. false. false. false. false. false. }."G"
	{false. false. false. false. false. false. false. false. }."H"
	{false. false. false. false. false. false. false. false. }."I"
	{false. false. false. false. false. false. false. false. }."J"
	{false. false. false. true. false. false. false. false. }."K"
	{false. false. false. false. false. false. false. false. }."L"
	{true. false. false. true. false. false. false. false. }."M"
	{true. false. false. false. false. false. true. false. }."N"
	{false. true. true. false. true. false. false. true.  }."O"
	{false. false. false. false. false. false. false. false. }."P"
	{false. false. false. false. false. false. true. false. }."Q"
	{false. false. false. false. false. false. true. false. }."R"
	{false. false. false. false. false. false. false. false. }."S"
	{false. false. false. false. false. false. false. false. }."T"
	{false. false. false. false. false. false. false. false. }."U"
	{false. false. false. false. true. false. false. true. }."V"
	{false. false. false. false. false. true. true. false. }."W"
	{true. false. false. true. false. true. true. false. }."X"
	{false. false. false. false. false. false. false. false. }."Y"
	{false. false. false. true. false. true. false. false. }."Z"
	{false. false. false. false. false. false. false. false. }}."SPACE"

	CHSegments := {
		{true. false. true}."0"
		{false. false. false}."1"
		{true. true. true}."2"
		{true. true. true}."3"
		{false. true. false}."4"
		{true. true. true}."5"
		{true. true. true}."6"
		{true. false. false}."7"
		{true. true. true}."8"
		{true. true. true}."9"
		{true. true. false}."A"
		{true. true. true}."B"
		{true. false. true}."C"
		{true. false. true}."D"
		{true. true. true}."E"
		{true. true. false}."F"
		{true. true. true}."G"
		{false. true. false}."H"
		{false. false. false}."I"
		{false. false. true}."J"
		{false. true. false}."K"
		{false. false. true}."L"
		{false. false. false}."M"
		{false. false. false}."N"
		{false. false. false}."O"
		{true. true. false}."P"
		{true. false. true}."Q"
		{true. true. false}."R"
		{true. true. true}."S"
		{false. true. true}."t"
		{false. false. true}."U"
		{false. false. false}."V"
		{false. false. false}."W"
		{false. false. false}."X"
		{false. true. true}."Y"
		{true. false. true}."Z"
		{false. false. false.}}."SPACE"
	CVSegments := {
		{true. true.  true. true}."0"
		{false. false. true. true}."1"
		{false. true. true. false}."2"
		{false. false. true. true}."3"
		{true. false. true. true}."4"
		{true. false. false. true}."5"
		{true. true. false. true}."6"
		{false. false. true. true}."7"
		{true. true. true. true}."8"
		{true. false. true. true}."9"
		{true. true. true. true}."A"
		{true. true. true. true}."B"
		{true. true. false. false}."C"
		{true. true. true. true}."D"
		{true. true. false. false}."E"
		{true. true. false. false}."F"
		{true. true. false. true}."G"
		{true. true. true. true}."H"
		{true. true. false. false}."I"
		{false. true. true. true}."J"
		{true. true. false. true}."K"
		{true. true. false. false}."L"
		{true. true.  true. true}."N"
		{true. true. true. true}."N"
		{false. false. false. false}."O"
		{true. true. true. false}."P"
		{true. true.  true. true}."q"
		{true. true. true. false}."R"
		{true. false. false. true}."S"
		{true. true. false. false}."t"
		{true. true. true. true}."U"
		{true. false. true. false}."V"
		{true. true.  true. true}."w"
		{false. false. false. false}."x"
		{true. false. true. true}."y"
		{false. false. false. false}."z"
		{false. false. false. false}}."SPACE"! !

!LedCharacterMorph methodsFor: 'accessing' stamp: 'kfr 5/26/2000 20:02'!
char

	 ^ char ! !

!LedCharacterMorph methodsFor: 'accessing' stamp: 'kfr 6/12/2000 15:13'!
char: aCharacter 
	char := aCharacter digitValue.
	char >= 0 & (char <= 35) ifFalse: [char := 36]! !

!LedCharacterMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:27'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color green! !

!LedCharacterMorph methodsFor: 'drawing' stamp: 'kfr 6/3/2000 21:29'!
drawOn: aCanvas 
	| foregroundColor backgroundColor thickness hThickness vThickness hOffset vOffset bOrigin i |
	i := 0.
	foregroundColor := highlighted
				ifTrue: [Color white]
				ifFalse: [color].
	backgroundColor := color darker darker darker.
	hThickness := self height * 0.1.
	vThickness := self width * 0.1.
	thickness := hThickness min: vThickness.
	vOffset := hThickness - thickness // 2 max: 0.
	hOffset := vThickness - thickness // 2 max: 0.
	aCanvas fillRectangle: self bounds color: backgroundColor.
	CHSegmentOrigins with: (CHSegments at: char + 1)
		do: [:o :isLit | aCanvas fillRectangle: (Rectangle origin: (self position + (0 @ vOffset) + (o * self extent)) rounded extent: (self width * 0.6 @ thickness) rounded)
				color: (isLit
						ifTrue: [foregroundColor]
						ifFalse: [backgroundColor])].
	CVSegmentOrigins with: (CVSegments at: char + 1)
		do: [:o :isLit | aCanvas fillRectangle: (Rectangle origin: (self position + (hOffset @ 0) + (o * self extent)) rounded extent: (thickness @ (self height * 0.25)) rounded)
				color: (isLit
						ifTrue: [foregroundColor]
						ifFalse: [backgroundColor])].
	TSegments with: (DSegments at: char + 1)
		do: 
			[:tOrigin :isLit | 
			i := i + 1.
			bOrigin := BSegments at: i.
			aCanvas
				line: self position x - hOffset + (self width * tOrigin x) @ (self position y - vOffset + (self height * tOrigin y))
				to: self position x + hOffset + (self width * bOrigin x) @ (self position y + vOffset + (self height * bOrigin y))
				width: thickness + 1 // 1.25
				color: (isLit
						ifTrue: [foregroundColor]
						ifFalse: [Color transparent])]! !

!LedCharacterMorph methodsFor: 'drawing' stamp: 'kfr 5/26/2000 19:03'!
drawOnFills: aRectangle

	^ true! !

!LedCharacterMorph methodsFor: 'accessing' stamp: 'kfr 5/26/2000 19:03'!
highlighted

	^ highlighted! !

!LedCharacterMorph methodsFor: 'accessing' stamp: 'kfr 5/26/2000 19:03'!
highlighted: aBoolean

	highlighted := aBoolean.
	self changed.! !

!LedCharacterMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:55'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	
	highlighted := false.
	char := 0! !

Morph subclass: #LedDigitMorph
	instanceVariableNames: 'digit highlighted'
	classVariableNames: 'HSegmentOrigins HSegments VSegmentOrigins VSegments'
	poolDictionaries: ''
	category: 'MorphicExtras-Leds'!

!LedDigitMorph commentStamp: '<historical>' prior: 0!
I am a 7-segment LED that can display a decimal digit!

!LedDigitMorph class methodsFor: 'new-morph participation' stamp: 'di 1/16/2000 10:39'!
includeInNewMorphMenu

	^false! !

!LedDigitMorph class methodsFor: 'class initialization' stamp: 'rjf 5/25/2000 00:16'!
initialize

	HSegmentOrigins := {0.2@0.1. 0.2@0.45. 0.2@0.8}.
	VSegmentOrigins := {0.1@0.2. 0.1@0.55. 0.8@0.2. 0.8@0.55}.
	HSegments := {
		{true. false. true}.
		{false. false. false}.
		{true. true. true}.
		{true. true. true}.
		{false. true. false}.
		{true. true. true}.
		{true. true. true}.
		{true. false. false}.
		{true. true. true}.
		{true. true. true}.
		{false. true. false}}.
	VSegments := {
		{true. true. true. true}.
		{false. false. true. true}.
		{false. true. true. false}.
		{false. false. true. true}.
		{true. false. true. true}.
		{true. false. false. true}.
		{true. true. false. true}.
		{false. false. true. true}.
		{true. true. true. true}.
		{true. false. true. true}.
		{false. false. false. false}}.! !

!LedDigitMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:28'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color green! !

!LedDigitMorph methodsFor: 'accessing' stamp: 'tao 5/18/1998 13:00'!
digit

	^ digit! !

!LedDigitMorph methodsFor: 'accessing' stamp: 'tao 5/18/1998 13:00'!
digit: anInteger

	digit := anInteger \\ 10	"make sure it stays between 0 and 9"! !

!LedDigitMorph methodsFor: 'drawing' stamp: 'dew 1/16/2002 20:44'!
drawOn: aCanvas

	| foregroundColor backgroundColor thickness hThickness vThickness hOffset vOffset |
	foregroundColor := highlighted ifTrue: [Color white] ifFalse: [color].
	backgroundColor := color muchDarker.
	hThickness := self height * 0.1.
	vThickness := self width * 0.1.
	thickness := hThickness min: vThickness.
	vOffset := ((hThickness - thickness) // 2) max: 0.
	hOffset := ((vThickness - thickness) // 2) max: 0.
	aCanvas fillRectangle: self bounds color: backgroundColor.
	"added to show the minus sign"
	(digit asString = '-') ifTrue: [digit := 10].
	HSegmentOrigins with: (HSegments at: digit+1) do:
		[:o :isLit |
		aCanvas
			fillRectangle: (Rectangle
				origin: (self position + (0@vOffset) + (o * self extent)) rounded
				extent: ((self width * 0.6) @ thickness) rounded)
			color: (isLit ifTrue: [foregroundColor] ifFalse: [backgroundColor])].
	VSegmentOrigins with: (VSegments at: digit+1) do:
		[:o :isLit |
		aCanvas
			fillRectangle: (Rectangle
				origin: (self position + (hOffset@0) + (o * self extent)) rounded
				extent: (thickness @ (self height * 0.25)) rounded)
			color: (isLit ifTrue: [foregroundColor] ifFalse: [backgroundColor])].
! !

!LedDigitMorph methodsFor: 'drawing' stamp: 'tao 5/18/1998 13:58'!
drawOnFills: aRectangle

	^ true! !

!LedDigitMorph methodsFor: 'accessing' stamp: 'tao 5/18/1998 17:00'!
highlighted

	^ highlighted! !

!LedDigitMorph methodsFor: 'accessing' stamp: 'tao 5/18/1998 18:43'!
highlighted: aBoolean

	highlighted := aBoolean.
	self changed.! !

!LedDigitMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 20:34'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	highlighted := false.
	digit := 0 ! !

Morph subclass: #LedMorph
	instanceVariableNames: 'digits chars value flashing flash string scroller scrollLoop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Leds'!

!LedMorph commentStamp: '<historical>' prior: 0!
I am a collection of LED digits that can display a decimal value.  The display can be set to flash by sending flash: true.

LedMorph can now display characters:

LedMorph new  string:'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'; openInWorld

Lowercase letters will be converted to Uppercase. Carachters not in the examle
above will be shown as SPACE which is char 36 in LedCharacterMorph.

LedMorph new  chars: 10; string:'           I must get a life';flash:true;scrollLoop:true; openInWorld

The number of letters is set by chars. 
If chars is not specified it will be set to the string size. 
When the string size is bigger than chars
the string will scroll across the led. WOW!!
scrollLoop let's you set the scrolling to start over once its finished.

Enjoy.

!

!LedMorph class methodsFor: 'new-morph participation' stamp: 'di 1/16/2000 10:39'!
includeInNewMorphMenu

	^false! !

!LedMorph methodsFor: 'accessing' stamp: 'kfr 5/26/2000 20:16'!
chars

	 ^ chars! !

!LedMorph methodsFor: 'accessing' stamp: 'kfr 6/3/2000 21:27'!
chars: aNumber 
	chars := aNumber.
	self removeAllMorphs.
	1 to: chars do: [:i | self addMorph: (LedCharacterMorph new color: color)].
	self layoutChanged.
	self changed! !

!LedMorph methodsFor: 'accessing' stamp: 'dgd 2/14/2003 22:46'!
color: aColor 
	"set the receiver's color and the submorphs color"
	super color: aColor.
	self
		submorphsDo: [:m | m color: aColor]! !

!LedMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:36'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color green! !

!LedMorph methodsFor: 'accessing' stamp: 'tao 5/18/1998 13:42'!
digits

	^ digits! !

!LedMorph methodsFor: 'accessing' stamp: 'tao 5/18/1998 13:46'!
digits: aNumber

	digits := aNumber.
	self removeAllMorphs.
	1 to: digits do: [:i | self addMorph: (LedDigitMorph new color: color)].
	self layoutChanged.
	self changed.! !

!LedMorph methodsFor: 'drawing' stamp: 'tao 5/18/1998 14:00'!
drawOn: aCanvas

	aCanvas fillRectangle: self bounds color: color darker darker.
! !

!LedMorph methodsFor: 'macpal' stamp: 'tao 5/18/1998 18:26'!
flash

	^ flash! !

!LedMorph methodsFor: 'accessing' stamp: 'tao 5/18/1998 18:26'!
flash: aBoolean

	flash := aBoolean.! !

!LedMorph methodsFor: 'accessing' stamp: 'djp 11/29/1999 17:27'!
highlighted: aBoolean

	self submorphsDo: [:m | m highlighted: aBoolean]! !

!LedMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:36'!
initialize
"initialize the state of the receiver"
	super initialize.
""
	flashing := false.
	flash := false.
	self scrollInit.
	self digits: 2.
	self value: 0! !

!LedMorph methodsFor: 'layout' stamp: 'tao 5/18/1998 13:53'!
layoutChanged

	super layoutChanged.
	submorphs withIndexDo:
		[:m :i |
		m
			position: self position + (((i-1) * self width / digits) rounded @ 0);
			extent: (self width / digits) rounded @ self height]! !

!LedMorph methodsFor: 'initialization' stamp: 'di 3/8/2001 23:44'!
scrollInit

	chars := 0.
	scroller := 1.
	string := ''.
	scrollLoop := false.
! !

!LedMorph methodsFor: 'accessing' stamp: 'kfr 6/1/2000 18:50'!
scrollLoop	

	^ scrollLoop! !

!LedMorph methodsFor: 'accessing' stamp: 'kfr 6/1/2000 18:50'!
scrollLoop: aBoolean

	scrollLoop := aBoolean.! !

!LedMorph methodsFor: 'stepping and presenter' stamp: 'tk 4/19/2001 17:02'!
step
	(flash or: [flashing])
		ifTrue: 
			[flashing := flashing not.
			self highlighted: flashing].
	scroller ifNil: [scroller := 1].
	chars ifNil: [^ self].
	scroller + chars < (string size + 1)
		ifTrue: 
			[scroller := scroller + 1.
			self stringToLed]
		ifFalse: [scrollLoop ifTrue: [scroller := 1]]! !

!LedMorph methodsFor: 'testing' stamp: 'tao 5/18/1998 18:44'!
stepTime

	^ 500! !

!LedMorph methodsFor: 'accessing' stamp: 'kfr 5/26/2000 20:25'!
string

	^ string! !

!LedMorph methodsFor: 'accessing' stamp: 'kfr 6/12/2000 15:29'!
string: aString 
	string := aString.
	chars = 0
		ifTrue: 
			[chars := string size.
			self chars: chars].
	self stringToLed! !

!LedMorph methodsFor: 'accessing' stamp: 'tk 4/19/2001 16:55'!
stringToLed
	| i k actualString |
	i := scroller ifNil: [1].
	k := 1.
	actualString := String new: chars.
	actualString do: 
		[:m | 
		i > string size ifFalse: [actualString at: k put: (string at: i) asUppercase asCharacter].
		i := i + 1.
		k := k + 1].
	i := 1.
	submorphs do: 
		[:m | 
		m char: (actualString at: i).
		i := i + 1].
	self changed! !

!LedMorph methodsFor: 'accessing' stamp: 'tao 5/18/1998 13:42'!
value

	^ value! !

!LedMorph methodsFor: 'accessing' stamp: 'tao 5/18/1998 13:47'!
value: aNumber

	| val |
	value := aNumber.
	val := value.
	submorphs reverseDo:
		[:m |
		m digit: val \\ 10.
		val := val // 10].
	self changed.! !

LedMorph subclass: #LedTimerMorph
	instanceVariableNames: 'counting startSeconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Leds'!

!LedTimerMorph methodsFor: 'accessing' stamp: 'djp 10/31/1999 19:36'!
continue

	counting := true! !

!LedTimerMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:36'!
initialize
"initialize the state of the receiver"
	super initialize.
""
	counting := false.
	startSeconds := Time totalSeconds! !

!LedTimerMorph methodsFor: 'accessing' stamp: 'djp 10/31/1999 21:58'!
pause

	counting ifTrue: [self updateTime].
	counting := false! !

!LedTimerMorph methodsFor: 'accessing' stamp: 'djp 10/23/1999 21:46'!
reset

	startSeconds := Time totalSeconds.
	self value: 0.! !

!LedTimerMorph methodsFor: 'accessing' stamp: 'djp 10/31/1999 19:02'!
resume

	counting ifFalse: [
		counting := true.
		startSeconds :=  (Time totalSeconds) - self value]! !

!LedTimerMorph methodsFor: 'stepping and presenter' stamp: 'djp 10/23/1999 21:35'!
start

	counting := true! !

!LedTimerMorph methodsFor: 'stepping and presenter' stamp: 'djp 10/24/1999 01:12'!
step

	flash
		ifTrue: [super step]
		ifFalse: [
			counting ifTrue: [self updateTime]]! !

!LedTimerMorph methodsFor: 'testing' stamp: 'djp 10/23/1999 21:27'!
stepTime

	^ 1000! !

!LedTimerMorph methodsFor: 'stepping and presenter' stamp: 'djp 10/31/1999 21:44'!
stop

	counting ifTrue: [self updateTime].
	counting := false.! !

!LedTimerMorph methodsFor: 'stepping' stamp: 'djp 10/24/1999 01:12'!
updateTime

	self value:  Time totalSeconds - startSeconds.
	self changed! !

!Morph class methodsFor: '*MorphicExtras-new-morph participation' stamp: 'sw 11/27/2001 13:20'!
addPartsDescriptorQuadsTo: aList if: aBlock
	"For each of the standard objects to be put into parts bins based on declarations in this class, add a parts-launching quintuplet to aList, provided that the boolean-valued-block-with-one-argument supplied evaluates to true when provided the DescriptionForPartsBin"

	| info more |
	(self class includesSelector: #descriptionForPartsBin) ifTrue:
		[info := self descriptionForPartsBin.
		(aBlock value: info) ifTrue:
			[aList add:
				{info globalReceiverSymbol.
				info nativitySelector.
				info formalName.
				info documentation.
				info sampleImageFormOrNil}]].

	(self class includesSelector: #supplementaryPartsDescriptions)
		ifTrue:
			[more := self supplementaryPartsDescriptions.
			(more isKindOf: DescriptionForPartsBin) ifTrue: [more := Array with: more].
				"The above being a mild bit of forgiveness, so that in the usual only-one
				case, the user need not return a collection"
			more do:
				[:aPartsDescription |  (aBlock value: aPartsDescription) ifTrue:
					[aList add:
						{aPartsDescription globalReceiverSymbol.
						aPartsDescription nativitySelector.
						aPartsDescription formalName.
						aPartsDescription documentation.
						aPartsDescription sampleImageFormOrNil}]]]! !

!Morph class methodsFor: '*MorphicExtras-arrow head size' stamp: ''!
defaultArrowheadSize
	
	^ 5 @ 4! !

!Morph class methodsFor: '*MorphicExtras-arrow head size' stamp: ''!
obtainArrowheadFor: aPrompt defaultValue: defaultPoint
	"Allow the user to supply a point to serve as an arrowhead size.  Answer nil if we fail to get a good point"

	| result  |
	result := FillInTheBlank request: aPrompt initialAnswer: defaultPoint asString.
	result isEmptyOrNil ifTrue: [^ nil].
	^ [(Point readFrom: (ReadStream on: result))]
		on: Error do: [:ex |  nil].! !

!Morph class methodsFor: '*MorphicExtras-parts bin' stamp: 'sw 8/12/2001 14:26'!
supplementaryPartsDescriptions
	"Answer a list of DescriptionForPartsBin objects that characterize objects that this class wishes to contribute to Stationery bins *other* than by the standard default #newStandAlone protocol"

	^ {	DescriptionForPartsBin
			formalName: 'Status'
			categoryList: #(Scripting)
			documentation: 'Buttons to run, stop, or single-step scripts'
			globalReceiverSymbol: #ScriptingSystem
			nativitySelector: #scriptControlButtons.
		DescriptionForPartsBin
			formalName: 'Scripting'
			categoryList: #(Scripting)
			documentation: 'A confined place for drawing and scripting, with its own private stop/step/go buttons.'
			globalReceiverSymbol: #ScriptingSystem
			nativitySelector: #newScriptingSpace.
		DescriptionForPartsBin
			formalName: 'Random'
			categoryList: #(Scripting)
			documentation: 'A tile that will produce a random number in a given range'
			globalReceiverSymbol: #RandomNumberTile
			nativitySelector: #new.
		DescriptionForPartsBin
			formalName: 'ButtonDown?'
			categoryList: #(Scripting)
			documentation: 'Tiles for querying whether the mouse button is down'
			globalReceiverSymbol: #ScriptingSystem
			nativitySelector: #anyButtonPressedTiles.
		DescriptionForPartsBin
			formalName: 'ButtonUp?'
			categoryList: #(Scripting)
			documentation: 'Tiles for querying whether the mouse button is up'
			globalReceiverSymbol: #ScriptingSystem
			nativitySelector: #noButtonPressedTiles.
		DescriptionForPartsBin
			formalName: 'NextPage'
			categoryList: #(Presentation)
			documentation: 'A button which, when clicked, takes the reader to the next page of a book'
			globalReceiverSymbol: #BookMorph
			nativitySelector: #nextPageButton.
		DescriptionForPartsBin
			formalName: 'PreviousPage'
			categoryList: #(Presentation)
			documentation: 'A button which, when clicked, takes the reader to the next page of a book'
			globalReceiverSymbol: #BookMorph
			nativitySelector: #previousPageButton.},

	(Flaps quadsDefiningToolsFlap collect:
		[:aQuad | DescriptionForPartsBin fromQuad: aQuad categoryList: #(Tools)])! !

!Morph methodsFor: '*MorphicExtras-menus' stamp: 'dgd 4/3/2006 14:18'!
dismissButton
	"Answer a button whose action would be to dismiss the receiver, and whose action is to send #delete to the receiver"

	| aButton |
	aButton := SimpleButtonMorph new.
	aButton
		target: self topRendererOrSelf;
		color: ColorTheme current cancelColor;
		borderColor: ColorTheme current cancelColor muchDarker;
		borderWidth: 1;
		label: 'X' font: Preferences standardButtonFont;
		actionSelector: #delete;
		setBalloonText: 'dismiss' translated.
	^ aButton! !

!Morph methodsFor: '*MorphicExtras-accessing' stamp: 'dgd 1/7/2005 19:07'!
highlightOnlySubmorph: aMorph
	"Distinguish only aMorph with border highlighting (2-pixel wide red); make all my other submorphs have one-pixel-black highlighting.  This is a rather special-purpose and hard-coded highlighting regime, of course.  Later, if someone cared to do it, we could parameterize the widths and colors via properties, or some such."

	self submorphs do:
		[:m |
			m == aMorph
				ifTrue: [m borderWidth: 1; borderColor: Color red. m firstSubmorph color: Color red]
				ifFalse: [m borderWidth: 1; borderColor: Color black. m firstSubmorph color: Color black]
		].
! !

!Morph methodsFor: '*MorphicExtras-geometry' stamp: 'dgd 8/31/2004 16:22'!
shiftSubmorphsBy: delta
	self shiftSubmorphsOtherThan: (submorphs select: [:m | m wantsToBeTopmost]) by: delta! !

Morph subclass: #MouseActionIndicatorMorph
	instanceVariableNames: 'siblings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!MouseActionIndicatorMorph commentStamp: '<historical>' prior: 0!
I am used to highlight morphs which have a special mouseup action!

!MouseActionIndicatorMorph classSide methodsFor: 'as yet unclassified' stamp: 'RAA 7/12/2000 11:08'!
world: aWorld inner: innerRectangle outer: outerRectangle color: aColor

	| allRects allMorphs |

	allRects := outerRectangle areasOutside: innerRectangle.
	allMorphs := allRects collect: [ :each |
		self new bounds: each; color: aColor
	].
	allMorphs do: [ :each |
		each siblings: allMorphs; openInWorld: aWorld
	].
	^allMorphs


! !

!MouseActionIndicatorMorph methodsFor: 'as yet unclassified' stamp: 'RAA 7/12/2000 10:49'!
deleteWithSiblings

	siblings do: [ :each | each delete]
! !

!MouseActionIndicatorMorph methodsFor: 'event handling' stamp: 'RAA 7/12/2000 10:48'!
handlesMouseOver: evt

	^true! !

!MouseActionIndicatorMorph methodsFor: 'event handling' stamp: 'RAA 7/17/2000 09:52'!
handlesMouseOverDragging: evt

	^true! !

!MouseActionIndicatorMorph methodsFor: 'initialization' stamp: 'RAA 7/12/2000 10:48'!
initialize

	super initialize.
	siblings := #().! !

!MouseActionIndicatorMorph methodsFor: 'event handling' stamp: 'RAA 7/12/2000 10:50'!
mouseEnter: evt

	self deleteWithSiblings
! !

!MouseActionIndicatorMorph methodsFor: 'event handling' stamp: 'RAA 7/17/2000 09:52'!
mouseEnterDragging: evt

	self deleteWithSiblings
! !

!MouseActionIndicatorMorph methodsFor: 'as yet unclassified' stamp: 'RAA 7/12/2000 10:49'!
siblings: aCollection

	siblings := aCollection.
! !

Morph subclass: #ScreeningMorph
	instanceVariableNames: 'screenForm displayMode passingColor passElseBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!ScreeningMorph commentStamp: '<historical>' prior: 0!
ScreeningMorph uses its first submorph as a screen, and its second submorph as a source.  It also wants you to choose (when showing only the screen) the passing color in the screen.  It then makes up a 1-bit mask which clips the source, and displays transparently outside it.!

!ScreeningMorph methodsFor: 'menu' stamp: 'dgd 10/8/2003 19:51'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	submorphs isEmpty ifTrue:
		[^ aCustomMenu add: '*Please add a source morph*' translated action: #itself].
	submorphs size = 1 ifTrue:
		[^ aCustomMenu add: '*Please add a screen morph*' translated action: #itself].
	submorphs size > 2 ifTrue:
		[^ aCustomMenu add: '*I have too many submorphs*' translated action: #itself].
	aCustomMenu add: 'show screen only' translated action: #showScreenOnly.
	aCustomMenu add: 'show source only' translated action: #showSourceOnly.
	aCustomMenu add: 'show screen over source' translated action: #showScreenOverSource.
	aCustomMenu add: 'show source screened' translated action: #showScreened.
	aCustomMenu add: 'exchange source and screen' translated action: #exchange.
	displayMode == #showScreenOnly ifTrue:
		[aCustomMenu add: 'choose passing color' translated action: #choosePassingColor.
		aCustomMenu add: 'choose blocking color' translated action: #chooseBlockingColor].
! !

!ScreeningMorph methodsFor: 'submorphs-add/remove' stamp: 'di 6/4/1999 08:25'!
addMorph: aMorph

	| f |
	super addMorph: aMorph.
	submorphs size <= 2 ifTrue:
		[self bounds: submorphs last bounds].
	submorphs size = 2 ifTrue:
		["The screenMorph has just been added.
		Choose as the passingColor the center color of that morph"
		f := self screenMorph imageForm.
		passingColor := f colorAt: f boundingBox center.
		passElseBlock := true]! !

!ScreeningMorph methodsFor: 'menu' stamp: 'di 6/3/1999 16:41'!
chooseBlockingColor
	passingColor := Color fromUser.
	passElseBlock := false.
	self layoutChanged! !

!ScreeningMorph methodsFor: 'menu' stamp: 'di 6/3/1999 16:41'!
choosePassingColor
	passingColor := Color fromUser.
	passElseBlock := true.
	self layoutChanged! !

!ScreeningMorph methodsFor: 'geometry testing' stamp: ''!
containsPoint: aPoint
	submorphs size = 2 ifFalse: [^ super containsPoint: aPoint].
	^ self screenMorph containsPoint: aPoint! !

!ScreeningMorph methodsFor: 'menu' stamp: ''!
exchange
	submorphs swap: 1 with: 2.
	self changed! !

!ScreeningMorph methodsFor: 'drawing' stamp: 'dgd 2/21/2003 22:57'!
fullDrawOn: aCanvas 
	| mergeForm |
	submorphs isEmpty ifTrue: [^super fullDrawOn: aCanvas].
	(aCanvas isVisible: self fullBounds) ifFalse: [^self].
	(submorphs size = 1 or: [displayMode == #showScreenOnly]) 
		ifTrue: [^aCanvas fullDrawMorph: self screenMorph].
	displayMode == #showSourceOnly 
		ifTrue: [^aCanvas fullDrawMorph: self sourceMorph].
	displayMode == #showScreenOverSource 
		ifTrue: 
			[aCanvas fullDrawMorph: self sourceMorph.
			^aCanvas fullDrawMorph: self screenMorph].
	displayMode == #showScreened 
		ifTrue: 
			[aCanvas fullDrawMorph: self screenMorph.
			self flag: #fixCanvas.	"There should be a more general way than this"
			mergeForm := self sourceMorph 
						imageFormForRectangle: self screenMorph bounds.
			(BitBlt current toForm: mergeForm) 
				copyForm: self screenForm
				to: 0 @ 0
				rule: Form and
				colorMap: (Bitmap with: 0 with: 4294967295).
			aCanvas paintImage: mergeForm at: self screenMorph position]! !

!ScreeningMorph methodsFor: 'initialization' stamp: 'panda 4/25/2000 15:42'!
initialize
	super initialize.
	passingColor := Color black.
	passElseBlock := true.
	displayMode := #showScreened.
	self enableDragNDrop! !

!ScreeningMorph methodsFor: 'layout' stamp: 'panda 4/25/2000 15:43'!
layoutChanged

	screenForm := nil.
	submorphs size >= 2
		ifTrue: [self disableDragNDrop]
		ifFalse: [self enableDragNDrop].
	submorphs size = 2 ifTrue:
		[bounds := ((self sourceMorph bounds merge: self screenMorph bounds) expandBy: 4)].
	^ super layoutChanged! !

!ScreeningMorph methodsFor: 'accessing' stamp: 'fc 7/24/2004 13:43'!
passElseBlock: aBool
	passElseBlock := aBool.! !

!ScreeningMorph methodsFor: 'accessing' stamp: 'fc 7/24/2004 13:42'!
passingColor: aColor
	passingColor := aColor.! !

!ScreeningMorph methodsFor: 'private' stamp: 'ar 8/10/2003 18:12'!
removedMorph: aMorph

	submorphs size = 1 ifTrue:
		[self bounds: submorphs first bounds].
	super removedMorph: aMorph.! !

!ScreeningMorph methodsFor: 'private' stamp: 'aoy 2/15/2003 21:40'!
screenForm
	| screenImage colorMap pickValue elseValue |
	screenForm ifNotNil: [^screenForm].
	passElseBlock ifNil: [passElseBlock := true].
	passingColor ifNil: [passingColor := Color black].
	elseValue := passElseBlock 
		ifTrue: 
			[pickValue := 4294967295.
			 0]
		ifFalse: 
			[pickValue := 0.
			 4294967295].
	screenImage := self screenMorph 
				imageFormForRectangle: self screenMorph bounds.
	colorMap := screenImage newColorMap atAllPut: elseValue.
	colorMap at: (passingColor indexInMap: colorMap) put: pickValue.
	screenForm := Form extent: screenImage extent.
	screenForm 
		copyBits: screenForm boundingBox
		from: screenImage
		at: 0 @ 0
		colorMap: colorMap.
	^screenForm! !

!ScreeningMorph methodsFor: 'private' stamp: 'dgd 2/21/2003 22:57'!
screenMorph
	^submorphs first! !

!ScreeningMorph methodsFor: 'menu' stamp: ''!
showScreenOnly
	displayMode := #showScreenOnly.
	self changed! !

!ScreeningMorph methodsFor: 'menu' stamp: ''!
showScreenOverSource
	displayMode := #showScreenOverSource.
	self changed! !

!ScreeningMorph methodsFor: 'menu' stamp: ''!
showScreened
	displayMode := #showScreened.
	self changed! !

!ScreeningMorph methodsFor: 'menu' stamp: ''!
showSourceOnly
	displayMode := #showSourceOnly.
	self changed! !

!ScreeningMorph methodsFor: 'private' stamp: 'dgd 2/22/2003 18:53'!
sourceMorph
	^submorphs second! !

!ScreeningMorph methodsFor: 'e-toy support' stamp: 'dgd 8/29/2004 11:04'!
wantsRecolorHandle
	"Answer whether the receiver would like a recolor handle to be  
	put up for it. We'd want to disable this but for the moment  
	that would cut off access to the button part of the properties  
	sheet. So this remains a loose end."
	^ false! !

Morph subclass: #SketchEditorMorph
	instanceVariableNames: 'hostView palette ticksToDwell rotationCenter registrationPoint newPicBlock emptyPicBlock paintingForm dimForm formCanvas rotationButton scaleButton cumRot cumMag undoBuffer enclosingPasteUpMorph forEachHand'
	classVariableNames: 'SketchTimes'
	poolDictionaries: ''
	category: 'MorphicExtras-Support'!

!SketchEditorMorph commentStamp: '<historical>' prior: 0!
Inst vars (converting to morphic events)
hostView -- SketchMorph we are working on.
stampForm -- Stamp is stored here.
canvasRectangle -- later use bounds
palette -- the PaintBox interface Morph
dirty -- not used
currentColor 
ticksToDwell rotationCenter registrationPoint 
newPicBlock -- do this after painting
action -- selector of painting action
paintingForm -- our copy
composite -- now paintArea origin.  world relative.  stop using it.
dimForm -- SketchMorph of the dimmed background.  Opaque.  
		installed behind the editor morph.
buff 
brush -- 1-bit Form of the brush, 
paintingFormPen 
formCanvas -- Aim it at paintingForm to allow it to draw ovals, rectangles, lines, etc.
picToComp dimToComp compToDisplay -- used to composite -- obsolete
picToBuff brushToBuff buffToBuff buffToPic 
rotationButton scaleButton -- submorphs, handles to do these actions.
strokeOrigin -- During Pickup, origin of rect. 
cumRot cumMag -- cumulative for multiple operations from same original
undoBuffer 
lastEvent 
currentNib -- 1 bit deep form.


For now, we do not carry the SketchMorph's registration point, rotation center, or ticksToDwell.

New -- using transform morphs to rotate the finished player.  How get it rotated back and the rotationDegrees to be right?  We cancel out rotationDegrees, so how remember it?

Registration point convention:  
In a GraphicFrame, reg point is relative to this image's origin.
During painting, it is relative to canvasRectangle origin, and thus us absolute within the canvas.  To convert back, subract newBox origin.

Be sure to convert back and forth correctly.  In deliverPainting. initializeFromFrame:inView: !

!SketchEditorMorph classSide methodsFor: 'new-morph participation' stamp: 'di 6/22/97 09:07'!
includeInNewMorphMenu
	"Not to be instantiated from the menu"
	^ false! !

!SketchEditorMorph methodsFor: 'start & finish' stamp: 'dgd 9/19/2003 14:50'!
addRotationScaleHandles

	"Rotation and scaling handles"

	rotationButton := SketchMorph withForm: (palette rotationTabForm).
	rotationButton position: bounds topCenter - (6@0).
	rotationButton on: #mouseDown send: #rotateScalePrep: to: self.
	rotationButton on: #mouseMove send: #rotateBy: to: self.
	rotationButton on: #mouseUp send: #rotateDone: to: self.
	rotationButton on: #mouseEnter send: #mouseLeave: to: self.
	"Put cursor back"
	rotationButton on: #mouseLeave send: #mouseEnter: to: self.
	self addMorph: rotationButton.
	rotationButton setBalloonText: 'Drag me sideways to
rotate your
picture.' translated.

	scaleButton := SketchMorph withForm: (palette scaleTabForm).
	scaleButton position: bounds rightCenter - ((scaleButton width)@6).
	scaleButton on: #mouseDown send: #rotateScalePrep: to: self.
	scaleButton on: #mouseMove send: #scaleBy: to: self.
	scaleButton on: #mouseEnter send: #mouseLeave: to: self.
	"Put cursor back"
	scaleButton on: #mouseLeave send: #mouseEnter: to: self.
	self addMorph: scaleButton.
	scaleButton setBalloonText: 'Drag me up and down to change
the size
of your picture.' translated.

"REMOVED:
	fwdButton := PolygonMorph new.
	pt := bounds topCenter.
	fwdButton borderWidth: 2; makeOpen; makeBackArrow; borderColor:
(Color r: 0 g: 0.8 b: 0).
	fwdButton removeHandles; setVertices: (Array with: pt+(0@7) with:
pt+(0@22)).
	fwdButton on: #mouseMove send: #forward:direction: to: self.
	fwdButton on: #mouseEnter send: #mouseLeave: to: self.	
	fwdButton on: #mouseLeave send: #mouseEnter: to: self.
	self setProperty: #fwdButton toValue: fwdButton.
	self addMorph: fwdButton.
	fwdButton setBalloonText: 'Drag me around to point
in the direction
I go forward.' translated.

	toggle := EllipseMorph
		newBounds: (Rectangle center: fwdButton vertices last +
(-4@4) extent: 8@8)
		color: Color gray.
	toggle on: #mouseUp send: #toggleDirType:in: to: self.
	toggle on: #mouseEnter send: #mouseLeave: to: self.
	toggle on: #mouseLeave send: #mouseEnter: to: self.
	self setProperty: #fwdToggle toValue: toggle.
	fwdButton addMorph: toggle.
	toggle setBalloonText: 'When your object turns,
how should its
picture change?
It can rotate, face left or right,
face up or down, or not
change.' translated.
	"
	self setProperty: #rotationStyle toValue: hostView rotationStyle.
"	self forward: hostView setupAngle direction: fwdButton.	"
	"Set to its current value"

! !

!SketchEditorMorph methodsFor: 'start & finish' stamp: 'tk 10/28/97 15:31'!
afterNewPicDo: goodBlock ifNoBits: badBlock
	"If the user said 'Save' at the end of drawing, do this block to save the picture.
goodBlock takes 2 args, the painted form and the bounding rectangle of its bits.
badBlock takes no args.  "

	newPicBlock := goodBlock.
	emptyPicBlock := badBlock.! !

!SketchEditorMorph methodsFor: 'start & finish' stamp: 'RAA 8/16/2000 01:46'!
cancel: evt
	"Palette is telling us that the use wants to end the painting session.  "

	Cursor blank show.
	self deliverPainting: #cancel evt: evt.! !

!SketchEditorMorph methodsFor: 'start & finish' stamp: 'sw 4/30/2005 23:05'!
cancelOutOfPainting
	"The user requested to back out of a painting session without saving"

	self deleteSelfAndSubordinates.
	emptyPicBlock ifNotNil: [emptyPicBlock value].	"note no args to block!!"
	hostView ifNotNil: [hostView changed].
	ActiveWorld resumeScriptsPausedByPainting.
	^ nil! !

!SketchEditorMorph methodsFor: 'palette handling' stamp: 'RAA 8/16/2000 01:47'!
cancelPainting: aPaintBoxMorph evt: evt
	"Undo the operation after user issued #cancel in aPaintBoxMorph"
	^self cancel: evt! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'tk 10/21/97 16:32'!
clear
	"wipe out all the paint"

	self polyFreeze.		"end polygon mode"
	paintingForm fillWithColor: Color transparent.
	self invalidRect: bounds.! !

!SketchEditorMorph methodsFor: 'palette handling' stamp: 'ar 3/23/2000 14:25'!
clearPainting: aPaintBoxMorph
	"Clear the image after user issued #clear in aPaintBoxMorph"
	^self clear! !

!SketchEditorMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:30'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color white alpha: 0.5! !

!SketchEditorMorph methodsFor: 'start & finish' stamp: 'sw 9/2/1999 12:54'!
deleteSelfAndSubordinates
	"Delete the receiver and, if it has one, its subordinate dimForm"
	self delete.
	dimForm ifNotNil: [dimForm delete]! !

!SketchEditorMorph methodsFor: 'start & finish' stamp: 'sw 5/1/2005 00:13'!
deliverPainting: result evt: evt
	"Done painting.  May come from resume, or from original call.  Execute user's post painting instructions in the block.  Always use this standard one.  4/21/97 tk"

	| newBox newForm ans |
	palette ifNotNil: "nil happens" [palette setAction: #paint: evt: evt].	"Get out of odd modes"
	"rot := palette getRotations."	"rotate with heading, or turn to and fro"
	"palette setRotation: #normal."
	result == #cancel ifTrue: [
		ans := PopUpMenu withCaption: 'Do you really want to throw away 
what you just painted?' translated 
				chooseFrom: 'throw it away\keep painting it' translated.
		^ ans = 1 ifTrue: [self cancelOutOfPainting]
				ifFalse: [nil]].	"cancelled out of cancelling."

	"hostView rotationStyle: rot."		"rotate with heading, or turn to and fro"
	newBox := paintingForm rectangleEnclosingPixelsNotOfColor: Color transparent.
	registrationPoint ifNotNil:
		[registrationPoint := registrationPoint - newBox origin]. "relative to newForm origin"
	newForm := 	Form extent: newBox extent depth: paintingForm depth.
	newForm copyBits: newBox from: paintingForm at: 0@0 
		clippingBox: newForm boundingBox rule: Form over fillColor: nil.
	newForm isAllWhite ifTrue: [
		(self valueOfProperty: #background) == true 
			ifFalse: [^ self cancelOutOfPainting]].

	newForm fixAlpha. "so alpha channel stays intact for 32bpp"

	self delete.	"so won't find me again"
	dimForm ifNotNil: [dimForm delete].
	newPicBlock value: newForm value: (newBox copy translateBy: bounds origin).
	ActiveWorld resumeScriptsPausedByPainting

! !

!SketchEditorMorph methodsFor: 'palette handling' stamp: 'RAA 8/31/2000 14:03'!
dimTheWindow

	"Updated to use TranslucentColor by kfr 10/5 00"
	"Do not call twice!! Installs a morph with an 'onion-skinned' copy of the pixels behind me." 

	"create an 'onion-skinned' version of the stuff on the screen"
	owner outermostMorphThat: [:morph | morph resumeAfterDrawError. false].

	"an experiment for Nebraska to see if opaque background speeds things up"

"----- now using the color variable to control background
	bgColor := false ifTrue: [TranslucentColor r:1.0 g:1.0 b:1.0 alpha:0.5] ifFalse: [Color white].
	dimForm := (RectangleMorph new color: bgColor; bounds: self bounds; borderWidth: 0).
	dimForm position: self position.
	owner
		privateAddMorph: dimForm
		atIndex: (owner submorphs indexOf: self) + 1.
-----"
! !

!SketchEditorMorph methodsFor: 'drawing' stamp: 'RAA 8/31/2000 13:49'!
drawOn: aCanvas
	"Put the painting on the display"

	color isTransparent ifFalse: [
		aCanvas fillRectangle: bounds color: color
	].
	paintingForm ifNotNil: [
		aCanvas paintImage: paintingForm at: bounds origin].

 ! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'sw 4/21/2004 13:23'!
ellipse: evt
	"Draw an ellipse from the center. "

	| rect oldRect ww ext oldExt cColor sOrigin priorEvt |

	sOrigin := self get: #strokeOrigin for: evt.
	cColor := self getColorFor: evt.
	ext := (sOrigin - evt cursorPoint) abs * 2.
	evt shiftPressed ifTrue: [ext := self shiftConstrainPoint: ext].
	rect := Rectangle center: sOrigin extent: ext.
	ww := (self getNibFor: evt) width.
	(priorEvt := self get: #lastEvent for: evt) ifNotNil: [
		oldExt := (sOrigin - priorEvt cursorPoint) abs + ww * 2.
		priorEvt shiftPressed ifTrue: [oldExt := self shiftConstrainPoint: oldExt].
		(oldExt < ext) ifFalse: ["Last draw sticks out, must erase the area"
			oldRect := Rectangle center: sOrigin extent: oldExt.
			self restoreRect: oldRect]].
	cColor == Color transparent
		ifFalse:
			[formCanvas fillOval: rect color: Color transparent borderWidth: ww borderColor: cColor]
		ifTrue:
			[formCanvas fillOval: rect color: cColor borderWidth: ww borderColor: Color black].

	self invalidRect: rect.

! !

!SketchEditorMorph methodsFor: 'access' stamp: 'sw 9/2/1999 11:03'!
enclosingPasteUpMorph
	^ enclosingPasteUpMorph! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'tk 7/2/97 09:02'!
erase: evt
	"Pen is set up to draw transparent squares"
	self paint: evt
! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'RAA 8/16/2000 11:30'!
erasePrep: evt
	"Transparent paint, square brush.  Be careful not to let this be undone by asking palette for brush and color."

	| size pfPen myBrush |

	pfPen := self get: #paintingFormPen for: evt.
	size := (self getNibFor: evt) width.
	self set: #brush for: evt to: (myBrush := Form extent: size@size depth: 1).
	myBrush offset: (0@0) - (myBrush extent // 2).
	myBrush fillWithColor: Color black.
	pfPen sourceForm: myBrush.
	"transparent"
	pfPen combinationRule: Form erase1bitShape.
	pfPen color: Color black.
! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'ar 12/19/2000 19:53'!
fill: evt 
	"Find the area that is the same color as where you clicked. Fill it with 
	the current paint color."
	| box |
	evt isMouseUp
		ifFalse: [^ self].
	"Only fill upon mouseUp"
	"would like to only invalidate the area changed, but can't find out what it is."
	Cursor execute
		showWhile: [
			box := paintingForm
				floodFill: (self getColorFor: evt)
				at: evt cursorPoint - bounds origin.
			self render: (box translateBy: bounds origin)]! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'RAA 8/15/2000 20:06'!
flipHoriz: evt 
	"Flip the image"
	| temp myBuff |

	myBuff := self get: #buff for: evt.
	temp := myBuff deepCopy flipBy: #horizontal centerAt: myBuff center.
	temp offset: 0 @ 0.
	paintingForm fillWithColor: Color transparent.
	temp displayOn: paintingForm at: paintingForm center - myBuff center + myBuff offset.
	rotationButton position: evt cursorPoint x - 6 @ rotationButton position y.
	self render: bounds! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'RAA 8/15/2000 20:06'!
flipVert: evt 
	"Flip the image"
	| temp myBuff |

	myBuff := self get: #buff for: evt.
	temp := myBuff deepCopy flipBy: #vertical centerAt: myBuff center.
	temp offset: 0 @ 0.
	paintingForm fillWithColor: Color transparent.
	temp displayOn: paintingForm at: paintingForm center - myBuff center + myBuff offset.
	rotationButton position: evt cursorPoint x - 6 @ rotationButton position y.
	self render: bounds! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'aoy 2/15/2003 21:46'!
forward: evt direction: button 
	"Move the forward direction arrow of this painting.  When the user
says forward:, the object moves in the direction of the arrow.  evt may be
an Event (from the user moving the arrow), or an initial number ofdegrees."

	| center dir ww ff |
	center := bounds center.	"+ (rotationButton width - 6 @ 0)"
	dir := evt isNumber 
				ifTrue:  
					[Point r: 100 degrees: evt - 90.0
					"convert to 0 on X axis"]
				ifFalse: [evt cursorPoint - center].
	ww := (bounds height min: bounds width) // 2 - 7.
	button 
		setVertices: (Array with: center + (Point r: ww degrees: dir degrees)
				with: center + (Point r: ww - 15 degrees: dir degrees)).
	(ff := self valueOfProperty: #fwdToggle) 
		position: center + (Point r: ww - 7 degrees: dir degrees + 6.5) 
				- (ff extent // 2).
	self showDirType! !

!SketchEditorMorph methodsFor: 'accessing' stamp: 'ar 9/22/2000 20:35'!
forwardDirection
	"The direction object will go when issued a sent forward:.  Up is
zero.  Clockwise like a compass.  From the arrow control."
	^ hostView forwardDirection! !

!SketchEditorMorph methodsFor: 'Nebraska support' stamp: 'RAA 8/15/2000 15:13'!
get: aSymbol for: anEventOrHand

	| valuesForHand |

	valuesForHand := self valuesForHand: anEventOrHand.
	^valuesForHand at: aSymbol ifAbsent: [nil].

! !

!SketchEditorMorph methodsFor: 'Nebraska support' stamp: 'RAA 8/16/2000 11:14'!
getActionFor: anEventOrHand

	^(self get: #action for: anEventOrHand) ifNil: [
		self set: #action for: anEventOrHand to: palette action
	].

! !

!SketchEditorMorph methodsFor: 'Nebraska support' stamp: 'RAA 8/15/2000 17:56'!
getBrushFor: anEventOrHand

	^(self get: #brush for: anEventOrHand) ifNil: [
		self set: #brush for: anEventOrHand to: palette getNib
	].

! !

!SketchEditorMorph methodsFor: 'Nebraska support' stamp: 'RAA 8/16/2000 11:20'!
getColorFor: anEventOrHand

	^(self get: #currentColor for: anEventOrHand) ifNil: [
		self set: #currentColor for: anEventOrHand to: palette getColor
	].

! !

!SketchEditorMorph methodsFor: 'Nebraska support' stamp: 'RAA 8/16/2000 13:40'!
getCursorFor: anEventOrHand

	| plainCursor |
	plainCursor := (self get: #currentCursor for: anEventOrHand) ifNil: [
		self set: #currentCursor for: anEventOrHand to: palette plainCursor
	].
	^palette
		cursorFor: (self getActionFor: anEventOrHand) 
		oldCursor: plainCursor 
		currentNib: (self getNibFor: anEventOrHand) 
		color: (self getColorFor: anEventOrHand)

! !

!SketchEditorMorph methodsFor: 'Nebraska support' stamp: 'RAA 8/15/2000 17:16'!
getNibFor: anEventOrHand

	^(self get: #currentNib for: anEventOrHand) ifNil: [
		self set: #currentNib for: anEventOrHand to: palette getNib
	].

! !

!SketchEditorMorph methodsFor: 'event handling' stamp: 'jm 7/28/97 11:49'!
handlesMouseDown: evt

	^ true
! !

!SketchEditorMorph methodsFor: 'event handling' stamp: ''!
handlesMouseOver: evt
	^true! !

!SketchEditorMorph methodsFor: 'event handling' stamp: 'di 9/14/1998 07:51'!
handlesMouseOverDragging: evt
	^true! !

!SketchEditorMorph methodsFor: 'access' stamp: ''!
hostView
	^ hostView! !

!SketchEditorMorph methodsFor: 'initialization' stamp: 'ar 6/2/2001 16:54'!
initializeFor: aSketchMorph inBounds: boundsToUse pasteUpMorph: aPasteUpMorph
	| aPaintBox newPaintBoxBounds worldBounds requiredWidth newOrigin aPosition aPal aTab paintBoxFullBounds |
	(aTab := self world paintingFlapTab) ifNotNil:
		[aTab showFlap.
		^ self initializeFor: aSketchMorph inBounds: boundsToUse pasteUpMorph: aPasteUpMorph paintBoxPosition: nil].

	aPaintBox := self world paintBox.
	worldBounds := self world bounds.
	requiredWidth := aPaintBox width.

	aPosition := (aPal := aPasteUpMorph standardPalette)
		ifNotNil:
			[aPal showNoPalette.
			aPal topRight + (aPaintBox width negated @ 0 "aPal tabsMorph height")]
		ifNil:
			[boundsToUse topRight].

	newOrigin := ((aPosition x  + requiredWidth <= worldBounds right) or: [Preferences unlimitedPaintArea])
			ifTrue:  "will fit to right of aPasteUpMorph"
				[aPosition]
			ifFalse:  "won't fit to right, try left"
				[boundsToUse topLeft - (requiredWidth @ 0)].
	paintBoxFullBounds := aPaintBox maxBounds.
	paintBoxFullBounds := (newOrigin - aPaintBox offsetFromMaxBounds) extent: 
					paintBoxFullBounds extent.
	newPaintBoxBounds := paintBoxFullBounds translatedToBeWithin: worldBounds.
	

	self initializeFor: aSketchMorph inBounds: boundsToUse 
		pasteUpMorph: aPasteUpMorph 
		paintBoxPosition: newPaintBoxBounds origin + aPaintBox offsetFromMaxBounds.! !

!SketchEditorMorph methodsFor: 'initialization' stamp: 'yo 7/16/2003 15:10'!
initializeFor: aSketchMorph inBounds: boundsToUse pasteUpMorph: aPasteUpMorph paintBoxPosition: aPosition
	"NB: if aPosition is nil, then it's assumed that the paintbox is obtained from a flap or some such, so do nothing special regarding a palette in this case.  The palette needs already to be in the world for this to work."
	| w  |
	(w := aPasteUpMorph world) addMorphInLayer: self.	"in back of palette"
	enclosingPasteUpMorph := aPasteUpMorph.
	hostView := aSketchMorph.  "may be ownerless"
	self bounds: boundsToUse.
	palette := w paintBox focusMorph: self.
	palette beStatic.		"give Nebraska whatever help we can"
	palette fixupButtons.
	palette addWeakDependent: self.
	aPosition ifNotNil:
		[w addMorphFront: palette.  "bring to front"
		palette position: aPosition].
	paintingForm := Form extent: bounds extent depth: w assuredCanvas depth.
	self dimTheWindow.
	self addRotationScaleHandles.
	aSketchMorph ifNotNil:
		[
		aSketchMorph form
			displayOn: paintingForm
			at: (hostView boundsInWorld origin - bounds origin - hostView form offset)
			clippingBox: (0@0 extent: paintingForm extent)
			rule: Form over
			fillColor: nil.  "assume they are the same depth".
			undoBuffer := paintingForm deepCopy.
		rotationCenter := aSketchMorph rotationCenter]! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'RAA 8/16/2000 11:54'!
line: evt 
	"Draw a line on the paintingForm using formCanvas aimed at it."
	| rect oldRect ww now diff cor cColor sOrigin priorEvt |
	sOrigin := self get: #strokeOrigin for: evt.
	rect := sOrigin rect: (now := evt cursorPoint).
	evt shiftPressed
		ifTrue: [diff := evt cursorPoint - sOrigin.
			now := sOrigin
						+ (Point r: diff r degrees: diff degrees + 22.5 // 45 * 45).
			rect := sOrigin rect: now].
	ww := (self getNibFor: evt) width.
	(priorEvt := self get: #lastEvent for: evt)
		ifNotNil: [oldRect := sOrigin rect: priorEvt cursorPoint.
			priorEvt shiftPressed
				ifTrue: [diff := priorEvt cursorPoint - sOrigin.
					cor := sOrigin
								+ (Point r: diff r degrees: diff degrees + 22.5 // 45 * 45).
					oldRect := sOrigin rect: cor].
			oldRect := oldRect expandBy: ww @ ww.
			"Last draw will always stick out, must erase the area"
			self restoreRect: oldRect].
	cColor := self getColorFor: evt.
	formCanvas
		line: sOrigin
		to: now
		width: ww
		color: cColor.
	self invalidRect: rect! !

!SketchEditorMorph methodsFor: 'WiW support' stamp: 'tk 8/6/2002 20:19'!
morphicLayerNumber
	"Place the painting behind the paint palette"

	^ 28! !

!SketchEditorMorph methodsFor: 'morphic' stamp: 'yo 11/17/2002 21:32'!
mouseDown: evt
	"Start a new stroke.  Check if any palette setting have changed.  6/11/97 20:30 tk"
	| cur pfPen myAction |
	"verify that we are in a good state"
	self verifyState: evt.		"includes prepareToPaint and #scalingOrRotate"
	pfPen := self get: #paintingFormPen for: evt.
	paintingForm extent = undoBuffer extent ifTrue: [
		paintingForm displayOn: undoBuffer at: 0@0 rule: Form over.
	] ifFalse: [
		undoBuffer := paintingForm deepCopy.	"know we will draw something"
	].
	pfPen place: (evt cursorPoint - bounds origin).
	myAction := self getActionFor: evt.
	myAction == #paint: ifTrue:[
		palette recentColor: (self getColorFor: evt)].
	self set: #strokeOrigin for: evt to: evt cursorPoint.
		"origin point for pickup: rect: ellispe: polygon: line: star:.  Always take it."
	myAction == #pickup: ifTrue: [
		cur := Cursor corner clone.
		cur offset: 0@0  "cur offset abs".
		evt hand showTemporaryCursor: cur].
	myAction == #polygon: ifTrue: [self polyNew: evt].	"a mode lets you drag vertices"
	self mouseMove: evt.! !

!SketchEditorMorph methodsFor: 'event handling' stamp: 'sw 7/5/2004 03:23'!
mouseEnter: evt
	"Set the cursor.  Reread colors if embedded editable polygon needs it."

	| poly cColor |
	super mouseEnter: evt.
	(self get: #action for: evt) == #scaleOrRotate ifTrue: [
		self set: #action for: evt to: (self get: #priorAction for: evt).
		].	"scale and rotate are not real modes.  If we enter with one, wear the previous tool."
	evt hand showTemporaryCursor: (self getCursorFor: evt).
	palette getSpecial == #polygon: ifFalse: [^self].
	(poly := self valueOfProperty: #polygon) ifNil: [^ self].
	cColor := self getColorFor: evt.
	poly borderColor: cColor; borderWidth: (self getNibFor: evt) width.
	poly changed.! !

!SketchEditorMorph methodsFor: 'event handling' stamp: 'di 9/14/1998 08:07'!
mouseEnterDragging: evt
	"Test button state elsewhere if at all"
	^ self mouseEnter: evt! !

!SketchEditorMorph methodsFor: 'event handling' stamp: 'jm 5/22/1998 10:15'!
mouseLeave: evt
	"Revert to the normal hand cursor."

	super mouseLeave: evt.
	evt hand showTemporaryCursor: nil.  "back to normal"
	"If this is modified to close down the SketchEditorMorph in any way, watch out for how it is called when entering a rotationButton and a scaleButton."
! !

!SketchEditorMorph methodsFor: 'event handling' stamp: 'di 9/14/1998 08:08'!
mouseLeaveDragging: evt
	"Test button state elsewhere if at all"
	^ self mouseLeave: evt! !

!SketchEditorMorph methodsFor: 'event handling' stamp: 'dgd 2/22/2003 18:45'!
mouseMove: evt 
	"In the middle of drawing a stroke.  6/11/97 19:51 tk"

	| pt priorEvt |
	WorldState canSurrenderToOS: false.	"we want maximum responsiveness"
	pt := evt cursorPoint.
	priorEvt := self get: #lastEvent for: evt.
	(priorEvt notNil and: [pt = priorEvt cursorPoint]) ifTrue: [^self].
	self perform: (self getActionFor: evt) with: evt.
	"Each action must do invalidRect:"
	self 
		set: #lastEvent
		for: evt
		to: evt.
	false 
		ifTrue: 
			["So senders will find the things performed here"

			self
				paint: nil;
				fill: nil;
				erase: nil;
				pickup: nil;
				stamp: nil.
			self
				rect: nil;
				ellipse: nil;
				polygon: nil;
				line: nil;
				star: nil]! !

!SketchEditorMorph methodsFor: 'event handling' stamp: 'ar 12/19/2000 00:20'!
mouseUp: evt
	| myAction |
	"Do nothing except those that work on mouseUp."

	myAction := self getActionFor: evt.
	myAction == #fill: ifTrue: [
		self perform: myAction with: evt.
		"Each action must do invalidRect:"
		].
	myAction == #pickup: ifTrue: [
		self pickupMouseUp: evt].
	myAction == #polygon: ifTrue: [self polyEdit: evt].	"a mode lets you drag vertices"
	self set: #lastEvent for: evt to: nil.
! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: ''!
notes
	"
Singleton costumes.
Registration points
"! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'RAA 8/16/2000 11:22'!
paint: evt
	"While the mouse is down, lay down paint, but only within window bounds.
	 11/28/96 sw: no longer stop painting when pen strays out of window; once it comes back in, resume painting rather than waiting for a mouse up"

	|  mousePoint startRect endRect startToEnd pfPen myBrush |

	pfPen := self get: #paintingFormPen for: evt.
	myBrush := self getBrushFor: evt.
	mousePoint := evt cursorPoint.
	startRect := pfPen location + myBrush offset extent: myBrush extent.
	pfPen goto: mousePoint - bounds origin.
	endRect := pfPen location + myBrush offset extent: myBrush extent.
	"self render: (startRect merge: endRect).	Show the user what happened"
	startToEnd := startRect merge: endRect.
	self invalidRect: (startToEnd translateBy: bounds origin).
! !

!SketchEditorMorph methodsFor: 'palette handling' stamp: 'RAA 8/15/2000 18:02'!
paintBoxChanged: arguments

	self set: arguments first for: arguments second to: arguments third.
! !

!SketchEditorMorph methodsFor: 'access' stamp: ''!
painting
	^ paintingForm! !

!SketchEditorMorph methodsFor: 'access' stamp: ''!
palette
	^palette! !

!SketchEditorMorph methodsFor: 'palette handling' stamp: 'ar 3/23/2000 14:37'!
paletteAttached: aPaintBoxMorph
	"A new palette has been attached to the receiver.
	Don't know what to do here..."! !

!SketchEditorMorph methodsFor: 'palette handling' stamp: 'ar 3/23/2000 14:33'!
paletteDetached: aPaintBoxMorph
	"The palette has been detached to the receiver.
	Don't know what to do here...."! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'dgd 2/21/2003 23:06'!
pickup: evt 
	"Grab a part of the picture (or screen) and store it in a known place.  Note where we started.  Use a rubberband rectangle to show what is being selected."

	| rect oldRect sOrigin priorEvt |
	sOrigin := self get: #strokeOrigin for: evt.
	rect := sOrigin rect: evt cursorPoint + (14 @ 14).
	(priorEvt := self get: #lastEvent for: evt) isNil 
		ifFalse: 
			["Last draw will stick out, must erase the area"

			oldRect := sOrigin rect: priorEvt cursorPoint + (14 @ 14).
			self restoreRect: (oldRect insetBy: -2)].
	formCanvas 
		frameAndFillRectangle: (rect insetBy: -2)
		fillColor: Color transparent
		borderWidth: 2
		borderColor: Color gray.
	self invalidRect: (rect insetBy: -2)! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'dgd 2/21/2003 23:06'!
pickupMouseUp: evt 
	"Grab a part of the picture (or screen) and store it in a known place. Like Copy on the Mac menu. Then switch to the stamp tool."

	| rr pForm ii oldRect sOrigin priorEvt |
	sOrigin := self get: #strokeOrigin for: evt.
	(priorEvt := self get: #lastEvent for: evt) isNil 
		ifFalse: 
			["Last draw will stick out, must erase the area"

			oldRect := sOrigin rect: priorEvt cursorPoint + (14 @ 14).
			self restoreRect: (oldRect insetBy: -2)].
	self primaryHand showTemporaryCursor: nil.	"later get rid of this"
	rr := sOrigin rect: evt cursorPoint + (14 @ 14).
	ii := rr translateBy: 0 @ 0 - bounds origin.
	(rr intersects: bounds) 
		ifTrue: 
			[pForm := paintingForm copy: ii.
			pForm isAllWhite 
				ifFalse: 
					["means transparent"

					"normal case.  Can be transparent in parts"

					]
				ifTrue: 
					[pForm := nil
					"Get an un-dimmed picture of other objects on the playfield"
					"don't know how yet"]].
	pForm ifNil: [pForm := Form fromDisplay: rr].	"Anywhere on the screen"
	palette pickupForm: pForm evt: evt.
	evt hand showTemporaryCursor: (self getCursorFor: evt)! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'ar 10/10/2000 16:40'!
polyEdit: evt
	"Add handles and let user drag'em around"
	| poly |
	poly := self valueOfProperty: #polygon.
	poly ifNil:[^self].
	poly addHandles.
	self polyEditing: true.
	self setProperty: #polyCursor toValue: palette plainCursor.
	palette plainCursor: Cursor normal event: evt.! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'ar 10/10/2000 16:28'!
polyEditing
	^self valueOfProperty: #polyEditing ifAbsent:[false]! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'ar 10/10/2000 16:28'!
polyEditing: aBool
	aBool
		ifTrue:[self setProperty: #polyEditing toValue: aBool]
		ifFalse:[self removeProperty: #polyEditing]! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'ar 10/10/2000 16:29'!
polyFreeze
	"A live polygon is on the painting.  Draw it into the painting and
delete it."

	| poly |
	self polyEditing ifFalse:[^self].
	(poly := self valueOfProperty: #polygon) ifNil: [^ self].
	poly drawOn: formCanvas.
	poly delete.
	self setProperty: #polygon toValue: nil.
	self polyEditing: false.! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'sw 7/5/2004 03:20'!
polyNew: evt
	"Create a new polygon.  Add it to the sketch, and let the user drag
its vertices around!!  Freeze it into the painting when the user chooses
another tool."

	| poly cColor |
	self polyEditing ifTrue:[
		self polyFreeze.
		(self hasProperty: #polyCursor)
			ifTrue:[palette plainCursor: (self valueOfProperty: #polyCursor) event: evt.
					self removeProperty: #polyCursor].
		^self].
	cColor := self getColorFor: evt.
	self polyFreeze.		"any old one we were working on"
	poly := PolygonMorph new "addHandles".
	poly referencePosition: poly bounds origin.
	poly align: poly bounds center with: evt cursorPoint.
	poly borderWidth: (self getNibFor: evt) width.
	poly borderColor: (cColor isTransparent ifTrue: [Color black] ifFalse: [cColor]).
	poly color: Color transparent.
	self addMorph: poly.
	poly changed.
	self setProperty: #polygon toValue: poly.! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'ar 10/10/2000 16:22'!
polygon: evt
	| poly |
	poly := self valueOfProperty: #polygon.
	poly ifNil:[^self].
	evt cursorPoint > poly bounds origin ifTrue:[
		poly extent: ((evt cursorPoint - poly bounds origin) max: 5@5)].! !

!SketchEditorMorph methodsFor: 'start & finish' stamp: 'RAA 8/16/2000 11:28'!
prepareToPaint: evt
	"Figure out what the current brush, fill, etc is.  Return an action to take every mouseMove.  Set up instance variable and pens.  Prep for normal painting is inlined here.  tk 6/14/97 21:11"

	| specialMode pfPen cColor cNib myBrush |
	"Install the brush, color, (replace mode), and cursor."
	specialMode := self getActionFor: evt.
 	cColor  := self getColorFor: evt.
	cNib := self getNibFor: evt.
	self set: #brush for: evt to: (myBrush := cNib).
	self set: #paintingFormPen for: evt to: (pfPen := Pen newOnForm: paintingForm).
	self set: #stampForm for: evt to: nil.	"let go of stamp"
	formCanvas := paintingForm getCanvas.	"remember to change when undo"
	formCanvas := formCanvas
		copyOrigin: self topLeft negated
		clipRect: (0@0 extent: bounds extent).

	specialMode == #paint: ifTrue: [
		"get it to one bit depth.  For speed, instead of going through a colorMap every time ."
		self set: #brush for: evt to: (myBrush := Form extent: myBrush extent depth: 1).
		myBrush offset: (0@0) - (myBrush extent // 2).
		cNib displayOn: myBrush at: (0@0 - cNib offset).

		pfPen sourceForm: myBrush.
		pfPen combinationRule: Form paint.
		pfPen color: cColor.
		cColor isTransparent ifTrue: [
			pfPen combinationRule: Form erase1bitShape.
			pfPen color: Color black].
		^ #paint:].

	specialMode == #erase: ifTrue: [
		self erasePrep: evt.
		^ #erase:].
	specialMode == #stamp: ifTrue: [
		self set: #stampForm for: evt to: palette stampForm.	"keep it"
		^ #stamp:].

	(self respondsTo: specialMode) 
		ifTrue: [^ specialMode]	"fill: areaFill: pickup: (in mouseUp:) 
				rect: ellipse: line: polygon: star:"
		ifFalse: ["Don't recognise the command"
			palette setAction: #paint: evt: evt.	"set it to Paint"
			^ self prepareToPaint: evt].! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'sw 7/25/2004 03:16'!
rect: evt 
	"While moving corner, just write on the canvas. When done, write on the paintingForm"

	| rect oldRect now diff cor cColor sOrigin priorEvt |
	sOrigin := self get: #strokeOrigin for: evt.
	rect := sOrigin rect: (now := evt cursorPoint).
	cColor := self getColorFor: evt.
	evt shiftPressed
		ifTrue: [diff := evt cursorPoint - sOrigin.
			now := sOrigin
						+ (Point r: (diff x abs min: diff y abs)
									* 2 degrees: diff degrees // 90 * 90 + 45).
			rect := sOrigin rect: now].
	(priorEvt := self get: #lastEvent for: evt) isNil
		ifFalse: [oldRect := sOrigin rect: priorEvt cursorPoint.
			priorEvt shiftPressed
				ifTrue: [diff := priorEvt cursorPoint - sOrigin.
					cor := sOrigin
								+ (Point r: (diff x abs min: diff y abs)
											* 2 degrees: diff degrees // 90 * 90 + 45).
					oldRect := sOrigin rect: cor].
		self restoreRect: oldRect].  		"Last draw will stick out, must erase the area"

	cColor == Color transparent
		ifTrue: [formCanvas
				frameAndFillRectangle: rect
				fillColor: Color transparent
				borderWidth: (self getNibFor: evt) width
				borderColor: Color black]
		ifFalse: [formCanvas
				frameAndFillRectangle: rect
				fillColor: Color transparent
				borderWidth: (self getNibFor: evt) width
				borderColor: cColor].
	self invalidRect: rect! !

!SketchEditorMorph methodsFor: 'access' stamp: ''!
registrationPoint
	^ registrationPoint! !

!SketchEditorMorph methodsFor: 'access' stamp: ''!
registrationPoint: aPoint
	registrationPoint := aPoint! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'RAA 8/15/2000 17:13'!
render: damageRect
	"Compose the damaged area again and store on the display.  damageRect is relative to paintingForm origin.  3/19/97 tk"

	self invalidRect: damageRect.	"Now in same coords as self bounds"
! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'tk 6/16/97 15:38'!
replaceOnly: initialMousePoint
	"Paint replacing only one color!!  Call this each stroke.  Also works for replacing all but one color.  "

! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'ar 2/12/2000 18:35'!
restoreRect: oldRect
	"Restore the given rectangular area of the painting Form from the undo buffer."

	formCanvas drawImage: undoBuffer
		at: oldRect origin
		sourceRect: (oldRect translateBy: self topLeft negated).
	self invalidRect: oldRect.
! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'RAA 8/15/2000 20:07'!
rotateBy: evt 
	"Left-right is rotation. 3/26/97 tk Slider at top of window. 4/3/97 tk"
	| pt temp amt smooth myBuff |

	myBuff := self get: #buff for: evt.
	evt cursorPoint x - self left < 20
		ifTrue: [^ self flipHoriz: evt].
	"at left end flip horizontal"
	evt cursorPoint x - self right > -20
		ifTrue: [^ self flipVert: evt].
	"at right end flip vertical"
	pt := evt cursorPoint - bounds center.
	smooth := 2.
	"paintingForm depth > 8 ifTrue: [2] ifFalse: [1]."
	"Could go back to 1 for speed"
	amt := pt x abs < 12
				ifTrue: ["detent"
					0]
				ifFalse: [pt x - (12 * pt x abs // pt x)].
	amt := amt * 1.8.
	temp := myBuff
				rotateBy: amt
				magnify: cumMag
				smoothing: smooth.
	temp displayOn: paintingForm at: paintingForm center - temp center + myBuff offset.
	rotationButton position: evt cursorPoint x - 6 @ rotationButton position y.
	self render: bounds.
	cumRot := amt! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: '6/13/97 17:55 '!
rotateDone: evt
	"MouseUp, snap box back to center."

"
self render: rotationButton bounds.
rotationButton position: (canvasRectangle width // 2 + composite x) @ rotationButton position y.
self render: rotationButton bounds.
"		"Not snap back..."! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'RAA 8/29/2000 10:01'!
rotateScalePrep: evt
	"Make a source that is the paintingForm.  Work from that.  3/26/97 tk"

	| newBox myBuff |

	(self getActionFor: evt) == #scaleOrRotate ifTrue: [^ self].	"Already doing it"
	paintingForm width > 120 
		ifTrue: [newBox := paintingForm rectangleEnclosingPixelsNotOfColor: Color transparent.
			"minimum size"
			newBox := newBox insetBy: 
				((18 - newBox width max: 0)//2) @ ((18 - newBox height max: 0)//2) * -1]
		ifFalse: [newBox := paintingForm boundingBox].
	newBox := newBox expandBy: 1.
	self set: #buff for: evt to: (myBuff := Form extent: newBox extent depth: paintingForm depth).
	myBuff offset: newBox center - paintingForm center.
	myBuff copyBits: newBox from: paintingForm at: 0@0 
		clippingBox: myBuff boundingBox rule: Form over fillColor: nil.
	"Could just run up owner chain asking colorUsed, but may not be embedded"
	cumRot := 0.0.  cumMag := 1.0.	"start over"
	self set: #changed for: evt to: true.
	self set: #action for: evt to: #scaleOrRotate.
		"Only changed by mouseDown with tool in paint area"! !

!SketchEditorMorph methodsFor: 'e-toy support' stamp: 'tk 9/3/97 17:12'!
rotationStyle

^ (self valueOfProperty: #rotationStyle) ifNil: [#normal]! !

!SketchEditorMorph methodsFor: 'start & finish' stamp: 'RAA 8/16/2000 11:14'!
save: evt
	"Palette is telling us that the use wants to end the painting session.  "

	Cursor blank show.
	(self getActionFor: evt) == #polygon: ifTrue: [self polyFreeze].		"end polygon mode"
	^ self deliverPainting: #okay evt: evt.! !

!SketchEditorMorph methodsFor: 'palette handling' stamp: 'RAA 8/16/2000 01:48'!
savePainting: aPaintBoxMorph evt: evt
	"Save the image after user issued #keep in aPaintBoxMorph"
	^self save: evt! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'RAA 8/15/2000 20:06'!
scaleBy: evt 
	"up-down is scale. 3/26/97 tk Now a slider on the right."
	| pt temp cy oldRect amt myBuff |

	myBuff := self get: #buff for: evt.
	pt := evt cursorPoint - bounds center.
	cy := bounds height * 0.5.
	oldRect := myBuff boundingBox expandBy: myBuff extent * cumMag / 2.
	amt := pt y abs < 12
				ifTrue: ["detent"
					1.0]
				ifFalse: [pt y - (12 * pt y abs // pt x)].
	amt := amt asFloat / cy + 1.0.
	temp := myBuff
				rotateBy: cumRot
				magnify: amt
				smoothing: 2.
	cumMag > amt
		ifTrue: ["shrinking"
			oldRect := oldRect translateBy: paintingForm center - oldRect center + myBuff offset.
			paintingForm
				fill: (oldRect expandBy: 1 @ 1)
				rule: Form over
				fillColor: Color transparent].
	temp displayOn: paintingForm at: paintingForm center - temp center + myBuff offset.
	scaleButton position: scaleButton position x @ (evt cursorPoint y - 6).
	self render: bounds.
	cumMag := amt! !

!SketchEditorMorph methodsFor: 'Nebraska support' stamp: 'ar 10/10/2000 17:30'!
set: aSymbol for: anEventOrHand to: anObject

	| valuesForHand |

	valuesForHand := self valuesForHand: anEventOrHand.
	aSymbol == #action ifTrue: [
		valuesForHand at: #priorAction put: (valuesForHand at: #action ifAbsent: [#paint:]).
		(anObject ~~ #polygon: and:[self polyEditing]) ifTrue:[self polyFreeze].
	].
	valuesForHand at: aSymbol put: anObject.
	^anObject

! !

!SketchEditorMorph methodsFor: 'start & finish' stamp: 'tk 4/3/97'!
setRotations: num
	"Tell the palette what number of rotations (or background) to show.  "

	| key |
	key := 'ItTurns'.	"default and value for num > 1"
	num == 1 ifTrue: [key := 'JustAsIs'].
	num == 18 ifTrue: [key := 'ItTurns'].
	num == 99 ifTrue: [key := 'ToAndFro'].
	num == #Background ifTrue: [key := 'Background'].
	num == #Repeated ifTrue: [key := 'Repeated'].
	palette setRotations: (palette contentsAtKey: key).! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'RAA 2/15/2001 07:18'!
shiftConstrainPoint: aPoint

	"answer a point with x and y equal for shift-constrained drawing"

	^aPoint max: aPoint transposed! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'tk 9/3/97 21:11'!
showDirType
	"Display the proper symbol for this direction type.  rotationStyle
is one of #(normal leftRight upDown none)."

| rr poly |
rr := self rotationStyle.
poly := self valueOfProperty: #fwdButton.
rr == #normal ifTrue: [^ poly makeBackArrow].
rr == #leftRight ifTrue: [
	poly makeBothArrows.
	^ poly setVertices: (Array with: poly center - (7@0) with:  poly
center + (7@0))].
rr == #upDown ifTrue: [
	poly makeBothArrows.
	^ poly setVertices: (Array with: poly center - (0@7) with:  poly
center + (0@7))].
rr == #none ifTrue: [
	poly makeNoArrows.
	^ poly setVertices: (Array with: poly center - (7@0) with:  poly
center + (7@0)
		 with: poly center with: poly center - (0@7) with:  poly
center + (0@7))].
! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'RAA 8/15/2000 17:43'!
stamp: evt
	"plop one copy of the user's chosen Form down."

	"Check depths"
	| pt sForm |

	sForm := self get: #stampForm for: evt.
	pt := evt cursorPoint - (sForm extent // 2).
	sForm displayOn: paintingForm 
		at: pt - bounds origin
		clippingBox: paintingForm boundingBox
		rule: Form paint
		fillColor: nil.
	self render: (pt extent: sForm extent).
! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'sw 7/5/2004 03:10'!
star: evt 
	"Draw an star from the center."
	| poly ext ww rect oldExt oldRect oldR verts pt cColor sOrigin priorEvt |
	sOrigin := self get: #strokeOrigin for: evt.
	cColor := self getColorFor: evt.
	ww := (self getNibFor: evt) width.
	ext := (pt := sOrigin - evt cursorPoint) r + ww * 2.
	rect := Rectangle center: sOrigin extent: ext.
	(priorEvt := self get: #lastEvent for: evt)
		ifNotNil: [oldExt := (sOrigin - priorEvt cursorPoint) r + ww * 2.
			"Last draw sticks out, must erase the area"
			oldRect := Rectangle center: sOrigin extent: oldExt.
			self restoreRect: oldRect].
	ext := pt r.
	oldR := ext.
	verts := (0 to: 350 by: 36)
				collect: [:angle | (Point r: (oldR := oldR = ext
									ifTrue: [ext * 5 // 12]
									ifFalse: [ext]) degrees: angle + pt degrees)
						+ sOrigin].
	poly := PolygonMorph new addHandles.
	poly borderColor: (cColor isTransparent ifTrue: [Color black] ifFalse: [cColor]).
	poly borderWidth: (self getNibFor: evt) width.
	poly fillStyle: Color transparent.

	"can't handle thick brushes"
	self invalidRect: rect.
	"self addMorph: poly."
	poly privateOwner: self.
	poly
		bounds: (sOrigin extent: ext).
	poly setVertices: verts.
	poly drawOn: formCanvas.
	"poly delete."
	self invalidRect: rect! !

!SketchEditorMorph methodsFor: 'access' stamp: 'dgd 2/21/2003 23:07'!
ticksToDwell
	ticksToDwell isNil ifTrue: [ticksToDwell := 1].
	^ticksToDwell! !

!SketchEditorMorph methodsFor: 'access' stamp: ''!
ticksToDwell: t
	ticksToDwell := t! !

!SketchEditorMorph methodsFor: 'actions & preps' stamp: 'tk 9/3/97 21:17'!
toggleDirType: evt in: handle
	"Toggle from 'rotate' to 'to and fro' to 'up and down' to 'none'
for the kind of rotation the object does.  An actor's rotationStyle is one
of #(normal leftRight upDown none)."

| rr ii |
"Clear the indicator"

"Find new style, store it, install the indicator"
rr := self rotationStyle.
ii := #(normal leftRight upDown none) indexOf: rr.
self setProperty: #rotationStyle toValue:
	(#(leftRight upDown none normal) at: ii).
ii = 4 ifTrue: ["normal" self forward: self forwardDirection
			direction: (self valueOfProperty: #fwdButton)]
	ifFalse: [self showDirType.].! !

!SketchEditorMorph methodsFor: 'start & finish' stamp: 'nk 7/30/2004 17:55'!
undo: evt 
	"revert to a previous state.  "

	| temp poly pen |
	self flag: #bob.	"what is undo in multihand environment?"
	undoBuffer ifNil: [^Beeper beep].	"nothing to go back to"
	(poly := self valueOfProperty: #polygon) ifNotNil: 
			[poly delete.
			self setProperty: #polygon toValue: nil.
			^self].
	temp := paintingForm.
	paintingForm := undoBuffer.
	undoBuffer := temp.	"can get back to what you had by undoing again"
	pen := self get: #paintingFormPen for: evt.
	pen ifNil: [^Beeper  beep].
	pen setDestForm: paintingForm.
	formCanvas := paintingForm getCanvas.	"used for lines, ovals, etc."
	formCanvas := formCanvas copyOrigin: self topLeft negated
				clipRect: (0 @ 0 extent: bounds extent).
	self render: bounds! !

!SketchEditorMorph methodsFor: 'palette handling' stamp: 'RAA 8/16/2000 11:17'!
undoPainting: aPaintBoxMorph evt: evt
	"Undo the operation after user issued #undo in aPaintBoxMorph"
	^self undo: evt! !

!SketchEditorMorph methodsFor: 'Nebraska support' stamp: 'RAA 8/15/2000 15:12'!
valuesForHand: anEventOrHand

	| hand valuesForHand |
	forEachHand ifNil: [forEachHand := IdentityDictionary new].
	hand := (anEventOrHand isKindOf: HandMorph) 
				ifTrue: [anEventOrHand] ifFalse: [anEventOrHand hand].
	valuesForHand := forEachHand at: hand ifAbsentPut: [Dictionary new].
	^valuesForHand

! !

!SketchEditorMorph methodsFor: 'Nebraska support' stamp: 'gm 2/22/2003 12:59'!
valuesForHandIfPresent: anEventOrHand 
	| hand |
	forEachHand ifNil: [forEachHand := IdentityDictionary new].
	hand := (anEventOrHand isHandMorph) 
				ifTrue: [anEventOrHand]
				ifFalse: [anEventOrHand hand].
	^forEachHand at: hand ifAbsent: [nil]! !

!SketchEditorMorph methodsFor: 'start & finish' stamp: 'ar 10/10/2000 16:47'!
verifyState: evt
	| myAction |
	"We are sure we will make a mark now.  Make sure the palette has not changed state while we were away.  If so, end this action and start another one.  6/11/97 19:52 tk  action, currentColor, brush"

	"Install the brush, color, (replace mode), and cursor."
	palette isInWorld ifFalse:
		[self world addMorphFront: palette].  "It happens.  might want to position it also"
	myAction := self getActionFor: evt.
	(self get: #changed for: evt) == false ifFalse: [
		self set: #changed for: evt to: false.
		self invalidRect: rotationButton bounds.	"snap these back"
		rotationButton position: bounds topCenter - (6@0).		"later adjust by button width?"
		self invalidRect: rotationButton bounds.
		self invalidRect: scaleButton bounds.
		scaleButton position: bounds rightCenter - ((scaleButton width)@6).
		self invalidRect: scaleButton bounds.
		myAction == #polygon: ifFalse: [self polyFreeze].		"end polygon mode"
		^ self set: #action for: evt to: (self prepareToPaint: evt)].

! !

!SketchEditorMorph methodsFor: 'copying' stamp: 'tk 1/8/1999 09:24'!
veryDeepFixupWith: deepCopier
	"If target and arguments fields were weakly copied, fix them here.  If they were in the tree being copied, fix them up, otherwise point to the originals!!!!"

super veryDeepFixupWith: deepCopier.
hostView := deepCopier references at: hostView ifAbsent: [hostView].
enclosingPasteUpMorph := deepCopier references at: enclosingPasteUpMorph 
			ifAbsent: [enclosingPasteUpMorph].! !

!SketchEditorMorph methodsFor: 'copying' stamp: 'RAA 8/16/2000 12:29'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

super veryDeepInner: deepCopier.
"hostView := hostView.		Weakly copied"
	"stampForm := stampForm veryDeepCopyWith: deepCopier."
	"canvasRectangle := canvasRectangle veryDeepCopyWith: deepCopier."
palette := palette veryDeepCopyWith: deepCopier.
	"currentColor := currentColor veryDeepCopyWith: deepCopier."
ticksToDwell := ticksToDwell veryDeepCopyWith: deepCopier.
rotationCenter := rotationCenter veryDeepCopyWith: deepCopier.
registrationPoint := registrationPoint veryDeepCopyWith: deepCopier.
newPicBlock := newPicBlock veryDeepCopyWith: deepCopier.
emptyPicBlock := emptyPicBlock veryDeepCopyWith: deepCopier.
	"action := action veryDeepCopyWith: deepCopier."
paintingForm := paintingForm veryDeepCopyWith: deepCopier.
dimForm := dimForm veryDeepCopyWith: deepCopier.
	"buff := buff veryDeepCopyWith: deepCopier."
	"brush := brush veryDeepCopyWith: deepCopier."
	"paintingFormPen := paintingFormPen veryDeepCopyWith: deepCopier."
formCanvas := formCanvas veryDeepCopyWith: deepCopier.
	"picToBuff := picToBuff veryDeepCopyWith: deepCopier."
	"brushToBuff := brushToBuff veryDeepCopyWith: deepCopier."
	"buffToBuff := buffToBuff veryDeepCopyWith: deepCopier."
	"buffToPic := buffToPic veryDeepCopyWith: deepCopier."
rotationButton := rotationButton veryDeepCopyWith: deepCopier.
scaleButton := scaleButton veryDeepCopyWith: deepCopier.
	"strokeOrigin := strokeOrigin veryDeepCopyWith: deepCopier."
cumRot := cumRot veryDeepCopyWith: deepCopier.
cumMag := cumMag veryDeepCopyWith: deepCopier.
undoBuffer := undoBuffer veryDeepCopyWith: deepCopier.
	"lastEvent := lastEvent veryDeepCopyWith: deepCopier."
	"currentNib := currentNib veryDeepCopyWith: deepCopier."
enclosingPasteUpMorph := enclosingPasteUpMorph.	"weakly copied"
forEachHand := nil.	"hmm..."                              ! !

!SketchEditorMorph methodsFor: 'e-toy support' stamp: 'yo 2/17/2005 14:31'!
wantsHaloFromClick

	^ Preferences eToyFriendly not.
! !

Morph subclass: #SpeakerMorph
	instanceVariableNames: 'bufferSize buffer lastConePosition sound'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SoundInterface'!

!SpeakerMorph methodsFor: 'initialization' stamp: 'nk 6/12/2004 10:05'!
addGraphic

	| graphic |
	graphic := World drawingClass withForm: self speakerGraphic.
	graphic position: bounds center - (graphic extent // 2).
	self addMorph: graphic.
! !

!SpeakerMorph methodsFor: 'speaker' stamp: 'jdl 3/28/2003 09:38'!
appendSample: aFloat 
	"Append the given sample, a number between -100.0 and 100.0, to my buffer. Flush the buffer if it is full."

	lastConePosition := aFloat.
	lastConePosition := lastConePosition min: 100.0.
	lastConePosition := lastConePosition max: -100.0.
	buffer nextPut: (327.67 * lastConePosition) truncated.
	buffer position >= bufferSize ifTrue: [self flushBuffer]
! !

!SpeakerMorph methodsFor: 'speaker' stamp: 'jm 4/21/1999 10:18'!
conePosition

	^ lastConePosition
! !

!SpeakerMorph methodsFor: 'speaker' stamp: 'jm 4/22/1999 16:46'!
conePosition: aNumber

	self appendSample: aNumber asFloat.  "sets lastConePosition"
! !

!SpeakerMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:51'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color
		r: 1.0
		g: 0.484
		b: 0.258! !

!SpeakerMorph methodsFor: 'speaker' stamp: 'jm 4/22/1999 13:29'!
flushBuffer

	| buf |
	buf := buffer contents.
	buffer resetContents.
	sound isPlaying ifFalse: [sound := SequentialSound new].
	sound add: (SampledSound samples: buf samplingRate: 11025).
	sound isPlaying
		ifTrue: [sound pruneFinishedSounds]
		ifFalse: [sound play].
! !

!SpeakerMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:51'!
initialize
"initialize the state of the receiver"
	super initialize.
""
	self addGraphic.
	bufferSize := 5000.
	buffer := WriteStream
				on: (SoundBuffer newMonoSampleCount: bufferSize).
	lastConePosition := 0.
	sound := SequentialSound new! !

!SpeakerMorph methodsFor: 'initialization' stamp: 'jm 4/22/1999 22:58'!
speakerGraphic

	^ Form
		extent: 19@18
		depth: 8
		fromArray: #(0 0 1493172224 2816 0 0 0 1493172224 11 0 0 138 1493172224 184549376 184549376 0 35509 2315255808 720896 720896 0 9090522 2315255808 2816 720896 0 2327173887 2315255819 2816 720896 138 3051028442 2315255819 2816 2816 1505080590 4294957786 2315255808 184549387 2816 3053453311 4292532917 1493172224 184549387 2816 1505080714 3048584629 1493172224 184549387 2816 9079434 3048584629 1493172224 184549387 2816 138 2327164341 1493172235 2816 2816 0 2324346293 1493172235 2816 720896 0 9079477 1493172224 2816 720896 0 35466 1493172224 720896 720896 0 138 0 184549376 184549376 0 0 0 11 0 0 0 0 2816 0)
		offset: 0@0
! !

!SpeakerMorph methodsFor: 'speaker' stamp: 'jm 4/22/1999 15:33'!
stopSound

	sound pause.
	buffer resetContents.
! !

Morph subclass: #SquishedNameMorph
	instanceVariableNames: 'target getSelector setSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Navigators'!

!SquishedNameMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/11/2000 23:19'!
colorAroundName

	^Color gray: 0.8! !

!SquishedNameMorph methodsFor: 'drawing' stamp: 'RAA 11/11/2000 23:17'!
drawOn: aCanvas

	| font stringToShow nameForm rectForName |

	super drawOn: aCanvas.
	self isEditingName ifTrue: [^self].

	font := self fontForName.
	stringToShow := self stringToShow.
	nameForm := (StringMorph contents: stringToShow font: font) imageForm.
	nameForm := nameForm scaledToSize: (self extent - (4@2) min: nameForm extent).
	rectForName := self bottomLeft + 
			(self width - nameForm width // 2 @ (nameForm height + 2) negated)
				extent: nameForm extent.
	rectForName topLeft eightNeighbors do: [ :pt |
		aCanvas
			stencil: nameForm 
			at: pt
			color: self colorAroundName.
	].
	aCanvas
		stencil: nameForm 
		at: rectForName topLeft 
		color: Color black.


	
! !

!SquishedNameMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/11/2000 23:18'!
fontForName

	| pickem |
	pickem := 3.

	pickem = 1 ifTrue: [
		^(((TextStyle named: #Helvetica) ifNil: [TextStyle default]) fontOfSize: 13) emphasized: 1.
	].
	pickem = 2 ifTrue: [
		^(((TextStyle named: #Palatino) ifNil: [TextStyle default]) fontOfSize: 12) emphasized: 1.
	].
	^((TextStyle default) fontAt: 1) emphasized: 1
! !

!SquishedNameMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/11/2000 23:17'!
isEditingName

	^((self findA: UpdatingStringMorph) ifNil: [^false]) hasFocus
! !

!SquishedNameMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/11/2000 23:32'!
stringToShow

	(target isNil or: [getSelector isNil]) ifTrue: [^'????'].
	^target perform: getSelector! !

!SquishedNameMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/11/2000 23:31'!
target: aTarget getSelector: symbol1 setSelector: symbol2

	target := aTarget.
	getSelector := symbol1.
	setSelector := symbol2.! !

Morph subclass: #TransitionMorph
	instanceVariableNames: 'startMorph endMorph startBlock completionBlock stepNumber nSteps stepTime startForm endForm effect direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!TransitionMorph commentStamp: '<historical>' prior: 0!
A transitionMorph inserts itself in the morphic object structure during a visual transition.  It has a stepNumber that runs from 1 to nSteps.  This class handles a large family of wipe-like transitions by itself.  Subclasses may implement other transitions such as dissolves and zooms.!

!TransitionMorph classSide methodsFor: 'available effects' stamp: 'di 12/22/1998 20:58'!
allEffects
	^ #(none
		slideOver slideBoth slideAway slideBorder
		pageForward pageBack 
		frenchDoor
		zoomFrame zoom
		dissolve)! !

!TransitionMorph classSide methodsFor: 'available effects' stamp: 'di 12/22/1998 20:59'!
directionsForEffect: eff
	 "All these arrays are ordered so inverse is atWrap: size//2."
	(#(slideOver slideBoth slideAway slideBorder) includes: eff)
		ifTrue: [^ #(right downRight down downLeft left upLeft up upRight)].
	(#(pageForward pageBack) includes: eff)
		ifTrue: [^ #(right down left up)].
	(#(frenchDoor) includes: eff)
		ifTrue: [^ #(in inH out outH)].
	(#(zoomFrame zoom) includes: eff)
		ifTrue: [^ #(in out)].
	^ Array new! !

!TransitionMorph classSide methodsFor: 'initialization' stamp: 'di 12/20/1998 22:01'!
effect: effectSymbol direction: dirSymbol
	^ self new effect: effectSymbol direction: dirSymbol! !

!TransitionMorph classSide methodsFor: 'initialization' stamp: 'di 12/20/1998 21:37'!
effect: effectSymbol direction: dirSymbol inverse: inverse
	| invEffect invDir i dirSet |
	inverse ifFalse: [^ self effect: effectSymbol direction: dirSymbol].

	invEffect := effectSymbol.
	effectSymbol = #pageForward ifTrue: [invEffect := #pageBack].
	effectSymbol = #pageBack ifTrue: [invEffect := #pageForward].
	effectSymbol = #slideOver ifTrue: [invEffect := #slideAway].
	effectSymbol = #slideAway ifTrue: [invEffect := #slideOver].

	invDir := dirSymbol.
	dirSet := self directionsForEffect: effectSymbol.
	(i := dirSet indexOf: dirSymbol) > 0
		ifTrue: [invDir := dirSet atWrap: i + (dirSet size // 2)].

	^ self effect: invEffect direction: invDir! !

!TransitionMorph classSide methodsFor: 'new-morph participation' stamp: 'di 11/16/1998 15:37'!
includeInNewMorphMenu
	"Transitions aren't meaningful without initializations"
	^ false! !

!TransitionMorph methodsFor: 'drawing' stamp: 'di 1/5/1999 08:37'!
areasRemainingToFill: aRectangle
	"May be overridden by any subclasses with opaque regions"

	^ aRectangle areasOutside: self bounds! !

!TransitionMorph methodsFor: 'updating' stamp: 'di 12/22/1998 20:59'!
changed
	"The default (super) method is, generally much slower than need be, since many transitions only change part of the screen on any given step of the animation.  The purpose of this method is to effect some of those savings."
	| loc box boxPrev h w |
	(stepNumber between: 1 and: nSteps) ifFalse: [^ super changed].
	effect = #slideBoth ifTrue: [^ super changed].
	effect = #slideOver ifTrue:
		[loc := self stepFrom: self position - (self extent * direction) to: self position.
		^ self invalidRect: (((loc extent: self extent) expandBy: 1) intersect: bounds)].
	effect = #slideAway ifTrue:
		[loc := self prevStepFrom: self position to: self position + (self extent * direction).
		^ self invalidRect: (((loc extent: self extent) expandBy: 1) intersect: bounds)].
	effect = #slideBorder ifTrue:
		[box := endForm boundingBox translateBy:
				(self stepFrom: self topLeft - (self extent * direction) to: self topLeft).
		boxPrev := endForm boundingBox translateBy:
				(self prevStepFrom: self topLeft - (self extent * direction) to: self topLeft).
		^ self invalidate: (box expandBy: 1) areasOutside: boxPrev].
	effect = #pageForward ifTrue:
		[loc := self prevStepFrom: 0@0 to: self extent * direction.
		^ self invalidRect: (((bounds translateBy: loc) expandBy: 1) intersect: bounds)].
	effect = #pageBack ifTrue:
		[loc := self stepFrom: self extent * direction negated to: 0@0.
		^ self invalidRect: (((bounds translateBy: loc) expandBy: 1) intersect: bounds)].
	effect = #frenchDoor ifTrue:
		[h := self height. w := self width.
		direction = #in ifTrue:
			[box := Rectangle center: self center
							extent: (self stepFrom: 0@h to: self extent).
			boxPrev := Rectangle center: self center
							extent: (self prevStepFrom: 0@h to: self extent).
			^ self invalidate: (box expandBy: 1) areasOutside: boxPrev].
		direction = #out ifTrue:
			[box := Rectangle center: self center
							extent: (self stepFrom: self extent to: 0@h).
			boxPrev := Rectangle center: self center
							extent: (self prevStepFrom: self extent to: 0@h).
			^ self invalidate: (boxPrev expandBy: 1) areasOutside: box].
		direction = #inH ifTrue:
			[box := Rectangle center: self center
							extent: (self stepFrom: w@0 to: self extent).
			boxPrev := Rectangle center: self center
							extent: (self prevStepFrom: w@0 to: self extent).
			^ self invalidate: (box expandBy: 1) areasOutside: boxPrev].
		direction = #outH ifTrue:
			[box := Rectangle center: self center
							extent: (self stepFrom: self extent to: w@0).
			boxPrev := Rectangle center: self center
							extent: (self prevStepFrom: self extent to: w@0).
			^ self invalidate: (boxPrev expandBy: 1) areasOutside: box]].
	effect = #zoomFrame ifTrue:
		[direction = #in ifTrue:
			[box := Rectangle center: self center
							extent: (self stepFrom: 0@0 to: self extent).
			boxPrev := Rectangle center: self center
							extent: (self prevStepFrom: 0@0 to: self extent).
			^ self invalidate: (box expandBy: 1) areasOutside: boxPrev].
		direction = #out ifTrue:
			[box := Rectangle center: self center
							extent: (self stepFrom: self extent to: 0@0).
			boxPrev := Rectangle center: self center
							extent: (self prevStepFrom: self extent to: 0@0).
			^ self invalidate: (boxPrev expandBy: 1) areasOutside: box]].
	effect = #zoom ifTrue:
		[box := Rectangle center: self center extent:
			(direction = #in
				ifTrue: [self stepFrom: 0@0 to: self extent]
				ifFalse: [self prevStepFrom: self extent to: 0@0]).
		^ self invalidRect: ((box expandBy: 1) intersect: bounds)].
	^ super changed
! !

!TransitionMorph methodsFor: 'initialization' stamp: 'di 12/22/1998 12:52'!
completeReplacement

	self delete.
	completionBlock value! !

!TransitionMorph methodsFor: 'drawing' stamp: 'ar 2/12/2000 18:01'!
drawDissolveOn: aCanvas
	"startForm and endFrom are both fixed, but the dissolve ration changes."

	startForm copyBits: endForm at: 0@0 translucent: stepNumber asFloat / (nSteps*2).

	aCanvas drawImage: startForm at: self position.
! !

!TransitionMorph methodsFor: 'drawing' stamp: 'ar 2/12/2000 18:01'!
drawFrenchDoorOn: aCanvas
	"startForm and endFrom are both fixed, but a border expands out from a vertical (or H) slit, revealing endForm.
	It's like opening a pair of doors."
	| box innerForm outerForm boxExtent h w |
	h := self height. w := self width.
	direction = #in ifTrue: [innerForm := endForm.  outerForm := startForm.
							boxExtent := self stepFrom: 0@h to: self extent].
	direction = #out ifTrue: [innerForm := startForm.  outerForm := endForm.
							boxExtent := self stepFrom: self extent to: 0@h].
	direction = #inH ifTrue: [innerForm := endForm.  outerForm := startForm.
							boxExtent := self stepFrom: w@0 to: self extent].
	direction = #outH ifTrue: [innerForm := startForm.  outerForm := endForm.
							boxExtent := self stepFrom: self extent to: w@0].
		
	aCanvas drawImage: outerForm at: self position.

	box := Rectangle center: self center extent: boxExtent.
	aCanvas drawImage: innerForm at: box topLeft sourceRect: (box translateBy: self position negated).

	((box expandBy: 1) areasOutside: box) do:
		[:r | aCanvas fillRectangle: r color: Color black].
! !

!TransitionMorph methodsFor: 'drawing' stamp: 'di 12/22/1998 20:58'!
drawOn: aCanvas
	"During the transition process, the reveal and obscure areas will be invalidated,
	so we should be drawing on a canvas that clips to only the changing region."

	(stepNumber between: 1 and: nSteps) ifFalse: [^ self].
	effect = #slideOver ifTrue: [^ self drawSlideOverOn: aCanvas].
	effect = #slideBoth ifTrue: [^ self drawSlideBothOn: aCanvas].
	effect = #slideAway ifTrue: [^ self drawSlideAwayOn: aCanvas].
	effect = #slideBorder ifTrue: [^ self drawSlideBorderOn: aCanvas].
	effect = #pageForward ifTrue: [^ self drawPageForwardOn: aCanvas].
	effect = #pageBack ifTrue: [^ self drawPageBackOn: aCanvas].
	effect = #frenchDoor ifTrue: [^ self drawFrenchDoorOn: aCanvas].
	effect = #zoomFrame ifTrue: [^ self drawZoomFrameOn: aCanvas].
	effect = #zoom ifTrue: [^ self drawZoomOn: aCanvas].
	effect = #dissolve ifTrue: [^ self drawDissolveOn: aCanvas].
! !

!TransitionMorph methodsFor: 'drawing' stamp: 'ar 2/12/2000 18:01'!
drawPageBackOn: aCanvas
	"endForm grows in the given direction, overlaying endForm."
	| offset growRect scale |
	aCanvas drawImage: startForm at: self position.

	offset := self stepFrom: self extent * direction negated to: 0@0.
	growRect := (bounds translateBy: offset) intersect: bounds.
	scale := growRect extent asFloatPoint / bounds extent.
	aCanvas drawImage: (endForm magnify: endForm boundingBox by: scale smoothing: 1)
		at: growRect topLeft.

	((growRect translateBy: direction) areasOutside: growRect) do:
		[:r | aCanvas fillRectangle: r color: Color black].
! !

!TransitionMorph methodsFor: 'drawing' stamp: 'ar 2/12/2000 18:02'!
drawPageForwardOn: aCanvas
	"startForm shrinks in the given direction, revealing endForm."
	| offset shrinkRect scale |
	aCanvas drawImage: endForm at: self position.

	offset := self stepFrom: 0@0 to: self extent * direction.
	shrinkRect := (bounds translateBy: offset) intersect: bounds.
	scale := shrinkRect extent asFloatPoint / bounds extent.
	aCanvas drawImage: (startForm magnify: startForm boundingBox by: scale smoothing: 1)
		at: shrinkRect topLeft.

	((shrinkRect translateBy: direction negated) areasOutside: shrinkRect) do:
		[:r | aCanvas fillRectangle: r color: Color black].
! !

!TransitionMorph methodsFor: 'drawing' stamp: 'ar 2/12/2000 18:02'!
drawSlideAwayOn: aCanvas
	"startMorph slides away in the given direction, revealing up the endMorph."
	| startLoc moveRect |
	startLoc := self stepFrom: self position to: self position + (self extent * direction).
	moveRect := startForm boundingBox translateBy: startLoc.

	aCanvas drawImage: endForm at: self position.
	aCanvas drawImage: startForm at: startLoc.

	((moveRect translateBy: direction negated) areasOutside: moveRect) do:
		[:r | aCanvas fillRectangle: r color: Color black].
! !

!TransitionMorph methodsFor: 'drawing' stamp: 'ar 2/12/2000 18:02'!
drawSlideBorderOn: aCanvas
	"startForm and endFrom are both fixed, but a border slides in the given direction, revealing endForm.  (It's like opening a can of sardines ;-)."
	| endRect box sourceRect boxLoc |
	box := endForm boundingBox.
	boxLoc := self stepFrom: box topLeft - (box extent * direction) to: box topLeft.
	sourceRect := box translateBy: boxLoc.
	endRect := sourceRect translateBy: self position.

	((endRect expandBy: 1) containsRect: aCanvas clipRect) ifFalse:
		[aCanvas drawImage: startForm at: self position].
	aCanvas drawImage: endForm at: self position + boxLoc sourceRect: sourceRect.

	((endRect translateBy: direction) areasOutside: endRect) do:
		[:r | aCanvas fillRectangle: r color: Color black].
! !

!TransitionMorph methodsFor: 'drawing' stamp: 'ar 2/12/2000 18:02'!
drawSlideBothOn: aCanvas
	"endMorph slides in the given direction, as startMorph slides out of its way."
	| endLoc endRect startLoc |
	startLoc := self stepFrom: self position to: self position + (self extent * direction).
	aCanvas drawImage: startForm at: startLoc.

	endLoc := self stepFrom: self position - (self extent * direction) to: self position.
	aCanvas drawImage: endForm at: endLoc.

	endRect := endForm boundingBox translateBy: endLoc.
	((endRect translateBy: direction) areasOutside: endRect) do:
		[:r | aCanvas fillRectangle: r color: Color black].
! !

!TransitionMorph methodsFor: 'drawing' stamp: 'ar 2/12/2000 18:03'!
drawSlideOverOn: aCanvas
	"endMorph slides in the given direction, covering up the startMorph."
	| endLoc endRect |
	endLoc := self stepFrom: self position - (self extent * direction) to: self position.
	endRect := endForm boundingBox translateBy: endLoc.

	((endRect expandBy: 1) containsRect: aCanvas clipRect) ifFalse:
		[aCanvas drawImage: startForm at: self position].
	aCanvas drawImage: endForm at: endLoc.

	((endRect translateBy: direction) areasOutside: endRect) do:
		[:r | aCanvas fillRectangle: r color: Color black].
! !

!TransitionMorph methodsFor: 'drawing' stamp: 'ar 2/12/2000 18:03'!
drawZoomFrameOn: aCanvas
	"startForm and endFrom are both fixed, but a square border expands out from the center (or back), revealing endForm.
	It's like passing through a portal."
	| box innerForm outerForm boxExtent |
	direction = #in
		ifTrue: [innerForm := endForm.  outerForm := startForm.
				boxExtent := self stepFrom: 0@0 to: self extent]
		ifFalse: [innerForm := startForm.  outerForm := endForm.
				boxExtent := self stepFrom: self extent to: 0@0].
		
	aCanvas drawImage: outerForm at: self position.

	box := Rectangle center: self center extent: boxExtent.
	aCanvas drawImage: innerForm at: box topLeft sourceRect: (box translateBy: self position negated).

	((box expandBy: 1) areasOutside: box) do:
		[:r | aCanvas fillRectangle: r color: Color black].
! !

!TransitionMorph methodsFor: 'drawing' stamp: 'ar 2/12/2000 18:03'!
drawZoomOn: aCanvas
	"Zoom in: endForm expands overlaying startForm.
	Zoom out: startForm contracts revealing endForm."
	| box innerForm outerForm boxExtent scale |
	direction = #in
		ifTrue: [innerForm := endForm.  outerForm := startForm.
				boxExtent := self stepFrom: 0@0 to: self extent]
		ifFalse: [innerForm := startForm.  outerForm := endForm.
				boxExtent := self stepFrom: self extent to: 0@0].

	aCanvas drawImage: outerForm at: self position.

	box := Rectangle center: self center extent: boxExtent.
	scale := box extent asFloatPoint / bounds extent.
	aCanvas drawImage: (innerForm magnify: innerForm boundingBox by: scale smoothing: 1)
		at: box topLeft.

	((box expandBy: 1) areasOutside: box) do:
		[:r | aCanvas fillRectangle: r color: Color black].
! !

!TransitionMorph methodsFor: 'private' stamp: 'aoy 2/17/2003 01:09'!
effect: effectSymbol direction: dirSymbol 
	| i |
	effect := effectSymbol.

	"Default directions"
	(#(#zoom #zoomFrame #frenchDoor) includes: effectSymbol) 
		ifTrue: 
			[direction := (#(#in #out #inH #outH) includes: dirSymbol) 
				ifTrue: [dirSymbol]
				ifFalse: [#in]]
		ifFalse: 
			[i := #(#right #downRight #down #downLeft #left #upLeft #up #upRight) 
						indexOf: dirSymbol
						ifAbsent: [5].
			direction := (0 @ 0) eightNeighbors at: i]! !

!TransitionMorph methodsFor: 'initialization' stamp: 'dgd 2/22/2003 14:22'!
initiateReplacement
	| n |
	startForm := effect = #dissolve 
				ifTrue: [(startMorph imageForm: 16 forRectangle: bounds) offset: 0 @ 0]
				ifFalse: [(startMorph imageFormForRectangle: bounds) offset: 0 @ 0].
	endForm := (endMorph imageFormForRectangle: bounds) offset: 0 @ 0.
	nSteps isNil 
		ifTrue: 
			[self nSteps: 30 stepTime: 10.
			(#(#zoom #pageForward #pageBack) includes: effect) 
				ifTrue: 
					[n := 20 * 100000 // self bounds area min: 20 max: 4.
					self nSteps: n stepTime: 10].
			#dissolve = effect 
				ifTrue: 
					[n := 20 * 50000 // self bounds area min: 20 max: 4.
					self nSteps: n stepTime: 10]].
	startBlock value.	"with forms in place there should b no further delay."
	self arrangeToStartStepping! !

!TransitionMorph methodsFor: 'change reporting' stamp: 'di 12/22/1998 20:10'!
invalidate: box1 areasOutside: box2

	((box1 intersect: bounds) areasOutside: (box2 intersect: bounds))
		do: [:r | self invalidRect: r]! !

!TransitionMorph methodsFor: 'initialization' stamp: 'di 12/14/1998 12:25'!
nSteps: n stepTime: msPerStep
	nSteps := n.
	stepTime := msPerStep! !

!TransitionMorph methodsFor: 'private' stamp: 'di 12/15/1998 11:42'!
prevStepFrom: p1 to: p2
	"Used for recalling dimensions from previous step."

	^ (p2-p1) * (stepNumber-1) // nSteps + p1! !

!TransitionMorph methodsFor: 'initialization' stamp: 'di 12/22/1998 13:32'!
showTransitionFrom: startingMorph to: endingMorph in: containingMorph
	whenStart: firstBlock whenDone: doneBlock

	effect == #none ifTrue: [firstBlock value.  ^ doneBlock value].

	self startMorph: startingMorph endMorph: endingMorph
		startBlock: firstBlock completionBlock: doneBlock.
	stepNumber := 0.

	self bounds: startingMorph bounds.
	endingMorph privateOwner: self.  "Allows test of transition in progress"
	containingMorph owner privateAddMorph: self atIndex: 
		(containingMorph owner submorphs indexOf: containingMorph).

	self initiateReplacement! !

!TransitionMorph methodsFor: 'initialization' stamp: 'di 12/20/1998 10:46'!
startMorph: start endMorph: end startBlock: firstBlock completionBlock: aBlock
	startMorph := start.
	endMorph := end.
	startBlock := firstBlock.
	completionBlock := aBlock! !

!TransitionMorph methodsFor: 'stepping and presenter' stamp: 'di 12/14/1998 12:30'!
step
	(stepNumber := stepNumber + 1) <= nSteps
		ifTrue: [self changed]
		ifFalse: [self completeReplacement]! !

!TransitionMorph methodsFor: 'private' stamp: 'di 12/14/1998 12:43'!
stepFrom: p1 to: p2
	"This gives p1 for stepCount = 0, moving to p2 for stepCount = nSteps"

	^ (p2-p1) * stepNumber // nSteps + p1! !

!TransitionMorph methodsFor: 'testing' stamp: 'di 12/15/1998 13:52'!
stepTime
	^ stepTime! !

!SimpleButtonMorph methodsFor: '*MorphicExtras-e-toy support' stamp: 'ar 3/17/2001 20:17'!
adaptToWorld: aWorld
	super adaptToWorld: aWorld.
	target := target adaptedToWorld: aWorld.! !

!SimpleButtonMorph methodsFor: '*MorphicExtras-copying' stamp: 'jm 7/28/97 11:52'!
updateReferencesUsing: aDictionary
	"If the arguments array points at a morph we are copying, then point at the new copy.  And also copies the array, which is important!!"

	super updateReferencesUsing: aDictionary.
	arguments := arguments collect:
		[:old | aDictionary at: old ifAbsent: [old]].
! !

SimpleButtonMorph subclass: #SimpleSwitchMorph
	instanceVariableNames: 'onColor offColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!SimpleSwitchMorph commentStamp: 'apb 5/3/2006 16:04' prior: 0!
I represent a switch that can be either on or off.  I chnage my state in response to a mouse click.  When clicked, I also send my actionSelector to my target, just like a SimpleButtonMorph.!

!SimpleSwitchMorph methodsFor: 'button' stamp: 'dgd 2/22/2003 18:40'!
doButtonAction
	"Perform the action of this button. The last argument of the message sent to the target is the new state of this switch."

	| newState |
	(target notNil and: [actionSelector notNil]) 
		ifTrue: 
			[newState := color = onColor.
			target perform: actionSelector
				withArguments: (arguments copyWith: newState)]! !

!SimpleSwitchMorph methodsFor: 'initialization' stamp: 'di 6/5/2000 08:44'!
initialize

	^ self initializeWithLabel: 'Toggle'
! !

!SimpleSwitchMorph methodsFor: 'initialization' stamp: 'apb 5/3/2006 15:51'!
initializeWithLabel: labelString

	super initializeWithLabel: labelString.
	self borderWidth: 3.
	self extent: self extent + 2.
	onColor := Color r: 1.0 g: 0.6 b: 0.6.
	offColor := Color lightGray.
	color := offColor
! !

!SimpleSwitchMorph methodsFor: 'switching' stamp: 'apb 5/3/2006 15:45'!
isOff
	^ color ~= onColor! !

!SimpleSwitchMorph methodsFor: 'switching' stamp: 'apb 5/3/2006 15:45'!
isOn
	^ color = onColor! !

!SimpleSwitchMorph methodsFor: 'event handling' stamp: 'ar 6/4/2001 00:39'!
mouseDown: evt

	oldColor := self fillStyle.! !

!SimpleSwitchMorph methodsFor: 'event handling' stamp: 'jm 1/30/98 13:55'!
mouseMove: evt

	(self containsPoint: evt cursorPoint)
		ifTrue: [self setSwitchState: (oldColor = offColor)]
		ifFalse: [self setSwitchState: (oldColor = onColor)].
! !

!SimpleSwitchMorph methodsFor: 'event handling' stamp: 'jm 1/30/98 13:58'!
mouseUp: evt

	(self containsPoint: evt cursorPoint)
		ifTrue: [  "toggle and do action"
			self setSwitchState: (oldColor = offColor).
			self doButtonAction]
		ifFalse: [  "restore old appearance"
			self setSwitchState: (oldColor = onColor)].
! !

!SimpleSwitchMorph methodsFor: 'switching' stamp: 'jm 1/29/98 20:18'!
offColor

	^ offColor
! !

!SimpleSwitchMorph methodsFor: 'switching' stamp: 'jm 1/29/98 20:18'!
offColor: aColor

	offColor := aColor.
! !

!SimpleSwitchMorph methodsFor: 'switching' stamp: 'jm 1/29/98 20:18'!
onColor

	^ onColor
! !

!SimpleSwitchMorph methodsFor: 'switching' stamp: 'jm 1/29/98 20:18'!
onColor: aColor

	onColor := aColor.
! !

!SimpleSwitchMorph methodsFor: 'switching' stamp: 'apb 5/3/2006 15:46'!
setSwitchState: aBoolean

	aBoolean
		ifTrue: [self turnOn]
		ifFalse: [self turnOff].
! !

!SimpleSwitchMorph methodsFor: 'switching' stamp: 'apb 5/3/2006 16:11'!
toggleState
	self isOn
		ifTrue: [self turnOff]
		ifFalse: [self turnOn]! !

!SimpleSwitchMorph methodsFor: 'switching' stamp: 'apb 5/3/2006 15:44'!
turnOff
	self borderColor: #raised.
	self color: offColor! !

!SimpleSwitchMorph methodsFor: 'switching' stamp: 'apb 5/3/2006 15:44'!
turnOn
	self borderColor: #inset.
	self color: onColor! !

!StandardScriptingSystem classSide methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/11/2003 19:08'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(ScriptingSystem	prototypicalHolder	'Holder'		'A place for storing alternative pictures in an animation, etc.')
						forFlapNamed: 'PlugIn Supplies'.
						cl registerQuad: #(ScriptingSystem	prototypicalHolder	'Holder'		'A place for storing alternative pictures in an animation, etc.')
						forFlapNamed: 'Supplies'.
						cl registerQuad: #(ScriptingSystem	newScriptingSpace	'Scripting'	'A confined place for drawing and scripting, with its own private stop/step/go buttons.')
						forFlapNamed: 'Widgets'.
						cl registerQuad: #(ScriptingSystem	holderWithAlphabet	'Alphabet'	'A source for single-letter objects')
						forFlapNamed: 'Widgets'.]! !

!StandardScriptingSystem classSide methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/12/2003 14:38'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: ScriptingSystem] ! !

!MessageNames class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/10/2003 12:53'!
initialize

	self registerInFlapsRegistry.	! !

!MessageNames class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/10/2003 12:53'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(MessageNames			prototypicalToolWindow		'Message Names'		'A tool for finding, viewing, and editing all methods whose names contain a given character sequence.')
						forFlapNamed: 'Tools']! !

!MessageNames class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/11/2003 12:37'!
unload
	"Unload the receiver from global registries"

	self environment at: #FileList ifPresent: [:cl |
	cl unregisterFileReader: self].
	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

!Point methodsFor: '*MorphicExtras-*morphic-Postscript Canvases' stamp: ''!
encodePostscriptOn:aStream 
	aStream writePoint:self.! !

PopUpChoiceMorph subclass: #DropDownChoiceMorph
	instanceVariableNames: 'items border'
	classVariableNames: 'SubMenuMarker'
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!DropDownChoiceMorph classSide methodsFor: 'class initialization' stamp: 'bolot 11/2/1999 12:19'!
initialize
	"DropDownChoiceMorph initialize"

	| f |
	f := Form
		extent: 5@9
		fromArray: #(2147483648 3221225472 3758096384 4026531840 4160749568 4026531840 3758096384 3221225472 2147483648)
		offset: 0@0.
	SubMenuMarker := ColorForm mappingWhiteToTransparentFrom: f.
! !

!DropDownChoiceMorph methodsFor: 'accessing' stamp: 'bolot 11/2/1999 12:20'!
border
	^border! !

!DropDownChoiceMorph methodsFor: 'accessing' stamp: 'bolot 11/2/1999 12:20'!
border: newBorder
	border := newBorder! !

!DropDownChoiceMorph methodsFor: 'drawing' stamp: 'ar 12/31/2001 02:35'!
drawOn: aCanvas

	aCanvas drawString: contents in: (bounds insetBy: 2)  font: self fontToUse color: color.

	border ifNotNil: [aCanvas frameAndFillRectangle: bounds
		fillColor: Color transparent
		borderWidth: 1
		borderColor: Color black].

	aCanvas
			paintImage: SubMenuMarker
			at: (self right - 8 @ ((self top + self bottom - SubMenuMarker height) // 2))! !

!DropDownChoiceMorph methodsFor: 'list access' stamp: 'bolot 11/2/1999 12:21'!
getCurrentSelectionIndex
	^self items indexOf: contents! !

!DropDownChoiceMorph methodsFor: 'accessing' stamp: 'bolot 11/2/1999 12:20'!
items
	(target notNil and: [getItemsSelector notNil])
		ifTrue: [items := target perform: getItemsSelector withArguments: getItemsArgs].
	items ifNil: [items := #()].
	^items! !

!DropDownChoiceMorph methodsFor: 'accessing' stamp: 'bolot 11/2/1999 12:20'!
items: someItems
	items := someItems! !

!DropDownChoiceMorph methodsFor: 'drawing' stamp: 'ar 12/31/2001 02:51'!
maxExtent: listOfStrings

	| h w maxW f |
	maxW := 0.
	listOfStrings do: [:str |
		f := self fontToUse.
		w := f widthOfString: str.
		h := f height.
		maxW := maxW max: w].
	self extent: (maxW + 4 + h) @ (h + 4).
	self changed! !

!DropDownChoiceMorph methodsFor: 'event handling' stamp: 'bolot 11/2/1999 12:22'!
mouseDown: evt

	| menu selectedItem |
	self items isEmpty ifTrue: [^ self].
	menu := CustomMenu new.
	self items do: [:item | menu add: item action: item].
	selectedItem := menu startUp.
	selectedItem ifNil: [^ self].
	self contentsClipped: selectedItem.  "Client can override this if necess"
	actionSelector ifNotNil: [
		target
			perform: actionSelector
			withArguments: (arguments copyWith: selectedItem)].
! !

!DropDownChoiceMorph methodsFor: 'list access' stamp: 'bolot 11/2/1999 12:21'!
selection: val
	self contentsClipped: val! !

!DropDownChoiceMorph methodsFor: 'copying' stamp: 'bolot 11/2/1999 12:17'!
veryDeepInner: deepCopier
	super veryDeepInner: deepCopier.
	items := items veryDeepCopyWith: deepCopier.
	border := border veryDeepCopyWith: deepCopier! !

!MatrixTransform2x3 methodsFor: '*MorphicExtras-*morphic-Postscript Canvases' stamp: ''!
encodePostscriptOn: aStream
	aStream writeMatrix:self.
! !

!MorphExtension methodsFor: '*MorphicExtras-accessing' stamp: 'dgd 2/16/2003 21:37'!
isPartsDonor
	"answer whether the receiver is PartsDonor"
	^ isPartsDonor! !

!MorphExtension methodsFor: '*MorphicExtras-accessing' stamp: 'dgd 2/16/2003 21:40'!
isPartsDonor: aBoolean 
	"change the receiver's isPartDonor property"
	isPartsDonor := aBoolean! !

!MorphExtension methodsFor: '*MorphicExtras-copying' stamp: 'md 2/27/2006 08:44'!
updateReferencesUsing: aDictionary 
	"Update intra-morph references within a composite morph that  
	has been copied. For example, if a button refers to morph X in  
	the orginal  
	composite then the copy of that button in the new composite  
	should refer to  
	the copy of X in new composite, not the original X. This default  
	implementation updates the contents of any morph-bearing slot."

	| old |
	eventHandler isNil 
		ifFalse: 
			[self eventHandler: self eventHandler copy.
			1 to: self eventHandler class instSize
				do: 
					[:i | 
					old := eventHandler instVarAt: i.
					old isMorph 
						ifTrue: [eventHandler instVarAt: i put: (aDictionary at: old ifAbsent: [old])]]].
	otherProperties ifNotNil: [otherProperties associationsDo:  [:assn | 
					assn value: (aDictionary at: assn value ifAbsent: [assn value])]]! !

!HTTPDownloadRequest methodsFor: '*MorphicExtras-accessing' stamp: 'mir 1/20/2000 13:33'!
url
	^url! !

!Workspace class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/11/2003 12:13'!
initialize

	self registerInFlapsRegistry.	! !

!Workspace class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/11/2003 12:14'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(Workspace	prototypicalToolWindow	'Workspace'		'A Workspace is a simple window for editing text.  You can later save the contents to a file if you desire.')
						forFlapNamed: 'Tools'.]! !

!Workspace class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/11/2003 12:42'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

!ColorForm methodsFor: '*MorphicExtras-*morphic-Postscript Canvases' stamp: 'sma 6/14/2000 14:20'!
encodePostscriptOn: aStream 
	self unhibernate.
	aStream print: '% form contains ';
	 write: (colors select: [:c | c = Color transparent]) size;
	 print: ' transparent colors';
	 cr.
	^ self asFormWithSingleTransparentColors 
		printPostscript: aStream operator: (self depth = 1
			ifTrue: ['imagemask']
			ifFalse: [(self indexOfColor: Color transparent) printString , ' transparentimage'])! !

!ColorForm methodsFor: '*MorphicExtras-*morphic-Postscript Canvases' stamp: ''!
printPostscript:aStream
	aStream nextPutAll:'% form contains '; 
			print:((colors select:[:c| c=Color transparent]) size); 
			nextPutAll:' transparent colors'; cr.
	^self asFormWithSingleTransparentColors printPostscript:aStream operator:(self depth=1 ifTrue:['imagemask'] 
	ifFalse:[ (self indexOfColor:Color transparent) printString ,' transparentimage']) .
! !

ObjectOut subclass: #MorphObjectOut
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SqueakPage'!

!MorphObjectOut methodsFor: 'as yet unclassified' stamp: 'tk 4/6/1999 10:00'!
doesNotUnderstand: aMessage 
	"Bring in the object, install, then resend aMessage"
	| aMorph myUrl oldFlag response |
	"Transcript show: thisContext sender selector; cr." "useful for debugging"
	oldFlag := recursionFlag.
	recursionFlag := true.
	myUrl := url.	"can't use inst vars after become"
	"fetch the object"
	aMorph := self xxxFetch.		"watch out for the become!!"
			"Now we ARE a MORPH"
	oldFlag == true ifTrue: [
		response := (PopUpMenu labels: 'proceed normally\debug' withCRs)
			startUpWithCaption: 'Object being fetched for a second time.
Should not happen, and needs to be fixed later.'.
		response = 2 ifTrue: [self halt]].	"We are already the new object"

	aMorph setProperty: #SqueakPage toValue: 
			(SqueakPageCache pageCache at: myUrl).
	"Can't be a super message, since this is the first message sent to this object"
	^ aMorph perform: aMessage selector withArguments: aMessage arguments
! !

!MorphObjectOut methodsFor: 'as yet unclassified' stamp: 'tk 10/22/1998 15:43'!
fullReleaseCachedState
	"do nothing, especially don't bring in my object!!"! !

!MorphObjectOut methodsFor: 'as yet unclassified' stamp: 'tk 2/24/1999 00:08'!
smallThumbnailForPageSorter

	^ self sqkPage thumbnail! !

!MorphObjectOut methodsFor: 'as yet unclassified' stamp: 'tk 2/24/1999 00:09'!
thumbnailForPageSorter

	^ self sqkPage thumbnail! !

!ObjectOut methodsFor: '*MorphicExtras-access' stamp: 'tk 12/4/1998 13:01'!
sqkPage
	^ page! !

!ObjectOut methodsFor: '*MorphicExtras-access' stamp: 'tk 12/4/1998 13:01'!
url
	^ url! !

!BalloonMorph methodsFor: '*MorphicExtras-classification' stamp: 'ar 9/15/2000 17:56'!
isBalloonHelp
	^true! !

FlattenEncoder subclass: #ByteEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Postscript Filters'!

!ByteEncoder classSide methodsFor: 'configuring' stamp: 'MPW 1/1/1901 01:18'!
defaultTarget
	^WriteStream on:(String new: 40000).! !

!ByteEncoder classSide methodsFor: 'configuring' stamp: 'MPW 1/1/1901 00:41'!
filterSelector
	^#byteEncode:.! !

!ByteEncoder classSide methodsFor: 'configuring' stamp: 'MPW 1/1/1901 22:46'!
numberDefaultBase
	^10.
! !

!ByteEncoder methodsFor: 'writing' stamp: 'MPW 1/1/1901 15:17'!
cr
	^target cr.
! !

!ByteEncoder methodsFor: 'filter streaming' stamp: 'MPW 1/1/1901 01:33'!
elementSeparator
	^' '.! !

!ByteEncoder methodsFor: 'writing' stamp: 'nk 12/31/2003 16:01'!
nextPut: encodedObject
	"pass through for stream compatibility"
	^target nextPut: encodedObject.
! !

!ByteEncoder methodsFor: 'writing' stamp: 'nk 12/31/2003 16:00'!
nextPutAll: encodedObject
	"pass through for stream compatibility"
	^target nextPutAll: encodedObject.
! !

!ByteEncoder methodsFor: 'accessing' stamp: 'MPW 1/1/1901 22:45'!
numberDefaultBase
	^self class numberDefaultBase.
! !

!ByteEncoder methodsFor: 'writing' stamp: 'MPW 1/1/1901 00:48'!
print:encodedObject
	^target write:encodedObject.
! !

!ByteEncoder methodsFor: 'writing' stamp: 'MPW 1/1/1901 02:18'!
space
	^target space.
! !

!ByteEncoder methodsFor: 'writing' stamp: 'MPW 1/1/1901 15:16'!
tab
	^target tab.
! !

!ByteEncoder methodsFor: 'writing' stamp: 'MPW 1/1/1901 20:51'!
writeArray:aCollection
	^self writeArrayedCollection:aCollection.

! !

!ByteEncoder methodsFor: 'writing' stamp: 'MPW 1/1/1901 20:53'!
writeAssocation:anAssociation
	^self write:anAssociation key; print:'->'; write:anAssociation value.

! !

!ByteEncoder methodsFor: 'writing' stamp: 'MPW 1/1/1901 02:31'!
writeCollection:aCollection
	^self print:aCollection class name; 
		writeCollectionContents:aCollection.

! !

!ByteEncoder methodsFor: 'writing' stamp: 'MPW 1/1/1901 02:31'!
writeCollectionContents:aCollection
	self print:'( '.
		super writeCollectionContents:aCollection.
		self print:')'.
	^self.
! !

!ByteEncoder methodsFor: 'writing' stamp: 'MPW 1/1/1901 22:44'!
writeNumber:aNumber
	^self writeNumber:aNumber base:self numberDefaultBase.

! !

!ByteEncoder methodsFor: 'writing' stamp: 'MPW 1/1/1901 00:03'!
writeNumber:aNumber base:aBase
	^aNumber byteEncode:self base:aBase.

! !

!ByteEncoder methodsFor: 'writing' stamp: 'MPW 1/1/1901 01:25'!
writeObject:anObject
	^self print:anObject stringRepresentation.
! !

!ByteEncoder methodsFor: 'writing' stamp: 'MPW 1/1/1901 00:21'!
writeString:aString
	^aString encodeDoublingQuoteOn:self.! !

ByteEncoder subclass: #PrintableEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Postscript Filters'!

PrintableEncoder subclass: #PostscriptEncoder
	instanceVariableNames: ''
	classVariableNames: 'MacToPSCharacterMappings'
	poolDictionaries: ''
	category: 'MorphicExtras-Postscript Canvases'!

!PostscriptEncoder commentStamp: '<historical>' prior: 0!
I translate the message protocol generated by PostscriptCanvas that represents the Postscript imaging model into an actual stream of ASCII-encoded Postscript Level 2.

Alternative implementations might provide binary representations, Level I or Level III or even PDF.


!

!PostscriptEncoder classSide methodsFor: 'configuring' stamp: 'RAA 9/19/2000 23:07'!
clearCharacterMappings

	MacToPSCharacterMappings := nil.! !

!PostscriptEncoder classSide methodsFor: 'configuring' stamp: ''!
filterSelector
	^#encodePostscriptOn:.! !

!PostscriptEncoder classSide methodsFor: 'configuring' stamp: 'RAA 9/19/2000 23:06'!
macToPSCharacterChart
	"mac char code, PS char code"
	^#(
		(128 999)  ""
		(129 999)  ""
		(130 999)  ""
		(131 999)  ""
		(132 999)  ""
		(133 999)  ""
		(134 999)  ""
		(135 999)  ""
		(136 999)  ""
		(137 999)  ""
		(138 999)  ""
		(139 999)  ""
		(140 999)  ""
		(141 999)  ""
		(142 999)  ""
		(143 999)  ""
		(144 999)  ""
		(145 999)  ""
		(146 999)  ""
		(147 999)  ""
		(148 999)  ""
		(149 999)  ""
		(150 999)  ""
		(151 999)  ""
		(152 999)  ""
		(153 999)  ""
		(154 999)  ""
		(155 999)  ""
		(156 999)  ""
		(157 999)  ""
		(158 999)  ""
		(159 999)  ""
		(160 999)  ""
		(161 202)  ""
		(162 162)  ""
		(163 163)  ""
		(164 167)  ""
		(165 183)  ""
		(166 182)  ""
		(167 251)  ""
		(168 999)  ""
		(169 999)  ""
		(170 999)  ""
		(171 999)  ""
		(172 999)  ""
		(173 999)  ""
		(174 225)  ""
		(175 999)  ""
		(176 999)  ""
		(177 999)  ""
		(178 999)  ""
		(179 999)  ""
		(180 165)  ""
		(181 999)  ""
		(182 999)  ""
		(183 999)  ""
		(184 999)  ""
		(185 999)  ""
		(186 999)  ""
		(187 227)  ""
		(188 235)  ""
		(189 999)  ""
		(190 241)  ""
		(191 999)  ""
		(192 191)  ""
		(193 166)  ""
		(194 999)  ""
		(195 999)  ""
		(196 999)  ""
		(197 999)  ""
		(198 999)  ""
		(199 171)  ""
		(200 187)  ""
		(201 188)  ""
		(202 999)  ""
		(203 999)  ""
		(204 999)  ""
		(205 999)  ""
		(206 234)  ""
		(207 250)  ""
		(208 999)  ""
		(209 999)  ""
		(210 999)  ""
		(211 999)  ""
		(212 999)  ""
		(213 999)  ""
		(214 999)  ""
		(215 999)  ""
		(216 999)  ""
		(217 999)  ""
		(218 999)  ""
		(219 999)  ""
		(220 999)  ""
		(221 999)  ""
		(222 999)  ""
		(223 999)  ""
		(224 999)  ""
		(225 999)  ""
		(226 999)  ""
		(227 999)  ""
		(228 999)  ""
		(229 999)  ""
		(230 999)  ""
		(231 999)  ""
		(232 999)  ""
		(233 999)  ""
		(234 999)  ""
		(235 999)  ""
		(236 999)  ""
		(237 999)  ""
		(238 999)  ""
		(239 999)  ""
		(240 999)  ""
		(241 999)  ""
		(242 999)  ""
		(243 999)  ""
		(244 999)  ""
		(245 999)  ""
		(246 999)  ""
		(247 999)  ""
		(248 999)  ""
		(249 999)  ""
		(250 999)  ""
		(251 999)  ""
		(252 999)  ""
		(253 999)  ""
		(254 999)  ""
		(255 999)  ""
	)! !

!PostscriptEncoder classSide methodsFor: 'configuring' stamp: 'RAA 9/19/2000 18:05'!
mapMacStringToPS: aString

	| copy val newVal |
	MacToPSCharacterMappings ifNil: [
		MacToPSCharacterMappings := Array new: 256.
		self macToPSCharacterChart do: [ :pair |
			pair second = 999 ifFalse: [MacToPSCharacterMappings at: pair first put: pair second]
		].
	].
	copy := aString copy.
	copy withIndexDo: [ :ch :index |
		(val := ch asciiValue) > 127 ifTrue: [
			(newVal := MacToPSCharacterMappings at: val) ifNotNil: [
				copy at: index put: newVal asCharacter
			].
		].
	].
	^copy! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: 'nk 4/1/2004 20:16'!
clip
	self print: 'clip'; cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
closepath
	self print:'closepath'; cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
comment:aString
	self print:'%'; print:aString; cr.

! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
comment:aString with:anObject
	self print:'%'; print:aString; print:' '; write:anObject; cr.

! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
concat:aMatrix
	self write:aMatrix asMatrixTransform2x3; print:' concat'; cr.

! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: 'mpw 9/12/1999 22:11'!
curvetoQuadratic:targetPoint from:sourcePoint via:offPoint
	self write:(sourcePoint + offPoint) / 2; print:' ';
		 write:(offPoint + targetPoint) / 2; print:' ';
		 write:targetPoint;
		 print:' curveto'; cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: 'nk 12/28/2003 21:09'!
eofill
	self print: 'eofill'; cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
fill
	self print:'fill'; cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
lineto:aPoint
	self write:aPoint; print:' lineto'; cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
moveto:aPoint
	self write:aPoint; print:' moveto'; cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: 'nk 4/1/2004 20:16'!
newpath
	self print: 'newpath'; cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: 'di 8/12/2000 19:45'!
oval: aPoint
	self print: 'matrix currentmatrix'; cr;
		write: (aPoint extent // 2); space;
		write: aPoint topLeft;
		print: ' newpath translate scale 1 1 1 0 360 arc setmatrix'; cr
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: 'nk 12/29/2003 15:56'!
preserveStateDuring: aBlock 
	"Note that this method supplies self, an encoder, to the block"
	| retval |
	self print: 'gsave';
		 cr.
	retval := aBlock value: self.
	self print: 'grestore';
		 cr.
	^ retval! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: 'nk 12/30/2003 17:24'!
rect: aRect

	self newpath.
	self
		moveto:aRect topLeft;
		lineto:aRect topRight x @ aRect topRight y;
		lineto:aRect bottomRight x @ aRect bottomRight y;
		lineto:aRect bottomLeft x @ aRect bottomLeft y;
		closepath.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
rectclip:aRect
	self write:aRect; print:' rectclip'; cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
rectfill:aRect
	self write:aRect; print:' rectfill'; cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
remapFontForSqueak:aFontName
	self print:'/'; print:aFontName; print:' adjustFontForSqueak'; cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
safeGrestore
	self print:'{ grestore } stopped pop'; cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
scale:aPoint
	self write:aPoint; print:' scale'; cr.

! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
selectflippedfont:fontname size:size
	self selectflippedfont:fontname size:size ascent:size.

! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
selectflippedfont:fontname size:size ascent:ascent
	self print:'/'; print:fontname; space; 
		print:'[ '; write:size; print:' 0 0 ';write:size negated; print:' 0 '; write:ascent; print:'] selectfont'; cr.

! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
selectfont:fontname size:size
	self print:'/'; print:fontname; space; write:size; print:' selectfont'; cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
setLinewidth:width
	self write:width; print:' setlinewidth';cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
setrgbcolor:aColor
	self write:aColor red; space;
		 write:aColor green; space;
		write:aColor blue; 
		print:' setrgbcolor'; cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: 'mpw 8/10/1930 21:34'!
showpage
	self print:'showpage'; cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
stroke
	self print:'stroke'; cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: 'mpw 8/10/1930 21:34'!
strokepath
	self print:'strokepath'; cr.
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
translate:aPoint
	self write:aPoint; print:' translate'; cr.

! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
writeMatrix:m
	self print:'[';
		write:m a11; print:' ';
		write:m a21; print:' ';
		write:m a12; print:' ';
		write:m a22; print:' ';
		write:m a13; print:' ';
		write:m a23; print:'] '.

! !

!PostscriptEncoder methodsFor: 'writing' stamp: 'mpw 11/12/1999 00:46'!
writeNumber:aNumber
	super writeNumber:(aNumber isInteger ifTrue:[aNumber] ifFalse:[aNumber roundTo:0.001]).
! !

!PostscriptEncoder methodsFor: 'Postscript generation' stamp: ''!
writePoint:aPoint
	self write:aPoint x; space; write:aPoint y.
! !

PostscriptEncoder subclass: #PostscriptEncoderToDisk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Postscript Canvases'!

!PostscriptEncoderToDisk classSide methodsFor: 'creation' stamp: 'RAA 10/12/2000 09:32'!
stream

	^self new initWithTarget: PickAFileToWriteNotification signal
! !

PrintableEncoder subclass: #PrintEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Postscript Filters'!

!PrintEncoder classSide methodsFor: 'configuring' stamp: 'MPW 1/1/1901 01:50'!
filterSelector
	^#printOnStream:! !

!PrintableEncoder methodsFor: 'writing' stamp: 'MPW 1/1/1901 22:50'!
writeNumber:aNumber base:aBase
	aBase ~= self numberDefaultBase ifTrue:[ self write:aBase; print:'r'].
	^super writeNumber:aNumber base:aBase.
! !

PrintableEncoder subclass: #PropertyListEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Postscript Filters'!

!PropertyListEncoder classSide methodsFor: 'configuring' stamp: 'MPW 1/1/1901 00:22'!
filterSelector
	^#propertyListOn:.
! !

!PropertyListEncoder methodsFor: 'writing' stamp: 'MPW 1/4/1901 08:22'!
writeArrayedCollection:aCollection
	self print:'/* '; print:aCollection class name; print:'*/'; cr.
	self print:'( '; writeCollectionContents:aCollection separator:','; print:')'.! !

!PropertyListEncoder methodsFor: 'writing' stamp: 'MPW 1/4/1901 08:32'!
writeDictionary:aCollection
	self print:'{ '; writeDictionaryContents:aCollection separator:'; '; print:'}'.! !

PrintableEncoder subclass: #StoreEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Postscript Filters'!

!StoreEncoder classSide methodsFor: 'configuring' stamp: 'MPW 1/1/1901 01:52'!
filterSelector
    ^#storeOnStream:.
! !

NewParagraph subclass: #TextOnCurve
	instanceVariableNames: 'lastCharacterIndex curve'
	classVariableNames: 'CachedWarpColor CachedWarpDepth CachedWarpMap'
	poolDictionaries: ''
	category: 'MorphicExtras-Text Support'!

!TextOnCurve commentStamp: '<historical>' prior: 0!
This subclass of Paragraph composes and displays text along a segmented line or curve.  It does this by using all the normal text composition machinery, but just to lay text out for each segment of the curve in question.  The display process is somewhat complicated, as it involves rotating the text for each segment, and then merging it into the destination Form with background, selection highlight, and transparency all handled correctly.

Because TextMorph flushes its paragraph to save space, the enduring specification of curve layout (direction, baseline, and margin) must be stored in the container.!

!TextOnCurve methodsFor: 'display' stamp: 'di 8/13/2000 12:27'!
asParagraphForPostscript

	^ self as: TextOnCurvePS! !

!TextOnCurve methodsFor: 'selection' stamp: 'ar 5/18/2000 18:33'!
characterBlockAtPoint: aPoint 
	"Answer a CharacterBlock for the character in the text at aPoint."
	| sourcePoint cb curvePoint |
	self textSegmentsDo:
		[:line :destRect :segStart :segAngle |
		(destRect containsPoint: aPoint) ifTrue:
			["It's in the destRect; now convert to source coords"
			sourcePoint := self pointInLine: line forDestPoint: aPoint
							segStart: segStart segAngle: segAngle.
			cb := (CharacterBlockScanner new text: text textStyle: textStyle)
				characterBlockAtPoint: (sourcePoint adhereTo: line rectangle)
				index: nil in: line.
			(sourcePoint x between: line left and: line right) ifTrue:
				["Definitely in this segment"
				^ cb]]].
	"Point is off curve -- try again with closest point on curve"
	curvePoint := curve closestPointTo: aPoint.
	curvePoint = aPoint ifFalse:
		[^ self characterBlockAtPoint: curvePoint].
	"If all else fails, at least return something acceptable."
	^ cb ifNil: [self defaultCharacterBlock]! !

!TextOnCurve methodsFor: 'composition' stamp: 'di 4/30/1999 08:06'!
composeAll
	self composeLinesFrom: firstCharacterIndex
		withLines: OrderedCollection new
		atY: container top.! !

!TextOnCurve methodsFor: 'composition' stamp: 'di 6/23/1999 10:17'!
composeLinesFrom: start to: stop delta: delta into: newLines priorLines: priorLines
	atY: startingY

	^ self composeLinesFrom: start withLines: newLines atY: startingY! !

!TextOnCurve methodsFor: 'as yet unclassified' stamp: 'dgd 2/21/2003 22:54'!
composeLinesFrom: startingIndex withLines: startingLines atY: startingY 
	"Here we determine the 'lines' of text that will fit along each segment of the curve. For each line, we determine its rectangle, then the dest wuadrilateral that it willbe rotated to.  Then, we take the outer hull to determine a dest rectangle for WarpBlt.  In addition we need the segment pivot point and angle, from which the source quadrilateral may be computed."

	| charIndex scanner line firstLine curveSegments segIndex pa pb segLen lineRect textSegments segDelta segAngle destRect destQuad i oldBounds |
	(oldBounds := container bounds) ifNotNil: [curve invalidRect: oldBounds].
	charIndex := startingIndex.
	lines := startingLines.
	curveSegments := curve lineSegments.
	container textDirection < 0 
		ifTrue: 
			[curveSegments := curveSegments reversed 
						collect: [:seg | Array with: (seg second) with: seg first]].
	textSegments := OrderedCollection new.
	scanner := SegmentScanner new text: text textStyle: textStyle.
	segIndex := 1.	"For curves, segIndex is just an index."
	firstLine := true.
	pa := curveSegments first first.
	[charIndex <= text size and: [segIndex <= curveSegments size]] whileTrue: 
			[curve isCurve ifFalse: [pa := (curveSegments at: segIndex) first].
			pb := (curveSegments at: segIndex) last.
			segDelta := pb - pa.	"Direction of this segment"
			segLen := segDelta r.
			lineRect := 0 @ 0 extent: segLen asInteger @ textStyle lineGrid.
			line := scanner 
						composeFrom: charIndex
						inRectangle: lineRect
						firstLine: firstLine
						leftSide: true
						rightSide: true.
			line setRight: scanner rightX.
			line width > 0 
				ifTrue: 
					[lines addLast: line.
					segAngle := segDelta theta.
					destQuad := line rectangle corners collect: 
									[:p | 
									(p translateBy: pa - (0 @ (line baseline + container baseline))) 
										rotateBy: segAngle negated
										about: pa].
					destRect := Rectangle encompassing: destQuad.
					textSegments addLast: (Array 
								with: destRect truncated
								with: pa
								with: segAngle).
					pa := pa + ((pb - pa) * line width / segLen).
					charIndex := line last + 1].
			segIndex := segIndex + 1.
			firstLine := false].
	lines isEmpty 
		ifTrue: 
			["No space in container or empty text"

			line := (TextLine 
						start: startingIndex
						stop: startingIndex - 1
						internalSpaces: 0
						paddingWidth: 0)
						rectangle: (0 @ 0 extent: 10 @ textStyle lineGrid);
						lineHeight: textStyle lineGrid baseline: textStyle baseline.
			lines := Array with: line.
			textSegments addLast: (Array 
						with: (curve vertices first extent: line rectangle extent)
						with: curve vertices first
						with: 0.0)].
	"end of segments, now attempt word break."
	lines last last < text size 
		ifTrue: 
			[
			[lines size > 1 
				and: [(text at: (i := lines last last) + 1) ~= Character space]] 
					whileTrue: 
						[i = lines last first 
							ifTrue: 
								[lines removeLast.
								textSegments removeLast]
							ifFalse: [lines last stop: i - 1]]].
	lines := lines asArray.
	container textSegments: textSegments asArray.
	curve invalidRect: container bounds.
	^maxRightX! !

!TextOnCurve methodsFor: 'selection' stamp: 'di 12/3/97 09:06'!
containsPoint: aPoint
	"Return true if aPoint is in the actual text areas."
	self textSegmentsDo:
		[:line :destRect :segStart :segAngle |
		(destRect containsPoint: aPoint) ifTrue:
			["It's in the destRect; now check if really in text area"
			(line rectangle containsPoint:
				(self pointInLine: line forDestPoint: aPoint
					segStart: segStart segAngle: segAngle))
				ifTrue: [^ true]]].
	^ false! !

!TextOnCurve methodsFor: 'display' stamp: 'ar 5/25/2000 18:01'!
displayOn: aCanvas using: displayScanner at: somePosition
	"Send all visible lines to the displayScanner for display"
	| maxExtent lineForm leftInRun lineRect warp sourceQuad backgroundColor lineCanvas |
	warp := nil.
	self textSegmentsDo:
		[:line :destRect :segStart :segAngle |
		false ifTrue:
			["Show the dest rects for debugging..."
			aCanvas frameRectangle: destRect width: 1 color: Color black].
		(aCanvas isVisible: destRect) ifTrue:
			[warp ifNil:
				["Lazy initialization because may hot have to display at all."
				maxExtent := lines inject: lines first rectangle extent 
					into: [:maxWid :lin | maxWid max: lin rectangle extent].
				lineForm := Form extent: maxExtent depth: aCanvas depth.
				displayScanner setDestForm: lineForm.
				lineRect := lineForm boundingBox.
				leftInRun := 0.
				backgroundColor := (curve borderWidth > 10
							ifTrue: [curve color]
							ifFalse: [curve owner isHandMorph
									ifTrue: [curve owner owner color]
									ifFalse: [curve owner color]]) dominantColor.
				warp := (aCanvas warpFrom: lineRect corners toRect: lineRect)
						cellSize: 2;  "installs a colormap if smoothing > 1"
						sourceForm: lineForm.
				warp colorMap: (self warpMapForDepth: aCanvas depth
									withTransparentFor: backgroundColor).
				lineCanvas := lineForm getCanvas].
			sourceQuad := destRect innerCorners collect:
				[:p | self pointInLine: line forDestPoint: p
						segStart: segStart segAngle: segAngle].
			lineForm fill: lineForm boundingBox fillColor: backgroundColor.
			self displaySelectionInLine: line on: lineCanvas.
			leftInRun := displayScanner displayLine: line offset: 0@0 leftInRun: leftInRun.
			warp sourceQuad: sourceQuad destRect: (destRect translateBy: aCanvas origin).
			warp warpBits]].
! !

!TextOnCurve methodsFor: 'access' stamp: 'jm 11/19/97 22:38'!
extent
	^ curve bounds extent! !

!TextOnCurve methodsFor: 'private' stamp: 'nk 6/23/2004 15:06'!
moveBy: delta
	positionWhenComposed := (positionWhenComposed ifNil: [ container origin ]) + delta.
	container := container translateBy: delta
! !

!TextOnCurve methodsFor: 'as yet unclassified' stamp: 'di 12/3/97 10:24'!
pointInLine: line forDestPoint: p segStart: segStart segAngle: segAngle
	^ (p rotateBy: segAngle about: segStart)
			translateBy: (0@(line baseline + container baseline)) - segStart! !

!TextOnCurve methodsFor: 'as yet unclassified' stamp: 'di 11/29/97 20:15'!
releaseCachedState
	super releaseCachedState.
	CachedWarpMap := CachedWarpDepth := CachedWarpColor := nil! !

!TextOnCurve methodsFor: 'selection' stamp: 'di 12/3/97 09:06'!
selectionRectsFrom: characterBlock1 to: characterBlock2
	"Return an array of rectangles encompassing the area
	between the two character blocks, presumably a selection."
	| rects |
	rects := OrderedCollection new.
	self textSegmentsDo:
		[:line :destRect :segStart :segAngle |
		(characterBlock1 stringIndex <= line last
			and: [characterBlock2 stringIndex >= line first]) ifTrue:
			[rects addLast: destRect].
		line first > characterBlock2 stringIndex ifTrue:
			[^ rects]].
	^ rects! !

!TextOnCurve methodsFor: 'access' stamp: 'jm 11/19/97 20:29'!
textOwner: theCurve
	curve := theCurve! !

!TextOnCurve methodsFor: 'as yet unclassified' stamp: 'dgd 2/21/2003 22:54'!
textSegmentsDo: blockForLineDestPivotAngle 
	| segments segSpec |
	(segments := container textSegments) ifNil: [^self].
	1 to: lines size
		do: 
			[:i | 
			segSpec := segments at: i.
			blockForLineDestPivotAngle 
				value: (lines at: i)
				value: (segSpec first)
				value: (segSpec second)
				value: (segSpec third)]! !

!TextOnCurve methodsFor: 'as yet unclassified' stamp: 'dgd 2/21/2003 22:54'!
warpMapForDepth: destDepth withTransparentFor: bkgndColor 
	(CachedWarpDepth = destDepth and: [CachedWarpColor = bkgndColor]) 
		ifTrue: 
			["Map is OK as is -- return it"

			^CachedWarpMap].
	(CachedWarpMap isNil or: [CachedWarpDepth ~= destDepth]) 
		ifTrue: 
			["Have to recreate the map"

			CachedWarpMap := Color computeColormapFrom: 32 to: destDepth.
			CachedWarpDepth := destDepth]
		ifFalse: 
			["Map is OK, if we restore prior color substiution"

			CachedWarpMap at: (CachedWarpColor indexInMap: CachedWarpMap)
				put: (CachedWarpColor pixelValueForDepth: destDepth)].
	"Now map the background color into transparent, and return the new map"
	CachedWarpColor := bkgndColor.
	CachedWarpMap at: (CachedWarpColor indexInMap: CachedWarpMap) put: 0.
	^CachedWarpMap! !

TextOnCurve subclass: #TextOnCurvePS
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Text Support'!

!TextOnCurvePS methodsFor: 'display' stamp: 'di 8/13/2000 12:39'!
displayOn: aCanvas using: displayScanner at: somePosition
	"Send all visible lines to the displayScanner for display"

	self textSegmentsDo:
		[:line :destRect :segStart :segAngle |
		self displaySelectionInLine: line on: aCanvas.
		line first <= line last ifTrue:
			[displayScanner displayLine: line offset: destRect topLeft leftInRun: 999]]

! !

!TheWorldMenu methodsFor: '*MorphicExtras-mechanics' stamp: 'RAA 6/15/2000 10:16'!
adaptToWorld: aWorld

        myWorld := aWorld.
        myProject := nil.                "figure it out if and when needed. maybe make it easier to find"
        myHand := aWorld primaryHand.! !

!TheWorldMenu methodsFor: '*MorphicExtras-action' stamp: 'sw 8/12/2001 16:36'!
createStandardPartsBin
	"A dead branch -- only reachable now from pre-existing menus that the user may have kept up"

	ObjectsTool newStandAlone openInHand! !

!TheWorldMenu methodsFor: '*MorphicExtras-windows & flaps menu' stamp: 'dao 10/1/2004 13:45'!
formulateFlapsMenu: aMenu
	"Fill aMenu with appropriate content"

	aMenu addTitle: 'flaps' translated.
	aMenu addStayUpItem.
	Preferences classicNavigatorEnabled ifTrue:
		[aMenu
			addUpdating: #navigatorShowingString
			enablementSelector: #enableProjectNavigator
			target: Preferences
			selector: #togglePreference: 
			argumentList: #(showProjectNavigator).
		aMenu balloonTextForLastItem: (Preferences preferenceAt: #showProjectNavigator) helpString translated].

	Flaps sharedFlapsAllowed
		ifTrue:
			[self fillIn: aMenu from:
				{{#suppressFlapsString.
					{Project current. #toggleFlapsSuppressed}.
				'Whether prevailing flaps should be shown in the project right now or not.'}}.

			aMenu addUpdating: #automaticFlapLayoutString  target: Preferences selector: #togglePreference: argumentList: #(automaticFlapLayout).
			aMenu balloonTextForLastItem: (Preferences preferenceAt: #automaticFlapLayout) helpString translated.

			aMenu addLine.
			Flaps addIndividualGlobalFlapItemsTo: aMenu].

     self fillIn: aMenu from: {
			nil.

               {'make a new flap'.
			{Flaps. #addLocalFlap}.
			'Create a new flap.  You can later make it into a shared flap is you wish.'}.

			nil.}.
	Flaps sharedFlapsAllowed
		ifTrue:
			[aMenu addWithLabel: 'put shared flaps on bottom' translated enablementSelector: #showSharedFlaps
				target: Flaps selector: #sharedFlapsAlongBottom argumentList: #().
			aMenu balloonTextForLastItem: 'Group all the standard shared flaps along the bottom edge of the screen' translated.

			self fillIn: aMenu from: {
				{'destroy all shared flaps'.
				{Flaps. #disableGlobalFlaps}.
				'Destroy all the shared flaps and disable their use in all projects.'}}]
		ifFalse:
			[aMenu add: 'install default shared flaps' translated target: Flaps action: #enableGlobalFlaps.
			aMenu balloonTextForLastItem: 'Create the default set of shared flaps' translated.
			aMenu add: 'install etoy flaps' translated target: Flaps action: #enableEToyFlaps.
			aMenu balloonTextForLastItem: 'Put up the default etoy flaps: a custom Suplies flap and the Navigator flap' translated.
			aMenu addLine].

	self fillIn: aMenu from: {
			nil.
			{'about flaps...'.
			{Flaps . #explainFlaps}.
			'Gives a window full of details about how to use flaps.'}}! !

!TheWorldMenu methodsFor: '*MorphicExtras-action' stamp: 'sw 8/12/2001 17:13'!
launchCustomPartsBin
	"A dead branch -- only reachable now from pre-existing menus that the user may have kept up"

	ObjectsTool newStandAlone openInHand! !

PluggableCanvas subclass: #CachingCanvas
	instanceVariableNames: 'cacheCanvas mainCanvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Support'!

!CachingCanvas commentStamp: '<historical>' prior: 0!
A canvas which has a hidden form caching the events.  contentsOfArea:into: uses the cache, instead of the main canvas.  This is typically used with remote canvases, where querying the bits would involve a network transaction.
!

!CachingCanvas classSide methodsFor: 'instance creation' stamp: 'ls 3/26/2000 13:37'!
on: aCanvas
	^super new mainCanvas: aCanvas! !

!CachingCanvas methodsFor: 'canvas methods' stamp: 'RAA 7/20/2000 13:08'!
allocateForm: extentPoint

	^cacheCanvas form allocateForm: extentPoint! !

!CachingCanvas methodsFor: 'private' stamp: 'ls 3/26/2000 13:35'!
apply: aBlock
	aBlock value: cacheCanvas.
	aBlock value: mainCanvas.! !

!CachingCanvas methodsFor: 'accessing' stamp: 'ls 3/27/2000 22:50'!
contentsOfArea: area  into: aForm
	^cacheCanvas contentsOfArea: area  into: aForm! !

!CachingCanvas methodsFor: 'accessing' stamp: 'ls 3/26/2000 20:21'!
form
	^cacheCanvas form! !

!CachingCanvas methodsFor: 'initialization' stamp: 'ls 4/8/2000 22:35'!
mainCanvas: mainCanvas0
	mainCanvas := mainCanvas0.
	cacheCanvas := FormCanvas extent: mainCanvas extent depth: mainCanvas depth.! !

!CachingCanvas methodsFor: 'canvas methods' stamp: 'RAA 7/21/2000 09:54'!
showAt: pt  invalidRects: rects

	mainCanvas showAt: pt  invalidRects: rects! !

Object subclass: #Command
	instanceVariableNames: 'phase cmdWording undoTarget undoSelector undoArguments redoTarget redoSelector redoArguments parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Undo'!

!Command commentStamp: '<historical>' prior: 0!
An object representing an undoable command to be done in the environment.

Structure:
	phase			indicates whether the cmd is current in undone or redone mode
 	cmdWording		The wording of the command (used in arming the "undo"/"redo" menu items
 	parameters		an IdentityDictionary /NOT USED/
	undoTarget		Receiver, selector and arguments to accomplish undo
	undoSelector
	undoArguments
	redoTarget		Receiver, selector and arguments to accomplish redo
	redoSelector
	redoArguments

To use this, for any command you wish to use, you
	*	Create an instance of Command, as follows...
			cmd _ Command new cmdWording: 'resizing'.
	*	Give the the command undo state and redo state, as follows...
			cmd undoTarget: target selector: #extent: argument: oldExtent.
			cmd redoTarget: target selector: #extent: argument: newExtent.
	*	Send a message of the form
			Command rememberCommand: cmd

LastCommand is the last command that was actually done or undone.

CommandHistory, applicable only when infiniteUndo is set, holds a 'tape' of the complete history of commands, as far back as it's possible to go.

CommandExcursions, also applicable only in the infiniteUndo case, and rather at the fringe even then, holds segments of former CommandHistory that have been lopped off because of variant paths taken.!

!Command class methodsFor: 'dog simple ui' stamp: 'ar 8/31/2000 23:13'!
redoEnabled
	| w |
	^(w := self currentWorld) == nil ifTrue:[false] ifFalse:[w commandHistory redoEnabled]! !

!Command class methodsFor: 'dog simple ui' stamp: 'ar 8/31/2000 23:13'!
redoNextCommand
	| w |
	^(w := self currentWorld) == nil ifFalse:[w commandHistory redoNextCommand]! !

!Command class methodsFor: 'dog simple ui' stamp: 'ar 8/31/2000 23:13'!
undoEnabled
	| w |
	^(w := self currentWorld) == nil ifTrue:[false] ifFalse:[w commandHistory undoEnabled]! !

!Command class methodsFor: 'dog simple ui' stamp: 'ar 8/31/2000 23:14'!
undoLastCommand
	| w |
	^(w := self currentWorld) == nil ifFalse:[w commandHistory undoLastCommand]! !

!Command class methodsFor: 'dog simple ui' stamp: 'ar 11/9/2000 20:38'!
undoRedoButtons
	"Answer a morph that offers undo and redo buttons"

	| aButton wrapper |
	"self currentHand attachMorph: Command undoRedoButtons"
	wrapper := AlignmentMorph newColumn.
	wrapper color: Color veryVeryLightGray lighter;
		borderWidth: 0;
		layoutInset: 0;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap.
	#((CrudeUndo undoLastCommand 'undo last command done' undoEnabled CrudeUndoDisabled CrudeUndoDisabled) 
	(CrudeRedo redoNextCommand 'redo last undone command' redoEnabled CrudeRedoDisabled CrudeRedoDisabled)) do:
		[:tuple |
			wrapper addTransparentSpacerOfSize: (8@0).
			aButton := UpdatingThreePhaseButtonMorph new.
			aButton
				onImage: (ScriptingSystem formAtKey: tuple first);
				offImage: (ScriptingSystem formAtKey: tuple fifth);
				pressedImage: (ScriptingSystem formAtKey: tuple sixth);
				getSelector: tuple fourth;
				color: Color transparent; 
				target: self;
				actionSelector: tuple second;
				setNameTo: tuple second;
				setBalloonText: tuple third;
				extent: aButton onImage extent.
			wrapper addMorphBack: aButton.
			wrapper addTransparentSpacerOfSize: (8@0)].
	^ wrapper! !

!Command class methodsFor: 'class initialization' stamp: 'RAA 9/21/2000 14:02'!
zapObsolete
"Command zapObsolete"
	"kill some obsolete stuff still retained by the CompiledMethods in change records"

	| before after histories lastCmd histCount lastCount |
	Smalltalk garbageCollect.
	before := Command allInstances size.
	histories := Association allInstances select: [ :each | 
		each key == #CommandHistory and: [
			(each value isKindOf: OrderedCollection) and: [
				each value isEmpty not and: [
					each value first isKindOf: Command]]]
	].
	histCount := histories size.
	lastCmd := Association allInstances select: [ :each | 
		each key == #LastCommand and: [each value isKindOf: Command]
	].
	lastCount := lastCmd size.
	histories do: [ :each | each value: OrderedCollection new].
	lastCmd do: [ :each | each value: Command new].
	Smalltalk garbageCollect.
	Smalltalk garbageCollect.
	after := Command allInstances size.
	Transcript show: {before. after. histCount. histories. lastCount. lastCmd} printString; cr; cr.
	! !

!Command methodsFor: 'private' stamp: 'sw 8/29/2000 14:09'!
assuredParameterDictionary
	"Private!!  Answer the parameters dictionary, creating it if necessary"

	^ parameters ifNil: [parameters := IdentityDictionary new]! !

!Command methodsFor: 'private' stamp: 'dgd 8/26/2003 21:43'!
cmdWording
	"Answer the wording to be used to refer to the command in a menu"

	^ cmdWording ifNil: ['last command' translated]! !

!Command methodsFor: 'initialization' stamp: 'sw 8/29/2000 14:12'!
cmdWording: wrd
	"Set the wording to be used in a menu item referring to the receiver"

	cmdWording := wrd! !

!Command methodsFor: 'command execution' stamp: 'di 8/30/2000 16:04'!
doCommand
	"Do the command represented by the receiver.  Not actually called by active current code, but reachable by the not-yet-unsealed promoteToCurrent: action."

	redoTarget ifNotNil: [redoTarget perform: redoSelector withArguments: redoArguments]! !

!Command methodsFor: 'parameters' stamp: 'sw 8/29/2000 14:12'!
parameterAt: aSymbol
	"Answer the parameter stored at the given symbol, or nil if none"

	^ self parameterAt: aSymbol ifAbsent: [nil]! !

!Command methodsFor: 'parameters' stamp: 'sw 8/29/2000 14:12'!
parameterAt: aSymbol ifAbsent: aBlock
	"Answer the parameter stored at the aSymbol, but if none, return the result of evaluating aBlock"

	^ self assuredParameterDictionary at: aSymbol ifAbsent: [aBlock value]! !

!Command methodsFor: 'parameters' stamp: 'sw 8/29/2000 14:12'!
parameterAt: aSymbol put: aValue
	"Place aValue in the parameters dictionary using aSymbol as key"

	^ self assuredParameterDictionary at: aSymbol put: aValue! !

!Command methodsFor: 'private' stamp: 'sw 8/29/2000 14:13'!
phase
	"Answer the phase of the command"

	^ phase! !

!Command methodsFor: 'initialization' stamp: 'sw 8/29/2000 14:13'!
phase: aPhase
	"Set the phase of the command to the supplied symbol"

	phase := aPhase! !

!Command methodsFor: 'printing' stamp: 'di 8/30/2000 14:09'!
printOn: aStream
	"Provide more detailed info about the receiver, put in for debugging, maybe should be removed"

	super printOn: aStream.
	aStream nextPutAll: ' phase: ', phase printString.
	cmdWording ifNotNil: [aStream nextPutAll: '; ', cmdWording asString].
	parameters ifNotNil:
		[parameters associationsDo:
			[:assoc | aStream nextPutAll: ': ', assoc printString]]! !

!Command methodsFor: 'command execution' stamp: 'di 8/30/2000 16:04'!
redoCommand
	"Perform the 'redo' operation"

	redoTarget ifNotNil: [redoTarget perform: redoSelector withArguments: redoArguments]! !

!Command methodsFor: 'initialization' stamp: 'di 8/30/2000 13:04'!
redoTarget: target selector: aSymbol argument: argument

	^ self redoTarget: target selector: aSymbol arguments: {argument}! !

!Command methodsFor: 'initialization' stamp: 'di 8/30/2000 20:53'!
redoTarget: target selector: selector arguments: arguments
	"Give target morph a chance to refine its undo operation"

	target refineRedoTarget: target selector: selector arguments: arguments in:
		[:rTarget :rSelector :rArguments |
		redoTarget := rTarget.
		redoSelector := rSelector.
		redoArguments := rArguments]! !

!Command methodsFor: 'command execution' stamp: 'sw 2/2/2006 02:00'!
stillValid
	"Answer whether the receiver is still valid."

	^ (undoTarget isMorph and: [undoTarget isInWorld]) or: [redoTarget isMorph and:  [redoTarget isInWorld]]! !

!Command methodsFor: 'command execution' stamp: 'di 8/30/2000 16:02'!
undoCommand
	"Perform the 'undo' operation"

	undoTarget ifNotNil: [undoTarget perform: undoSelector withArguments: undoArguments]! !

!Command methodsFor: 'private' stamp: 'di 12/12/2000 12:36'!
undoTarget
	^ undoTarget! !

!Command methodsFor: 'initialization' stamp: 'di 8/30/2000 13:04'!
undoTarget: target selector: aSymbol argument: argument

	^ self undoTarget: target selector: aSymbol arguments: {argument}! !

!Command methodsFor: 'initialization' stamp: 'di 8/30/2000 20:53'!
undoTarget: target selector: selector arguments: arguments
	"Give target morph a chance to refine its undo operation"

	target refineUndoTarget: target selector: selector arguments: arguments in:
		[:rTarget :rSelector :rArguments |
		undoTarget := rTarget.
		undoSelector := rSelector.
		undoArguments := rArguments]! !

!Command methodsFor: 'copying' stamp: 'tk 2/25/2001 17:53'!
veryDeepFixupWith: deepCopier
	| old |
	"ALL inst vars were weakly copied.  If they were in the tree being copied, fix them up, otherwise point to the originals!!!!"

super veryDeepFixupWith: deepCopier.
1 to: self class instSize do:
	[:ii | old := self instVarAt: ii.
	self instVarAt: ii put: (deepCopier references at: old ifAbsent: [old])].

! !

!Command methodsFor: 'copying' stamp: 'tk 2/25/2001 17:53'!
veryDeepInner: deepCopier
	"ALL fields are weakly copied!!  Can't duplicate an object by duplicating a Command that involves it.  See DeepCopier."

	super veryDeepInner: deepCopier.
	"just keep old pointers to all fields"
	parameters := parameters.! !

Object subclass: #CommandHistory
	instanceVariableNames: 'lastCommand history excursions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Undo'!

!CommandHistory class methodsFor: 'system startup' stamp: 'tk 5/16/2002 13:52'!
forgetAllGrabCommandsFrom: starter
	"Forget all the commands that might be held on to in the properties dicitonary of various morphs for various reasons."

	| object |
	object := starter.
	[
		[0 == object] whileFalse: [
			object isMorph ifTrue: [object removeProperty: #undoGrabCommand].
			object := object nextObject].
		] ifError: [:err :rcvr | "object is obsolete"
			self forgetAllGrabCommandsFrom: object nextObject].

	"CommandHistory forgetAllGrabCommandsFrom: true someObject"
! !

!CommandHistory class methodsFor: 'class initialization' stamp: 'dgd 4/3/2006 14:28'!
initialize
	"CommandHistory initialize"

	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!CommandHistory class methodsFor: 'system startup' stamp: 'tk 5/16/2002 13:38'!
resetAllHistory
	"Reset all command histories, and make all morphs that might be holding on to undo-grab-commands forget them"

	self allInstancesDo: [:c | c resetCommandHistory].
	self forgetAllGrabCommandsFrom: self someObject.

	"CommandHistory resetAllHistory"
! !

!CommandHistory class methodsFor: 'system startup' stamp: 'dgd 4/3/2006 14:28'!
shutDown: aboutToQuit 
	Preferences purgeUndoOnQuit ifTrue: [
		aboutToQuit ifTrue: [self resetAllHistory].
	].
! !

!CommandHistory class methodsFor: 'system startup' stamp: 'dgd 10/15/2004 12:11'!
startUp: aboutToQuit 
	Preferences purgeUndoOnQuit
		ifTrue: [
			aboutToQuit ifTrue: [self resetAllHistory].
		].
 
	! !

!CommandHistory methodsFor: 'called by programmer' stamp: 'sw 2/2/2006 01:48'!
assureLastCommandStillValid
	"If the lastCommand is not valid, set it to nil; answer the lastCommand."

	lastCommand ifNotNil:
		[lastCommand stillValid ifFalse:
			[self cantUndo]].
	^ lastCommand! !

!CommandHistory methodsFor: 'called by programmer' stamp: 'ar 8/31/2000 22:46'!
cantUndo
	"Called by client to indicate that the prior undoable command is no longer undoable"

	lastCommand := nil.
	history := OrderedCollection new.! !

!CommandHistory methodsFor: 'called from the ui' stamp: 'ar 8/31/2000 22:49'!
commandToUndo
	"Undo the last command, i.e. move backward in the recent-commands tape, if possible."

	| anIndex |
	lastCommand ifNil: [^ nil].
	lastCommand phase == #done ifTrue: [^ lastCommand].
	(lastCommand phase == #undone and:
		[(anIndex := history indexOf: lastCommand) > 1])
		ifTrue: [^ history at: anIndex - 1]
		ifFalse: [^ nil]
! !

!CommandHistory methodsFor: 'command history' stamp: 'ar 8/31/2000 22:44'!
historyIndexOfLastCommand
	"Answer which position of the CommandHistory list is occupied by the LastCommand"

	^ history indexOf: lastCommand ifAbsent: [0]! !

!CommandHistory methodsFor: 'initialize' stamp: 'ar 8/31/2000 22:50'!
initialize
	lastCommand := nil.
	history := OrderedCollection new.
	excursions := OrderedCollection new.! !

!CommandHistory methodsFor: 'command history' stamp: 'ar 8/31/2000 22:45'!
lastCommand
	"Answer the last command done or undone"

	^ lastCommand! !

!CommandHistory methodsFor: 'command history' stamp: 'ar 8/31/2000 22:45'!
nextCommand
	"Answer the command object that would be sent the #redoCommand message if the user were to request Redo, or nil if none"

	| anIndex |
	lastCommand ifNil: [^ nil].
	lastCommand phase == #undone ifTrue: [^ lastCommand].
	anIndex := history indexOf: lastCommand ifAbsent: [^ nil].
	^ anIndex = history size ifTrue: [nil] ifFalse: [history at: (anIndex + 1)]! !

!CommandHistory methodsFor: 'menu' stamp: 'ar 8/31/2000 22:41'!
nextCommandToUndo
	| anIndex |
	lastCommand ifNil: [^ nil].
	lastCommand phase == #done ifTrue: [^ lastCommand].
	(lastCommand phase == #undone and:
		[(anIndex := history indexOf: lastCommand) > 1])
		ifTrue: [^ history at: anIndex - 1]
		ifFalse: [^ nil]! !

!CommandHistory methodsFor: 'called by programmer' stamp: 'ar 8/31/2000 22:47'!
promoteToCurrent: aCommand
	"Very unusual and speculative and unfinished!!.  Not currently reachable.  For the real thing, we presumably march forward or backward from the current command pointer to the target command in an orderly fashion, doing or undoing each command in turn."

	| itsIndex |
	Preferences useUndo ifFalse: [^ self].
	itsIndex := history indexOf: aCommand ifAbsent: [nil].
	itsIndex ifNotNil:
		[history remove: aCommand ifAbsent: []].
	history add: (lastCommand := aCommand).
	itsIndex < history size ifTrue:
		[excursions add: (history copyFrom: (itsIndex to: history size))].
	history := (history copyFrom: 1 to: itsIndex) copyWith: aCommand.

	lastCommand := aCommand.
	aCommand doCommand.
	lastCommand phase: #done.! !

!CommandHistory methodsFor: 'called by programmer' stamp: 'aoy 2/15/2003 21:14'!
purgeAllCommandsSuchThat: cmdBlock 
	"Remove a bunch of commands, as in [:cmd | cmd undoTarget == zort]"

	Preferences useUndo ifFalse: [^self].
	history := history reject: cmdBlock.
	lastCommand := history isEmpty ifTrue: [nil] ifFalse: [history last] ! !

!CommandHistory methodsFor: 'menu' stamp: 'ar 8/31/2000 22:39'!
redoEnabled
	"Answer whether the redo command is currently available"

	^ self nextCommand notNil! !

!CommandHistory methodsFor: 'menu' stamp: 'dgd 4/3/2006 14:26'!
redoMenuWording
	"Answer the wording to be used in a menu offering the current 
	Redo command"
	| nextCommand |

	((nextCommand := self nextCommand) isNil
			or: [Preferences useUndo not])
		ifTrue: [^ 'can''t redo' translated].

	^ String
		streamContents: [:aStream | 
			aStream nextPutAll: 'redo' translated.
			aStream nextPutAll: ' "'.
			aStream nextPutAll: (nextCommand cmdWording truncateWithElipsisTo: 20).
			aStream nextPut: $".
			lastCommand phase == #done
				ifFalse: [aStream nextPutAll: ' (z)']]! !

!CommandHistory methodsFor: 'called from the ui' stamp: 'nb 6/17/2003 12:25'!
redoNextCommand
	"If there is a way to 'redo' (move FORWARD) in the undo/redo history tape, do it."

	| anIndex |
	lastCommand ifNil: [^ Beeper beep].
	lastCommand phase == #undone
		ifFalse:
			[anIndex := history indexOf: lastCommand.
			(anIndex < history size)
				ifTrue:
					[lastCommand := history at: anIndex + 1]
				ifFalse:
					[^ Beeper beep]].

	lastCommand redoCommand.
	lastCommand phase: #done
! !

!CommandHistory methodsFor: 'undo' stamp: 'di 12/12/2000 10:16'!
rememberCommand: aCommand
	"Make the supplied command be the 'LastCommand', and mark it 'done'"

	| currentCommandIndex |
	Preferences useUndo ifFalse: [^ self].  "Command initialize"

	Preferences infiniteUndo ifTrue:
		[currentCommandIndex := history indexOf: lastCommand.
		((currentCommandIndex < history size) and: [Preferences preserveCommandExcursions]) ifTrue:
			[excursions add: (history copyFrom: (currentCommandIndex to: history size)).
			history := history copyFrom: 1 to: currentCommandIndex].
		history addLast: aCommand].

	lastCommand := aCommand.
	lastCommand phase: #done.! !

!CommandHistory methodsFor: 'command history' stamp: 'di 12/12/2000 13:46'!
resetCommandHistory    "CommandHistory allInstancesDo: [:ch | ch resetCommandHistory]"
	"Clear out the command history so that no commands are held"

	lastCommand := nil.
	history := OrderedCollection new.! !

!CommandHistory methodsFor: 'menu' stamp: 'ar 8/31/2000 22:40'!
undoEnabled
	"Answer whether there is an undoable command at the ready"

	^ lastCommand notNil! !

!CommandHistory methodsFor: 'called from the ui' stamp: 'nb 6/17/2003 12:25'!
undoLastCommand
	"Undo the last command, i.e. move backward in the recent-commands tape, if possible."

	| aPhase anIndex |
	lastCommand ifNil: [^ Beeper beep].

	(aPhase := lastCommand phase) == #done
		ifFalse:
			[aPhase == #undone
				ifTrue:
					[anIndex := history indexOf: lastCommand.
					anIndex > 1 ifTrue:
						[lastCommand := history at: anIndex - 1]]].

	lastCommand undoCommand.
	lastCommand phase: #undone

	"Command undoLastCommand"
! !

!CommandHistory methodsFor: 'menu' stamp: 'dgd 4/3/2006 14:26'!
undoMenuWording
	"Answer the wording to be used in an 'undo' menu item"

	(lastCommand isNil
			or: [Preferences useUndo not]
			or: [Preferences infiniteUndo not and: [lastCommand phase == #undone]]
			or: [self nextCommandToUndo isNil])
		ifTrue: [^ 'can''t undo' translated].

	^ String
		streamContents: [:aStream | 
			aStream nextPutAll: 'undo' translated.
			aStream nextPutAll: ' "'.
			aStream nextPutAll: (self nextCommandToUndo cmdWording truncateWithElipsisTo: 20).
			aStream nextPut: $".
			lastCommand phase == #done
				ifTrue: [aStream nextPutAll: ' (z)']].! !

!CommandHistory methodsFor: 'called from the ui' stamp: 'nb 6/17/2003 12:25'!
undoOrRedoCommand
	"This gives a feature comparable to standard Mac undo/redo.  If the undo/redo action taken was a simple do or a redo, then undo it.  But if the last undo/redo action taken was an undo, then redo it."

	"Command undoOrRedoCommand"
	| aPhase |
	lastCommand ifNil: [^ Beeper beep].

	(aPhase := lastCommand phase) == #done
		ifTrue:
			[lastCommand undoCommand.
			lastCommand phase: #undone]
		ifFalse:
			[aPhase == #undone
				ifTrue:
					[lastCommand redoCommand.
					lastCommand phase: #done]]! !

!CommandHistory methodsFor: 'menu' stamp: 'sw 2/2/2006 01:53'!
undoOrRedoMenuWording
	"Answer the wording to be used in a menu item offering undo/redo (i.e., the form used when the #infiniteUndo preference is false)"

	| pre |
	self assureLastCommandStillValid. 
	lastCommand ifNil: [^ 'can''t undo' translated].
	pre := lastCommand phase == #done
		ifTrue: ['undo' translated]
		ifFalse: ['redo' translated].
	^ pre, ' "', (lastCommand cmdWording truncateWithElipsisTo: 20), '" (z)'! !

!CommandHistory methodsFor: 'called from the ui' stamp: 'nb 6/17/2003 12:25'!
undoTo
	"Not yet functional, and not yet sent.  Allow the user to choose a point somewhere in the undo/redo tape, and undo his way to there.   Applicable only if infiniteUndo is set. "

	| anIndex commandList aMenu reply |
	(anIndex := self historyIndexOfLastCommand) == 0 ifTrue: [^ Beeper beep].
	commandList := history
		copyFrom:	((anIndex - 10) max: 1)
		to:			((anIndex + 10) min: history size).
	aMenu := SelectionMenu labels:  (commandList collect: [:cmd | cmd cmdWording truncateWithElipsisTo: 20]) selections: commandList.
	reply := aMenu startUpWithCaption: 'undo or redo to...'.
	reply ifNotNil: [self inform: #deferred]

	"ActiveWorld commandHistory undoTo"
! !

Object subclass: #DescriptionForPartsBin
	instanceVariableNames: 'formalName categoryList documentation globalReceiverSymbol nativitySelector sampleImageForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-PartsBin'!

!DescriptionForPartsBin commentStamp: '<historical>' prior: 0!
An object description, for use with the ObjectsTool and other parts-bin-like repositories.

formalName				The formal name by which the object is to be known 
categoryList				A list of category symbols, by way of attribute tags
documentation			For use in balloon help, etc.
globalReceiverSymbol	A symbol representing the global to whom to send nativitySelector 
nativitySelector 		The selector to send to the global receiver to obtain a new instance!

!DescriptionForPartsBin classSide methodsFor: 'instance creation' stamp: 'sw 8/10/2001 14:39'!
formalName: aName categoryList: aList documentation: aDoc globalReceiverSymbol: aSym nativitySelector: aSel
	"Answer a new instance of the receiver with the given traits"

	^ self new formalName: aName categoryList: aList documentation: aDoc globalReceiverSymbol: aSym nativitySelector: aSel! !

!DescriptionForPartsBin classSide methodsFor: 'instance creation' stamp: 'sw 8/10/2001 22:33'!
fromQuad: aQuad categoryList: aList
	"Answer an instance of DescriptionForPartsBin from the part-defining quad provided"

	^ self formalName: aQuad third categoryList: aList documentation: aQuad fourth globalReceiverSymbol: aQuad first nativitySelector: aQuad second! !

!DescriptionForPartsBin methodsFor: 'access' stamp: 'sw 8/10/2001 14:38'!
categories
	"Answer the categoryList of the receiver"

	^ categoryList! !

!DescriptionForPartsBin methodsFor: 'access' stamp: 'sw 8/10/2001 14:38'!
documentation
	"Answer the documentation of the receiver"

	^ documentation! !

!DescriptionForPartsBin methodsFor: 'access' stamp: 'sw 8/10/2001 14:38'!
formalName
	"Answer the formalName of the receiver"

	^ formalName! !

!DescriptionForPartsBin methodsFor: 'initialization' stamp: 'sw 8/2/2001 01:04'!
formalName: aName categoryList: aList documentation: aDoc globalReceiverSymbol: aSym nativitySelector: aSel
	"Set all of the receiver's instance variables from the parameters provided"

	formalName := aName.
	categoryList := aList.
	documentation := aDoc.
	globalReceiverSymbol := aSym.
	nativitySelector  := aSel! !

!DescriptionForPartsBin methodsFor: 'access' stamp: 'sw 8/10/2001 14:38'!
globalReceiverSymbol
	"Answer the globalReceiverSymbol of the receiver"

	^ globalReceiverSymbol! !

!DescriptionForPartsBin methodsFor: 'access' stamp: 'sw 8/10/2001 14:38'!
nativitySelector
	"Answer the nativitySelector of the receiver"

	^ nativitySelector! !

!DescriptionForPartsBin methodsFor: 'printing' stamp: 'sw 8/10/2001 21:48'!
printOn: aStream
	aStream nextPutAll: 'a DescriptionForPartsBin, with categoryList=', categoryList asString, ' docmentation=', documentation asString,  ' globalReceiverSymbol=', globalReceiverSymbol asString, ' nativitySelector=', nativitySelector asString ! !

!DescriptionForPartsBin methodsFor: 'initialization' stamp: 'nk 9/1/2004 16:52'!
sampleImageForm
	"If I have a sample image form override stored, answer it, else answer one obtained by launching an actual instance"

	^ sampleImageForm ifNil:
		[((Smalltalk at: globalReceiverSymbol) perform: nativitySelector) imageFormDepth: 32]! !

!DescriptionForPartsBin methodsFor: 'initialization' stamp: 'sw 10/24/2001 16:37'!
sampleImageForm: aForm
	"Set the sample image form"

	sampleImageForm := aForm! !

!DescriptionForPartsBin methodsFor: 'initialization' stamp: 'sw 11/27/2001 13:19'!
sampleImageFormOrNil
	"If I have a sample image form override stored, answer it, dlse answer nil"

	^ sampleImageForm ! !

!DescriptionForPartsBin methodsFor: 'access' stamp: 'dgd 9/2/2003 18:57'!
translatedCategories
	"Answer translated the categoryList of the receiver"
	^ self categories
		collect: [:each | each translated]! !

Object subclass: #Flaps
	instanceVariableNames: ''
	classVariableNames: 'FlapsQuads SharedFlapTabs SharedFlapsAllowed'
	poolDictionaries: ''
	category: 'MorphicExtras-Flaps'!

!Flaps commentStamp: 'asm 3/13/2003 12:46' prior: 0!
ClassVariables

FlapsQuads               quads defining predefined flaps
			default flaps are: 'PlugIn Supplies', 'Stack Tools', 'Supplies', 'Tools', 'Widgets' and 'Scripting'

SharedFlapTabs          an  array of flaps shared between squeak projects
SharedFlapsAllowed     boolean

!

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'dgd 4/3/2006 13:22'!
addAndEnableEToyFlaps
	"Initialize the standard default out-of-box set of global flaps.  This method creates them and places them in my class variable #SharedFlapTabs, but does not itself get them displayed."

	| aSuppliesFlap |
	SharedFlapTabs
		ifNotNil: [^ self].
	SharedFlapTabs := OrderedCollection new.

	aSuppliesFlap := self newSuppliesFlapFromQuads: self quadsDefiningPlugInSuppliesFlap positioning: #right.
	aSuppliesFlap referent setNameTo: 'Supplies Flap' translated.  "Per request from Kim Rose, 7/19/02"
	SharedFlapTabs add: aSuppliesFlap.  "The #center designation doesn't quite work at the moment"

	Preferences showProjectNavigator
		ifTrue:[ SharedFlapTabs add: self newNavigatorFlap ].

	self enableGlobalFlapWithID: 'Supplies' translated.

	Preferences showProjectNavigator
		ifTrue:[ self enableGlobalFlapWithID: 'Navigator' translated ].

	SharedFlapsAllowed := true.
	Project current flapsSuppressed: false.
	^ SharedFlapTabs

"Flaps addAndEnableEToyFlaps"! !

!Flaps classSide methodsFor: 'shared flaps' stamp: 'sw 4/17/2001 13:31'!
addGlobalFlap: aFlapTab
	"Add the given flap tab to the list of shared flaps"

	SharedFlapTabs ifNil: [SharedFlapTabs := OrderedCollection new].
	SharedFlapTabs add: aFlapTab! !

!Flaps classSide methodsFor: 'menu support' stamp: 'sw 4/24/2001 11:03'!
addIndividualGlobalFlapItemsTo: aMenu
	"Add items governing the enablement of specific global flaps to aMenu"

	|  anItem |
	self globalFlapTabsIfAny do:
		[:aFlapTab |
			anItem := aMenu addUpdating: #globalFlapWithIDEnabledString: enablementSelector: #showSharedFlaps target: self selector: #enableDisableGlobalFlapWithID: argumentList: {aFlapTab flapID}.
			anItem wordingArgument: aFlapTab flapID.
			anItem setBalloonText: aFlapTab balloonTextForFlapsMenu].! !

!Flaps classSide methodsFor: 'new flap' stamp: 'dgd 8/31/2003 18:58'!
addLocalFlap
	"Menu command -- let the user add a new project-local flap.  Once the new flap is born, the user can tell it to become a shared flap.  Obtain an initial name and edge for the flap, launch the flap, and also launch a menu governing the flap, so that the user can get started right away with customizing it."

	| aMenu reply aFlapTab aWorld edge |
	aMenu := MVCMenuMorph entitled: 'Where should the new flap cling?' translated.
	aMenu defaultTarget: aMenu.
	#(left right top bottom) do:
		[:sym | aMenu add: sym asString translated selector: #selectMVCItem: argument: sym].
	edge := aMenu invokeAt: self currentHand position in: self currentWorld.

	edge ifNotNil:
		[reply := FillInTheBlank request: 'Wording for this flap: ' translated initialAnswer: 'Flap' translated.
		reply isEmptyOrNil ifFalse:
			[aFlapTab := self newFlapTitled: reply onEdge: edge.
			(aWorld := self currentWorld) addMorphFront: aFlapTab.
			aFlapTab adaptToWorld: aWorld.
			aMenu := aFlapTab buildHandleMenu: ActiveHand.
			aFlapTab addTitleForHaloMenu: aMenu.
			aFlapTab computeEdgeFraction.
			aMenu popUpEvent: ActiveEvent in: ActiveWorld]]
	
! !

!Flaps classSide methodsFor: 'construction support' stamp: 'sw 5/4/2001 23:52'!
addMorph: aMorph asElementNumber: aNumber inGlobalFlapSatisfying: flapBlock
	"If any global flap satisfies flapBlock, add aMorph to it at the given position.  Applies to flaps that are parts bins and that like thumbnailing"

	| aFlapTab flapPasteUp |
	aFlapTab := self globalFlapTabsIfAny detect: [:aTab | flapBlock value: aTab] ifNone: [^ self].
	flapPasteUp := aFlapTab referent.
	flapPasteUp addMorph: aMorph asElementNumber: aNumber.
	flapPasteUp replaceTallSubmorphsByThumbnails; setPartsBinStatusTo: true! !

!Flaps classSide methodsFor: 'construction support' stamp: 'sw 5/4/2001 23:52'!
addMorph: aMorph asElementNumber: aNumber inGlobalFlapWithID: anID
	"If any global flap satisfies flapBlock, add aMorph to it at the given position.  No senders in the image -- intended to be invoked by doits in code updates only, and applies to flaps that are parts bins and that like thumbnailing"

	^ self addMorph: aMorph asElementNumber: aNumber inGlobalFlapSatisfying: [:aFlap | aFlap flapID = anID]! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'dgd 8/31/2003 18:44'!
addNewDefaultSharedFlaps
	"Add the stack tools flap and the navigator flap to the global list, but do not have them showing initially.  Transitional, called by the postscript of the FlapsOnBottom update; probably dispensable afterwards."

	SharedFlapTabs ifNotNil:
		[(self globalFlapTabWithID: 'Stack Tools' translated) ifNil:
			[SharedFlapTabs add: self newStackToolsFlap delete].
		self enableGlobalFlapWithID: 'Stack Tools' translated.
		(self globalFlapTabWithID: 'Navigator' translated) ifNil:
			[SharedFlapTabs add: self newNavigatorFlap delete].
		self enableGlobalFlapWithID: 'Navigator' translated.
		self currentWorld addGlobalFlaps]! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'alain.plantec 6/26/2008 09:53'!
addStandardFlaps
	"Initialize the standard default out-of-box set of global flaps. 
	This method creates them and places them in my class 
	variable #SharedFlapTabs, but does not itself get them 
	displayed. "
	SharedFlapTabs
		ifNil: [SharedFlapTabs := OrderedCollection new].
	SharedFlapTabs add: self newPharoFlap.
	SharedFlapTabs add: self newSuppliesFlap.
	SharedFlapTabs add: self newToolsFlap.
	SharedFlapTabs add: self newWidgetsFlap.
	SharedFlapTabs add: self newStackToolsFlap.

	Preferences showProjectNavigator
		ifTrue:[SharedFlapTabs add: self newNavigatorFlap].

	SharedFlapTabs add: self newPaintingFlap.
	SharedFlapTabs add: self newObjectsFlap.
	self disableGlobalFlapWithID: 'Stack Tools' translated.
	self disableGlobalFlapWithID: 'Painting' translated.

	Preferences showProjectNavigator
		ifTrue:[self disableGlobalFlapWithID: 'Navigator' translated].

	^ SharedFlapTabs! !

!Flaps classSide methodsFor: 'construction support' stamp: 'sw 4/30/2001 18:57'!
addToSuppliesFlap: aMorph asElementNumber: aNumber
	"Add the given morph to the supplies flap.  To be called by doits in updates, so don't be alarmed by its lack of senders."

	self addMorph: aMorph asElementNumber: aNumber inGlobalFlapWithID: 'Supplies'! !

!Flaps classSide methodsFor: 'miscellaneous' stamp: 'sw 11/22/2001 10:04'!
automaticFlapLayoutChanged
	"Sent when the automaticFlapLayout preference changes.  No senders in easily traceable in the image, but this is really sent by a Preference object!!"

	Preferences automaticFlapLayout ifTrue:
		[self positionNavigatorAndOtherFlapsAccordingToPreference]! !

!Flaps classSide methodsFor: 'flap mechanics' stamp: 'sw 2/16/1999 18:29'!
clobberFlapTabList
	"Flaps clobberFlapTabList"

	SharedFlapTabs := nil! !

!Flaps classSide methodsFor: 'new flap' stamp: 'sw 5/4/2001 23:59'!
defaultColorForFlapBackgrounds
	"Answer the color to use, by default, in new flap backgrounds"

	^ (Color blue mixed: 0.8 with: Color white) alpha: 0.6! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'nk 9/2/2004 15:49'!
defaultsQuadsDefiningPlugInSuppliesFlap
	"Answer a list of quads which define the objects to appear in the default Supplies flap used in the Plug-in image"

	^  #(
	(ObjectsTool				newStandAlone				'Object Catalog'		'A tool that lets you browse the catalog of available objects')
	(AllScriptsTool			allScriptsToolForActiveWorld	'All Scripts' 		'Stop, Step, and Go buttons for controlling all your scripts at once.  The tool can also be "opened up" to control each script in your project individually.')
	(TrashCanMorph			new						'Trash'				'A tool for discarding objects')
	(GrabPatchMorph		new						'Grab Patch'		'Allows you to create a new Sketch by grabbing a rectangular patch from the screen')
	(LassoPatchMorph		new						'Lasso'		'Allows you to create a new Sketch by lassoing an area from the screen')

	(StickyPadMorph		newStandAlone			'Sticky Pad'			'Each time you obtain one of these pastel, translucent, borderless rectangles, it will be a different color from the previous time.')
	"(PaintInvokingMorph	new						'Paint'				'Drop this into an area to start making a fresh painting there')"
	(TextMorph				boldAuthoringPrototype			'Text'				'Text that you can edit into anything you desire.')
	(RecordingControlsMorph	authoringPrototype		'Sound'				'A device for making sound recordings.')
	(RectangleMorph 		authoringPrototype		'Rectangle' 		'A rectangle')
	(RectangleMorph		roundRectPrototype		'RoundRect'		'A rectangle with rounded corners')
	(EllipseMorph			authoringPrototype		'Ellipse'			'An ellipse or circle')
	(StarMorph				authoringPrototype		'Star'			'A star')
	(CurveMorph			authoringPrototype		'Curve'			'A curve')
	(PolygonMorph			authoringPrototype		'Polygon'		'A straight-sided figure with any number of sides')
	(ScriptableButton		authoringPrototype		'Button'			'A Scriptable button')
	(BookMorph				nextPageButton			'NextPage'		'A button that takes you to the next page')
	(BookMorph				previousPageButton 		'PreviousPage'	'A button that takes you to the previous page')
	(ScriptingSystem		prototypicalHolder 		'Holder'			'A place for storing alternative pictures in an animation, etc.')
	(PasteUpMorph			authoringPrototype		'Playfield'		'A place for assembling parts or for staging animations')
	(SimpleSliderMorph		authoringPrototype		'Slider'			'A slider for showing and setting numeric values.')
	(JoystickMorph			authoringPrototype		'Joystick'		'A joystick-like control')
	(BookMorph				authoringPrototype		'Book'			'A multi-paged structure')
	(ClockMorph				authoringPrototype		'Clock'			'A simple digital clock')
	(RandomNumberTile		new					'Random'		'A random-number tile for use with tile scripting')) asOrderedCollection! !

!Flaps classSide methodsFor: 'flaps registry' stamp: 'asm 3/13/2003 11:22'!
defaultsQuadsDefiningScriptingFlap
	"Answer a structure defining the default items in the Scripting flap.
	previously in quadsDeiningScriptingFlap"

	^ #(
	(TrashCanMorph			new						'Trash'				'A tool for discarding objects')	
	(ScriptingSystem 		scriptControlButtons 			'Status'				'Buttons to run, stop, or single-step scripts')
	(AllScriptsTool			allScriptsToolForActiveWorld	'All Scripts' 		'A tool that lets you control all the running scripts in your world')
	(ScriptingSystem		newScriptingSpace			'Scripting'			'A confined place for drawing and scripting, with its own private stop/step/go buttons.')

	(PaintInvokingMorph	new						'Paint'				'Drop this into an area to start making a fresh painting there')
	(ScriptableButton		authoringPrototype		'Button'			'A Scriptable button')
	(ScriptingSystem		prototypicalHolder 		'Holder'			'A place for storing alternative pictures in an animation, etc.')
	(RandomNumberTile		new		'Random'		'A tile that will produce a random number in a given range')
	(ScriptingSystem		anyButtonPressedTiles	'ButtonDown?'	'Tiles for querying whether the mouse button is down')
	(ScriptingSystem		noButtonPressedTiles		'ButtonUp?'		'Tiles for querying whether the mouse button is up')

	(SimpleSliderMorph		authoringPrototype		'Slider'			'A slider for showing and setting numeric values.')
	(JoystickMorph			authoringPrototype		'Joystick'		'A joystick-like control')
	(TextFieldMorph			exampleBackgroundField		'Scrolling Field'	'A scrolling data field which will have a different value on every card of the background')

	(PasteUpMorph			authoringPrototype		'Playfield'		'A place for assembling parts or for staging animations')


	(StackMorph 			authoringPrototype		'Stack' 			'A multi-card data base'	)
	(TextMorph				exampleBackgroundLabel	'Background Label' 'A piece of text that will occur on every card of the background')
	(TextMorph				exampleBackgroundField		'Background Field'	'A  data field which will have a different value on every card of the background')

		) asOrderedCollection! !

!Flaps classSide methodsFor: 'flaps registry' stamp: 'asm 3/13/2003 11:22'!
defaultsQuadsDefiningStackToolsFlap
	"Answer a structure defining the items on the default system Stack Tools flap.
	previously in quadsDefiningStackToolsFlap"

	^ #(
	(StackMorph 			authoringPrototype		'Stack' 				'A multi-card data base'	)
	(StackMorph			stackHelpWindow		'Stack Help'			'Some hints about how to use Stacks')
	(TextMorph				authoringPrototype		'Simple Text'		'Text that you can edit into anything you wish')
	(TextMorph				fancyPrototype			'Fancy Text' 		'A text field with a rounded shadowed border, with a fancy font.')
	(ScrollableField			newStandAlone			'Scrolling Text'		'Holds any amount of text; has a scroll bar')
	(ScriptableButton		authoringPrototype		'Scriptable Button'	'A button whose script will be a method of the background Player')
	(StackMorph			previousCardButton 		'Previous Card' 		'A button that takes the user to the previous card in the stack')
	(StackMorph			nextCardButton			'Next Card'			'A button that takes the user to the next card in the stack')) asOrderedCollection
! !

!Flaps classSide methodsFor: 'flaps registry' stamp: 'nk 9/2/2004 15:49'!
defaultsQuadsDefiningSuppliesFlap
	"Answer a list of quads which define the objects to appear in the default Supplies flap.
	previously in quadsDefiningSuppliesFlap"

	^  #(
	(RectangleMorph 		authoringPrototype		'Rectangle' 		'A rectangle')
	(RectangleMorph		roundRectPrototype		'RoundRect'		'A rectangle with rounded corners')
	(EllipseMorph			authoringPrototype		'Ellipse'			'An ellipse or circle')
	(StarMorph				authoringPrototype		'Star'			'A star')
	(CurveMorph			authoringPrototype		'Curve'			'A curve')
	(PolygonMorph			authoringPrototype		'Polygon'		'A straight-sided figure with any number of sides')
	(TextMorph				boldAuthoringPrototype		'Text'			'Text that you can edit into anything you desire.')
	(ScriptingSystem		prototypicalHolder 		'Holder'			'A place for storing alternative pictures in an animation, etc.')
	(ImageMorph			authoringPrototype		'Picture'		'A non-editable picture of something')
	(ScriptableButton		authoringPrototype		'Button'			'A Scriptable button')
	(SimpleSliderMorph		authoringPrototype		'Slider'			'A slider for showing and setting numeric values.')
	(PasteUpMorph			authoringPrototype		'Playfield'		'A place for assembling parts or for staging animations')
	(BookMorph				authoringPrototype		'Book'			'A multi-paged structure')
	(TabbedPalette			authoringPrototype		'TabbedPalette'	'A structure with tabs')
	(JoystickMorph			authoringPrototype		'Joystick'		'A joystick-like control')
	(ClockMorph				authoringPrototype		'Clock'			'A simple digital clock')
	(BookMorph				previousPageButton 		'PreviousPage'	'A button that takes you to the previous page')
	(BookMorph				nextPageButton			'NextPage'		'A button that takes you to the next page')
		) asOrderedCollection! !

!Flaps classSide methodsFor: 'flaps registry' stamp: 'marcus.denker 10/6/2008 21:15'!
defaultsQuadsDefiningToolsFlap
	"Answer a structure defining the default Tools flap.
	previously in quadsDefiningToolsFlap"

	^ OrderedCollection new
	addAll: #(
	(Browser 				prototypicalToolWindow		'Browser'			'A Browser is a tool that allows you to view all the code of all the classes in the system')
	(TranscriptStream		openMorphicTranscript				'Transcript'			'A Transcript is a window usable for logging and debugging; browse references to #Transcript for examples of how to write to it.')
	(Workspace			prototypicalToolWindow		'Workspace'			'A Workspace is a simple window for editing text.  You can later save the contents to a file if you desire.'));
		add: {   FileList2 .
				#prototypicalToolWindow.
				'File List'.
				'A File List is a tool for browsing folders and files on disks and FTP servers.' };
	addAll: #(
	(DualChangeSorter		prototypicalToolWindow		'Change Sorter'		'Shows two change sets side by side')
	(MessageNames		prototypicalToolWindow		'Message Names'		'A tool for finding, viewing, and editing all methods whose names contain a given character sequence.')
	(Preferences			preferencesControlPanel	'Preferences'			'Allows you to control numerous options')
	(Utilities				recentSubmissionsWindow	'Recent'				'A message browser that tracks the most recently-submitted methods')
	(ProcessBrowser		prototypicalToolWindow		'Processes'			'A Process Browser shows you all the running processes')
	(Preferences			annotationEditingWindow	'Annotations'		'Allows you to specify the annotations to be shown in the annotation panes of browsers, etc.')
	(Scamper				newOpenableMorph			'Scamper'			'A web browser')
	(Celeste				newOpenableMorph			'Celeste'				'Celeste -- an EMail reader')
	(ChangeSorter			prototypicalToolWindow		'Change Set'			'A tool that allows you to view and manipulate all the code changes in a single change set'));
		yourself! !

!Flaps classSide methodsFor: 'flaps registry' stamp: 'marcus.denker 8/18/2008 17:11'!
defaultsQuadsDefiningWidgetsFlap
	"Answer a structure defining the default Widgets flap.
     previously in quadsDefiningWidgetsFlap"

	^ #(
	(TrashCanMorph			new						'Trash'				'A tool for discarding objects')
	(AllScriptsTool			allScriptsToolForActiveWorld	'All Scripts' 		'A tool that lets you see and control all the running scripts in your project')
	(PaintInvokingMorph	new						'Paint'				'Drop this into an area to start making a fresh painting there')
	(RecordingControlsMorph	authoringPrototype		'Sound'				'A device for making sound recordings.')
	(MPEGMoviePlayerMorph	authoringPrototype		'Movie Player'		'A Player for MPEG movies')
	(FrameRateMorph		authoringPrototype			'Frame Rate'		'An indicator of how fast your system is running')
	(MagnifierMorph		newRound					'Magnifier'			'A magnifying glass')
	(ScriptingSystem		newScriptingSpace			'Scripting'			'A confined place for drawing and scripting, with its own private stop/step/go buttons.')
	(ScriptingSystem		holderWithAlphabet			'Alphabet'			'A source for single-letter objects')
	(BouncingAtomsMorph	new						'Bouncing Atoms'	'Atoms, mate')
	(ObjectsTool				newStandAlone				'Object Catalog'		'A tool that lets you browse the catalog of objects')
	) asOrderedCollection! !

!Flaps classSide methodsFor: 'construction support' stamp: 'sw 5/5/2001 02:12'!
deleteMorphsSatisfying: deleteBlock fromGlobalFlapSatisfying: flapBlock
	"If any global flap satisfies flapBlock, then delete objects satisfying from deleteBlock from it.  Occasionally called from do-its in updates or other fileouts."

	| aFlapTab flapPasteUp |
	aFlapTab := self globalFlapTabsIfAny detect: [:aTab | flapBlock value: aTab] ifNone: [^ self].
	flapPasteUp := aFlapTab referent.
	flapPasteUp submorphs do:
		[:aMorph | (deleteBlock value: aMorph) ifTrue: [aMorph delete]]! !

!Flaps classSide methodsFor: 'menu commands' stamp: 'alain.plantec 5/30/2008 13:20'!
disableGlobalFlapWithID: aFlapID
	"Mark this project as having the given flapID disabled"

	| disabledFlapIDs  aFlapTab currentProject |
	(currentProject := Project current) assureFlapIntegrity.
	disabledFlapIDs := currentProject parameterAt: #disabledGlobalFlapIDs.
	(aFlapTab := self globalFlapTabWithID: aFlapID) ifNotNil:
		[aFlapTab hideFlap].
	(disabledFlapIDs includes: aFlapID)
		ifFalse:
			[disabledFlapIDs add: aFlapID].
	aFlapTab ifNotNil: [aFlapTab delete]

	! !

!Flaps classSide methodsFor: 'menu commands' stamp: 'mir 8/22/2001 18:55'!
disableGlobalFlaps
	"Clobber all the shared flaps structures.  First read the user her Miranda rights."

	self disableGlobalFlaps: true! !

!Flaps classSide methodsFor: 'menu commands' stamp: 'alain.plantec 5/30/2008 13:22'!
disableGlobalFlaps: interactive 
	"Clobber all the shared flaps structures. First read the user her Miranda
	rights. "
	interactive
		ifTrue: [(self confirm: 'CAUTION!! This will destroy all the shared
flaps, so that they will not be present in 
*any* project.  If, later, you want them
back, you will have to reenable them, from
this same menu, whereupon the standard
default set of shared flaps will be created.
Do you really want to go ahead and clobber
all shared flaps at this time?' translated)
				ifFalse: [^ self]].
	self globalFlapTabsIfAny
		do: [:aFlapTab | 
			self removeFlapTab: aFlapTab keepInList: false.
			aFlapTab isInWorld
				ifTrue: [self error: 'Flap problem' translated]].
	self clobberFlapTabList.
	SharedFlapsAllowed := false.
	ActiveWorld restoreMorphicDisplay.
	ActiveWorld reformulateUpdatingMenus! !

!Flaps classSide methodsFor: 'miscellaneous' stamp: 'sw 11/22/2001 09:58'!
doAutomaticLayoutOfFlapsIfAppropriate
	"Do automatic layout of flaps if appropriate"

	Preferences automaticFlapLayout ifTrue:
		[self positionNavigatorAndOtherFlapsAccordingToPreference]! !

!Flaps classSide methodsFor: 'miscellaneous' stamp: 'dgd 8/31/2003 19:26'!
enableClassicNavigatorChanged
	"The #classicNavigatorEnabled preference has changed.   No senders in easily traceable in the image, but this is really sent by a Preference object!!"

	Preferences classicNavigatorEnabled
		ifTrue:
			[Flaps disableGlobalFlapWithID: 'Navigator' translated.
			Preferences enable: #showProjectNavigator.
			self disableGlobalFlapWithID: 'Navigator' translated.]
		ifFalse:
			[self enableGlobalFlapWithID: 'Navigator' translated.
			ActiveWorld addGlobalFlaps].

	self doAutomaticLayoutOfFlapsIfAppropriate.
	Project current assureNavigatorPresenceMatchesPreference.
	ActiveWorld reformulateUpdatingMenus! !

!Flaps classSide methodsFor: 'menu commands' stamp: 'alain.plantec 5/30/2008 13:23'!
enableDisableGlobalFlapWithID: aFlapID
	"Toggle the enable/disable status of the given global flap"

	| disabledFlapIDs  aFlapTab currentProject |
	(currentProject := Project current) assureFlapIntegrity.
	disabledFlapIDs := currentProject parameterAt: #disabledGlobalFlapIDs.
	(aFlapTab := self globalFlapTabWithID: aFlapID) ifNotNil:
		[aFlapTab hideFlap].
	(disabledFlapIDs includes: aFlapID)
		ifTrue:
			[disabledFlapIDs remove: aFlapID.
			self currentWorld addGlobalFlaps]
		ifFalse:
			[disabledFlapIDs add: aFlapID.
			aFlapTab ifNotNil: [aFlapTab delete]].
	self doAutomaticLayoutOfFlapsIfAppropriate! !

!Flaps classSide methodsFor: 'menu support' stamp: 'sw 6/11/2002 14:05'!
enableEToyFlaps
	"Start using global flaps, plug-in version, given that they were not present."

	Cursor wait showWhile:
		[self addAndEnableEToyFlaps.
		self enableGlobalFlaps]! !

!Flaps classSide methodsFor: 'menu commands' stamp: 'alain.plantec 5/30/2008 13:24'!
enableGlobalFlapWithID: aFlapID
	"Remove any memory of this flap being disabled in this project"

	| disabledFlapIDs  currentProject |
	(currentProject := Project current) assureFlapIntegrity.
	disabledFlapIDs := currentProject parameterAt: #disabledGlobalFlapIDs ifAbsent: [^ self].
	disabledFlapIDs remove: aFlapID ifAbsent: []
	! !

!Flaps classSide methodsFor: 'menu support' stamp: 'alain.plantec 5/30/2008 13:25'!
enableGlobalFlaps
	"Start using global flaps, given that they were not present."
	Cursor wait
		showWhile: [SharedFlapsAllowed := true.
			self globalFlapTabs.
			"This will create them"
			ActiveWorld addGlobalFlaps.
			self doAutomaticLayoutOfFlapsIfAppropriate.
			FlapTab
				allInstancesDo: [:aTab | aTab computeEdgeFraction].
			ActiveWorld reformulateUpdatingMenus]! !

!Flaps classSide methodsFor: 'shared flaps' stamp: 'sw 7/24/2001 22:01'!
enableOnlyGlobalFlapsWithIDs: survivorList
	"In the current project, suppress all global flaps other than those with ids in the survivorList"

	self globalFlapTabsIfAny do: [:aFlapTab |
		(survivorList includes: aFlapTab flapID)
			ifTrue:
				[self enableGlobalFlapWithID: aFlapTab flapID]
			ifFalse:
				[self disableGlobalFlapWithID: aFlapTab flapID]].
	ActiveWorld addGlobalFlaps 

	"Flaps enableOnlyGlobalFlapsWithIDs: #('Supplies')"! !

!Flaps classSide methodsFor: 'menu commands' stamp: 'sw 3/3/2004 15:49'!
explainFlaps
	"Open a window giving flap help."

	(StringHolder new contents: self explainFlapsText translated)
		openLabel: 'Flaps' translated

"Flaps explainFlaps"




	! !

!Flaps classSide methodsFor: 'menu commands' stamp: 'sw 3/3/2004 15:51'!
explainFlapsText
	"Answer the text, in English, to show in a help-window about Flaps."

	^'Flaps are like drawers on the edge of the screen, which can be opened so that you can use what is inside them, and closed when you do not need them.  They have many possible uses, a few of which are illustrated by the default set of flaps you can get as described below.

''Shared flaps'' are available in every morphic project.  As you move from project to project, you will see these same shared flaps in each, though there are also options, on a project-by-project basis, to choose which of the shared flaps should be shown, and also momentarily to suppress the showing of all shared flaps.   

To get started using flaps, bring up the desktop menu and choose ''flaps...'', and make the menu stay up by choosing ''keep this menu up''.  If you see, in this flaps menu,  a list of flap names such as ''Squeak'', ''Tools'', etc., it means that shared flaps are already set up in your image.  If you do not see the list, you will instead see a menu item that invites you to ''install default shared flaps''; choose that, and new flaps will be created, and the flaps menu will change to reflect their presence.

''Project flaps'' are flaps that belong to a single morphic project.  You will see them when you are in that project, but not when you are in any other morphic project.

If a flap is set up as a parts bin (such as the default Tools and Supplies flaps), you can use it to create new objects -- just open the flap, then find the object you want, and drag it out; when the cursor leaves the flap, the flap itself will snap closed, and you''ll be left holding the new object -- just click to place it exactly where you want it.

If a flap is *not* set up as a parts bin (such as the default ''Squeak'' flap at the left edge of the screen) you can park objects there (this is an easy way to move objects from project to project) and you can place your own private controls there, etc.  Everything in the default ''Squeak'' flap (and all the other default flaps, for that matter) is there only for illustrative purposes -- every user will want to fine-tune the flaps to suit his/her own style and needs.

Each flap may be set up to appear on mouseover, dragover, both, or neither.  See the menu items described below for more about these and other options.

You can open a closed flap by clicking on its tab, or by dragging the tab toward the center of the screen

You can close an open flap by clicking on its tab or by dragging the tab back off the edge of the screen.

Drag the tab of a flap to reposition the tab and to resize the flap itself.  Repositioning starts when you drag the cursor out of the original tab area.

If flaps or their tabs seem wrongly positioned or lost, try issuing a restoreDisplay from the screen menu.

The red-halo menu on a flap allows you to change the flap''s properties.   For greatest ease of use, request ''keep this menu up'' here -- that way, you can easily explore all the options in the menu.

tab color...				Lets you change the color of the flap''s tab.
flap color...				Lets you change the color of the flap itself.

use textual tab...		If the tab is not textual, makes it become textual.
change tab wording...	If the tab is already textual, allows you to edit
							its wording.

use graphical tab...		If the tab is not graphical, makes it become
							graphical.
choose tab graphic...	If the tab is already graphical, allows you
							to change the picture.

use solid tab...			If the tab is not solid, makes it become solid, i.e.
							appear as a solid band of color along the
							entire length or width of the screen.

parts-bin behavior		If set, then dragging an object from the flap
							tears off a new copy of the object.

dragover				If set, the flap opens on dragover and closes
							again on drag-leave.

mouseover				If set, the flap opens on mouseover and closes
							again on mouse-leave. 

cling to edge...			Governs which edge (left, right, top, bottom)
							the flap adheres to.

shared					If set, the same flap will be available in all projects; if not, the
							flap will will occur only in one project.

destroy this flap		Deletes the flap.

To define a new flap, use ''make a new flap'', found in the ''flaps'' menu.

To reinstate the default system flaps, you can use ''destroy all shared flaps'' from the ''flaps'' menu, and once they are destroyed, choose ''install default shared flaps''.

To add, delete, or edit things on a given flap, it is often wise first to suspend the flap''s mouse-over and drag-over sensitivity, so it won''t keep disappearing on you while you''re trying to work with it.

Besides the three standard flaps delivered with the default system, there are two other flaps readily available on demand from the ''flaps'' menu -- one is called ''Stack Tools'', which provides some tools useful for building stack-like content, the other is called ''Painting'', which provides a quick way to make a new painting.  Simply clicking on the appropriate checkbox in the ''flaps'' menu will toggle the corresponding flap between being visible and not being visible in the project.'! !

!Flaps classSide methodsFor: 'miscellaneous' stamp: 'sd 1/16/2004 21:33'!
fileOutChanges
	"Bug workaround for squeak-flap 'fileOutChanges' buttons which for a while were mistakenly sending their requests here..."

	^ ChangeSet current verboseFileOut. ! !

!Flaps classSide methodsFor: 'flap mechanics' stamp: 'sw 7/12/2001 22:01'!
freshFlapsStart
	"To be called manually only, as a drastic measure.  Delete all flap artifacts and establish fresh default global flaps
	Flaps freshFlapsStart
	"
	self currentWorld deleteAllFlapArtifacts.
	self clobberFlapTabList.
	self addStandardFlaps
! !

!Flaps classSide methodsFor: 'shared flaps' stamp: 'sw 4/27/2001 16:34'!
globalFlapTab: aName
	"Answer the global flap tab in the current system whose flapID is the same as aName, or nil if none found."

	| idToMatch |
	idToMatch := (aName beginsWith: 'flap: ')
		ifTrue:  "Ted's old scheme; this convention may still be found
				in pre-existing content that has been externalized"
			[aName copyFrom: 7 to: aName size]
		ifFalse:
			[aName].

	^ self globalFlapTabsIfAny detect: [:ft | ft flapID = idToMatch] ifNone: [nil]! !

!Flaps classSide methodsFor: 'shared flaps' stamp: 'sw 4/27/2001 16:36'!
globalFlapTabOrDummy: aName
	"Answer a global flap tab in the current image with the given name.  If none is found, answer a dummy StringMorph for some reason (check with tk about the use of this)"

	| gg |
	(gg := self globalFlapTab: aName) ifNil:
		[^ StringMorph contents: aName, ' can''t be found'].
	^ gg! !

!Flaps classSide methodsFor: 'shared flaps' stamp: 'di 11/19/2001 22:07'!
globalFlapTabWithID: aFlapID
	"answer the global flap tab with the given id, or nil if none"

	^ self globalFlapTabsIfAny detect: [:aFlapTab | aFlapTab flapID = aFlapID]
		ifNone:
		["Second try allows sequence numbers"
		self globalFlapTabsIfAny detect: [:aFlapTab | FlapTab givenID: aFlapTab flapID matches: aFlapID]
			ifNone: [nil]]! !

!Flaps classSide methodsFor: 'shared flaps' stamp: 'sw 5/5/2001 02:41'!
globalFlapTabs
	"Answer the list of shared flap tabs, creating it if necessary.  Much less aggressive is #globalFlapTabsIfAny"

	SharedFlapTabs ifNil: [self initializeStandardFlaps].
	^ SharedFlapTabs copy! !

!Flaps classSide methodsFor: 'shared flaps' stamp: 'sw 4/23/2001 18:04'!
globalFlapTabsIfAny
	"Answer a list of the global flap tabs, but it they don't exist, just answer an empty list"

	^ SharedFlapTabs copy ifNil: [Array new]! !

!Flaps classSide methodsFor: 'shared flaps' stamp: 'sw 4/8/2002 08:41'!
globalFlapTabsWithID: aFlapID
	"Answer all flap tabs whose ids start with the given id"

	^ self globalFlapTabsIfAny select:
		[:aFlapTab |
			(aFlapTab flapID = aFlapID) or: [FlapTab givenID: aFlapTab flapID matches: aFlapID]]

"Flaps globalFlapTabsWithID: 'Stack Tools'"! !

!Flaps classSide methodsFor: 'menu support' stamp: 'sw 4/17/2001 13:50'!
globalFlapWithIDEnabledString: aFlapID
	"Answer the string to be shown in a menu to represent the status of the givne flap regarding whether it it should be shown in this project."

	| aFlapTab wording |
	aFlapTab := self globalFlapTabWithID: aFlapID.
	wording := aFlapTab ifNotNil: [aFlapTab wording] ifNil: ['(',  aFlapID, ')'].
	^ (Project current isFlapIDEnabled: aFlapID)
		ifTrue:
			['<on>', wording]
		ifFalse:
			['<off>', wording]! !

!Flaps classSide methodsFor: 'class initialization' stamp: 'nk 6/14/2004 08:37'!
initialize
	self initializeFlapsQuads! !

!Flaps classSide methodsFor: 'flaps registry' stamp: 'asm 3/13/2003 10:58'!
initializeFlapsQuads
	"initialize the list of dynamic flaps quads.
	self initializeFlapsQuads"
	FlapsQuads := nil. 
	self registeredFlapsQuads at: 'PlugIn Supplies' put: self defaultsQuadsDefiningPlugInSuppliesFlap;
		 at: 'Stack Tools' put: self defaultsQuadsDefiningStackToolsFlap;
		 at: 'Supplies' put: self defaultsQuadsDefiningSuppliesFlap;
		 at: 'Tools' put: self defaultsQuadsDefiningToolsFlap;
		 at: 'Widgets' put: self defaultsQuadsDefiningWidgetsFlap;
		 at: 'Scripting' put: self defaultsQuadsDefiningScriptingFlap.
	^ self registeredFlapsQuads! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'sw 8/12/2001 16:55'!
initializeStandardFlaps
	"Initialize the standard default out-of-box set of global flaps. This method creates them and places them in my class variable #SharedFlapTabs, but does not itself get them displayed."

	SharedFlapTabs := nil.
	self addStandardFlaps! !

!Flaps classSide methodsFor: 'miscellaneous' stamp: 'dgd 8/31/2003 19:28'!
makeNavigatorFlapResembleGoldenBar
	"At explicit request, make the flap-based navigator resemble the golden bar.  No senders in the image, but sendable from a doit"

	"Flaps makeNavigatorFlapResembleGoldenBar"

	Preferences setPreference: #classicNavigatorEnabled toValue: false.
	Preferences setPreference: #showProjectNavigator toValue: false.
	(self globalFlapTabWithID: 'Navigator' translated) ifNil:
		[SharedFlapTabs add: self newNavigatorFlap delete].
	self enableGlobalFlapWithID: 'Navigator' translated.
	Preferences setPreference: #navigatorOnLeftEdge toValue: true.
	(self globalFlapTabWithID: 'Navigator' translated) arrangeToPopOutOnMouseOver: true.
	ActiveWorld addGlobalFlaps.
	self doAutomaticLayoutOfFlapsIfAppropriate.
	Project current assureNavigatorPresenceMatchesPreference.
	! !

!Flaps classSide methodsFor: 'new flap' stamp: 'sw 4/17/2001 13:24'!
newFlapTitled: aString onEdge: anEdge
	"Create a new flap with the given title and place it on the given edge"

	^ self newFlapTitled: aString onEdge: anEdge inPasteUp: self currentWorld
! !

!Flaps classSide methodsFor: 'new flap' stamp: 'di 11/19/2001 21:07'!
newFlapTitled: aString onEdge: anEdge inPasteUp: aPasteUpMorph
	"Add a flap with the given title, placing it on the given edge, in the given pasteup"

	| aFlapBody aFlapTab  |
	aFlapBody := PasteUpMorph newSticky.
	aFlapTab := FlapTab new referent: aFlapBody.
	aFlapTab setName: aString edge: anEdge color: (Color r: 0.516 g: 0.452 b: 1.0).

	anEdge == #left ifTrue:
		[aFlapTab position: (aPasteUpMorph left @ aPasteUpMorph top).
		aFlapBody extent: (200 @ aPasteUpMorph height)].
	anEdge == #right ifTrue:
		[aFlapTab position: ((aPasteUpMorph right - aFlapTab width) @ aPasteUpMorph top).
		aFlapBody extent: (200 @ aPasteUpMorph height)].
	anEdge == #top ifTrue:
		[aFlapTab position: ((aPasteUpMorph left + 50) @ aPasteUpMorph top).
		aFlapBody extent: (aPasteUpMorph width @ 200)].
	anEdge == #bottom ifTrue:
		[aFlapTab position: ((aPasteUpMorph left + 50) @ (aPasteUpMorph bottom - aFlapTab height)).
		aFlapBody extent: (aPasteUpMorph width @ 200)].

	aFlapBody beFlap: true.
	aFlapBody color: self defaultColorForFlapBackgrounds.

	^ aFlapTab! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'nk 8/6/2004 11:37'!
newLoneSuppliesFlap
	"Answer a fully-instantiated flap named 'Supplies' to be placed at the bottom of the screen, for use when it is the only flap shown upon web launch"

	|  aFlapTab aStrip leftEdge |  "Flaps setUpSuppliesFlapOnly"
	aStrip := PartsBin newPartsBinWithOrientation: #leftToRight andColor: Color red muchLighter from:	 #(

	(TrashCanMorph			new						'Trash'				'A tool for discarding objects')	
	(ScriptingSystem 		scriptControlButtons 			'Status'				'Buttons to run, stop, or single-step scripts')
	(AllScriptsTool			allScriptsToolForActiveWorld	'All Scripts' 		'A tool that lets you control all the running scripts in your world')

	(PaintInvokingMorph	new						'Paint'				'Drop this into an area to start making a fresh painting there')
	(RectangleMorph 		authoringPrototype		'Rectangle' 		'A rectangle'	)
	(RectangleMorph		roundRectPrototype		'RoundRect'		'A rectangle with rounded corners')
	(EllipseMorph			authoringPrototype		'Ellipse'			'An ellipse or circle')
	(StarMorph				authoringPrototype		'Star'			'A star')
	(CurveMorph			authoringPrototype		'Curve'			'A curve')
	(PolygonMorph			authoringPrototype		'Polygon'		'A straight-sided figure with any number of sides')
	(TextMorph				authoringPrototype		'Text'			'Text that you can edit into anything you desire.')
	(SimpleSliderMorph		authoringPrototype		'Slider'			'A slider for showing and setting numeric values.')
	(JoystickMorph			authoringPrototype		'Joystick'		'A joystick-like control')
	(ScriptingSystem		prototypicalHolder 		'Holder'			'A place for storing alternative pictures in an animation, ec.')
	(ScriptableButton		authoringPrototype		'Button'			'A Scriptable button')
	(PasteUpMorph			authoringPrototype		'Playfield'		'A place for assembling parts or for staging animations')
	(BookMorph				authoringPrototype		'Book'			'A multi-paged structure')
	(TabbedPalette			authoringPrototype		'Tabs'			'A structure with tabs')

	(RecordingControlsMorph authoringPrototype			'Sound'				'A device for making sound recordings.')
	(MagnifierMorph		newRound					'Magnifier'			'A magnifying glass')

	(ImageMorph			authoringPrototype		'Picture'		'A non-editable picture of something')
	(ClockMorph				authoringPrototype		'Clock'			'A simple digital clock')
	(BookMorph				previousPageButton 		'Previous'		'A button that takes you to the previous page')
	(BookMorph				nextPageButton			'Next'			'A button that takes you to the next page')
		).

	aFlapTab := FlapTab new referent: aStrip beSticky.
	aFlapTab setName: 'Supplies' translated edge: #bottom color: Color red lighter.

	aStrip extent: self currentWorld width @ 78.
	leftEdge := ((Display width - (16  + aFlapTab width)) + 556) // 2.

	aFlapTab position: (leftEdge @ (self currentWorld height - aFlapTab height)).

	aStrip beFlap: true.
	aStrip autoLineLayout: true.
	
	^ aFlapTab! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'dgd 8/31/2003 19:03'!
newNavigatorFlap
	"Answer a newly-created flap which adheres to the bottom edge of the screen and which holds the project navigator controls. "

	|  aFlapTab navBar aFlap |
	navBar := ProjectNavigationMorph preferredNavigator new.
	aFlap := PasteUpMorph newSticky borderWidth: 0;
			extent: navBar extent + (0@20);
			color: (Color orange alpha: 0.8);
			beFlap: true;
			addMorph: navBar beSticky.
	aFlap hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	aFlap useRoundedCorners.
	aFlap setNameTo: 'Navigator Flap' translated.
	navBar fullBounds.  "to establish width"
	
	aFlapTab := FlapTab new referent: aFlap.
	aFlapTab setName: 'Navigator' translated edge: #bottom color: Color orange.
	aFlapTab position: ((navBar width // 2) - (aFlapTab width // 2))
					@ (self currentWorld height - aFlapTab height).
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.
	^ aFlapTab

"Flaps replaceGlobalFlapwithID: 'Navigator' translated "
! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'nk 9/3/2004 12:51'!
newObjectsFlap
	"Answer a fully-instantiated flap named 'Objects' to be placed at the top of the screen."

	|  aFlapTab anObjectsTool |
	anObjectsTool := ObjectsTool new.
	anObjectsTool initializeForFlap.

	aFlapTab := FlapTab new referent: anObjectsTool beSticky.
	aFlapTab setName: 'Objects' translated edge: #top color: Color red lighter.
	aFlapTab position: ((Display width - (aFlapTab width + 22)) @ 0).
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.

	anObjectsTool extent: self currentWorld width @ 200.
	anObjectsTool beFlap: true.
	anObjectsTool color: Color red muchLighter.
	anObjectsTool clipSubmorphs: true.

	anObjectsTool showCategories.

	^ aFlapTab! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'dgd 8/31/2003 19:50'!
newPaintingFlap
	"Add a flap with the paint palette in it"

	| aFlap aFlapTab  |
	"Flaps reinstateDefaultFlaps. Flaps addPaintingFlap"

	aFlap := PasteUpMorph new borderWidth: 0.
	aFlap color: Color transparent.
	aFlap layoutPolicy: TableLayout new.
	aFlap hResizing: #shrinkWrap.
	aFlap vResizing: #shrinkWrap.
	aFlap cellPositioning: #topLeft.
	aFlap clipSubmorphs: false.

	aFlap beSticky. "really?!!"
	aFlap addMorphFront: PaintBoxMorph new.
	aFlap setProperty: #flap toValue: true.
	aFlap fullBounds. "force layout"

	aFlapTab := FlapTab new referent: aFlap.
	aFlapTab setNameTo: 'Painting' translated.
	aFlapTab setProperty: #priorWording toValue: 'Paint' translated.
	aFlapTab useGraphicalTab.
	aFlapTab removeAllMorphs.
	aFlapTab setProperty: #paintingFlap toValue: true.
	aFlapTab addMorphFront: 
		"(SketchMorph withForm: (ScriptingSystem formAtKey: #PaintingFlapPic))"
		self paintFlapButton.
	aFlapTab cornerStyle: #rounded.
	aFlapTab edgeToAdhereTo: #right.
	aFlapTab setToPopOutOnDragOver: false.
	aFlapTab setToPopOutOnMouseOver: false.
	aFlapTab on: #mouseUp send: #startOrFinishDrawing: to: aFlapTab.
	aFlapTab setBalloonText:'Click here to start or finish painting.' translated.

	aFlapTab fullBounds. "force layout"
	aFlapTab position: (0@6).
	self currentWorld addMorphFront: aFlapTab.  
	^ aFlapTab! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'alain.plantec 6/26/2008 10:17'!
newPharoFlap
	"Answer a new default 'Pharo' flap for the left edge of the screen"

	| aFlap aFlapTab aButton aClock buttonColor anOffset bb aFont |
	aFlap := PasteUpMorph newSticky borderWidth: 0.
	aFlapTab := FlapTab new referent: aFlap.
	aFlapTab setName: 'Pharo' translated edge: #left color: (Color gray lighter lighter).
	aFlapTab position: (0 @ ((Display height - aFlapTab height) // 8)).
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.

	aFlap cellInset: 14@14.
	aFlap beFlap: true.
	aFlap color: (Color gray muchLighter  alpha: 0.8).
	aFlap extent: 150 @ self currentWorld height.
	aFlap layoutPolicy: TableLayout new.
	aFlap wrapCentering: #topLeft.
	aFlap layoutInset: 2.
	aFlap listDirection: #topToBottom.
	aFlap wrapDirection: #leftToRight.

	"self addProjectNavigationButtonsTo: aFlap."
	anOffset := 16.

	aClock := ClockMorph newSticky.
	aClock color: Color red.
	aClock showSeconds: false.
	aClock font: (TextStyle default fontAt: 3).
	aClock step.
	aClock setBalloonText: 'The time of day.  If you prefer to see seconds, check out my menu.' translated.
	aFlap addCenteredAtBottom: aClock offset: anOffset.

	buttonColor :=  Color cyan muchLighter.
	bb := SimpleButtonMorph new target: SmalltalkImage current.
	bb color: buttonColor.
	aButton := bb copy.
	aButton actionSelector: #saveSession.
	aButton setBalloonText: 'Make a complete snapshot of the current state of the image onto disk.' translated.
	aButton label: 'save' translated font: (aFont := ScriptingSystem fontForTiles).
	aFlap addCenteredAtBottom: aButton offset: anOffset.

	aButton := bb copy target: Utilities.
	aButton actionSelector: #updateFromServer.
	aButton label: 'load code updates' translated font: aFont.
	aButton color: buttonColor.
	aButton setBalloonText: 'Check the Pharo server for any new code updates, and load any that are found.' translated.
	aFlap addCenteredAtBottom: aButton offset: anOffset.

	aButton := SimpleButtonMorph new target: SmalltalkImage current; actionSelector: #aboutThisSystem;
		label: 'about this system' translated font: aFont.
	aButton color: buttonColor.
	aButton setBalloonText: 'click here to find out version information' translated.
	aFlap addCenteredAtBottom: aButton offset: anOffset.

	aFlap addCenteredAtBottom: (Preferences themeChoiceButtonOfColor: buttonColor font: aFont) offset: anOffset.

	aButton := TrashCanMorph newSticky.
	aFlap addCenteredAtBottom: aButton offset: anOffset.
	aButton startStepping.

	^ aFlapTab

"Flaps replaceGlobalFlapwithID: 'Pharo' translated "! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'alain.plantec 6/26/2008 10:03'!
newSqueakFlap
	"Answer a new default 'Squeak' flap for the left edge of the screen"

	| aFlap aFlapTab aButton aClock buttonColor anOffset bb aFont |
	self halt.
	self deprecated: 'This is Pharo, use newPharoFlap instead'.
	aFlap := PasteUpMorph newSticky borderWidth: 0.
	aFlapTab := FlapTab new referent: aFlap.
	aFlapTab setName: 'Squeak' translated edge: #left color: Color brown lighter lighter.
	aFlapTab position: (0 @ ((Display height - aFlapTab height) // 2)).
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.

	aFlap cellInset: 14@14.
	aFlap beFlap: true.
	aFlap color: (Color brown muchLighter lighter "alpha: 0.3").
	aFlap extent: 150 @ self currentWorld height.
	aFlap layoutPolicy: TableLayout new.
	aFlap wrapCentering: #topLeft.
	aFlap layoutInset: 2.
	aFlap listDirection: #topToBottom.
	aFlap wrapDirection: #leftToRight.

	"self addProjectNavigationButtonsTo: aFlap."
	anOffset := 16.

	aClock := ClockMorph newSticky.
	aClock color: Color red.
	aClock showSeconds: false.
	aClock font: (TextStyle default fontAt: 3).
	aClock step.
	aClock setBalloonText: 'The time of day.  If you prefer to see seconds, check out my menu.' translated.
	aFlap addCenteredAtBottom: aClock offset: anOffset.

	buttonColor :=  Color cyan muchLighter.
	bb := SimpleButtonMorph new target: SmalltalkImage current.
	bb color: buttonColor.
	aButton := bb copy.
	aButton actionSelector: #saveSession.
	aButton setBalloonText: 'Make a complete snapshot of the current state of the image onto disk.' translated.
	aButton label: 'save' translated font: (aFont := ScriptingSystem fontForTiles).
	aFlap addCenteredAtBottom: aButton offset: anOffset.

	aButton := bb copy target: Utilities.
	aButton actionSelector: #updateFromServer.
	aButton label: 'load code updates' translated font: aFont.
	aButton color: buttonColor.
	aButton setBalloonText: 'Check the Squeak server for any new code updates, and load any that are found.' translated.
	aFlap addCenteredAtBottom: aButton offset: anOffset.

	aButton := SimpleButtonMorph new target: SmalltalkImage current; actionSelector: #aboutThisSystem;
		label: 'about this system' translated font: aFont.
	aButton color: buttonColor.
	aButton setBalloonText: 'click here to find out version information' translated.
	aFlap addCenteredAtBottom: aButton offset: anOffset.

	aFlap addCenteredAtBottom: (Preferences themeChoiceButtonOfColor: buttonColor font: aFont) offset: anOffset.

	aButton := TrashCanMorph newSticky.
	aFlap addCenteredAtBottom: aButton offset: anOffset.
	aButton startStepping.

	^ aFlapTab

"Flaps replaceGlobalFlapwithID: 'Squeak' translated "! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'nk 8/6/2004 11:39'!
newStackToolsFlap
	"Add a flap with stack tools in it"

	| aFlapTab aStrip |
	aStrip := PartsBin newPartsBinWithOrientation: #leftToRight
		andColor: (Color red muchLighter "alpha: 0.2") from: self quadsDefiningStackToolsFlap.

	aFlapTab := FlapTab new referent: aStrip beSticky.
	aFlapTab setName: 'Stack Tools' translated edge: #bottom color: Color brown lighter lighter.
	aFlapTab position: ((Display width - (aFlapTab width + 226)) @ (self currentWorld height - aFlapTab height)).
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.

	aStrip extent: self currentWorld width @ 78.
	aStrip beFlap: true.
	aStrip autoLineLayout: true.
	aStrip extent: self currentWorld width @ 70.

	^ aFlapTab

"Flaps replaceGlobalFlapwithID: 'Stack Tools' translated"! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'sw 6/11/2002 14:00'!
newSuppliesFlap
	"Answer a fully-instantiated flap named 'Supplies' to be placed at the bottom of the screen; this is for the non-plug-in-version"

	^ self newSuppliesFlapFromQuads: self quadsDefiningSuppliesFlap positioning: #right! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'mir 10/7/2005 16:32'!
newSuppliesFlapFromQuads: quads positioning: positionSymbol
	"Answer a fully-instantiated flap named 'Supplies' to be placed at the bottom of the screen.  Use #center as the positionSymbol to have it centered at the bottom of the screen, or #right to have it placed off near the right edge."

	|  aFlapTab aStrip hPosition |
	aStrip := PartsBin newPartsBinWithOrientation: #leftToRight andColor: Color red muchLighter from:	 quads.
	self twiddleSuppliesButtonsIn: aStrip.
	aFlapTab := FlapTab new referent: aStrip beSticky.
	aFlapTab setName: 'Supplies' translated edge: #bottom color: Color red lighter.
	hPosition := positionSymbol == #center
		ifTrue:
			[(Display width // 2) - (aFlapTab width // 2)]
		ifFalse:
			[Display width - (aFlapTab width + 22)].
	aFlapTab position: (hPosition @ (self currentWorld height - aFlapTab height)).
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.

	aStrip extent: self currentWorld width @ 136.
	aStrip beFlap: true.
	aStrip autoLineLayout: true.
	
	^ aFlapTab

"Flaps replaceGlobalFlapwithID: 'Supplies' translated"! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'nk 8/6/2004 11:39'!
newToolsFlap
	"Answer a newly-created flap which adheres to the right edge of the screen and which holds prototypes of standard tools."

	|  aFlapTab aStrip |
	aStrip := PartsBin newPartsBinWithOrientation: #topToBottom andColor: (Color orange muchLighter alpha: 0.8) from: self quadsDefiningToolsFlap.
 
	aFlapTab := FlapTab new referent: aStrip beSticky.
	aFlapTab setName: 'Tools' translated edge: #right color: Color orange lighter.
	aFlapTab position: (self currentWorld width - aFlapTab width) @ ((Display height - aFlapTab height) // 2).
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.

	aStrip extent: (90 @ self currentWorld height).
	aStrip beFlap: true.
	
	^ aFlapTab

"Flaps replaceGlobalFlapwithID: 'Tools' translated "
! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'nk 8/6/2004 11:40'!
newWidgetsFlap
	"Answer a newly-created flap which adheres to the bottom edge of the screen and which holds prototypes of standard widgets. "

	|  aFlapTab aStrip |
	aStrip := PartsBin newPartsBinWithOrientation: #leftToRight andColor: (Color blue muchLighter alpha: 0.8)
		from:	 self quadsDefiningWidgetsFlap.

	aFlapTab := FlapTab new referent: aStrip beSticky.
	aFlapTab setName: 'Widgets' translated edge: #bottom color: Color blue lighter lighter.
	aFlapTab position: ((Display width - (aFlapTab width + 122)) @ (self currentWorld height - aFlapTab height)).
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.

	aStrip extent: self currentWorld width @ 78.
	aStrip beFlap: true.
	aStrip autoLineLayout: true.
	
	^ aFlapTab

"Flaps replaceGlobalFlapwithID: 'Widgets' translated "
! !

!Flaps classSide methodsFor: 'miscellaneous' stamp: 'sw 4/17/2001 13:24'!
orientationForEdge: anEdge
	"Answer the orientation -- #horizontal or #vertical -- that corresponds to the edge symbol"

	^ (#(left right) includes: anEdge)
		ifTrue:	[#vertical]
		ifFalse:	[#horizontal]! !

!Flaps classSide methodsFor: 'miscellaneous' stamp: 'sw 4/17/2001 13:24'!
paintFlapButton
	"Answer a button to serve as the paint flap"

	| pb oldArgs brush myButton m |
	pb := PaintBoxMorph new submorphNamed: #paint:.
	pb
		ifNil:
			[(brush := Form extent: 16@16 depth: 16) fillColor: Color red]
		ifNotNil:
			[oldArgs := pb arguments.
			brush := oldArgs third.
			brush := brush copy: (2@0 extent: 42@38).
			brush := brush scaledToSize: brush extent // 2].
	myButton := BorderedMorph new.
	myButton color: (Color r: 0.833 g: 0.5 b: 0.0); borderWidth: 2; borderColor: #raised.
	myButton addMorph: (m := brush asMorph lock).
	myButton extent: m extent + (myButton borderWidth + 6).
	m position: myButton center - (m extent // 2).
	^ myButton

! !

!Flaps classSide methodsFor: 'shared flaps' stamp: 'dgd 8/31/2003 19:27'!
positionNavigatorAndOtherFlapsAccordingToPreference
	"Lay out flaps along the designated edge right-to-left, possibly positioning the navigator flap, exceptionally, on the left."

	| ids |
	ids := Preferences navigatorOnLeftEdge ifTrue: [{'Navigator' translated}] ifFalse: [#()].

	Flaps positionVisibleFlapsRightToLeftOnEdge: #bottom butPlaceAtLeftFlapsWithIDs: ids

"Flaps positionNavigatorAndOtherFlapsAccordingToPreference"! !

!Flaps classSide methodsFor: 'shared flaps' stamp: 'dgd 8/31/2003 19:29'!
positionVisibleFlapsRightToLeftOnEdge: edgeSymbol butPlaceAtLeftFlapsWithIDs: idList
	"Lay out flaps along the designated edge right-to-left, while laying left-to-right any flaps found in the exception list

	Flaps positionVisibleFlapsRightToLeftOnEdge: #bottom butPlaceAtLeftFlapWithIDs: {'Navigator' translated. 'Supplies' translated}
	Flaps sharedFlapsAlongBottom"

	| leftX flapList flapsOnRight flapsOnLeft |
	flapList := self globalFlapTabsIfAny select:
		[:aFlapTab | aFlapTab isInWorld and: [aFlapTab edgeToAdhereTo == edgeSymbol]].
	flapsOnLeft := flapList select: [:fl | idList includes: fl flapID].
	flapList removeAll: flapsOnLeft.

	flapsOnRight := flapList asSortedCollection:
		[:f1 :f2 | f1 left > f2 left].
	leftX := ActiveWorld width - 15.

	flapsOnRight do:
		[:aFlapTab |
			aFlapTab right: leftX - 3.
			leftX := aFlapTab left].

	leftX := ActiveWorld left.
	flapsOnLeft := flapsOnLeft asSortedCollection:
		[:f1 :f2 | f1 left > f2 left].
	flapsOnLeft do:
		[:aFlapTab |
			aFlapTab left: leftX + 3.
			leftX := aFlapTab right].

	(flapsOnLeft asOrderedCollection, flapsOnRight asOrderedCollection) do:
		[:ft | ft computeEdgeFraction.
		ft flapID = 'Navigator' translated ifTrue:
			[ft referent left: (ft center x - (ft referent width//2) max: 0)]]
! !

!Flaps classSide methodsFor: 'construction support' stamp: 'alain.plantec 5/30/2008 13:26'!
possiblyReplaceEToyFlaps
	"If in eToyFriendly mode, and if it's ok to reinitialize flaps, replace the
	existing flaps with up-too-date etoy flaps. Caution: this is destructive of
	existing flaps. If preserving the contents of existing flaps is important,
	set the preference 'okToReinitializeFlaps' to true"
	"PartsBin clearThumbnailCache"
	"Flaps possiblyReplaceEToyFlaps"
	PartsBin thumbnailForPartsDescription: StickyPadMorph descriptionForPartsBin.
	"Puts StickyPadMorph's custom icon back in the cache which typically
	will have been called"
	(Preferences eToyFriendly
			and: [Preferences okToReinitializeFlaps])
		ifTrue: [Flaps disableGlobalFlaps: false.
			Flaps addAndEnableEToyFlaps.
			ActiveWorld enableGlobalFlaps]! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'sw 3/3/2004 13:38'!
quadsDefiningPlugInSuppliesFlap
	"Answer a list of quads which define the objects to appear in the default Supplies flap used in the Plug-in image"

	^ self registeredFlapsQuadsAt: 'PlugIn Supplies'! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'asm 3/13/2003 10:25'!
quadsDefiningStackToolsFlap
	"Answer a structure defining the items on the default system Stack Tools flap"

	^ self registeredFlapsQuadsAt: 'Stack Tools'

	"Flaps replaceGlobalFlapwithID: 'Stack Tools'"! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'asm 3/13/2003 10:26'!
quadsDefiningSuppliesFlap
	"Answer a list of quads which define the objects to appear in the default Supplies flap"

	^ self registeredFlapsQuadsAt: 'Supplies'! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'asm 3/13/2003 10:51'!
quadsDefiningToolsFlap
	"Answer a structure defining the default Tools flap"

	^ self registeredFlapsQuadsAt: 'Tools'! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'asm 3/13/2003 10:26'!
quadsDefiningWidgetsFlap
	"Answer a structure defining the default Widgets flap"

	^ self registeredFlapsQuadsAt: 'Widgets'! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'asm 3/13/2003 10:26'!
quadsDeiningScriptingFlap
	"Answer a structure defining the default items in the Scripting flap"

	^ self registeredFlapsQuadsAt: 'Scripting'! !

!Flaps classSide methodsFor: 'flaps registry' stamp: 'asm 3/13/2003 11:09'!
registerQuad: aQuad forFlapNamed: aLabel
	"If any previous registration of the same label string is already known, delete the old one."

	"aQuad received must be an array of the form {TargetObject. #command label  'A Help String'} 

Flaps registerQuad: #(FileList2 openMorphicViewInWorld	'Enhanced File List'	'A nicer File List.')
	forFlapNamed: 'Tools' "

	self unregisterQuad: aQuad forFlapNamed: aLabel.
	(self registeredFlapsQuads at: aLabel) add: aQuad! !

!Flaps classSide methodsFor: 'flaps registry' stamp: 'asm 3/13/2003 09:55'!
registeredFlapsQuads
	"Answer the list of dynamic flaps quads"
	
	FlapsQuads ifNil: [FlapsQuads := Dictionary new].
	^ FlapsQuads

" FlapsQuads := nil. "! !

!Flaps classSide methodsFor: 'flaps registry' stamp: 'hpt 4/26/2004 16:46'!
registeredFlapsQuadsAt: aLabel
	"Answer the list of dynamic flaps quads at aLabel"

	^ (self registeredFlapsQuads at: aLabel)
		removeAllSuchThat: [:q | (self environment includesKey: q first) not or: [(self environment at: q first) isNil]]
! !

!Flaps classSide methodsFor: 'flap mechanics' stamp: 'dgd 10/7/2003 22:47'!
reinstateDefaultFlaps
	"Remove all existing 'standard' global flaps clear the global list, and and add fresh ones.  To be called by doits in updates etc.  This is a radical step, but it does *not* clobber non-standard global flaps or local flaps.  To get the effect of the *former* version of this method, call Flaps freshFlapsStart"

	"Flaps reinstateDefaultFlaps"
	self globalFlapTabsIfAny do:
		[:aFlapTab |
			({
				'Painting' translated.
				'Stack Tools' translated.
				'Squeak' translated.
				'Menu' translated.
				'Widgets' translated.
				'Tools' translated.
				'Supplies' translated.
				'Scripting' translated.
				'Objects' translated.
				'Navigator' translated
			  } includes: aFlapTab flapID) ifTrue:
				[self removeFlapTab: aFlapTab keepInList: false]].

	"The following reduces the risk that flaps will be created with variant IDs
		such as 'Stack Tools2', potentially causing some shared flap logic to fail."
		"Smalltalk garbageCollect."  "-- see if we are OK without this"

	self addStandardFlaps.
	"self disableGlobalFlapWithID: 'Scripting'.
	self disableGlobalFlapWithID: 'Objects'."
	self currentWorld addGlobalFlaps.
	self currentWorld reformulateUpdatingMenus.
! !

!Flaps classSide methodsFor: 'shared flaps' stamp: 'mir 8/24/2001 20:42'!
removeDuplicateFlapTabs
	"Remove flaps that were accidentally added multiple times"
	"Flaps removeDuplicateFlapTabs"
	| tabs duplicates same |
	SharedFlapTabs copy ifNil: [^self].
	tabs := SharedFlapTabs copy.
	duplicates := Set new.
	tabs do: [:tab |
		same := tabs select: [:each | each wording = tab wording].
		same isEmpty not
			ifTrue: [
				same removeFirst.
				duplicates addAll: same]].
	SharedFlapTabs removeAll: duplicates! !

!Flaps classSide methodsFor: 'flap mechanics' stamp: 'sw 4/17/2001 14:47'!
removeFlapTab: aFlapTab keepInList: aBoolean
	"Remove the given flap tab from the screen, and, if aBoolean is true, also from the global list"

	(SharedFlapTabs ~~ nil and: [SharedFlapTabs includes: aFlapTab])
		ifTrue:
			[aBoolean ifFalse: [self removeFromGlobalFlapTabList: aFlapTab]].
	aFlapTab ifNotNil:
		[aFlapTab referent delete.
		aFlapTab delete]! !

!Flaps classSide methodsFor: 'miscellaneous' stamp: 'sw 11/6/2000 14:23'!
removeFromGlobalFlapTabList: aFlapTab
	"If the flap tab is in the global list, remove it"

	SharedFlapTabs remove: aFlapTab ifAbsent: []! !

!Flaps classSide methodsFor: 'replacement' stamp: 'alain.plantec 6/26/2008 10:09'!
replaceGlobalFlapwithID: flapID
	"If there is a global flap with flapID, replace it with an updated one."

	| replacement tabs |
	(tabs := self globalFlapTabsWithID: flapID) size = 0 ifTrue: [^ self].
	tabs do: [:tab |
		self removeFlapTab: tab keepInList: false].
	flapID = 'Stack Tools' translated ifTrue: [replacement := self newStackToolsFlap].
	flapID = 'Supplies' translated ifTrue: [replacement := self newSuppliesFlapFromQuads: 
		(Preferences eToyFriendly
			ifFalse: [self quadsDefiningSuppliesFlap]
			ifTrue: [self quadsDefiningPlugInSuppliesFlap]) positioning: #right].
	flapID = 'Tools' translated ifTrue: [replacement := self newToolsFlap].
	flapID = 'Widgets' translated ifTrue: [replacement := self newWidgetsFlap].
	flapID = 'Navigator' translated ifTrue: [replacement := self newNavigatorFlap].
	flapID = 'Pharo' translated ifTrue: [replacement := self newPharoFlap].
	replacement ifNil: [^ self].
	self addGlobalFlap: replacement.
	self currentWorld ifNotNil: [self currentWorld addGlobalFlaps]

"Flaps replaceFlapwithID: 'Widgets' translated "! !

!Flaps classSide methodsFor: 'replacement' stamp: 'sw 5/3/1999 22:44'!
replacePartSatisfying: elementBlock inGlobalFlapSatisfying: flapBlock with: replacement
	"If any global flap satisfies flapBlock, look in it for a part satisfying elementBlock; if such a part is found, replace it with the replacement morph, make sure the flap's layout is made right, etc."

	| aFlapTab flapPasteUp anElement |
	aFlapTab := self globalFlapTabsIfAny detect: [:aTab | flapBlock value: aTab] ifNone: [^ self].
	flapPasteUp := aFlapTab referent.
	anElement := flapPasteUp submorphs detect: [:aMorph | elementBlock value: aMorph] ifNone: [^ self].
	flapPasteUp replaceSubmorph: anElement by: replacement.
	flapPasteUp replaceTallSubmorphsByThumbnails; setPartsBinStatusTo: true.

"Flaps replacePartSatisfying: [:el |  (el isKindOf: MorphThumbnail) and: [(el morphRepresented isKindOf: SystemWindow) and: [el morphRepresented label = 'scripting area']]]
inGlobalFlapSatisfying: [:fl | (fl submorphs size > 0) and:  [(fl submorphs first isKindOf: TextMorph) and: [(fl submorphs first contents string copyWithout: Character cr) = 'Tools']]] with: ScriptingSystem newScriptingSpace"! !

!Flaps classSide methodsFor: 'replacement' stamp: 'sw 4/17/2001 13:15'!
replacePartSatisfying: elementBlock inGlobalFlapWithID: aFlapID with: replacement
	"If a global flapl exists with the given flapID, look in it for a part satisfying elementBlock; if such a part is found, replace it with the replacement morph, make sure the flap's layout is made right, etc."

	^ self replacePartSatisfying: elementBlock inGlobalFlapSatisfying: [:fl | fl flapID = aFlapID] with: replacement! !

!Flaps classSide methodsFor: 'replacement' stamp: 'dgd 8/31/2003 19:41'!
replaceToolsFlap
	"if there is a global tools flap, replace it with an updated one."

	self replaceGlobalFlapwithID: 'Tools' translated

"Flaps replaceToolsFlap"! !

!Flaps classSide methodsFor: 'menu support' stamp: 'alain.plantec 5/30/2008 13:27'!
setUpSuppliesFlapOnly
	"Set up the Supplies flap as the only shared flap.  A special version formulated for this stand-alone use is used, defined in #newLoneSuppliesFlap"

	| supplies |
	SharedFlapTabs isEmptyOrNil ifFalse:  "get rid of pre-existing guys if any"
		[SharedFlapTabs do:
			[:t | t referent delete.  t delete]].

	SharedFlapsAllowed := true.
	SharedFlapTabs := OrderedCollection new.
	SharedFlapTabs add: (supplies := self newLoneSuppliesFlap).
	self enableGlobalFlapWithID: 'Supplies' translated.
	supplies setToPopOutOnMouseOver: false.

	ActiveWorld addGlobalFlaps.
	ActiveWorld reformulateUpdatingMenus! !

!Flaps classSide methodsFor: 'shared flaps' stamp: 'sw 4/24/2001 11:17'!
sharedFlapsAllowed
	"Answer whether the shared flaps feature is allowed in this system"

	^ SharedFlapsAllowed ifNil: [SharedFlapsAllowed := SharedFlapTabs isEmptyOrNil not]! !

!Flaps classSide methodsFor: 'shared flaps' stamp: 'dgd 10/7/2003 22:47'!
sharedFlapsAlongBottom
	"Put all shared flaps (except Painting which can't be moved) along the bottom"
	"Flaps sharedFlapsAlongBottom"

	| leftX unordered ordered |
	unordered := self globalFlapTabsIfAny asIdentitySet.
	ordered := Array streamContents:
		[:s | {
				'Squeak' translated.
				'Navigator' translated.
				'Supplies' translated.
				'Widgets' translated.
				'Stack Tools' translated.
				'Tools' translated.
				'Painting' translated.
			} do:
			[:id | (self globalFlapTabWithID: id) ifNotNilDo:
				[:ft | unordered remove: ft.
				id = 'Painting' translated ifFalse: [s nextPut: ft]]]].

	"Pace off in order from right to left, setting positions"
	leftX := Display width-15.
	ordered , unordered asArray reverseDo:
		[:ft | ft setEdge: #bottom.
		ft right: leftX - 3.  leftX := ft left].

	"Put Nav Bar centered under tab if possible"
	(self globalFlapTabWithID: 'Navigator' translated) ifNotNilDo:
		[:ft | ft referent left: (ft center x - (ft referent width//2) max: 0)].
	self positionNavigatorAndOtherFlapsAccordingToPreference.
! !

!Flaps classSide methodsFor: 'menu support' stamp: 'dao 10/1/2004 12:59'!
showSharedFlaps
	"Answer whether shared flaps are currently showing.  Presumably it is in service of Alan's wishes to have flaps show sometimes on interior subprojects and sometomes on outer projects that Bob's CurrentProjectRefactoring is threaded into the logic here."

	^ Project current showSharedFlaps! !

!Flaps classSide methodsFor: 'menu support' stamp: 'dao 10/1/2004 13:12'!
suppressFlapsString
	"Answer the string to be shown in a menu to represent the suppress-flaps-in-this-project status"

	^ Project current suppressFlapsString! !

!Flaps classSide methodsFor: 'predefined flaps' stamp: 'sw 4/3/2003 16:35'!
twiddleSuppliesButtonsIn: aStrip
	"Munge item(s) in the strip whose names as seen in the parts bin should be different from the names to be given to resulting torn-off instances"

	(aStrip submorphs detect: [:m | m target == StickyPadMorph] ifNone: [nil])
		ifNotNilDo:
			[:aButton | aButton arguments: {#newStandAlone.  'tear off'}]! !

!Flaps classSide methodsFor: 'flaps registry' stamp: 'asm 3/13/2003 10:34'!
unregisterQuad: aQuad forFlapNamed: aLabel 
	"If any previous registration at the same label string has the same receiver-command,
	delete the old one."
	(self registeredFlapsQuadsAt: aLabel)
		removeAllSuchThat: [:q | q first = aQuad first
				and: [q second = aQuad second]]! !

!Flaps classSide methodsFor: 'flaps registry' stamp: 'ar 9/27/2005 22:10'!
unregisterQuadsWithReceiver: aReceiver 
	"delete all quads with receiver aReceiver."
	self registeredFlapsQuads
		do: [:assoc | assoc value
				removeAllSuchThat: [:q | (self environment at: (q first) ifAbsent:[nil]) = aReceiver ]]! !

!Flaps classSide methodsFor: 'flaps registry' stamp: 'asm 4/12/2003 14:16'!
unregisterQuadsWithReceiver: aReceiver fromFlapNamed: aLabel
	"delete all quads with receiver aReceiver."
	(self registeredFlapsQuads at: aLabel) removeAllSuchThat: [:q | q first = aReceiver name]! !

Object subclass: #PostscriptCharacterScanner
	instanceVariableNames: 'canvas paragraph bounds curPos font foregroundColor emphasis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Postscript Canvases'!

!PostscriptCharacterScanner commentStamp: '<historical>' prior: 0!
I am a simple character scanner that forwards text-drawing commands to my canvas.  Despite the name, it should also work with other Canvases that actually implement the text-drawing commands (which the basic FormCanvas does not).

Style text support currently includes color, centering, fonts and emphasis.  Not yet supported are embedded objects, full justification and probably some others as well.

Tabs aren't supported properly, but rather hacked in the Postscript Header provided by PostscriptCanvas to be equivalent to 4 space.

mpw.
!

!PostscriptCharacterScanner classSide methodsFor: 'as yet unclassified' stamp: ''!
scannerWithCanvas:aCanvas paragraph:aParagraph bounds:newBounds
    ^self new canvas:aCanvas; paragraph:aParagraph; bounds:newBounds.
 ! !

!PostscriptCharacterScanner methodsFor: 'textstyle support' stamp: 'RAA 5/8/2001 10:01'!
addEmphasis: emphasisCode

	emphasis := emphasis bitOr: emphasisCode.! !

!PostscriptCharacterScanner methodsFor: 'textstyle support' stamp: ''!
addKern: kern
	" canvas comment:'kern now: ',kern printString. "
! !

!PostscriptCharacterScanner methodsFor: 'accessing' stamp: ''!
bounds:newBounds
    bounds:=newBounds.
    curPos:=newBounds origin.

	! !

!PostscriptCharacterScanner methodsFor: 'accessing' stamp: ''!
canvas
	^canvas.

	! !

!PostscriptCharacterScanner methodsFor: 'accessing' stamp: ''!
canvas:newCanvas
    canvas:=newCanvas.

	! !

!PostscriptCharacterScanner methodsFor: 'accessing' stamp: 'sw 12/6/1999 13:10'!
defaultFont
	^ TextStyle defaultFont! !

!PostscriptCharacterScanner methodsFor: 'displaying' stamp: 'RAA 10/2/2000 21:00'!
displayLine: line offset: baseOffset leftInRun: leftInRun
	| drawFont offset aText string s doJustified |

	self setTextStylesForOffset: ((line first) + 1).	" sets up various instance vars from text styles "
	drawFont := self font.
	offset := baseOffset.
	offset := offset + (line left @ (line top + line baseline - drawFont ascent )). 
	offset := offset + ((self textStyle alignment caseOf:{
		[2] -> [ line paddingWidth /2 ].
		[1] -> [ line paddingWidth ] } otherwise:[0]) @ 0).

	canvas moveto: offset.

	aText := paragraph text copyFrom: line first to: line last.
	doJustified := (paragraph textStyle alignment = 3)
						and: [ (paragraph text at:line last) ~= Character cr
						and: [aText runs runs size = 1]].
	string := aText string.
	aText runs withStartStopAndValueDo: [:start :stop :attributes |
		self setTextStylesForOffset: (start + line first - 1).	" sets up inst vars from text styles "
		s := string copyFrom: start to: stop.
		drawFont := self font.
		canvas setFont: drawFont.
		canvas 
			textStyled: s
			at: offset 		"<--now ignored"
			font: drawFont 		"<--now ignored"
			color: foregroundColor
			justified: doJustified		"<-can't do this now for multi-styles" 
			parwidth: line right - line left.
	].
! !

!PostscriptCharacterScanner methodsFor: 'accessing' stamp: ''!
font
	^ font ifNil:[self defaultFont].! !

!PostscriptCharacterScanner methodsFor: 'textstyle support' stamp: ''!
indentationLevel: amount
	" canvas comment:'indentation level ',amount printString. "
! !

!PostscriptCharacterScanner methodsFor: 'accessing' stamp: ''!
paragraph
	^paragraph.

	! !

!PostscriptCharacterScanner methodsFor: 'accessing' stamp: ''!
paragraph:newPara
    paragraph:=newPara.

	! !

!PostscriptCharacterScanner methodsFor: 'textstyle support' stamp: ''!
placeEmbeddedObject: anchoredMorph
! !

!PostscriptCharacterScanner methodsFor: 'textstyle support' stamp: ''!
setActualFont: newFont
	font := newFont.! !

!PostscriptCharacterScanner methodsFor: 'textstyle support' stamp: 'nk 6/10/2004 13:32'!
setAlignment: alignment
	self paragraph textStyle alignment: alignment.! !

!PostscriptCharacterScanner methodsFor: 'accessing' stamp: 'mpw 8/4/1930 09:09'!
setDestForm:destForm
	"dummy"
! !

!PostscriptCharacterScanner methodsFor: 'textstyle support' stamp: ''!
setFont: fontNumber
	self setActualFont:(self textStyle fontAt:fontNumber).
! !

!PostscriptCharacterScanner methodsFor: 'textstyle support' stamp: 'sw 12/7/1999 12:28'!
setTextStylesForOffset:offset
	" default text style "
	font := self textStyle defaultFont.
	emphasis := 0.
	foregroundColor := Color black.

	" set text styles defined at this point, these methods will set instance vars of myself "
	(paragraph text attributesAt: offset forStyle: paragraph textStyle) do: 
		[:att | att emphasizeScanner: self].

	" post-processing of 'emphasis' "
	self setActualFont: (font emphasized: emphasis)! !

!PostscriptCharacterScanner methodsFor: 'textstyle support' stamp: ''!
textColor: aColor
	foregroundColor := aColor.
! !

!PostscriptCharacterScanner methodsFor: 'accessing' stamp: ''!
textStyle
	^paragraph textStyle.
! !

Object subclass: #PostscriptDummyWarp
	instanceVariableNames: 'canvas subCanvas transform'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Postscript Canvases'!

!PostscriptDummyWarp commentStamp: '<historical>' prior: 0!
I simulate the effects of having a WarpBlit done in Postscript, by simply adjusting the coordinate system.
!

!PostscriptDummyWarp classSide methodsFor: 'as yet unclassified' stamp: 'mpw 8/4/1930 09:18'!
canvas:aCanvas
	^self new canvas:aCanvas.! !

!PostscriptDummyWarp methodsFor: 'dummy' stamp: ''!
canvas
	^canvas
! !

!PostscriptDummyWarp methodsFor: 'dummy' stamp: 'mpw 8/4/1930 09:19'!
canvas:newCanvas
	canvas := newCanvas.
! !

!PostscriptDummyWarp methodsFor: 'dummy' stamp: ''!
cellSize:newCellSize
	^self.! !

!PostscriptDummyWarp methodsFor: 'dummy' stamp: 'mpw 8/4/1930 09:09'!
colorMap:aMap
! !

!PostscriptDummyWarp methodsFor: 'dummy' stamp: ''!
combinationRule:newRule
	^self.! !

!PostscriptDummyWarp methodsFor: 'dummy' stamp: 'mpw 8/4/1930 09:12'!
drawPostscriptContext:aCanvas
	canvas drawPostscriptContext:aCanvas.


! !

!PostscriptDummyWarp methodsFor: 'dummy' stamp: 'di 8/12/2000 10:01'!
preserveStateDuring: aBlock

	^ canvas preserveStateDuring:
		"Note block arg must be self so various things get overridden properly"
		[:inner | aBlock value: self]

! !

!PostscriptDummyWarp methodsFor: 'dummy' stamp: ''!
sourceForm:newForm
	^self.! !

!PostscriptDummyWarp methodsFor: 'dummy' stamp: 'mpw 8/4/1930 09:10'!
sourceQuad:aQuad destRect:aRect
! !

!PostscriptDummyWarp methodsFor: 'dummy' stamp: 'mpw 8/10/1930 21:02'!
subCanvas:patchRect
	subCanvas ifNil:
		[ subCanvas := PostscriptCanvas new reset setOrigin:patchRect topLeft clipRect:(-10000@-10000 extent:20000@20000)].
	^subCanvas.

! !

!PostscriptDummyWarp methodsFor: 'dummy' stamp: ''!
transform
	^transform.
! !

!PostscriptDummyWarp methodsFor: 'dummy' stamp: ''!
transform:newTransform
	transform := newTransform.
	^self.
! !

!PostscriptDummyWarp methodsFor: 'dummy' stamp: 'mpw 8/4/1930 09:11'!
transformBy:aTransform
	canvas transformBy:aTransform.


! !

!PostscriptDummyWarp methodsFor: 'dummy' stamp: 'di 8/12/2000 10:13'!
warpBits
	canvas preserveStateDuring:
		[:inner | 
		transform ifNotNil: [inner transformBy: transform].
		inner drawPostscriptContext:subCanvas].
! !

Object subclass: #ScrollingToolHolder
	instanceVariableNames: 'pickupButtons stampButtons stamps thumbnailPics start'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Support'!

!ScrollingToolHolder commentStamp: '<historical>' prior: 0!
Used to hold stamp images in the PaintBox. Displays a small number of the available stamps and allows scrolling to access the others. One stamp is always kept blank as a way to create new stamps.

Note:
	stamps are the full size Forms
	thumbnailPics are the shrunken ones
	nil in both lists means no stamp yet, so user can create one
!

!ScrollingToolHolder methodsFor: 'as yet unclassified' stamp: 'tk 7/2/97 15:00'!
clear
	"wipe out all existing stamps"

	stamps := OrderedCollection new: 16.
	thumbnailPics := OrderedCollection new: 16.
	stampButtons do: [:each | 
		stamps addLast: nil.	"hold a space"
		thumbnailPics addLast: nil].
	start := 1.
	self normalize.! !

!ScrollingToolHolder methodsFor: 'as yet unclassified' stamp: 'tk 3/9/98 13:17'!
normalize
	"Correspondence between buttons and stamp forms has changed.  Make all thumbnails show up right."

	| shrunkForm button trans |
	1 to: stampButtons size do: [:ind |
		shrunkForm := thumbnailPics atWrap: ind+start-1.
		button := stampButtons at: ind.
		shrunkForm 
			ifNil: [trans := Form extent: button extent depth: 8.
				trans fill: trans boundingBox fillColor: Color transparent.
				button onImage: trans]
			ifNotNil: [button onImage: shrunkForm].
		button offImage: shrunkForm; pressedImage: shrunkForm.	"later modify them"
		].! !

!ScrollingToolHolder methodsFor: 'as yet unclassified' stamp: 'tk 7/2/97 11:46'!
otherButtonFor: aButton
	"Find the corresponding button for either a pickup or a stamp button"

	| ii |
	(ii := pickupButtons indexOf: aButton) > 0 ifTrue: [^ stampButtons at: ii].
	(ii := stampButtons indexOf: aButton) > 0 ifTrue: [^ pickupButtons at: ii].
	self error: 'stamp button not found'.! !

!ScrollingToolHolder methodsFor: 'as yet unclassified' stamp: 'tk 7/16/97 19:22'!
pickupButtons

	^ pickupButtons! !

!ScrollingToolHolder methodsFor: 'as yet unclassified' stamp: 'tk 7/2/97 10:51'!
pickupButtons: anArray
	"Save the list of buttons that are for making a new stamp.  Left to right"

	pickupButtons := anArray! !

!ScrollingToolHolder methodsFor: 'as yet unclassified' stamp: 'tk 10/11/97 17:04'!
remove: tool
	"Remove a stamp.  Make this stamp blank.  OK to have a bunch of blank ones."

	| which |
	which := stampButtons indexOf: tool ifAbsent: [
				pickupButtons indexOf: tool ifAbsent: [^ self]].
	stamps atWrap: which+start-1 put: nil.
	thumbnailPics atWrap: which+start-1 put: nil.
	self normalize.	"show them"! !

!ScrollingToolHolder methodsFor: 'as yet unclassified' stamp: 'tk 7/2/97 14:37'!
scroll: amt
	"Move the stamps over"

	start := start - 1 + amt \\ stamps size + 1.
	self normalize.	"show them"! !

!ScrollingToolHolder methodsFor: 'as yet unclassified' stamp: 'tk 7/16/97 19:22'!
stampButtons

	^ stampButtons! !

!ScrollingToolHolder methodsFor: 'as yet unclassified' stamp: 'tk 10/11/97 10:21'!
stampButtons: anArray
	"Pop in a new list of buttons that are the tools for stamping.  Left to right"

	stampButtons := anArray.
	self clear.! !

!ScrollingToolHolder methodsFor: 'as yet unclassified' stamp: 'tk 7/17/97 09:59'!
stampForm: stampForm for: aPickupButton
	"Install this form to stamp. Find its index.  Make a thumbnail."

	| which scale shrunkForm stampBtn mini |
	which := pickupButtons indexOf: aPickupButton.
	which = 0 ifTrue: [which := stampButtons indexOf: aPickupButton].
	stamps atWrap: which+start-1 put: stampForm.

	"Create the thumbnail"
	stampBtn := stampButtons at: which.
	scale := stampBtn width / (stampForm extent x max: stampForm extent y).
	scale := scale min: 1.0.	"do not expand it"
	mini := stampForm magnify: stampForm boundingBox by: scale smoothing: 1.
	shrunkForm := mini class extent: stampBtn extent depth: stampForm depth.
	mini displayOn: shrunkForm at: (stampBtn extent - mini extent)//2.
	thumbnailPics atWrap: which+start-1 put: shrunkForm.
	stampBtn offImage: shrunkForm; onImage: shrunkForm; pressedImage: shrunkForm.
		"Emphasis is done by border of enclosing layoutMorph, not modifying image"

	(stamps indexOf: nil) = 0 ifTrue: ["Add an extra blank place"
		"Keep stamp we just installed in the same location!!"
		start+which-1 > stamps size ifTrue: [start := start + 1].
		stamps addLast: nil.
		thumbnailPics addLast: nil.
		self normalize].
! !

!ScrollingToolHolder methodsFor: 'as yet unclassified' stamp: 'tk 7/2/97 14:04'!
stampFormFor: aButton

	| which |
	which := stampButtons indexOf: aButton ifAbsent: [1].
	^ stamps atWrap: which+start-1! !

!ScrollingToolHolder methodsFor: 'as yet unclassified' stamp: 'jm 7/28/97 11:54'!
updateReferencesUsing: aDictionary
	"Fix up the Morphs I own"
	"Note: Update this method when adding new inst vars that could contain Morphs."

	stampButtons := stampButtons collect:
		[:old | aDictionary at: old ifAbsent: [old]].
	pickupButtons := pickupButtons collect:
		[:old | aDictionary at: old ifAbsent: [old]].
! !

Object subclass: #SqueakPage
	instanceVariableNames: 'url title comment thumbnail contentsMorph creationTime creationAuthor lastChangeTime lastChangeAuthor policy dirty'
	classVariableNames: 'MaxThumbnailWidthOrHeight RecentMaxNum RecentStem'
	poolDictionaries: ''
	category: 'MorphicExtras-SqueakPage'!

!SqueakPage commentStamp: '<historical>' prior: 0!
A SqueakPage is holder for a page of morphs that live on the disk or on a server.
A URLMorph is a thumbnail sized stand-in for the page.  Clicking on it gets the page.
An ObjectOut is a fake object that stands for an object that is out on the disk.  (Like ObjectTracer or ObjectViewer.)
A MorphObjectOut is a subclass that stands for a Morph that is out on the disk.

To find out how to make the pages of any BookMorph go out to the disk (or a server), see 	http://minnow.cc.gatech.edu/SqueakDoc.1 then go to 'SqueakPages'.

A SqueakPage is always in-memory.  Its contentsMorph will be 'become-ed' to a MorphObjectOut tombstone when it goes out.  (A page may or may not be in the cache.  First put it in, then ask it for the data.)  Sending any message to the contentsMorph triggers the fetch.  Many URLMorphs may hold onto one page.  A page has a thumbnail.  A URLMorph points at its page object.

States of a SqueakPage, and the transitions to another state:
1) have a url as a string.  Then: (URLMorph grabURL: 'file://Ted''s/books/tryThis/p1').  
	Drop it into any morph.
2) have a URLMorph, with page==nil.     Click it.  (makes an empty page, installs 
	it in the global page cache)
3) have a URLMorph with a SqueakPage, with contentsMorph==nil, 
	but page is not in the cache (this is a rare case).  ask page contentsMorph.
4) OUT: have a URLMorph with a SqueakPage, with contentsMorph being a MorphObjectOut, 
	and its page is in the cache.  Sending the contentsMorph any message brings it in and
	becomes it to the morph.  (fix up morph's pointer to the page.)
5) Totally IN:  a morph, owned by a SqueakPage, has a page in the cache.  
	The morph is clean.   
	Whenever someone triggers a purge (when?), contentsMorph is becomed
	to a MorphObjectOut. (go to 4)
	Causing the morph to execute layoutChanged marks the morph as dirty.
	(morph's property #pageDirty is set to true) (go to 6)
6) Totally IN and dirty.  
	Whenever any other page is fetched from the disk or the net, all other 
	dirty pages are written and marked clean.  (go to 5)

Note that the entire tree of submorphs goes out -- hundreds of objects.  Bringing the object back in brings in the SqueakPage, installs it in the cache.  Classes other than PasteUpMorph can easily be made to send their contents out if there is any need.

Note that every book is now automatically a WebBook.  We simply give a page a url and tell it to purge.

url		a string
title		
comment		
thumbnail		
contentsMorph		(1) a pasteUpMorph with other morphs in it.
					(2) a MorphObjectOut.  Sending any message brings it in. 
					(3) nil if the page has never been in this image.
creationTime		
creationAuthor		
lastChangeTime		
lastChangeAuthor 
policy		#alwaysWrite, #neverWrite, #ask.  (cache can override with a global policy)
			(Explicit writing by user has policy #neverWrite)
dirty 		(Morph>>layoutChanged sends changed: #SqueakPage. If policy==#check, 
				then the page sets dirty_true.)
			(If policy==#alwaysWrite, then set dirty when the page is retrieved from the cache.)

Class MorphObjectOut has an instance variable called page.
All messages to an MorphObjectOut cause it to be brought in.  Except the messages needed to write the MorphObjectOut on the disk as part of a parent's being sent out.  (size, class, instSize, instVar:at:.  Can rename these and call from its own version of the writing routine.)
	To purge, go through the clean pages, and any that have world not equal to this world, entomb them.  
	(If an object in the subtree is held by an object outside the tree, it will remain,  And will be duplicated when the tree comes back in.  This is a problem already in normal uses of SmartRefStream.)


!

!SqueakPage classSide methodsFor: 'as yet unclassified' stamp: 'jm 6/18/1998 11:15'!
initialize
	"SqueakPage initialize"

	MaxThumbnailWidthOrHeight := 60.
! !

!SqueakPage classSide methodsFor: 'as yet unclassified' stamp: 'on 5/10/2008 14:58'!
newURLAndPageFor: aMorph
	"Create a new SqueakPage whose contents is the given morph. Assign a URL for that page, record it in the page cache, and answer its URL."

	| pg newURL stamp |
	pg := self new.
	stamp := Author initialsPerSe ifNil: ['*'].
	pg saveMorph: aMorph author: stamp.
	newURL := SqueakPageCache generateURL.
	SqueakPageCache atURL: newURL put: pg.
	^ newURL 
! !

!SqueakPage classSide methodsFor: 'as yet unclassified' stamp: 'tk 1/15/1999 08:13'!
stemUrl: aUrlString
	"Peel off the 'x5.sp'  or '.bo' from the end of a url of a SqueakPage or a BookMorph index file"

	| ll aUrl |
	ll := aUrlString findLast: [:char | char == $.].
	ll = 0 
		ifTrue: [aUrl := aUrlString]
		ifFalse: [aUrl := aUrlString copyFrom: 1 to: ll-1].	"remove .sp"
	aUrl := (aUrl stemAndNumericSuffix) at: 1.
			"remove trailing number"
	aUrl size = 0 ifTrue: [^ aUrl].	"empty"
	[aUrl last == $x] whileTrue: [aUrl := aUrl allButLast].
	^ aUrl! !

!SqueakPage methodsFor: 'accessing' stamp: 'tk 2/5/1999 16:47'!
asMorph
	^ self fetchContents! !

!SqueakPage methodsFor: 'accessing' stamp: 'jm 6/16/1998 13:47'!
comment

	comment ifNil: [^ ''] ifNotNil: [^ comment].
! !

!SqueakPage methodsFor: 'accessing' stamp: 'jm 6/16/1998 18:12'!
comment: aString

	aString isEmpty
		ifTrue: [comment := nil]
		ifFalse: [comment := aString].
! !

!SqueakPage methodsFor: 'private' stamp: 'tk 2/25/1999 09:13'!
computeThumbnail
	"Make a thumbnail from my morph."

	(contentsMorph isKindOf: PasteUpMorph) 
		ifTrue: [thumbnail := contentsMorph smallThumbnailForPageSorter]
		ifFalse: [self updateThumbnail]! !

!SqueakPage methodsFor: 'accessing' stamp: 'tk 10/2/1998 11:27'!
contentsMorph
	"Return what it is now.  If the morph is out on the disk, return nil.  Use fetchContents to get the data for sure."

	^ contentsMorph
! !

!SqueakPage methodsFor: 'accessing' stamp: 'tk 11/11/1998 12:54'!
contentsMorph: aPasteUpMorph

	contentsMorph := aPasteUpMorph! !

!SqueakPage methodsFor: 'accessing' stamp: 'tk 2/23/1999 14:39'!
copyForSaving
	"Make a copy and configure me to be put out on the disk.  When it is brought in and touched, it will turn into the object at the url."

	| forDisk holder |
	forDisk := self clone.
	holder := MorphObjectOut new xxxSetUrl: url page: forDisk.
	forDisk contentsMorph: holder.
	^ holder		"directly representing the object"! !

!SqueakPage methodsFor: 'saving' stamp: 'tk 9/30/1998 22:40'!
dirty: aBool
	dirty := aBool! !

!SqueakPage methodsFor: 'accessing' stamp: 'tk 10/30/1998 15:08'!
fetchContents
	"Make every effort to get contentsMorph."

	self isContentsInMemory ifTrue: [^ contentsMorph].
	^ self fetchInformIfError! !

!SqueakPage methodsFor: 'accessing' stamp: 'ar 4/10/2005 18:52'!
fetchContentsIfAbsent: failBlock
	"Make every effort to get contentsMorph.  Assume I am in the cache already."
	| strm page temp temp2 |
	SqueakPageCache write.		"sorry about the pause"
	Cursor wait showWhile: [
		strm := (ServerFile new fullPath: url) asStream].
	strm isString ifTrue: [^ failBlock value].		
	page := strm fileInObjectAndCode.
	page isMorph ifTrue: [contentsMorph := page].	"may be a bare morph"
	"copy over the state"
	temp := url.
	temp2 := policy.
	self copyAddedStateFrom: page.
	url := temp.	"don't care what it says"
	temp2 ifNotNil: [policy := temp2].		"use mine"
	contentsMorph setProperty: #pageDirty toValue: nil.
	self dirty: false.
	^ contentsMorph! !

!SqueakPage methodsFor: 'accessing' stamp: 'ar 4/10/2005 18:52'!
fetchInformIfError
	"Make every effort to get contentsMorph.  Put up a good notice if can't get it.  Assume page is in the cache already.  Overwrite the contentsMorph no matter what."
	| strm page temp temp2 |

	SqueakPageCache write.		"sorry about the pause"
	Cursor wait showWhile: [
		strm := (ServerFile new fullPath: url) asStream].
	strm isString ifTrue: [self inform: 'Sorry, ',strm. ^ nil].	"<<<<< Note Diff"
	(url beginsWith: 'file:') ifTrue: [Transcript show: 'Fetching  ', url; cr].	
	page := strm fileInObjectAndCode.
	page isMorph 
		ifTrue: [contentsMorph := page]	"may be a bare morph"
		ifFalse: ["copy over the state"
			temp := url.
			temp2 := policy.
			self copyFrom: page.	"including contentsMorph"
			url := temp.	"I know best!!"
			temp2 ifNotNil: [policy := temp2]].		"use mine"
	contentsMorph setProperty: #pageDirty toValue: nil.
	contentsMorph setProperty: #SqueakPage toValue: self.
	self dirty: false.
	^ contentsMorph! !

!SqueakPage methodsFor: 'accessing' stamp: 'tk 10/30/1998 15:08'!
isContentsInMemory
	"Is my contentsMorph in memory, or is it an ObjectOut tombstone?  Be careful not to send it any message."

	^ (contentsMorph xxxClass inheritsFrom: Object) and: [(contentsMorph == nil) not]! !

!SqueakPage methodsFor: 'accessing' stamp: 'tk 12/4/1998 01:00'!
lastChangeTime
	^ lastChangeTime! !

!SqueakPage methodsFor: 'saving' stamp: 'tk 10/8/1998 13:18'!
policy
	^ policy! !

!SqueakPage methodsFor: 'saving' stamp: 'tk 9/30/1998 22:39'!
policy: aSymbol
	policy := aSymbol! !

!SqueakPage methodsFor: 'private' stamp: 'tk 6/24/1999 11:42'!
postChangeNotification
	"Inform all thumbnails and books that this page has been updated."

	URLMorph allSubInstancesDo: [:m | m pageHasChanged: self].
! !

!SqueakPage methodsFor: 'saving' stamp: 'ar 3/17/2001 23:36'!
prePurge
	"Return self if ready to be purged, or nil if not"

	self isContentsInMemory ifFalse: [^ nil].
	contentsMorph ifNil: [^ nil].  "out already"
	url ifNil: [^ nil].	"just to be safe"
	^ (World ~~ nil and: [contentsMorph world == World]) 
		ifTrue: [nil "showing now"] ifFalse: [self]! !

!SqueakPage methodsFor: 'saving' stamp: 'tk 12/16/1998 08:24'!
purge
	"Replace my morph with a tombstone, if I am not in a world that is being shown."

	(self prePurge) ifNotNil: [
		contentsMorph become: (MorphObjectOut new xxxSetUrl: url page: self)].
		"Simple, isn't it!!"! !

!SqueakPage methodsFor: 'accessing' stamp: 'tk 2/24/1999 12:06'!
saveMorph: aMorph author: authorString
	"Save the given morph as this page's contents. Update its thumbnail and inform references to this URL that the page has changed."
	"Details: updateThumbnail releases the cached state of the saved page contents after computing the thumbnail."

	| n |
	contentsMorph := aMorph.
	n := aMorph knownName.
	n ifNotNil: [self title: n].
	creationAuthor ifNil: [
		creationAuthor := authorString.
		creationTime := Time totalSeconds].
"	lastChangeAuthor := authorString.
	lastChangeTime := Time totalSeconds.	do it when actually write"
	self computeThumbnail.
	self postChangeNotification.
! !

!SqueakPage methodsFor: 'accessing' stamp: 'jm 6/16/1998 17:45'!
thumbnail

	^ thumbnail
! !

!SqueakPage methodsFor: 'accessing' stamp: 'jm 6/16/1998 13:47'!
title

	title ifNil: [^ ''] ifNotNil: [^ title].
! !

!SqueakPage methodsFor: 'accessing' stamp: 'jm 6/16/1998 18:12'!
title: aString

	aString isEmpty
		ifTrue: [title := nil]
		ifFalse: [title := aString].
! !

!SqueakPage methodsFor: 'private' stamp: 'jm 6/18/1998 11:31'!
updateThumbnail
	"Update my thumbnail from my morph."

	| f scale scaleX scaleY shrunkF |
	contentsMorph ifNil: [thumbnail := nil. ^ self].
	f := contentsMorph imageForm.
	scaleX := MaxThumbnailWidthOrHeight asFloat / f height.
	scaleY := MaxThumbnailWidthOrHeight asFloat/ f width.
	scale := scaleX min: scaleY.  "choose scale that maintains aspect ratio"
	shrunkF := (f magnify: f boundingBox by: scale@scale smoothing: 2).
	thumbnail := Form extent: shrunkF extent depth: 8.  "force depth to be 8"
	shrunkF displayOn: thumbnail.
	contentsMorph allMorphsDo: [:m | m releaseCachedState].
! !

!SqueakPage methodsFor: 'accessing' stamp: 'tk 11/4/1998 20:34'!
url

	^ url! !

!SqueakPage methodsFor: 'accessing' stamp: 'tk 1/14/1999 23:50'!
url: aString

	| sd |
	aString isEmpty ifTrue: [url := nil. ^ self].

	"Expand ./ and store as an absolute url"
	sd := ServerFile new.
	sd fullPath: aString.
	url := sd realUrl.! !

!SqueakPage methodsFor: 'saving' stamp: 'tk 1/23/1999 13:19'!
urlNoOverwrite: suggested
	"Look in the directory.  If there is a file of this name, create a new name.  Keep track of highest numbers used as a hint."

	| dir ll stem num local trial suffix |
	(suggested endsWith: '.sp') ifTrue: [suffix := '.sp'].
	(suggested endsWith: '.bo') ifTrue: [suffix := '.bo'].
	suffix ifNil: [self error: 'unknown suffix'].
	dir := ServerFile new fullPath: suggested.
	(dir includesKey: dir fileName) ifFalse: [^ url := suggested].
	"File already exists!!  Create a new name"
	"Find the stem file name"
	stem := SqueakPage stemUrl: suggested.
	num := stem = RecentStem ifTrue: [RecentMaxNum+1] ifFalse: [1].

	local := dir fileName.	"ugh, take stem again..."
	ll := local findLast: [:char | char == $.].
	ll = 0 ifFalse: [local := local copyFrom: 1 to: ll-1].	"remove .sp"
	local := (local splitInteger) at: 1.		"remove trailing number"
	local last == $x ifFalse: [local := local , 'x'].
	[trial := local, num printString, suffix.
		dir includesKey: trial] whileTrue: [num := num + 1].
	RecentStem := stem.  RecentMaxNum := num.
	^ url := stem, 'x', num printString, suffix! !

!SqueakPage methodsFor: 'saving' stamp: 'on 5/10/2008 14:58'!
write
	"Decide whether to write this page on the disk."
	| sf remoteFile |
	policy == #neverWrite ifTrue: [^ self].
		"demo mode, or write only when user explicitly orders it"

	"All other policies do write:   #now"
	contentsMorph ifNil: [^ self].
	dirty := dirty | ((contentsMorph valueOfProperty: #pageDirty) == true).
		"set by layoutChanged"
	dirty == true ifTrue: [ 
		sf := ServerDirectory new fullPath: url.
		"check for shared password"
		"contentsMorph allMorphsDo: [:m | m prepareToBeSaved].
				done in objectToStoreOnDataStream"
		lastChangeAuthor := Author initialsPerSe ifNil: ['*'].
		lastChangeTime := Time totalSeconds.
		Cursor wait showWhile: [
			remoteFile := sf fileNamed: url.	"no notification when overwriting"
			remoteFile dataIsValid.
			remoteFile fileOutClass: nil andObject: self.
			"remoteFile close"].
		contentsMorph setProperty: #pageDirty toValue: nil.
		dirty := false].! !

Object subclass: #SqueakPageCache
	instanceVariableNames: ''
	classVariableNames: 'GlobalPolicy PageCache'
	poolDictionaries: ''
	category: 'MorphicExtras-SqueakPage'!

!SqueakPageCache commentStamp: '<historical>' prior: 0!
A global cache of web pages known to this Squeak image.  Since there is a single, global page cache, it is implemented entirely as class methods.

Once a page has an entry, keep it.  (url string -> A SqueakPage)  The SqueakPage has a thumbnail and other info, but may not have the contentsMorph.  The morph is purged when space is needed, and fetched from the server as needed.

See SqueakPage's comment for the stages of in/out.!

!SqueakPageCache classSide methodsFor: 'cache access' stamp: 'jm 6/25/1998 11:06'!
allURLs
	"Answer a collection of URLs for all pages in the cache."

	^ PageCache keys

! !

!SqueakPageCache classSide methodsFor: 'cache access' stamp: 'tk 10/2/1998 12:07'!
atURL: aURLString
	"Answer the page corresponding to this URL. Evaluate the given block if there is no entry for the given URL."

	| pg |
	^ PageCache at: aURLString ifAbsent: [
		pg := SqueakPage new.
		"stamp := Utilities authorInitialsPerSe ifNil: ['*']."
		"pg author: stamp."
		"Need to deal with inst vars if we turn out to be new!!"
		"pg url: aURLString. 	done by atURL:put:"
		self atURL: aURLString put: pg.
		pg]
! !

!SqueakPageCache classSide methodsFor: 'cache access' stamp: 'tk 10/2/1998 12:06'!
atURL: aURLString ifAbsent: failBlock
	"Answer the page corresponding to this URL. Evaluate the given block if there is no entry for the given URL."

	self halt.  "use atURL:"
! !

!SqueakPageCache classSide methodsFor: 'cache access' stamp: 'tk 10/20/1998 15:51'!
atURL: aURLString oldPage: aPage
	"Bring in page and return the object.  First try looking up my url in the pageCache.  Then try the page (and install it, under its url).  Then start from scratch with the url."

	| myPage |
	(myPage := PageCache at: aURLString ifAbsent: [nil]) ifNotNil: [
		^ myPage].
	aPage url: aURLString.	"for consistancy"
	PageCache at: aPage url put: aPage.
	^ aPage! !

!SqueakPageCache classSide methodsFor: 'cache access' stamp: 'tk 12/8/1998 21:51'!
atURL: aURLString put: aSqueakPage
	"Store the given page in the cache entry for the given URL."

	aSqueakPage url: aURLString.
	aSqueakPage contentsMorph isInMemory ifTrue: [
		aSqueakPage contentsMorph ifNotNil: [
			aSqueakPage contentsMorph setProperty: #SqueakPage 
				toValue: aSqueakPage]].
	PageCache at: aURLString put: aSqueakPage.
! !

!SqueakPageCache classSide methodsFor: 'housekeeping' stamp: 'tk 6/24/1999 11:42'!
deleteUnreferencedPages
	"Remove any pages that are not current referred to by any book or URL morph."
	"Details: Since unreferenced pages could refer to other pages, this process is iterated until no unreferenced pages can be found. It currently does not collect cycles."
	"SqueakPageCache deleteUnreferencedPages"

	| unreferenced |
	[true] whileTrue: [
		Smalltalk garbageCollect.
		unreferenced := PageCache keys.
		URLMorph allSubInstancesDo: [:m | unreferenced remove: m url ifAbsent: []].
		MorphObjectOut allInstancesDo: [:ticklish |
			unreferenced remove: ticklish url ifAbsent: []].
		unreferenced size = 0 ifTrue: [^ self].
		unreferenced do: [:url | PageCache removeKey: url ifAbsent: []]].
! !

!SqueakPageCache classSide methodsFor: 'cache access' stamp: 'tk 10/30/1998 15:08'!
doPagesInMemory: aBlock
	"Evaluate aBlock for each page whose contentsMorph is in-memory.  Don't add or remove pages while in this loop."

	PageCache do: [:sqkPage |
		sqkPage isContentsInMemory ifTrue: [aBlock value: sqkPage]].! !

!SqueakPageCache classSide methodsFor: 'cache access' stamp: 'tk 11/24/1998 14:52'!
generateURL
	"Generate an unused URL for an in-memory page."
	"SqueakPageCache generateURL"

	| sd |
	sd := ServerFile new on: 'file:./'.
	sd fileName: 'page1.sp'.
	^ SqueakPage new urlNoOverwrite: sd pathForFile
! !

!SqueakPageCache classSide methodsFor: 'cache access' stamp: 'tk 10/1/1998 13:02'!
includesMorph: aPasteUp

	PageCache do: [:squeakPage |
		squeakPage contentsMorph == aPasteUp ifTrue: [^ true]].
	^ false! !

!SqueakPageCache classSide methodsFor: 'class initialization' stamp: 'tk 11/24/1998 14:53'!
initialize
	"SqueakPageCache initialize"

	GlobalPolicy := #neverWrite.
	PageCache := Dictionary new: 100.
		"forgets urls of pages, but ObjectOuts still remember them"
! !

!SqueakPageCache classSide methodsFor: 'cache access' stamp: 'tk 10/20/1998 15:11'!
pageCache

	^ PageCache! !

!SqueakPageCache classSide methodsFor: 'cache access' stamp: 'tk 10/1/1998 13:04'!
pageForMorph: aPasteUp

	PageCache do: [:squeakPage |
		squeakPage contentsMorph == aPasteUp ifTrue: [^ squeakPage]].
	^ nil! !

!SqueakPageCache classSide methodsFor: 'cache access' stamp: 'tk 12/16/1998 08:30'!
purge
	"Replace morphs with tombstones in all pages that are clean and not being shown.  Write any dirty ones first, if allowed to."

	| list |
	list := OrderedCollection new.
	GlobalPolicy == #neverWrite 
		ifTrue: [PageCache doPagesInMemory: [:aPage | list add: aPage prePurge]]
			"Writing only done by user's command"
		ifFalse: [
			PageCache doPagesInMemory: [:aPage | aPage write
					 list add: aPage prePurge]].
	list := list select: [:each | each notNil].
	"do bulk become:"
	(list collect: [:each | each contentsMorph])
		elementsExchangeIdentityWith:
			(list collect: [:pg | MorphObjectOut new xxxSetUrl: pg url page: pg])
! !

!SqueakPageCache classSide methodsFor: 'cache access' stamp: 'tk 10/21/1998 13:28'!
purge: megs
	"Replace morphs with tombstones in all pages that are clean and not being shown.  Do this until megs of new memory have been recovered.  Write any dirty ones first, if allowed to."

	| goal |
	goal := Smalltalk garbageCollect + (megs * 1000000) asInteger.
	PageCache doPagesInMemory: [:aPage | 
		GlobalPolicy == #neverWrite ifFalse: [aPage write].
		aPage purge.
		Smalltalk garbageCollect > goal ifTrue: [^ true]].	"got enough"
	^ false	"caller may want to tell the user to write out more pages"! !

!SqueakPageCache classSide methodsFor: 'housekeeping' stamp: 'jm 6/25/1998 13:00'!
releaseCachedStateOfPages
	"Note: This shouldn't be necessary if we are doing a good job of releasing cached state as we go. If running this doesn't do very much, we're doing well!!"
	"SqueakPageCache releaseCachedStateOfPages"

	| memBytes |
	memBytes := Smalltalk garbageCollect.
	PageCache do: [:pg |
		pg contentsMorph allMorphsDo: [:m | m releaseCachedState]].
	^ (Smalltalk garbageCollect - memBytes) printString, ' bytes recovered'
! !

!SqueakPageCache classSide methodsFor: 'cache access' stamp: 'jm 6/16/1998 18:12'!
removeURL: aURLString
	"Remove the cache entry for the given URL. Do nothing if it has no cache entry."

	PageCache removeKey: aURLString ifAbsent: [].
! !

!SqueakPageCache classSide methodsFor: 'cache access' stamp: 'tk 10/22/1998 11:07'!
write
	"Write out all dirty pages"
	GlobalPolicy == #neverWrite ifTrue: [^ self].
	self doPagesInMemory: [:aPage | aPage write].! !

Object subclass: #TextOnCurveContainer
	instanceVariableNames: 'baseline inset textDirection textSegments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Text Support'!

!TextOnCurveContainer commentStamp: '<historical>' prior: 0!
I am not really a container in the sense of TextContainer.  However, I get stored in the same field of a textMorph.  My baseline specifies the vertical displacement of the character baselines from the curve center (0 means on center, 5 would mean, eg, the character baselines are 5 pixels above the curve center).  This is ssential enduring information.  I also cache temporary layout information, including the locations, angles and bounding boxes of each of the characters as displayed.!

!TextOnCurveContainer methodsFor: 'as yet unclassified' stamp: 'di 12/3/97 10:22'!
baseline
	baseline ifNil: [^ 0].
	^ baseline! !

!TextOnCurveContainer methodsFor: 'as yet unclassified' stamp: 'jm 11/19/97 19:30'!
baseline: newBaseline
	baseline := newBaseline! !

!TextOnCurveContainer methodsFor: 'as yet unclassified' stamp: 'dgd 2/22/2003 13:36'!
bounds
	textSegments ifNil: [^nil].
	^textSegments inject: (textSegments first first)
		into: [:bnd :each | bnd merge: (each first)]! !

!TextOnCurveContainer methodsFor: 'as yet unclassified' stamp: 'jm 11/19/97 19:28'!
paragraphClass
	^ TextOnCurve! !

!TextOnCurveContainer methodsFor: 'as yet unclassified' stamp: 'di 12/4/97 08:28'!
releaseCachedState
	textSegments := nil.! !

!TextOnCurveContainer methodsFor: 'as yet unclassified' stamp: 'di 12/3/97 09:16'!
textDirection
	^ textDirection! !

!TextOnCurveContainer methodsFor: 'as yet unclassified' stamp: 'di 12/4/97 09:23'!
textDirection: plusOrMinusOne
	textDirection := plusOrMinusOne! !

!TextOnCurveContainer methodsFor: 'as yet unclassified' stamp: 'di 12/3/97 09:29'!
textSegments
	^ textSegments! !

!TextOnCurveContainer methodsFor: 'as yet unclassified' stamp: 'di 12/3/97 09:29'!
textSegments: segments
	textSegments := segments! !

!TextOnCurveContainer methodsFor: 'as yet unclassified' stamp: 'di 11/21/97 21:48'!
top
	^ 1  "for compatibility"! !

!TextOnCurveContainer methodsFor: 'as yet unclassified' stamp: 'dgd 2/22/2003 13:37'!
translateBy: delta 
	textSegments isNil ifTrue: [^self].
	textSegments := textSegments collect: 
					[:ls | 
					Array 
						with: (ls first translateBy: delta)
						with: (ls second translateBy: delta)
						with: ls third]! !

CharacterScanner subclass: #CanvasCharacterScanner
	instanceVariableNames: 'canvas fillBlt foregroundColor runX lineY defaultTextColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Support'!

!CanvasCharacterScanner commentStamp: '<historical>' prior: 0!
A displaying scanner which draws its output to a Morphic canvas.!

!CanvasCharacterScanner methodsFor: 'accessing' stamp: 'ls 9/25/1999 15:59'!
canvas: aCanvas
	"set the canvas to draw on"
	canvas ifNotNil: [ self inform: 'initializing twice!!' ].
	canvas := aCanvas! !

!CanvasCharacterScanner methodsFor: 'object fileIn' stamp: 'nk 6/17/2003 15:30'!
convertToCurrentVersion: varDict refStream: smartRefStrm

	"From Squeak3.5 [latest update: #5180] on 17 June 2003"
	varDict  at: 'defaultTextColor' put: Color black.
	^ super convertToCurrentVersion: varDict refStream: smartRefStrm! !

!CanvasCharacterScanner methodsFor: 'stop conditions' stamp: 'ls 9/25/1999 16:07'!
cr
	"When a carriage return is encountered, simply increment the pointer 
	into the paragraph."

	lastIndex:= lastIndex + 1.
	^false! !

!CanvasCharacterScanner methodsFor: 'stop conditions' stamp: 'ls 9/25/1999 16:10'!
crossedX
	"This condition will sometimes be reached 'legally' during display, when, 
	for instance the space that caused the line to wrap actually extends over 
	the right boundary. This character is allowed to display, even though it 
	is technically outside or straddling the clipping ectangle since it is in 
	the normal case not visible and is in any case appropriately clipped by 
	the scanner."

	"self fillLeading."
	^ true ! !

!CanvasCharacterScanner methodsFor: 'private' stamp: 'mu 8/9/2003 22:40'!
defaultTextColor
	defaultTextColor ifNil:[defaultTextColor := Color black].
	^defaultTextColor! !

!CanvasCharacterScanner methodsFor: 'private' stamp: 'yo 6/23/2003 18:09'!
defaultTextColor: color
	"This defaultTextColor inst var is equivalent to paragraphColor of DisplayScanner."
	defaultTextColor := color.
! !

!CanvasCharacterScanner methodsFor: 'scanning' stamp: 'gvc 3/5/2008 17:12'!
displayLine: textLine offset: offset leftInRun: leftInRun 
	"largely copied from DisplayScanner's routine.
	Fixed to set left margin after setting up alignment."

	| nowLeftInRun done startLoc startIndex stopCondition |
	line := textLine.
	foregroundColor ifNil: [foregroundColor := Color black].
	rightMargin := line rightMargin + offset x.
	lineY := line top + offset y.
	lastIndex := textLine first.
	nowLeftInRun := leftInRun <= 0 
				ifTrue: 
					[self setStopConditions.	"also sets the font"
					text runLengthFor: lastIndex]
				ifFalse: [leftInRun]. 
	leftMargin := (line leftMarginForAlignment: alignment) + offset x.
	runX := destX := leftMargin.
	runStopIndex := lastIndex + (nowLeftInRun - 1) min: line last.
	spaceCount := 0.
	done := false.
	[done] whileFalse: 
			["remember where this portion of the line starts"

			startLoc := destX @ destY.
			startIndex := lastIndex.

			"find the end of this portion of the line"
			stopCondition := self 
						scanCharactersFrom: lastIndex
						to: runStopIndex
						in: text string
						rightX: rightMargin
						stopConditions: stopConditions
						kern: kern.	"displaying: false"

			"display that portion of the line"
			canvas 
				drawString: text string
				from: startIndex
				to: lastIndex
				at: startLoc
				font: font
				color: foregroundColor.

			"handle the stop condition"
			done := self perform: stopCondition].
	^runStopIndex - lastIndex! !

!CanvasCharacterScanner methodsFor: 'private' stamp: 'ls 9/26/1999 10:03'!
doesDisplaying
	^false   "it doesn't do displaying using copyBits"! !

!CanvasCharacterScanner methodsFor: 'stop conditions' stamp: 'ls 9/25/1999 16:11'!
endOfRun
	"The end of a run in the display case either means that there is actually 
	a change in the style (run code) to be associated with the string or the 
	end of this line has been reached."
	| runLength |

	lastIndex = line last ifTrue: [^true].
	runX := destX.
	runLength := text runLengthFor: (lastIndex := lastIndex + 1).
	runStopIndex := lastIndex + (runLength - 1) min: line last.
	self setStopConditions.
	^ false! !

!CanvasCharacterScanner methodsFor: 'stop conditions' stamp: 'ls 9/29/1999 20:13'!
paddedSpace
	"Each space is a stop condition when the alignment is right justified. 
	Padding must be added to the base width of the space according to 
	which space in the line this space is and according to the amount of 
	space that remained at the end of the line when it was composed."

	destX := destX + spaceWidth + (line justifiedPadFor: spaceCount).

	lastIndex := lastIndex + 1.
	^ false! !

!CanvasCharacterScanner methodsFor: 'private' stamp: 'mu 8/9/2003 22:40'!
setFont
	foregroundColor := self defaultTextColor.
	super setFont.
	destY := lineY + line baseline - font ascent! !

!CanvasCharacterScanner methodsFor: 'stop conditions' stamp: 'ar 10/18/2004 14:31'!
setStopConditions
	"Set the font and the stop conditions for the current run."
	
	self setFont.
	self setConditionArray: (alignment = Justified ifTrue: [#paddedSpace]).
! !

!CanvasCharacterScanner methodsFor: 'stop conditions' stamp: 'ar 12/15/2001 23:28'!
tab

	destX := (alignment == Justified and: [self leadingTab not])
		ifTrue:		"imbedded tabs in justified text are weird"
			[destX + (textStyle tabWidth - (line justifiedTabDeltaFor: spaceCount)) max: destX]
		ifFalse: 
			[textStyle nextTabXFrom: destX
				leftMargin: leftMargin
				rightMargin: rightMargin].

	lastIndex := lastIndex + 1.
	^ false! !

!CanvasCharacterScanner methodsFor: 'private' stamp: 'ls 9/25/1999 16:24'!
textColor: color
	foregroundColor := color! !

!BorderedMorph methodsFor: '*MorphicExtras-initialization' stamp: 'dgd 2/14/2003 22:00'!
basicInitialize
	"Do basic generic initialization of the instance variables"
	super basicInitialize.
""
	self borderInitialize! !

!BorderedMorph methodsFor: '*MorphicExtras-printing' stamp: 'di 6/20/97 11:20'!
fullPrintOn: aStream
	aStream nextPutAll: '('.
	super fullPrintOn: aStream.
	aStream nextPutAll: ') setBorderWidth: '; print: borderWidth;
		nextPutAll: ' borderColor: ' , (self colorString: borderColor)! !

BorderedMorph subclass: #MagnifierMorph
	instanceVariableNames: 'magnification trackPointer srcExtent showPointer'
	classVariableNames: 'RecursionLock'
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!MagnifierMorph commentStamp: '<historical>' prior: 0!
MagnifierMorph instances are magnifying lenses that magnify the morphs below them (if grabbed or if trackPointer is false) or the area around the mouse pointer.

Instance variables:

magnification	<Number> The magnification to use. If non-integer, smooths the magnified form.

trackPointer		<Boolean> If set, magnifies the area around the Hand. If not, magnfies the area underneath the magnifier center.

showPointer		<Boolean> If set, display a small reversed rectangle in the center of the lens. Also enables the display of Morphs in the Hand itself.

srcExtent		<Rectangle> The extent of the source rectangle.
		
Class variables:

RecursionLock	<MagnifierMorph|nil> Used to avoid infinite recursion when getting the source patch to display.!

MagnifierMorph subclass: #FishEyeMorph
	instanceVariableNames: 'gridNum d clipRects toRects quads savedExtent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!FishEyeMorph classSide methodsFor: 'parts bin' stamp: 'sw 8/2/2001 12:47'!
descriptionForPartsBin
	^ self partName:	'FishEye'
		categories:		#('Useful')
		documentation:	'An extreme-wide-angle lens'! !

!FishEyeMorph methodsFor: 'initialization' stamp: 'yo 12/17/1999 12:00'!
calculateTransform
	| stepX stepY rect tx ty arrayX arrayY |
	(gridNum x = 0 or: [gridNum y = 0]) ifTrue: [^self].
	stepX := srcExtent x // gridNum x.
	stepY := srcExtent y // gridNum y.

	arrayX := (1 to: gridNum y + 1) collect: [:j | FloatArray new: gridNum x + 1].
	arrayY := (1 to: gridNum y + 1) collect: [:j |  FloatArray new: gridNum x + 1].

	0 to: gridNum y do: [:j |
		0 to: gridNum x do: [:i |
			(arrayX at: (j + 1)) at: (i + 1) put: i*stepX.
			(arrayY at: (j + 1)) at: (i + 1) put: j*stepY.
		].
	].

	0 to: gridNum y do: [:j |
		self transformX: (arrayX at: (j+1)).
		self transformY: (arrayY at: (j+1)).
	].

	0 to: gridNum y do: [:j |
		arrayX at: (j+1) put: ((1 to: gridNum x +1) collect: [:i | ((arrayX at: (j+1)) at: i) asInteger]).
		arrayY at: (j+1) put: ((1 to: gridNum x +1) collect: [:i | ((arrayY at: (j+1)) at: i) asInteger]).
	].


	clipRects := (1 to: gridNum y) collect: [:j | Array new: gridNum x].
	toRects := (1 to: gridNum y) collect: [:j |  Array new: gridNum x].
	quads := (1 to: gridNum y) collect: [:j |  Array new: gridNum x].
	0 to: gridNum y - 1 do: [:j |
		0 to: gridNum x- 1 do: [:i |
			rect := (((arrayX at: (j+1)) at: (i+1))@((arrayY at: (j+1)) at: (i+1)))
						corner: ((arrayX at: (j+2)) at: (i+2))@((arrayY at: (j+2)) at: (i+2)).
			(clipRects at: j+1) at: i+1 put: rect.

			rect width >= stepX ifTrue: [rect := rect expandBy: (1@0)].
			rect height >= stepY ifTrue: [rect := rect expandBy: (0@1)].
			(toRects at: j+1) at: i+1 put: rect.

			tx := (i)*stepX.
			ty := (j)*stepY.
			(quads at: j+1) at: i+1
						put: {(tx)@(ty). (tx)@(ty+stepY). (tx+stepX)@(ty+stepY). (tx+stepX)@(ty)}.
		].
	].

! !

!FishEyeMorph methodsFor: 'menus' stamp: 'dgd 9/21/2003 17:55'!
chooseMagnification
	self inform: 'Magnification is fixed, sorry.' translated! !

!FishEyeMorph methodsFor: 'menu' stamp: 'yo 12/17/1999 12:03'!
chooseMagnification: evt
! !

!FishEyeMorph methodsFor: 'geometry' stamp: 'yo 12/17/1999 12:27'!
extent: aPoint
	"Round to a number divisible by grid.  Note that the superclass has its own implementation."
	| g gridSize |
	gridSize := self gridSizeFor: aPoint.
	"self halt."
	g := (aPoint - (2 * borderWidth)) // gridSize.
	srcExtent := g * gridSize.
	gridNum := g.
	^super extent: self defaultExtent! !

!FishEyeMorph methodsFor: 'initialization' stamp: 'yo 12/17/1999 10:15'!
g: aFloatArray max: max focus: focus
	| dNormX array |

	dNormX := aFloatArray - focus.
	
	array := dNormX / max.
	array *= d.
	array += 1.0.
	array := 1.0 / array.
	dNormX *= (d+1.0).
	array *= dNormX.
	^array += focus.
! !

!FishEyeMorph methodsFor: 'private' stamp: 'yo 12/17/1999 11:15'!
gridSizeFor: aPoint
	"returns appropriate size for specified argument"
	| g |
	g := aPoint x min: aPoint y.
	g <= 256 ifTrue: [^8].
	^16.! !

!FishEyeMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:39'!
initialize
"initialize the state of the receiver"
	super initialize.
""
	"magnification should be always 1"
	magnification := 1.
	d := 1.3.
	self extent: 130 @ 130! !

!FishEyeMorph methodsFor: 'parts bin' stamp: 'sw 6/28/2001 11:32'!
initializeToStandAlone
	super initializeToStandAlone.
	"magnification should be always 1"
	magnification := 1.
	d := 1.3.
	self extent: 130@130.
! !

!FishEyeMorph methodsFor: 'magnifying' stamp: 'ar 5/28/2000 12:12'!
magnifiedForm
	| warp warpForm fromForm |

	savedExtent ~= srcExtent ifTrue: [
		savedExtent := srcExtent.
		self calculateTransform].

	warpForm := Form extent: srcExtent depth: Display depth.
	fromForm := super magnifiedForm.

	warp :=  (WarpBlt current toForm: warpForm)
		sourceForm: fromForm;
		colorMap: nil;
		cellSize: 2;
		combinationRule: Form over.

	1 to: gridNum y do: [:j |
		1 to: gridNum x do: [:i |
			warp
				clipRect: ((clipRects at: j) at: i);
				copyQuad: ((quads at: j) at: i)
					toRect: ((toRects at: j) at: i).
		].
	].
	^warpForm
! !

!FishEyeMorph methodsFor: 'initialization' stamp: 'md 11/14/2003 16:32'!
transformX: aFloatArray
	| focus gridNum2 subArray dMaxX |

	focus := srcExtent x asFloat / 2.

	gridNum2 := (aFloatArray findFirst: [:x | x > focus]) - 1.

	dMaxX := 0.0 - focus.
	subArray := self g: (aFloatArray copyFrom: 1 to: gridNum2) max: dMaxX focus: focus.

	aFloatArray replaceFrom: 1 to: gridNum2 with: subArray startingAt: 1.


	dMaxX := focus.    " = (size - focus)"
	subArray := self g: (aFloatArray copyFrom: gridNum2 + 1 to: gridNum x + 1)
		max: dMaxX focus: focus.

	aFloatArray replaceFrom: gridNum2 + 1 to: gridNum x + 1 with: subArray startingAt: 1.
! !

!FishEyeMorph methodsFor: 'initialization' stamp: 'dgd 2/21/2003 23:04'!
transformY: aFloatArray 
	| focus subArray dMaxY |
	focus := srcExtent y asFloat / 2.
	dMaxY := (aFloatArray first) <= focus 
				ifTrue: [0.0 - focus]
				ifFalse: [focus].
	subArray := self 
				g: (aFloatArray copyFrom: 1 to: gridNum x + 1)
				max: dMaxY
				focus: focus.
	aFloatArray 
		replaceFrom: 1
		to: gridNum x + 1
		with: subArray
		startingAt: 1! !

!MagnifierMorph classSide methodsFor: 'parts bin' stamp: 'sw 8/2/2001 15:04'!
descriptionForPartsBin
	^ self partName:	'Magnifier'
		categories:		#('Useful')
		documentation:	'A magnifying glass'! !

!MagnifierMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/10/2003 13:14'!
initialize

	self registerInFlapsRegistry.! !

!MagnifierMorph classSide methodsFor: 'instance creation' stamp: 'sw 6/25/2001 13:33'!
newRound
	"Answer a round Magnifier"

	| aMagnifier sm |
	aMagnifier := self new.
	sm := ScreeningMorph new position: aMagnifier position.
	sm addMorph: aMagnifier.
	sm addMorph: (EllipseMorph newBounds: aMagnifier bounds).
	sm setNameTo: 'Magnifier'.
	^ sm! !

!MagnifierMorph classSide methodsFor: 'instance creation' stamp: 'nk 3/6/2004 10:28'!
newShowingPointer
	"Answer a Magnifier that also displays Morphs in the Hand and the Hand position"

	^(self new)
		showPointer: true;
		setNameTo: 'HandMagnifier';
		yourself! !

!MagnifierMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/10/2003 13:14'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(MagnifierMorph		newRound	'Magnifier'			'A magnifying glass') 
						forFlapNamed: 'Widgets']! !

!MagnifierMorph classSide methodsFor: 'parts bin' stamp: 'nk 3/6/2004 10:27'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'RoundGlass'
		categoryList: #(Useful)
		documentation: 'A round magnifying glass'
		globalReceiverSymbol: #MagnifierMorph
		nativitySelector: #newRound.
		
	DescriptionForPartsBin
		formalName: 'Hand Magnifier'
		categoryList: #(Useful)
		documentation: 'A magnifying glass that also shows Morphs in the Hand and displays the Hand position.'
		globalReceiverSymbol: #MagnifierMorph
		nativitySelector: #newShowingPointer }! !

!MagnifierMorph classSide methodsFor: 'class initialization' stamp: 'asm 4/11/2003 12:37'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

!MagnifierMorph methodsFor: 'menu' stamp: 'nk 3/6/2004 10:15'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu
		addLine;
		add: 'magnification...' translated action: #chooseMagnification;
		addUpdating: #trackingPointerString action: #toggleTrackingPointer;
		addUpdating: #showingPointerString action: #toggleShowingPointer;
		addUpdating: #toggleRoundString action: #toggleRoundness.! !

!MagnifierMorph methodsFor: 'accessing' stamp: 'bf 9/21/1999 09:31'!
borderWidth: anInteger
	"Grow outwards preserving innerBounds"
	| c |  
	c := self center.
	super borderWidth: anInteger.
	super extent: self defaultExtent.
	self center: c.! !

!MagnifierMorph methodsFor: 'menu' stamp: 'md 11/16/2003 15:14'!
chooseMagnification
	| result |
	result := (SelectionMenu selections: #(1.5 2 4 8))
		startUpWithCaption: ('Choose magnification
(currently {1})' translated format:{magnification}).
	(result isNil or: [result = magnification]) ifTrue: [^ self].
	magnification := result.
	self extent: self extent. "round to new magnification"
	self changed. "redraw even if extent wasn't changed"! !

!MagnifierMorph methodsFor: 'menu' stamp: 'di 8/24/2000 14:02'!
chooseMagnification: evt
	| handle origin aHand currentMag |
	currentMag := magnification.
	aHand := evt ifNil: [self currentHand] ifNotNil: [evt hand].
	origin := aHand position y.
	handle := HandleMorph new forEachPointDo:
		[:newPoint | self magnification: (newPoint y - origin) / 8.0 + currentMag].
	aHand attachMorph: handle.
	handle startStepping.
	self changed. "Magnify handle"! !

!MagnifierMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:38'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!MagnifierMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:28'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color black! !

!MagnifierMorph methodsFor: 'geometry' stamp: 'bf 9/21/1999 09:22'!
defaultExtent
	^(srcExtent * magnification) truncated + (2 * borderWidth)! !

!MagnifierMorph methodsFor: 'drawing' stamp: 'ar 2/12/2000 18:06'!
drawOn: aCanvas
	super drawOn: aCanvas.		"border and fill"
	aCanvas isShadowDrawing ifFalse: [
		"Optimize because #magnifiedForm is expensive"
		aCanvas paintImage: self magnifiedForm at: self innerBounds origin]! !

!MagnifierMorph methodsFor: 'geometry' stamp: 'bf 9/21/1999 09:23'!
extent: aPoint
	"Round to multiples of magnification"
	srcExtent := (aPoint - (2 * borderWidth)) // magnification.
	^super extent: self defaultExtent! !

!MagnifierMorph methodsFor: 'event handling' stamp: 'bf 9/18/1999 20:42'!
handlesMouseDown: evt
	^evt yellowButtonPressed
		or: [super handlesMouseDown: evt]! !

!MagnifierMorph methodsFor: 'accessing' stamp: 'bf 9/21/1999 08:51'!
hasTranslucentColor
	"I may show what's behind me, so tell the hand to don't cache"
	^self sourceRect intersects: self bounds! !

!MagnifierMorph methodsFor: 'initialization' stamp: 'nk 3/6/2004 10:47'!
initialize
	"initialize the state of the receiver"
	super initialize.

	trackPointer := true.
	showPointer := false.
	magnification := 2.

	self extent: 128 @ 128! !

!MagnifierMorph methodsFor: 'round view' stamp: 'di 9/28/1999 23:01'!
isRound

	^ owner isMemberOf: ScreeningMorph! !

!MagnifierMorph methodsFor: 'magnifying' stamp: 'bf 9/21/1999 12:27'!
magnification: aNumber
	| c |  
	magnification := aNumber min: 8 max: 0.5.
	magnification := magnification roundTo:
		(magnification < 3 ifTrue: [0.5] ifFalse: [1]).
	srcExtent := srcExtent min: (512@512) // magnification. "to prevent accidents"
	c := self center.
	super extent: self defaultExtent.
	self center: c.! !

!MagnifierMorph methodsFor: 'magnifying' stamp: 'nk 3/17/2004 11:34'!
magnifiedForm
	"Answer the magnified form"
	| srcRect form exclusion magnified |
	srcRect := self sourceRectFrom: self sourcePoint.
	(RecursionLock isNil and: [ self showPointer or: [ srcRect intersects: self bounds ]])
		ifTrue: [RecursionLock := self.
			exclusion := self isRound
						ifTrue: [owner]
						ifFalse: [self].
			form := self currentWorld
						patchAt: srcRect
						without: exclusion
						andNothingAbove: false.
			RecursionLock := nil]
		ifFalse: ["cheaper method if the source is not occluded"
			form := Display copy: srcRect].
	"smooth if non-integer scale"
	magnified := form
				magnify: form boundingBox
				by: magnification
				smoothing: (magnification isInteger
						ifTrue: [1]
						ifFalse: [2]).
	"display the pointer rectangle if desired"
	self showPointer
		ifTrue: [magnified
				reverse: (magnified center - (2 @ 2) extent: 4 @ 4)
				fillColor: Color white].
	^ magnified! !

!MagnifierMorph methodsFor: 'event handling' stamp: 'bf 9/21/1999 10:45'!
mouseDown: evt
	evt yellowButtonPressed
		ifTrue: [self chooseMagnification: evt]
		ifFalse: [super mouseDown: evt]! !

!MagnifierMorph methodsFor: 'menu' stamp: 'nk 3/17/2004 11:34'!
showPointer
	^showPointer ifNil: [ showPointer := false ].! !

!MagnifierMorph methodsFor: 'accessing' stamp: 'nk 3/6/2004 10:14'!
showPointer: aBoolean
	"If aBoolean is true, display the current pointer position as a small square in the center of the lens."

	showPointer == aBoolean ifTrue: [ ^self ].
	showPointer := aBoolean.
	self changed.! !

!MagnifierMorph methodsFor: 'menu' stamp: 'nk 3/17/2004 11:34'!
showingPointerString
	^ (self showPointer
		ifTrue: ['stop showing pointer']
		ifFalse: ['start showing pointer']) translated! !

!MagnifierMorph methodsFor: 'magnifying' stamp: 'bf 11/1/2000 16:02'!
sourcePoint
	"If we are being dragged use our center, otherwise use pointer position"
	^(trackPointer not or: [owner notNil and: [owner isHandMorph]])
		ifTrue: [self center]
		ifFalse: [self currentHand position]! !

!MagnifierMorph methodsFor: 'magnifying' stamp: 'bf 9/21/1999 08:47'!
sourceRect
	^self sourceRectFrom: self sourcePoint
! !

!MagnifierMorph methodsFor: 'magnifying' stamp: 'di 12/17/1999 13:42'!
sourceRectFrom: aPoint
	^ (aPoint extent: srcExtent) translateBy: (srcExtent // -2) + 1.
! !

!MagnifierMorph methodsFor: 'stepping and presenter' stamp: 'di 9/28/1999 07:57'!
step
	self changed! !

!MagnifierMorph methodsFor: 'testing' stamp: 'di 9/28/1999 07:57'!
stepTime
	^ 0! !

!MagnifierMorph methodsFor: 'round view' stamp: 'dgd 8/30/2003 21:51'!
toggleRoundString
	^ (self isRound
		ifTrue: ['be square']
		ifFalse: ['be round'])  translated! !

!MagnifierMorph methodsFor: 'round view' stamp: 'di 9/28/1999 23:16'!
toggleRoundness
	| sm w |
	w := self world.
	self isRound
		ifTrue: [owner delete.
				w addMorph: self]
		ifFalse: [sm := ScreeningMorph new position: self position.
				sm addMorph: self.
				sm addMorph: (EllipseMorph newBounds: self bounds).
				w addMorph: sm]! !

!MagnifierMorph methodsFor: 'menu' stamp: 'nk 3/17/2004 11:35'!
toggleShowingPointer
	self showPointer: self showPointer not! !

!MagnifierMorph methodsFor: 'menu' stamp: 'bf 9/20/1999 15:48'!
toggleTrackingPointer
	trackPointer := trackPointer not! !

!MagnifierMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 21:51'!
trackingPointerString
	^ (trackPointer
		ifTrue: ['stop tracking pointer']
		ifFalse: ['start tracking pointer']) translated! !

BorderedMorph subclass: #MarqueeMorph
	instanceVariableNames: 'colors count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-AdditionalWidgets'!

!MarqueeMorph commentStamp: '<historical>' prior: 0!
The MarqueeMorph is a subclass of the BorderedMorph which quickly cycles its border color.

The implementation could be simplified and generalized.  The color values and cycle speed are hard-coded for example.!

!MarqueeMorph methodsFor: 'initialization' stamp: 'RAA 9/25/1999 21:26'!
initialize

        super initialize.
        colors := {Color red. Color white. Color blue}.
        count := 0! !

!MarqueeMorph methodsFor: 'stepping and presenter' stamp: 'RAA 9/25/1999 21:27'!
step

        count := count + 1.
        count > colors size ifTrue: [count := 1].
        self borderColor: (colors at: count)! !

!MarqueeMorph methodsFor: 'testing' stamp: 'RAA 9/25/1999 21:30'!
stepTime
        "Answer the desired time between steps in milliseconds."

        ^ 200! !

!MarqueeMorph methodsFor: 'testing' stamp: 'RAA 9/25/1999 21:28'!
wantsSteps

        ^ true! !

BorderedMorph subclass: #ReferenceMorph
	instanceVariableNames: 'referent isHighlighted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Palettes'!

!ReferenceMorph commentStamp: '<historical>' prior: 0!
Serves as a reference to any arbitrary morph; used, for example, as the tab in a tabbed palette  The wrapper intercepts mouse events and fields them, passing them on to their referent morph.!

ReferenceMorph subclass: #FlapTab
	instanceVariableNames: 'flapShowing edgeToAdhereTo slidesOtherObjects popOutOnDragOver popOutOnMouseOver inboard dragged lastReferentThickness edgeFraction labelString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Flaps'!

!FlapTab commentStamp: '<historical>' prior: 0!
The tab associated with a flap.

nb: slidesOtherObjects and inboard are instance variables relating to disused features.  The feature implementations still exist in the system, but the UI to them has been sealed off.!

!FlapTab classSide methodsFor: 'printing' stamp: 'sw 2/11/1999 14:39'!
defaultNameStemForInstances
	^ 'flap tab'! !

!FlapTab classSide methodsFor: 'as yet unclassified' stamp: 'di 11/19/2001 21:59'!
givenID: aFlapID matches: pureID
	"eg, FlapTab givenID: 'Stack Tools2' matches: 'Stack Tools' "

	^ aFlapID = pureID or:
		[(aFlapID beginsWith: pureID)
			and: [(aFlapID copyFrom: pureID size+1 to: aFlapID size)
					allSatisfy: [:c | c isDigit]]]! !

!FlapTab classSide methodsFor: 'new-morph participation' stamp: 'kfr 5/3/2000 12:51'!
includeInNewMorphMenu
	"Not to be instantiated from the menu"
	^ false! !

!FlapTab methodsFor: 'access' stamp: 'dgd 8/31/2003 18:58'!
acquirePlausibleFlapID
	"Give the receiver a flapID that is globally unique; try to hit the mark vis a vis the standard system flap id's, for the case when this method is invoked as part of the one-time transition"

	| wording |
	wording := self wording.
	(wording isEmpty or: [wording = '---']) ifTrue: [wording := 'Flap' translated].
	
	^ self provideDefaultFlapIDBasedOn: wording! !

!FlapTab methodsFor: 'initialization' stamp: 'tk 12/11/2000 16:29'!
adaptToWorld
	| wasShowing new |
	(wasShowing := self flapShowing) ifTrue:
					[self hideFlap].
	(self respondsTo: #unhibernate) ifTrue: [
		(new := self unhibernate) == self ifFalse: [
			^ new adaptToWorld]].
	self spanWorld.
	self positionObject: self.
	wasShowing ifTrue:
		[self showFlap]! !

!FlapTab methodsFor: 'menu' stamp: 'dgd 8/30/2003 21:21'!
addCustomMenuItems: aMenu hand: aHandMorph
	"Add further items to the menu as appropriate"

	aMenu add: 'tab color...' translated target: self action: #changeColor.
	aMenu add: 'flap color...' translated target: self action: #changeFlapColor.
	aMenu addLine.
	aMenu addUpdating: #edgeString action: #setEdgeToAdhereTo.
	aMenu addLine.
	aMenu addUpdating: #textualTabString action: #textualTab.
	aMenu addUpdating: #graphicalTabString action: #graphicalTab.
	aMenu addUpdating: #solidTabString enablement: #notSolid action: #solidTab.
	aMenu addLine.

	(referent isKindOf: PasteUpMorph) ifTrue: 
		[aMenu addUpdating: #partsBinString action: #togglePartsBinMode].
	aMenu addUpdating: #dragoverString action: #toggleDragOverBehavior.
	aMenu addUpdating: #mouseoverString action: #toggleMouseOverBehavior.
	aMenu addLine.
	aMenu addUpdating: #isGlobalFlapString enablement: #sharedFlapsAllowed action: #toggleIsGlobalFlap.
	aMenu balloonTextForLastItem: 'If checked, this flap will be available in all morphic projects; if not, it will be private to this project.,' translated.

	aMenu addLine.
	aMenu add: 'destroy this flap' translated action: #destroyFlap.

	"aMenu addUpdating: #slideString action: #toggleSlideBehavior.
	aMenu addUpdating: #inboardString action: #toggleInboardness.
	aMenu addUpdating: #thicknessString ('thickness... (current: ', self thickness printString, ')') action: #setThickness."

! !

!FlapTab methodsFor: 'menus' stamp: 'sw 6/19/1999 23:16'!
addTitleForHaloMenu: aMenu
	aMenu addTitle: self externalName updatingSelector: #flapMenuTitle updateTarget: self! !

!FlapTab methodsFor: 'show & hide' stamp: 'sw 2/16/1999 17:58'!
adjustPositionAfterHidingFlap
	self positionObject: self! !

!FlapTab methodsFor: 'positioning' stamp: 'sw 2/16/1999 18:13'!
adjustPositionVisAVisFlap
	| sideToAlignTo opposite |
	opposite := Utilities oppositeSideTo: edgeToAdhereTo.
	sideToAlignTo := inboard
		ifTrue:	[opposite]
		ifFalse:	[edgeToAdhereTo].
	self perform: (Utilities simpleSetterFor: sideToAlignTo) with: (referent perform: opposite)! !

!FlapTab methodsFor: 'edge' stamp: 'sw 10/31/2001 20:51'!
applyEdgeFractionWithin: aBoundsRectangle
	"Make the receiver reflect remembered edgeFraction"

	| newPosition |
	edgeFraction ifNil: [^ self].
	self isCurrentlySolid ifTrue: [^ self].
	newPosition := self
		ifVertical:
			[self left @  (self edgeFraction * (aBoundsRectangle height - self height))]
		ifHorizontal:
			[(self edgeFraction * (aBoundsRectangle width - self width) @ self top)].

	self position: (aBoundsRectangle origin + newPosition)
	! !

!FlapTab methodsFor: 'solid tabs' stamp: 'sw 2/27/1999 13:16'!
applyTabThickness: newThickness
	(self orientation == #vertical)
			ifTrue:
				[submorphs first width: newThickness asNumber]
			ifFalse:
				[submorphs first height: newThickness asNumber].
	self fitContents.
	self positionReferent. 
	self adjustPositionVisAVisFlap! !

!FlapTab methodsFor: 'menu' stamp: 'sw 6/20/1999 23:41'!
applyThickness: newThickness
	| toUse |
	toUse := newThickness asNumber max: 0.
	(self orientation == #vertical)
			ifTrue:
				[referent width: toUse]
			ifFalse:
				[referent height: toUse].
	self positionReferent. 
	self adjustPositionVisAVisFlap! !

!FlapTab methodsFor: 'mouseover & dragover' stamp: 'sw 4/7/2000 07:52'!
arrangeToPopOutOnDragOver: aBoolean
	aBoolean
		ifTrue:
			[self on: #mouseEnterDragging send: #showFlapIfHandLaden: to: self.
			referent on: #mouseLeaveDragging send: #maybeHideFlapOnMouseLeaveDragging to: self.
			self on: #mouseLeaveDragging send: #maybeHideFlapOnMouseLeaveDragging to: self]
		ifFalse:
			[self on: #mouseEnterDragging send: nil to: nil.
			referent on: #mouseLeaveDragging send: nil to: nil.
			self on: #mouseLeaveDragging send: nil to: nil]! !

!FlapTab methodsFor: 'mouseover & dragover' stamp: 'sw 7/31/2002 00:53'!
arrangeToPopOutOnMouseOver: aBoolean
	aBoolean
		ifTrue:
			[self on: #mouseEnter send: #showFlap to: self.
			referent on: #mouseLeave send: #hideFlapUnlessBearingHalo to: self.
			self on: #mouseLeave send: #maybeHideFlapOnMouseLeave to: self]
		ifFalse:
			[self on: #mouseEnter send: nil to: nil.
			self on: #mouseLeave send: nil to: nil.
			referent on: #mouseLeave send: nil to: nil]! !

!FlapTab methodsFor: 'textual tabs' stamp: 'yo 7/16/2003 15:25'!
assumeString: aString font: aFont orientation: orientationSymbol color: aColor 
	| aTextMorph workString tabStyle |
	labelString := aString asString.
	workString := orientationSymbol == #vertical 
				ifTrue: 
					[String streamContents: 
							[:s | 
							labelString do: [:c | s nextPut: c] separatedBy: [s nextPut: Character cr]]]
				ifFalse: [labelString]. 
	tabStyle := (TextStyle new)
				leading: 0;
				newFontArray: (Array with: aFont).
	aTextMorph := (TextMorph new setTextStyle: tabStyle) 
				contents: (workString asText addAttribute: (TextKern kern: 3)).
	self removeAllMorphs.
	self
		borderWidth: 2;
		borderColor: #raised.
	aColor ifNotNil: [self color: aColor].
	self addMorph: aTextMorph centered.
	aTextMorph lock
	"
FlapTab allSubInstancesDo: [:ft | ft reformatTextualTab]
"! !

!FlapTab methodsFor: 'miscellaneous' stamp: 'dgd 8/31/2003 18:43'!
balloonTextForFlapsMenu
	"Answer the balloon text to show on a menu item in the flaps menu that governs the visibility of the receiver in the current project"

	| id |
	id := self flapID.
	#(
	('Squeak'		'Has a few generally-useful controls; it is also a place where you can "park" objects')
	('Tools'			'A quick way to get browsers, change sorters, file lists, etc.')
	('Widgets'		'A variety of controls and media tools')
	('Supplies' 		'A source for many basic types of objects')
	('Stack Tools' 	'Tools for building stacks.  Caution!!  Powerful but young and underdocumented')
	('Scripting'		'Tools useful when doing tile scripting')
	('Navigator'		'Project navigator:  includes controls for navigating through linked projects.  Also supports finding, loading and publishing projects in a shared environment')
	('Painting'		'A flap housing the paint palette.  Click on the closed tab to make make a new painting')) do:
		[:pair | (FlapTab givenID: id matches: pair first translated) ifTrue: [^ pair second translated]].

	^ self balloonText! !

!FlapTab methodsFor: 'menu' stamp: 'dgd 9/21/2003 17:55'!
changeColor
	self isCurrentlyGraphical
		ifTrue:
			[^ self inform: 'Color only pertains to a flap tab when the 
tab is textual or "solid".  This tab is
currently graphical, so color-choice
does not apply.' translated].
	super changeColor
	
! !

!FlapTab methodsFor: 'menu' stamp: 'dgd 9/21/2003 17:55'!
changeFlapColor
	(self flapShowing)
		ifTrue:
			[referent changeColor]
		ifFalse:
			[self inform: 'The flap itself needs to be open
before you can change its
color.' translated]! !

!FlapTab methodsFor: 'solid tabs' stamp: 'sw 6/21/1999 11:40'!
changeTabSolidity
	"Presently no actual options associated with this menu item if the flap is currently alreadly solid, so entertain the user with an anuran sound.  However, in latest scheme, the corresponding menu item is disabled in this circumstance, so this method is effectively unreachable."

	self playSoundNamed: 'croak'! !

!FlapTab methodsFor: 'menu' stamp: 'yo 7/2/2004 17:58'!
changeTabText
	"Allow the user to change the text on the tab"

	| reply |
	reply := FillInTheBlank
		request: 'new wording for this tab:' translated
		initialAnswer: self existingWording.
	reply isEmptyOrNil ifTrue: [^ self].
	self changeTabText: reply.
! !

!FlapTab methodsFor: 'textual tabs' stamp: 'ar 9/3/2004 14:58'!
changeTabText: aString 

	| label |
	aString isEmptyOrNil ifTrue: [^ self].
	label := Locale current languageEnvironment class flapTabTextFor: aString in: self.
	label isEmptyOrNil ifTrue: [^ self].
	self useStringTab: label.
	submorphs first delete.
	self assumeString: label
		font: Preferences standardFlapFont
		orientation: (Flaps orientationForEdge: self edgeToAdhereTo)
		color: nil.
! !

!FlapTab methodsFor: 'solid tabs' stamp: 'dgd 2/21/2003 22:39'!
changeTabThickness
	| newThickness |
	newThickness := FillInTheBlank request: 'New thickness:'
				initialAnswer: self tabThickness printString.
	newThickness notEmpty ifTrue: [self applyTabThickness: newThickness]! !

!FlapTab methodsFor: 'edge' stamp: 'sw 10/31/2001 15:01'!
computeEdgeFraction
	"Compute and remember the edge fraction"

	| aBox aFraction |
	self isCurrentlySolid ifTrue: [^ edgeFraction ifNil: [self edgeFraction: 0.5]].

	aBox := ((owner ifNil: [ActiveWorld]) bounds) insetBy: (self extent // 2).
	aFraction := self
		ifVertical: 
			[(self center y - aBox top) / (aBox height max: 1)]
		ifHorizontal:
			[(self center x - aBox left) / (aBox width max: 1)].
	^ self edgeFraction: aFraction! !

!FlapTab methodsFor: 'menu' stamp: 'dgd 9/5/2003 18:25'!
destroyFlap
	"Destroy the receiver"

	| reply request |
	request := self isGlobalFlap
		ifTrue:
			['Caution -- this would permanently
remove this flap, so it would no longer be
available in this or any other project.
Do you really want to this? ']
		ifFalse:
			['Caution -- this is permanent!!  Do
you really want to do this? '].
	reply := self confirm: request translated orCancel: [^ self].
	reply ifTrue:
		[self isGlobalFlap
			ifTrue:
				[Flaps removeFlapTab: self keepInList: false.
				self currentWorld reformulateUpdatingMenus]
			ifFalse:
				[referent isInWorld ifTrue: [referent delete].
				self delete]]! !

!FlapTab methodsFor: 'submorphs-add/remove' stamp: 'rbb 2/18/2005 14:13'!
dismissViaHalo
	"Dismiss the receiver (and its referent), unless it resists"

	self resistsRemoval ifTrue:
		[(UIManager default chooseFrom: #( 'Yes' 'Um, no, let me reconsider') 
				title: 'Really throw this flap away?') = 2 ifFalse: [^ self]].

	referent delete.
	self delete! !

!FlapTab methodsFor: 'mouseover & dragover' stamp: 'dgd 8/30/2003 21:32'!
dragoverString
	"Answer the string to be shown in a menu to represent the 
	dragover status"
	^ (popOutOnDragOver
		ifTrue: ['<yes>']
		ifFalse: ['<no>']), 'pop out on dragover' translated! !

!FlapTab methodsFor: 'edge' stamp: 'sw 10/31/2001 06:56'!
edgeFraction
	^ edgeFraction ifNil: [self computeEdgeFraction]! !

!FlapTab methodsFor: 'edge' stamp: 'sw 10/31/2001 08:38'!
edgeFraction: aNumber
	"Set my edgeFraction to the given number, without side effects"

	edgeFraction := aNumber asFloat! !

!FlapTab methodsFor: 'edge' stamp: 'yo 2/10/2005 18:06'!
edgeString
	^ 'cling to edge... (current: {1})' translated format: {edgeToAdhereTo translated}! !

!FlapTab methodsFor: 'edge' stamp: 'sw 2/11/1999 00:41'!
edgeToAdhereTo
	^ edgeToAdhereTo! !

!FlapTab methodsFor: 'edge' stamp: 'MAL 1/7/2005 12:20'!
edgeToAdhereTo: e
	edgeToAdhereTo := e asSymbol! !

!FlapTab methodsFor: 'menu' stamp: 'di 11/17/2001 20:17'!
existingWording
	^ labelString! !

!FlapTab methodsFor: 'misc' stamp: 'di 11/19/2001 12:19'!
fitContents
	self isCurrentlyTextual ifFalse: [^ super fitContents].
	self ifVertical:
		[self extent: submorphs first extent + (2 * self borderWidth) + (0@4).
		submorphs first position: self position + self borderWidth + (1@4)]
	ifHorizontal:
		[self extent: submorphs first extent + (2 * self borderWidth) + (8@-1).
		submorphs first position: self position + self borderWidth + (5@1)]! !

!FlapTab methodsFor: 'positioning' stamp: 'dgd 4/4/2006 16:12'!
fitOnScreen
	"19 sept 2000 - allow flaps in any paste up"
	| constrainer t l |
	constrainer := (owner ifNil: [self]) clearArea.
	self flapShowing "otherwise no point in doing this"
		ifTrue:[self spanWorld].
	self orientation == #vertical ifTrue: [
		t := ((self top min: (constrainer bottom- self height)) max: constrainer top).
		t = self top ifFalse: [self top: t].
	] ifFalse: [
		l := ((self left min: (constrainer right - self width)) max: constrainer left).
		l = self left ifFalse: [self left: l].
	].
	self flapShowing ifFalse: [self positionObject: self atEdgeOf: constrainer].
! !

!FlapTab methodsFor: 'access' stamp: 'sw 4/30/2001 18:39'!
flapID
	"Answer the receiver's flapID, creating it if necessary"

	^ self knownName ifNil: [self acquirePlausibleFlapID]! !

!FlapTab methodsFor: 'access' stamp: 'sw 4/30/2001 18:39'!
flapID: anID
	"Set the receiver's flapID"

	self setNameTo: anID! !

!FlapTab methodsFor: 'access' stamp: 'sw 5/4/2001 23:25'!
flapIDOrNil
	"If the receiver has a flapID, answer it, else answer nil"

	^ self knownName! !

!FlapTab methodsFor: 'menu' stamp: 'sw 7/8/1999 15:44'!
flapMenuTitle
	^ 'flap: ', self wording! !

!FlapTab methodsFor: 'access' stamp: 'sw 2/9/1999 14:44'!
flapShowing
	^ flapShowing == true! !

!FlapTab methodsFor: 'graphical tabs' stamp: 'sw 6/17/1999 16:07'!
graphicalTab
	self isCurrentlyGraphical
		ifTrue:
			[self changeTabGraphic]
		ifFalse:
			[self useGraphicalTab]! !

!FlapTab methodsFor: 'graphical tabs' stamp: 'dgd 8/30/2003 21:29'!
graphicalTabString
	^ (self isCurrentlyGraphical
		ifTrue: ['choose new graphic...']
		ifFalse: ['use graphical tab']) translated! !

!FlapTab methodsFor: 'show & hide' stamp: 'tk 1/31/2001 12:27'!
hideFlap
	| aWorld |
	aWorld := self world ifNil: [self currentWorld].
	referent privateDelete.
	aWorld removeAccommodationForFlap: self.
	flapShowing := false.
	self isInWorld ifFalse: [aWorld addMorphFront: self].
	self adjustPositionAfterHidingFlap.
	aWorld haloMorphs do:
		[:m | m target isInWorld ifFalse: [m delete]]! !

!FlapTab methodsFor: 'show & hide' stamp: 'sw 12/29/1999 12:41'!
hideFlapUnlessBearingHalo
	self hasHalo ifFalse: [self hideFlapUnlessOverReferent]! !

!FlapTab methodsFor: 'show & hide' stamp: 'sw 11/24/2001 21:50'!
hideFlapUnlessOverReferent
	"Hide the flap unless the mouse is over my referent."

	| aWorld where |
	(referent isInWorld and: 
		[where := self outermostWorldMorph activeHand lastEvent cursorPoint.
			referent bounds containsPoint: (referent globalPointToLocal: where)])
				ifTrue: [^ self].
	(aWorld := self world) ifNil: [^ self].  "In case flap tabs just got hidden"
	self referent delete.
	aWorld removeAccommodationForFlap: self.
	flapShowing := false.
	self isInWorld ifFalse:
		[self inboard ifTrue: [aWorld addMorphFront: self]].
	self adjustPositionAfterHidingFlap! !

!FlapTab methodsFor: 'edge' stamp: 'sw 10/31/2001 15:58'!
ifVertical: block1 ifHorizontal: block2
	"Evaluate and return the value of either the first or the second block, depending whether I am vertically or horizontally oriented"

	^ self orientation == #vertical
		ifTrue:
			[block1 value]
		ifFalse:
			[block2 value]
	! !

!FlapTab methodsFor: 'disused options' stamp: 'sw 6/21/1999 13:03'!
inboard
	^ inboard == true! !

!FlapTab methodsFor: 'disused options' stamp: 'sw 2/15/1999 12:57'!
inboard: aBoolean
	inboard := aBoolean! !

!FlapTab methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:49'!
initialize
"initialize the state of the receiver"
	super initialize.
""
	edgeToAdhereTo := #left.
	flapShowing := false.
	slidesOtherObjects := false.
	popOutOnDragOver := false.
	popOutOnMouseOver := false.
	inboard := false.
	dragged := false! !

!FlapTab methodsFor: 'solid tabs' stamp: 'sw 6/21/1999 11:39'!
isCurrentlySolid
	"Don't never use double negatives"

	^ self notSolid not! !

!FlapTab methodsFor: 'menu' stamp: 'gm 2/22/2003 13:11'!
isCurrentlyTextual
	| first |
	^submorphs notEmpty and: 
			[((first := submorphs first) isKindOf: StringMorph) 
				or: [first isTextMorph]]! !

!FlapTab methodsFor: 'classification' stamp: 'ar 9/28/2000 13:53'!
isFlapTab
	^true! !

!FlapTab methodsFor: 'globalness' stamp: 'sw 5/4/2001 23:25'!
isGlobalFlap
	"Answer whether the receiver is currently a shared flap"

	^ Flaps globalFlapTabsIfAny includes: self! !

!FlapTab methodsFor: 'globalness' stamp: 'dgd 8/30/2003 21:36'!
isGlobalFlapString
	"Answer a string to construct a menu item representing control 
	over whether the receiver is or is not a shared flap"
	^ (self isGlobalFlap
		ifTrue: ['<yes>']
		ifFalse: ['<no>'])
		, 'shared by all projects' translated! !

!FlapTab methodsFor: 'accessing' stamp: 'tk 9/25/2002 18:08'!
labelString
	^labelString! !

!FlapTab methodsFor: 'show & hide' stamp: 'sw 2/12/2001 16:49'!
lastReferentThickness: anInteger
	"Set the last remembered referent thickness to the given integer"

	lastReferentThickness := anInteger! !

!FlapTab methodsFor: 'layout' stamp: 'ar 10/26/2000 17:36'!
layoutChanged
	self fitOnScreen.
	^super layoutChanged! !

!FlapTab methodsFor: 'mouseover & dragover' stamp: 'ar 12/18/2000 01:14'!
makeNewDrawing: evt
	self flapShowing ifTrue:[
		self world makeNewDrawing: evt.
	] ifFalse:[
		self world assureNotPaintingEvent: evt.
	].! !

!FlapTab methodsFor: 'show & hide' stamp: 'RAA 6/2/2000 14:07'!
maybeHideFlapOnMouseLeave
	self hasHalo ifTrue: [^ self].
	referent isInWorld ifFalse: [^ self].
	self hideFlapUnlessOverReferent.
! !

!FlapTab methodsFor: 'show & hide' stamp: 'sw 3/5/1999 17:42'!
maybeHideFlapOnMouseLeaveDragging
	| aWorld |
	self hasHalo ifTrue: [^ self].
	referent isInWorld ifFalse: [^ self].
	(dragged or: [referent bounds containsPoint: self cursorPoint])
		ifTrue:	[^ self].
	aWorld := self world.
	referent privateDelete.  "could make me worldless if I'm inboard"
	aWorld ifNotNil: [aWorld removeAccommodationForFlap: self].
	flapShowing := false.
	self isInWorld ifFalse: [aWorld addMorphFront: self].
	self adjustPositionAfterHidingFlap! !

!FlapTab methodsFor: 'WiW support' stamp: 'RAA 10/3/2000 09:24'!
morphicLayerNumber
	^self flapShowing ifTrue: [26] ifFalse: [25] 	"As navigators"! !

!FlapTab methodsFor: 'event handling' stamp: 'sw 10/31/2001 15:46'!
mouseMove: evt
	| aPosition newReferentThickness adjustedPosition thick |

	dragged ifFalse: [(thick := self referentThickness) > 0
			ifTrue: [lastReferentThickness := thick]].
	((self containsPoint: (aPosition := evt cursorPoint)) and: [dragged not])
		ifFalse:
			[flapShowing ifFalse: [self showFlap].
			adjustedPosition := aPosition - evt hand targetOffset.
			(edgeToAdhereTo == #bottom)
				ifTrue:
					[newReferentThickness := inboard
						ifTrue:
							[self world height - adjustedPosition y]
						ifFalse:
							[self world height - adjustedPosition y - self height]].

			(edgeToAdhereTo == #left)
					ifTrue:
						[newReferentThickness :=
							inboard
								ifTrue:
									[adjustedPosition x + self width]
								ifFalse:
									[adjustedPosition x]].

			(edgeToAdhereTo == #right)
					ifTrue:
						[newReferentThickness :=
							inboard
								ifTrue:
									[self world width - adjustedPosition x]
								ifFalse:
									[self world width - adjustedPosition x - self width]].

			(edgeToAdhereTo == #top)
					ifTrue:
						[newReferentThickness :=
							inboard
								ifTrue:
									[adjustedPosition y + self height]
								ifFalse:
									[adjustedPosition y]].
		
			self isCurrentlySolid ifFalse:
				[(#(left right) includes: edgeToAdhereTo)
					ifFalse:
						[self left: adjustedPosition x]
					ifTrue:
						[self top: adjustedPosition y]].

			self applyThickness: newReferentThickness.
			dragged := true.
			self fitOnScreen.
			self computeEdgeFraction]! !

!FlapTab methodsFor: 'event handling' stamp: 'sw 11/22/2001 08:11'!
mouseUp: evt
	"The mouse came back up, presumably after having dragged the tab.  Caution: if not operating full-screen, this notification can easily be *missed*, which is why the edge-fraction-computation is also being done on mouseMove."

	super mouseUp: evt.
	(self referentThickness <= 0 or:
		[(referent isInWorld and: [(referent boundsInWorld intersects: referent owner boundsInWorld) not])]) ifTrue:
			[self hideFlap.
			flapShowing := false].
	self fitOnScreen.
	dragged ifTrue:
		[self computeEdgeFraction.
		dragged := false].
	Flaps doAutomaticLayoutOfFlapsIfAppropriate! !

!FlapTab methodsFor: 'mouseover & dragover' stamp: 'dgd 8/30/2003 21:36'!
mouseoverString
	"Answer the string to be shown in a menu to represent the  
	mouseover status"
	^ (popOutOnMouseOver
		ifTrue: ['<yes>']
		ifFalse: ['<no>'])
		, 'pop out on mouseover' translated ! !

!FlapTab methodsFor: 'solid tabs' stamp: 'sw 6/21/1999 11:36'!
notSolid
	"Answer whether the receiver is currenty not solid.  Used for determining whether the #solidTab menu item should be enabled"

	^ self isCurrentlyTextual or: [self isCurrentlyGraphical]! !

!FlapTab methodsFor: 'objects from disk' stamp: 'sw 5/4/2001 23:27'!
objectForDataStream: refStrm
	"I am about to be written on an object file.  If I am a global flap, write a proxy instead."

	| dp |
	self isGlobalFlap ifTrue:
		[dp := DiskProxy global: #Flaps selector: #globalFlapTabOrDummy: 
					args: {self flapID}.
		refStrm replace: self with: dp.
		^ dp].

	^ super objectForDataStream: refStrm! !

!FlapTab methodsFor: 'show & hide' stamp: 'sw 2/12/2001 16:59'!
openFully
	"Make an educated guess at how wide or tall we are to be, and open to that thickness"

	| thickness amt |
	thickness := referent boundingBoxOfSubmorphs extent max: (100 @ 100).
	self applyThickness: (amt := self orientation == #horizontal
			ifTrue:
				[thickness y]
			ifFalse:
				[thickness x]).
	self lastReferentThickness: amt.
	self showFlap! !

!FlapTab methodsFor: 'access' stamp: 'MAL 1/7/2005 12:25'!
orientation
	^ (#left == edgeToAdhereTo or: [#right == edgeToAdhereTo])
		ifTrue:		[#vertical]
		ifFalse:		[#horizontal]! !

!FlapTab methodsFor: 'change reporting' stamp: 'ar 10/26/2000 17:36'!
ownerChanged
	self fitOnScreen.
	^super ownerChanged.! !

!FlapTab methodsFor: 'parts bin' stamp: 'dgd 8/30/2003 21:31'!
partsBinString
	"Answer the string to be shown in a menu to represent the 
	parts-bin status"
	^ (referent isPartsBin
		ifTrue: ['<yes>']
		ifFalse: ['<no>']), 'parts-bin' translated! !

!FlapTab methodsFor: 'thumbnail' stamp: 'sw 6/16/1999 11:29'!
permitsThumbnailing
	^ false! !

!FlapTab methodsFor: 'positioning' stamp: 'dgd 4/4/2006 16:08'!
positionObject: anObject
        "anObject could be myself or my referent"

"Could consider container := referent pasteUpMorph, to allow flaps on things other than the world, but for the moment, let's skip it!!"

	"19 sept 2000 - going for all paste ups"

	| pum |
	pum := self pasteUpMorph ifNil: [^ self].

	^self 
		positionObject: anObject 
		atEdgeOf: pum clearArea! !

!FlapTab methodsFor: 'positioning' stamp: 'RAA 6/14/2000 19:35'!
positionObject: anObject atEdgeOf: container
        "anObject could be myself or my referent"

        edgeToAdhereTo == #left ifTrue: [^ anObject left: container left].
        edgeToAdhereTo == #right ifTrue: [^ anObject right: container right].
        edgeToAdhereTo == #top ifTrue: [^ anObject top: container top].
        edgeToAdhereTo == #bottom ifTrue: [^ anObject bottom: container bottom]! !

!FlapTab methodsFor: 'positioning' stamp: 'sw 2/16/1999 17:58'!
positionReferent
	self positionObject: referent! !

!FlapTab methodsFor: 'menu' stamp: 'sw 6/20/1999 19:17'!
preserveDetails
	"The receiver is being switched to use a different format.  Preserve the existing details (e.g. wording if textual, grapheme if graphical) so that if the user reverts back to the current format, the details will be right"

	| thickness |
	color = Color transparent ifFalse: [self setProperty: #priorColor toValue: color].
	self isCurrentlyTextual
		ifTrue:
			[self setProperty: #priorWording toValue: self existingWording]
		ifFalse:
			[self isCurrentlyGraphical
				ifTrue:
					[self setProperty: #priorGraphic toValue: submorphs first form]
				ifFalse:
					[thickness := (self orientation == #vertical)
						ifTrue:	[self width]
						ifFalse:	[self height].
					self setProperty: #priorThickness toValue: thickness]]! !

!FlapTab methodsFor: 'printing' stamp: 'sw 11/6/2000 15:41'!
printOn: aStream
	"Append a textual representation of the receiver to aStream"

	super printOn: aStream.
	aStream nextPutAll: ' "', self wording, '"'! !

!FlapTab methodsFor: 'initialization' stamp: 'di 11/18/2001 13:09'!
provideDefaultFlapIDBasedOn: aStem
	"Provide the receiver with a default flap id"

	| aNumber usedIDs anID  |
	aNumber := 0.
	usedIDs := FlapTab allSubInstances select: [:f | f ~~ self] thenCollect: [:f | f flapIDOrNil].
	anID := aStem.
	[usedIDs includes: anID] whileTrue:
		[aNumber := aNumber + 1.
		anID := aStem, (aNumber asString)].
	self flapID: anID.
	^ anID! !

!FlapTab methodsFor: 'access' stamp: 'sw 6/18/1999 13:38'!
referentThickness
	^ (self orientation == #horizontal)
		ifTrue:
			[referent height]
		ifFalse:
			[referent width]! !

!FlapTab methodsFor: 'textual tabs' stamp: 'sw 12/8/1999 18:16'!
reformatTextualTab
	"The font choice possibly having changed, reformulate the receiver"

	self isCurrentlyTextual ifFalse: [^ self].
	self assumeString: self existingWording font: Preferences standardFlapFont orientation: self orientation color: self color! !

!FlapTab methodsFor: 'rounding' stamp: 'di 11/20/2001 08:20'!
roundedCorners
	edgeToAdhereTo == #bottom ifTrue: [^ #(1 4)].
	edgeToAdhereTo == #right ifTrue: [^ #(1 2)].
	edgeToAdhereTo == #left ifTrue: [^ #(3 4)].
	^ #(2 3)  "#top and undefined"
! !

!FlapTab methodsFor: 'edge' stamp: 'MAL 1/7/2005 12:24'!
setEdge: anEdge
	"Set the edge as indicated, if possible"

	| newOrientation e |
	e := anEdge asSymbol.
	self edgeToAdhereTo = anEdge ifTrue: [^ self].
	newOrientation := nil.
	self orientation == #vertical
		ifTrue: [(#top == e or: [#bottom == e]) ifTrue:
					[newOrientation := #horizontal]]
		ifFalse: [(#top == e or: [#bottom == e]) ifFalse:
					[newOrientation := #vertical]].
	self edgeToAdhereTo: e.
	newOrientation ifNotNil: [self transposeParts].
	referent isInWorld ifTrue: [self positionReferent].
	self adjustPositionVisAVisFlap! !

!FlapTab methodsFor: 'edge' stamp: 'dgd 10/17/2003 22:36'!
setEdgeToAdhereTo
	| aMenu |
	aMenu := MenuMorph new defaultTarget: self.
	#(left top right bottom) do:
		[:sym | aMenu add: sym asString translated target: self selector:  #setEdge: argument: sym].
	aMenu popUpEvent: self currentEvent in: self world! !

!FlapTab methodsFor: 'initialization' stamp: 'di 11/19/2001 21:20'!
setName: nameString edge: edgeSymbol color: flapColor
	"Set me up with the usual..."

	self setNameTo: nameString.
	self edgeToAdhereTo: edgeSymbol; inboard: false.
	self assumeString: nameString font: Preferences standardFlapFont
		orientation: self orientation color: flapColor.
	self setToPopOutOnDragOver: true.
	self setToPopOutOnMouseOver: false.
! !

!FlapTab methodsFor: 'mouseover & dragover' stamp: 'sw 2/25/1999 14:53'!
setToPopOutOnDragOver: aBoolean
	self arrangeToPopOutOnDragOver:  (popOutOnDragOver := aBoolean)! !

!FlapTab methodsFor: 'mouseover & dragover' stamp: 'sw 2/25/1999 14:52'!
setToPopOutOnMouseOver: aBoolean
	self arrangeToPopOutOnMouseOver:  (popOutOnMouseOver := aBoolean)! !

!FlapTab methodsFor: 'menu' stamp: 'sw 4/24/2001 11:04'!
sharedFlapsAllowed
	"Answer (for the benefit of a menu item for which I am the target) whether the system presently allows shared flaps"

	^ Flaps sharedFlapsAllowed! !

!FlapTab methodsFor: 'show & hide' stamp: 'dgd 8/31/2004 16:25'!
showFlap
	"Open the flap up"

	| thicknessToUse flapOwner |

	"19 sept 2000 - going for all paste ups <- raa note"
	flapOwner := self pasteUpMorph.
	self referentThickness <= 0
		ifTrue:
			[thicknessToUse := lastReferentThickness ifNil: [100].
			self orientation == #horizontal
				ifTrue:
					[referent height: thicknessToUse]
				ifFalse:
					[referent width: thicknessToUse]].
	inboard ifTrue:
		[self stickOntoReferent].  "makes referent my owner, and positions me accordingly"
	referent pasteUpMorph == flapOwner
		ifFalse:
			[flapOwner accommodateFlap: self.  "Make room if needed"
			flapOwner addMorphFront: referent.
			flapOwner startSteppingSubmorphsOf: referent.
			self positionReferent.
			referent adaptToWorld: flapOwner].
	inboard  ifFalse:
		[self adjustPositionVisAVisFlap].
	flapShowing := true.
	
	self pasteUpMorph hideFlapsOtherThan: self ifClingingTo: edgeToAdhereTo.

	flapOwner bringTopmostsToFront! !

!FlapTab methodsFor: 'show & hide' stamp: 'sw 4/7/2000 07:51'!
showFlapIfHandLaden: evt
	"The hand has drifted over the receiver with the button down.  If the hand is carrying anything, show the flap.  If the hand is empty, the likely cause is that it's manipulating a scrollbar or some such, so in that case don't pop the flap out."

	evt hand hasSubmorphs ifTrue: [self showFlap]! !

!FlapTab methodsFor: 'disused options' stamp: 'sw 2/11/1999 10:55'!
slidesOtherObjects
	^ slidesOtherObjects! !

!FlapTab methodsFor: 'solid tabs' stamp: 'sw 6/20/1999 21:34'!
solidTab
	self isCurrentlySolid
		ifFalse:
			[self useSolidTab]
		ifTrue:
			[self changeTabSolidity]! !

!FlapTab methodsFor: 'solid tabs' stamp: 'dgd 8/30/2003 21:31'!
solidTabString
	^ (self isCurrentlySolid
		ifTrue: ['currently using solid tab']
		ifFalse: ['use solid tab']) translated! !

!FlapTab methodsFor: 'positioning' stamp: 'dgd 4/4/2006 16:10'!
spanWorld
	| container area |
	
	container := self pasteUpMorph
				ifNil: [self currentWorld].

	area := container clearArea.

	self orientation == #vertical ifTrue: [
		referent vResizing == #rigid
			ifTrue: [referent height: area height].
		referent hResizing == #rigid
			ifTrue: [referent width: (referent width min: area width - self width)].
		referent top: area top.
		referent bottom: (area bottom min: referent bottom)
	]
	ifFalse: [
		referent hResizing == #rigid
			ifTrue: [referent width: area width].
		referent vResizing == #rigid
			ifTrue: [referent height: (referent height min: area height - self height)].
		referent left: area left.
		referent right: (area right min: referent right)
	].
! !

!FlapTab methodsFor: 'mouseover & dragover' stamp: 'ar 2/8/2001 19:27'!
startOrFinishDrawing: evt
	| w |
	self flapShowing ifTrue:[
		(w := self world) makeNewDrawing: evt at:  w center.
	] ifFalse:[
		self world endDrawing: evt.
	].! !

!FlapTab methodsFor: 'positioning' stamp: 'sw 2/11/1999 14:46'!
stickOntoReferent
	"Place the receiver directly onto the referent -- for use when the referent is being shown as a flap"
	| newPosition |
	referent addMorph: self.
	edgeToAdhereTo == #left
		ifTrue:
			[newPosition := (referent width - self width) @ self top].
	edgeToAdhereTo == #right
		ifTrue:
			[newPosition := (referent left @ self top)].
	edgeToAdhereTo == #top
		ifTrue:
			[newPosition := self left @ (referent height - self height)].
	edgeToAdhereTo == #bottom
		ifTrue:
			[newPosition := self left @ referent top].
	self position: newPosition! !

!FlapTab methodsFor: 'events' stamp: 'sw 2/12/2001 17:04'!
tabSelected
	"The user clicked on the tab.  Show or hide the flap.  Try to be a little smart about a click on a tab whose flap is open but only just barely."

	dragged == true ifTrue:
		[^ dragged := false].
	self flapShowing
		ifTrue:
			[self referentThickness < 23  "an attractive number"
				ifTrue:
					[self openFully]
				ifFalse:
					[self hideFlap]]
		ifFalse:
			[self showFlap]! !

!FlapTab methodsFor: 'access' stamp: 'sw 2/27/1999 13:14'!
tabThickness
	^ (self orientation == #vertical)
		ifTrue:
			[self width]
		ifFalse:
			[self height]! !

!FlapTab methodsFor: 'textual tabs' stamp: 'sw 6/17/1999 13:21'!
textualTab
	self isCurrentlyTextual
		ifTrue:
			[self changeTabText]
		ifFalse:
			[self useTextualTab]! !

!FlapTab methodsFor: 'textual tabs' stamp: 'dgd 8/30/2003 21:27'!
textualTabString
	^ (self isCurrentlyTextual
		ifTrue: ['change tab wording...']
		ifFalse: ['use textual tab']) translated! !

!FlapTab methodsFor: 'menu' stamp: 'sw 6/14/1999 16:38'!
thicknessString
	^ 'thickness... (currently ', self thickness printString, ')'! !

!FlapTab methodsFor: 'mouseover & dragover' stamp: 'sw 2/15/1999 14:10'!
toggleDragOverBehavior
	self arrangeToPopOutOnDragOver:  (popOutOnDragOver := popOutOnDragOver not)! !

!FlapTab methodsFor: 'globalness' stamp: 'sw 4/30/2001 18:52'!
toggleIsGlobalFlap
	"Toggle whether the receiver is currently a global flap or not"

	| oldWorld |
	self hideFlap.
	oldWorld := self currentWorld.
	self isGlobalFlap
		ifTrue:
			[Flaps removeFromGlobalFlapTabList: self.
			oldWorld addMorphFront: self]
		ifFalse:
			[self delete.
			Flaps addGlobalFlap: self.
			self currentWorld addGlobalFlaps].
	ActiveWorld reformulateUpdatingMenus
		! !

!FlapTab methodsFor: 'mouseover & dragover' stamp: 'sw 2/15/1999 14:07'!
toggleMouseOverBehavior
	self arrangeToPopOutOnMouseOver:  (popOutOnMouseOver := popOutOnMouseOver not)! !

!FlapTab methodsFor: 'parts bin' stamp: 'sw 2/25/1999 13:17'!
togglePartsBinMode
	referent setPartsBinStatusTo: referent isPartsBin not! !

!FlapTab methodsFor: 'positioning' stamp: 'di 11/21/2001 16:02'!
transposeParts
	"The receiver's orientation has just been changed from vertical to horizontal or vice-versa."
	"First expand the flap to screen size, letting the submorphs lay out to fit,
	and then shrink the minor dimension back to the last row."

	self isCurrentlyTextual ifTrue:  "First recreate the tab with proper orientation"
		[self assumeString: self existingWording font: Preferences standardFlapFont
			orientation: self orientation color: self color].
	self orientation == #vertical
		ifTrue:	"changed from horizontal"
			[referent listDirection: #topToBottom; wrapDirection: #leftToRight.
			referent hasSubmorphs ifTrue:
				[referent extent: self currentWorld extent.
				referent fullBounds.  "Needed to trigger layout"
				referent width: (referent submorphs collect: [:m | m right]) max
									- referent left + self width]]
		ifFalse:
			[referent listDirection: #leftToRight; wrapDirection: #topToBottom.
			referent hasSubmorphs ifTrue:
				[referent extent: self currentWorld extent.
				referent fullBounds.  "Needed to trigger layout"
				referent height: (referent submorphs collect: [:m | m bottom]) max
									- referent top + self height]].
	referent hasSubmorphs ifFalse: [referent extent: 100@100].

	self spanWorld.
	flapShowing ifTrue: [self showFlap]! !

!FlapTab methodsFor: 'solid tabs' stamp: 'sw 6/20/1999 20:55'!
useSolidTab
	| thickness colorToUse |
	self preserveDetails.

	thickness := self valueOfProperty: #priorThickness ifAbsent: [20].
	colorToUse := self valueOfProperty: #priorColor ifAbsent: [Color red muchLighter].
	self color: colorToUse.
	self removeAllMorphs.
	
	(self orientation == #vertical)
		ifTrue:
			[self width: thickness.
			self height: self currentWorld height.
			self position: (self position x @ 0)]
		ifFalse:
			[self height: thickness.
			self width: self currentWorld width.
			self position: (0 @ self position y)].

	self borderWidth: 0.
	self layoutChanged.! !

!FlapTab methodsFor: 'textual tabs' stamp: 'di 11/17/2001 20:22'!
useStringTab: aString
	| aLabel |
	labelString := aString asString.
	aLabel := StringMorph  new contents: labelString.
	self addMorph: aLabel.
	aLabel position: self position.
	aLabel highlightColor: self highlightColor; regularColor: self regularColor.
	aLabel lock.
	self fitContents.
	self layoutChanged! !

!FlapTab methodsFor: 'textual tabs' stamp: 'dgd 10/8/2003 19:03'!
useTextualTab
	| stringToUse colorToUse |
	self preserveDetails.
	colorToUse := self valueOfProperty: #priorColor ifAbsent: [Color green muchLighter].
	submorphs notEmpty ifTrue: [self removeAllMorphs].
	stringToUse := self valueOfProperty: #priorWording ifAbsent: ['Unnamed Flap' translated].
	self assumeString: stringToUse font:  Preferences standardFlapFont orientation: self orientation color: colorToUse! !

!FlapTab methodsFor: 'rounding' stamp: 'ar 12/22/2001 22:45'!
wantsRoundedCorners
	^self isCurrentlyTextual or:[super wantsRoundedCorners]! !

!FlapTab methodsFor: 'menu' stamp: 'ar 12/18/2000 16:38'!
wording
	^ self isCurrentlyTextual
		ifTrue:
			[self existingWording]
		ifFalse:
			[self valueOfProperty: #priorWording ifAbsent: ['---']]! !

FlapTab subclass: #ViewerFlapTab
	instanceVariableNames: 'scriptedPlayer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Flaps'!

!ViewerFlapTab commentStamp: 'kfr 10/28/2003 06:31' prior: 0!
ViewerFlapTab are flap tabs for etoy scripting viewers.!

!ViewerFlapTab classSide methodsFor: 'printing' stamp: 'dgd 8/26/2004 12:12'!
defaultNameStemForInstances
	^ 'viewerFlapTab'! !

!ViewerFlapTab methodsFor: 'menu' stamp: 'dgd 8/30/2003 22:21'!
addCustomMenuItems: aMenu hand: aHandMorph
	"Add further items to the menu as appropriate.  NB: Cannot call super here."

	aMenu add: 'flap color...' translated target: self action: #changeFlapColor.
	aMenu addLine.
	aMenu addUpdating: #edgeString action: #setEdgeToAdhereTo.
	aMenu addUpdating: #dragoverString action: #toggleDragOverBehavior.
	aMenu addUpdating: #mouseoverString action: #toggleMouseOverBehavior.
	aMenu addLine.
	aMenu addUpdating: #compactFlapString target: self action: #changeCompactFlap.

	aMenu add: 'destroy this flap' translated action: #destroyFlap! !

!ViewerFlapTab methodsFor: 'submorphs-accessing' stamp: 'tk 1/31/2001 16:03'!
allNonSubmorphMorphs
	"Return a collection containing all morphs in this morph which are not currently in the submorph containment hierarchy.  Especially the non-showing pages in BookMorphs."

	^ flapShowing 
		ifTrue: [#()]
		ifFalse: [Array with: referent]! !

!ViewerFlapTab methodsFor: 'compact' stamp: 'ar 12/19/2000 18:58'!
changeCompactFlap
	self makeFlapCompact: self isFlapCompact not.! !

!ViewerFlapTab methodsFor: 'compact' stamp: 'dgd 8/30/2003 22:23'!
compactFlapString
	^ (self isFlapCompact
		ifTrue: ['<on>compact flap']
		ifFalse: ['<off>']), 'compact flap' translated! !

!ViewerFlapTab methodsFor: 'menu' stamp: 'sw 5/4/2001 07:45'!
graphicalMorphForTab
	"Answer a graphical morph to serve as my tab's display"

	^ ThumbnailMorph new objectToView: scriptedPlayer viewSelector: #graphicForViewerTab! !

!ViewerFlapTab methodsFor: 'transition' stamp: 'ar 3/3/2001 20:24'!
hibernate
	"drop my viewer to save space when writing to the disk."

	referent submorphs do: 
		[:m | (m isKindOf: Viewer) ifTrue: [m delete]]! !

!ViewerFlapTab methodsFor: 'transition' stamp: 'sw 7/7/1999 13:14'!
initializeFor: aPlayer topAt: aTop

	scriptedPlayer := aPlayer.
	self useGraphicalTab.
	self top: aTop! !

!ViewerFlapTab methodsFor: 'accessing' stamp: 'sw 7/7/1999 13:28'!
isCurrentlyGraphical
	^ true! !

!ViewerFlapTab methodsFor: 'compact' stamp: 'ar 12/19/2000 18:54'!
isFlapCompact
	"Return true if the referent of the receiver represents a 'compact' flap"
	referent layoutPolicy ifNil:[^false].
	referent layoutPolicy isTableLayout ifFalse:[^false].
	referent vResizing == #shrinkWrap ifFalse:[^false].
	^true! !

!ViewerFlapTab methodsFor: 'compact' stamp: 'ar 12/19/2000 18:55'!
makeFlapCompact: aBool
	"Return true if the referent of the receiver represents a 'compact' flap"
	aBool ifTrue:[
		referent
			layoutPolicy: TableLayout new;
			vResizing: #shrinkWrap;
			useRoundedCorners.
	] ifFalse:[
		referent
			layoutPolicy: nil;
			vResizing: #rigid;
			useSquareCorners.
	].! !

!ViewerFlapTab methodsFor: 'access' stamp: 'sw 6/25/1999 22:07'!
scriptedPlayer
	^ scriptedPlayer! !

!ViewerFlapTab methodsFor: 'transition' stamp: 'aoy 2/15/2003 21:19'!
unhibernate
	"recreate my viewer"

	| wasShowing viewer |
	referent ifNotNil: [(referent findA: Viewer) ifNotNil: [^self]].
	wasShowing := flapShowing.
	"guard against not-quite-player-players"
	viewer := ((scriptedPlayer respondsTo: #costume) 
				and: [scriptedPlayer costume isMorph]) 
					ifTrue: [self presenter viewMorph: scriptedPlayer costume]
					ifFalse: [self presenter viewObjectDirectly: scriptedPlayer]. 
	wasShowing ifFalse: [self hideFlap].
	^viewer! !

!ReferenceMorph classSide methodsFor: 'printing' stamp: 'sw 11/30/1998 12:44'!
defaultNameStemForInstances
	^ 'ref'! !

!ReferenceMorph classSide methodsFor: 'instance creation' stamp: 'sw 11/30/1998 14:12'!
forMorph: aMorph
	"Create a new tab consisting of a string holding the morph's name"
	^ self new morphToInstall: aMorph! !

!ReferenceMorph classSide methodsFor: 'instance creation' stamp: 'sw 1/11/2000 10:19'!
forMorph: aMorph font: aFont
	"Create a new tab consisting of a string holding the morph's name"
	^ self new morphToInstall: aMorph font: aFont! !

!ReferenceMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 21:59'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"Add morph-specific items to the menu for the hand"

	| sketch |
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addLine.
	self isCurrentlyTextual
		ifTrue:
			[aCustomMenu add: 'change label wording...' translated action: #changeTabText.
			aCustomMenu add: 'use graphical label' translated action: #useGraphicalTab]
		ifFalse:
			[aCustomMenu add: 'use textual label' translated action: #useTextualTab.
			aCustomMenu add: 'choose graphic...' translated action: #changeTabGraphic.
			(sketch := self findA: SketchMorph) ifNotNil:
				[aCustomMenu add: 'repaint' translated target: sketch action: #editDrawing]]! !

!ReferenceMorph methodsFor: 'submorphs-accessing' stamp: 'tk 3/8/2000 17:39'!
allNonSubmorphMorphs
	"we hold extra morphs"

	^ Array with: referent! !

!ReferenceMorph methodsFor: 'accessing' stamp: 'sw 10/30/2000 11:11'!
borderWidth: aWidth
	"Set the receiver's border width as indicated, and trigger a fresh layout"

	super borderWidth: aWidth.
	self layoutChanged! !

!ReferenceMorph methodsFor: 'menu' stamp: 'sw 12/16/1998 14:02'!
changeTabGraphic
	submorphs first chooseNewGraphicCoexisting: true! !

!ReferenceMorph methodsFor: 'menu' stamp: 'sma 6/18/2000 10:36'!
changeTabText
	| reply |
	reply := FillInTheBlank
		request: 'new wording for this tab:'
		initialAnswer: submorphs first contents.
	reply isEmptyOrNil ifFalse: [submorphs first contents: reply]! !

!ReferenceMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:49'!
defaultBorderWidth
"answer the default border width for the receiver"
	^ 0! !

!ReferenceMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:48'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color transparent! !

!ReferenceMorph methodsFor: 'button' stamp: 'sw 12/21/1998 14:13'!
doButtonAction
	self tabSelected! !

!ReferenceMorph methodsFor: 'menu' stamp: 'sw 6/21/1999 11:43'!
existingWording
	^ submorphs first contents asString! !

!ReferenceMorph methodsFor: 'misc' stamp: 'sw 2/11/1999 14:11'!
fitContents
	submorphs size == 1 ifTrue:
		[self extent: submorphs first extent + (2 * self borderWidth).
		submorphs first position: self position + self borderWidth]! !

!ReferenceMorph methodsFor: 'menu' stamp: 'di 2/17/2000 20:32'!
graphicalMorphForTab
	| formToUse |
	formToUse := self valueOfProperty: #priorGraphic ifAbsent: [ScriptingSystem formAtKey: 'squeakyMouse'].
	^ SketchMorph withForm: formToUse! !

!ReferenceMorph methodsFor: 'event handling' stamp: 'sw 11/30/1998 12:46'!
handlesMouseDown: evt
	^ true
! !

!ReferenceMorph methodsFor: 'accessing' stamp: 'dgd 2/22/2003 13:20'!
highlight
	| str |
	isHighlighted := true.
	submorphs notEmpty 
		ifTrue: 
			[((str := submorphs first) isKindOf: StringMorph) 
				ifTrue: [str color: self highlightColor]
				ifFalse: 
					[self
						borderWidth: 1;
						borderColor: self highlightColor]]! !

!ReferenceMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:49'!
initialize
"initialize the state of the receiver"
	super initialize.
""
	isHighlighted := false.
	referent := nil! !

!ReferenceMorph methodsFor: 'accessing' stamp: 'nk 6/12/2004 10:03'!
isCurrentlyGraphical
	"Answer whether the receiver is currently showing a graphical face"

	| first |
	^submorphs notEmpty and: 
			[((first := submorphs first) isKindOf: ImageMorph) 
				or: [first isSketchMorph]]! !

!ReferenceMorph methodsFor: 'menu' stamp: 'gm 2/22/2003 12:51'!
isCurrentlyTextual
	| first |
	^((first := submorphs first) isKindOf: StringMorph) 
		or: [first isTextMorph]! !

!ReferenceMorph methodsFor: 'misc' stamp: 'sw 12/2/1998 12:38'!
isHighlighted
	^ isHighlighted == true! !

!ReferenceMorph methodsFor: 'layout' stamp: 'sw 12/1/1998 13:20'!
layoutChanged
	self fitContents.
	super layoutChanged! !

!ReferenceMorph methodsFor: 'accessing' stamp: 'sw 11/30/1998 12:47'!
morphToInstall
	^ referent! !

!ReferenceMorph methodsFor: 'misc' stamp: 'sw 12/21/1998 15:50'!
morphToInstall: aMorph
	"Create a new tab consisting of a string holding the morph's name"
	| aLabel nameToUse |
	aLabel := StringMorph new contents: (nameToUse := aMorph externalName).
	self addMorph: aLabel.
	aLabel lock.
	self referent: aMorph.
	self setNameTo: nameToUse.
	self fitContents.! !

!ReferenceMorph methodsFor: 'misc' stamp: 'sw 1/11/2000 10:18'!
morphToInstall: aMorph font: aFont
	"Create a new tab consisting of a string holding the morph's name"
	| aLabel nameToUse |
	aLabel := StringMorph contents: (nameToUse := aMorph externalName) font: aFont.
	self addMorph: aLabel.
	aLabel lock.
	self referent: aMorph.
	self setNameTo: nameToUse.
	self fitContents.! !

!ReferenceMorph methodsFor: 'event handling' stamp: 'sw 3/7/1999 00:29'!
mouseDown: evt
	self setProperty: #oldColor toValue: color! !

!ReferenceMorph methodsFor: 'event handling' stamp: 'sw 10/24/2000 14:45'!
mouseMove: evt
	"The mouse moved while the butten was down in the receiver"

	| aForm |
	aForm := self imageForm.
	(self containsPoint: evt cursorPoint)
		ifTrue:
			[aForm reverse displayOn: Display]
		ifFalse:
			[aForm displayOn: Display]! !

!ReferenceMorph methodsFor: 'event handling' stamp: 'sw 10/26/2000 14:41'!
mouseUp: evt
	"The mouse came up in the receiver; If the mouse is still within the receiver at this point, do the corresponding action"

	| aColor |
	(aColor := self valueOfProperty: #oldColor) ifNotNil: [self color: aColor].
	(self containsPoint: evt cursorPoint)
		ifTrue: [self doButtonAction].
	super mouseUp: evt "send to evt handler if any"
! !

!ReferenceMorph methodsFor: 'menu' stamp: 'sw 3/23/2000 10:47'!
preserveDetails
	"The receiver is being switched to use a different format.  Preserve the existing details (e.g. wording if textual, grapheme if graphical) so that if the user reverts back to the current format, the details will be right"

	self isCurrentlyTextual
		ifTrue:
			[self setProperty: #priorWording toValue: self existingWording.
			self setProperty: #priorColor toValue: color.
			self setProperty: #priorBorderWidth toValue: borderWidth]
		ifFalse:
			[self setProperty: #priorGraphic toValue: submorphs first form]! !

!ReferenceMorph methodsFor: 'accessing' stamp: 'sw 12/3/1998 10:06'!
referent
	^ referent! !

!ReferenceMorph methodsFor: 'accessing' stamp: 'de 11/30/1998 09:58'!
referent: m
	referent := m! !

!ReferenceMorph methodsFor: 'menu' stamp: 'sw 10/30/2000 11:11'!
setLabelFontTo: aFont
	"Change the receiver's label font to be as indicated"

	| aLabel oldLabel |
	aLabel := StringMorph contents:  (oldLabel := self findA: StringMorph) contents font: aFont.
	self replaceSubmorph: oldLabel by: aLabel.
	aLabel position: self position.
	aLabel highlightColor: self highlightColor; regularColor: self regularColor.
	aLabel lock.
	self fitContents.
	self layoutChanged.
	(owner isKindOf: IndexTabs) ifTrue:
		[self borderWidth: 0.
		owner laySubpartsOutInOneRow.
		isHighlighted ifTrue:
			[self highlight]]! !

!ReferenceMorph methodsFor: 'naming' stamp: 'dgd 2/22/2003 13:21'!
setNameTo: aString 
	super setNameTo: aString.
	(submorphs notEmpty and: [submorphs first isKindOf: StringMorph]) 
		ifTrue: [submorphs first contents: aString]! !

!ReferenceMorph methodsFor: 'misc' stamp: 'sw 12/1/1998 11:59'!
sorterToken
	^ SorterTokenMorph new forMorph: self! !

!ReferenceMorph methodsFor: 'events' stamp: 'nb 6/17/2003 12:25'!
tabSelected
	"Called when the receiver is hit.  First, bulletproof against someone having taken the structure apart.  My own action basically requires that my grand-owner be a TabbedPalette.  Note that the 'opening' script concept has been left behind here."
	| gramps |
	(owner isKindOf: IndexTabs) ifFalse: [^ Beeper beep].
	((gramps := owner owner) isKindOf: TabbedPalette)  ifTrue:
		[gramps selectTab: self]! !

!ReferenceMorph methodsFor: 'accessing' stamp: 'dgd 2/22/2003 13:21'!
unHighlight
	| str |
	isHighlighted := false.
	self borderWidth: 0.
	submorphs notEmpty 
		ifTrue: 
			[((str := submorphs first) isKindOf: StringMorph orOf: RectangleMorph) 
				ifTrue: [str color: self regularColor]]! !

!ReferenceMorph methodsFor: 'menu' stamp: 'sw 7/7/1999 12:49'!
useGraphicalTab
	| aGraphic |
	self preserveDetails.
	self color: Color transparent.
	aGraphic := self graphicalMorphForTab.
	self borderWidth: 0.
	self removeAllMorphs.
	self addMorphBack: aGraphic.
	aGraphic position: self position.
	aGraphic lock.
	self fitContents.
	self layoutChanged.
	(owner isKindOf: IndexTabs) ifTrue:
		[owner laySubpartsOutInOneRow.
		isHighlighted ifTrue: [self highlight]].! !

!ReferenceMorph methodsFor: 'menu' stamp: 'sw 10/24/2000 14:39'!
useTextualTab
	"Use a textually-emblazoned tab"

	| aLabel stringToUse font aColor |
	self preserveDetails.
	stringToUse := self valueOfProperty: #priorWording ifAbsent: [self externalName].
	font := self valueOfProperty: #priorFont ifAbsent: [Preferences standardButtonFont].
	aColor := self valueOfProperty: #priorColor ifAbsent: [Color green darker].
	aLabel := StringMorph contents: stringToUse font: font.
	self replaceSubmorph: submorphs first by: aLabel.
	aLabel position: self position.
	self color: aColor.
	aLabel highlightColor: self highlightColor; regularColor: self regularColor.
	aLabel lock.
	self fitContents.
	self layoutChanged.
	(owner isKindOf: IndexTabs) ifTrue:
		[self borderWidth: 0.
		owner laySubpartsOutInOneRow.
		isHighlighted ifTrue:
			[self highlight]]! !

BorderedMorph subclass: #SorterTokenMorph
	instanceVariableNames: 'morphRepresented'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Palettes'!

!SorterTokenMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:35'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color blue! !

!SorterTokenMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:40'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!SorterTokenMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:31'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color transparent! !

!SorterTokenMorph methodsFor: 'as yet unclassified' stamp: 'sw 12/1/1998 12:38'!
fitContents
	submorphs size == 1 ifTrue: [self bounds: (submorphs first bounds insetBy: (-1 @ -1))]! !

!SorterTokenMorph methodsFor: 'as yet unclassified' stamp: 'dgd 2/21/2003 23:16'!
forMorph: aMorph 
	| it |
	morphRepresented := aMorph.
	aMorph submorphs notEmpty 
		ifTrue: 
			[self addMorphBack: (it := aMorph submorphs first veryDeepCopy).
			it position: self position + (1 @ 1).
			it lock].
	self fitContents! !

!SorterTokenMorph methodsFor: 'thumbnail' stamp: 'sw 12/1/1998 12:27'!
morphRepresented
	^ morphRepresented! !

!MenuMorph methodsFor: '*MorphicExtras-accessing' stamp: 'dgd 8/30/2003 20:44'!
allWordings
	"Answer a collection of the wordings of all items and subitems, omitting the window-list in the embed... branch and (unless a certain hard-coded preference is set) also omitting items from the debug menu"

	| verboten |
	verboten := OrderedCollection with: 'embed into'.
	Preferences debugMenuItemsInvokableFromScripts 
		ifFalse:	[verboten add: 'debug...' translated].
	^ self allWordingsNotInSubMenus: verboten! !

!MenuMorph methodsFor: '*MorphicExtras-accessing' stamp: 'sw 10/3/2002 20:11'!
allWordingsNotInSubMenus: verbotenSubmenuContentsList
	"Answer a collection of the wordings of all items and subitems, but omit the stay-up item, and also any items in any submenu whose tag is in verbotenSubmenuContents"

	| aList |
	aList := OrderedCollection new.
	self items do: [:anItem | aList addAll: (anItem allWordingsNotInSubMenus: verbotenSubmenuContentsList)].
	^ aList! !

!CurveMorph class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/11/2003 10:15'!
initialize

	self registerInFlapsRegistry.	! !

!CurveMorph class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/11/2003 10:16'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(CurveMorph		authoringPrototype		'Curve'		'A curve')
						forFlapNamed: 'PlugIn Supplies'.
						cl registerQuad: #(CurveMorph		authoringPrototype		'Curve'		'A curve')
						forFlapNamed: 'Supplies'.]! !

!CurveMorph class methodsFor: '*MorphicExtras-parts bin' stamp: 'nk 8/23/2004 18:11'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'Curvy Arrow'
		categoryList: #('Basic' 'Graphics')
		documentation: 'A curved line with an arrowhead.  Shift-click to get handles and move the points.'
		globalReceiverSymbol: #CurveMorph
		nativitySelector: #arrowPrototype}
! !

!CurveMorph class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/11/2003 12:33'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

!EventHandler methodsFor: '*MorphicExtras-initialization' stamp: 'ar 3/17/2001 20:12'!
adaptToWorld: aWorld
	"If any of my recipients refer to a world or a hand, make them now refer
	to the corresponding items in the new world.  (instVarNamed: is slow, later
	use perform of two selectors.)"

	| value newValue |
	#(mouseDownRecipient mouseStillDownRecipient mouseUpRecipient
	mouseEnterRecipient mouseLeaveRecipient mouseEnterDraggingRecipient
	mouseLeaveDraggingRecipient clickRecipient doubleClickRecipient startDragRecipient keyStrokeRecipient valueParameter) do:
		[:aName |
		(value := self instVarNamed: aName asString) ifNotNil:[
			newValue := value adaptedToWorld: aWorld.
			(newValue notNil and: [newValue ~~ value])
				ifTrue:
					[self instVarNamed: aName asString put: newValue]]]! !

!Form methodsFor: '*MorphicExtras-postscript generation' stamp: 'RAA 4/20/2001 15:40'!
encodePostscriptOn: aStream 
	self unhibernate.

	"since current Postscript support treats 8-bit forms as 0 to 255 gray scale, convert
	to 16 first so we get more faithful results"

	self depth <= 8 ifTrue: [^(self asFormOfDepth: 16) encodePostscriptOn: aStream].

	^ self printPostscript: aStream operator: (self depth = 1
			ifTrue: ['imagemask']
			ifFalse: ['image'])! !

!Form methodsFor: '*MorphicExtras-other' stamp: 'sw 5/3/2001 16:23'!
graphicForViewerTab
	"Answer the graphic to be used in the tab of a viewer open on me"

	^ self! !

PasteUpMorph subclass: #IndexTabs
	instanceVariableNames: 'highlightColor regularColor basicHeight basicWidth verticalPadding fixedWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Palettes'!

!IndexTabs commentStamp: '<historical>' prior: 0!
Used in conjunction wi[th a TabbedPalette -- each TabbedPalette has one.  Each submorph of an IndexTabs is a TabMorph.  When you click on one of the tabs, a corresponding action is taken -- sometimes, the existing palette gets replaced by the new one, other times, the tab results in some selector being invoked; in any case, tab highlighting takes place accordingly.!

!IndexTabs classSide methodsFor: 'printing' stamp: 'sw 7/2/1998 15:16'!
defaultNameStemForInstances
	"Answer a basis for names of default instances of the receiver"
	^ 'tabs'! !

!IndexTabs methodsFor: 'tabs' stamp: 'sw 7/3/1998 11:44'!
addTab: aTab
	self addMorphBack: aTab.
	self laySubpartsOutInOneRow! !

!IndexTabs methodsFor: 'tabs' stamp: 'sw 1/11/2000 11:15'!
addTabFor: aReferent font: aFont
	|  aTab |
	aTab := ReferenceMorph forMorph: aReferent font: aFont.
	self addMorphBack: aTab.
	aTab highlightColor: self highlightColor; regularColor: self regularColor.
	aTab unHighlight.
	self laySubpartsOutInOneRow; layoutChanged.
	^ aTab! !

!IndexTabs methodsFor: 'tabs' stamp: 'sw 12/2/1998 17:53'!
addTabForBook: aBook
	|  aTab |
	aTab := ReferenceMorph forMorph: aBook.
	self addMorphBack: aTab.
	aTab highlightColor: self highlightColor; regularColor: self regularColor.
	aTab unHighlight.
	self laySubpartsOutInOneRow; layoutChanged.
	^ aTab! !

!IndexTabs methodsFor: 'layout' stamp: 'sw 7/3/1998 18:37'!
basicHeight
	^ basicHeight! !

!IndexTabs methodsFor: 'layout' stamp: 'sw 11/30/1998 15:38'!
basicWidth
	basicWidth ifNil: [basicWidth := owner ifNotNil: [owner width] ifNil: [100]].
	^ basicWidth! !

!IndexTabs methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:38'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 0! !

!IndexTabs methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:27'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color
		r: 0.0
		g: 0.6
		b: 0.6! !

!IndexTabs methodsFor: 'layout' stamp: 'sw 1/13/2000 15:18'!
fixedWidth: aWidth
	fixedWidth := aWidth! !

!IndexTabs methodsFor: 'accessing' stamp: 'sw 7/2/1998 14:56'!
highlightColor
	^ highlightColor ifNil: [Color yellow]! !

!IndexTabs methodsFor: 'accessing' stamp: 'sw 7/2/1998 13:29'!
highlightColor: aColor
	highlightColor := aColor! !

!IndexTabs methodsFor: 'highlighting' stamp: 'sw 7/2/1998 13:43'!
highlightColor: color1 regularColor: color2
	"Apply these colors to all of the receiver's tabs"
	highlightColor := color1.
	regularColor := color2.
	self tabMorphs do:
		[:m | m highlightColor: color1.  m regularColor: color2]! !

!IndexTabs methodsFor: 'highlighting' stamp: 'sw 11/30/1998 12:43'!
highlightTab: aTab
	self tabMorphs do:
		[:m | m == aTab
			ifTrue: [m highlight]
			ifFalse: [m unHighlight]]! !

!IndexTabs methodsFor: 'highlighting' stamp: 'sw 11/30/1998 12:44'!
highlightTabFor: aBook
	| theOne |
	self tabMorphs do: [:m |
		(m morphToInstall == aBook)
				ifTrue: [m highlight.  theOne := m]
				ifFalse: [m unHighlight]].
	^ theOne
! !

!IndexTabs methodsFor: 'highlighting' stamp: 'sw 12/2/1998 12:30'!
highlightedTab
	^ self tabMorphs detect: [:m | m isHighlighted] ifNone: [nil]! !

!IndexTabs methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:43'!
initialize
	"Initialize the receiver. Make sure it is not open to drag and  
	drop"
	super initialize.
	""
	padding := 10.
	verticalPadding := 4.
	basicHeight := 14.
	basicWidth := 200.
	
	self enableDragNDrop: false! !

!IndexTabs methodsFor: 'layout' stamp: 'sw 1/19/2000 13:57'!
laySubpartsOutInOneRow
	| aPosition neededHeight widthToUse mid |
	fixedWidth ifNotNil: [self error: 'incompatibility in IndexTabs'].
	verticalPadding ifNil: [verticalPadding := 4].  "for benefit of old structures"
	aPosition := self topLeft.
	neededHeight := self basicHeight.
	submorphs do:
		[:aMorph |
			aMorph position: (aPosition + (padding @ 0)).
			aPosition := aMorph topRight.
			neededHeight := neededHeight max: aMorph height].
	neededHeight := neededHeight + (verticalPadding * 2).
	mid := self top + (neededHeight // 2).
	submorphs do:
		[:aMorph |
			aMorph top: (mid - (aMorph height // 2))].
	widthToUse := self widthImposedByOwner max: self requiredWidth.
	self extent: (((aPosition x + padding - self left) max: widthToUse) @ neededHeight)! !

!IndexTabs methodsFor: 'change reporting' stamp: 'sw 1/13/2000 15:19'!
ownerChanged
	fixedWidth ifNil: [self laySubpartsOutInOneRow]! !

!IndexTabs methodsFor: 'accessing' stamp: 'sw 7/2/1998 14:47'!
regularColor
	^ regularColor ifNil: [Color r: 0.4 g: 0.2 b: 0.6]! !

!IndexTabs methodsFor: 'accessing' stamp: 'sw 7/2/1998 13:29'!
regularColor: aColor
	regularColor := aColor! !

!IndexTabs methodsFor: 'dropping/grabbing' stamp: 'sw 4/27/2000 13:30'!
repelsMorph: aMorph event: evt
	^ false! !

!IndexTabs methodsFor: 'layout' stamp: 'dgd 2/22/2003 13:25'!
requiredWidth
	submorphs isEmpty ifTrue: [^self basicWidth].
	^(submorphs detectSum: [:m | m width]) + (submorphs size * padding)! !

!IndexTabs methodsFor: 'layout' stamp: 'sw 1/13/2000 15:50'!
rowsNoWiderThan: maxWidth
	| aPosition neededHeight |
	self fixedWidth: maxWidth.
	verticalPadding ifNil: [verticalPadding := 4].  "for benefit of old structures"
	aPosition := self topLeft.
	neededHeight := self basicHeight.
	submorphs do:
		[:aMorph |
			aMorph position: (aPosition + (padding @ 0)).
			(aMorph right > (self left + maxWidth)) ifTrue:
				[aPosition := self left @ (aPosition y + neededHeight).
				aMorph position: aPosition + (padding @ 0).
				neededHeight := self basicHeight].
			aPosition := aMorph topRight.
			neededHeight := neededHeight max: aMorph height].
	self extent: (maxWidth @ ((aPosition y + neededHeight) - self top))! !

!IndexTabs methodsFor: 'selection' stamp: 'sw 7/3/1998 18:43'!
selectTab: aTab
	| aWorld |
	(aWorld := self world) ifNotNil: [aWorld abandonAllHalos].  "nil can happen at init time"
	self highlightTab: aTab.
! !

!IndexTabs methodsFor: 'tabs' stamp: 'marcus.denker 9/24/2008 21:48'!
tabMorphs
	"Presently all the submorphs are ReferenceMorphs, but this still supports an earlier design where spacers are interleaved, and where the old TabMorph class was used"

	^ submorphs select: [:m | m isKindOf: ReferenceMorph]! !

!IndexTabs methodsFor: 'layout' stamp: 'dgd 2/22/2003 13:25'!
widthImposedByOwner
	((owner isNil or: [owner isWorldOrHandMorph]) 
		or: [owner submorphs size < 2]) ifTrue: [^self basicWidth].
	^owner submorphs second width! !

PasteUpMorph subclass: #PartsBin
	instanceVariableNames: ''
	classVariableNames: 'Thumbnails'
	poolDictionaries: ''
	category: 'MorphicExtras-PartsBin'!

!PartsBin classSide methodsFor: 'thumbnail cache' stamp: 'sw 8/12/2001 17:44'!
cacheAllThumbnails
	"In one monster operation, cache all the thumbnails of parts.  Intended to be called from do-its in update postscripts, for example, or manually."

	Cursor wait showWhile:
		[Morph withAllSubclasses do: [:aClass |
			(aClass class includesSelector: #descriptionForPartsBin) ifTrue:
				[self thumbnailForPartsDescription: aClass descriptionForPartsBin].
			(aClass class includesSelector: #supplementaryPartsDescriptions) ifTrue:
				[aClass supplementaryPartsDescriptions do:
					[:aDescription | self thumbnailForPartsDescription: aDescription]]]]

"Time millisecondsToRun: [PartsBin initialize. PartsBin cacheAllThumbnails]"
! !

!PartsBin classSide methodsFor: 'thumbnail cache' stamp: 'sw 7/12/2001 19:06'!
cacheThumbnail: aThumbnail forSymbol: aSymbol
	"Cache the thumbnail provided as the graphic representing a parts-bin denizen whose name is the given symbol"

	Thumbnails at: aSymbol put: aThumbnail! !

!PartsBin classSide methodsFor: 'thumbnail cache' stamp: 'sw 7/12/2001 18:56'!
clearThumbnailCache
	"Clear the cache of thumbnails:
		PartsBin clearThumbnailCache
"

	Thumbnails := Dictionary new! !

!PartsBin classSide methodsFor: 'class initialization' stamp: 'sw 7/12/2001 19:07'!
initialize
	"Initialize the PartsBin class, by starting it out with an empty Thumbnails dictionary"

	Thumbnails := Dictionary new
	"PartsBin initialize"! !

!PartsBin classSide methodsFor: 'class initialization' stamp: 'tak 8/3/2005 18:32'!
localeChanged
	self initialize! !

!PartsBin classSide methodsFor: 'instance creation' stamp: 'nk 8/31/2004 18:51'!
newPartsBinWithOrientation: aListDirection andColor: aColor from: quadList 
	"Answer a new PartBin object, to run horizontally or vertically,  
	obtaining its elements from the list of tuples of the form:  
	(<receiver> <selector> <label> <balloonHelp>)"
	^ (self new)
		color: aColor;
		listDirection: aListDirection quadList: (self translatedQuads: quadList).! !

!PartsBin classSide methodsFor: 'instance creation' stamp: 'dgd 8/26/2004 12:24'!
newPartsBinWithOrientation: aListDirection from: quadList 
	"Answer a new PartBin object, to run horizontally or vertically,  
	obtaining its elements from the list of tuples of the form:  
	(<receiver> <selector> <label> <balloonHelp>)"
	^ self new
		listDirection: aListDirection
		quadList: (self translatedQuads: quadList) ! !

!PartsBin classSide methodsFor: 'thumbnail cache' stamp: 'sw 7/12/2001 19:06'!
thumbnailForInstanceOf: aMorphClass
	"Answer a thumbnail for a stand-alone instance of the given class, creating it if necessary.  If it is created afresh, it will also be cached at this time"

	| aThumbnail |
	^ Thumbnails at: aMorphClass name ifAbsent:
		[aThumbnail := Thumbnail new makeThumbnailFromForm: aMorphClass newStandAlone imageForm.
		self cacheThumbnail: aThumbnail forSymbol: aMorphClass name.
		^ aThumbnail]

"PartsBin initialize"! !

!PartsBin classSide methodsFor: 'thumbnail cache' stamp: 'sw 10/24/2001 15:29'!
thumbnailForPartsDescription: aPartsDescription
	"Answer a thumbnail for the given parts description creating it if necessary.  If it is created afresh, it will also be cached at this time"

	| aThumbnail aSymbol |
	aSymbol := aPartsDescription formalName asSymbol.
	^ Thumbnails at: aSymbol ifAbsent:
		[aThumbnail := Thumbnail new makeThumbnailFromForm: aPartsDescription sampleImageForm.
		self cacheThumbnail: aThumbnail forSymbol: aSymbol.
		^ aThumbnail]

"PartsBin initialize"! !

!PartsBin classSide methodsFor: 'thumbnail cache' stamp: 'nk 9/1/2004 17:38'!
thumbnailForQuad: aQuint
	"Answer a thumbnail for a morph obtaining as per the quintuplet provided, creating the thumbnail if necessary.  If it is created afresh, it will also be cached at this time"
	^self thumbnailForQuad: aQuint color: Color transparent.! !

!PartsBin classSide methodsFor: 'thumbnail cache' stamp: 'nk 9/1/2004 17:44'!
thumbnailForQuad: aQuint color: aColor
	"Answer a thumbnail for a morph obtaining as per the quintuplet provided, creating the thumbnail if necessary.  If it is created afresh, it will also be cached at this time"

	| aThumbnail aSymbol formToThumbnail labeledItem |
	aSymbol := aQuint third.
	Thumbnails at: aSymbol ifPresent: [ :thumb | ^thumb ].
	formToThumbnail := aQuint at: 5 ifAbsent: [].
	formToThumbnail ifNil: [
		labeledItem := (Smalltalk at: aQuint first) perform: aQuint second.
		formToThumbnail := labeledItem imageForm: 32 backgroundColor: aColor forRectangle: labeledItem fullBounds.
		formToThumbnail replaceColor: aColor withColor: Color transparent.
	].

	aThumbnail := Thumbnail new makeThumbnailFromForm: formToThumbnail.
	self cacheThumbnail: aThumbnail forSymbol: aSymbol.
	^ aThumbnail

"PartsBin initialize"! !

!PartsBin classSide methodsFor: 'private' stamp: 'dgd 8/26/2004 12:23'!
translatedQuads: quads
	"private - convert the given quads to a translated one"
	
	| translatedQuads |

	translatedQuads := quads collect: [:each |
		| element |
		element := each copy. 
		element at: 3 put: each third translated.
		element at: 4 put: each fourth translated.
		element.
	].

	^ translatedQuads
! !

!PartsBin methodsFor: 'properties' stamp: 'dgd 8/30/2003 15:52'!
innocuousName
	"Answer a harmless name for an unnamed instance"

	^ 'parts bin' translated! !

!PartsBin methodsFor: 'initialization' stamp: 'nk 9/1/2004 17:28'!
listDirection: aListDirection quadList: quadList
	"Initialize the receiver to run horizontally or vertically, obtaining its elements from the list of tuples of the form:
		(<receiver> <selector> <label> <balloonHelp>)"

	| aButton aClass |
	self layoutPolicy: TableLayout new.
	self listDirection: aListDirection.
	self wrapCentering: #topLeft.
	self layoutInset: 2.
	self cellPositioning: #bottomCenter.

	aListDirection == #leftToRight
		ifTrue:
			[self vResizing: #rigid.
			self hResizing: #spaceFill.
			self wrapDirection: #topToBottom]
		ifFalse:
			[self hResizing: #rigid.
			self vResizing: #spaceFill.
			self wrapDirection: #leftToRight].
	quadList do:
		[:tuple |
			aClass := Smalltalk at: tuple first.
			aButton := IconicButton new initializeWithThumbnail: (self class thumbnailForQuad: tuple color: self color) withLabel: tuple third andColor: self color andSend: tuple second to: aClass.
			(tuple size > 3 and: [tuple fourth isEmptyOrNil not]) ifTrue:
				[aButton setBalloonText: tuple fourth].
 			self addMorphBack: aButton]! !

!PartsBin methodsFor: 'initialization' stamp: 'nk 9/1/2004 20:09'!
listDirection: aListDirection quadList: quadList buttonClass: buttonClass
	"Initialize the receiver to run horizontally or vertically, obtaining its elements from the list of tuples of the form:
		(<receiver> <selector> <label> <balloonHelp>)"

	| aButton aClass |
	self layoutPolicy: TableLayout new.
	self listDirection: aListDirection.
	self wrapCentering: #topLeft.
	self layoutInset: 2.
	self cellPositioning: #bottomCenter.

	aListDirection == #leftToRight
		ifTrue:
			[self vResizing: #rigid.
			self hResizing: #spaceFill.
			self wrapDirection: #topToBottom]
		ifFalse:
			[self hResizing: #rigid.
			self vResizing: #spaceFill.
			self wrapDirection: #leftToRight].
	quadList do:
		[:tuple |
			aClass := Smalltalk at: tuple first.
			aButton := buttonClass new initializeWithThumbnail: (self class thumbnailForQuad: tuple color: self color) withLabel: tuple third andColor: self color andSend: tuple second to: aClass.
			(tuple size > 3 and: [tuple fourth isEmptyOrNil not]) ifTrue:
				[aButton setBalloonText: tuple fourth].
 			self addMorphBack: aButton]! !

!PartsBin methodsFor: 'dropping/grabbing' stamp: 'sw 4/22/2005 21:55'!
morphToDropFrom: aMorph
	"Answer the morph to drop if the user attempts to drop aMorph"

	| aButton |
	((aMorph isKindOf: IconicButton) and: [aMorph actionSelector == #launchPartVia:label:])
		ifTrue: [^ aMorph].  
	"The above handles the unusual case of a button that's already set up in a manner suitable for living in PartsBin; the archetypal example is the attempt to reposition an object within a partsflap by dragging it via the black halo handle."

	aButton := IconicButton new.
	aButton color: self color;
		initializeToShow: aMorph withLabel: aMorph externalName andSend: #veryDeepCopy to: aMorph veryDeepCopy.
	^ aButton! !

!PartsBin methodsFor: 'dropping/grabbing' stamp: 'sw 6/13/2001 17:47'!
wantsDroppedMorph: aMorph event: evt
	"Answer whether the receiver would like to accept the given morph.  For a Parts bin, we accept just about anything except something that just originated from ourselves"

	(aMorph hasProperty: #beFullyVisibleAfterDrop) ifTrue:
		["Sign that this was launched from a parts bun, probably indeed this very parts bin"
		^ false].

	^ super wantsDroppedMorph: aMorph event: evt! !

!PartsBin methodsFor: 'event handling' stamp: 'dgd 9/27/2004 13:56'!
wantsEasySelection
	"Answer if the receiver want easy selection mode"
	^ false! !

!PasteUpMorph class methodsFor: '*MorphicExtras-scripting' stamp: 'sw 10/3/2004 01:14'!
additionsToViewerCategories
	"Answer a list of (<categoryName> <list of category specs>) pairs that characterize the phrases this kind of morph wishes to add to various Viewer categories."

	^ # (

(playfield (
(command initiatePainting 'Initiate painting of a new object in the standard playfield.')
(slot mouseX 'The x coordinate of the mouse pointer' Number readWrite Player getMouseX  unused unused)
(slot mouseY 'The y coordinate of the mouse pointer' Number readWrite Player getMouseY  unused unused)
(command roundUpStrays 'Bring all out-of-container subparts back into view.')
(slot graphic 'The graphic shown in the background of this object' Graphic readWrite Player getGraphic Player setGraphic:)
(command unhideHiddenObjects 'Unhide all hidden objects.')))

(scripting (
(command tellAllContents: 'Send a message to all the objects inside the playfield' ScriptName)))

(collections (
(slot cursor 'The index of the chosen element' Number readWrite Player getCursor Player setCursorWrapped:)
(slot count 'How many elements are within me' Number readOnly Player getCount unused unused)
(slot stringContents 'The characters of the objects inside me, laid end to end' String readOnly Player getStringContents unused unused)
(slot playerAtCursor 'the object currently at the cursor' Player readWrite Player getValueAtCursor  unused unused)
(slot firstElement  'The first object in my contents' Player  readWrite Player getFirstElement  Player  setFirstElement:)
(slot numberAtCursor 'the number at the cursor' Number readWrite Player getNumberAtCursor Player setNumberAtCursor: )
(slot graphicAtCursor 'the graphic worn by the object at the cursor' Graphic readOnly Player getGraphicAtCursor  unused unused)
(command tellAllContents: 'Send a message to all the objects inside the playfield' ScriptName)
(command removeAll 'Remove all elements from the playfield')
(command shuffleContents 'Shuffle the contents of the playfield')
(command append: 'Add the object to the end of my contents list.' Player)
(command prepend: 'Add the object at the beginning of my contents list.' Player)
(command includeAtCursor: 'Add the object to my contents at my current cursor position' Player)
(command include: 'Add the object to my contents' Player)
))

(#'stack navigation' (
(command goToNextCardInStack 'Go to the next card')
(command goToPreviousCardInStack  'Go to the previous card')
(command goToFirstCardInBackground 'Go to the first card of the current background')
(command goToFirstCardOfStack 'Go to the first card of the entire stack')
(command goToLastCardInBackground 'Go to the last card of the current background')
(command goToLastCardOfStack 'Go to the last card of the entire stack')
(command deleteCard 'Delete the current card')
(command insertCard 'Create a new card')))

"(viewing (
(slot viewingNormally 'whether contents are viewed normally' Boolean readWrite Player getViewingByIcon Player setViewingByIcon: )))"

(#'pen trails' (
(command liftAllPens 'Lift the pens on all the objects in my interior.')
(command lowerAllPens  'Lower the pens on all the objects in my interior.')
(command trailStyleForAllPens:  'Set the trail style for pens of all objects within' TrailStyle)
(command clearTurtleTrails 'Clear all the pen trails in the interior.'))))
! !

!PasteUpMorph class methodsFor: '*MorphicExtras-class initialization' stamp: 'nk 12/13/2004 18:22'!
initialize
	"Initialize the class"

	self registerInFlapsRegistry.	
	ScriptingSystem addCustomEventFor: self named: #keyStroke help: 'when a keystroke happens and nobody heard it' targetMorphClass: PasteUpMorph.! !

!PasteUpMorph class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/11/2003 10:10'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(PasteUpMorph			authoringPrototype		'Playfield'		'A place for assembling parts or for staging animations')
						forFlapNamed: 'PlugIn Supplies'.
						cl registerQuad: #(PasteUpMorph			authoringPrototype		'Playfield'		'A place for assembling parts or for staging animations')
						forFlapNamed: 'Supplies'.
						cl registerQuad: #(PasteUpMorph			authoringPrototype		'Playfield'		'A place for assembling parts or for staging animations')
						forFlapNamed: 'Scripting']! !

!PasteUpMorph class methodsFor: '*MorphicExtras-parts bin' stamp: 'sw 8/2/2001 16:29'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'Holder'
		categoryList: #(Scripting)
		documentation: 'A place for storing alternative pictures in an animation, ec.'
		globalReceiverSymbol: #ScriptingSystem
		nativitySelector: #prototypicalHolder}! !

!PasteUpMorph class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/11/2003 12:38'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

!PasteUpMorph methodsFor: '*MorphicExtras-flaps' stamp: 'dgd 4/3/2006 14:41'!
deleteAllFlapArtifacts
	"self currentWorld deleteAllFlapArtifacts"

	self submorphs do:[:m | m wantsToBeTopmost ifTrue:[m delete]].! !

!PasteUpMorph methodsFor: '*morphicextras-world menu' stamp: 'sw 7/23/2002 16:19'!
findAPreferencesPanel: evt
	"Locate a Preferences Panel, open it, and bring it to the front.  Create one if necessary"

	| aPanel |
	self findAWindowSatisfying:
		[:aWindow | aWindow model isKindOf: PreferencesPanel] orMakeOneUsing:
			[aPanel _ Preferences preferencesControlPanel.
			"Note -- we don't really want the openInHand -- but owing to some annoying
			difficulty, if we don't, we get the wrong width.  Somebody please clean this up"
			^ aPanel openInHand]! !

!PasteUpMorph methodsFor: '*MorphicExtras-misc' stamp: 'dgd 4/3/2006 14:33'!
roundUpStrays
	self submorphs
		reject: [:each | each wantsToBeTopmost]
		thenDo: [:each | each goHome].
	super roundUpStrays! !

PasteUpMorph subclass: #ZASMScriptMorph
	instanceVariableNames: 'somethingChanged'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!ZASMScriptMorph methodsFor: 'layout' stamp: 'RAA 12/3/2000 09:56'!
acceptDroppingMorph: aMorph event: evt

	super acceptDroppingMorph: aMorph event: evt.
	somethingChanged := true.
	! !

!ZASMScriptMorph methodsFor: 'menus' stamp: 'dgd 8/30/2003 22:32'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addLine.
	aCustomMenu add: 'save script' translated action: #saveScript.

! !

!ZASMScriptMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/3/2000 11:18'!
compileScript

	| newScript prevMark prevSteps data |

	self fixup.
	newScript := OrderedCollection new.
	prevMark := prevSteps := nil.
	submorphs do: [ :each |
		(each isKindOf: ZASMCameraMarkMorph) ifTrue: [
			prevMark ifNotNil: [
				data := Dictionary new.
				data 
					at: #steps put: prevSteps;
					at: #startPoint put: (prevMark valueOfProperty: #cameraPoint);
					at: #endPoint put: (each valueOfProperty: #cameraPoint);
					at: #startZoom put: (prevMark valueOfProperty: #cameraScale);
					at: #endZoom put: (each valueOfProperty: #cameraScale).
				newScript add: data.
			].
			prevMark := each.
		].
		(each isKindOf: ZASMStepsMorph) ifTrue: [
			prevSteps := each getStepCount.
		].
	].
	^newScript
! !

!ZASMScriptMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/3/2000 12:03'!
decompileScript: aScript named: aString for: aController

	| newMorphs prevPt prevScale cameraPoint cameraScale mark |

	self removeAllMorphs.
	self setProperty: #cameraController toValue: aController.
	self setProperty: #cameraScriptName toValue: aString.

	newMorphs := OrderedCollection new.
	prevPt := prevScale := nil.
	aScript do: [ :each |
		cameraPoint := each at: #startPoint ifAbsent: [nil].
		cameraScale := each at: #startZoom ifAbsent: [nil].
		(prevPt = cameraPoint and: [prevScale = cameraScale]) ifFalse: [
			mark := ZASMCameraMarkMorph new.
			mark cameraPoint: cameraPoint cameraScale: cameraScale controller: aController.
			newMorphs add: mark.
		].
		newMorphs add: (ZASMStepsMorph new setStepCount: (each at: #steps ifAbsent: [10])).
		cameraPoint := each at: #endPoint ifAbsent: [nil].
		cameraScale := each at: #endZoom ifAbsent: [nil].
		mark := ZASMCameraMarkMorph new.
		mark cameraPoint: cameraPoint cameraScale: cameraScale controller: aController.
		newMorphs add: mark.
		prevPt := cameraPoint.
		prevScale := cameraScale.
	].
	self addAllMorphs: newMorphs.
! !

!ZASMScriptMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:35'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color blue! !

!ZASMScriptMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:40'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 2! !

!ZASMScriptMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:32'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color lightBlue! !

!ZASMScriptMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/3/2000 11:16'!
fixup

	| newMorphs state fixed |

	somethingChanged := false.
	newMorphs := OrderedCollection new.
	state := #new.
	fixed := false.
	submorphs do: [ :each |
		(each isKindOf: ZASMCameraMarkMorph) ifTrue: [
			state == #mark ifTrue: [
				newMorphs add: (
					ZASMStepsMorph new setStepCount: 10
				).
				fixed := true.
			].
			newMorphs add: each.
			state := #mark.
		].
		(each isKindOf: ZASMStepsMorph) ifTrue: [
			state == #steps ifTrue: [
				fixed := true.
			] ifFalse: [
				newMorphs add: each.
				state := #steps.
			].
		].
	].
	fixed ifTrue: [
		self removeAllMorphs.
		self addAllMorphs: newMorphs.
	].! !

!ZASMScriptMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:46'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	somethingChanged := true.
	self dragEnabled: true;
		 layoutPolicy: TableLayout new;
		 listDirection: #topToBottom;
		 wrapCentering: #topLeft;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 layoutInset: 6;
		
		 rubberBandCells: true! !

!ZASMScriptMorph methodsFor: 'layout' stamp: 'RAA 12/3/2000 09:33'!
layoutChanged

	super layoutChanged.
	somethingChanged := true.

	! !

!ZASMScriptMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/3/2000 12:02'!
saveScript

	| newScript scriptName |
	newScript := self compileScript.
	scriptName := FillInTheBlank 
		request: 'Name this script' 
		initialAnswer: (self valueOfProperty: #cameraScriptName ifAbsent: ['']).
	scriptName isEmptyOrNil ifTrue: [^self].
	(self valueOfProperty: #cameraController)
		saveScript: newScript
		as: scriptName.
	self delete.! !

!ZASMScriptMorph methodsFor: 'stepping and presenter' stamp: 'RAA 12/3/2000 10:36'!
step

	super step.
	somethingChanged ifFalse: [^self].
	self fixup.
! !

!ZASMScriptMorph methodsFor: 'testing' stamp: 'RAA 12/3/2000 09:53'!
stepTime

	^500! !

!ZASMScriptMorph methodsFor: 'dropping/grabbing' stamp: 'RAA 12/3/2000 09:02'!
wantsDroppedMorph: aMorph event: evt

	^aMorph isKindOf: ZASMCameraMarkMorph! !

!ZASMScriptMorph methodsFor: 'testing' stamp: 'RAA 12/3/2000 09:49'!
wantsSteps

	^true! !

!Color methodsFor: '*MorphicExtras-*morphic-Postscript Canvases' stamp: ''!
encodePostscriptOn: aStream

	aStream setrgbcolor:self.

! !

!TransformMorph methodsFor: '*MorphicExtras-accessing' stamp: 'sps 12/28/2002 02:09'!
quickAddAllMorphs: aCollection
"A fast add of all the morphs for the PluggableListMorph>>list: method to use -- assumes that fullBounds will get called later by the sender, so it avoids doing any updating on the morphs in aCol or updating layout of this scroller. So the sender should handle those tasks as appropriate"

	| myWorld itsWorld |
	myWorld := self world.
	aCollection do: [:m |
		m owner ifNotNil: [
			itsWorld := m world.
			itsWorld == myWorld ifFalse: [m outOfWorld: itsWorld].
			m owner privateRemoveMorph: m].
		m privateOwner: self.
		"inWorld ifTrue: [self addedOrRemovedSubmorph: m]."
		itsWorld == myWorld ifFalse: [m intoWorld: myWorld].
		].
	submorphs := aCollection.
	"self layoutChanged."

! !

TransformMorph subclass: #ZoomMorph
	instanceVariableNames: 'fromMorph toMorph boundsSeq finalAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!ZoomMorph classSide methodsFor: 'new-morph participation' stamp: 'di 10/6/1998 13:15'!
includeInNewMorphMenu
	"Zooms aren't meaningful without initializations"
	^ false! !

!ZoomMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:32'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color transparent! !

!ZoomMorph methodsFor: 'stepping and presenter' stamp: ''!
step

	boundsSeq isEmpty ifTrue:
		["If all done, then grant one final request and vanish"
		finalAction value.
		^ self delete].

	"Otherwise, zoom to the next rectangle"
	self zoomTo: boundsSeq removeFirst! !

!ZoomMorph methodsFor: 'testing' stamp: ''!
stepTime

	^ 40! !

!ZoomMorph methodsFor: 'as yet unclassified' stamp: ''!
zoomFromMorph: m1 toMorph: m2 andThen: actionBlock
	| nSteps topLeft r2 r1 extent ratio r mouthDeltas |
	fromMorph := m1.
	toMorph := m2.
	r1 := fromMorph fullBounds.
	r2 := toMorph fullBounds.
	finalAction := actionBlock.
	nSteps := 8.
	boundsSeq := OrderedCollection new.
	r := (1/nSteps) asFloat.
	ratio := r.
r1 := 105@326 corner: 130@348.
mouthDeltas := {-7@24. -6@21. -6@18. -4@14. -4@10. -3@8. -3@3. 0@0}.
	1 to: nSteps do:
		[:i | topLeft := ((r2 topLeft - r1 topLeft) * ratio) asIntegerPoint + r1 topLeft.
		extent := ((r2 extent - r1 extent) * ratio) asIntegerPoint + r1 extent.
		boundsSeq addLast: (topLeft + (mouthDeltas at: i) extent: extent).
		ratio := ratio + r].
	self addMorph: toMorph.
	self step! !

!ZoomMorph methodsFor: 'as yet unclassified' stamp: ''!
zoomTo: newBounds
	| scale |
	self bounds: newBounds.
	scale := newBounds extent / toMorph fullBounds extent.
	self setOffset: toMorph position - self position angle: 0.0 scale: scale! !

!ServerDirectory methodsFor: '*MorphicExtras-accessing' stamp: 'tk 1/25/1999 15:12'!
url
	"This was mis-named at the beginning.  Eventually convert over to altUrl and use this for the real url."
	^ self realUrl! !

!Canvas methodsFor: '*MorphicExtras-drawing' stamp: 'ls 3/19/2000 15:12'!
paragraph2: para bounds: bounds color: c

	| scanner |
	scanner := CanvasCharacterScanner new.
	scanner
		 canvas: self;
		text: para text textStyle: para textStyle;
		textColor: c.

	para displayOn: self using: scanner at: bounds topLeft.
! !

Canvas subclass: #PostscriptCanvas
	instanceVariableNames: 'origin clipRect currentColor shadowColor currentFont morphLevel gstateStack fontMap usedFonts psBounds topLevelMorph initialScale savedMorphExtent currentTransformation printSpecs pages'
	classVariableNames: 'FontMap'
	poolDictionaries: ''
	category: 'MorphicExtras-Postscript Canvases'!

!PostscriptCanvas commentStamp: '<historical>' prior: 0!
I am a canvas that converts Morphic drawing messages into Postscript.  The canvas itself does not actually generate the Postscript code, but rather sends messages corresponding 1:1 to the Postscript imaging model to its target (default: PostscriptEncoder), which has the job of generating actual drawing commands.

PostscriptCharacterScanner and PostscriptDummyWarp are helper classes that simulate effects currently implemented via BitBlt-specific mechanisms during Postscript generation.  They should be going away as Morphic becomes fully device independent.

!

PostscriptCanvas subclass: #DSCPostscriptCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Postscript Canvases'!

!DSCPostscriptCanvas commentStamp: '<historical>' prior: 0!
I generate multi-page Postscript files, for example of Book morphs.  The goal is to crete Adobe Document Structuring Conventions compliant, but this is currently not the case.
!

!DSCPostscriptCanvas methodsFor: 'page geometry' stamp: 'mpw 9/15/1999 20:14'!
defaultImageableArea
	^ self defaultPageSize insetBy:self defaultMargin.
! !

!DSCPostscriptCanvas methodsFor: 'page geometry' stamp: 'di 8/3/2000 14:18'!
defaultMargin  "In Points"
	^ (0.25 * 72) asInteger.
! !

!DSCPostscriptCanvas methodsFor: 'page geometry' stamp: 'di 8/5/2000 22:56'!
defaultPageSize
	" This is Letter size in points.  European A4 is 595 @ 842 "
	^ 0 @ 0 extent: ((8.5 @ 11.0) * 72) asIntegerPoint.
! !

!DSCPostscriptCanvas methodsFor: 'morph drawing' stamp: 'nk 1/2/2004 16:53'!
endGStateForMorph: aMorph 
	"position the morph on the page "
	morphLevel
			== (topLevelMorph pagesHandledAutomatically
					ifTrue: [2]
					ifFalse: [1])
		ifTrue:  [ target showpage; print: 'grestore'; cr  ]! !

!DSCPostscriptCanvas methodsFor: 'drawing-general' stamp: 'nk 1/2/2004 16:53'!
fullDraw: aMorph 
	(morphLevel = 0 and: [aMorph pagesHandledAutomatically not]) 
		ifTrue: 
			[pages := pages + 1.
			target
				print: '%%Page: 1 1';
				cr].
	super fullDraw: aMorph.
	morphLevel = 0 
		ifTrue: 
			[ self writeTrailer: pages. ]! !

!DSCPostscriptCanvas methodsFor: 'morph drawing' stamp: 'nk 6/10/2004 13:19'!
fullDrawBookMorph: aBookMorph
	" draw all the pages in a book morph, but only if it is the top-level morph "

	morphLevel = 1 ifFalse: [^ super fullDrawBookMorph: aBookMorph].

	"Unfortunately, the printable 'pages' of a StackMorph are the cards, but for a BookMorph, they are the pages.  Separate the cases here."
	(aBookMorph isKindOf: StackMorph) 
		ifTrue: [
			aBookMorph cards do: [:aCard |
				aBookMorph goToCard: aCard.	"cause card-specific morphs to be installed"
				pages := pages + 1.
				target print: '%%Page: '; write: pages; space; write: pages; cr.
				self drawPage: aBookMorph currentPage]]
		ifFalse: [
			aBookMorph pages do: [:aPage |
				pages := pages + 1.
				target print: '%%Page: '; write: pages; space; write: pages; cr.
				self drawPage: aPage]].
	morphLevel = 0 ifTrue: [ self writeTrailer: pages ].
! !

!DSCPostscriptCanvas methodsFor: 'page geometry' stamp: 'nk 1/1/2004 19:56'!
pageBBox
	| pageSize offset bbox trueExtent |
	trueExtent := savedMorphExtent * initialScale.
	"this one has been rotated"
	pageSize := self defaultPageSize.
	offset := pageSize extent - trueExtent / 2 max: 0 @ 0.
	bbox := offset extent: trueExtent.
	^ bbox! !

!DSCPostscriptCanvas methodsFor: 'page geometry' stamp: 'nk 12/30/2003 17:22'!
pageOffset
	^self pageBBox origin.
! !

!DSCPostscriptCanvas methodsFor: 'morph drawing' stamp: 'nk 1/1/2004 18:21'!
setupGStateForMorph: aMorph 
	"position the morph on the page "
	morphLevel
			== (topLevelMorph pagesHandledAutomatically
					ifTrue: [2]
					ifFalse: [1])
		ifTrue:  [ self writePageSetupFor: aMorph ]! !

!DSCPostscriptCanvas methodsFor: 'initialization' stamp: 'on 5/10/2008 15:10'!
writePSIdentifierRotated: rotateFlag 
	| morphExtent pageExtent |
	target print: '%!!PS-Adobe-2.0'; cr;
		 print: '%%Pages: (atend)'; cr;
		 print: '%%DocumentFonts: (atend)'; cr.
	"Define initialScale so that the morph will fit the page rotated or not"
	savedMorphExtent := morphExtent := rotateFlag
						ifTrue: [psBounds extent transposed]
						ifFalse: [psBounds extent].
	pageExtent := self defaultImageableArea extent asFloatPoint.
	initialScale := (printSpecs isNil
					or: [printSpecs scaleToFitPage])
				ifTrue: [pageExtent x / morphExtent x min: pageExtent y / morphExtent y]
				ifFalse: [1.0].
	target print: '%%BoundingBox: ';
		 write: self defaultImageableArea; cr.
	target print: '%%Title: '; print: self topLevelMorph externalName; cr.
	target print: '%%Creator: '; print: Author fullName; cr.
	target print: '%%CreationDate: '; print: Date today asString; space; print: Time now asString; cr.

	target print: '%%Orientation: ';
		
		print: (rotateFlag
				ifTrue: ['Landscape']
				ifFalse: ['Portrait']); cr.
	target print: '%%EndComments'; cr.
! !

DSCPostscriptCanvas subclass: #DSCPostscriptCanvasToDisk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Postscript Canvases'!

!DSCPostscriptCanvasToDisk classSide methodsFor: 'configuring' stamp: 'RAA 9/16/2000 22:14'!
defaultTarget

	^PostscriptEncoderToDisk stream.
! !

!DSCPostscriptCanvasToDisk classSide methodsFor: 'testing' stamp: 'RAA 2/22/2001 07:41'!
morphAsPostscript: aMorph rotated: rotateFlag offsetBy: offset

	^self morphAsPostscript: aMorph rotated: rotateFlag offsetBy: offset specs: nil
! !

!DSCPostscriptCanvasToDisk classSide methodsFor: 'as yet unclassified' stamp: 'nk 12/30/2003 16:58'!
morphAsPostscript: aMorph rotated: rotateFlag offsetBy: offset specs: specsOrNil

	| newFileName stream |

	^[
		(self new morphAsPostscript: aMorph rotated: rotateFlag offsetBy: offset) close
	]
		on: PickAFileToWriteNotification
		do: [ :ex |
			newFileName := FillInTheBlank
				request: 'Name of file to write:' translated
				initialAnswer: 'xxx',Time millisecondClockValue printString, self defaultExtension. 
			newFileName isEmptyOrNil ifFalse: [
				stream := FileStream fileNamed: newFileName.
				stream ifNotNil: [ex resume: stream].
			].
		].

! !

!DSCPostscriptCanvasToDisk classSide methodsFor: 'as yet unclassified' stamp: 'RAA 2/22/2001 07:43'!
morphAsPostscript: aMorph rotated: rotateFlag specs: specsOrNil

	^ self morphAsPostscript: aMorph rotated: rotateFlag offsetBy: self baseOffset specs: specsOrNil
! !

!DSCPostscriptCanvasToDisk methodsFor: 'as yet unclassified' stamp: 'RAA 2/22/2001 07:41'!
morphAsPostscript: aMorph rotated: rotateFlag offsetBy: offset

	^self morphAsPostscript: aMorph rotated: rotateFlag offsetBy: offset specs: nil
! !

!DSCPostscriptCanvasToDisk methodsFor: 'as yet unclassified' stamp: 'nk 12/30/2003 17:39'!
morphAsPostscript: aMorph rotated: rotateFlag offsetBy: offset specs: specsOrNil 
	self reset.
	psBounds := offset extent: aMorph bounds extent.
	topLevelMorph := aMorph.
	self writeHeaderRotated: rotateFlag.
	self fullDrawMorph: aMorph.
	^ self close! !

PostscriptCanvas subclass: #EPSCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Postscript Canvases'!

!EPSCanvas commentStamp: '<historical>' prior: 0!
I am a canvas for generating Encapsulates PostScript (EPS) files from single morphs, for example for screen-dumps.

I make sure that the bounding box of the EPS surrounds exactly the morph, and am not capable of generating multiple pages.  I do not generate an on-screen Preview for the EPS file, though that should be possible.
!

!EPSCanvas classSide methodsFor: 'configuring' stamp: 'nk 12/29/2003 13:19'!
defaultExtension
	^'.eps'! !

!EPSCanvas methodsFor: 'drawing-general' stamp: 'nk 1/2/2004 16:53'!
fullDraw: aMorph
	super fullDraw: aMorph.
	morphLevel = 0 ifTrue: [
		self writeTrailer: 1.
	]! !

!EPSCanvas methodsFor: 'page geometry' stamp: 'nk 1/1/2004 18:29'!
pageBBox
	^psBounds! !

!EPSCanvas methodsFor: 'page geometry' stamp: 'nk 1/1/2004 20:22'!
pageOffset
	^0@0! !

!EPSCanvas methodsFor: 'private' stamp: 'nk 1/1/2004 12:48'!
writeEPSPreviewImageFor: aMorph
	| form stream string lines newExtent |
	newExtent := (aMorph width roundUpTo: 8) @ aMorph height.
	form := aMorph imageForm: 1 forRectangle: (aMorph bounds origin extent: newExtent).
	stream := RWBinaryOrTextStream on: (String new: (form bits byteSize * 2.04) asInteger).
	form storePostscriptHexOn: stream.
	string := stream contents.
	lines := string occurrencesOf: Character cr.

	"%%BeginPreview: 80 24 1 24"
	"width height depth "
	target print: '%%BeginPreview: '; write:  newExtent; space; write: form depth; space; write: lines; cr.

	stream position: 0.
	[ stream atEnd ] whileFalse: [
		target nextPut: $%; nextPutAll: (stream upTo: Character cr); cr.
		lines := lines - 1.
	].

	target print: '%%EndPreview'; cr.

! !

!EPSCanvas methodsFor: 'private' stamp: 'on 5/10/2008 15:10'!
writePSIdentifierRotated: rotateFlag 
	target
		print: '%!!PS-Adobe-2.0 EPSF-2.0';
		cr.
	rotateFlag 
		ifTrue: 
			[target
				print: '%%BoundingBox: ';
				write: (0 @ 0 corner: psBounds corner transposed) rounded;
				cr]
		ifFalse: 
			[target
				print: '%%BoundingBox: ';
				write: psBounds rounded;
				cr].
	target
		print: '%%Title: ';
		print: self topLevelMorph externalName;
		cr.
	target
		print: '%%Creator: ';
		print: Author fullName;
		cr.
	target
		print: '%%CreationDate: ';
		print: Date today asString;
		space;
		print: Time now asString;
		cr.
		
	"is this relevant?"
	target print: '%%Orientation: ';
		 print: (rotateFlag ifTrue: [ 'Landscape' ] ifFalse: [ 'Portrait' ]);
		cr.
	target print: '%%DocumentFonts: (atend)'; cr.
	target
		print: '%%EndComments';
		cr

	"	self writeEPSPreviewImageFor: topLevelMorph."

	"	target print: '%%EndProlog'; cr."! !

!PostscriptCanvas classSide methodsFor: 'configuring' stamp: 'mpw 9/18/1999 11:04'!
baseOffset
	^0@0.
! !

!PostscriptCanvas classSide methodsFor: 'font mapping' stamp: 'nk 1/1/2004 22:32'!
convertFontName: aName
	"Break apart aName on case boundaries, inserting hyphens as needed."
	| lastCase |
	lastCase := aName first isUppercase.
	^ String streamContents: [ :s |
		aName do: [ :c | | thisCase |
			thisCase := c isUppercase.
			(thisCase and: [ lastCase not ]) ifTrue: [ s nextPut: $- ].
			lastCase := thisCase.
			s nextPut: c ]]! !

!PostscriptCanvas classSide methodsFor: 'configuring' stamp: 'RAA 2/1/2001 15:50'!
defaultCanvasType

	^Preferences postscriptStoredAsEPS ifTrue: [EPSCanvas] ifFalse: [DSCPostscriptCanvas]! !

!PostscriptCanvas classSide methodsFor: 'configuring' stamp: 'nk 12/29/2003 13:19'!
defaultExtension
	^ '.ps'! !

!PostscriptCanvas classSide methodsFor: 'configuring' stamp: ''!
defaultTarget
	^PostscriptEncoder stream.
! !

!PostscriptCanvas classSide methodsFor: 'configuring' stamp: ''!
filterSelector
	^#fullDrawPostscriptOn:.
! !

!PostscriptCanvas classSide methodsFor: 'font mapping' stamp: 'nk 1/1/2004 22:20'!
fontMap
	"Answer the font mapping dictionary. Made into a class var so that it can be edited."
	^FontMap ifNil: [ self initializeFontMap. FontMap ].! !

!PostscriptCanvas classSide methodsFor: 'font mapping' stamp: 'nk 3/25/2004 16:06'!
fontSampler
	"Produces a Postscript .eps file on disk, returns a Morph."
	"PostscriptCanvas fontSampler"
	"PostscriptCanvas fontSampler openInWorld"
	| morph file |
	morph := Morph new
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		wrapDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		color: Color white.
	TextStyle actualTextStyles keysAndValuesDo: [ :styleName :style |
		{ style fontArray first. style fontArray last } do: [ :baseFont | | info |
			0 to: 2 do: [ :i | | font string string2 textMorph row |
				font := baseFont emphasized: i.
				(i isZero or: [ font ~~ baseFont ]) ifTrue: [
					string := font fontNameWithPointSize.
					row := Morph new
						layoutPolicy: TableLayout new;
						listDirection: #topToBottom;
						hResizing: #shrinkWrap;
						vResizing: #shrinkWrap;
						cellSpacing: 20@0;
						color: Color white.
		
					textMorph := TextMorph new hResizing: #spaceFill; backgroundColor: Color white; beAllFont: font; contentsAsIs: string.
					row addMorphBack: (textMorph imageForm asMorph).

					info := self postscriptFontInfoForFont: font.
					string2 := String streamContents: [ :stream |
						stream nextPutAll: info first; space; print: (font pixelSize * info second) rounded.
					].
					textMorph := TextMorph new hResizing: #spaceFill; backgroundColor: Color white; beAllFont: font; contentsAsIs: string2.
					row addMorphBack: textMorph.
					
					morph addMorphBack: row.
				]
			]
		]
	].
	morph bounds: World bounds.
	morph layoutChanged; fullBounds.
	file := (FileDirectory default newFileNamed: 'PSFontSampler.eps').
	Cursor wait showWhile: [ 
		file nextPutAll: (EPSCanvas morphAsPostscript: morph) ].
	^morph! !

!PostscriptCanvas classSide methodsFor: 'font mapping' stamp: 'nk 1/2/2004 01:27'!
fontsForAccuAt

	| d |

	"Bold = 1, Ital = 2, Under = 4, Narrow = 8, Struckout = 16"
	d := Dictionary new.
	d
		at: 0 put: #('Helvetica-Bold' 1.0);
		at: 1 put: #('Helvetica-Bold' 1.0);
		at: 2 put: #('Helvetica-BoldOblique' 1.0);
		at: 3 put: #('Helvetica-BoldOblique' 1.0).
	^d! !

!PostscriptCanvas classSide methodsFor: 'font mapping' stamp: 'nk 1/2/2004 01:27'!
fontsForComicBold

	| d |

	"Bold = 1, Ital = 2, Under = 4, Narrow = 8, Struckout = 16"
	d := Dictionary new.
	d
		at: 0 put: #('Helvetica-Narrow-Bold' 0.9);
		at: 1 put: #('Helvetica-Narrow-Bold' 0.9);
		at: 2 put: #('Helvetica-Narrow-BoldOblique' 0.9);
		at: 3 put: #('Helvetica-Narrow-BoldOblique' 0.9).
	^d! !

!PostscriptCanvas classSide methodsFor: 'font mapping' stamp: 'nk 1/2/2004 01:27'!
fontsForComicPlain

	| d |

	"Bold = 1, Ital = 2, Under = 4, Narrow = 8, Struckout = 16"

"how do we do underlined??"

	d := Dictionary new.
	d
		at: 0 put: #('Helvetica-Narrow' 0.9);
		at: 1 put: #('Helvetica-Narrow-Bold' 0.9);
		at: 2 put: #('Helvetica-Narrow-Oblique' 0.9);
		at: 3 put: #('Helvetica-Narrow-BoldOblique' 0.9).
	^d
! !

!PostscriptCanvas classSide methodsFor: 'font mapping' stamp: 'nk 1/2/2004 01:27'!
fontsForHelvetica

	| d |

	"Bold = 1, Ital = 2, Under = 4, Narrow = 8, Struckout = 16"
	d := Dictionary new.
	d
		at: 0 put: #('Helvetica' 1.0);
		at: 1 put: #('Helvetica-Bold' 1.0);
		at: 2 put: #('Helvetica-Oblique' 1.0);
		at: 3 put: #('Helvetica-BoldOblique' 1.0);
		at: 8 put: #('Helvetica-Narrow' 1.0);
		at: 9 put: #('Helvetica-Narrow-Bold' 1.0);
		at: 10 put: #('Helvetica-Narrow-Oblique' 1.0);
		at: 11 put: #('Helvetica-Narrow-BoldOblique' 1.0).
	^d! !

!PostscriptCanvas classSide methodsFor: 'font mapping' stamp: 'nk 1/2/2004 01:27'!
fontsForNewYork

	| d |

	"Bold = 1, Ital = 2, Under = 4, Narrow = 8, Struckout = 16"
	d := Dictionary new.
	d
		at: 0 put: #('Times-Roman' 1.0);
		at: 1 put: #('Times-Bold' 1.0);
		at: 2 put: #('Times-Italic' 1.0);
		at: 3 put: #('Times-BoldItalic' 1.0);
		at: 8 put: #('Helvetica-Narrow' 1.0);
		at: 9 put: #('Helvetica-Narrow-Bold' 1.0);
		at: 10 put: #('Helvetica-Narrow-Oblique' 1.0);
		at: 11 put: #('Helvetica-Narrow-BoldOblique' 1.0).
	^d! !

!PostscriptCanvas classSide methodsFor: 'font mapping' stamp: 'nk 1/2/2004 01:27'!
fontsForPalatino

	| d |

	"Bold = 1, Ital = 2, Under = 4, Narrow = 8, Struckout = 16"
	d := Dictionary new.
	d
		at: 0 put: #('Palatino-Roman' 1.0);
		at: 1 put: #('Palatino-Bold' 1.0);
		at: 2 put: #('Palatino-Italic' 1.0);
		at: 3 put: #('Palatino-BoldItalic' 1.0).
	^d
! !

!PostscriptCanvas classSide methodsFor: 'font mapping' stamp: 'nk 1/1/2004 23:05'!
initializeFontMap
	"Initialize the dictionary mapping font names to substitutions for Postscript code generation."
	"PostscriptCanvas initializeFontMap"
	| f |
	FontMap := Dictionary new.
	FontMap
		at: 'NewYork' put: (f := self fontsForNewYork);
		at: 'Accuny' put: f;

		at: 'Helvetica' put: (f := self fontsForHelvetica);
		at: 'Accujen' put: f;
				
		at: 'Palatino' put: self fontsForPalatino;
		
		at: 'ComicBold' put: (f := self fontsForComicBold);
		at: 'Accuat' put: self fontsForAccuAt;
		
		at: 'ComicPlain' put: self fontsForComicPlain! !

!PostscriptCanvas classSide methodsFor: 'testing' stamp: 'mpw 9/18/1999 11:02'!
morphAsPostscript:aMorph
	^self morphAsPostscript:aMorph rotated:false offsetBy:self baseOffset.
! !

!PostscriptCanvas classSide methodsFor: 'testing' stamp: 'di 9/22/1999 09:31'!
morphAsPostscript: aMorph rotated: rotateFlag

	^ self morphAsPostscript: aMorph rotated: rotateFlag offsetBy: self baseOffset.
! !

!PostscriptCanvas classSide methodsFor: 'testing' stamp: 'nk 1/1/2004 20:21'!
morphAsPostscript:aMorph rotated:rotateFlag offsetBy:offset
 | psCanvas |
  psCanvas := self new.
  psCanvas reset.
  psCanvas bounds: (0@0 extent: (aMorph bounds extent + (2 * offset))).
  psCanvas topLevelMorph:aMorph.
  psCanvas resetContentRotated: rotateFlag.
  psCanvas fullDrawMorph: aMorph .
  ^psCanvas contents.
! !

!PostscriptCanvas classSide methodsFor: 'font mapping' stamp: 'nk 3/25/2004 20:13'!
postscriptFontInfoForFont: font

	| fontName decoded desired mask decodedName keys match |

	fontName := font textStyleName asString.
	decoded := TextStyle decodeStyleName: fontName.
	decodedName := decoded second.
	keys := self fontMap keys asArray sort: [ :a :b | a size > b size ].

	match := keys select: [ :k | decoded first = k or: [ fontName = k ] ].
	match do: [ :key | | subD |
		subD := self fontMap at: key.
		desired := font emphasis.
		mask := 31.
		[
			desired := desired bitAnd: mask.
			subD at: desired ifPresent: [ :answer | ^answer].
			mask := mask bitShift: -1.
			desired > 0
		] whileTrue.
	].

	"No explicit lookup found; try to convert the style name into the canonical Postscript name.
	This name will probably still be wrong."

	fontName := String streamContents: [ :s |
		s nextPutAll: decodedName.
		decoded third do: [ :nm | s nextPut: $-; nextPutAll: nm ].

		(font emphasis == 0 and: [ (decoded last includes: 0) not ])
			ifTrue: [ s nextPutAll:  '-Regular' ].

		(font emphasis == 1 and: [ (decoded first anyMask: 1) not ])
			ifTrue: [ s nextPutAll:  '-Bold' ].

		(font emphasis == 2 and: [ (decoded first anyMask: 2) not ])
			ifTrue: [ s nextPutAll:  '-Italic' ].

		(font emphasis == 3 and: [ (decoded first anyMask: 3) not ])
			ifTrue: [ s nextPutAll:  '-BoldItalic' ].
	].

	^ {fontName. 1.0}
! !

!PostscriptCanvas classSide methodsFor: 'font mapping' stamp: 'nk 3/25/2004 15:55'!
postscriptFontMappingSummary
	"
	Transcript nextPutAll: 
	PostscriptCanvas postscriptFontMappingSummary
	; endEntry
	"
	| stream |
	stream := WriteStream on: (String new: 1000).
	TextStyle actualTextStyles keysAndValuesDo: [ :styleName :style |
		stream nextPutAll: styleName; cr.
		style fontArray do: [ :baseFont | | info |
			0 to: 3 do: [ :i | | font |
				font := baseFont emphasized: i.
				font emphasis = i ifTrue: [
					stream tab; nextPutAll: font fontNameWithPointSize; tab.
					info := self postscriptFontInfoForFont: font.
					stream nextPutAll: info first; space; print: (font pixelSize * info second) rounded.
					stream cr.
				]
			]
		]
	].
	^stream contents! !

!PostscriptCanvas methodsFor: 'balloon compatibility' stamp: 'mpw 9/13/1999 20:57'!
aaLevel:newLevel
	"ignore "! !

!PostscriptCanvas methodsFor: 'balloon compatibility' stamp: ''!
asBalloonCanvas
     ^self.! !

!PostscriptCanvas methodsFor: 'private' stamp: 'mpw 8/7/2000 09:09'!
bounds:newBounds
	psBounds := newBounds.
! !

!PostscriptCanvas methodsFor: 'testing' stamp: 'nk 1/1/2004 21:08'!
canBlendAlpha
	^false! !

!PostscriptCanvas methodsFor: 'private' stamp: ''!
clip	
	^target clip.
! !

!PostscriptCanvas methodsFor: 'drawing-support' stamp: 'mpw 6/22/1930 22:37'!
clipBy: aRectangle during: aBlock
	^self translateBy: 0@0 clippingTo: aRectangle during: aBlock.
! !

!PostscriptCanvas methodsFor: 'accessing' stamp: 'mpw 8/3/1930 07:36'!
clipRect
	^clipRect.
! !

!PostscriptCanvas methodsFor: 'private' stamp: 'mpw 8/3/1930 08:39'!
closepath
	^target closepath.


              ! !

!PostscriptCanvas methodsFor: 'private' stamp: ''!
comment:aString
	target comment:aString.
! !

!PostscriptCanvas methodsFor: 'private' stamp: 'nk 12/29/2003 09:51'!
comment: aString with: anObject 
	target comment:aString with:anObject.
	! !

!PostscriptCanvas methodsFor: 'accessing' stamp: 'mpw 8/6/2000 13:36'!
contentsOfArea: aRectangle into: aForm
	"not supported for PS canvas"
! !

!PostscriptCanvas methodsFor: 'private' stamp: 'sw 12/6/1999 13:10'!
defaultFont
	^ TextStyle defaultFont! !

!PostscriptCanvas methodsFor: 'balloon compatibility' stamp: 'nk 12/28/2003 17:42'!
deferred: ignored! !

!PostscriptCanvas methodsFor: 'private' stamp: 'nk 1/2/2004 15:34'!
defineFont: aFont

	| psNameFor alreadyRemapped |

	(usedFonts includesKey: aFont) ifFalse:[
		psNameFor := self postscriptFontNameForFont: aFont.
		alreadyRemapped := usedFonts includes: psNameFor.
		usedFonts at: aFont put: psNameFor.
		" here: define as Type-3 unless we think its available "
		" or, just remap"

		" I had some problems if same font remapped twice"
		alreadyRemapped ifFalse: [target remapFontForSqueak: psNameFor].
	].! !

!PostscriptCanvas methodsFor: 'drawing-support' stamp: 'nk 4/1/2004 20:46'!
definePathProcIn: pathBlock during: duringBlock 
	"Bracket the output of pathBlock (which is passed the receiver) in 
	gsave 
		newpath 
			<pathBlock> 
		closepath 
		<duringBlock> 
	grestore 
	"
	| retval |
	self
		preserveStateDuring: [:tgt | 
			self comment: 'begin pathProc path block'.
			target newpath.
			pathBlock value: tgt.
			target closepath.
			self comment: 'begin pathProc during block'.
			retval := duringBlock value: tgt.
			self comment: 'end pathProc'].
	^ retval! !

!PostscriptCanvas methodsFor: 'testing' stamp: 'di 8/12/2000 15:04'!
doesRoundedCorners 

	^ false! !

!PostscriptCanvas methodsFor: 'drawing-general' stamp: 'mpw 8/10/1930 05:23'!
draw: anObject
	^anObject drawPostscriptOn: self! !

!PostscriptCanvas methodsFor: 'balloon compatibility' stamp: 'nk 4/1/2004 20:34'!
drawGeneralBezierShape: shapeArray color: color borderWidth: borderWidth borderColor: borderColor 
	"shapeArray is an array of: 
	arrays of points, each of which must have 
	a multiple of 3 points in it. 
	This method tries to sort the provided triplets so that curves that 
	start and end at the same point are together."
	| where triplets groups g2 fillC |
	fillC := self shadowColor
				ifNil: [color].
	shapeArray isEmpty
		ifTrue: [^ self].
	where := nil.
	groups := OrderedCollection new.
	triplets := OrderedCollection new.
	shapeArray
		do: [:arr | arr
				groupsOf: 3
				atATimeDo: [:bez | 
					| rounded | 
					rounded := bez roundTo: 0.001.
					(where isNil
							or: [where = rounded first])
						ifFalse: [groups addLast: triplets.
							triplets := OrderedCollection new].
					triplets addLast: rounded.
					where := rounded last]].
	groups addLast: triplets.
	triplets := OrderedCollection new.
	"now try to merge stray groups"
	groups copy
		do: [:g1 | g1 first first = g1 last last
				ifFalse: ["not closed"
					g2 := groups
								detect: [:g | g ~~ g1
										and: [g1 last last = g first first]]
								ifNone: [].
					g2
						ifNotNil: [groups remove: g2.
							groups add: g2 after: g1]]].
	groups
		do: [:g | triplets addAll: g].
	where := nil.
	self
		definePathProcIn: [ :cvs |
			triplets do: [:shape | 
					where ~= shape first
						ifTrue: [where
								ifNotNil: [cvs closepath].
							cvs moveto: shape first].
					where := cvs outlineQuadraticBezierShape: shape]]
		during: [ :cvs |
			cvs clip.
			cvs setLinewidth: borderWidth "*2";
				 fill: fillC andStroke: borderColor]! !

!PostscriptCanvas methodsFor: 'private' stamp: 'nk 4/1/2004 20:36'!
drawGradient: fillColor 
	self comment: 'not-solid fill ' with: fillColor.
	self comment: ' origin ' with: fillColor origin.
	self comment: ' direction ' with: fillColor direction.
	self fill: fillColor asColor! !

!PostscriptCanvas methodsFor: 'balloon compatibility' stamp: 'nk 4/1/2004 19:14'!
drawOval: r color: c borderWidth: borderWidth borderColor: borderColor
	| fillC |
	fillC := self shadowColor ifNil:[c].
	^ self fillOval: r color: fillC borderWidth: borderWidth borderColor: borderColor
	

		
! !

!PostscriptCanvas methodsFor: 'private' stamp: 'nk 1/2/2004 16:54'!
drawPage:aMorph
	self fullDrawMorph:aMorph.
! !

!PostscriptCanvas methodsFor: 'private' stamp: 'nk 1/2/2004 16:18'!
drawPages:collectionOfPages
	collectionOfPages do:[ :page |
		pages := pages + 1.
		target print:'%%Page: '; write:pages; space; write:pages; cr.
		self drawPage:page.
	].
	morphLevel = 0 ifTrue: [ self writeTrailer: pages ].! !

!PostscriptCanvas methodsFor: 'drawing-polygons' stamp: 'nk 4/1/2004 19:15'!
drawPolygon: vertices color: aColor borderWidth: bw borderColor: bc 
	| fillC |
	fillC := self shadowColor ifNil:[aColor].
	self
		preserveStateDuring: [:pc | pc
			 outlinePolygon: vertices;
				 setLinewidth: bw;
				
				fill: fillC
				andStroke: ((bc isKindOf: Symbol)
						ifTrue: [Color gray]
						ifFalse: [bc])]! !

!PostscriptCanvas methodsFor: 'private' stamp: 'di 8/12/2000 09:42'!
drawPostscriptContext: subCanvas
	| contents |
	(contents := subCanvas contents) ifNil: [^ self].
	^ target comment: ' sub-canvas start';
		preserveStateDuring: [:inner | inner print: contents];
		comment: ' sub-canvas stop'.	

! !

!PostscriptCanvas methodsFor: 'balloon compatibility' stamp: 'nk 4/1/2004 19:16'!
drawRectangle: r color: color borderWidth: borderWidth borderColor: borderColor

	| fillC |
	fillC := self shadowColor
				ifNil: [color].
	^ self
		frameAndFillRectangle: r
		fillColor: fillC
		borderWidth: borderWidth
		borderColor: borderColor! !

!PostscriptCanvas methodsFor: 'drawing-text' stamp: 'nk 4/1/2004 19:28'!
drawString: s from: firstIndex to: lastIndex in: boundsRect font: fontOrNil color: c 
	| fillC oldC |
	fillC := self shadowColor
		ifNil: [c].
	self setFont: (fontOrNil
				ifNil: [self defaultFont]).
	self comment: ' text color: ' , c printString.
	oldC := currentColor.
	self setColor: fillC.
	self comment: ' boundsrect origin ' , boundsRect origin printString.
	self comment: '  origin ' , origin printString.
	self moveto: boundsRect origin.
	target print: ' (';
		 print: (s asString copyFrom: firstIndex to: lastIndex) asPostscript;
		 print: ') show';
		 cr.
	self setColor: oldC.! !

!PostscriptCanvas methodsFor: 'drawing-text' stamp: 'nk 12/30/2003 17:50'!
drawString: s from: firstIndex to: lastIndex in: boundsRect font: fontOrNil color: c background: b
	target preserveStateDuring: [ :t | self fillRectangle: boundsRect color: b ].
	self drawString: s from: firstIndex to: lastIndex in: boundsRect font: fontOrNil color: c ! !

!PostscriptCanvas methodsFor: 'private' stamp: 'nk 1/2/2004 16:53'!
endGStateForMorph: aMorph 

	morphLevel == 1
		ifTrue: [ target showpage; print: 'grestore'; cr ]! !

!PostscriptCanvas methodsFor: 'private' stamp: 'nk 12/28/2003 21:08'!
fill: fillColor
	fillColor isSolidFill
		ifTrue: [self paint: fillColor asColor operation: #eofill]
		ifFalse: [self preserveStateDuring: [:inner | inner clip; drawGradient: fillColor]]! !

!PostscriptCanvas methodsFor: 'private' stamp: 'di 8/12/2000 09:44'!
fill: fillColor andStroke: strokeColor
	self preserveStateDuring: [:inner | inner fill: fillColor];
		stroke: strokeColor.
! !

!PostscriptCanvas methodsFor: 'drawing' stamp: ''!
fillColor:aColor
	self rect:clipRect; fill:aColor.
! !

!PostscriptCanvas methodsFor: 'drawing-ovals' stamp: 'di 8/12/2000 19:45'!
fillOval: r color: c borderWidth: borderWidth borderColor: borderColor 
	self preserveStateDuring:
		[:inner |
		inner oval: r;
		setLinewidth: borderWidth;
		fill: c andStroke: borderColor].

	

		
! !

!PostscriptCanvas methodsFor: 'drawing-rectangles' stamp: ''!
fillRectangle: r color: c
	self rect:r; fill:c.! !

!PostscriptCanvas methodsFor: 'drawing-rectangles' stamp: 'RAA 2/2/2001 09:54'!
fillRectangle: aRectangle fillStyle: aFillStyle
	"Fill the given rectangle."
	| pattern |

	(aFillStyle isKindOf: InfiniteForm) ifTrue: [
		^self infiniteFillRectangle: aRectangle fillStyle: aFillStyle
	].

	aFillStyle isSolidFill ifTrue:[^self fillRectangle: aRectangle color: aFillStyle asColor].

	"We have a very special case for filling with infinite forms"
	(aFillStyle isBitmapFill and:[aFillStyle origin = (0@0)]) ifTrue:[
		pattern := aFillStyle form.
		(aFillStyle direction = (pattern width @ 0) 
			and:[aFillStyle normal = (0@pattern height)]) ifTrue:[
				"Can use an InfiniteForm"
				^self fillRectangle: aRectangle color: (InfiniteForm with: pattern)].
	].

	"Use a BalloonCanvas instead PROBABLY won't work here"
	"self balloonFillRectangle: aRectangle fillStyle: aFillStyle."

	^self fillRectangle: aRectangle color: aFillStyle asColor! !

!PostscriptCanvas methodsFor: 'drawing-rectangles' stamp: 'nk 12/29/2003 20:10'!
frameAndFillRectangle: r fillColor: fillColor borderWidth: borderWidth borderColor: borderColor 
	"since postscript strokes on the line and squeak strokes inside, we need 
	to adjust inwards"
	self
		preserveStateDuring: [:pc | pc
				
				rect: (r insetBy: borderWidth / 2);
				 setLinewidth: borderWidth;
				 fill: fillColor andStroke: borderColor]! !

!PostscriptCanvas methodsFor: 'drawing-rectangles' stamp: 'nk 12/29/2003 16:27'!
frameAndFillRectangle: r fillColor: fillColor borderWidth: borderWidth topLeftColor: topLeftColor bottomRightColor: bottomRightColor 
	self
		preserveStateDuring: [:pc | 
			target newpath.
			pc setLinewidth: 0.
			pc outlinePolygon: {r origin. r topRight. r topRight + (borderWidth negated @ borderWidth). r origin + (borderWidth @ borderWidth). r bottomLeft + (borderWidth @ borderWidth negated). r bottomLeft. r origin};
				 fill: topLeftColor andStroke: topLeftColor.
			target newpath.
			pc outlinePolygon: {r topRight. r bottomRight. r bottomLeft. r bottomLeft + (borderWidth @ borderWidth negated). r bottomRight - (borderWidth @ borderWidth). r topRight + (borderWidth negated @ borderWidth). r topRight};
				 fill: bottomRightColor andStroke: bottomRightColor]! !

!PostscriptCanvas methodsFor: 'drawing-rectangles' stamp: ''!
frameRectangle: r width: w color: c 
	self rect:r; stroke:c.

! !

!PostscriptCanvas methodsFor: 'drawing-general' stamp: 'nk 1/2/2004 16:47'!
fullDraw: aMorph 
	self comment: 'start morph: ' with: aMorph.
	self comment: 'level: ' with: morphLevel.
	self comment: 'bounds: ' with: aMorph bounds.
	self comment: 'corner: ' with: aMorph bounds corner.
	morphLevel := morphLevel + 1.
	self setupGStateForMorph: aMorph.
	aMorph fullDrawPostscriptOn: self.
	self endGStateForMorph: aMorph.
	morphLevel := morphLevel - 1.
	self comment: 'end morph: ' with: aMorph.
	self comment: 'level: ' with: morphLevel.
! !

!PostscriptCanvas methodsFor: 'drawing-general' stamp: 'nk 1/2/2004 16:00'!
fullDrawBookMorph:aBookMorph
	^aBookMorph fullDrawOn:self.
! !

!PostscriptCanvas methodsFor: 'private' stamp: 'di 8/12/2000 10:06'!
image: aForm at: aPoint sourceRect: sourceRect rule: rule 
	self preserveStateDuring:
		[:inner | inner translate: aPoint + self origin.
		target write: aForm]
! !

!PostscriptCanvas methodsFor: 'balloon compatibility' stamp: 'RAA 9/20/2000 16:16'!
infiniteFillRectangle: aRectangle fillStyle: aFillStyle

	self flag: #bob.		"need to fix this"

	"^aFillStyle 
		displayOnPort: (port clippedBy: aRectangle) 
		at: aRectangle origin - origin"
! !

!PostscriptCanvas methodsFor: 'testing' stamp: 'nk 1/1/2004 21:09'!
isPostscriptCanvas
	^true! !

!PostscriptCanvas methodsFor: 'accessing' stamp: 'nk 4/1/2004 19:08'!
isShadowDrawing
	^shadowColor notNil! !

!PostscriptCanvas methodsFor: 'drawing' stamp: ''!
line: pt1 to: pt2 brushForm: brush 
	" to do: set brushform "
	self moveto:pt1; lineto:pt2; stroke:currentColor.
 
! !

!PostscriptCanvas methodsFor: 'drawing' stamp: ''!
line: pt1 to: pt2 width: w color: c 
	self setLinewidth:w; moveto:pt1; lineto:pt2; stroke:c. 	
! !

!PostscriptCanvas methodsFor: 'private' stamp: ''!
lineto:aPoint
	^target lineto:aPoint.


              ! !

!PostscriptCanvas methodsFor: 'private' stamp: ''!
moveto:aPoint
	^target moveto:aPoint.


              ! !

!PostscriptCanvas methodsFor: 'accessing' stamp: 'mpw 8/3/1930 07:35'!
origin
	^origin.
! !

!PostscriptCanvas methodsFor: 'private' stamp: 'dgd 2/21/2003 23:06'!
outlinePolygon: vertices 
	target moveto: (vertices first).
	2 to: vertices size do: [:i | target lineto: (vertices at: i)].
	target closepath! !

!PostscriptCanvas methodsFor: 'private' stamp: 'nk 1/1/2004 22:29'!
outlineQuadraticBezierShape: vertices 
	| where |
	3
		to: vertices size
		by: 3
		do: [:i | 
			| v1 v2 v3 | 
			v1 := (vertices at: i - 2) roundTo: 0.001.
			v2 := (vertices at: i - 1) roundTo: 0.001.
			v3 := (vertices at: i) roundTo: 0.001.
			(v1 = v2
					or: [v2 = v3])
				ifTrue: [target lineto: v3]
				ifFalse: [target
						curvetoQuadratic: v3
						from: v1
						via: v2].
			where := v3].
	^where! !

!PostscriptCanvas methodsFor: 'private' stamp: ''!
oval:aPoint
	^target oval:aPoint.! !

!PostscriptCanvas methodsFor: 'private' stamp: ''!
paint:color operation:operation
	self setColor:color.
	currentColor isTransparent ifFalse:[target perform:operation] ifTrue:[target newpath].

              ! !

!PostscriptCanvas methodsFor: 'drawing' stamp: 'di 8/13/2000 12:27'!
paragraph: para bounds: bounds color: c 
	| displayablePara |
	self comment:'paragraph with bounds: ' with:bounds.
	displayablePara := para asParagraphForPostscript.
	self preserveStateDuring:
		[:inner |
		displayablePara displayOn: inner
			using: (PostscriptCharacterScanner
					scannerWithCanvas: self paragraph: displayablePara bounds: bounds)
			at: bounds topLeft]
! !

!PostscriptCanvas methodsFor: 'private' stamp: 'nk 1/1/2004 22:18'!
postscriptFontNameForFont: font

	^(self class postscriptFontInfoForFont: font) first
! !

!PostscriptCanvas methodsFor: 'drawing-support' stamp: 'nk 4/1/2004 19:52'!
preserveStateDuring: aBlock
	| retval saveClip saveTransform |
	target preserveStateDuring: [ :innerTarget |
		saveClip := clipRect.
		saveTransform := currentTransformation.
		gstateStack addLast: currentFont.
		gstateStack addLast: currentColor.
		gstateStack addLast: shadowColor.
		retval := aBlock value: self.
		shadowColor := gstateStack removeLast.
		currentColor := gstateStack removeLast.
		currentFont := gstateStack removeLast.
		clipRect := saveClip.
		currentTransformation := saveTransform.
	].
	^ retval
! !

!PostscriptCanvas methodsFor: 'private' stamp: ''!
printContentsOn: aStream 
	^ aStream nextPutAll: target contents! !

!PostscriptCanvas methodsFor: 'private' stamp: ''!
psSize
	^ target size! !

!PostscriptCanvas methodsFor: 'private' stamp: ''!
rect:aRect
	^target rect:aRect.
! !

!PostscriptCanvas methodsFor: 'initialization' stamp: 'nk 4/1/2004 19:09'!
reset
	super reset.
	origin := 0 @ 0.				"origin of the top-left corner of this canvas"
	clipRect := 0 @ 0 corner: 10000 @ 10000.		"default clipping rectangle"
	currentTransformation := nil.
	morphLevel := 0.
	pages := 0.
	gstateStack := OrderedCollection new.
	usedFonts := Dictionary new.
	initialScale := 1.0.
	shadowColor := nil.
	currentColor := nil! !

!PostscriptCanvas methodsFor: 'private' stamp: 'di 9/22/1999 08:16'!
resetContentRotated: rotateFlag
	target := self class defaultTarget.
	self writeHeaderRotated: rotateFlag.
     ^self.! !

!PostscriptCanvas methodsFor: 'private' stamp: ''!
setColor: color 
     currentColor ~= color ifTrue:[
          target write:color asColor.
		currentColor := color.
	].
! !

!PostscriptCanvas methodsFor: 'private' stamp: 'nk 3/25/2004 15:36'!
setFont:aFont

	| fInfo |

	aFont = currentFont ifTrue: [^self].
	currentFont := aFont.
	self defineFont: aFont.
	fInfo := self class postscriptFontInfoForFont: aFont.

	target 
		selectflippedfont: fInfo first
		size: (aFont pixelSize * fInfo second)
		ascent: aFont ascent.
! !

!PostscriptCanvas methodsFor: 'private' stamp: ''!
setLinewidth: width 
	target setLinewidth: width.
! !

!PostscriptCanvas methodsFor: 'balloon compatibility' stamp: ''!
setOrigin: aPoint clipRect: aRectangle
	self comment:'new origin: ' with:aPoint.
	target rectclip:aRectangle.
	self translate:aPoint - origin.

"	self grestore; gsave.

	self write:aRectangle.
	target print:' textclip'; cr.
	target print:'% new offset '.
	target write:aPoint.
	target cr.
"	super setOrigin: aPoint clipRect: aRectangle.
! !

!PostscriptCanvas methodsFor: 'private' stamp: 'nk 1/2/2004 16:42'!
setupGStateForMorph: aMorph 

	morphLevel == 1
		ifTrue: [self writePageSetupFor: aMorph]! !

!PostscriptCanvas methodsFor: 'accessing' stamp: 'nk 4/1/2004 19:06'!
shadowColor
	^shadowColor! !

!PostscriptCanvas methodsFor: 'accessing' stamp: 'nk 4/1/2004 19:02'!
shadowColor: aColor
	shadowColor := aColor.! !

!PostscriptCanvas methodsFor: 'drawing-images' stamp: ''!
stencil: stencilForm at: aPoint color: aColor
	target comment:' imagemask'.
! !

!PostscriptCanvas methodsFor: 'private' stamp: 'gm 2/24/2003 18:07'!
stroke: strokeColor 
	strokeColor ifNil: [^self].
	(strokeColor isKindOf: Symbol) 
		ifTrue: [^self paint: Color gray operation: #stroke	"punt"].
	strokeColor isSolidFill 
		ifTrue: [^self paint: strokeColor asColor operation: #stroke].
	self preserveStateDuring: 
			[:inner | 
			inner
				strokepath;
				fill: strokeColor]! !

!PostscriptCanvas methodsFor: 'private' stamp: ''!
strokepath
	^target strokepath.


              ! !

!PostscriptCanvas methodsFor: 'private' stamp: 'RAA 10/2/2000 20:20'!
text: s at:point font: fontOrNil color: c justified:justify parwidth:parwidth

	self flag: #bob.		"deprecated in favor of #textStyled......."







	self setFont:(fontOrNil ifNil:[self defaultFont]).
	self comment:' text color: ',c printString.
	self setColor:c.
	self comment:'  origin ',  origin printString.
     self moveto: point.
	target print:' (';
     	 print:s asPostscript; print:') '.
		justify ifTrue:[
			target write:parwidth; print:' jshow'; cr.
		] ifFalse:[
			target print:'show'.
		].
		target cr.
! !

!PostscriptCanvas methodsFor: 'private' stamp: 'nk 4/1/2004 19:28'!
text: s at: point font: fontOrNil color: c spacePad: pad 
	| fillC oldC |
	fillC := self shadowColor
				ifNil: [c].
	self
		setFont: (fontOrNil
				ifNil: [self defaultFont]).
	self comment: ' text color: ' , c printString.
	oldC := currentColor.
	self setColor: fillC.
	self comment: '  origin ' , origin printString.
	self moveto: point.
	target write: pad;
		 print: ' 0 32 (';
		 print: s asPostscript;
		 print: ') widthshow';
		 cr.
	self setColor: oldC.! !

!PostscriptCanvas methodsFor: 'private' stamp: 'nk 4/1/2004 19:27'!
textStyled: s at: ignored0 font: ignored1 color: c justified: justify parwidth: parwidth 
	| fillC oldC |
	fillC := c.
	self shadowColor
		ifNotNilDo: [:sc | 
			self comment: ' shadow color: ' , sc printString.
			fillC := sc].
	self comment: ' text color: ' , c printString.
	oldC := currentColor.
	self setColor: fillC.
	self comment: '  origin ' , origin printString.
	"self moveto: point."
	"now done by sender"
	target print: ' (';
		 print: s asPostscript;
		 print: ') '.
	justify
		ifTrue: [target write: parwidth;
				 print: ' jshow';
				 cr]
		ifFalse: [target print: 'show'].
	target cr.
	self setColor: oldC.! !

!PostscriptCanvas methodsFor: 'private' stamp: 'mpw 9/14/1999 06:58'!
topLevelMorph
	^topLevelMorph
! !

!PostscriptCanvas methodsFor: 'private' stamp: 'mpw 9/14/1999 06:58'!
topLevelMorph:newMorph
	topLevelMorph := newMorph.
! !

!PostscriptCanvas methodsFor: 'balloon compatibility' stamp: 'mpw 8/4/1930 12:13'!
transformBy:aMatrix
	("aMatrix isPureTranslation" false) ifTrue:[
		target translate:aMatrix offset negated.
	] ifFalse:[
		target  concat:aMatrix.
	].
	^self.
! !

!PostscriptCanvas methodsFor: 'drawing-support' stamp: 'nk 4/1/2004 19:48'!
transformBy: aDisplayTransform clippingTo: aClipRect during: aBlock smoothing: cellSize 
	| retval oldShadow |
	oldShadow := shadowColor.
	self comment: 'drawing clipped ' with: aClipRect.
	self comment: 'drawing transformed ' with: aDisplayTransform.
	self
		preserveStateDuring: [:inner | 
			currentTransformation
				ifNil: [currentTransformation := aDisplayTransform]
				ifNotNil: [currentTransformation := currentTransformation composedWithLocal: aDisplayTransform].
			aClipRect
				ifNotNil: [clipRect := aDisplayTransform
								globalBoundsToLocal: (clipRect intersect: aClipRect).
					inner rect: aClipRect;
						 clip].
			inner transformBy: aDisplayTransform.
			retval := aBlock value: inner].
	self comment: 'end of drawing clipped ' with: aClipRect.
	shadowColor := oldShadow.
	^ retval! !

!PostscriptCanvas methodsFor: 'balloon compatibility' stamp: 'mpw 9/13/1999 21:05'!
transformBy:aTransform during:aBlock
	^self transformBy:aTransform clippingTo: nil during:aBlock! !

!PostscriptCanvas methodsFor: 'private' stamp: ''!
translate:aPoint
	^target translate:aPoint.


              ! !

!PostscriptCanvas methodsFor: 'other' stamp: 'mpw 8/4/1930 12:07'!
translateBy: delta clippingTo: aRect during: aBlock
	self comment:'translateBy: ' with:delta.
	^self transformBy:(MatrixTransform2x3 withOffset:delta) clippingTo:aRect during:aBlock.

! !

!PostscriptCanvas methodsFor: 'drawing-support' stamp: 'nk 4/1/2004 19:41'!
translateBy: delta during: aBlock
	"Set a translation only during the execution of aBlock."

	| result oldShadow |
	oldShadow := shadowColor.
	self translate: delta.
	result := aBlock value: self.
	self translate: delta negated.
	shadowColor := oldShadow.
	^ result
! !

!PostscriptCanvas methodsFor: 'balloon compatibility' stamp: 'mpw 8/4/1930 20:11'!
warpFrom: sourceQuad toRect: innerRect
	"^PostscriptDummyWarp canvas:self."! !

!PostscriptCanvas methodsFor: 'private' stamp: 'nk 1/1/2004 20:24'!
writeGlobalSetup: rotateFlag 
	target print: '%%EndProlog';
		 cr.
	target print: '%%BeginSetup';
		 cr.
	target print: '% initialScale: ';
		 write: initialScale;
		 cr.
	target print: '% pageBBox: '; write: self pageBBox; cr.
	
	target print: '% pageOffset';
		 cr.
	target translate: self pageOffset.
	rotateFlag
		ifTrue: ["no translate needed for 0,0 = upper LH corner of page"
			target print: '90 rotate';
				 cr;
				 print: '0 0 translate';
				 cr]
		ifFalse: [target write: 0 @ topLevelMorph height * initialScale;
				 print: ' translate';
				 cr].
	target print: '% flip';
		 cr.
	target scale: initialScale @ initialScale negated;
		 print: ' [ {true setstrokeadjust} stopped ] pop';
		 cr.
	target print: '%%EndSetup';
		 cr! !

!PostscriptCanvas methodsFor: 'private' stamp: 'nk 1/1/2004 17:50'!
writeHeaderRotated: rotateFlag 
	self writePSIdentifierRotated: rotateFlag.
	self writeProcset.
	self writeGlobalSetup: rotateFlag.! !

!PostscriptCanvas methodsFor: 'private' stamp: 'di 9/22/1999 08:24'!
writePSIdentifierRotated: rotateFlag
	"NB: rotation not yet supported"

	target print:'%!!'; cr.! !

!PostscriptCanvas methodsFor: 'private' stamp: 'nk 1/2/2004 16:37'!
writePageSetupFor: aMorph 

	target print: '%%BeginPageSetup'; cr.
	target print: 'gsave'; cr.
	target translate: aMorph bounds origin negated.
	target print: '%%EndPageSetup';
		 cr! !

!PostscriptCanvas methodsFor: 'private' stamp: 'mpw 11/15/1999 08:57'!
writeProcset
	target print:'

%%BeginProcset: Squeak-Level2-Emulation
/level1 /languagelevel where { 
	pop  languagelevel 2 lt
} {true } ifelse def
level1
{
	/rectclip {
		4 2 roll moveto
		1 index 0 rlineto
		 0 exch rlineto
		neg 0 rlineto closepath
		clip newpath
	} bind def
	/setcolorspace { pop } bind def
	/makeDict {
		counttomark 2 idiv dup dict begin
		{  def } repeat
		currentdict end exch pop
	} bind def
	/defaultDict [ /MultipleDataSources  false makeDict def
	/image {
		dup type /dicttype eq {
			defaultDict begin
			begin
				Width
				Height
				BitsPerComponent
				ImageMatrix 
				/DataSource load MultipleDataSources { aload pop } if				MultipleDataSources
				Decode length 2 idiv
			end
			end
		} if
		colorimage 
		currentfile ( ) readstring pop pop
	} bind def

	/_imagemask /imagemask load def
	/imagemask {
		dup type /dicttype eq {
			begin
				Width
				Height
				Decode 0 get 1 eq
				ImageMatrix
				/DataSource load
			end
		} if
		_imagemask 
		currentfile ( ) readstring pop pop
	} bind def
	/transparentimage {
		pop image
	} bind def

} {
	/makeDict { >> } bind def
	/transparentimage {
	  gsave
	  32 dict begin
	  /tinteger exch def
	  /transparent 1 string def
	  transparent 0 tinteger put
	  /olddict exch def
	  olddict /DataSource get dup type /filetype ne {
	    olddict /DataSource 3 -1 roll 0 () /SubFileDecode filter put
	  } {
	    pop
	  } ifelse
	  /newdict olddict maxlength dict def
	  olddict newdict copy pop
	  /w newdict /Width get def
	  /str w string def
	  /substrlen 2 w log 2 log div floor exp cvi def
	  /substrs [
	  {
	     substrlen string
	     0 1 substrlen 1 sub {
	       1 index exch tinteger put
	     } for
	     /substrlen substrlen 2 idiv def
	     substrlen 0 eq {exit} if
	  } loop
	  ] def
	  /h newdict /Height get def
	  1 w div 1 h div matrix scale
	  olddict /ImageMatrix get exch matrix concatmatrix
	  matrix invertmatrix concat
	  newdict /Height 1 put
	  newdict /DataSource str put
	  /mat [w 0 0 h 0 0] def
	  newdict /ImageMatrix mat put
	  0 1 h 1 sub {
	    mat 5 3 -1 roll neg put
	    olddict /DataSource get str readstring pop pop
	    /tail str def
	    /x 0 def
	    {
	      tail transparent search dup /done exch not def
	      {exch pop exch pop} if
	      /w1 1 index length def
	      w1 0 ne {
	        newdict /DataSource 3 -1 roll put
	        newdict /Width w1 put
	        mat 4 x neg put
	        /x x w1 add def
	        newdict image
	        /tail tail w1 tail length w1 sub getinterval def
	      } if
	      done {exit} if
	      tail substrs {
	        anchorsearch {pop} if
	      } forall
	      /tail exch def
	      tail length 0 eq {exit} if
	      /x w tail length sub def
	    } loop
	  } for
	  end
	  grestore
	} bind def
} ifelse

%%EndProcset
%%BeginProcset: Squeak-Printing
/_showpageSqueak /showpage load def
/showpage { gsave _showpageSqueak grestore } bind def
/countspaces {
	[ exch { dup 32 ne { pop } if  } forall ] length 
} bind def
/jshow { 
	10 dict begin
	/width exch def
	/str exch def
	str length 0 gt {
		str dup length 1 sub get 32 eq { /str str dup length 1 sub 0 exch getinterval def } if
		/strw str stringwidth pop def
		/diffwidth width strw sub def
		/numspaces str countspaces def
		numspaces 0 eq { /numspaces 1 def } if
		/adjspace width strw sub numspaces div def
		/adjchar 0 def
		diffwidth 0 lt {
			/adjspace adjspace 0.2 mul def
			/adjchar diffwidth str length div 0.8 mul def
		} if
		adjspace 0 32 adjchar 0 str awidthshow

	} if
	end
} bind def

/copydict {
	dup length dict begin 
		 { 1 index /FID eq 2 index /UniqueID eq and {pop pop} {  def  } ifelse } forall
	currentdict end
} bind def
/getSymbolcharproc {
	1 dict begin 
		/charstring exch def 
	 [ 550 0 0 0 650 600 /setcachedevice cvx 50 100 /translate cvx  /pop cvx 
		1 dict begin /setbbox { pop pop pop } bind def currentdict end /begin cvx   

		gsave  /Symbol 600 selectfont 0 0 moveto charstring false charpath false upath grestore

	 /exec cvx /fill cvx /end cvx ] cvx bind 
	end
} bind def
/adjustFontForSqueak		% converts _ to left-arrow, ^to upArrow and tab -> 4 spaces
{ 
	gsave dup 1000 selectfont
	dup dup findfont copydict
	begin
	CharStrings 
	/CharStrings exch copydict
	dup /leftarrow (\254) getSymbolcharproc  put
	dup /uparrow (\255) getSymbolcharproc  put
	dup /tab [ /pop cvx ( ) stringwidth pop 6 mul 0 0 0 0 0  /setcachedevice cvx ] cvx bind  put
	def
	/Encoding Encoding dup length array copy 
	dup 94 /uparrow put
	dup 95 /leftarrow put
	dup 9 /tab put
	def
	currentdict end definefont pop pop
	grestore
} bind def

%%EndProcset
'.
! !

!PostscriptCanvas methodsFor: 'morph drawing' stamp: 'mir 4/13/2005 17:09'!
writeTrailer: somePages 
	target
		print: '%%Trailer';
		cr.
	usedFonts isEmpty 
		ifFalse: 
			[target print: '%%DocumentFonts:'.
			usedFonts values asSet do: 
					[:f | 
					target
						space;
						print: f].
			target cr].
	target print:'%%Pages: '; write: somePages; cr.
	target
		print: '%%EOF';
		cr! !

!FileStream methodsFor: '*MorphicExtras-file accessing' stamp: 'fbs 2/2/2005 13:23'!
url
	"Convert my path into a file:// type url String."
	
	^self asUrl asString! !

RectangleMorph subclass: #AbstractMediaEventMorph
	instanceVariableNames: 'startTimeInScore endTimeInScore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!AbstractMediaEventMorph commentStamp: '<historical>' prior: 0!
An abstract representation of media events to be placed in a PianoRollScoreMorph (or others as they are developed)!

!AbstractMediaEventMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:36'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!AbstractMediaEventMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:24'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color paleYellow! !

!AbstractMediaEventMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/7/2000 12:58'!
endTime

	^endTimeInScore ifNil: [startTimeInScore + 100]! !

!AbstractMediaEventMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:38'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self layoutPolicy: TableLayout new;
	  listDirection: #leftToRight;
	  wrapCentering: #topLeft;
	  hResizing: #shrinkWrap;
	  vResizing: #shrinkWrap;
	  layoutInset: 2;
	  rubberBandCells: true! !

AbstractMediaEventMorph subclass: #SoundEventMorph
	instanceVariableNames: 'sound'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SoundInterface'!

!SoundEventMorph methodsFor: 'piano rolls' stamp: 'RAA 12/7/2000 12:36'!
addMorphsTo: morphList pianoRoll: pianoRoll eventTime: t betweenTime: leftTime and: rightTime

	| startX lengthInTicks endX |

	startTimeInScore > rightTime ifTrue: [^ self].  
	lengthInTicks := pianoRoll scorePlayer ticksForMSecs: sound duration * 1000.0.
	startTimeInScore + lengthInTicks < leftTime ifTrue: [^ self].
	startX := pianoRoll xForTime: startTimeInScore.
	endX := pianoRoll xForTime: startTimeInScore + lengthInTicks.
	morphList add: 
		(self left: startX; width: endX - startX).

! !

!SoundEventMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:31'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color lightGreen! !

!SoundEventMorph methodsFor: 'piano rolls' stamp: 'RAA 12/7/2000 12:29'!
encounteredAtTime: ticks inScorePlayer: scorePlayer atIndex: index inEventTrack: track secsPerTick: secsPerTick

	"hack... since we are called from within the SoundPlayer loop, the Semaphore will
	block attempts to play directly from here"
	WorldState addDeferredUIMessage: [sound play].! !

!SoundEventMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:39'!
initialize
"initialize the state of the receiver"
	super initialize.
""
	self height: 10! !

!SoundEventMorph methodsFor: 'piano rolls' stamp: 'RAA 12/9/2000 18:48'!
justDroppedIntoPianoRoll: newOwner event: evt
	
	| startX lengthInTicks endX |

	super justDroppedIntoPianoRoll: newOwner event: evt.

	startTimeInScore := newOwner timeForX: self left.
	lengthInTicks := newOwner scorePlayer ticksForMSecs: sound duration * 1000.0.
	endTimeInScore := startTimeInScore + lengthInTicks.

	endTimeInScore > newOwner scorePlayer durationInTicks ifTrue:
		[newOwner scorePlayer updateDuration].

	startX := newOwner xForTime: startTimeInScore.
	endX := newOwner xForTime: endTimeInScore.
	self width: endX - startX.

! !

!SoundEventMorph methodsFor: 'caching' stamp: 'RAA 12/8/2000 09:52'!
releaseCachedState

	super releaseCachedState.
	sound := sound compressWith: GSMCodec.
! !

!SoundEventMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/7/2000 13:01'!
sound: aSound

	sound := aSound.
	self setBalloonText: 'a sound of duration ',(sound duration roundTo: 0.1) printString,' seconds'.! !

AbstractMediaEventMorph subclass: #ZASMCameraMarkMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!ZASMCameraMarkMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 22:32'!
addCustomMenuItems: aMenu hand: aHandMorph
	"Add custom halo menu items"

	aMenu add: 'Go to this mark' translated target: self action: #gotoMark.
	aMenu add: 'Set transition' translated target: self action: #setTransition.

	super addCustomMenuItems: aMenu hand: aHandMorph
! !

!ZASMCameraMarkMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/6/2000 13:46'!
cameraController

	^(self valueOfProperty: #cameraController)! !

!ZASMCameraMarkMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/3/2000 10:09'!
cameraPoint: aPoint cameraScale: aNumber controller: aController

	self setProperty: #cameraPoint toValue: aPoint.
	self setProperty: #cameraScale toValue: aNumber.
	self setProperty: #cameraController toValue: aController.
	self addMorph: (
		StringMorph contents: aPoint printString,'  ',(aNumber roundTo: 0.001) printString
	) lock.! !

!ZASMCameraMarkMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/12/2000 13:57'!
cameraPoint: aPoint cameraScale: aNumber controller: aController page: aBookPage
 
	self setProperty: #cameraPoint toValue: aPoint.
	self setProperty: #cameraScale toValue: aNumber.
	self setProperty: #cameraController toValue: aController.
	self setProperty: #bookPage toValue: aBookPage.
	self addMorphBack: (ImageMorph new image: (aBookPage imageForm scaledToSize: 80@80)) lock.
	self setBalloonText: aPoint rounded printString,'  ',(aNumber roundTo: 0.001) printString! !

!ZASMCameraMarkMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/16/2000 15:56'!
gotoMark

	self cameraController 
		turnToPage: (self valueOfProperty: #bookPage)
		position: (self valueOfProperty: #cameraPoint) 
		scale: (self valueOfProperty: #cameraScale)
		transition: (self valueOfProperty: #transitionSpec).
	self setCameraValues.


! !

!ZASMCameraMarkMorph methodsFor: 'event handling' stamp: 'RAA 12/18/2000 15:39'!
handlesMouseDown: evt

	^true
! !

!ZASMCameraMarkMorph methodsFor: 'dropping/grabbing' stamp: 'RAA 12/11/2000 23:26'!
justDroppedInto: newOwner event: anEvent

	| holder |

	newOwner isWorldMorph ifTrue: [
		holder := ZASMScriptMorph new.
		holder 
			position: self position;
			setProperty: #cameraController toValue: self cameraController.
		self world addMorph: holder.
		holder addMorph: self.
		holder startStepping.
	].
	super justDroppedInto: newOwner event: anEvent! !

!ZASMCameraMarkMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/16/2000 15:53'!
menuPageVisualFor: target event: evt

	| tSpec menu subMenu directionChoices |

	tSpec := self 
		valueOfProperty: #transitionSpec
		ifAbsent: [
			(self valueOfProperty: #bookPage) 
				valueOfProperty: #transitionSpec
				ifAbsent: [{ 'silence' . #none. #none}]
		].
	menu := (MenuMorph entitled: 'Choose an effect
(it is now ' , tSpec second , ')') defaultTarget: self.
	TransitionMorph allEffects do: [:effect |
		directionChoices := TransitionMorph directionsForEffect: effect.
		directionChoices isEmpty
		ifTrue: [menu add: effect target: self
					selector: #setProperty:toValue:
					argumentList: (Array with: #transitionSpec
									with: (Array with: tSpec first with: effect with: #none))]
		ifFalse: [subMenu := MenuMorph new.
				directionChoices do:
					[:dir |
					subMenu add: dir target: self
						selector: #setProperty:toValue:
						argumentList: (Array with: #transitionSpec
									with: (Array with: tSpec first with: effect with: dir))].
				menu add: effect subMenu: subMenu]].

	menu popUpEvent: evt in: self world! !

!ZASMCameraMarkMorph methodsFor: 'event handling' stamp: 'RAA 12/18/2000 15:43'!
mouseDown: evt

	evt shiftPressed ifTrue: [^self].
	self isSticky ifTrue: [^self].
	evt hand grabMorph: self.! !

!ZASMCameraMarkMorph methodsFor: 'event handling' stamp: 'RAA 12/18/2000 15:43'!
mouseUp: evt

	evt shiftPressed ifTrue: [^self gotoMark].
! !

!ZASMCameraMarkMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/11/2000 23:26'!
setCameraValues

	| camera |
	camera := self cameraController.

	"ick... since one may fail to fully take due to constraints, retry"
	2 timesRepeat: [
		camera cameraPoint: (self valueOfProperty: #cameraPoint).
		camera cameraScale: (self valueOfProperty: #cameraScale).
	].

! !

!ZASMCameraMarkMorph methodsFor: 'menu' stamp: 'sw 11/27/2001 14:58'!
setTransition
	"Set the transition"

	^ self setTransition: ActiveEvent! !

!ZASMCameraMarkMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/16/2000 15:54'!
setTransition: evt

	| tSpec menu subMenu directionChoices |

	tSpec := self 
		valueOfProperty: #transitionSpec
		ifAbsent: [
			(self valueOfProperty: #bookPage) 
				valueOfProperty: #transitionSpec
				ifAbsent: [{ 'silence' . #none. #none}]
		].
	menu := (MenuMorph entitled: 'Choose an effect
(it is now ' , tSpec second , ')') defaultTarget: self.
	TransitionMorph allEffects do: [:effect |
		directionChoices := TransitionMorph directionsForEffect: effect.
		directionChoices isEmpty
		ifTrue: [menu add: effect target: self
					selector: #setProperty:toValue:
					argumentList: (Array with: #transitionSpec
									with: (Array with: tSpec first with: effect with: #none))]
		ifFalse: [subMenu := MenuMorph new.
				directionChoices do:
					[:dir |
					subMenu add: dir target: self
						selector: #setProperty:toValue:
						argumentList: (Array with: #transitionSpec
									with: (Array with: tSpec first with: effect with: dir))].
				menu add: effect subMenu: subMenu]].

	menu popUpEvent: evt in: self world! !

!ZASMCameraMarkMorph methodsFor: 'copying' stamp: 'RAA 12/11/2000 15:34'!
veryDeepCopyWith: deepCopier
	| camera page |
	"Keep the same camera???"
 
	(camera := self cameraController) ifNotNil: [
		(deepCopier references includesKey: camera) ifFalse: [
			"not recorded, outside our tree, use same camera"
			deepCopier references at: camera put: camera]].
	(page := self valueOfProperty: #bookPage) ifNotNil: [
		(deepCopier references includesKey: page) ifFalse: [
			deepCopier references at: page put: page]].

	^ super veryDeepCopyWith: deepCopier

! !

RectangleMorph subclass: #BasicButton
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!BasicButton commentStamp: '<historical>' prior: 0!
A minimalist button-like object intended for use with the tile-scripting system.!

!BasicButton classSide methodsFor: 'printing' stamp: 'sw 6/16/1998 16:58'!
defaultNameStemForInstances
	^ 'button'! !

!BasicButton methodsFor: 'menus' stamp: 'stephane.ducasse 8/17/2008 22:38'!
addCustomMenuItems: aCustomMenu hand: aHandMorph 

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'change label...' translated action: #setLabel! !

!BasicButton methodsFor: 'initialization' stamp: 'stephane.ducasse 8/17/2008 22:32'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	
	^ Color yellow darker! !

!BasicButton methodsFor: 'initialization' stamp: 'stephane.ducasse 8/17/2008 22:32'!
defaultBorderWidth
	"answer the default border width for the receiver"
	
	^ 1! !

!BasicButton methodsFor: 'initialization' stamp: 'stephane.ducasse 8/17/2008 22:32'!
defaultColor
	"answer the default color/fill style for the receiver"
	
	^ Color yellow! !

!BasicButton methodsFor: 'initialization' stamp: 'stephane.ducasse 8/17/2008 22:32'!
initialize
	"initialize the state of the receiver"
	
	super initialize.
	self label: 'Button'.
	self useRoundedCorners! !

!BasicButton methodsFor: 'accessing' stamp: 'stephane.ducasse 8/17/2008 22:39'!
label
	
	^ label! !

!BasicButton methodsFor: 'accessing' stamp: 'marcus.denker 8/18/2008 11:30'!
label: aString

	self label: aString font: Preferences standardButtonFont.
	! !

!BasicButton methodsFor: 'accessing' stamp: 'stephane.ducasse 8/17/2008 22:41'!
label: aString font: aFontOrNil

	| aFont |
	label ifNotNil: [label delete].
	aFont := aFontOrNil ifNil: [Preferences standardButtonFont].
	label := StringMorph contents: aString font: aFont.
	self extent: (label width + 6) @ (label height + 6).
	label position: self center - (label extent // 2).
	self addMorph: label.
	label lock
! !

!BasicButton methodsFor: 'accessing' stamp: 'stephane.ducasse 8/17/2008 22:38'!
setLabel
	| newLabel |
	newLabel := FillInTheBlank 
					request:
'Enter a new label for this button'
		initialAnswer: self label.
	newLabel isEmpty ifFalse: [self label: newLabel font: nil].
! !

BasicButton subclass: #URLMorph
	instanceVariableNames: 'url page isBookmark book'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SqueakPage'!

!URLMorph commentStamp: '<historical>' prior: 0!
This morph represents a URL for a SqueakPage. It displays the thumbnail for the associated page, if available. Used in page sorters and for bookmarks.

This morph has several options:
  a. It can act like a thumbnail for sorting (in which case it can be picked up and dragged) or it acts as a bookmark (in which case shift clicking on it activates it).
  b. If it has book set to true, it is a page in a book.  Clicking fetches the index of the book, opens it to the first page, and puts it in the hand.

A thumbnail on a known book:
	(URLMorph grabURL: 'ftp://doltest1.disney.com/squeak/test/p1.sp')
		book: true.

A thumbnail on a single PasteUpMorph:
Make a PasteUpMorph with any morphs in it.
Decide where it should live, make a url string, and copy it.
	'file://HardDisk/books/book1/myPage.sp'
	'ftp://doltest1.disney.com/squeak/test/p1.sp'
Choose 'Save as Web Morph'
Paste in the url.
Drop the resulting thumbnail into some morph.

See SqueakPage's comment for the stages of in/out.

url 
page 		A SqueakPage
isBookmark 		Boolean
book 	A Boolean -- whether I represent a whole book or a page.
!

!URLMorph classSide methodsFor: 'instance creation' stamp: 'tk 2/27/1999 14:18'!
grabForBook: bookMorph
	"Create a URLMorph for this book.  Put it into the hand."

	| um bookUrl pageUrl pg |
	bookUrl := bookMorph valueOfProperty: #url.
	pageUrl := bookMorph currentPage url.	"should have one!!"
	pg := SqueakPageCache atURL: pageUrl.
	(SqueakPage stemUrl: bookUrl) = (SqueakPage stemUrl: pageUrl) 
		ifTrue: [bookUrl := true].		"not a shared book"
	um := URLMorph newForURL: pageUrl.
	um setURL: pageUrl page: pg.
	pg isContentsInMemory ifTrue: [pg computeThumbnail].
	um isBookmark: true.
	um book: bookUrl.
	um removeAllMorphs.
	um color: Color transparent.
	Smalltalk currentHand attachMorph: um.
	^ um! !

!URLMorph classSide methodsFor: 'instance creation' stamp: 'sma 4/30/2000 10:52'!
grabURL: aURLString
	"Create a URLMorph for this url.  Drop it and click it to get the SqueakPage."

	| um |
	(um := self new) isBookmark: true; setURL: aURLString page: nil.
	HandMorph attach: um.
	^ um! !

!URLMorph classSide methodsFor: 'instance creation' stamp: 'jm 6/17/1998 07:35'!
newBookmarkForURL: aURLString

	^ (self newForURL: aURLString) isBookmark: true
! !

!URLMorph classSide methodsFor: 'instance creation' stamp: 'tk 10/2/1998 12:08'!
newForURL: aURLString

	| pg |
	pg := SqueakPageCache atURL: aURLString.
	^ self new setURL: aURLString page: pg
! !

!URLMorph methodsFor: 'accessing' stamp: 'jm 6/17/1998 21:49'!
book

	^ book
! !

!URLMorph methodsFor: 'accessing' stamp: 'tk 2/17/1999 12:38'!
book: aUrl
	"A notation about what book this page is in.  true means page is in same book as url strm says.  Set to the url of the Book if the book has a different stem url.  nil or false if not for a book page at all."

	book := aUrl! !

!URLMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:31'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color lightGray! !

!URLMorph methodsFor: 'drawing' stamp: 'ar 2/12/2000 18:07'!
drawOn: aCanvas
	"Draw thumbnail for my page, if it is available. Otherwise, just draw a rectangle." 

| thumbnail oldExt |
color == Color transparent 
	ifTrue: ["show thumbnail"
		thumbnail := self thumbnailOrNil.
		thumbnail
			ifNil: [aCanvas frameRectangle: bounds width: borderWidth 
						color: borderColor.
				aCanvas fillRectangle: (bounds insetBy: borderWidth) color: color]
			ifNotNil: [oldExt := bounds extent.
				bounds := bounds origin extent: thumbnail extent + (2@2).
				aCanvas frameRectangle: bounds width: borderWidth color: borderColor.
				aCanvas paintImage: thumbnail at: bounds origin + borderWidth.
				oldExt = thumbnail extent ifFalse: [self layoutChanged]]]
	ifFalse: ["show labeled button"
		^ super drawOn: aCanvas]
! !

!URLMorph methodsFor: 'private' stamp: 'tk 11/23/1998 17:37'!
enclosingBook
	"rethink this since class WebBookMorph is gone"! !

!URLMorph methodsFor: 'private' stamp: 'di 11/13/2000 00:55'!
enclosingPage
	"Answer the inner-most SqueakPage contents that contains this morph, or nil if there isn't one."

	self allOwnersDo:
		[:m | (m isKindOf: PasteUpMorph)
			ifTrue: [(SqueakPageCache pageForMorph: m) ifNotNilDo: [:pg | ^ pg]]].
	^ nil
! !

!URLMorph methodsFor: 'event handling' stamp: 'tk 1/13/1999 08:04'!
handlesMouseDown: event

	^ isBookmark & event shiftPressed
! !

!URLMorph methodsFor: 'event handling' stamp: 'tk 10/2/1998 08:55'!
handlesMouseUp: evt

	^ isBookmark
! !

!URLMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 20:53'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	
	isBookmark := false! !

!URLMorph methodsFor: 'accessing' stamp: 'jm 6/17/1998 07:16'!
isBookmark

	^ isBookmark
! !

!URLMorph methodsFor: 'accessing' stamp: 'jm 6/17/1998 07:17'!
isBookmark: aBoolean
	"Make this morph behave as a clickable bookmark if the argument is true."

	isBookmark := aBoolean.
! !

!URLMorph methodsFor: 'private' stamp: 'RAA 8/30/2000 11:56'!
label: aString font: aFontOrNil

	| oldLabel m aFont |
	(oldLabel := self findA: StringMorph)
		ifNotNil: [oldLabel delete].
	(oldLabel := self findA: TextMorph)
		ifNotNil: [oldLabel delete].
	aFont := aFontOrNil ifNil: [Preferences standardButtonFont].
	m := TextMorph new contents: aString; beAllFont: aFont.
	self extent: (m width + 6) @ (m height + 6).
	m position: self center - (m extent // 2).
	self addMorph: m.
	m lock
! !

!URLMorph methodsFor: 'event handling' stamp: 'tk 10/2/1998 08:58'!
mouseDown: evt
	"do nothing"
! !

!URLMorph methodsFor: 'event handling' stamp: 'ar 4/10/2005 18:54'!
mouseUp: evt
	| pg ow newPage mm bookUrl bk |
	"If url of a book, open it to that page, or bring it in and open to that page."
	book ifNotNil: [book == false ifFalse: [
		(bookUrl := book) isString ifFalse: [
			bookUrl := (SqueakPage stemUrl: url), '.bo'].
		(bk := BookMorph isInWorld: self world withUrl: bookUrl) class ~~ Symbol 
			ifTrue: [^ bk goToPageUrl: url].
		bk == #conflict ifTrue: [
			^ self inform: 'This book is already open in some other project'].
		(bk := BookMorph new fromURL: bookUrl) ifNil: [^ self].
		bk goToPageUrl: url.	"turn to the page"
		^ HandMorph attach: bk]].

	"If inside a SqueakPage, replace it!!"
	pg := self enclosingPage.
	pg ifNotNil: [
		(ow := pg contentsMorph owner) ifNotNil: [
			pg contentsMorph delete.	"from its owner"
			newPage := SqueakPageCache atURL: url.
			mm := newPage fetchContents.
			mm ifNotNil: [ow addMorph: mm.
				page := newPage].
			^ self]].
	"If I am a project, jump  -- not done yet"

	"For now, just put new page on the hand"
	newPage := SqueakPageCache atURL: url.
	mm := newPage fetchInformIfError.
	mm ifNotNil: [self primaryHand attachMorph: mm.
		page := newPage].

! !

!URLMorph methodsFor: 'accessing' stamp: 'jm 6/16/1998 18:07'!
page
	"Answer the cached page that this morph represents."

	^ page
! !

!URLMorph methodsFor: 'updating' stamp: 'jm 6/17/1998 14:15'!
pageHasChanged: aSqueakPage
	"The given page has changed. Update this morph if it refers to the given page."

	| thumbnail |
	page == aSqueakPage ifFalse: [^ self].  "this change does not affect me"
	thumbnail := self thumbnailOrNil.
	thumbnail ifNotNil: [
		self extent: (thumbnail extent + 2).
		self changed].
! !

!URLMorph methodsFor: 'private' stamp: 'tk 10/2/1998 08:20'!
setURL: aURLString page: aSqueakPage
	"Initialize the receiver for the given URL and page."

	url := aURLString.
	page := aSqueakPage.
	page ifNotNil: [self pageHasChanged: page].
! !

!URLMorph methodsFor: 'private' stamp: 'gm 2/22/2003 13:16'!
thumbnailOrNil
	"Answer the thumbnail Form for the page this morph represents. Answer nil if no thumbnail is available."

	| thum |
	page ifNil: [page := SqueakPageCache atURL: url].
	(thum := page thumbnail) ifNil: [^nil].
	^(thum isForm) 
		ifTrue: [thum]
		ifFalse: [thum form	"a BookPageThumbnailMorph"]! !

!URLMorph methodsFor: 'accessing' stamp: 'jm 6/17/1998 07:05'!
url
	"Answer the URL for the page that this morph represents."

	^ url
! !

RectangleMorph subclass: #CodecDemoMorph
	instanceVariableNames: 'codecClassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SoundInterface'!

!CodecDemoMorph methodsFor: 'layout' stamp: 'jm 2/4/1999 12:37'!
acceptDroppingMorph: aMorph event: evt

	| codecClass |
	'None' = codecClassName
		ifTrue: [aMorph sound play]
		ifFalse: [
			codecClass := Smalltalk at: codecClassName ifAbsent: [^ self].
			(codecClass new compressAndDecompress: aMorph sound) play].
	aMorph position: self topRight + (10@0).
! !

!CodecDemoMorph methodsFor: 'menus' stamp: 'dgd 8/30/2003 21:17'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'select codec' translated action: #selectCodec.
! !

!CodecDemoMorph methodsFor: 'as yet unclassified' stamp: 'jm 2/4/1999 12:36'!
codecClassName: aStringOrSymbol

	| label |
	codecClassName := aStringOrSymbol asSymbol.
	self removeAllMorphs.
	label := StringMorph contents: aStringOrSymbol.
	label position: self position + (5@5).
	self addMorph: label.
	label lock: true.
	self extent: label extent + (10@10).
! !

!CodecDemoMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:20'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color
		r: 1.0
		g: 0.806
		b: 0.677! !

!CodecDemoMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:20'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	
	self codecClassName: 'MuLawCodec'! !

!CodecDemoMorph methodsFor: 'as yet unclassified' stamp: 'jm 2/4/1999 12:33'!
selectCodec

	| aMenu codecs newCodec |
	aMenu := CustomMenu new title: 'Codec:'.
	codecs := (SoundCodec allSubclasses collect: [:c | c name]) asSortedCollection.
	codecs add: 'None'.
	codecs do:[:cName | aMenu add: cName action: cName].
	newCodec := aMenu startUp.
	newCodec ifNil: [^ self].
	self codecClassName: newCodec.
! !

!CodecDemoMorph methodsFor: 'dropping/grabbing' stamp: 'jm 2/4/1999 12:19'!
wantsDroppedMorph: aMorph event: evt

	^ aMorph isMemberOf: SoundTile
! !

RectangleMorph subclass: #DoubleClickExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!DoubleClickExample commentStamp: '<historical>' prior: 0!
Illustrates the double-click capabilities of Morphic.

If you have a kind of morph you wish to have respond specially to a double-click, it should:

(1)  Respond "true" to #handlesMouseDown:

(2)  In its mouseDown: method, send #waitForClicksOrDrag:event: to the hand.

(3)  Reimplement #click: to react to single-clicked mouse-down.

(4)  Reimplement #doubleClick: to make the appropriate response to a double-click.

(5)  Reimplement #drag: to react to non-clicks.  This message is sent continuously until the button is released.  You can check the event argument to react differently on the first, intermediate, and last calls.!

!DoubleClickExample classSide methodsFor: 'parts bin' stamp: 'sw 8/2/2001 12:46'!
descriptionForPartsBin
	^ self partName:	'DoubleClick'
		categories:		#('Demo')
		documentation:	'An example of how to use double-click in moprhic'! !

!DoubleClickExample methodsFor: 'accessing' stamp: 'nk 7/26/2004 10:38'!
balloonText
	^ 'Double-click on me to change my color; 
single-click on me to change border color;
hold mouse down within me and then move it to grow 
(if I''m red) or shrink (if I''m blue).' translated
! !

!DoubleClickExample methodsFor: 'event handling' stamp: 'ar 10/3/2000 17:05'!
click: evt
	self showBalloon: 'click' hand: evt hand.
	self borderColor: (self borderColor = Color black ifTrue: [Color yellow] ifFalse: [Color black])
! !

!DoubleClickExample methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:22'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color red! !

!DoubleClickExample methodsFor: 'event handling' stamp: 'ar 10/3/2000 17:05'!
doubleClick: evt
	self showBalloon: 'doubleClick' hand: evt hand.
	self color: ((color = Color blue) ifTrue: [Color red] ifFalse: [Color blue])
! !

!DoubleClickExample methodsFor: 'event handling' stamp: 'sw 9/14/1999 16:05'!
handlesMouseDown: evt
	^ true! !

!DoubleClickExample methodsFor: 'event handling' stamp: 'bf 9/28/1999 17:20'!
mouseDown: evt
	"Do nothing upon mouse-down except inform the hand to watch for a double-click; wait until an ensuing click:, doubleClick:, or drag: message gets dispatched"

	evt hand waitForClicksOrDrag: self event: evt! !

!DoubleClickExample methodsFor: 'event handling' stamp: 'ar 10/3/2000 17:05'!
startDrag: evt
	"We'll get a mouseDown first, some mouseMoves, and a mouseUp event last"
	| oldCenter |
	evt isMouseDown ifTrue:
		[self showBalloon: 'drag (mouse down)' hand: evt hand.
		self world displayWorld.
		(Delay forMilliseconds: 750) wait].
	evt isMouseUp ifTrue:
		[self showBalloon: 'drag (mouse up)' hand: evt hand].
	(evt isMouseUp or: [evt isMouseDown]) ifFalse:
		[self showBalloon: 'drag (mouse still down)' hand: evt hand].
	(self containsPoint: evt cursorPoint)
		ifFalse: [^ self].

	oldCenter := self center.
	color = Color red
		ifTrue:
			[self extent: self extent + (1@1)]
		ifFalse:
			[self extent: ((self extent - (1@1)) max: (16@16))].
	self center: oldCenter! !

RectangleMorph subclass: #EnvelopeEditorMorph
	instanceVariableNames: 'sound soundName envelope hScale vScale graphArea pixPerTick limits limitXs limitHandles line prevMouseDown sampleDuration showAllEnvelopes denominator keyboard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SoundInterface'!

!EnvelopeEditorMorph class methodsFor: 'as yet unclassified' stamp: 'di 5/15/1998 09:49'!
openOn: aSound title: aString
	"EnvelopeEditorMorph openOn: (AbstractSound soundNamed: 'brass1') copy title: 'brass1'"
	(self basicNew initOnSound: aSound title: aString) openInWorld! !

!EnvelopeEditorMorph methodsFor: 'editing' stamp: 'dgd 2/22/2003 14:23'!
acceptGraphPoint: p at: index 
	| ms val points whichLim linePoint other boundedP |
	boundedP := p adhereTo: graphArea bounds.
	ms := self msFromX: boundedP x.
	points := envelope points.
	ms := self 
				constrain: ms
				adjacentTo: index
				in: points.
	(index = 1 or: [(whichLim := limits indexOf: index) > 0]) 
		ifTrue: 
			["Limit points must not move laterally"

			ms := (points at: index) x].
	val := self valueFromY: boundedP y.
	points at: index put: ms @ val.
	linePoint := (self xFromMs: ms) @ (self yFromValue: val).
	(whichLim notNil and: [whichLim between: 1 and: 2]) 
		ifTrue: 
			["Loop start and loop end must be tied together"

			other := limits at: 3 - whichLim.	" 1 <--> 2 "
			points at: other put: (points at: other) x @ val.
			line verticesAt: other put: (line vertices at: other) x @ linePoint y].
	"Make sure envelope feels the change in points array..."
	envelope 
		setPoints: points
		loopStart: limits first
		loopEnd: (limits second).
	^linePoint! !

!EnvelopeEditorMorph methodsFor: 'construction' stamp: 'di 7/14/2000 13:08'!
addControls
	| chooser |
	chooser := PopUpChoiceMorph new extent: 110@14;
		contentsClipped: 'Editing: ' , envelope name;
		target: self;
		actionSelector: #chooseFrom:envelopeItem:;
		getItemsSelector: #curveChoices.
	chooser arguments: (Array with: chooser).
	self addMorph: chooser.
	chooser align: chooser bounds topLeft with: graphArea bounds bottomLeft + (0@5).

	chooser := PopUpChoiceMorph new extent: 130@14;
		contentsClipped: 'Timbre: ' , soundName;
		target: self;
		actionSelector: #chooseFrom:soundItem:;
		getItemsSelector: #soundChoices.
	chooser arguments: (Array with: chooser).
	self addMorph: chooser.
	chooser align: chooser bounds topRight with: graphArea bounds bottomRight + (-50@5).
! !

!EnvelopeEditorMorph methodsFor: 'construction' stamp: 'ar 3/17/2001 14:24'!
addCurves
	"Add the polyLine corresponding to the currently selected envelope,
	and possibly all the others, too."
	| verts aLine |
	sound envelopes do:
		[:env | 
		(showAllEnvelopes or: [env == envelope]) ifTrue:
			[verts := env points collect:
				[:p | (self xFromMs: p x) @ (self yFromValue: p y)].
			aLine := EnvelopeLineMorph basicNew
						vertices: verts borderWidth: 1
						borderColor: (self colorForEnvelope: env).
			env == envelope
				ifTrue: [aLine borderWidth: 2.  line := aLine]
				ifFalse: [aLine on: #mouseUp send: #clickOn:evt:from:
							to: self withValue: env.
						self addMorph: aLine]]].
	self addMorph: line  "add the active one last (in front)"! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 21:19'!
addCustomMenuItems: menu hand: aHandMorph
	super addCustomMenuItems: menu hand: aHandMorph.
	menu addLine.
	envelope updateSelector = #ratio: ifTrue:
		[menu add: 'choose denominator...' translated action: #chooseDenominator:].
	menu add: 'adjust scale...' translated action: #adjustScale:.
	SoundPlayer isReverbOn
		ifTrue: [menu add: 'turn reverb off' translated target: SoundPlayer selector: #stopReverb]
		ifFalse: [menu add: 'turn reverb on' translated target: SoundPlayer selector: #startReverb].
	menu addLine.
	menu add: 'get sound from lib' translated action: #chooseSound:.
	menu add: 'put sound in lib' translated action: #saveSound:.
	menu add: 'read sound from disk...' translated action: #readFromDisk:.
	menu add: 'save sound on disk...' translated action: #saveToDisk:.
	menu add: 'save library on disk...' translated action: #saveLibToDisk:.
! !

!EnvelopeEditorMorph methodsFor: 'editing' stamp: 'JMV 1/29/2001 10:57'!
addEnvelopeNamed: envName
	| points env |
	points := OrderedCollection new.
	points add: 0@0.0;
		add: (envelope points at: envelope loopStartIndex) x@1.0;
		add: (envelope points at: envelope loopEndIndex) x@1.0;
		add: (envelope points last) x@0.0.
	envName = 'volume' ifTrue:
		[env := VolumeEnvelope points: points loopStart: 2 loopEnd: 3.
		env target: sound; scale: 0.7].
	envName = 'modulation' ifTrue:
		[env := Envelope points: (points collect: [:p | p x @ 0.5])
						loopStart: 2 loopEnd: 3.
		env target: sound; updateSelector: #modulation:;
			scale: sound modulation*2.0].
	envName = 'pitch' ifTrue:
		[env := PitchEnvelope points: (points collect: [:p | p x @ 0.5])
						loopStart: 2 loopEnd: 3.
		env target: sound; updateSelector: #pitch:; scale: 0.5].
	envName = 'random pitch:' ifTrue:
		[env := RandomEnvelope for: #pitch:.
		points := OrderedCollection new.
		points add: 0@(env delta * 5 + 0.5);
			add: (envelope points at: envelope loopStartIndex) x@(env highLimit - 1 * 5 + 0.5);
			add: (envelope points at: envelope loopEndIndex) x@(env highLimit - 1 * 5 + 0.5);
			add: (envelope points last) x@(env lowLimit - 1 * 5 + 0.5).
		env setPoints: points loopStart: 2 loopEnd: 3.
		env target: sound. ].
	envName = 'ratio' ifTrue:
		[denominator := 9999.  "No gridding"
		env := Envelope points: (points collect: [:p | p x @ 0.5])
						loopStart: 2 loopEnd: 3.
		env target: sound; updateSelector: #ratio:;
			scale: sound ratio*2.0].
	env ifNotNil:
		[sound addEnvelope: env.
		self editEnvelope: env]! !

!EnvelopeEditorMorph methodsFor: 'construction' stamp: 'ar 3/17/2001 14:25'!
addHandlesIn: frame
	| handle |
	handle := PolygonMorph
		vertices: (Array with: 0@0 with: 8@0 with: 4@8)
		color: Color orange borderWidth: 1 borderColor: Color black.
	handle addMorph: ((RectangleMorph
			newBounds: ((self handleOffset: handle)-(2@0) extent: 1@(graphArea height-2))
			color: Color orange) borderWidth: 0).

	limitHandles := Array with: handle with: handle veryDeepCopy with: handle veryDeepCopy.
	1 to: limitHandles size do:
		[:i | handle := limitHandles at: i.
		handle on: #mouseDown
				send: #limitHandleMove:event:from:
				to: self withValue: i.
		handle on: #mouseMove
				send: #limitHandleMove:event:from:
				to: self withValue: i.
		self addMorph: handle.
		handle position: ((self xFromMs: 
			(envelope points at: (limits at: i)) x) @ 
				(graphArea top)) - (self handleOffset: handle)]! !

!EnvelopeEditorMorph methodsFor: 'construction' stamp: 'di 9/4/1998 15:49'!
addKeyboard
	keyboard := PianoKeyboardMorph new soundPrototype: sound.
	keyboard align: keyboard bounds bottomCenter with: bounds bottomCenter - (0@4).
	self addMorph: keyboard! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'dgd 2/22/2003 14:23'!
adjustScale: evt 
	| scaleString oldScale baseValue |
	oldScale := envelope scale.
	scaleString := FillInTheBlank request: 'Enter the new full-scale value...'
				initialAnswer: oldScale printString.
	scaleString isEmpty ifTrue: [^self].
	envelope scale: (Number readFrom: scaleString) asFloat.
	baseValue := envelope updateSelector = #pitch: ifTrue: [0.5] ifFalse: [0.0].
	envelope 
		setPoints: (envelope points collect: 
					[:p | 
					p x @ ((p y - baseValue) * oldScale / envelope scale + baseValue min: 1.0
								max: 0.0)])
		loopStart: (limits first)
		loopEnd: (limits second).
	self buildView! !

!EnvelopeEditorMorph methodsFor: 'construction' stamp: 'di 9/4/1998 15:56'!
buildGraphAreaIn: frame
	| r y |
	graphArea := RectangleMorph
		newBounds: ((frame left + 40) @ (frame top + 40)
		corner: (frame right+1) @ (frame bottom - 60))
		color: Color lightGreen lighter lighter.
	graphArea borderWidth: 1.
	self addMorph: graphArea.
	(envelope updateSelector = #pitch: and: [envelope scale <= 2.0]) ifTrue:
		["Show half-steps"
		r := graphArea innerBounds.
		0.0 to: 1.0 by: 1.0/12.0/envelope scale do:
			[:val |
			y := self yFromValue: val.
			graphArea addMorph: ((RectangleMorph
					newBounds: (r left@y extent: r width@1)
					color: Color veryLightGray)
						borderWidth: 0)]].
	(envelope updateSelector = #ratio: and: [denominator ~= 9999]) ifTrue:
		["Show denominator gridding"
		r := graphArea innerBounds.
		(0.0 to: 1.0 by: 1.0/denominator/envelope scale) do:
			[:v |
			y := self yFromValue: v.
			graphArea addMorph: ((RectangleMorph
					newBounds: (r left@y extent: r width@1)
					color: Color veryLightGray)
						borderWidth: 0)]].
! !

!EnvelopeEditorMorph methodsFor: 'editing' stamp: 'JMV 1/26/2001 11:28'!
buildScalesIn: frame
	| env hmajortick hminortick |
	env := envelope.
	pixPerTick := graphArea width // (self maxTime//10) max: 1.
	hminortick := ( 1 + ( self maxTime // 800 ) ) * 10.
	hmajortick := ( 1 + ( self maxTime // 800 ) ) * 100.
	hScale := (ScaleMorph newBounds: ((graphArea left)@(frame top) corner: (self xFromMs: self maxTime)@(graphArea top - 1)))
		start: 0 stop: self maxTime
		minorTick: hminortick minorTickLength: 3
		majorTick: hmajortick majorTickLength: 10
		caption: 'milliseconds' tickPrintBlock: [:v | v printString].
	self addMorph: hScale.
	vScale := ScaleMorph newBounds: (0@0 extent: (graphArea height)@(graphArea left - frame left)).
	env name = 'pitch'
		ifTrue:
		[env scale >= 2.0
			ifTrue:
			[vScale start: 0 stop: env scale
				minorTick: env scale / 24 minorTickLength: 3
				majorTick: env scale / 2.0 majorTickLength: 10
				caption: 'pitch (octaves)'
				tickPrintBlock: [:v | (v-(env scale/2)) asInteger printString]]
			ifFalse:
			[vScale start: 0 stop: env scale
				minorTick: 1.0/48.0 minorTickLength: 3
				majorTick: 1.0/12.0 majorTickLength: 10
				caption: 'pitch (half-steps)'
				tickPrintBlock: [:v | (v-(env scale/2)*12) rounded printString]]]
		ifFalse: [
			env name = 'random pitch:'
				ifTrue: [
					vScale start: 0.9 stop: 1.1
						minorTick: 0.2 / 50.0 minorTickLength: 3
						majorTick: 0.2 / 5.0 majorTickLength: 10
						caption: env name
						tickPrintBlock: [:v | v printString]]
				ifFalse: [
					vScale start: 0 stop: env scale
						minorTick: env scale / 50.0 minorTickLength: 3
						majorTick: env scale / 5.0 majorTickLength: 10
						caption: env name
						tickPrintBlock: [:v | v printString]].
		].
	vScale := TransformationMorph new asFlexOf: vScale.
	vScale angle: Float pi / 2.0.
	self addMorph: vScale.
	vScale position: (frame left)@(graphArea top-1) - (3@1).
! !

!EnvelopeEditorMorph methodsFor: 'construction' stamp: 'di 9/4/1998 13:16'!
buildView
	| frame |
	self color: Color lightGreen.
	self removeAllMorphs.
	frame := self innerBounds.
	self buildGraphAreaIn: frame.
	self buildScalesIn: frame.
	self addHandlesIn: frame.
	self addCurves.
	line addHandles.
	self addControls.
	self addKeyboard! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'RAA 6/12/2000 08:58'!
chooseDenominator: evt
	| menu |
	menu := MenuMorph new.
	(Integer primesUpTo: 30) do:
		[:i |
		menu add: i printString
			target: self selector: #setDenominator:
			argument: i].
	menu addLine.
	menu add: 'none' target: self selector: #setDenominator: argument: 9999.
	menu popUpEvent: evt in: self world! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'di 2/3/98 16:50'!
chooseEnvelope: choice
	| name |
	(choice beginsWith: 'edit ') ifTrue:
		[name := choice copyFrom: 'edit ' size+1 to: choice size.
		^ self editEnvelope: (sound envelopes detect:
				[:env | env name = name])].
	(choice beginsWith: 'add ') ifTrue:
		[name := choice copyFrom: 'add ' size+1 to: choice size.
		^ self addEnvelopeNamed: name].
	(choice beginsWith: 'remove ') ifTrue:
		[^ self removeEnvelope  "the current one"].
! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'di 2/3/98 19:14'!
chooseFrom: chooserMorph envelopeItem: item
	| name |
	(item beginsWith: 'edit ') ifTrue:
		[name := item copyFrom: 'edit ' size+1 to: item size.
		self editEnvelope: (sound envelopes detect:
				[:env | env name = name])].
	(item beginsWith: 'add ') ifTrue:
		[name := item copyFrom: 'add ' size+1 to: item size.
		self addEnvelopeNamed: name].
	(item beginsWith: 'remove ') ifTrue:
		[self removeEnvelope  "the current one"].
	chooserMorph contentsClipped: envelope name! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'di 7/14/2000 13:03'!
chooseFrom: chooserMorph soundItem: item
	self editSoundNamed: item.
! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'di 7/14/2000 12:42'!
chooseSound: evt
	| menu |
	menu := MenuMorph new.
	menu add: 'new...' target: self selector: #editNewSound.
	menu addLine.
	AbstractSound soundNames do:
		[:name |
		menu add: name
			target: self selector: #editSoundNamed:
			argument: name].
	menu popUpEvent: evt in: self world! !

!EnvelopeEditorMorph methodsFor: 'editing' stamp: 'ar 3/17/2001 14:24'!
clickOn: env evt: anEvent from: aLine
	self editEnvelope: env! !

!EnvelopeEditorMorph methodsFor: 'editing' stamp: 'ar 3/18/2001 17:27'!
clickOnLine: arg1 evt: arg2 envelope: arg3
	"Reorder the arguments for existing event handlers"
	(arg3 isMorph and:[arg3 eventHandler notNil]) ifTrue:[arg3 eventHandler fixReversedValueMessages].
	^self clickOn: arg1 evt: arg2 from: arg3! !

!EnvelopeEditorMorph methodsFor: 'construction' stamp: 'di 2/3/98 16:50'!
colorForEnvelope: env
	| name index |
	name := env name.
	index := #('volume' 'modulation' 'pitch' 'ratio') indexOf: name
				ifAbsent: [5].
	^ Color perform: (#(red green blue magenta black) at: index)! !

!EnvelopeEditorMorph methodsFor: 'editing' stamp: 'di 1/29/98 13:06'!
constrain: xVal adjacentTo: ix in: points
	"Return xVal, restricted between points adjacent to vertX"
	| newVal |
	newVal := xVal.
	ix > 1 ifTrue: [newVal := newVal max: (points at: ix-1) x].
	ix < points size ifTrue: [newVal := newVal min: (points at: ix+1) x].
	^ newVal! !

!EnvelopeEditorMorph methodsFor: 'construction' stamp: 'JMV 1/29/2001 10:58'!
curveChoices
	| extant others |
	extant := sound envelopes collect: [:env | env name].
	others := #('volume' 'modulation' 'pitch' 'random pitch:' 'ratio')
		reject: [:x | (extant includes: x) | ((x = 'pitch') & (extant includes: 'random pitch:')) | ((x = 'random pitch:') & (extant includes: 'pitch')) ].
	^ (extant collect: [:name | 'edit ' , name])
	, (others collect: [:name | 'add ' , name])
	, (sound envelopes size > 1
		ifTrue: [Array with: 'remove ' , envelope name]
		ifFalse: [Array new])! !

!EnvelopeEditorMorph methodsFor: 'editing' stamp: 'dgd 2/22/2003 14:24'!
deletePoint: ix 
	"If the point is a limit point, return false,
	otherwise, delete the point at ix, and return true."

	(limits includes: ix) ifTrue: [^false].
	1 to: limits size
		do: 
			[:i | 
			"Decrease limit indices beyond the deletion"

			(limits at: i) > ix ifTrue: [limits at: i put: (limits at: i) - 1]].
	envelope 
		setPoints: (envelope points 
				copyReplaceFrom: ix
				to: ix
				with: Array new)
		loopStart: (limits first)
		loopEnd: (limits second).
	^true! !

!EnvelopeEditorMorph methodsFor: 'initialization' stamp: 'di 1/31/98 10:41'!
editEnvelope: env
	envelope := env.
	limits := Array with: envelope loopStartIndex
				with: envelope loopEndIndex
				with: envelope points size.
	limitXs := limits collect: [:i | (envelope points at: i) x].
	self buildView! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'di 1/30/98 22:58'!
editNewSound
	| known i |
	known := AbstractSound soundNames.
	i := 0.
	[soundName := 'unnamed' , i printString.
	known includes: soundName]
		whileTrue: [i := 1+1].
	soundName := soundName.
	self editSound: FMSound default copy! !

!EnvelopeEditorMorph methodsFor: 'initialization' stamp: 'JMV 1/9/2001 13:43'!
editSound: aSound

	| p |
	(aSound respondsTo: #envelopes)
		ifFalse: [
			PopUpMenu inform: 'You selected a ', aSound class name, '.', String cr,
				'I can''t handle these kinds of sounds.'.
			^self ].
	sound := aSound.
	sound envelopes isEmpty ifTrue: [
		"provide a default volume envelope"
		p := OrderedCollection new.
		p add: 0@0.0; add: 10@1.0; add: 100@1.0; add: 120@0.0.
		sound addEnvelope: (VolumeEnvelope points: p loopStart: 2 loopEnd: 3)].

	self editEnvelope: sound envelopes first.
	keyboard soundPrototype: sound.
! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'di 7/14/2000 12:44'!
editSoundNamed: name

	name = 'new...' ifTrue: [^ self editNewSound].
	soundName := name.
	self editSound: (AbstractSound soundNamed: soundName) copy! !

!EnvelopeEditorMorph methodsFor: 'geometry' stamp: 'di 9/4/1998 16:03'!
extent: newExtent
	super extent: (newExtent max: (self maxTime//10*3+50 max: 355) @ 284).
	self buildView! !

!EnvelopeEditorMorph methodsFor: 'construction' stamp: 'di 1/26/98 15:37'!
handleOffset: handle
	"This is the offset from position to the bottom vertex"
	^ (handle width//2+1) @ handle height
! !

!EnvelopeEditorMorph methodsFor: 'initialization' stamp: 'di 9/5/1998 10:40'!
initOnSound: aSound title: title
	sound := aSound.
	soundName := title.
	self initialize.
! !

!EnvelopeEditorMorph methodsFor: 'initialization' stamp: 'di 7/14/2000 12:48'!
initialize
	super initialize.
	prevMouseDown := false.
	showAllEnvelopes := true.
	soundName ifNil: [soundName := 'test'].
	self editSound: (sound ifNil: [FMSound brass1 copy]).
	sound duration: 0.25.
	denominator := 7.
	self extent: 10@10.  "ie the minimum"
! !

!EnvelopeEditorMorph methodsFor: 'editing' stamp: 'dgd 2/22/2003 14:24'!
insertPointAfter: ix 
	"If there is not enough roon (in x) then return false.
	Otherwise insert a point between ix and ix+1 and return true."

	| points pt |
	points := envelope points.
	(points at: ix + 1) x - (points at: ix) x < 20 ifTrue: [^false].
	pt := ((points at: ix + 1) + (points at: ix)) // 2.
	1 to: limits size
		do: 
			[:i | 
			"Increase limit indices beyond the insertion"

			(limits at: i) > ix ifTrue: [limits at: i put: (limits at: i) + 1]].
	envelope 
		setPoints: (points 
				copyReplaceFrom: ix + 1
				to: ix
				with: (Array with: pt))
		loopStart: (limits first)
		loopEnd: (limits second).
	^true! !

!EnvelopeEditorMorph methodsFor: 'editing' stamp: 'ar 3/17/2001 14:24'!
limitHandleMove: index event: evt from: handle
	"index is the handle index = 1, 2 or 3"
	| ix p ms x points limIx |
	ix := limits at: index.  "index of corresponding vertex"
	p := evt cursorPoint adhereTo: graphArea bounds.
	ms := self msFromX: p x + (self handleOffset: handle) x.

	"Constrain move to adjacent points on ALL envelopes"
	sound envelopes do:
		[:env | limIx := env perform:
			(#(loopStartIndex loopEndIndex decayEndIndex) at: index).
		ms := self constrain: ms adjacentTo: limIx in: env points].

	"Update the handle, the vertex and the line being edited"
	x := self xFromMs: ms.
	handle position: (x @ graphArea top) - (self handleOffset: handle).
	line verticesAt: ix put: x @ (line vertices at: ix) y.

	sound envelopes do:
		[:env | limIx := env perform:
			(#(loopStartIndex loopEndIndex decayEndIndex) at: index).
		points := env points.
		points at: limIx put: ms @ (points at: limIx) y.
		env setPoints: points loopStart: env loopStartIndex loopEnd: env loopEndIndex].! !

!EnvelopeEditorMorph methodsFor: 'editing' stamp: 'ar 3/18/2001 17:27'!
limitHandleMoveEvent: arg1 from: arg2 index: arg3
	"Reorder the arguments for existing event handlers"
	(arg3 isMorph and:[arg3 eventHandler notNil]) ifTrue:[arg3 eventHandler fixReversedValueMessages].
	^self limitHandleMove: arg1 event: arg2 from: arg3! !

!EnvelopeEditorMorph methodsFor: 'scaling' stamp: 'di 1/27/98 14:40'!
maxTime
	^ (envelope points at: limits last) x + 100! !

!EnvelopeEditorMorph methodsFor: 'scaling' stamp: 'di 1/26/98 14:10'!
msFromX: x
	^ (x - graphArea left)//pixPerTick*10! !

!EnvelopeEditorMorph methodsFor: 'playing' stamp: 'di 2/3/98 17:07'!
playNothing
! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'di 1/31/98 16:49'!
readFileNamed: fileName
	| snd |
	snd := Compiler evaluate:
		(FileStream readOnlyFileNamed: fileName) contentsOfEntireFile.
	soundName := fileName copyFrom: 1 to: fileName size-4. "---.fmp"
	self editSound: snd! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'RAA 6/12/2000 08:58'!
readFromDisk: evt
	| menu |
	menu := MenuMorph new.
	(FileDirectory default fileNamesMatching: '*.fmp') do:
		[:fileName |
		menu add: fileName
			target: self selector: #readFileNamed:
			argument: fileName].
	menu popUpEvent: evt in: self world! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'di 2/3/98 16:50'!
removeEnvelope
	(PopUpMenu confirm: 'Really remove ' , envelope name , '?')
		ifFalse: [^ self].
	sound removeEnvelope: envelope.
	self editEnvelope: sound envelopes first.! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'sw 5/23/2001 14:26'!
saveLibToDisk: evt
	"Save the library to disk"

	| newName f snd |
	newName := FillInTheBlank request: 'Please confirm name for library...'
						initialAnswer: 'MySounds'.
	newName isEmpty ifTrue: [^ self].
	f := FileStream newFileNamed: newName , '.fml'.
	AbstractSound soundNames do:
		[:name | snd := AbstractSound soundNamed: name.
		"snd isStorable" true ifTrue: [f nextChunkPut: 'AbstractSound soundNamed: ' , name , ' put: ' , snd storeString; cr; cr]
			ifFalse: [self inform: name , ' is not currently storable']].
	f close! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'di 2/17/98 11:05'!
saveSound: evt
	| newName |
	newName := FillInTheBlank request: 'Please confirm name for save...'
						initialAnswer: soundName.
	newName isEmpty ifTrue: [^ self].
	AbstractSound soundNamed: newName put: sound.
	soundName := newName.! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'di 1/31/98 16:41'!
saveToDisk: evt
	| newName f |
	newName := FillInTheBlank request: 'Please confirm name for save...'
						initialAnswer: soundName.
	newName isEmpty ifTrue: [^ self].
	f := FileStream newFileNamed: newName , '.fmp'.
	sound storeOn: f.
	f close! !

!EnvelopeEditorMorph methodsFor: 'menu' stamp: 'di 1/31/98 01:36'!
setDenominator: denom
	denominator := denom.
	self buildView! !

!EnvelopeEditorMorph methodsFor: 'initialization' stamp: 'di 11/7/2000 12:45'!
soundBeingEdited

	^ sound! !

!EnvelopeEditorMorph methodsFor: 'construction' stamp: 'di 7/14/2000 12:56'!
soundChoices
	^ #('new...') , AbstractSound soundNames! !

!EnvelopeEditorMorph methodsFor: 'stepping and presenter' stamp: 'di 6/7/1999 15:37'!
step
	| mouseDown hand |
	hand := self world firstHand.
	(bounds containsPoint: hand position) ifFalse: [^ self].

	mouseDown := hand lastEvent redButtonPressed.
	mouseDown not & prevMouseDown ifTrue:
		["Mouse just went up"
		limitXs = (limits collect: [:i | (envelope points at: i) x]) ifFalse:
			["Redisplay after changing limits"
			self editEnvelope: envelope]].
	prevMouseDown := mouseDown! !

!EnvelopeEditorMorph methodsFor: 'testing' stamp: 'di 1/30/98 13:29'!
stepTime
	^ 100! !

!EnvelopeEditorMorph methodsFor: 'scaling' stamp: 'di 1/31/98 01:10'!
valueFromY: y
	"The convention is that envelope values are between 0.0 and 1.0"
	| value |
	value := (graphArea bottom - y) asFloat / (graphArea height).
	envelope updateSelector = #ratio: ifTrue:
		["Ratio gets gridded by denominator"
		^ (value * envelope scale * denominator) rounded asFloat / denominator / envelope scale].
	^ value! !

!EnvelopeEditorMorph methodsFor: 'rounding' stamp: 'di 7/14/2000 11:13'!
wantsRoundedCorners
	^ Preferences roundedWindowCorners or: [super wantsRoundedCorners]! !

!EnvelopeEditorMorph methodsFor: 'scaling' stamp: 'di 1/26/98 14:09'!
xFromMs: ms
	^ graphArea left + (ms//10*pixPerTick)! !

!EnvelopeEditorMorph methodsFor: 'scaling' stamp: 'di 1/27/98 00:23'!
yFromValue: val
	"The convention is that envelope values are between 0.0 and 1.0"
	^ graphArea bottom - (val* (graphArea height))! !

RectangleMorph subclass: #GradientFillMorph
	instanceVariableNames: 'fillColor2 gradientDirection colorArray colorDepth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!GradientFillMorph commentStamp: '<historical>' prior: 0!
Class GradientFillMorph is obsolete. For getting gradient fills use a BorderedMorph with an appropriate fill style, e.g.,

	| morph fs |
	morph _ BorderedMorph new.
	fs _ GradientFillStyle ramp: {0.0 -> Color red. 1.0 -> Color green}.
	fs origin: morph bounds center.
	fs direction: (morph bounds width // 2) @ 0.
	fs radial: true.
	morph fillStyle: fs.
	World primaryHand attachMorph: morph.

Here's the old (obsolete) comment:
GradientFills cache an array of bitpatterns for the colors across their rectangle.  It costs a bit of space, but makes display fast enough to eschew the use of a bitmap.  The array must be recomputed whenever the colors, dimensions or display depth change.!

!GradientFillMorph methodsFor: 'menu' stamp: 'dgd 8/30/2003 21:45'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'gradient color' translated action: #setGradientColor:.
	gradientDirection == #vertical
		ifTrue: [aCustomMenu add: 'horizontal pan' translated action: #beHorizontal]
		ifFalse: [aCustomMenu add: 'vertical pan' translated action: #beVertical].
! !

!GradientFillMorph methodsFor: 'menu' stamp: 'di 11/2/97 14:35'!
beHorizontal
	gradientDirection := #horizontal.
	self changed! !

!GradientFillMorph methodsFor: 'menu' stamp: 'di 11/2/97 14:35'!
beVertical
	gradientDirection := #vertical.
	self changed! !

!GradientFillMorph methodsFor: 'updating' stamp: 'di 11/13/97 15:20'!
changed
	super changed.
	self releaseCachedState! !

!GradientFillMorph methodsFor: 'drawing' stamp: 'gm 2/22/2003 13:15'!
drawOn: aCanvas 
	"Note that this could run about 4 times faster if we got hold of
	the canvas's port and just sent it copyBits with new coords and color"

	| style |
	super drawOn: aCanvas.
	(color isColor) ifFalse: [^self].	"An InfiniteForm, for example"
	color = Color transparent ifTrue: [^self].	"Skip the gradient attempts, which will drop into debugger"
	color = fillColor2 ifTrue: [^self].	"same color; no gradient"
	"Check if we can use the cached gradient fill"
	((self valueOfProperty: #cachedGradientColor1) = color 
		and: [(self valueOfProperty: #cachedGradientColor2) = fillColor2]) 
			ifTrue: [style := self valueOfProperty: #cachedGradientFill].
	style ifNil: 
			[style := GradientFillStyle ramp: { 
								0.0 -> color.
								1.0 -> fillColor2}.
			self setProperty: #cachedGradientColor1 toValue: color.
			self setProperty: #cachedGradientColor2 toValue: fillColor2.
			self setProperty: #cachedGradientFill toValue: style].
	style origin: self position.
	style direction: (gradientDirection == #vertical 
				ifTrue: [0 @ self height]
				ifFalse: [self width @ 0]).
	aCanvas fillRectangle: self innerBounds fillStyle: style! !

!GradientFillMorph methodsFor: 'as yet unclassified' stamp: 'jm 11/5/97 12:40'!
gradientFillColor: aColor

	fillColor2 := aColor.
	self changed.
! !

!GradientFillMorph methodsFor: 'accessing' stamp: 'di 1/3/1999 12:24'!
hasTranslucentColor
	"Answer true if this any of this morph is translucent but not transparent."

	(color isColor and: [color isTranslucentColor]) ifTrue: [^ true].
	(fillColor2 isColor and: [fillColor2 isTranslucentColor]) ifTrue: [^ true].
	^ false
! !

!GradientFillMorph methodsFor: 'initialization' stamp: 'di 1/9/98 22:17'!
initialize
	super initialize.
	borderWidth := 0.
	fillColor2 := Color black.
	gradientDirection := #vertical! !

!GradientFillMorph methodsFor: 'as yet unclassified' stamp: 'ar 10/5/2000 18:52'!
setGradientColor: evt

	self changeColorTarget: self selector: #gradientFillColor: originalColor: fillColor2 hand: evt hand! !

RectangleMorph subclass: #GraphMorph
	instanceVariableNames: 'data dataColor cursor cursorColor cursorColorAtZeroCrossings startIndex minVal maxVal cachedForm hasChanged'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!GraphMorph commentStamp: '<historical>' prior: 0!
I display a graph of numbers, normalized so the full range of values just fits my height. I support a movable cursor that can be dragged with the mouse.

Implementation notes: Some operations on me may be done at sound sampling rates (e.g. 11-44 thousand times/second). To allow such high bandwidth application, certain operations that change my appearance do not immediately report a damage rectangle. Instead, a flag is set indicating that my display needs to refreshed and a step method reports the damage rectangle if that flag is set. Also, I cache a bitmap of my graph to allow the cursor to be moved without redrawing the graph.
!

!GraphMorph class methodsFor: 'parts bin' stamp: 'sw 8/2/2001 12:50'!
descriptionForPartsBin
	^ self partName:	'Graph'
		categories:		#('Useful')
		documentation:	'A graph of numbers, normalized so the full range of values just fits my height.  I support a movable cursor that can be dragged with the mouse.'! !

!GraphMorph methodsFor: 'commands' stamp: 'marcus.denker 8/17/2008 21:25'!
appendValue: aPointOrNumber

	| newVal |
	data := data asOrderedCollection.
	newVal := self asNumber: aPointOrNumber.
	data addLast: newVal.
	newVal < minVal ifTrue: [minVal := newVal].
	newVal > maxVal ifTrue: [maxVal := newVal].
	self cursor: data size.
	self flushCachedForm.
! !

!GraphMorph methodsFor: 'commands' stamp: 'jm 7/30/1998 12:17'!
centerCursor
	"Scroll so that the cursor is as close as possible to the center of my window."

	| w |
	w := self width - (2 * borderWidth).
	self startIndex: ((cursor - (w // 2)) max: 1).
! !

!GraphMorph methodsFor: 'commands' stamp: ''!
clear

	self startIndex: 1.
	self cursor: 1.
	self data: OrderedCollection new.
! !

!GraphMorph methodsFor: 'accessing' stamp: ''!
color: aColor

	super color: aColor.
	self flushCachedForm.
! !

!GraphMorph methodsFor: 'objects from disk' stamp: 'RAA 12/20/2000 17:46'!
convertToCurrentVersion: varDict refStream: smartRefStrm
	
	hasChanged ifNil: [hasChanged := false].
	^super convertToCurrentVersion: varDict refStream: smartRefStrm.

! !

!GraphMorph methodsFor: 'e-toy support' stamp: ''!
cursor

	^ cursor
! !

!GraphMorph methodsFor: 'e-toy support' stamp: 'jm 6/17/1999 21:41'!
cursor: aNumber

	| truncP |
	cursor ~= aNumber ifTrue:  [
		cursor := aNumber.
		truncP := aNumber truncated.
		truncP > data size ifTrue: [cursor := data size].
		truncP < 0 ifTrue: [cursor := 1].
		self keepIndexInView: truncP.
		hasChanged := true].
! !

!GraphMorph methodsFor: 'accessing' stamp: ''!
cursorAtEnd

	^ cursor truncated >= data size
! !

!GraphMorph methodsFor: 'accessing' stamp: ''!
cursorColor

	^ cursorColor
! !

!GraphMorph methodsFor: 'accessing' stamp: ''!
cursorColor: aColor

	cursorColor := aColor.
	self flushCachedForm.
! !

!GraphMorph methodsFor: 'accessing' stamp: 'jm 7/8/1998 20:32'!
cursorColorAtZeroCrossing

	^ cursorColorAtZeroCrossings
! !

!GraphMorph methodsFor: 'accessing' stamp: 'jm 7/8/1998 20:32'!
cursorColorAtZeroCrossings: aColor

	cursorColorAtZeroCrossings := aColor.
	self flushCachedForm.
! !

!GraphMorph methodsFor: 'accessing' stamp: 'jm 6/17/1999 21:43'!
cursorWrapped: aNumber

	| sz |
	cursor ~= aNumber ifTrue: [
		cursor := aNumber.
		sz := data size.
		sz = 0
			ifTrue: [cursor := 1]
			ifFalse: [
				((cursor >= (sz + 1)) or: [cursor < 0]) ifTrue: [
					cursor := cursor - ((cursor // sz) * sz)].
				cursor < 1 ifTrue: [cursor := sz + cursor]].
		"assert: 1 <= cursor < data size + 1"
		hasChanged := true].
! !

!GraphMorph methodsFor: 'accessing' stamp: ''!
data

	^ data
! !

!GraphMorph methodsFor: 'accessing' stamp: ''!
data: aCollection

	data := aCollection.
	maxVal := minVal := 0.
	data do: [:x |
		x < minVal ifTrue: [minVal := x].
		x > maxVal ifTrue: [maxVal := x]].

	self flushCachedForm.
! !

!GraphMorph methodsFor: 'accessing' stamp: ''!
dataColor

	^ dataColor
! !

!GraphMorph methodsFor: 'accessing' stamp: ''!
dataColor: aColor

	dataColor := aColor.
	self flushCachedForm.
! !

!GraphMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:27'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color
		r: 0.8
		g: 0.8
		b: 0.6! !

!GraphMorph methodsFor: 'private' stamp: 'jm 6/17/1999 21:36'!
drawCursorOn: aCanvas

	| ptr x r c |
	ptr := (cursor asInteger max: 1) min: data size.
	c := cursorColor.
	((ptr > 1) and: [ptr < data size]) ifTrue: [
		(data at: ptr) sign ~= (data at: ptr + 1) sign
			ifTrue: [c := cursorColorAtZeroCrossings]].
	r := self innerBounds.
	x := r left + ptr - startIndex.
	((x >= r left) and: [x <= r right]) ifTrue: [
		aCanvas fillRectangle: (x@r top corner: x + 1@r bottom) color: c].
! !

!GraphMorph methodsFor: 'private' stamp: ''!
drawDataOn: aCanvas

	| yScale baseLine x start end value left top bottom right |
	super drawOn: aCanvas.

	data isEmpty ifTrue: [^ self].
	maxVal = minVal ifTrue: [
		yScale := 1.
	] ifFalse: [
		yScale := (bounds height - (2 * borderWidth)) asFloat / (maxVal - minVal)].
	baseLine := bounds bottom - borderWidth + (minVal * yScale) truncated.
	left := top := 0. right := 10. bottom := 0.
	x := bounds left + borderWidth.
	start := (startIndex asInteger max: 1) min: data size.
	end := (start + bounds width) min: data size.
	start to: end do: [:i |
		left := x truncated. right := x + 1.
		right > (bounds right - borderWidth) ifTrue: [^ self].
		value := (data at: i) asFloat.
		value >= 0.0 ifTrue: [
			top := baseLine - (yScale * value) truncated.
			bottom := baseLine.
		] ifFalse: [
			top := baseLine.
			bottom := baseLine - (yScale * value) truncated].
		aCanvas fillRectangle: (left@top corner: right@bottom) color: dataColor.
		x := x + 1].
! !

!GraphMorph methodsFor: 'drawing' stamp: 'dgd 2/22/2003 14:39'!
drawOn: aCanvas 
	| c |
	cachedForm isNil 
		ifTrue: 
			[c := Display defaultCanvasClass extent: bounds extent.
			c translateBy: bounds origin negated
				during: [:tempCanvas | self drawDataOn: tempCanvas].
			cachedForm := c form].
	aCanvas 
		cache: bounds
		using: cachedForm
		during: [:cachingCanvas | self drawDataOn: cachingCanvas].
	self drawCursorOn: aCanvas! !

!GraphMorph methodsFor: 'private' stamp: 'jm 6/17/1999 20:10'!
flushCachedForm

	cachedForm := nil.
	hasChanged := true.
! !

!GraphMorph methodsFor: 'event handling' stamp: 'jm 10/18/97 11:32'!
handlesMouseDown: evt

	evt shiftPressed
		ifTrue: [^ super handlesMouseDown: evt]
		ifFalse: [^ true].
! !

!GraphMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:28'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self extent: 365 @ 80.

	dataColor := Color darkGray.
	cursor := 1.0.
	"may be fractional"
	cursorColor := Color red.
	cursorColorAtZeroCrossings := Color red.
	startIndex := 1.
	hasChanged := false.
	self
		data: ((0 to: 360 - 1)
				collect: [:x | (100.0 * x degreesToRadians sin) asInteger])! !

!GraphMorph methodsFor: 'accessing' stamp: 'dgd 2/22/2003 14:40'!
interpolatedValueAtCursor
	| sz prev frac next |
	data isEmpty ifTrue: [^0].
	sz := data size.
	cursor < 0 ifTrue: [^data first].	"just to be safe, though cursor shouldn't be negative"
	prev := cursor truncated.
	frac := cursor - prev.
	prev < 1 ifTrue: [prev := sz].
	prev > sz ifTrue: [prev := 1].
	"assert: 1 <= prev <= sz"
	frac = 0 ifTrue: [^data at: prev].	"no interpolation needed"

	"interpolate"
	next := prev = sz ifTrue: [1] ifFalse: [prev + 1].
	^(1.0 - frac) * (data at: prev) + (frac * (data at: next))! !

!GraphMorph methodsFor: 'private' stamp: 'jm 4/21/1999 11:30'!
keepIndexInView: index

	| w newStart |
	w := bounds width - (2 * borderWidth).
	index < startIndex ifTrue: [
		newStart := index - w + 1.
		^ self startIndex: (newStart max: 1)].
	index > (startIndex + w) ifTrue: [
		^ self startIndex: (index min: data size)].
! !

!GraphMorph methodsFor: 'accessing' stamp: 'dgd 2/22/2003 14:40'!
lastValue
	data isEmpty ifTrue: [^0].
	^data last! !

!GraphMorph methodsFor: 'accessing' stamp: 'jm 4/21/1999 11:25'!
lastValue: aNumber

	self appendValue: aNumber.
! !

!GraphMorph methodsFor: 'layout' stamp: ''!
layoutChanged

	super layoutChanged.
	cachedForm := nil.
! !

!GraphMorph methodsFor: 'commands' stamp: 'ads 7/31/2003 11:11'!
loadSineWave

	self loadSoundData: SoundBuffer sineTable.
! !

!GraphMorph methodsFor: 'commands' stamp: 'jm 4/22/1999 14:17'!
loadSound: aSound

	self loadSoundData: aSound samples.
! !

!GraphMorph methodsFor: 'commands' stamp: 'jm 4/22/1999 14:23'!
loadSoundData: aCollection

	| scale absV newData |
	scale := 0.
	aCollection do: [:v | (absV := v abs) > scale ifTrue: [scale := absV]].
	scale := 100.0 / scale.
	newData := OrderedCollection new: aCollection size.
	1 to: aCollection size do: [:i | newData addLast: (scale * (aCollection at: i))].

	self data: newData.
	self startIndex: 1.
	self cursor: 1.
! !

!GraphMorph methodsFor: 'event handling' stamp: 'jm 10/18/97 11:52'!
mouseMove: evt

	| x w |
	x := evt cursorPoint x - (bounds left + borderWidth).
	w := self width - (2 * borderWidth).

	self changed.
	x < 0 ifTrue: [
		cursor := startIndex + (3 * x).
		cursor := (cursor max: 1) min: data size.
		^ self startIndex: cursor].
	x > w ifTrue: [
		cursor := startIndex + w + (3 * (x - w)).
		cursor := (cursor max: 1) min: data size.
		^ self startIndex: cursor - w].

	cursor := ((startIndex + x) max: 1) min: data size.
! !

!GraphMorph methodsFor: 'commands' stamp: 'gk 2/23/2004 21:08'!
playOnce

	| scale absV scaledData |
	data isEmpty ifTrue: [^ self].  "nothing to play"
	scale := 1.
	data do: [:v | (absV := v abs) > scale ifTrue: [scale := absV]].
	scale := 32767.0 / scale.
	scaledData := SoundBuffer newMonoSampleCount: data size.
	1 to: data size do: [:i | scaledData at: i put: (scale * (data at: i)) truncated].
	SoundService default playSampledSound: scaledData rate: 11025.
! !

!GraphMorph methodsFor: 'commands' stamp: ''!
reverse

	data := data reversed.
	self flushCachedForm.
! !

!GraphMorph methodsFor: 'accessing' stamp: ''!
startIndex

	^ startIndex
! !

!GraphMorph methodsFor: 'accessing' stamp: ''!
startIndex: aNumber

	startIndex ~= aNumber ifTrue:  [
		startIndex := aNumber asInteger.
		self flushCachedForm].
! !

!GraphMorph methodsFor: 'stepping and presenter' stamp: 'dgd 2/22/2003 14:40'!
step
	"Make a deferred damage rectangle if I've changed. This allows applications to call methods that invalidate my display at high-bandwidth without paying the cost of doing the damage reporting on ever call; they can merely set hasChanged to true."

	super step.
	hasChanged isNil ifTrue: [hasChanged := false].
	hasChanged 
		ifTrue: 
			[self changed.
			hasChanged := false]! !

!GraphMorph methodsFor: 'accessing' stamp: ''!
valueAtCursor

	data isEmpty ifTrue: [^ 0].
	^ data at: ((cursor truncated max: 1) min: data size)
! !

!GraphMorph methodsFor: 'accessing' stamp: ''!
valueAtCursor: aPointOrNumber

	data isEmpty ifTrue: [^ 0].
	data
		at: ((cursor truncated max: 1) min: data size)
		put: (self asNumber: aPointOrNumber).
	self flushCachedForm.
! !

RectangleMorph subclass: #HeadingMorph
	instanceVariableNames: 'degrees magnitude'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!HeadingMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:34'!
defaultBorderWidth
"answer the default border width for the receiver"
	^ 1! !

!HeadingMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:33'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color
		r: 0.6
		g: 1.0
		b: 1.0! !

!HeadingMorph methodsFor: 'accessing' stamp: ''!
degrees

	^ (degrees + 90.0) \\ 360.0! !

!HeadingMorph methodsFor: 'accessing' stamp: ''!
degrees: aNumber

	degrees := (aNumber asFloat + 270.0) \\ 360.0.! !

!HeadingMorph methodsFor: 'drawing' stamp: ''!
drawArrowFrom: p1 to: p2 width: w color: aColor on: aCanvas

	| d p |
	d := (p1 - p2) theta radiansToDegrees.
	aCanvas line: p1 to: p2 width: w color: aColor.
	p := p2 + (Point r: 5 degrees: d - 50).
	aCanvas line: p to: p2 width: w color: aColor.
	p := p2 + (Point r: 5 degrees: d + 50).
	aCanvas line: p to: p2 width: w color: aColor.
! !

!HeadingMorph methodsFor: 'drawing' stamp: ''!
drawOn: aCanvas

	| x y r center box |
	super drawOn: aCanvas.
	box := self innerBounds.
	1 to: 9 do: [:i |
		x := box left + ((box width * i) // 10).
		aCanvas line: (x@box top) to: (x@(box bottom - 1)) color: 
Color black.
		y := box top + ((box height * i) // 10).
		aCanvas line: (box left@y) to: ((box right - 1)@y) color: 
Color black].

	r := ((box width asFloat * magnitude asFloat) / 2.0) - 1.0.
	center := box center.
	self drawArrowFrom: center - (1@1)
		to: center + ((r * degrees degreesToRadians cos)@0) - (1@1)
		width: 3
		color: (Color red)
		on: aCanvas.
	self drawArrowFrom: center - (1@1)
		to: center + (0@(r * degrees degreesToRadians sin)) - (1@1)
		width: 3
		color: (Color red)
		on: aCanvas.
	self drawArrowFrom: center - (1@1)
		to: center + (Point r: r degrees: degrees) - (1@1)
		width: 3
		color: Color black
		on: aCanvas.
! !

!HeadingMorph methodsFor: 'geometry' stamp: ''!
extent: aPoint
	"Contrain extent to be square."

	| d |
	d := aPoint x min: aPoint y.
	super extent: d@d.
! !

!HeadingMorph methodsFor: 'event handling' stamp: ''!
handlesMouseDown: evt

	^ true
! !

!HeadingMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:34'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	degrees := 90.0.
	magnitude := 1.0.
	
	self extent: 160 @ 160! !

!HeadingMorph methodsFor: 'accessing' stamp: ''!
magnitude

	^ magnitude! !

!HeadingMorph methodsFor: 'accessing' stamp: ''!
magnitude: aNumber

	magnitude := (aNumber asFloat max: 0.0) min: 1.0.! !

!HeadingMorph methodsFor: 'events' stamp: 'mk 11/7/2003 11:35'!
mouseDown: evt

	| v |
	self changed.
	v := evt cursorPoint - bounds center.
	degrees := v theta radiansToDegrees.
	magnitude := (v r asFloat / (bounds width asFloat / 2.0)) min: 1.0.
! !

!HeadingMorph methodsFor: 'events' stamp: 'mk 11/7/2003 11:36'!
mouseMove: evt

	self mouseDown: evt! !

RectangleMorph subclass: #InterimSoundMorph
	instanceVariableNames: 'graphic sound'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SoundInterface'!

!InterimSoundMorph methodsFor: 'as yet unclassified' stamp: 'di 2/17/2000 20:30'!
addGraphic

	graphic := SketchMorph withForm: self speakerGraphic.
	graphic position: bounds center - (graphic extent // 2).
	self addMorph: graphic.
! !

!InterimSoundMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:38'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!InterimSoundMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:27'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color
		r: 0
		g: 0.8
		b: 0.6! !

!InterimSoundMorph methodsFor: 'event handling' stamp: 'jm 9/18/97 15:26'!
handlesMouseDown: evt

	(graphic containsPoint: evt cursorPoint)
		ifTrue: [^ true]
		ifFalse: [^ super handlesMouseDown: evt].
! !

!InterimSoundMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 20:57'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	
	self extent: 30 @ 30.
	self addGraphic.
	sound := PluckedSound
				pitch: 880.0
				dur: 2.0
				loudness: 0.5! !

!InterimSoundMorph methodsFor: 'event handling' stamp: 'jm 9/18/97 18:56'!
mouseDown: evt

	(graphic containsPoint: evt cursorPoint)
		ifTrue: [sound copy play]
		ifFalse: [super mouseDown: evt].
! !

!InterimSoundMorph methodsFor: 'as yet unclassified' stamp: 'jm 9/18/97 15:02'!
sound

	^ sound
! !

!InterimSoundMorph methodsFor: 'as yet unclassified' stamp: 'jm 9/18/97 15:01'!
sound: aSound

	sound := aSound.
! !

!InterimSoundMorph methodsFor: 'as yet unclassified' stamp: 'jm 9/18/97 15:20'!
speakerGraphic

	^ Form
		extent: 19@18
		depth: 8
		fromArray: #(0 0 1493172224 2816 0 0 0 1493172224 11 0 0 138 1493172224 184549376 184549376 0 35509 2315255808 720896 720896 0 9090522 2315255808 2816 720896 0 2327173887 2315255819 2816 720896 138 3051028442 2315255819 2816 2816 1505080590 4294957786 2315255808 184549387 2816 3053453311 4292532917 1493172224 184549387 2816 1505080714 3048584629 1493172224 184549387 2816 9079434 3048584629 1493172224 184549387 2816 138 2327164341 1493172235 2816 2816 0 2324346293 1493172235 2816 720896 0 9079477 1493172224 2816 720896 0 35466 1493172224 720896 720896 0 138 0 184549376 184549376 0 0 0 11 0 0 0 0 2816 0)
		offset: 0@0
! !

RectangleMorph subclass: #MorphExample
	instanceVariableNames: 'phase ball star'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!MorphExample commentStamp: 'kfr 10/26/2003 18:38' prior: 0!
This is a example of how to use a morph. It consists of only two 
methods, initialize and step.

DoIt:
MorphExample new openInWorld.



!

!MorphExample methodsFor: 'initialization' stamp: 'dgd 2/21/2003 19:59'!
initialize
	"initialize the state of the receiver"
	super initialize.
	phase := 1.
	self extent: 200 @ 200.
	ball := EllipseMorph new extent: 30 @ 30.
	self
		addMorph: ((star := StarMorph new extent: 150 @ 150) center: self center)! !

!MorphExample methodsFor: 'stepping and presenter' stamp: 'kfr 10/26/2003 18:33'!
step
	phase := phase\\8 + 1.
	phase = 1 ifTrue: [^ ball delete].
	phase < 4 ifTrue:[^self].
	phase = 4 ifTrue: [self addMorph: ball].
	ball align: ball center with: (star vertices at: (phase-3*2)).! !

RectangleMorph subclass: #PianoKeyboardMorph
	instanceVariableNames: 'whiteKeyColor blackKeyColor playingKeyColor nOctaves target noteOnSelector noteOffSelector soundPrototype soundPlaying'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SoundInterface'!

PianoKeyboardMorph subclass: #MIDIPianoKeyboardMorph
	instanceVariableNames: 'midiPort channel velocity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SoundInterface'!

!MIDIPianoKeyboardMorph commentStamp: '<historical>' prior: 0!
I implement a piano keyboard that can be played with the mouse. I can output to a MIDI port, if MIDI is supported on this platform. I can also spawn controllers for other MIDI parameters, such as pitch bend.
!

!MIDIPianoKeyboardMorph methodsFor: 'menus' stamp: 'dgd 8/30/2003 21:50'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	midiPort
		ifNil: [aCustomMenu add: 'play via MIDI' translated action: #openMIDIPort]
		ifNotNil: [
			aCustomMenu add: 'play via built in synth' translated action: #closeMIDIPort.
			aCustomMenu add: 'new MIDI controller' translated action: #makeMIDIController:].
! !

!MIDIPianoKeyboardMorph methodsFor: 'as yet unclassified' stamp: 'jm 10/12/1998 15:57'!
closeMIDIPort

	midiPort := nil.
! !

!MIDIPianoKeyboardMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 20:55'!
initialize
"initialize the state of the receiver"
	super initialize.
""
	SimpleMIDIPort midiIsSupported
		ifTrue: [midiPort := SimpleMIDIPort openDefault].
	channel := 1.
	velocity := 100! !

!MIDIPianoKeyboardMorph methodsFor: 'as yet unclassified' stamp: 'jm 10/12/1998 18:11'!
makeMIDIController: evt

	self world activeHand attachMorph:
		(MIDIControllerMorph new midiPort: midiPort).
! !

!MIDIPianoKeyboardMorph methodsFor: 'simple keyboard' stamp: 'ar 3/17/2001 14:40'!
mouseDownPitch: midiKey event: event noteMorph: noteMorph

	midiPort ifNil: [^ super mouseDownPitch: midiKey-1 event: event noteMorph: noteMorph].
	noteMorph color: playingKeyColor.
	soundPlaying
		ifNil: [midiPort ensureOpen]
		ifNotNil: [self turnOffNote].
	self turnOnNote: midiKey + 23.
! !

!MIDIPianoKeyboardMorph methodsFor: 'simple keyboard' stamp: 'ar 3/17/2001 14:41'!
mouseUpPitch: midiKey event: event noteMorph: noteMorph

	midiPort ifNil: [
		^ super mouseUpPitch: midiKey event: event noteMorph: noteMorph].

	noteMorph color:
		((#(0 1 3 5 6 8 10) includes: midiKey \\ 12)
			ifTrue: [whiteKeyColor]
			ifFalse: [blackKeyColor]).
	soundPlaying ifNotNil: [self turnOffNote].
! !

!MIDIPianoKeyboardMorph methodsFor: 'as yet unclassified' stamp: 'jm 10/12/1998 18:00'!
openMIDIPort

	| portNum |
	portNum := SimpleMIDIPort outputPortNumFromUser.
	portNum ifNil: [^ self].
	midiPort := SimpleMIDIPort openOnPortNumber: portNum.
! !

!MIDIPianoKeyboardMorph methodsFor: 'as yet unclassified' stamp: 'jm 10/12/1998 15:44'!
turnOffNote

	midiPort notNil & soundPlaying notNil ifTrue: [
		soundPlaying isInteger ifTrue: [
			midiPort midiCmd: 16r90 channel: channel byte: soundPlaying byte: 0]].
	soundPlaying := nil.
! !

!MIDIPianoKeyboardMorph methodsFor: 'as yet unclassified' stamp: 'jm 10/12/1998 16:25'!
turnOnNote: midiKey

	midiPort midiCmd: 16r90 channel: channel byte: midiKey byte: velocity.
	soundPlaying := midiKey.
! !

!PianoKeyboardMorph class methodsFor: 'parts bin' stamp: 'sw 8/2/2001 14:52'!
descriptionForPartsBin
	^ self partName:	'PianoKeyboard'
		categories:		#('Multimedia')
		documentation:	'A piano keyboard'! !

!PianoKeyboardMorph methodsFor: 'simple keyboard' stamp: 'ar 3/17/2001 14:30'!
buildKeyboard
	| wtWid bkWid keyRect octavePt nWhite nBlack |
	self removeAllMorphs.
	wtWid := 8. bkWid := 5.
	self extent: 10@10.
	1 to: nOctaves+1 do:
		[:i | i <= nOctaves ifTrue: [nWhite := 7.  nBlack := 5]
						ifFalse: [nWhite := 1.  nBlack := 0 "High C"].
		octavePt := self innerBounds topLeft + ((7*wtWid*(i-1)-1)@-1).
		1 to: nWhite do:
			[:j | keyRect := octavePt + (j-1*wtWid@0) extent: (wtWid+1)@36.
			self addMorph: ((RectangleMorph newBounds: keyRect color: whiteKeyColor)
								borderWidth: 1;
				on: #mouseDown send: #mouseDownPitch:event:noteMorph: to: self
								withValue: i-1*12 + (#(1 3 5 6 8 10 12) at: j))].
		1 to: nBlack do:
			[:j | keyRect := octavePt + ((#(6 15 29 38 47) at: j)@1) extent: bkWid@21.
			self addMorph: ((Morph newBounds: keyRect color: blackKeyColor)
				on: #mouseDown send: #mouseDownPitch:event:noteMorph: to: self
								withValue: i-1*12 + (#(2 4 7 9 11) at: j))]].
	self submorphsDo:
		[:m | m on: #mouseMove send: #mouseMovePitch:event:noteMorph: to: self;
				on: #mouseUp send: #mouseUpPitch:event:noteMorph: to: self;
				on: #mouseEnterDragging send: #mouseDownPitch:event:noteMorph: to: self;
				on: #mouseLeaveDragging send: #mouseUpPitch:event:noteMorph: to: self].
	self extent: (self fullBounds extent + borderWidth - 1)! !

!PianoKeyboardMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:29'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color veryLightGray! !

!PianoKeyboardMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 20:56'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	
	whiteKeyColor := Color gray: 0.95.
	blackKeyColor := Color black.
	playingKeyColor := Color red.
	nOctaves := 6.
	self buildKeyboard.
	soundPrototype := FMSound brass1 duration: 9.9! !

!PianoKeyboardMorph methodsFor: 'simple keyboard' stamp: 'ar 3/18/2001 17:27'!
mouseDownEvent: arg1 noteMorph: arg2 pitch: arg3
	"Reorder the arguments for existing event handlers"
	(arg3 isMorph and:[arg3 eventHandler notNil]) ifTrue:[arg3 eventHandler fixReversedValueMessages].
	^self mouseDownPitch: arg1 event: arg2 noteMorph: arg3! !

!PianoKeyboardMorph methodsFor: 'simple keyboard' stamp: 'ar 3/17/2001 14:27'!
mouseDownPitch: midiKey event: event noteMorph: noteMorph
	| pitch |
	event hand hasSubmorphs ifTrue: [^ self  "no response if drag something over me"].
	event hand mouseFocus ifNil:
		["If dragged into me, then establish focus so I'll see moves"
		event hand newMouseFocus: noteMorph event: event].
	noteMorph color: playingKeyColor.
	pitch := AbstractSound pitchForMIDIKey: midiKey + 23.
	soundPlaying ifNotNil: [soundPlaying stopGracefully].
	soundPlaying := soundPrototype soundForPitch: pitch dur: 100.0 loudness: 0.3.
	SoundPlayer resumePlaying: soundPlaying quickStart: true.
! !

!PianoKeyboardMorph methodsFor: 'simple keyboard' stamp: 'ar 3/18/2001 17:27'!
mouseMoveEvent: arg1 noteMorph: arg2 pitch: arg3
	"Reorder the arguments for existing event handlers"
	(arg3 isMorph and:[arg3 eventHandler notNil]) ifTrue:[arg3 eventHandler fixReversedValueMessages].
	^self mouseMovePitch: arg1 event: arg2 noteMorph: arg3! !

!PianoKeyboardMorph methodsFor: 'simple keyboard' stamp: 'ar 3/17/2001 14:28'!
mouseMovePitch: pitch event: event noteMorph: noteMorph

	(noteMorph containsPoint: event cursorPoint) ifFalse:
		["If drag out of me, zap focus so other morphs can see drag in."
		event hand releaseMouseFocus: noteMorph]
! !

!PianoKeyboardMorph methodsFor: 'simple keyboard' stamp: 'ar 3/18/2001 17:28'!
mouseUpEvent: arg1 noteMorph: arg2 pitch: arg3
	"Reorder the arguments for existing event handlers"
	(arg3 isMorph and:[arg3 eventHandler notNil]) ifTrue:[arg3 eventHandler fixReversedValueMessages].
	^self mouseUpPitch: arg1 event: arg2 noteMorph: arg3! !

!PianoKeyboardMorph methodsFor: 'simple keyboard' stamp: 'ar 3/17/2001 14:29'!
mouseUpPitch: pitch event: event noteMorph: noteMorph

	noteMorph color: ((#(0 1 3 5 6 8 10) includes: pitch\\12)
					ifTrue: [whiteKeyColor]
					ifFalse: [blackKeyColor]).
	soundPlaying ifNotNil: [soundPlaying stopGracefully].
! !

!PianoKeyboardMorph methodsFor: 'simple keyboard' stamp: 'di 9/4/1998 12:57'!
soundPrototype: aSound
	soundPrototype := aSound! !

!RectangleMorph class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/11/2003 10:23'!
initialize

	self registerInFlapsRegistry.	! !

!RectangleMorph class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/11/2003 10:27'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(RectangleMorph	roundRectPrototype		'RoundRect'		'A rectangle with rounded corners')
						forFlapNamed: 'Supplies'.
						cl registerQuad: #(RectangleMorph	authoringPrototype		'Rectangle' 		'A rectangle')
						forFlapNamed: 'Supplies'.
						cl registerQuad: #(RectangleMorph	roundRectPrototype		'RoundRect'		'A rectangle with rounded corners')
						forFlapNamed: 'PlugIn Supplies'.
						cl registerQuad: #(RectangleMorph	authoringPrototype		'Rectangle' 		'A rectangle')
						forFlapNamed: 'PlugIn Supplies'.]! !

!RectangleMorph class methodsFor: '*MorphicExtras-parts bin' stamp: 'nk 8/23/2004 18:12'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'RoundRect'
		categoryList: #('Graphics' 'Basic')
		documentation: 'A rectangle with rounded corners'
		globalReceiverSymbol: #RectangleMorph
		nativitySelector: #roundRectPrototype.

	DescriptionForPartsBin
		formalName: 'Gradient'
		categoryList: #('Graphics' 'Basic')
		documentation: 'A rectangle with a horizontal gradient'
		globalReceiverSymbol: #RectangleMorph
		nativitySelector: #gradientPrototype.

	DescriptionForPartsBin
		formalName: 'Gradient (slanted)'
		categoryList: #('Graphics' 'Basic')
		documentation: 'A rectangle with a diagonal gradient'
		globalReceiverSymbol: #RectangleMorph
		nativitySelector: #diagonalPrototype}! !

!RectangleMorph class methodsFor: '*MorphicExtras-class initialization' stamp: 'asm 4/11/2003 12:39'!
unload
	"Unload the receiver from global registries"

	self environment at: #Flaps ifPresent: [:cl |
	cl unregisterQuadsWithReceiver: self] ! !

RectangleMorph subclass: #RulerMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!RulerMorph classSide methodsFor: 'parts bin' stamp: 'sw 8/2/2001 12:52'!
descriptionForPartsBin
	^ self partName:	'Ruler'
		categories:		#('Useful')
		documentation:	'A rectangle which continuously reports its size in pixels'! !

!RulerMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:50'!
defaultBorderWidth
"answer the default border width for the receiver"
	^ 1! !

!RulerMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:50'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color
		r: 0.8
		g: 1.0
		b: 1.0! !

!RulerMorph methodsFor: 'drawing' stamp: 'ar 12/31/2001 02:38'!
drawOn: aCanvas

	| s |
	super drawOn: aCanvas.
	s := self width printString, 'x', self height printString.
	aCanvas drawString: s in: (bounds insetBy: borderWidth + 5) font: nil color: Color red.
! !

RectangleMorph subclass: #ScaleMorph
	instanceVariableNames: 'caption start stop minorTick minorTickLength majorTick majorTickLength tickPrintBlock labelsAbove captionAbove'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!ScaleMorph commentStamp: '<historical>' prior: 0!
Rewrite of ScaleMorph - March 2000 (Russell Swan). Added accessors. Added two Booleans, labelsAbove and captionAbove. Determines where the labels and captions print, if they exist. Tick marks can either go up or down. For ticks going up, put in majorTickLength > 0. Negative value will make ticks go down. Examples on Class side.!

!ScaleMorph classSide methodsFor: 'examples' stamp: 'sma 3/24/2000 12:09'!
example1
	"Example 1 captions and labels above, ticks point up"
	^ (self new
		start: 0
		stop: 150
		minorTick: 1
		minorTickLength: 2
		majorTick: 10
		majorTickLength: 10
		caption: 'Example 1'
		tickPrintBlock: [:v | v printString];
		width: 300) openInWorld! !

!ScaleMorph classSide methodsFor: 'examples' stamp: 'sma 3/24/2000 12:09'!
example2
	"Example 2 captions and labels above, ticks point down"
	^ (self new
		start: 0
		stop: 150
		minorTick: 1
		minorTickLength: 2
		majorTick: 10
		majorTickLength: -10
		caption: 'Example 2'
		tickPrintBlock: [:v | v printString];
		width: 300) openInWorld! !

!ScaleMorph classSide methodsFor: 'examples' stamp: 'sma 3/24/2000 12:11'!
example3
	"Example 3 caption above, labels below, ticks point down"
	^ (self new
		start: -23
		stop: 47
		minorTick: 1
		minorTickLength: 2
		majorTick: 10
		majorTickLength: -10
		caption: 'Example 3'
		tickPrintBlock: [:v | v printString]
		labelsAbove: false
		captionAbove: true;
		color: Color lightBlue;
		width: 300) openInWorld! !

!ScaleMorph classSide methodsFor: 'examples' stamp: 'sma 3/24/2000 12:10'!
example4
	"Example 4 caption below, labels above, ticks point up"
	^ (self new
		start: 100000
		stop: 300000
		minorTick: 5000
		minorTickLength: 2
		majorTick: 50000
		majorTickLength: 10
		caption: 'Example 4'
		tickPrintBlock: [:v | '$' , v printString]
		labelsAbove: true
		captionAbove: false;
		color: Color lightOrange;
		width: 300) openInWorld! !

!ScaleMorph methodsFor: 'drawing' stamp: 'gm 2/28/2003 00:14'!
buildLabels
	| scale x1 y1 y2 x captionMorph tickMorph loopStart offset |
	majorTickLength * minorTickLength < 0 
		ifTrue: [minorTickLength := 0 - minorTickLength].
	self removeAllMorphs.
	caption ifNotNil: 
			[captionMorph := StringMorph contents: caption.
			offset := captionAbove 
				ifTrue: [majorTickLength abs + captionMorph height + 7]
				ifFalse: [2].
			captionMorph align: captionMorph bounds bottomCenter
				with: self bounds bottomCenter - (0 @ offset).
			self addMorph: captionMorph].
	tickPrintBlock ifNotNil: 
			["Calculate the offset for the labels, depending on whether or not 
			  1) there's a caption   
			below, 2) the labels are above or below the ticks, and 3) the   
			ticks go up or down"

			offset := labelsAbove 
						ifTrue: [majorTickLength abs + minorTickLength abs + 2]
						ifFalse: [2].
			caption 
				ifNotNil: [captionAbove ifFalse: [offset := offset + captionMorph height + 2]].
			scale := (self innerBounds width - 1) / (stop - start) asFloat.
			x1 := self innerBounds left.
			y1 := self innerBounds bottom.
			y2 := y1 - offset.
			"Start loop on multiple of majorTick"
			loopStart := (start / majorTick) ceiling * majorTick.
			loopStart to: stop
				by: majorTick
				do: 
					[:v | 
					x := x1 + (scale * (v - start)).
					tickMorph := StringMorph contents: (tickPrintBlock value: v).
					tickMorph align: tickMorph bounds bottomCenter with: x @ y2.
					tickMorph left < self left 
						ifTrue: [tickMorph position: self left @ tickMorph top].
					tickMorph right > self right 
						ifTrue: [tickMorph position: (self right - tickMorph width) @ tickMorph top].
					self addMorph: tickMorph]]! !

!ScaleMorph methodsFor: 'accessing' stamp: 'RCS 3/15/2000 21:41'!
caption
	^ caption.! !

!ScaleMorph methodsFor: 'accessing' stamp: 'RCS 3/15/2000 21:42'!
caption: aString
	caption := aString.! !

!ScaleMorph methodsFor: 'accessing' stamp: 'RCS 3/16/2000 00:38'!
captionAbove: aBoolean 
	captionAbove := aBoolean! !

!ScaleMorph methodsFor: 'geometry' stamp: 'RCS 3/16/2000 13:58'!
checkExtent: newExtent 
	| pixPerTick newWidth |
	pixPerTick := newExtent x - (self borderWidth * 2) - 1 / ((stop - start) asFloat / minorTick).
	pixPerTick := pixPerTick
				detentBy: 0.1
				atMultiplesOf: 1.0
				snap: false.
	newWidth := pixPerTick * ((stop - start) asFloat / minorTick) + (self borderWidth * 2) + 1.
	^ (newWidth @ newExtent y).! !

!ScaleMorph methodsFor: 'objects from disk' stamp: 'RAA 12/20/2000 17:49'!
convertToCurrentVersion: varDict refStream: smartRefStrm
	
	labelsAbove ifNil: [labelsAbove := true].
	captionAbove ifNil: [captionAbove := true].
	^super convertToCurrentVersion: varDict refStream: smartRefStrm.
! !

!ScaleMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:39'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 0! !

!ScaleMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:30'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color lightGreen! !

!ScaleMorph methodsFor: 'drawing' stamp: 'aoy 2/15/2003 21:15'!
drawMajorTicksOn: aCanvas 
	| scale x1 y1 y2 x y3 even yy loopStart checkStart yoffset randomLabel |
	scale := (self innerBounds width - 1) / (stop - start) asFloat.
	yoffset := majorTickLength < 0 
		ifTrue: [ majorTickLength abs + 1]
		ifFalse: [1].
	caption ifNotNil: 
			[captionAbove 
				ifFalse: 
					[randomLabel := StringMorph contents: 'Foo'.
					yoffset := yoffset + randomLabel height + 2]].
	tickPrintBlock ifNotNil: 
			[labelsAbove 
				ifFalse: 
					[randomLabel := StringMorph contents: '50'.
					yoffset := yoffset + randomLabel height + 2]].
	x1 := self innerBounds left.
	y1 := self innerBounds bottom - yoffset.
	y2 := y1 - majorTickLength.
	y3 := y1 - ((minorTickLength + majorTickLength) // 2).
	even := true.
	"Make sure major ticks start drawing on a multiple of majorTick"
	loopStart := (start / majorTick) ceiling * majorTick.
	checkStart := (start / (majorTick / 2.0)) ceiling * majorTick.
	"Check to see if semimajor tick should be drawn before majorTick"
	checkStart = (loopStart * 2) 
		ifFalse: 
			[loopStart := checkStart / 2.0.
			even := false].
	loopStart to: stop
		by: majorTick / 2.0
		do: 
			[:v | 
			x := x1 + (scale * (v - start)).
			yy := even ifTrue: [y2] ifFalse: [y3].
			aCanvas 
				line: x @ y1
				to: x @ yy
				width: 1
				color: Color black.
			even := even not]! !

!ScaleMorph methodsFor: 'drawing' stamp: 'aoy 2/15/2003 21:16'!
drawMinorTicksOn: aCanvas 
	| scale x1 y1 y2 x loopStart yoffset randomLabel |
	scale := (self innerBounds width - 1) / (stop - start) asFloat.
	yoffset := majorTickLength < 0 
				ifTrue: [majorTickLength abs + 1]
				ifFalse: [1]. 
	caption ifNotNil: 
			[captionAbove 
				ifFalse: 
					[randomLabel := StringMorph contents: 'Foo'.
					yoffset := yoffset + randomLabel height + 2]].
	tickPrintBlock ifNotNil: 
			[labelsAbove 
				ifFalse: 
					[randomLabel := StringMorph contents: '50'.
					yoffset := yoffset + randomLabel height + 2]].
	x1 := self innerBounds left.
	y1 := self innerBounds bottom - yoffset.
	y2 := y1 - minorTickLength.
	loopStart := (start / minorTick) ceiling * minorTick.
	loopStart to: stop
		by: minorTick
		do: 
			[:v | 
			x := x1 + (scale * (v - start)).
			aCanvas 
				line: x @ y1
				to: x @ y2
				width: 1
				color: Color black]! !

!ScaleMorph methodsFor: 'drawing' stamp: 'RCS 3/15/2000 21:36'!
drawOn: aCanvas 
	| |
	super drawOn: aCanvas.
	
	self drawTicksOn: aCanvas.! !

!ScaleMorph methodsFor: 'drawing' stamp: 'RCS 3/16/2000 14:19'!
drawTicksOn: aCanvas 
	self drawMajorTicksOn: aCanvas.
	self drawMinorTicksOn: aCanvas! !

!ScaleMorph methodsFor: 'geometry' stamp: 'RCS 3/16/2000 13:59'!
extent: newExtent 
	| modExtent |
	modExtent := self checkExtent: newExtent.
	super extent: modExtent.
	self buildLabels! !

!ScaleMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 21:00'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	
	start := 0.
	stop := 100.
	minorTick := 1.
	majorTick := 10.
	minorTickLength := 3.
	majorTickLength := 10.
	caption := nil.
	tickPrintBlock := [:v | v printString].
	labelsAbove := true.
	captionAbove := true! !

!ScaleMorph methodsFor: 'accessing' stamp: 'RCS 3/16/2000 00:38'!
labelsAbove: aBoolean
	labelsAbove := aBoolean.! !

!ScaleMorph methodsFor: 'accessing' stamp: 'RCS 3/15/2000 21:46'!
majorTickLength: anInteger 
	majorTickLength := anInteger! !

!ScaleMorph methodsFor: 'accessing' stamp: 'RCS 3/15/2000 21:46'!
minorTickLength: anInteger
	minorTickLength := anInteger.! !

!ScaleMorph methodsFor: 'stepping and presenter' stamp: 'RCS 3/15/2000 21:43'!
start
	^ start! !

!ScaleMorph methodsFor: 'accessing' stamp: 'RCS 3/15/2000 21:43'!
start: aNumber
	start := aNumber.! !

!ScaleMorph methodsFor: 'initialization' stamp: 'RCS 3/16/2000 14:55'!
start: strt stop: stp minorTick: mnt minorTickLength: mntLen majorTick: mjt majorTickLength: mjtLen

	self start: strt stop: stp minorTick: mnt minorTickLength: mntLen majorTick: mjt majorTickLength: mjtLen caption: nil tickPrintBlock: nil
	! !

!ScaleMorph methodsFor: 'initialization' stamp: 'RCS 3/16/2000 14:54'!
start: strt stop: stp minorTick: mnt minorTickLength: mntLen majorTick: mjt majorTickLength: mjtLen caption: cap tickPrintBlock: blk 
	self start: strt stop: stp minorTick: mnt minorTickLength: mntLen majorTick: mjt majorTickLength: mjtLen caption: cap tickPrintBlock: blk labelsAbove: true captionAbove: true.
	! !

!ScaleMorph methodsFor: 'initialization' stamp: 'RCS 3/16/2000 15:09'!
start: strt stop: stp minorTick: mnt minorTickLength: mntLen majorTick: mjt majorTickLength: mjtLen caption: cap tickPrintBlock: blk labelsAbove: aBoolean captionAbove: notherBoolean 
	start := strt.
	stop := stp.
	minorTick := mnt.
	minorTickLength := mntLen.
	majorTick := mjt.
	majorTickLength := mjtLen.
	caption := cap.
	tickPrintBlock := blk.
	labelsAbove := aBoolean.
	captionAbove := notherBoolean.
	self buildLabels! !

!ScaleMorph methodsFor: 'stepping and presenter' stamp: 'RCS 3/15/2000 21:43'!
stop
	^ stop! !

!ScaleMorph methodsFor: 'accessing' stamp: 'RCS 3/15/2000 21:44'!
stop: aNumber
	stop := aNumber.! !

!ScaleMorph methodsFor: 'accessing' stamp: 'RCS 3/15/2000 21:47'!
tickPrintBlock: aBlock
	tickPrintBlock := aBlock.! !

RectangleMorph subclass: #SoundLoopMorph
	instanceVariableNames: 'samplesUntilNextControl seqSound cursor controlIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SoundInterface'!

!SoundLoopMorph methodsFor: 'as yet unclassified' stamp: 'jm 11/14/97 11:21'!
addCursorMorph
	self addMorph:
		(cursor := (RectangleMorph
				newBounds: (self innerBounds topLeft extent: 1@self innerBounds height)
				color: Color red)
						borderWidth: 0)! !

!SoundLoopMorph methodsFor: 'as yet unclassified' stamp: 'jm 11/14/97 11:11'!
allowSubmorphExtraction

	^ true! !

!SoundLoopMorph methodsFor: 'as yet unclassified' stamp: 'jm 1/5/98 17:31'!
buildSound
	"Build a compound sound for the next iteration of the loop."

	| mixer soundMorphs startTime pan |
	mixer := MixedSound new.
	mixer add: (RestSound dur: (self width - (2 * borderWidth)) / 128.0).
	soundMorphs := self submorphs select: [:m | m respondsTo: #sound].
	soundMorphs do: [:m |
		startTime := (m position x - (self left + borderWidth)) / 128.0.
		pan := (m position y - (self top + borderWidth)) asFloat / (self height - (2 * borderWidth) - m height).
		mixer add: ((RestSound dur: startTime), m sound copy) pan: pan].
	^ mixer
! !

!SoundLoopMorph methodsFor: 'playing' stamp: 'jm 11/14/97 11:21'!
controlRate
	"Answer the number of control changes per second."

	^ 32
! !

!SoundLoopMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:40'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!SoundLoopMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 15:07'!
defaultBounds
"answer the default bounds for the receiver"
	^ 0 @ 0 corner: 128 @ 128 + (self defaultBorderWidth * 2)! !

!SoundLoopMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:31'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color lightBlue! !

!SoundLoopMorph methodsFor: 'playing' stamp: 'jm 11/14/97 11:21'!
doControl

	seqSound doControl.
	controlIndex := controlIndex + 1.
	controlIndex >= (self controlRate * (self innerBounds width // 128))
		ifTrue: [controlIndex := 0].
! !

!SoundLoopMorph methodsFor: 'geometry' stamp: 'jm 11/14/97 11:21'!
extent: newExtent
	super extent: (newExtent truncateTo: 128@128) + (self borderWidth*2)! !

!SoundLoopMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 20:50'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	
	controlIndex := 0.
	self addCursorMorph! !

!SoundLoopMorph methodsFor: 'playing' stamp: 'jm 1/5/98 13:40'!
mixSampleCount: n into: aSoundBuffer startingAt: startIndex leftVol: leftVol rightVol: rightVol
	"Repeatedly play my sounds."

	| i count samplesNeeded |
	i := startIndex.
	samplesNeeded := n.
	[samplesNeeded > 0] whileTrue: [
		count := seqSound samplesRemaining min: samplesNeeded.
		count = 0 ifTrue: [
			self reset.
			count := seqSound samplesRemaining min: samplesNeeded.
			count = 0 ifTrue: [^ self]].  "zero length sound"
		seqSound mixSampleCount: count into: aSoundBuffer startingAt: i leftVol: leftVol rightVol: rightVol.
		i := i + count.
		samplesNeeded := samplesNeeded - count].
! !

!SoundLoopMorph methodsFor: 'as yet unclassified' stamp: 'jm 11/14/97 11:11'!
play
	"Play this sound to the sound ouput port in real time."

	self reset.
	SoundPlayer playSound: self.
! !

!SoundLoopMorph methodsFor: 'playing' stamp: 'jm 1/26/98 22:05'!
playSampleCount: n into: aSoundBuffer startingAt: startIndex
	"Mixes the next count samples of this sound into the given buffer starting at the given index, updating the receiver's control parameters at periodic intervals."

	| fullVol samplesBetweenControlUpdates pastEnd i remainingSamples count |
	fullVol := AbstractSound scaleFactor.
	samplesBetweenControlUpdates := self samplingRate // self controlRate.
	pastEnd := startIndex + n.  "index just index of after last sample"
	i := startIndex.
	[i < pastEnd] whileTrue: [
		remainingSamples := self samplesRemaining.
		remainingSamples <= 0 ifTrue: [^ self].
		count := pastEnd - i.
		samplesUntilNextControl < count ifTrue: [count := samplesUntilNextControl].
		remainingSamples < count ifTrue: [count := remainingSamples].
		self mixSampleCount: count into: aSoundBuffer startingAt: i leftVol: fullVol rightVol: fullVol.
		samplesUntilNextControl := samplesUntilNextControl - count.
		samplesUntilNextControl <= 0 ifTrue: [
			self doControl.
			samplesUntilNextControl := samplesBetweenControlUpdates].
		i := i + count].
! !

!SoundLoopMorph methodsFor: 'playing' stamp: 'jm 11/14/97 11:21'!
positionCursor
	| x |
	x := controlIndex * 128 // self controlRate.
	cursor position: self innerBounds topLeft + (x@0)
! !

!SoundLoopMorph methodsFor: 'playing' stamp: 'jm 11/14/97 11:21'!
reset
	"Reset my internal state for a replay."

	seqSound := self buildSound reset.
	samplesUntilNextControl := (self samplingRate // self controlRate).
	controlIndex := 0.
	self positionCursor! !

!SoundLoopMorph methodsFor: 'playing' stamp: 'jm 11/14/97 11:11'!
samplesRemaining

	^ 1000000
! !

!SoundLoopMorph methodsFor: 'playing' stamp: 'jm 11/14/97 11:11'!
samplingRate
	"Answer the sampling rate in samples per second."

	^ SoundPlayer samplingRate! !

!SoundLoopMorph methodsFor: 'stepping and presenter' stamp: 'jm 11/14/97 11:21'!
step
	self positionCursor! !

!SoundLoopMorph methodsFor: 'testing' stamp: 'jm 11/14/97 11:21'!
stepTime

	^ 50
! !

!SoundLoopMorph methodsFor: 'stepping and presenter' stamp: 'jm 11/14/97 11:11'!
stop
	"Stop playing this sound."

	SoundPlayer pauseSound: self.
! !

!SoundLoopMorph methodsFor: 'dropping/grabbing' stamp: 'jm 11/14/97 11:11'!
wantsDroppedMorph: aMorph event: evt

	^ aMorph respondsTo: #sound
! !

RectangleMorph subclass: #SoundSequencerMorph
	instanceVariableNames: 'controlPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MorphicExtras-SoundInterface'!

!SoundSequencerMorph methodsFor: 'initialization' stamp: 'jm 11/14/97 11:21'!
initialize
	super initialize.
	self extent: 550@350.
	self makeControlPanel.
	self addMorph: controlPanel.
	self addMorph: ((SoundLoopMorph newBounds: (10@40 extent: 128@128)) extent: 128@128).
	self addMorph: ((SoundLoopMorph newBounds: (10@200 extent: 512@128)) extent: 512@128).! !

!SoundSequencerMorph methodsFor: 'as yet unclassified' stamp: 'tk 2/19/2001 18:14'!
makeControlPanel
	| bb cc |
	cc := Color black.
	bb := SimpleButtonMorph new target: self; borderColor: cc.
	controlPanel := AlignmentMorph newRow.
	bb := SimpleButtonMorph new target: self; borderColor: cc.
	controlPanel color: bb color; borderWidth: 0; layoutInset: 0.
	controlPanel hResizing: #shrinkWrap; vResizing: #shrinkWrap; extent: 5@5.
	bb := SimpleButtonMorph new target: self; borderColor: cc.
	controlPanel addMorphBack: (bb label: 'reset';	actionSelector: #reset).
	bb := SimpleButtonMorph new target: self; borderColor: cc.
	controlPanel addMorphBack: (bb label: 'stop';		actionSelector: #stop).
	bb := SimpleButtonMorph new target: self; borderColor: cc.
	controlPanel addMorphBack: (bb label: 'play';	actionSelector: #play).
! !

!SoundSequencerMorph methodsFor: 'as yet unclassified' stamp: 'jm 11/14/97 11:08'!
play
	self submorphsDo: [:m | m == controlPanel ifFalse: [m play]]! !

!SoundSequencerMorph methodsFor: 'as yet unclassified' stamp: 'jm 11/14/97 11:08'!
reset
	self submorphsDo: [:m | m == controlPanel ifFalse: [m reset]]! !

!SoundSequencerMorph methodsFor: 'stepping and presenter' stamp: 'jm 11/14/97 11:21'!
stop
	self submorphsDo: [:m | m == controlPanel ifFalse: [m stop]].
	SoundPlayer shutDown! !

RectangleMorph subclass: #StickyPadMorph
	instanceVariableNames: ''
	classVariableNames: 'Colors LastColorIndex'
	poolDictionaries: ''
	category: 'MorphicExtras-Demo'!

!StickyPadMorph commentStamp: 'sw 3/3/2004 13:31' prior: 0!
A custom item for the  Squeakland Supplies bin, as defined by Kim Rose and BJ Con.A parts bin will deliver up translucent, borderless Rectangles in a sequence of 6 colors.  It offers some complication to the parts-bin protocols in two ways::
* The multi-colored icon seen in the parts bin is not a thumbnail of any actual instance, all of which are monochrome
* New instances need to be given default names that are not the same as the name seen in the parts bin.!

!StickyPadMorph classSide methodsFor: 'parts bin' stamp: 'sw 4/3/2003 14:26'!
defaultNameStemForInstances
	"Answer the default name stem to use"

	^ 'tear off'! !

!StickyPadMorph classSide methodsFor: 'parts bin' stamp: 'sw 4/4/2003 11:12'!
descriptionForPartsBin
	"Answer a description of the receiver for use in a parts bin"

	^ self partName: 	'Sticky Pad'
		categories:		#('Graphics')
		documentation:	'A translucent, borderless rectangle of a standard size, delivered in a predictable sequence of pastel colors'
		sampleImageForm: (Form extent: 50@40 depth: 16
	fromArray: #( 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461414680 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461414680 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461414680 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521903284 1723098804 1723098804 1723096921 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521903284 1723098804 1723098804 1723096921 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521903284 1723098804 1723098804 1723096921 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322274512 1322274512 1322275535 1389318863 1389318863 1389317938 1328697138 1328697138 1328702226 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322274512 1322274512 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322274512 1322275535 1389318863 1389318863 1389317938 1328697138 1328697138 1328702226 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322274512 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1322275535 1389318863 1389318863 1389317938 1328697138 1328697138 1328702226 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1389318863 1389318863 1389318863 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1521903284 1389318863 1389318863 1389317938 1460426508 1460426508 1460429548 1659658988 1659658988 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521900214 1723098804 1389318863 1389318863 1328697138 1460426508 1460426508 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1521903284 1723098804 1389318863 1389317938 1328697138 1460426508 1460429548 1659658988 1659658988 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521900214 1723098804 1723098804 1389318863 1328697138 1328697138 1460426508 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1521903284 1723098804 1723098804 1389317938 1328697138 1328697138 1460429548 1659658988 1659658988 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1723098804 1723098804 1723098804 1328697138 1328697138 1328697138 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461414680 1723098804 1723098804 1723096921 1328697138 1328697138 1328702226 1659658988 1659658988 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1796762392 1723098804 1723098804 1599692633 1328697138 1328697138 1662149394 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461414680 1796762392 1723098804 1723096921 1599692633 1328697138 1328702226 1662149394 1659658988 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1796762392 1796762392 1723098804 1599692633 1599692633 1328697138 1662149394 1662149394 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461414680 1796762392 1796762392 1723096921 1599692633 1599692633 1328702226 1662149394 1662149394 1659660157 1736271741 1736271741 1736271741 1736271741 1736271741)
	offset: 0@0)! !

!StickyPadMorph classSide methodsFor: 'class initialization' stamp: 'sw 3/3/2004 13:44'!
initialize
	"Class initialization"

	LastColorIndex := 0.
	Colors :=  {
		TranslucentColor r: 0.0 g: 0.0 b: 0.839 alpha: 0.267.
		TranslucentColor r: 0.484 g: 1.0 b: 0.452 alpha: 0.706.
		TranslucentColor r: 1.0 g: 0.355 b: 0.71 alpha: 0.569.
		TranslucentColor r: 1.0 g: 1.0 b: 0.03 alpha: 0.561.
		TranslucentColor r: 0.484 g: 0.161 b: 1.0 alpha: 0.529.
		TranslucentColor r: 0.097 g: 0.097 b: 0.097 alpha: 0.192.
	}.
	
	self registerInFlapsRegistry.	

"StickyPadMorph initialize"! !

!StickyPadMorph classSide methodsFor: 'parts bin' stamp: 'sw 7/5/2004 18:09'!
launchPartVia: aSelector label: aString
	"Obtain a morph by sending aSelector to self, and attach it to the morphic hand.  This provides a general protocol for parts bins.  Overridden here so that all instances will be given the name, unlike the prevailing convention for other object types"

	| aMorph |
	aMorph := self perform: aSelector.
	aMorph setNameTo: self defaultNameStemForInstances.  "i.e., circumvent uniqueness in this case"
	aMorph setProperty: #beFullyVisibleAfterDrop toValue: true.
	aMorph openInHand! !

!StickyPadMorph classSide methodsFor: 'as yet unclassified' stamp: 'sw 3/3/2004 13:42'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: #(StickyPadMorph		newStandAlone			'Sticky Pad'			'Each time you obtain one of these pastel, translucent, borderless rectangles, it will be a different color from the previous time.')
						forFlapNamed: 'Supplies'.
				cl registerQuad: #(StickyPadMorph		newStandAlone			'Sticky Pad'			'Each time you obtain one of these pastel, translucent, borderless rectangles, it will be a different color from the previous time.')
						forFlapNamed: 'PlugIn Supplies'.]! !

!StickyPadMorph methodsFor: 'visual properties' stamp: 'dgd 9/18/2004 18:52'!
canHaveFillStyles
	"Return true if the receiver can have general fill styles; not just 
	colors. This method is for gradually converting old morphs."
	^ true! !

!StickyPadMorph methodsFor: 'parts bin' stamp: 'sw 4/3/2003 15:25'!
initializeToStandAlone
	"Initialize the receiver to stand alone.  Use the next color in the standard sequence."

	Colors ifNil: [self initialize].
	LastColorIndex := 
		LastColorIndex
			ifNil:
				[1]
			ifNotNil:
				[(LastColorIndex \\ Colors size) + 1].
	super initializeToStandAlone.
	self assureExternalName.
	self color: (Colors at: LastColorIndex).
	self extent: 100@80.
	self borderWidth: 0
	! !

RectangleMorph subclass: #ThumbnailMorph
	instanceVariableNames: 'objectToView viewSelector lastSketchForm lastFormShown drawTime'
	classVariableNames: 'EccentricityThreshhold RecursionDepth RecursionMax'
	poolDictionaries: ''
	category: 'MorphicExtras-Widgets'!

!ThumbnailMorph commentStamp: 'sw 1/6/2005 03:47' prior: 0!
A Morph that views another morph, its objectToView.!

!ThumbnailMorph class methodsFor: 'class initialization' stamp: 'sw 12/30/2004 00:47'!
initialize
	"Initialize the class variables of ThumbnailMorph"

	RecursionMax := 2.
	RecursionDepth := 0.
	EccentricityThreshhold :=  Float pi

"ThumbnailMorph initialize"! !

!ThumbnailMorph class methodsFor: 'as yet unclassified' stamp: 'sw 5/3/1998 19:12'!
recursionReset
	"ThumbnailMorph recursionReset"
	"Reset the RecursionDepth counter in case the user interrupted
during a thumbnail being drawn.  Do this just once in a while when no
drawOn: is being called.  tk 9/8/97"

	RecursionDepth := 0.! !

!ThumbnailMorph methodsFor: 'what to view' stamp: 'nk 8/29/2004 17:18'!
actualViewee
	"Return the actual morph to be viewed, or nil if there isn't an appropriate morph to view."

	| aMorph actualViewee |
	aMorph := self morphToView ifNil: [^ nil]. 
	aMorph isInWorld ifFalse: [^ nil].
	actualViewee := viewSelector ifNil: [aMorph] ifNotNil: [objectToView perform: viewSelector].
	actualViewee == 0 ifTrue: [^ nil].  "valueAtCursor result for an empty HolderMorph"
	actualViewee ifNil: [actualViewee := objectToView].
	(actualViewee isPlayerLike) ifTrue: [actualViewee := actualViewee costume].
	(actualViewee isMorph and: 
		[actualViewee isFlexMorph and: [actualViewee submorphs size = 1]])
			ifTrue: [actualViewee := actualViewee firstSubmorph].
	^ actualViewee! !

!ThumbnailMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:57'!
defaultBorderWidth
"answer the default border width for the receiver"
	^ 1! !

!ThumbnailMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:56'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color
		r: 0.781
		g: 0.781
		b: 0.781! !

!ThumbnailMorph methodsFor: 'display' stamp: 'wiz 8/6/2005 22:01'!
drawForForm: aForm on: aCanvas
	"Draw a small view of the given form on the canvas"

	| scale shrunkForm viewedObjectBox interimCanvas |
	viewedObjectBox := aForm boundingBox.
	scale :=  self scaleFor: viewedObjectBox in: self innerBounds.
	interimCanvas := Display defaultCanvasClass extent: viewedObjectBox extent depth: aCanvas depth.
	interimCanvas translateBy: viewedObjectBox topLeft negated 
				during: [:tempCanvas | tempCanvas drawImage: aForm at: 0@0].
	shrunkForm := interimCanvas form magnify: interimCanvas form boundingBox by: scale smoothing: 1.
	lastFormShown := shrunkForm.

	aCanvas paintImage: shrunkForm at: self center - shrunkForm boundingBox center! !

!ThumbnailMorph methodsFor: 'display' stamp: 'wiz 8/6/2005 22:11'!
drawMeOn: aCanvas 
	"Draw a small view of a morph in another place.  Guard against infinite recursion if that morph has a thumbnail of itself inside.  Now also works if the thing to draw is a plain Form rather than a morph."

	| viewedMorphBox scale c shrunkForm aWorld aFormOrMorph  |
	super drawOn: aCanvas.
	((aFormOrMorph := self formOrMorphToView) isForm) 
		ifTrue: [^self drawForForm: aFormOrMorph on: aCanvas].
	(((aFormOrMorph notNil and: [(aWorld := aFormOrMorph world) notNil]) 
		and: [aWorld ~~ aFormOrMorph or: [lastFormShown isNil]]) 
			and: [RecursionDepth + 1 < RecursionMax]) 
			ifTrue: 
				[RecursionDepth := RecursionDepth + 1.
				viewedMorphBox := aFormOrMorph fullBounds.
			scale :=  self scaleFor: viewedMorphBox in: self innerBounds.
				c := Display defaultCanvasClass extent: viewedMorphBox extent
							depth: aCanvas depth.
				c translateBy: viewedMorphBox topLeft negated
					during: 
						[:tempCanvas | 
						"recursion happens here"
						tempCanvas fullDrawMorph: aFormOrMorph].
				shrunkForm := c form 
							magnify: c form boundingBox
							by: scale
							smoothing: 1.
				lastFormShown := shrunkForm.
				RecursionDepth := RecursionDepth - 1]
			ifFalse: 
				["This branch used if we've recurred, or if the thumbnail views a World that's already been rendered once, or if the referent is not in a world at the moment"
				lastFormShown ifNotNil: [shrunkForm := lastFormShown]].
	shrunkForm ifNotNil: 
			[aCanvas paintImage: shrunkForm
				at: self center - shrunkForm boundingBox center]! !

!ThumbnailMorph methodsFor: 'drawing' stamp: 'ar 10/26/2000 23:45'!
drawOn: aCanvas
	"Draw a small view of a morph in another place. Guard against infinite recursion if that morph has a thumbnail of itself inside."
	| time |
	time := Time millisecondClockValue.
	self drawMeOn: aCanvas.
	drawTime := Time millisecondClockValue - time.
	drawTime < 0 ifTrue:[drawTime := nil].
! !

!ThumbnailMorph methodsFor: 'what to view' stamp: 'nk 8/29/2004 17:18'!
formOrMorphToView
	"Answer the form to be viewed, or the morph to be viewed, or nil"

	| actualViewee |
	(objectToView isForm) ifTrue: [^objectToView].
	actualViewee := viewSelector ifNil: [objectToView]
				ifNotNil: [objectToView perform: viewSelector].
	^actualViewee == 0 
		ifTrue: [nil	"valueAtCursor result for an empty HolderMorph"]
		ifFalse: 
			[(actualViewee isPlayerLike) 
				ifTrue: [actualViewee costume]
				ifFalse: [actualViewee]]! !

!ThumbnailMorph methodsFor: 'accessing' stamp: 'sw 1/6/2005 01:46'!
getSelector
	"Answer the selector I send to my target to retrieve my value"

	^ viewSelector! !

!ThumbnailMorph methodsFor: 'accessing' stamp: 'sw 1/6/2005 17:03'!
getSelector: aSelector
	"Set the selector used to obtain my value"

	self objectToView: objectToView viewSelector: aSelector! !

!ThumbnailMorph methodsFor: 'initialization' stamp: 'dgd 3/7/2003 14:57'!
initialize
	"Initialize the receiver, obeying a #nominalExtent property if I  
	have one"
	| anExtent |
	super initialize.
	""
	anExtent := self
				valueOfProperty: #nominalExtent
				ifAbsent: [25 @ 25].
	self
		extent: (anExtent
				)! !

!ThumbnailMorph methodsFor: 'texture support' stamp: 'ar 11/7/1999 22:55'!
installAsWonderlandTextureOn: anActor
	"Make the receiver a texture for the given actor"
	self morphRepresented installAsWonderlandTextureOn: anActor! !

!ThumbnailMorph methodsFor: 'scripting' stamp: 'sw 1/6/2005 01:29'!
isEtoyReadout
	"Answer whether the receiver can serve as an etoy readout"

	^ true! !

!ThumbnailMorph methodsFor: 'what to view' stamp: 'nk 8/29/2004 17:18'!
morphToView
	"If the receiver is viewing some object, answer a morph can be thought of as being viewed;  A gesture is made toward generalizing this beyond the morph/player regime, in that a plain blue rectangle is returned rather than simply failing if the referent is not itself displayable."

	objectToView ifNil: [^ nil].
	^ objectToView isMorph
		ifTrue:
			[objectToView]
		ifFalse:
			[(objectToView isPlayerLike)
				ifTrue:
					[objectToView costume]
				ifFalse:
					[RectangleMorph new color: Color blue]]
! !

!ThumbnailMorph methodsFor: 'initialization' stamp: 'sw 6/9/2000 18:35'!
objectToView: objectOrNil
	(objectOrNil isMorph and: [objectOrNil allMorphs includes: self]) ifTrue:
		["cannot view a morph containing myself or drawOn: goes into infinite recursion"
		objectToView := nil.
		^ self].
	objectToView := objectOrNil! !

!ThumbnailMorph methodsFor: 'initialization' stamp: 'sw 6/9/2000 18:35'!
objectToView: objectOrNil viewSelector: aSelector
	self objectToView: objectOrNil.
	viewSelector := aSelector! !

!ThumbnailMorph methodsFor: 'accessing' stamp: 'sw 1/6/2005 17:06'!
putSelector
	"Answer the selector used  for the receiver to send a fresh value back to its target"

	^ nil! !

!ThumbnailMorph methodsFor: 'caching' stamp: 'ar 3/3/2001 19:37'!
releaseCachedState
	super releaseCachedState.
	lastSketchForm := lastFormShown := nil.! !

!ThumbnailMorph methodsFor: 'display' stamp: 'wiz 8/6/2005 21:58'!
scaleFor:  viewedMorphBox in: myBox
	"Compute the proper scale for the thumbnail."

	|   scale  scaleX scaleY ratio factor  |
scaleX := myBox width asFloat / viewedMorphBox width.
				scaleY := myBox height asFloat / viewedMorphBox height.
				ratio := scaleX / scaleY.
				factor := 1.0 / EccentricityThreshhold.
				ratio < factor
					ifTrue:
						[scale := (scaleX) @ (factor * scaleY)]
					ifFalse:
						[ratio > EccentricityThreshhold
							ifTrue:
								[scale := (factor * scaleX) @ scaleY]
							ifFalse:
								[scale := scaleX min: scaleY]].
^ scale
! !

!ThumbnailMorph methodsFor: 'stepping and presenter' stamp: 'nk 6/14/2004 16:47'!
step
	"Optimization: Don't redraw if we're viewing some kind of SketchMorph and its rotated Form hasn't changed."

	| viewee f |
	viewee := self actualViewee.
	viewee ifNil: [ self stopStepping. ^self ].
	(viewee isSketchMorph) ifTrue: [
		f := viewee rotatedForm.
		f == lastSketchForm ifTrue: [^ self].
		lastSketchForm := f].
	self changed.
! !

!ThumbnailMorph methodsFor: 'testing' stamp: 'ar 5/16/2001 01:41'!
stepTime 
	"Adjust my step time to the time it takes drawing my referent"
	drawTime ifNil:[^ 250].
	^(objectToView updateThresholdForGraphicInViewerTab * drawTime) max: 250.! !

!ThumbnailMorph methodsFor: 'accessing' stamp: 'sw 1/6/2005 01:39'!
target
	"Answer the object on which I act"

	^ objectToView! !

!ThumbnailMorph methodsFor: 'copying' stamp: 'tk 1/7/1999 14:57'!
veryDeepFixupWith: deepCopier
	"If target and arguments fields were weakly copied, fix them here.  If they were in the tree being copied, fix them up, otherwise point to the originals!!!!"

super veryDeepFixupWith: deepCopier.
objectToView := deepCopier references at: objectToView ifAbsent: [objectToView].! !

!ThumbnailMorph methodsFor: 'copying' stamp: 'ar 10/26/2000 23:55'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

super veryDeepInner: deepCopier.
"objectToView := objectToView.		Weakly copied"
viewSelector := viewSelector veryDeepCopyWith: deepCopier.
lastSketchForm := lastSketchForm veryDeepCopyWith: deepCopier.
lastFormShown := lastFormShown veryDeepCopyWith: deepCopier.
drawTime := drawTime veryDeepCopyWith: deepCopier.
! !
RectangleMorph initialize!
CommandHistory initialize!
SimpleSliderMorph initialize!
LedCharacterMorph initialize!
LedDigitMorph initialize!
ThumbnailMorph initialize!
Workspace initialize!
MessageNames initialize!
PolygonMorph initialize!
PasteUpMorph initialize!
CurveMorph initialize!
EllipseMorph initialize!
AnimatedImageMorph initialize!
BookMorph initialize!
BooklikeMorph initialize!
BouncingAtomsMorph initialize!
ClockMorph initialize!
DropDownChoiceMorph initialize!
EventRecorderMorph initialize!
Flaps initialize!
FrameRateMorph initialize!
MagnifierMorph initialize!
MovingEyeMorph initialize!
MultiuserTinyPaint initialize!
ObjectsTool initialize!
PaintBoxMorph initialize!
PaintInvokingMorph initialize!
PartsBin initialize!
ScrollableField initialize!
SqueakPage initialize!
SqueakPageCache initialize!
StarMorph initialize!
StickyPadMorph initialize!
TabbedPalette initialize!
TrashCanMorph initialize!
